      subroutine dmncgn()
C $Id: dismantocongen.f,v 2.0 1997/01/29 17:13:54 tejero Exp tejero $
C
C ----- COMMENTS AND CORRECTIONS -----
C
C (FEB.,27,1993) THE CODE HAS BEEN REVISED AND IT IS FOUND TO BE UGLY AND
C NOT TOO MUCH OPTIMIZED BUT IT WORKS!. ONE DAY MAY BE IT IS WORTH TO HAVE
C A SEAT AND WORK FIXING AND CLEANING UP THE CODE. ANYWAY, THIS REVISION IS 
C DEVOTED TO INCLUDE NEW CODE TO READ CONGEN INPUT FORMATS FOR CONSTRAINTS
C AND ALSO TO READ IMPACT INPUT FORMATS FOR NOES AND DISTANCES.
C
C (DEC.,22,1992, RTT)
C THE PROGRAM NOW PRODUCES A NEW OUPUT FILE CALLED 'KYCNS.OUT' FOR FURTHER
C USE WITH VIOLACIONES.F  IN THAT FILE AN ARRAY WITH ALL THE INFORMATION
C ABOUT THE CONSTRAINTS IS WRITTEN. IT HAS THREE COLUMNS WITH THE 
C FOLLOWING DATA:
C   RES (NUMBER OF RESIDUE) 
C   NCNS (NUMBER OF CONSTRAINTS FOR THAT RESIDUE)
C   KYCNS (AN ARRAY WITH THE NUMBER OF EVERY CONSTRAINT OF THAT RESIDUE)
C THE FILE IS READED LATER BY VIOLACIONES.F TO CALCULATE THE VIOLATIONS
C PER RESIDUE AND THE FRACTION OF CONSTRAINTS VIOLATED
C
C (DEC.14.92, RTT)
C A NEW CAPABILITY HAS BEEN ADDED TO THE PROGRAM. NOW IT CAN DO SOME 
C ROUGH STATISTICS ABOUT DISMAN INPUT FILES. THE PROGRAM CREATES AN OUT
C PUT FILE CALLED 'CONSTRAINT.SUMMARY' WITH THE CONSTRAINTS CLASSIFIED BY 
C RANGE AS INTRARESIDUE, INTER BETWEEN I AND I+1, I+2 AND I+4, GT. I+5.
C ALSO IT GIVES YOU A LIST WITH THE NUMBER OF CONSTRAINTS PER RESIDUE
C
C AS NOW (OCT.29.1992) CONGEN CAN HANDLE PSEUDOATOMS LIKE CG1,CZ4 AND QR
C IN PHE AND TYR, SO CODE HAS BEEN ADDED TO TREAT THESE CASES. THE SAME 
C COMMENT CAN BE APPLIED TO PSEUDOATOMS QQG AND QQD (VAL,LEU). IN SUMMARY
C CONGEN CAN HANDLE NOW ANY PSEUDOATOM USING (1/r6) AVERAGE.
C ALSO THE CODE FOR GENERATING THE CONGEN INPUT FILE HAS BEEN MODIFIED TO
C TAKE INTO ACCOUNT THE NEW WAY USED IN CONGEN TO PUT THE CONSTRAINTS 
C USING THE ATOM SELECTION FACILITY. (RTT, OCT.,29,1992)
C
C (OCT.20.92) A NEW CAPABILITY HAS BEEN ADDED TO THE CODE. IT IS DESIGNED
C TO FULLY CHECK (I HOPE!) THE COMMENT PART IN THE DISMAN INPUT FILE. IT
C LOOKS FOR SPECIAL LETTERS IN THE COMMENT TRYING TO LOCATE THE DIFFERENT
C CORRECTION TERMS. FOR THAT WORKING WELL A FEW RULES MUST BE FOLLOWED IN
C WRITING THE DISMAN INPUT FILE:
C
C     - USE DISMAN FORMAT
C     - USE ALWAYS (WHERE POSSIBLE) LOWER CASE LETTERS FOR COMMENT
C     - ALLOWED CAPITAL LETTERS ARE IN THE Me AND dMe TYPES AND IN THE FI
C       NAL PART OF THE COMMENT WHERE YOU GIVE ANY OTHER RELEVANT DATA
C     - OTHER ALLOWED CAPITAL LETTER ARE SPECIAL COMMENTS AS
C                     -    H-BOND
C                     -    SS-BRIDGE
C                     -    ETC.
C     - ALWAYS FULLY COMMENT FIRST ATOM AND THEN SECOND ATOM
C     - EVERY TERM IN COMMENT MUST BE SEPARATED BY COMMAS
C     - ALWAYS USE :
C              #correction,comment,correction,comment   more comment/data
C            ->|    1  5      s  p  a  c  e  s      |<--
C     - ALLOW  AT LEAST 15 SPACES FOR THE CORRECTION PART OF THE COMMENT
C     - SOME EXAMPLES:
C                guide          01234567890123456789012345678901234567890
C                guide          +    +    +    +    +    +    +    +    +
C
C                           |   #m,db,i,both    any other useful comment
C          some examples    |   #q,dMe,i,both   any other useful comment
C                           |   #q,both,i,both  any other useful comment
C
C------------------------------------------------------------------------
C     (RTT, OCT.,20,1992)
C
C (10/15/92) A NEW MODULE HAS BEEN ADDED. THIS MODULE (SUBROUTINE CHECK) 
C MAKES A CHECK OF THE DISMAN INPUT FILE LOOKING AT THE COMMENTS AND 
C TELLING THE USER IF THE COMMENTS ARE OK. --STILL UNDER DEVELOPMENT--
C
C (10/14/92) THE PROGRAM NOW CAN CONVERT THE DIHEDRAL CONSTRAINTS INPUT
C FILE FROM DISMAN INTO A DIHEDRAL CONSTRAINT FILE FOR CONGEN USING THE
C COMMAND 'CONS DIHE' WHICH MEANS USE A FLAT-BOTTOM POTENTIAL IN CONGEN
C BETWEEN THE VALUES 'MIN' AND 'MAX' AS SPECIFIED BY THE USER
C
C (10/14/92) ADDED THE TREATMENT OF METHYLENES FOR ALL RESIDUES
C REMOVING CORRECTION TERM (I OR M) 0.6 OR 1.0.
C CORRECTED THE REMOVAL OF CORRECTION TERM FORT METHYLS 0.6 OR 1.0
C DEPENDING ON THE COMMENT (I OR M)
C
C (10/7/92) FIXED A LITTLE BUG. THE PROGRAM BEFORE DID NOT TREAT
C PROPERLY THE METHYLS OF THR. ADDED THE CODE RIGHT AFTER THE OTHER
C METHYLS
C
C (10/2/92) ADDED THE POSSIBILITY TO CONVERT DIHEDRAL CONSTRAINTS
C INTO DISTANCE CONSTRAINTS. FOR THAT YOU NEED AN INPUT FILE OF THE
C DIHEDRAL ANGLES IN THE SAME FORMAT AS THE ONE FOR EGF DEPOSITED IN
C THE PROTEIN DATABANK
C
C THIS PROGRAM IS INTENDED TO TRANSLATE THE DISMAN INPUT FILE/S FOR
C NMR CONSTRAINTS INTO INPUT FILE/S FOR CONGEN. AS IN THIS DATE
C (7/30/92) IS ABLE TO CHANGE EVERYTHING IN DISMAN INPUT FILE/S 
C BUT:
C         1) QR PSEUDOATOMS LIKE IN TYR AND PHE
C            THEY ARE COUNTED AND ELIMINATED FROM THE LIST.
C
C         2) THE QQ PSEUDOATOMS (VAL AND LEU RESIDUES) ARE 
C            TREATED IN A SEPECIAL WAY. AS THEY CAN NOT BE 
C            HANDLED AT THIS TIME BY CONGEN THESE KIND OF
C            CONSTRAINTS ARE SUBSTITUTED BY
C                       QQG       CB
C                       QQD       CG
C
      IMPLICIT NONE
C
C     DECLARATIONS
C
      CHARACTER*80  LINEA
      CHARACTER*6   
     1              ATM1, ! IDENTIFICATION ATOM 1
     1             ATM1O, ! IDENTIFICATION ATOM 1
     1              ATM2, ! IDENTIFICATION ATOM 2
     1             ATM2O, ! IDENTIFICATION ATOM 2
     1                ID, ! IDENTIFICATION FOR THE MOLECULE IN CONGEN
     1              LOUP, ! LOWER OR UPPER BOUNDS IN DISMAN FILE
     1              RES1, ! ID FOR THE FIRST RESIDUE IN CONSTRAINT
     1              RES2, ! ID FOR THE SECOND RESIDUE 
     1             RES1O, ! ID FOR THE FIRST RESIDUE IN CONSTRAINT
     1             RES2O, ! ID FOR THE SECOND RESIDUE 
     1              REST, ! TEMPORAL ID FOR THE RESIDUE
     1             YESNO, ! Y IF THERE IS ANOTHER CONSTRAINT FILE TO READ
     1              YNJC, ! Y IF THERE IS A JCOUP CONSTRAINT FILE
     1            CONVER, ! DIHEDRAL CONVERSION TYPE
     1               CHK, ! Y IF YOU DESIRE CHECKING OF INPUT FILE
     1            DISDIA, ! DIS -> DISMAN, DIA -> DIANA
     1             UPDONE ! if upper have been already done
C
      CHARACTER*40 COMMEN ! COMMENT IN DISMAN FILE (AND ALSO IN CONGEN)
      CHARACTER*40 CPYCMN ! COPY OF COMMENT ABOVE
      CHARACTER*40 CPYCM0 ! COPY OF COMMENT ABOVE
      CHARACTER*20 ENTRA  ! NAME OF DISMAN INPUT FILE
      CHARACTER*20 SALE   ! NAME OF OUTPUT FILE FOR CONSTRAINTS
      CHARACTER*20 CHKNAM ! NAME OF OUTPUT FILE FOR CHECK
      CHARACTER*20 SEQU   ! NAME OF THE SEQUENCE FILE
C
      INTEGER*4
     1             IX,
     1             NUMT,   ! TEMPORAL NUMBER OF RESIDUE
     1             NUM1,   ! NUMBER OF RESIDUE 1
     1            NUM1O,   ! NUMBER OF RESIDUE 1
     2             NUM2,   ! NUMBER OF RESIDUE 2
     2            NUM2O,   ! NUMBER OF RESIDUE 2
     3             ICONS,  ! COUNTER OF FINAL CONSTRAINTS  
     4             ICONSO, ! COUNTER OF ORIGINAL CONSTRAINTS
     5             NUMQ,   ! COUNTER OF Q ATOM TYPES
     6             NUMQQ,  ! COUNTER OF QQ ATOM TYPES
     7             CONTROL,! CONTROL WHICH KIND OF OUTPUT FILE    
     8             I,K,    ! COUNTER 
     9             FLAG,   ! FLAG FOR CORRECTIONS
     $             NUMRES  ! NUMBER OF RESIDUES
      INTEGER      MECAGUENLA
C
      INTEGER      ICONSL, ! NUMBER OF LOWER BOUND CONSTRAINTS
     1             ICONSU, ! NUMBER OF UPPER BOUND CONSTRAINTS
     2             ICONQR, ! NUMBER OF QR ATOM TYPES
     3              CTERR  ! COUNT ERRORS ON CHECKING CONSTRAINTS  
C
      REAL         VAL,    ! CONSTRAINT VALUE
     1             VAL0,   ! ORIGINAL CONSTRAINT VALUE    
     1             CUTOFF, ! CUTOFF TO APPLY CORRECTION IN NOE CONSTRAIN
     1             PERCENT ! % OF CORRECTION APPLIED
C
      REAL         KORREK  ! CORRECTION TO BE APPLIED TO CONSTRAINTS
C
      LOGICAL     
     1             CONGEN, ! TRUE IF WE ARE GONNA MAKE CONGEN FILE
     2             DISCOV, ! TRUE IF WE ARE GONNA MAKE DISCOVER FILE
     3             IMPACT  ! TRUE IF WE ARE GONNA MAKE IMPACT FILE  
C
C VARIABLES FOR STATISTICAL ANALYSIS
C
      INTEGER      INTRA,  ! INTRARESIDUE CONSTRAINTS
     1             INTER1, ! INTERRESIDUE CONSTRAINTS I-J=1
     2             INTER2, ! INTERRESIDUE CONSTRAINTS 2<=I-J>=4
     A             ITBCKB, ! INTERRESIDUE BACKBONE BACKBONE
     B             ITBCKS, ! INTERRESIDUE BACKBONE SIDE CHAIN
     C             ITSCHS, ! INTERRESIDUE SIDE CHAIN SIDE CHAIN
     3             INTER5, ! INTERRESIDUE CONSTRAINTS I-J >= 5
     4             BCKB,   ! BACKBONE BACKBONE
     5             BCKS,   ! BACKBONE SIDE CHAIN
     6             SCHS,   ! SIDE CHAIN TO SIDE CHAIN
     7             IHB,    ! HYDROGEN BOND CONSTRAINTS
     8             ISS     ! DISULFIDE CONSTRAINTS
      LOGICAL      OUT     ! TELLS YOU IF ONE CONSTRAINT IS ALREADY DONE
C
      INTEGER      VIORES(100),
     2             VIORESB(100)
      REAL         VIORESA(100)
C
      INTEGER        CNUM1(3000),
     1               CNUM2(3000),
     1               NCNS(100),
     1               NCNST,
     1               KYCNS(100,200)
C
      REAL           LOWER(3000),
     1               UPPER(3000),
     1               ORIG0(3000),
     1               RFLAG(3000)
C
      CHARACTER*4    CATM1(3000),CATM2(3000),
     1               CRES1(3000),CRES2(3000),
     2               CRES(100)
C
      CHARACTER*40   CCMNT(3000)
C
      INTEGER        ERRORNO,LERR,ERCNSIST(1000),RESMAX,RESINI
C
      REAL           LOW,UPP
C
C INITIALIZATON
C
      DO 651 I=1,100
         VIORESA(I)=0
         VIORESB(I)=0
         VIORES(I)=0
         NCNS(I)=0
          DO 650 K=1,200
             KYCNS(I,K)=0
 650      CONTINUE
 651  CONTINUE
      MECAGUENLA=0
      ERRORNO=0
      LERR=0
      BCKB=0
      BCKS=0
      SCHS=0
      IHB=0
      ISS=0
      INTRA=0
      INTER1=0
      INTER2=0
      ITBCKB=0
      ITBCKS=0
      ITSCHS=0
      INTER5=0
      CONTROL=0
      ICONS=0
      ICONSL=0
      ICONSU=0
      ICONQR=0
      NUMQ=0
      NUMQQ=0
      CTERR=0
      CONGEN = .FALSE.
      DISCOV = .FALSE.
      IMPACT = .FALSE.
      YNJC='N'
      CONVER='F'
      CHK='Y'
      CUTOFF=0.0
      PERCENT=0.0
      UPDONE(1:2)='NO'
C
C OPEN FILE/S
C
      PRINT*, '                                          '
      PRINT*, ' --- beginning of DISMAN/DIANA to congen conversion --'
      PRINT*, '                                          '
C
C      TYPE 
C     1 '(''  NAME FOR CONSTRAINT OUTPUT FILE (def.: tejero.noe): '',$)'
C      ACCEPT '(A)', SALE
C
      PRINT*, 'NAME FOR CONSTRAINT OUTPUT FILE (def.: tejero.noe): '
      READ(5,'(A)') SALE
      IF (SALE .EQ. '') SALE='tejero.noe'
      OPEN(UNIT=2,NAME=SALE,STATUS='UNKNOWN')
      PRINT*, '                                        '
      PRINT*, '  WHAT KIND OF OUTPUT FILE: (TYPE 1, 2 OR 3) ? '
      PRINT*, '   1) CONGEN     2) DISCOVER   3) IMPACT     '
      PRINT*, '                                              '
C
C      TYPE '(''   Input file type (1/2/3) (default: 1) ->  '',$)'
C      ACCEPT '(I)', CONTROL
C
      PRINT*, '    Input file type (1/2/3) (default: 1) ->  '
      READ(5,'(I)') CONTROL
      IF (CONTROL .NE. 0 .AND.
     1    CONTROL .NE. 1 .AND.
     2    CONTROL .NE. 2 .AND.
     3    CONTROL .NE. 3) THEN
          PRINT*, '                                      '
          PRINT*, ' ==================================================='
          PRINT*, ' **  '
          PRINT*, ' **  YOU TYPED >>',CONTROL,'<<  ** NOT ACCEPTED **'
          PRINT*, ' **  TAKING DEFAULT VALUE OF 1 FOR CONGEN '
          PRINT*, ' **  '
          PRINT*, ' ==================================================='
          PRINT*, '                                      '
          CONTROL = 1
      ENDIF
      IF (CONTROL .EQ. 0) CONGEN = .TRUE.
      IF (CONTROL .EQ. 1) CONGEN = .TRUE.
      IF (CONTROL .EQ. 2) DISCOV = .TRUE.
      IF (CONTROL .EQ. 3) IMPACT = .TRUE.
      IF (CONGEN .EQ. .TRUE. ) THEN
         PRINT*, '  MAKING CONVERSION FROM DISMAN/DIANA TO CONGEN '
C
C         TYPE '(''   IDENTIFICATION FOR CHAIN (DEFAULT= R) : '',$) '
C         ACCEPT '(A)',ID
C        
         PRINT*, '   IDENTIFICATION FOR CHAIN (DEFAULT= R) : '
         READ(5,'(A)') ID
         IF (ID(1 : 3) .EQ. '   ') ID='R  '
      ENDIF
      IF (DISCOV .EQ. .TRUE.) THEN
        PRINT*, '  MAKING CONVERSION FROM DISMAN/DIANA TO DISCOVER '
        PRINT*, '  ====== !!!! NOT YET COMPLETELY DEVELOPPED !!! ===== '
        RETURN
      ENDIF
      IF (IMPACT .EQ. .TRUE.) THEN
         PRINT*, '  MAKING CONVERSION FROM DISMAN/DIANA TO IMPACT '
         PRINT*, '  ======= !!!  NOT YET DEVELOPPED !!! ===== '
         RETURN
      ENDIF
C
C FIRST READ SEQUENCE DATA. THIS SHOULD BE A LIST OF THE RESIDUES IN FORMAT A3
C
C
C      TYPE '(''   NAME FOR SEQUENCE INPUT FILE (def.: seq): ? '',$)'
C      ACCEPT '(A)', SEQU
C
      PRINT*, '    NAME FOR SEQUENCE INPUT FILE (def.: seq): ? '
      READ(5,'(A)') SEQU
      IF (SEQU .EQ. '') SEQU='seq'
      OPEN(UNIT=91,NAME=SEQU,STATUS='OLD')
C
C      TYPE '(''   STARTING WITH RESIDUE ?_ (def.: 1) '',$)'
C      ACCEPT '(A)', LINEA
C
      PRINT*, '    STARTING WITH RESIDUE ?_ (def.: 1) '
      READ(5,'(A)') LINEA
      IF (LINEA(1:1) .EQ. ' ') THEN 
         RESINI = 1
         I = RESINI - 1
      ELSE 
         READ(LINEA,'(I)') RESINI
         I = RESINI - 1
      ENDIF
      PRINT*,'  Starting residue: ',I+1
 1109 I=I+1
      RESMAX=I-1
      READ(91,901,END=1110,ERR=1108) CRES(I)
      GOTO 1109
 1110 CONTINUE
      GOTO 201
 1108 PRINT*, '  THE FILE  ',SEQU,' DOES NOT EXIST OR IS IN BAD FORMAT '
      RETURN
 201  CONTINUE
C
C REQUESTING INPUT DATA
C
      KORREK=0.0
      PRINT*, ' '
      PRINT*, '  WHAT CORRECTION FOR CONSTRAINTS (REAL FORMAT)? ; '
      PRINT*, '  EXAMPLE : FOR 15% CORRECTION INPUT SHOULD BE 15.0  '
C
C      TYPE '(''   Input amount of correction you want --> '',$)'
C      ACCEPT '(F12.2)', KORREK
C
      PRINT*, '    Input amount of correction you want --> '
      READ(5,'(F12.2)') KORREK
      IF (KORREK .LT. 0.0) KORREK=10.0
      WRITE(6,*) '  CORRECTION TERM SET TO : ',KORREK
C
C HEAD/S NEEDED BY THE PROGRAMS   
C
      IF (CONGEN .EQ. .TRUE.) THEN
                              WRITE(2,*) ' NMR CONSTRAINT FILE  '
                              WRITE(2,*) 
     1                        ' PERCENTAGE OF CORRECTION : ',PERCENT
                              WRITE(2,*) 
     1                        ' PERCENTAGE OF RELAX in all : ',KORREK
                              WRITE(2,1008) 
                              WRITE(2,1005)
                              WRITE(2,1007)
      ENDIF
      IF (DISCOV .EQ. .TRUE.) THEN
                              WRITE(2,2007)
                              WRITE(2,2008)
      ENDIF
C
C UPPER BOUNDS, LOWER BOUNDS AND DIHEDRAL
C
 1111 PRINT*, '                                '
C
C      TYPE '(''   INPUT FROM DISM, DIAN or SYBYL? [dis/dia/syb]: '',$)'
C      ACCEPT '(A)', DISDIA
C
      PRINT*, '    INPUT FROM DISM, DIAN or SYBYL? [dis/dia/syb]: '
      READ(5,'(a)') DISDIA
      IF (DISDIA(1:2) .EQ. ' ') DISDIA(1:4)='DISM'
      IF (UPDONE(1:2) .EQ. 'NO') THEN
         PRINT*, '                                '
         PRINT*, '  -------- INPUT OF CONSTRAINTS --------   '
         PRINT*, '  Note: as lower are a subgroup of upper , '
         PRINT*, '        upper MUST be input first          '
         PRINT*, '  --------------------------------------- '
         PRINT*, ' '
      ENDIF
C
C      TYPE  
C     1'(''   IS LOWER, UPPER OR DIHEDRAL CONSTRAINTS? (L/U/D)? : '',$)'
C      ACCEPT '(A)', LOUP
C
      PRINT*, '    IS LOWER, UPPER OR DIHEDRAL CONSTRAINTS? (L/U/D)? : '
      READ(5,'(A)') LOUP
      IF (LOUP(1:1) .EQ. ' ') THEN
         IF (UPDONE(1:3) .EQ. 'YES') LOUP='L'
         IF (UPDONE(1:2) .EQ. 'NO') LOUP='U'
      ENDIF
      IF (LOUP(1 : 1) .NE. 'D'  .AND.
     1    LOUP(1 : 1) .NE. 'd'  .AND.  
     2    LOUP(1 : 1) .NE. 'L'  .AND.  
     3    LOUP(1 : 1) .NE. 'l'  .AND.  
     4    LOUP(1 : 1) .NE. 'u'  .AND.  
     5    LOUP(1 : 1) .NE. 'U')  THEN
          PRINT*,'                             '
          PRINT*,' ****** YOU MUST TYPE L, U OR D '
          GOTO 1111
      ENDIF
      IF (LOUP(1:1) .EQ. 'U' .OR. LOUP(1:1) .EQ. 'u')  UPDONE='YES'
      IF (LOUP(1 : 1) .EQ. 'D'  .OR.
     1    LOUP(1 : 1) .EQ. 'd')  THEN
          CALL  JCOUP(ID,ICONS,CONVER,CRES,RESMAX,DISDIA)
          GOTO 301
      ENDIF
C
C DISMAN/DIANA INPUT FILE FOR UPPER LOWER OR DIHEDRAL
C
 2222 IF (LOUP(1:1) .EQ. 'U' .OR. LOUP(1:1) .EQ. 'u') THEN
         IF (DISDIA(1:3) .EQ. 'DIA' .OR. DISDIA(1:3) .EQ. 'dia') THEN
C
C            TYPE '(''   UPPER INPUT FILE (FROM DIANA)  :  '',$)'
C
         PRINT*, '    UPPER INPUT FILE (FROM DIANA)  :  '
         ELSE IF (DISDIA(1:3) .EQ. 'DIS' .OR. DISDIA(1:3) .EQ. 'dis') 
     2   THEN
C
C            TYPE '(''   UPPER INPUT FILE (FROM DISMAN)  :  '',$)'
C
         PRINT*, '    UPPER INPUT FILE (FROM DISMAN)  :  '
         ELSE IF (DISDIA(1:3) .EQ. 'SYB' .OR. DISDIA(1:3) .EQ. 'syb') 
     2   THEN
C
C            TYPE '(''   UPPER INPUT FILE (FROM SYBYL-DIANA)  :  '',$)'
C
         PRINT*, '    UPPER INPUT FILE (FROM SYBYL-DIANA)  :  '
         ENDIF
      ENDIF
      IF (LOUP(1:1) .EQ. 'L' .OR. LOUP(1:1) .EQ. 'l') THEN
         IF (DISDIA(1:3) .EQ. 'DIA' .OR. DISDIA(1:3) .EQ. 'dia') THEN
C
C            TYPE '(''   LOWER INPUT FILE (FROM DIANA)  :  '',$)'
C
         PRINT*, '    LOWER INPUT FILE (FROM DIANA)  :  '
         ELSE IF (DISDIA(1:3) .EQ. 'DIS' .OR. DISDIA(1:3) .EQ. 'dis') 
     2   THEN
C
C            TYPE '(''   LOWER INPUT FILE (FROM DISMAN)  :  '',$)'
C
         PRINT*, '    LOWER INPUT FILE (FROM DISMAN)  :  '
         ELSE IF (DISDIA(1:3) .EQ. 'SYB' .OR. DISDIA(1:3) .EQ. 'syb') 
     2   THEN
C
C            TYPE '(''   LOWER INPUT FILE (FROM SYBYL-DIANA)  :  '',$)'
C
         PRINT*, '    LOWER INPUT FILE (FROM SYBYL-DIANA)  :  '
         ENDIF
      ENDIF
C
C      ACCEPT '(A)', ENTRA
C
      READ(5,'(A)') ENTRA
      IF (ENTRA(1 : 6) .EQ. '      ') THEN
          PRINT*, ' **** YOU MUST SUPPLY AN INPUT FILE  '
          GOTO 2222
      ENDIF 
      OPEN(UNIT=1,NAME=ENTRA,STATUS='OLD',ERR=11)
C
      IF (LOUP(1:1) .EQ. 'U' .OR. LOUP(1:1) .EQ. 'u') THEN
C
C      TYPE  '(''   DO YOU WANT CHECK OF INPUT FILE (Y/N)'',$)'
C      ACCEPT '(A)', CHK
C
      PRINT*, '    DO YOU WANT CHECK OF INPUT FILE (Y/N) '
      READ(5,'(A)') CHK
      IF (CHK .EQ. '') CHK='Y'
      IF (CHK(1:1) .EQ. 'Y' .OR. CHK(1:1) .EQ. 'y') THEN
         IF (LOUP(1:1) .EQ. 'U' .OR. LOUP(1:1) .EQ. 'u' ) THEN
C
C         TYPE '(''   NAME OF OUTPUT FOR CHECKING (DEF: CHECK.OUT) '',$)'
C         ACCEPT '(A)', CHKNAM
C
         PRINT*, '    NAME OF OUTPUT FOR CHECKING (DEF: CHECK.OUT) '
	 READ(5,'(A)') CHKNAM
         IF (CHKNAM .EQ. '') CHKNAM='CHECK.OUT'
         OPEN(UNIT=98,NAME=CHKNAM,STATUS='UNKNOWN')
         ENDIF
      ENDIF
      ENDIF
C
      GOTO 49
 11   PRINT*,'  FILE *** ',ENTRA,' *** DOES NOT EXIST '
      PRINT*,'  IN CURRENT DIRECTORY, YOU HAVE GOT ANOTHER '
      PRINT*,'  OPPORTUNITY, GIVE ME OTHER NAME '
      GOTO 2222  
  49  PRINT*, '    '
      PRINT*, '  Wait please.......'
C
C THE MAIN BUCLE BEGINS HERE -------------------------------------------
C
  50  CONTINUE
C
C READING INPUT FILE
C
C This has been chaged un July, 1995. From this date on we read a line
C the we scan the line for comments (#) and then we read the line
C
      IF (DISDIA(1:3) .EQ. 'DIS' .OR. DISDIA(1:3) .EQ. 'dis') THEN
         READ (1,'(A)',END=300,ERR=101) LINEA
         IX=INDEX(LINEA,'#')
         IF (IX.GT.0 .AND. IX.LT.5) THEN
            LINEA(IX:80)=' '
            GOTO 50
         ENDIF
         IF (LINEA(1:3).NE.' ' .OR. LINEA(7:11).NE.' ') 
     1        READ (LINEA,1000,END=300,ERR=101) 
     1        NUMT,REST,ATM1,NUM2,RES2,ATM2,VAL,COMMEN
      ELSE IF(DISDIA(1:3) .EQ. 'DIA' .OR. DISDIA(1:3) .EQ. 'dia' .OR.
     2        DISDIA(1:3) .EQ. 'SYB' .OR. DISDIA(1:3) .EQ. 'syb') THEN
         READ (1,'(A)',END=300,ERR=101) LINEA
         IX=INDEX(LINEA,'#')
         IF (IX.GT.0 .AND. IX.LT.20) THEN
            LINEA(IX:80)=' '
            GOTO 50
         ENDIF
         IF (LINEA(1:3).NE.' ' .OR. LINEA(10:14).NE.' ') 
     1        READ (LINEA,1001,END=300,ERR=101) 
     1        NUMT,REST,ATM1,NUM2,RES2,ATM2,VAL,COMMEN
      ELSE
         PRINT*, '    '
         PRINT*, ' --- FORMAT UNKNOWN  '
         PRINT*, '    '
         RETURN
      END IF
C
C
      VAL0=VAL
      CPYCMN=COMMEN
      CPYCM0=COMMEN
      IF (NUMT .NE. 0) THEN
        NUM1=NUMT
        RES1=REST
        IF (LOUP(1:1) .EQ. 'U' .OR. LOUP(1:1) .EQ. 'u') THEN
          IF (CHK(1:1) .EQ. 'Y' .OR. CHK(1:1) .EQ. 'y') THEN
            IF (RES1 .NE. CRES(NUM1) .AND. (NUM2 .NE. 0)) THEN
               IF (CRES(NUM1) .NE. RES1) WRITE(98,1009)
     1           RES1,ATM1,NUM2,
     2           RES2,ATM2,VAL,
     3           RES1,CRES(NUM1)
 1009          FORMAT
     1              ('-->',A3,'<-',A4,'-----',I2,1X,A3,2X,A4,'----',
     2              F4.1,'-- Mismatch, in upp (',A3,
     3              '), in seq (',A3,') --')
               CPYCMN = ' ALREADY DONE '
            ENDIF
            IF (RES1 .NE. CRES(NUM1) .AND. (NUM2 .EQ. 0)) THEN
                WRITE(98,2010) NUM1, RES1, RES1,CRES(NUM1)
 2010         FORMAT(I2,'>',A3,'<------ Mismatch -- ',
     1        'in upp (',A3,') -- in seq (',A3,')' )
              CPYCMN = ' ALREADY DONE '
            ENDIF   
            CALL CHECK(CTERR,NUM1,RES1,ATM1,NUM2,RES2,ATM2,VAL,CPYCMN,
     1      COMMEN)
          ENDIF
        ENDIF
        GOTO 50
      ENDIF
      OUT=.FALSE.
      NUM1O=NUM1
      NUM2O=NUM2
      ATM1O=ATM1
      ATM2O=ATM2
      RES1O=RES1
      RES2O=RES2
C
C Call check the atom names in constraints
C
      IF (DISDIA(1:3) .EQ. 'DIS' .OR. DISDIA(1:3) .EQ. 'dis') THEN
            CALL NWCDIS(CTERR,NUM1,RES1,ATM1,NUM2,RES2,ATM2)
      ELSE IF (DISDIA(1:3) .EQ. 'DIA' .OR. DISDIA(1:3) .EQ. 'dia') THEN
            CALL NWCDIA(CTERR,NUM1,RES1,ATM1,NUM2,RES2,ATM2)
      ELSE IF (DISDIA(1:3) .EQ. 'SYB' .OR. DISDIA(1:3) .EQ. 'syb') THEN
            CALL NWCSYB(CTERR,NUM1,RES1,ATM1,NUM2,RES2,ATM2)
      ELSE
         PRINT*, ' '
         PRINT*, ' -------- FORMAT NOT KNOWN ------- '
         PRINT*, ' '
      ENDIF
C
C GOTO 7000 TO TREAT LOWER BOUNDS. THEY MUST BE A SUBGROUP OF UPPER
C
      IF ((LOUP(1:1) .EQ. 'L') .OR. (LOUP(1:1) .EQ. 'l')) GOTO 7000
C
C FOLLOW THE MAIN BUCLE FOR THE NORMAL CONSTRAINTS
C CONSTRAINTS PER RESIDUE
C
      IF (NUMT .EQ. 0) THEN
C
C FIRST INTRARESIDUE CONSTRAINTS
C
         IF (NUM1 .EQ. NUM2) VIORES(NUM1)=VIORES(NUM1)+1
C
C THEN INTER + SEQUENTIAL
C
         IF (ABS(NUM2-NUM1) .GE. 1) THEN
            VIORESA(NUM1)=VIORESA(NUM1)+0.5
            VIORESA(NUM2)=VIORESA(NUM2)+0.5
         ENDIF
C
C STORING THE NUMBER OF CONSTRAINTS PER RESIDUE
C
         NCNS(NUM1)=NCNS(NUM1)+1
         IF (NUM2 .NE. NUM1) NCNS(NUM2)=NCNS(NUM2)+1
      ENDIF
C
C STORING NAME OF RESIDUE
C
      IF (NUMRES .LE. NUM1) THEN
          NUMRES=NUM1
C          CRES(NUMRES)=RES1
      ENDIF
      IF (NUMRES .LE. NUM2) THEN
         NUMRES=NUM2
      ENDIF
C
C BUILDING UP THE ARRAY WITH CONSTRAINT DATA
C
      ICONS=ICONS+1
      KYCNS(NUM1,NCNS(NUM1))=ICONS
      IF (NUM2 .NE. NUM1) KYCNS(NUM2,NCNS(NUM2))=ICONS
      IF (NUM2 .EQ. NUM1) RFLAG(ICONS)=1.0
      IF (NUM2 .NE. NUM1) RFLAG(ICONS)=0.5
C
C STATISTICS OF CONSTRAINTS
C
      DO 212 I=1,30
         IF ((COMMEN(I:I+6) .EQ. 'H-BOND') .OR. 
     1       (COMMEN(I:I+6) .EQ. 'h-bond')) THEN
            IHB=IHB+2       ! It must be upper and lower constraints
            OUT=.TRUE.
         ENDIF
         IF ((COMMEN(I:I+2) .EQ. 'SS-') .OR.
     1       (COMMEN(I:I+2) .EQ. 'ss-')) THEN
            ISS=ISS+1
            OUT=.TRUE.
         ENDIF
 212  CONTINUE
C
C CLASSIFYING THE CONSTRAINTS.
C
      IF (OUT .EQ. .FALSE.) THEN
         IF (NUM2 .EQ. NUM1) INTRA=INTRA+1
         IF (ABS(NUM2-NUM1) .EQ. 1) THEN
            INTER1=INTER1+1
            IF ((ATM1(1:1) .EQ. 'N') .OR. (ATM1(1:2) .EQ. 'CA') .OR. 
     1          (ATM1(1:1) .EQ. 'O') .OR. (ATM1(1:2) .EQ. 'HN') .OR.
     2          (ATM1(1:2) .EQ. 'HA')) THEN
               IF ((ATM2(1:1) .EQ. 'N') .OR. (ATM2(1:2) .EQ. 'CA') .OR.
     1             (ATM2(1:1) .EQ. 'O') .OR. (ATM2(1:2) .EQ. 'HN') .OR. 
     2             (ATM2(1:2) .EQ. 'HA')) THEN
                    ITBCKB=ITBCKB+1
               ELSE
                    ITBCKS=ITBCKS+1
               ENDIF
            ELSE
               ITSCHS=ITSCHS+1
            ENDIF
         ENDIF
C
C BETWEEN 1 AND 5
C
         IF ((ABS(NUM2-NUM1) .GT. 1) .AND.
     1       (ABS(NUM2-NUM1) .LE. 5)) THEN
            INTER2=INTER2+1
            IF ((ATM1(1:1) .EQ. 'N') .OR. (ATM1(1:2) .EQ. 'CA') .OR. 
     1          (ATM1(1:1) .EQ. 'O') .OR. (ATM1(1:2) .EQ. 'HN') .OR.
     2          (ATM1(1:2) .EQ. 'HA')) THEN
               IF ((ATM2(1:1) .EQ. 'N') .OR. (ATM2(1:2) .EQ. 'CA') .OR.
     1             (ATM2(1:1) .EQ. 'O') .OR. (ATM2(1:2) .EQ. 'HN') .OR. 
     2             (ATM2(1:2) .EQ. 'HA')) THEN
                    BCKB=BCKB+1
               ELSE
                    BCKS=BCKS+1
               ENDIF
            ELSE
               SCHS=SCHS+1
            ENDIF
        ENDIF
C
C COUNTING GREATER THAN I I+5
C
        IF (ABS(NUM2-NUM1) .GT. 5)  INTER5=INTER5+1
      ENDIF
C
C CHECKING CONSISTENCY BETWEEN SEQUENCE DATA AND CONSTRAINTS DATA 
C ABOUT RESIDUE NAME AND NUMBER
C
      IF (CRES(NUM1) .NE. RES1 .OR. CRES(NUM2) .NE. RES2) THEN
         LERR=LERR+1
         ERCNSIST(LERR)=ICONS
         IF (CRES(NUM2) .NE. RES2) THEN
            WRITE(98,1004)
     1           ATM1,NUM2,RES2,
     2           ATM2,VAL,
     3           RES2,CRES(NUM2)
 1004       FORMAT
     1  (' > -----',A4,'-----',I2,'>',A3,'< ',A4,'----',
     2  F4.1,'-- Mismatch, in upp (',A3,
     3  '), in seq (',A3,') --')
         CPYCMN = ' ALREADY DONE '
         ENDIF
      ENDIF
C
C CALL CHECKING COMMENTS OF CONSTRAINTS BY SUBROUTINE CHECK
C
      IF (LOUP(1:1) .EQ. 'U' .OR. LOUP(1:1) .EQ. 'u') THEN
         IF (CHK(1:1) .EQ. 'Y' .OR. CHK(1:1) .EQ. 'y') THEN
            CALL CHECK(CTERR,NUM1,RES1,ATM1,NUM2,RES2,ATM2,VAL,CPYCMN,
     1                 COMMEN)
         ENDIF
      ENDIF
C
      ICONSO=ICONSO+1
C
 7000 CONTINUE
C
C Change O in last residue to OT1 if CONGEN is the OUTPUT
C
      IF (NUM1 .EQ. RESMAX) THEN
         IF (CONGEN .EQ. .TRUE. ) THEN
            IF (ATM1(1:4) .EQ. 'O   ') ATM1(1:4)='OT1 '
         ENDIF
      ENDIF
      IF (NUM2 .EQ. RESMAX) THEN
         IF (CONGEN .EQ. .TRUE. ) THEN
            IF (ATM2(1:4) .EQ. 'O   ') ATM2(1:4)='OT1 '
         ENDIF
      ENDIF

C
C -------------- GENERAL CHANGES ---------------
C
C CHANGE HN (IN DISMAN/DIANA) TO H IN CONGEN
C
      IF (CONGEN) THEN
         IF (ATM1(1 : 4) .EQ. 'HN  ') ATM1='H   '
         IF (ATM2(1 : 4) .EQ. 'HN  ') ATM2='H   '
      ENDIF
C
C GENERAL HYDROGENS CHANGES RESIDUE BY RESIDUE
C
C ==== ALA NEEDS NO CHANGES
C ==== ARG NEEDS NO CHANGES
      IF (RES1(1:3) .EQ. 'ARG') THEN 
         IF (DISDIA(1:3) .EQ. 'DIA' .OR. DISDIA(1:3) .EQ. 'dia') THEN
            IF (ATM1(1 : 4) .EQ. 'HB2 ') ATM1(1 : 4)='HB1 '
            IF (ATM1(1 : 4) .EQ. 'HB3 ') ATM1(1 : 4)='HB2 '
            IF (ATM1(1 : 4) .EQ. 'HG2 ') ATM1(1 : 4)='HG1 '
            IF (ATM1(1 : 4) .EQ. 'HG3 ') ATM1(1 : 4)='HG2 '
            IF (ATM1(1 : 4) .EQ. 'HE2 ') ATM1(1 : 4)='HE1 '
            IF (ATM1(1 : 4) .EQ. 'HE3 ') ATM1(1 : 4)='HE2 '
         ENDIF
      ENDIF
      IF (RES2(1 : 3) .EQ. 'ARG') THEN
         IF (DISDIA(1:3) .EQ. 'DIA' .OR. DISDIA(1:3) .EQ. 'dia') THEN
            IF (ATM2(1 : 4) .EQ. 'HB2 ') ATM2(1 : 4)='HB1 '
            IF (ATM2(1 : 4) .EQ. 'HB3 ') ATM2(1 : 4)='HB2 '
            IF (ATM2(1 : 4) .EQ. 'HG2 ') ATM2(1 : 4)='HG1 '
            IF (ATM2(1 : 4) .EQ. 'HG3 ') ATM2(1 : 4)='HG2 '
            IF (ATM2(1 : 4) .EQ. 'HE2 ') ATM2(1 : 4)='HE1 '
            IF (ATM2(1 : 4) .EQ. 'HE3 ') ATM2(1 : 4)='HE2 '
         ENDIF
      ENDIF
C ==== ASP NEEDS NO CHANGES
C
C ==== ASN
C                              HD21      (HDE)
C                             /
C                OD1       ND2
C                  \      /   \
C                   \    /     HD22      (HDZ)
C                     CG
C                     |
C                     CB
C                     |
C                   N-CA-C
C
C                   
      IF (RES1(1:3) .EQ. 'ASN') THEN   
         IF (DISDIA(1:3) .EQ. 'DIA' .OR. DISDIA(1:3) .EQ. 'dia') THEN
            IF (ATM1(1 : 4) .EQ. 'HB2 ') ATM1(1 : 4)='HB1 '
            IF (ATM1(1 : 4) .EQ. 'HB3 ') ATM1(1 : 4)='HB2 '
         ENDIF
         IF (ATM1(1 : 4) .EQ. 'HDE ') ATM1(1 : 4)='HD21'
         IF (ATM1(1 : 4) .EQ. 'HDZ ') ATM1(1 : 4)='HD22'
      ENDIF
      IF (RES2(1 : 3) .EQ. 'ASN') THEN
         IF (DISDIA(1:3) .EQ. 'DIA' .OR. DISDIA(1:3) .EQ. 'dia') THEN
            IF (ATM2(1 : 4) .EQ. 'HB2 ') ATM2(1 : 4)='HB1 '
            IF (ATM2(1 : 4) .EQ. 'HB3 ') ATM2(1 : 4)='HB2 '
         ENDIF
         IF (ATM2(1 : 4) .EQ. 'HDE ') ATM2(1 : 4)='HD21'
         IF (ATM2(1 : 4) .EQ. 'HDZ ') ATM2(1 : 4)='HD22'
      ENDIF
C
C ==== CYS NEEDS NO CHANGES
C ==== GLU NEEDS NO CHANGES
C
C ==== GLN
C
C                              HE21    (HEE)
C                             /
C                OE1       NE2
C                  \      /   \
C                   \    /     HE22    (HEZ)
C                     CD
C                     |
C                     CG
C                     |
C                     CB
C                     |
C                   N-CA-C
C
C
      IF (RES1(1:3) .EQ. 'GLN') THEN   
         IF (ATM1(1 : 4) .EQ. 'HEE ') ATM1(1 : 4)='HE21'
         IF (ATM1(1 : 4) .EQ. 'HEZ ') ATM1(1 : 4)='HE22'
      ENDIF  
      IF (RES2(1:3) .EQ. 'GLN') THEN   
         IF (ATM2(1 : 4) .EQ. 'HEE ') ATM2(1 : 4)='HE21'
         IF (ATM2(1 : 4) .EQ. 'HEZ ') ATM2(1 : 4)='HE22'
      ENDIF  
C
C ==== HIS
C
      IF (RES1(1:3) .EQ. 'HIS') THEN
         IF (ATM1(1:4) .EQ. 'HD4 ') ATM1(1:4)='HD2 '
         IF (ATM1(1:4) .EQ. 'HE2 ') ATM1(1:4)='HE1 '
      ENDIF
      IF (RES2(1:3) .EQ. 'HIS') THEN
         IF (ATM2(1:4) .EQ. 'HD4 ')ATM2(1:4)='HD2 '
         IF (ATM2(1:4) .EQ. 'HE2 ')ATM2(1:4)='HE1 '
      ENDIF
C
C ==== ILE
C
      IF (RES1(1:3) .EQ. 'ILE') THEN
         IF (ATM1(1:4) .EQ. 'HG1 ') ATM1(1:4)='HG11'
         IF (ATM1(1:4) .EQ. 'HG2 ') ATM1(1:4)='HG12'
         IF (ATM1(1:4) .EQ. 'HG3 ') ATM1(1:4)='HG21'
         IF (ATM1(1:4) .EQ. 'HG4 ') ATM1(1:4)='HG22'
         IF (ATM1(1:4) .EQ. 'HG5 ') ATM1(1:4)='HG23'
         IF (ATM1(1:4) .EQ. 'CD1 ') ATM1(1:4)='CD  '
      ENDIF
      IF (RES2(1:3) .EQ. 'ILE') THEN
         IF (ATM2(1:4) .EQ. 'HG1 ') ATM2(1:4)='HG11'
         IF (ATM2(1:4) .EQ. 'HG2 ') ATM2(1:4)='HG12'
         IF (ATM2(1:4) .EQ. 'HG3 ') ATM2(1:4)='HG21'
         IF (ATM2(1:4) .EQ. 'HG4 ') ATM2(1:4)='HG22'
         IF (ATM2(1:4) .EQ. 'HG5 ') ATM2(1:4)='HG23'
         IF (ATM2(1:4) .EQ. 'CD1 ') ATM2(1:4)='CD  '
      ENDIF
C
C ==== LEU
C
      IF (RES1(1:3) .EQ. 'LEU') THEN
         IF (ATM1(1:4) .EQ. 'HD1 ') ATM1(1:4)='HD11'
         IF (ATM1(1:4) .EQ. 'HD2 ') ATM1(1:4)='HD12'
         IF (ATM1(1:4) .EQ. 'HD3 ') ATM1(1:4)='HD13'
         IF (ATM1(1:4) .EQ. 'HD4 ') ATM1(1:4)='HD21'
         IF (ATM1(1:4) .EQ. 'HD5 ') ATM1(1:4)='HD22'
         IF (ATM1(1:4) .EQ. 'HD6 ') ATM1(1:4)='HD23'
      ENDIF
      IF (RES2(1:3) .EQ. 'LEU') THEN
         IF (ATM2(1:4) .EQ. 'HD1 ') ATM2(1:4)='HD11'
         IF (ATM2(1:4) .EQ. 'HD2 ') ATM2(1:4)='HD12'
         IF (ATM2(1:4) .EQ. 'HD3 ') ATM2(1:4)='HD13'
         IF (ATM2(1:4) .EQ. 'HD4 ') ATM2(1:4)='HD21'
         IF (ATM2(1:4) .EQ. 'HD5 ') ATM2(1:4)='HD22'
         IF (ATM2(1:4) .EQ. 'HD6 ') ATM2(1:4)='HD23'
      ENDIF
C
C LYS NEEDS NO CHANGES
C MET NEEDS NO CHANGES
C
C ==== PHE
C
      IF (RES1(1:3) .EQ. 'PHE') THEN
         IF (ATM1(1:4) .EQ. 'HD2 ') ATM1(1:4)='HD1 '
         IF (ATM1(1:4) .EQ. 'HE3 ') ATM1(1:4)='HE1 '
         IF (ATM1(1:4) .EQ. 'HE5 ') ATM1(1:4)='HE2 '
         IF (ATM1(1:4) .EQ. 'HD6 ') ATM1(1:4)='HD2 '
         IF (ATM1(1:4) .EQ. 'HZ4 ') ATM1(1:4)='HZ '
      ENDIF
      IF (RES2(1:3) .EQ. 'PHE') THEN
         IF (ATM2(1:4) .EQ. 'HD2 ') ATM2(1:4)='HD1 '
         IF (ATM2(1:4) .EQ. 'HE3 ') ATM2(1:4)='HE1 '
         IF (ATM2(1:4) .EQ. 'HE5 ') ATM2(1:4)='HE2 '
         IF (ATM2(1:4) .EQ. 'HD6 ') ATM2(1:4)='HD2 '
         IF (ATM2(1:4) .EQ. 'HZ4 ') ATM2(1:4)='HZ '
      ENDIF
C
C ==== PRO NEEDS NO CHANGES
C
C ==== SER
C
      IF (RES1(1 : 3) .EQ. 'SER') THEN
         IF (ATM1(1 : 4) .EQ. 'HG  ') ATM1(1 : 4)='HG1 '
      ENDIF
      IF (RES2(1 : 3) .EQ. 'SER') THEN
         IF (ATM2(1 : 4) .EQ. 'HG  ') ATM2(1 : 4)='HG1 '
      ENDIF
C
C ==== THR
C
      IF (RES1(1:3) .EQ. 'THR') THEN
         IF (ATM1(1:4) .EQ. 'HG2 ') ATM1(1:4)='HG21'
         IF (ATM1(1:4) .EQ. 'HG3 ') ATM1(1:4)='HG22'
         IF (ATM1(1:4) .EQ. 'HG4 ') ATM1(1:4)='HG23'
      ENDIF
      IF (RES2(1:3) .EQ. 'THR') THEN
         IF (ATM2(1:4) .EQ. 'HG2 ') ATM2(1:4)='HG21'
         IF (ATM2(1:4) .EQ. 'HG3 ') ATM2(1:4)='HG22'
         IF (ATM2(1:4) .EQ. 'HG4 ') ATM2(1:4)='HG23'
      ENDIF
C
C ==== TRP
C
      IF (RES1(1:3) .EQ. 'TRP') THEN   
         IF (ATM1(1 : 4) .EQ. 'HZ7 ') ATM1(1 : 4)='HZ2 '
         IF (ATM1(1 : 4) .EQ. 'HH6 ') ATM1(1 : 4)='HH2 '
         IF (ATM1(1 : 4) .EQ. 'HD2 ') ATM1(1 : 4)='HD1 '
         IF (ATM1(1 : 4) .EQ. 'HE4 ') ATM1(1 : 4)='HE3 '
         IF (ATM1(1 : 4) .EQ. 'HZ5 ') ATM1(1 : 4)='HZ3 '
      ENDIF
      IF (RES2(1:3) .EQ. 'TRP') THEN   
         IF (ATM2(1 : 4) .EQ. 'HZ7 ') ATM2(1 : 4)='HZ2 '
         IF (ATM2(1 : 4) .EQ. 'HH6 ') ATM2(1 : 4)='HH2 '
         IF (ATM2(1 : 4) .EQ. 'HD2 ') ATM2(1 : 4)='HD1 '
         IF (ATM2(1 : 4) .EQ. 'HE4 ') ATM2(1 : 4)='HE3 '
         IF (ATM2(1 : 4) .EQ. 'HZ5 ') ATM2(1 : 4)='HZ3 '
      ENDIF
C
C ==== TYR
C
      IF (RES1(1:3) .EQ. 'TYR') THEN
         IF (ATM1(1:4) .EQ. 'HD2 ') ATM1(1:4)='HD1 '
         IF (ATM1(1:4) .EQ. 'HE3 ') ATM1(1:4)='HE1 '
         IF (ATM1(1:4) .EQ. 'HE5 ') ATM1(1:4)='HE2 '
         IF (ATM1(1:4) .EQ. 'HD6 ') ATM1(1:4)='HD2 '
      ENDIF
      IF (RES2(1:3) .EQ. 'TYR') THEN
         IF (ATM2(1:4) .EQ. 'HD2 ') ATM2(1:4)='HD1 '
         IF (ATM2(1:4) .EQ. 'HE3 ') ATM2(1:4)='HE1 '
         IF (ATM2(1:4) .EQ. 'HE5 ') ATM2(1:4)='HE2 '
         IF (ATM2(1:4) .EQ. 'HD6 ') ATM2(1:4)='HD2 '
      ENDIF
C
C ==== VAL
C
      IF (RES1(1:3) .EQ. 'VAL') THEN
         IF (ATM1(1:4) .EQ. 'HG1 ') ATM1(1:4)='HG11'
         IF (ATM1(1:4) .EQ. 'HG2 ') ATM1(1:4)='HG12'
         IF (ATM1(1:4) .EQ. 'HG3 ') ATM1(1:4)='HG13'
         IF (ATM1(1:4) .EQ. 'HG4 ') ATM1(1:4)='HG21'
         IF (ATM1(1:4) .EQ. 'HG5 ') ATM1(1:4)='HG22'
         IF (ATM1(1:4) .EQ. 'HG6 ') ATM1(1:4)='HG23'
      ENDIF
      IF (RES2(1:3) .EQ. 'VAL') THEN
         IF (ATM2(1:4) .EQ. 'HG1 ') ATM2(1:4)='HG11'
         IF (ATM2(1:4) .EQ. 'HG2 ') ATM2(1:4)='HG12'
         IF (ATM2(1:4) .EQ. 'HG3 ') ATM2(1:4)='HG13'
         IF (ATM2(1:4) .EQ. 'HG4 ') ATM2(1:4)='HG21'
         IF (ATM2(1:4) .EQ. 'HG5 ') ATM2(1:4)='HG22'
         IF (ATM2(1:4) .EQ. 'HG6 ') ATM2(1:4)='HG23'
      ENDIF
C
C CHANGE THE WILDCARD FOR COMMENTS IN CONGEN FILE
C
      CPYCM0=COMMEN
      DO 60 I=1,10
         IF (COMMEN(I : I) .EQ. '#') THEN
             COMMEN(I:I)='!'
             FLAG=I
             GOTO 61
         ENDIF
 60      CONTINUE
C
C CHECK IF THERE IS NO COMMENT IN DISMAN INPUT FILE
C
      IF (COMMEN(1:5) .EQ. '     ') THEN
        COMMEN(1:5)='  !  '
      ENDIF
 61   CONTINUE
C
C =================== PSUEDOATOMS =========================
C
C =====  AROMATIC HYDROGENS . PSEUDOATOMS CG1 AND CZ4
C
C
C CHANGE CG1 AND CZ4 IN DISMAN TO
C        HD* AND HE* IN CONGEN IN TYROSINE 
C
      IF (RES1(1:3) .EQ. 'TYR') THEN                     !     CZ  (CZ4)
         IF (ATM1(1 : 4) .EQ. 'CG1 ') ATM1(1 : 4)='HD* ' !    /  \
         IF (ATM1(1 : 4) .EQ. 'CZ4 ') ATM1(1 : 4)='HE* ' !  CE1  CE2
              CALL REMOVE(VAL,COMMEN,FLAG)               !   |    |
      ENDIF                                              !  CD1  CD2
      IF (RES2(1:3) .EQ. 'TYR') THEN                     !    \  /
         IF (ATM2(1 : 4) .EQ. 'CG1 ')ATM2(1 : 4)='HD* '  !     CG  (CG1)
         IF (ATM2(1 : 4) .EQ. 'CZ4 ')ATM2(1 : 4)='HE* '  !     |
              CALL REMOVE(VAL,COMMEN,FLAG)               !     CB
      ENDIF                                              !     |
C                                                        !   N-CA-C
C CHANGE CG1 AND CZ4 IN DISMAN TO
C        HD* AND HE* IN CONGEN IN PHENYLALANINE
C
      IF (RES1(1:3) .EQ. 'PHE') THEN   
         IF (ATM1(1 : 4) .EQ. 'CG1 ') ATM1(1 : 4)='HD* '
         IF (ATM1(1 : 4) .EQ. 'CZ4 ') ATM1(1 : 4)='HE* '
              CALL REMOVE(VAL,COMMEN,FLAG)
      ENDIF
      IF (RES2(1:3) .EQ. 'PHE') THEN   
         IF (ATM2(1 : 4) .EQ. 'CG1 ')ATM2(1 : 4)='HD* '
         IF (ATM2(1 : 4) .EQ. 'CZ4 ')ATM2(1 : 4)='HE* '
              CALL REMOVE(VAL,COMMEN,FLAG)
      ENDIF
C
C ===== QR ATOM TYPE FOR TYR AND PHE
C
C This code has been added in SEp 94 and it is only provisional
C at this momments only the comment is analyzed and the corrections
C removed.
C
C RTT. Universidad de Valencia
C
      IF (RES1(1:3) .EQ. 'PHE' .OR. RES1(1:3) .EQ. 'TYR') THEN
	 IF (ATM1(1:4) .EQ. 'QR  ') THEN
            CALL  REMOVE(VAL,COMMEN,FLAG)
            ICONQR=ICONQR+1
         ENDIF
      ENDIF
C
C second atom
C
      IF (RES2(1:3) .EQ. 'PHE' .OR. RES2(1:3) .EQ. 'TYR') THEN
	 IF (ATM2(1:4) .EQ. 'QR  ') THEN
            CALL  REMOVE(VAL,COMMEN,FLAG)
            ICONQR=ICONQR+1
         ENDIF
      ENDIF

C ======  METHYLS , RESIDUES : ALA, MET, ILE AND THR
C
C    AS NOW (OCT.7.92) THE PROGRAM DOES THE FOLLOWING
C     RESIDUE        CHANGE       REMOVE CORRECTION
C     -------      ---------      -----------------
C       ALA        QB  TO HB*      1.0 or 0.6 (i or m)
C       MET        QE  TO HE*      1.0 or 0.6 (i or m)
C       ILE        QD  TO HD*      1.0 or 0.6 (i or m)
C       ILE        QG2 TO HG2*     1.0 or 0.6 (i or m)
C       THR        QG  TO HG2*     1.0 or 0.6 (i or m)
C
C
C ==== ALA
C                                           !
      IF (RES1(1:3) .EQ. 'ALA' ) THEN       !
          IF (ATM1(1:4) .EQ. 'QB  ') THEN   !
              CALL REMOVE(VAL,COMMEN,FLAG)  !      HB3
              NUMQ=NUMQ+1                   !       |
              ATM1(1:3)='HB*'               !   HB1-CB-HB3   (QB)
              IF (DISCOV) CALL DISC3(ATM1)  !       |
          ENDIF                             !     N-CA-C
      ENDIF                                 !
C                                           !     
C ==== ILE
C
      IF (RES1(1:3) .EQ. 'ILE') THEN        !
          IF (ATM1(1:1) .EQ. 'Q') THEN      !     HD2   (QD)
             IF(ATM1(2:4) .EQ. 'D  ') THEN  !      |
               CALL REMOVE(VAL,COMMEN,FLAG) !  HD1-CD-HD3     HG21
               NUMQ=NUMQ+1                  !      |         /
               ATM1(1:3)='HD*'              !(QG1) CG1    CG2-HG22  (QG2)
               IF (DISCOV) CALL DISC3(ATM1) !       \    /   \
             ENDIF                          !        \  /     HG23
             IF(ATM1(2:4) .EQ. 'G2 ') THEN  !         CB            (QB)
               CALL REMOVE(VAL,COMMEN,FLAG) !         |
               NUMQ=NUMQ+1                  !       N-CA-C           
               ATM1(1:4)='HG2*'             !
               IF (DISCOV) CALL DISC3(ATM1) !
             ENDIF                          !
          ENDIF                             !
      ENDIF                                 !
C
C ===== MET
C
      IF (RES1(1:3) .EQ. 'MET' ) THEN       !      HE2
          IF (ATM1(1:4) .EQ. 'QE  ') THEN   !       |
              CALL REMOVE(VAL,COMMEN,FLAG)  !   HE1-CE-HE3   (QE)
              NUMQ=NUMQ+1                   !       |
              ATM1(1:3)='HE*'               !       SD
              IF (DISCOV) CALL DISC3(ATM1)  !   HG1-CG-HG2   (QG)
          ENDIF                             !   HB1-CB-HB2   (QB)
      ENDIF                                 !       |
C
C ===== THR                                 !
C                                           !
      IF (RES1(1:3) .EQ. 'THR' ) THEN       !   HG1      HG21
          IF (ATM1(1:4) .EQ. 'QG  ') THEN   !    |      /
              CALL REMOVE(VAL,COMMEN,FLAG)  !   OG1  CG2-HG22    (QG2)
              NUMQ=NUMQ+1                   !     \ /   \
              ATM1(1:4)='HG2*'              !      CB    HG23    (QB)
              IF (DISCOV) CALL DISC3(ATM1)  !      |
          ENDIF                             !    N-CA-C
      ENDIF                                 !
C
C =========== SECOND ATOM ==========
C
C ===== ALA
C
      IF (RES2(1:3) .EQ. 'ALA' ) THEN
          IF (ATM2(1:4) .EQ. 'QB  ') THEN
              CALL REMOVE(VAL,COMMEN,FLAG)
              NUMQ=NUMQ+1
              ATM2(1:3)='HB*'
              IF (DISCOV) CALL DISC3(ATM1)
          ENDIF
      ENDIF
C
C ===== ILE
C
      IF (RES2(1:3) .EQ. 'ILE') THEN
          IF (ATM2(1:1) .EQ. 'Q') THEN
             IF(ATM2(2:4) .EQ. 'D  ') THEN
               CALL REMOVE(VAL,COMMEN,FLAG)
               NUMQ=NUMQ+1
               ATM2(1:3)='HD*'
               IF (DISCOV) CALL DISC3(ATM1)
             ENDIF
             IF(ATM2(2:4) .EQ. 'G2 ') THEN
               CALL REMOVE(VAL,COMMEN,FLAG)
               NUMQ=NUMQ+1
               ATM2(1:4)='HG2*'
               IF (DISCOV) CALL DISC3(ATM1)
             ENDIF
          ENDIF
      ENDIF
C
C ===== MET
C
      IF (RES2(1:3) .EQ. 'MET' ) THEN
          IF (ATM2(1:4) .EQ. 'QE  ') THEN
              CALL REMOVE(VAL,COMMEN,FLAG)
              NUMQ=NUMQ+1
              ATM2(1:3)='HE*'
              IF (DISCOV) CALL DISC3(ATM1)
          ENDIF
      ENDIF
C
C ===== THR
C
      IF (RES2(1:3) .EQ. 'THR' ) THEN
          IF (ATM2(1:4) .EQ. 'QG  ') THEN
              CALL REMOVE(VAL,COMMEN,FLAG)
              NUMQ=NUMQ+1
              ATM2(1:4)='HG2*'
              IF (DISCOV) CALL DISC3(ATM1)
          ENDIF
      ENDIF
C
C ====  METHYLS, RESIDUES  VAL AND LEU
C
C   AS NOW (OCT.7.92) THE PROGRAM DOES THE FOLLOWING
C
C     RESIDUE           CHANGE           REMOVE CORRECTION
C     -------        -------------       -----------------
C       VAL           QG1  TO HG1*       1.0 or 0.6 (i or m)
C       VAL           QG2  TO HG2*       1.0 or 0.6 (i or m)
C       VAL           QQG  TO HG*             ---
C       LEU           QD1  TO HD1 *      1.0 or 0.6 (i or m)
C       LEU           QD2  TO HD2*       1.0 or 0.6 (i or m)
C       LEU           QQD  TO HD*             ---
C
C
C             LEU                                VAL
C    ======================             ======================
C
C    HD13              HD23             HG13              HG23
C        \ (QD1) (QD2)/                     \ (QG1) (QG2)/
C    HD12-CD1  .   CD2-HD22             HG12-CG1  .   CG2-HG22
C        /  \(QQD)/   \                     /  \(QQG)/   \
C    HD11    \   /     HD21             HG11    \   /     HG21
C             \ /                                \ /
C              CG                                 CB    (QB)
C              |                                  |
C              CB   (QB)                        N-CA-C
C              |
C            N-CA-C
C
C
      IF (RES1(1:3) .EQ. 'VAL' .OR.
     1    RES1(1:3) .EQ. 'LEU') THEN
          IF (ATM1(1:1) .EQ. 'Q' .AND. ATM1(2:4) .EQ. 'G1 ') THEN
             CALL REMOVE(VAL,COMMEN,FLAG)
             NUMQ=NUMQ+1
             ATM1(1:4)='HG1*'
             IF (DISCOV) CALL DISC3(ATM1)
          ENDIF
          IF (ATM1(1:1) .EQ. 'Q' .AND. ATM1(2:4) .EQ. 'G2 ') THEN
             CALL REMOVE(VAL,COMMEN,FLAG)
             NUMQ=NUMQ+1
             ATM1(1:4)='HG2*'
             IF (DISCOV) CALL DISC3(ATM1)
          ENDIF
          IF (ATM1(1:1) .EQ. 'Q' .AND. ATM1(2:4) .EQ. 'D1 ') THEN
             CALL REMOVE(VAL,COMMEN,FLAG)
             NUMQ=NUMQ+1
             ATM1(1:4)='HD1*'
             IF (DISCOV) CALL DISC3(ATM1)
          ENDIF
          IF (ATM1(1:1) .EQ. 'Q' .AND. ATM1(2:4) .EQ. 'D2 ') THEN
             CALL REMOVE(VAL,COMMEN,FLAG)
             NUMQ=NUMQ+1
             ATM1(1:4)='HD2*'
             IF (DISCOV) CALL DISC3(ATM1)
          ENDIF
          IF (ATM1(1:4) .EQ. 'QQG ') THEN
              CALL REMOVE(VAL,COMMEN,FLAG)
              ATM1(1:4)='HG* '
              NUMQQ=NUMQQ+1
          ENDIF
          IF (ATM1(1:4) .EQ. 'QQD ') THEN
              CALL REMOVE(VAL,COMMEN,FLAG)
              ATM1(1:4)='HD* '
              NUMQQ=NUMQQ+1
          ENDIF
      ENDIF
C
C ======= SECOND ATOM =======
C
      IF (RES2(1:3) .EQ. 'VAL' .OR.
     1    RES2(1:3) .EQ. 'LEU') THEN
          IF (ATM2(1:1) .EQ. 'Q' .AND. ATM2(2:4) .EQ. 'G1 ') THEN
             CALL REMOVE(VAL,COMMEN,FLAG)
             NUMQ=NUMQ+1
             ATM2(1:4)='HG1*'
             IF (DISCOV) CALL DISC3(ATM1)
          ENDIF
          IF (ATM2(1:1) .EQ. 'Q' .AND. ATM2(2:4) .EQ. 'G2 ') THEN
             CALL REMOVE(VAL,COMMEN,FLAG)
             NUMQ=NUMQ+1
             ATM2(1:4)='HG2*'
             IF (DISCOV) CALL DISC3(ATM1)
          ENDIF
          IF (ATM2(1:1) .EQ. 'Q' .AND. ATM2(2:4) .EQ. 'D1 ') THEN
             CALL REMOVE(VAL,COMMEN,FLAG)
             NUMQ=NUMQ+1
             ATM2(1:4)='HD1*'
             IF (DISCOV) CALL DISC3(ATM1)
          ENDIF
          IF (ATM2(1:1) .EQ. 'Q' .AND. ATM2(2:4) .EQ. 'D2 ') THEN
             CALL REMOVE(VAL,COMMEN,FLAG)
             NUMQ=NUMQ+1
             ATM2(1:4)='HD2*'
             IF (DISCOV) CALL DISC3(ATM1)
          ENDIF
          IF (ATM2(1:4) .EQ. 'QQG ') THEN
              CALL REMOVE(VAL,COMMEN,FLAG)
              ATM2(1:4)='HG* '
              NUMQQ=NUMQQ+1
          ENDIF
          IF (ATM2(1:4) .EQ. 'QQD ') THEN
              CALL REMOVE(VAL,COMMEN,FLAG)
              ATM2(1:4)='HD* '
              NUMQQ=NUMQQ+1
          ENDIF
      ENDIF
C
C ============= METHYLENES ==============
C CODE ADDED (11-14-92) RTT
C 
C ==== GLY
C                                          !
      IF (RES1(1:3) .EQ. 'GLY') THEN       !
         IF (ATM1(1:4) .EQ. 'CA  ' .OR.    
     $       ATM1(1:4) .EQ. 'QA  ') THEN
            CALL REMOVE(VAL,COMMEN,FLAG)   !
            ATM1(1:3)='HA*'                !
            IF (DISCOV) CALL DISC3(ATM1)   !          HA1
         ENDIF                             !           |
      ENDIF                                !       N - CA - C   (QA)
C                                          !           |
      IF (RES2(1:3) .EQ. 'GLY') THEN       !          HA2
         IF (ATM2(1:4) .EQ. 'CA  ' .OR.
     $       ATM2(1:4) .EQ. 'QA  ' ) THEN
            CALL REMOVE(VAL,COMMEN,FLAG)   !
           ATM2(1:3)='HA*'                 !
            IF (DISCOV) CALL DISC3(ATM2)   !
         ENDIF                             !
      ENDIF                                !
C
C ==== ILE
C
      IF (RES1(1:3) .EQ. 'ILE') THEN       !
         IF (ATM1(1:4) .EQ. 'QG1 ') THEN   !
            CALL REMOVE(VAL,COMMEN,FLAG)   !
            ATM1(1:4)='HG1*'               !
            IF (DISCOV) CALL DISC3(ATM1)   !         
         ENDIF                             !      
      ENDIF                                !           CD (QD)
C                                          !           |      
      IF (RES2(1:3) .EQ. 'ILE') THEN       !      HG11 |      
         IF (ATM2(1:4) .EQ. 'QG1 ') THEN   ! (QG1)    >CG1   CG2 (QG2)
            CALL REMOVE(VAL,COMMEN,FLAG)   !      HG12   \  /   
           ATM2(1:4)='HG1*'                !              CB     (QB)
            IF (DISCOV) CALL DISC3(ATM2)   !              |
         ENDIF                             !            N-CA-C
      ENDIF                                !
C
C
C ======= OTHER CASES
C
C ==== CZ OF ARG                         !
C                                           !
      IF (RES1(1:3) .EQ. 'ARG' ) THEN       !  HH11 HH12  HH21 HH22
          IF (ATM1(1:4) .EQ. 'CZ  ') THEN   !     \  /      \  /
              CALL REMOVE(VAL,COMMEN,FLAG)  !      NH1       NH2
              NUMQ=NUMQ+1                   !       \        /
              ATM1(1:3)='HH*'               !        \      /
              IF (DISCOV) CALL DISC3(ATM1)  !         \    /
          ENDIF                             !          \  /  
      ENDIF                                 !           CZ       (CZ)
C                                           !           |
C ======= SECOND ATOM                       !           NE
C                                           !           |
      IF (RES2(1:3) .EQ. 'ARG' ) THEN       !           CD
          IF (ATM2(1:4) .EQ. 'CZ  ') THEN   !           |
              CALL REMOVE(VAL,COMMEN,FLAG)  !           CG
              NUMQ=NUMQ+1                   !           |
              ATM2(1:3)='HH*'               !           CB
              IF (DISCOV) CALL DISC3(ATM1)  !           |
          ENDIF                             !         N-CA-C
      ENDIF                                 !
C
C
C ==== ALL OTHERS
C
C THIS PART IS SUPPOSED TO TREAT ONLY QB, QG, QD, ETC ATOM TYPES
C
C RESIDUES : ALL OTHERS EXCEPT GLY
C
      IF (ATM1(1:1) .EQ. 'Q' .AND. ATM1(2:2) .NE. 'Q' .AND.
     1                             ATM1(2:2) .NE. 'R') THEN
          CALL REMOVE(VAL,COMMEN,FLAG)
          ATM1(1:1)='H'
          ATM1(3:3)='*'
          IF (DISCOV .EQ. .TRUE.) CALL DISC3(ATM1)
          NUMQ=NUMQ+1
      ENDIF
      IF (ATM2(1:1) .EQ. 'Q' .AND. ATM2(2:2) .NE. 'Q' .AND.
     1                             ATM2(2:2) .NE. 'R') THEN
          CALL REMOVE(VAL,COMMEN,FLAG)
          ATM2(1:1)='H'
          ATM2(3:3)='*'
          IF (DISCOV .EQ. .TRUE.) CALL DISC3(ATM2)
          NUMQ=NUMQ+1
      ENDIF
C
      IF ((LOUP(1:1) .EQ. 'L') .OR. (LOUP(1:1) .EQ. 'l')) GOTO 7007
C
C NOW ADD A PRE-DETERMINED CORRECTION FACTOR IF ANY TO THE VALUE OF THE
C CONSTRAINT 
C
      IF ((VAL .LE. CUTOFF).AND.((LOUP .EQ. 'U') .OR. (LOUP .EQ. 'u'))) 
     1     VAL=VAL+PERCENT*VAL/100.0
C
C RELAX THE SET OF CONSTRAINTS BY ADDING THE 10% OF RANGE
C ONLY THOSE CONSTRAINTS THAT ARE NOT INVOLVED IN HYDROGEN OR DISULFIDE
C
      IF ((ATM1(1:2) .NE. 'SG') .AND.
     1    (ATM1(1:2) .NE. 'O ') .AND.
     1    (ATM2(1:2) .NE. 'SG') .AND.
     1    (ATM2(1:2) .NE. 'O ')) THEN
          IF ((LOUP(1:1) .EQ. 'U') .OR. (LOUP(1:1) .EQ. 'u')) 
     1           VAL=VAL*(1.0+KORREK/100.0)
      ENDIF
C
C CHECKING VALUE OF THE CONSTRAINT
C
      IF (CPYCMN(1:9) .NE. ' ALREADY ') THEN
         IF ((VAL .LE. 1.80) .OR.
     1       (VAL .GE. 10.50)) THEN
            CTERR=CTERR+1
            WRITE(98,2011)
     1           ATM1O,NUM2O,RES2O,
     2           ATM2O,VAL,VAL0
 2011       FORMAT
     1  (' > -----',A4,'----',I2,' ',A3,'  ',A4,'-->',
     2  F4.1,' <-- chk bound, it is RARE. orig. value(',F4.1,')')
         ELSE
            WRITE(98,2012)
     1           ATM1O,NUM2O,RES2O,
     2           ATM2O,VAL,CPYCM0
 2012       FORMAT
     1  ('        ',A4,'    ',I2,' ',A3,'  ',A4,'   ',
     2  F4.1,8x,A25)
         ENDIF            
      ENDIF
C
C STORING THE CONSTRAINT IN ARRAYS
C
      ICONSU=ICONSU+1
      LOWER(ICONS)=0.
      UPPER(ICONS)=0.
      CRES1(ICONS)=RES1
      CRES2(ICONS)=RES2
      CNUM1(ICONS)=NUM1
      CNUM2(ICONS)=NUM2
      CATM1(ICONS)=ATM1
      CATM2(ICONS)=ATM2
      CCMNT(ICONS)=COMMEN
      LOWER(ICONS)=1.80
      ORIG0(ICONS)=VAL0
      IF ((LOUP .EQ. 'U') .OR. (LOUP .EQ. 'u')) UPPER(ICONS)=VAL
C
C TREAT LOWER BOUNDS CONSTRAINTS
C
      GOTO 7002
 7007 ICONSL=ICONSL+1
      ERRORNO=0
      DO 7001 I=1,ICONSU
      IF (ATM1 .EQ. CATM1(I) .AND.
     1    ATM2 .EQ. CATM2(I) .AND.
     2    NUM1 .EQ. CNUM1(I) .AND.
     3    NUM2 .EQ. CNUM2(I)) THEN
          LOWER(I)=VAL
          ERRORNO=1
      ENDIF
 7001 CONTINUE
      IF (ERRORNO .EQ. 0) THEN
         IF (MECAGUENLA .LT. 1) THEN
             MECAGUENLA = MECAGUENLA + 1            
             PRINT*, '  ** ERROR IN LOWER BOUNDS FILE : '
         ENDIF
             WRITE(6,7003) NUM1,ATM1,NUM2,ATM2
 7003        FORMAT(5X,I4,2X,A4,2X,I6,2X,A4)
      ENDIF
C
 7002 GOTO 50
 300  CLOSE(1)
 301  PRINT*, '                                             '
C
C      TYPE '(''   IS THERE ANOTHER CONSTRAINT FILE (Y/N) : '',$)'
C      ACCEPT '(A)', YESNO
C
      PRINT*, '    IS THERE ANOTHER CONSTRAINT FILE (Y/N) : '
      READ(5,'(A)') YESNO
      IF (YESNO(1:1) .EQ. 'Y' .OR.
     1    YESNO(1:1) .EQ. 'y' ) GOTO 1111
      IF (YESNO(1:1) .NE. 'N' .AND.
     1    YESNO(1:1) .NE. 'n' ) THEN
          PRINT*, '  ** ERROR YOU MUST TYPE Y OR N  '
          GOTO 301
          ENDIF
C
      PRINT*, '  Wait please.......'
      DO 7008 I=1,ICONS
        RES1=CRES1(I)
        RES2=CRES2(I)
        NUM1=CNUM1(I)
        NUM2=CNUM2(I)
        ATM1=CATM1(I)
        ATM2=CATM2(I)
        COMMEN=CCMNT(I)
        LOW=LOWER(I)
        UPP=UPPER(I)
        VAL0=ORIG0(I)
        CALL ESCRIBE(ID,NUM1,ATM1,NUM2,ATM2,COMMEN,LOW,UPP,VAL0,
     1               I,RES1,RES2,CONGEN,
     2               DISCOV,IMPACT)
 7008 CONTINUE
      IF (LERR .NE. 0) THEN
         PRINT*, '    '
         PRINT*, '    '
         PRINT*, '**************************************************'
         PRINT*, ' -------------   IMPORTANT ERROR/S   ------------ '
         PRINT*, ' THE RESIDUE INFORMATION (NUMBER OR NAME) DOES NOT'
         PRINT*, ' MATCH BETWEEN SEQUENCE FILE AND CONSTRAINT FILE  '
         PRINT*, ' FOR THE FOLLOWING CONSTRAINT/S:                  '
         DO 8687 I=1,LERR
            WRITE(6,8688) ERCNSIST(I),
     1                    CNUM1(ERCNSIST(I)),CRES1(ERCNSIST(I)),
     1                    CATM1(ERCNSIST(I)),
     1                    CNUM2(ERCNSIST(I)),CRES2(ERCNSIST(I)),
     1                    CATM2(ERCNSIST(I))
 8687    CONTINUE
         PRINT*, '**************************************************'

      ENDIF
         IF (CTERR .NE. 0) THEN
             PRINT*,' '
             PRINT*,'-----------------------------------------------'
             PRINT*,'| YOU SHOULD CHECK',CTERR,'    CONSTRAINTS |' 
             PRINT*,'|      TAKE A LOOK TO THE CHECK.OUT FILE      |'
             PRINT*,'-----------------------------------------------'
             PRINT*,' '
             PRINT*,' >>>>>>>>>  YOU HAVE BEEN WARNED <<<<<<<<<<'
             PRINT*,' '
         ENDIF
C
C SUMMARY OF CHANGES
C
 9999 WRITE(6,*)
     1        '   ALL DISMAN FILE/S  READ .  END OF CONVERSION  '
      PRINT*, '   -------------  SUMMARY OF CHANGES ---------    '
      PRINT*, '   UPPER BOUNDS             :', ICONSU
      PRINT*, '   LOWER BOUNDS             :', ICONSL
      PRINT*, '   Q* TYPE ATOMS            :', NUMQ
      PRINT*, '   QR TYPE ATOMS            :', ICONQR
      PRINT*, '   QQ* TYPE ATOMS           :', NUMQQ 
      PRINT*, '   ORIGINAL CONSTRAINTS     :', ICONSO
      PRINT*, '   FINAL CONGEN CONSTRAINTS :', ICONS
      PRINT*, '                                                  '
C
C      IF (ICONQR .NE. 0) THEN
C         PRINT*, '                                '
C         PRINT*, ' ================ IMPORTANT ===================='
C         PRINT*, ' THERE ARE',ICONQR,'   QR ATOM TYPE/S IN DISMAN '
C         PRINT*, ' CONSTRAINT FILE. REPLACE THESE RESTRAINTS   '
C         PRINT*, ' ==============================================='
C      ENDIF
C
         PRINT*, ' ---- END OF DISMAN TO CONGEN CONVERSION -----  '
         PRINT*, '                                                '
C
C PRINTING STATISTICS
C
C
C  THIS IS THE OLD WAY
C
C      OPEN(UNIT=55,NAME='CONSTRAINT.SUMMARY',STATUS='UNKNOWN')
C      WRITE(55,*) '           *****    STATISTICAL SUMMARY   *****  '
C      WRITE(55,3008) ICONS
C      WRITE(55,3009) INTRA
C      WRITE(55,3010) INTER1
C      WRITE(55,3011) INTER2
C      WRITE(55,3012) INTER5
C      WRITE(55,3015) BCKB
C      WRITE(55,3016) BCKS
C      WRITE(55,3017) SCHS
C      WRITE(55,3018) IHB
C      WRITE(55,3019) ISS
C      WRITE(55,*) '          *****  CONSTRAINTS PER RESIDUE  *****  '
C      WRITE(55,*) ' NUM  RES     INTRA    INTER '
C      DO 3013 I=1,NUMRES
C         WRITE(55,3014) I,CRES(I),VIORES(I), VIORESA(I)
C 3013 CONTINUE
C
C THIS IS THE NEW WAY
C
      OPEN(UNIT=55,NAME='CONSTRAINT.SUMMARY',STATUS='UNKNOWN')
      WRITE(55,*) '           *****    STATISTICAL SUMMARY   *****  '
      WRITE(55,3008) ICONS+IHB/2
      WRITE(55,3009) INTRA
      WRITE(55,3010) INTER1
      WRITE(55,3020) ITBCKB
      WRITE(55,3021) ITBCKS
      WRITE(55,3022) ITSCHS, ITBCKB+ITBCKS+ITSCHS
      WRITE(55,3011) INTER2, INTRA+INTER1+INTER2
      WRITE(55,3015) BCKB
      WRITE(55,3016) BCKS
      WRITE(55,3017) SCHS, BCKB+BCKS+SCHS
      WRITE(55,3012) INTER5
      WRITE(55,3018) IHB
      WRITE(55,3019) ISS, INTRA+INTER1+INTER2+IHB+ISS+INTER5
      WRITE(55,*) '          *****  CONSTRAINTS PER RESIDUE  *****  '
      WRITE(55,*) ' NUM  RES     INTRA    INTER '
      DO 3013 I=1,NUMRES
         WRITE(55,3014) I,CRES(I),VIORES(I), VIORESA(I)
 3013 CONTINUE

C PRINTING NOE ARRAY DATA
C
      OPEN(UNIT=56,NAME='KYCNS.OUT',STATUS='UNKNOWN')
      WRITE(56,5553) 
      DO 654 K=1,NUMRES
       NCNST=NCNS(K)
       WRITE(56,5554) K,NCNS(K),(KYCNS(K,I),RFLAG(KYCNS(K,I)),I=1,NCNST)
 654  CONTINUE
         
C
C     ERRORS 
C
      GOTO 9000
 101  WRITE(6,*) ' ** ERROR IN INPUT FILE '
 9000 IF (CONGEN) WRITE(2,1011)
 901  FORMAT(A4)
c dissman format for uppwer and lower bounds
 1000 FORMAT(I2,1X,A3,2X,A4,4X,I2,1X,A3,2X,A4,F7.1,A40)
c diana format for upper and lower bounds
 1001 FORMAT(I3,1X,2A5,I4,1X,2A5,F7.2,A40)
 1005 FORMAT('TYPE NOE')
 1007 FORMAT('WEIGHT 1.0')
 1008 FORMAT('*')
 1011 FORMAT('END')
 2007 FORMAT('!BIOSYM restraint 1')
 2008 FORMAT('#NOE_distance restraints ')
C
C THIS IS THE OLD WAY
C
C 3008 FORMAT(' TOTAL NUMBER OF RESTRAINTS                     :', I5)
C 3009 FORMAT('   INTRA-RESIDUE RESTRAINTS  (I=J)              :', I5)
C 3010 FORMAT('   INTER-RESIDUE RESTRAINTS  (I-J) 1            :', I5)
C 3011 FORMAT('   INTER-RESIDUE RESTRAINTS  (I-J) 2-4          :', I5)
C 3012 FORMAT('   INTER-RESIDUE RESTRAINTS  (I-J) >5           :', I5)
C 3015 FORMAT('      BACKBONE-BACKBONE RESTRAINTS   (I-J) >5   :', I5)
C 3016 FORMAT('      BACKBONE SIDECHAIN RESTRAINTS  (I-J) >5   :', I5)
C 3017 FORMAT('      SIDECHAIN SIDECHAIN RESTRAINTS (I-J) >5   :', I5)
C 3018 FORMAT('   HYDROGEN BOND RESTRAINTS                     :', I5)
C 3019 FORMAT('   DISULFIDE RESTRAINTS                         :', I5)
C
C THIS IS THE NEW WAY
C
 3008 FORMAT('TOTAL NUMBER OF RESTRAINTS                       :', I5)
 3009 FORMAT('  INTRA-RESIDUE RESTRAINTS  (I=J)                :', I5)
 3010 FORMAT('  INTER-RESIDUE RESTRAINTS  (I-J) = 1            :', I5)
 3020 FORMAT('    BACKBONE-BACKBONE RESTRAINTS   (I-J) = 1     :', I5)
 3021 FORMAT('    BACKBONE SIDECHAIN RESTRAINTS  (I-J) = 1     :', I5)
 3022 FORMAT('    SIDECHAIN SIDECHAIN RESTRAINTS (I-J) = 1     :', I5,
     1       '      CHECK :', I5 )
 3011 FORMAT('  INTER-RESIDUE RESTRAINTS          1<(I-J)<=5   :', I5,
     1       '      CHECK :',I5 )
 3015 FORMAT('    BACKBONE-BACKBONE RESTRAINTS    1<(I-J)<=5   :', I5)
 3016 FORMAT('    BACKBONE SIDECHAIN RESTRAINTS   1<(I-J)<=5   :', I5)
 3017 FORMAT('    SIDECHAIN SIDECHAIN RESTRAINTS  1<(I-J)<=5   :', I5,
     1       '      CHECK :',I5 )
 3012 FORMAT('  INTER-RESIDUE RESTRAINTS  (I-J)>5              :', I5)
 3018 FORMAT('  HYDROGEN BOND RESTRAINTS                       :', I5)
 3019 FORMAT('  DISULFIDE RESTRAINTS                           :', I5,
     1       '      CHECK :',I5 )
 3014 FORMAT(I4,3X,A3,3X,I5,4X,F5.1)
 5553 FORMAT('  RES  NCNS            KYCNS          ')
 5554 FORMAT(I5,2X,I3,2X,200(I5,F4.1))
 8688 FORMAT
     1 ('   Line:',I4,' -- ',I3,' >',A3'< ',A3,2X,I3,' >',A3,'< ',A3)
 5555 RETURN
      END

C
C=======================================================================>
      SUBROUTINE ESCRIBE(ID,NUM1,ATM1,NUM2,ATM2,CPYCMN,LOW,UPP,VAL0,
     1                   I,RES1,RES2,CONGEN,
     2                   DISCOV,IMPACT)
C=======================================================================>
C
      CHARACTER*4   ATM1,ATM2,ID,RES1,RES2
      CHARACTER*40  CPYCMN
      CHARACTER*40  KOMMEN
      INTEGER       NUM1,NUM2,I
      REAL          LOW,UPP,VAL0
      LOGICAL       CONGEN,DISCOV,IMPACT
C
      IF (CPYCMN(1:9) .EQ. ' ALREADY ') THEN
         KOMMEN = '! Needs checking, take care '
      ELSE
         KOMMEN = CPYCMN
      ENDIF
C
      IF (CONGEN .EQ. .TRUE.) THEN
         IF (ATM1(1:4) .NE. 'QR  ' .AND. ATM2(1:4) .NE. 'QR  ')
     1   WRITE(2,1015) ID,NUM1,ATM1,ID,NUM2,ATM2,
     2                LOW,UPP,KOMMEN,I,VAL0-UPP  
         IF (ATM1(1:4) .EQ. 'QR  ' .AND. ATM2(1:4) .EQ. 'QR  ')
     1   WRITE(2,1016) ID,NUM1,ID,NUM1,ID,NUM2,ID,NUM2,
     2                LOW,UPP,KOMMEN,I,VAL0-UPP  
         IF (ATM1(1:4) .EQ. 'QR  ' .AND. ATM2(1:4) .NE. 'QR  ')
     1   WRITE(2,1017) ID,NUM1,ID,NUM1,ID,NUM2,ATM2,
     2                LOW,UPP,KOMMEN,I,VAL0-UPP  
         IF (ATM1(1:4) .NE. 'QR  ' .AND. ATM2(1:4) .EQ. 'QR  ')
     1   WRITE(2,1018) ID,NUM1,ATM1,ID,NUM2,ID,NUM2,
     2                LOW,UPP,KOMMEN,I,VAL0-UPP  
      ENDIF
 1015 FORMAT('CONS ATOM ',A1,I3,1X,A4,5x,1X,
     1          ': ATOM ',A1,I3,1X,A4,5x,1X,
     2          'LOWE',F6.2,1X,
     3          'UPPE',F6.2,1x,
     4          '!', A16,I4,'~',F5.2)
 1016 FORMAT('CONS ATOM ',A1,I3,1X,'HD* ATOM ',A1,I3,1X,' HE* ',1X,
     1          ': ATOM ',A1,I3,1X,'HD* ATOM ',A1,I3,1X,' HE* ',1X,
     2          'LOWE',F6.2,1X,
     3          'UPPE',F6.2,1x,
     4          '!', A16,I4,'~',F5.2)
 1017 FORMAT('CONS ATOM ',A1,I3,1X,'HD* ATOM ',A1,I3,1X,' HE* ',1X,
     1          ': ATOM ',A1,I3,1X,A4,5x,1X,
     2          'LOWE',F6.2,1X,
     3          'UPPE',F6.2,1x,
     4          '!', A16,I4,'~',F5.2)
 1018 FORMAT('CONS ATOM ',A1,I3,1X,A4,5x,1X,
     1          ': ATOM ',A1,I3,1X,'HD* ATOM ',A1,I3,1X,' HE* ',1X,
     2          'LOWE',F6.2,1X,
     3          'UPPE',F6.2,1x,
     4          '!', A16,I4,'~',F5.2)
      RETURN
      END

C
C=======================================================================>
      SUBROUTINE DISC1(RES1,RES2,NUM1,NUM2,ATM1,ATM2,
     1                  RLOUP,VAL,COMMEN,ICONS,VAL0)
C=======================================================================>
C
      REAL         VAL,VAL0,RLOUP,
     1             FORCE1,FORCE2,FORCEM   
      INTEGER      NUM1,NUM2,ICONS
      CHARACTER*4  ATM1,ATM2,RES1,RES2
      CHARACTER*40 COMMEN
C
      FORCE1=100.0
      FORCE2=100.0
      FORCEM=1000.0
      IF (NUM1 .LT. 10) THEN
         IF (NUM2 .LT. 10) THEN
               WRITE(2,1030) RES1,NUM1,ATM1,
     1                    RES2,NUM2,ATM2,
     2                    VAL,RLOUP,FORCE1,FORCE2,
     3                    FORCEM,COMMEN,ICONS,VAL0          
         ELSE
               WRITE(2,1031) RES1,NUM1,ATM1,
     1                    RES2,NUM2,ATM2,
     2                    VAL,RLOUP,FORCE1,FORCE2,
     3                    FORCEM,COMMEN,ICONS,VAL0
         ENDIF
       ELSE
         IF (NUM2 .LT. 10) THEN
               WRITE(2,1032) RES1,NUM1,ATM1,
     1                    RES2,NUM2,ATM2,
     2                    RLOUP,VAL,FORCE1,FORCE2,
     3                    FORCEM,COMMEN,ICONS,VAL0          
            ELSE
               WRITE(2,1033) RES1,NUM1,ATM1,
     1                    RES2,NUM2,ATM2,
     2                    VAL,RLOUP,FORCE1,FORCE2,
     3                    FORCEM,COMMEN,ICONS,VAL0          
            ENDIF
       ENDIF

 1030 FORMAT('1:',A3,'_',I1,':',A4,3X,
     1       '1:',A3,'_',I1,':',A4,3X,
     1        F5.2,2X,F5.2,'  10.0',2(2X,F6.2),2X,
     3        F7.2,A20,I5,' *',F5.2)
 1031 FORMAT('1:',A3,'_',I1,':',A4,3X,
     1       '1:',A3,'_',I2,':',A4,2X,
     1        F5.2,2X,F5.2,'  10.0',2(2X,F6.2),2X,
     3        F7.2,A20,I5,' *',F5.2)
 1032 FORMAT('1:',A3,'_',I2,':',A4,2X,
     1       '1:',A3,'_',I1,':',A4,3X,
     1        F5.2,2X,F5.2,'  10.0',2(2X,F6.2),2X,
     3        F7.2,A20,I5,' *',F5.2)
 1033 FORMAT('1:',A3,'_',I2,':',A4,2X,
     1       '1:',A3,'_',I2,':',A4,2X,
     1        F5.2,2X,F5.2,'  10.0',2(2X,F6.2),2X,
     3        F7.2,A20,I5,' *',F5.2)           
      RETURN
      END

C
C=======================================================================>
      SUBROUTINE DISC2(RES1,RES2,NUM1,NUM2,ATM1,ATM2,
     1                  RLOUP,VAL,COMMEN,ICONS,VAL0)
C=======================================================================>
C
      REAL         VAL,VAL0,RLOUP,
     1             FORCE1,FORCE2,FORCEM   
      INTEGER      NUM1,NUM2,ICONS
      CHARACTER*4  ATM1,ATM2,RES1,RES2
      CHARACTER*40 COMMEN
C
      FORCE1=100.0
      FORCE2=100.0
      FORCEM=1000.0
      IF (NUM1 .LT. 10) THEN
         IF (NUM2 .LT. 10) THEN
               WRITE(2,1030) RES1,NUM1,ATM1,
     1                    RES2,NUM2,ATM2,
     2                    RLOUP,VAL,FORCE1,FORCE2,
     3                    FORCEM,COMMEN,ICONS,VAL0          
         ELSE
               WRITE(2,1031) RES1,NUM1,ATM1,
     1                    RES2,NUM2,ATM2,
     2                    RLOUP,VAL,FORCE1,FORCE2,
     3                    FORCEM,COMMEN,ICONS,VAL0
         ENDIF
       ELSE
         IF (NUM2 .LT. 10) THEN
               WRITE(2,1032) RES1,NUM1,ATM1,
     1                    RES2,NUM2,ATM2,
     2                    RLOUP,VAL,FORCE1,FORCE2,
     3                    FORCEM,COMMEN,ICONS,VAL0          
            ELSE
               WRITE(2,1033) RES1,NUM1,ATM1,
     1                    RES2,NUM2,ATM2,
     2                    RLOUP,VAL,FORCE1,FORCE2,
     3                    FORCEM,COMMEN,ICONS,VAL0          
            ENDIF
       ENDIF

 1030 FORMAT('1:',A3,'_',I1,':',A4,3X,
     1       '1:',A3,'_',I1,':',A4,3X,
     1        F5.2,2X,F5.2,'  10.0',2(2X,F6.2),2X,
     3        F7.2,A20,I5,' *',F5.2)
 1031 FORMAT('1:',A3,'_',I1,':',A4,3X,
     1       '1:',A3,'_',I2,':',A4,2X,
     1        F5.2,2X,F5.2,'  10.0',2(2X,F6.2),2X,
     3        F7.2,A20,I5,' *',F5.2)
 1032 FORMAT('1:',A3,'_',I2,':',A4,2X,
     1       '1:',A3,'_',I1,':',A4,3X,
     1        F5.2,2X,F5.2,'  10.0',2(2X,F6.2),2X,
     3        F7.2,A20,I5,' *',F5.2)
 1033 FORMAT('1:',A3,'_',I2,':',A4,2X,
     1       '1:',A3,'_',I2,':',A4,2X,
     1        F5.2,2X,F5.2,'  10.0',2(2X,F6.2),2X,
     3        F7.2,A20,I5,' *',F5.2)           
      RETURN
      END

C
C=======================================================================>
      SUBROUTINE DISC3(CHAIN)
C=======================================================================>
C
      CHARACTER*4 CHAIN
             DO 70 I=1,4 
                IF (CHAIN(I:I) .EQ. ' ' .AND.
     1              CHAIN(I-1:I-1) .NE. '*') CHAIN(I:I)='*'
70           CONTINUE
      RETURN
      END

C
C=======================================================================>
      SUBROUTINE JCOUP(ID,ICONS,CONVER,CRES,RESMAX,DISDIA)
C=======================================================================>
C
      IMPLICIT NONE
      REAL	      ANG1,ANG01,
     1                ANG2,ANG02,
     2                RCC1,RCC2,
     3                RCCB1,RCCB2,
     4                RNCG1,RNCG2,
     5                RCPCG1,RCPCG2,
     6                RMIN,RMAX,PI,DPR,DIST,
     7                DEPHAS,DEFASE,FORCE 
      CHARACTER*6     RESTYP,
     1                DIHTYP,
     2                ATOM1,ATOM2,ATOM3,ATOM4, DISDIA
      CHARACTER*1     ID,CONVER
      INTEGER         RESNO,RESMAX,
     1                ICONS,IDVAR
      CHARACTER*20    NOMBRE,  ! NAME OF JCOUP FILE
     1                DIHNAM    
      CHARACTER*4     CRES(100)
      CHARACTER*80    LINEA
      INTEGER         IX
C
C$     INCLUDE peptide.par     
C
C-----------------------------------------------------------------------
C IN THIS FILE ARE STORED THE STANDARD DATA ABOUT THE BOND LENGTHS AND
C ANGLES FOR THE PEPTIDE BOND. SO IT IS EASY CHANGE ANY VALUE FOR USE
C IN THE PROGRAM TO CONVERT DIHEDRAL INTO DISTANCES
C THE VALUES ARE
C 	LNCPI1      BOND LENGHT N (RESIDUE I) AND C (RESIDUE I-1)
C	LNCA        BOND LEMGHT N (I) CA (I)
C	LCACPI      BOND LENGHT CA (I) CP (I)
C       LCACB       BOND LENGHT CA (I) CB (I)
C	LCBCG       BOND LENGHT CB (I) CG (I)
C                ... AND SO ON ..
C       CANCP1	    ANGLE BETWEEN CA (I) N (I) C (I-1)
C	NCACPI	    ANGLE BETWEEN N (I) CA (I) CP (I)
C		 ... AND SO ON ..
C
C	DELTA       IS AN INTERVAL IF YOU WANT TO PUT SOME ERROR
C	 	    IN THE DISTANCES
C
C
      REAL          LNCPI1,
     1              LNCA,
     2              LCACPI,LCACB,LCBCG,LCBOG,LCBSG,
     3              CANCPI1,CBCAN,CACBCG,CACBOG,CACBSG,
     4              NCACPI,
     5              NCACB,CBCACPI,
     6              DELTA    

      PARAMETER    (LNCPI1=1.33,
     1              LNCA=1.45,
     2              LCACPI=1.52,
     3              LCACB=1.53,
     4              LCBCG=1.53,
     5              LCBOG=1.42,
     6              LCBSG=1.81,
     7              CANCPI1=120.0,
     8              NCACPI=111.6,
     9              NCACB=105.0,
     A              CBCAN=105.0,
     B	            CACBCG=111.0,
     C              CACBOG=109.50,
     D              CACBSG=112.50,
     E              CBCACPI=109.52,
     F              DELTA=0.0)
C-----------------------------------------------------------------------
C
      PI=3.141592654
      DPR=PI/180.0
C
C      PRINT*, ' '
C      PRINT*, '  The sequence is ... '
C      PRINT*, ' '
C     DO 3333 I=1,RESMAX,10
C        WRITE(6,*) ('   ', CRES(I+k),K=1,10)
C 3333 CONTINUE
C      PRINT*, '  '
C
 888  IF (DISDIA(1:3) .EQ. 'DIS' .OR. DISDIA(1:3) .EQ. 'dis') THEN
C
C       TYPE
C     $'(''   INPUT NAME FOR DIHEDRAL (DISMAN) CONSTRAINT FILE :? '',$)'
C
      PRINT*, '    INPUT NAME FOR DIHEDRAL (DISMAN) CONSTRAINT FILE :? '
      ELSE IF (DISDIA(1:3) .EQ. 'DIA' .OR. DISDIA(1:3) .EQ. 'dia') 
     2THEN
C
C       TYPE 
C     $'(''   INPUT NAME FOR DIHEDRAL (DIANA) CONSTRAINT FILE :? '',$)'
C
      PRINT*, '    INPUT NAME FOR DIHEDRAL (DIANA) CONSTRAINT FILE :? '
      ELSE IF (DISDIA(1:3) .EQ. 'SYB' .OR. DISDIA(1:3) .EQ. 'syb') 
     2THEN
C
C       TYPE 
C     $'(''   INPUT NAME FOR DIHEDRAL (SYBYL) CONSTRAINT FILE :? '',$)'
C
      PRINT*, '    INPUT NAME FOR DIHEDRAL (SYBYL) CONSTRAINT FILE :? '
      ENDIF
C
C      ACCEPT '(A)', NOMBRE
C
      READ(5,'(A)') NOMBRE
      OPEN(UNIT=10,NAME=NOMBRE,STATUS='OLD',ERR=4000)
      PRINT*, '   '
      PRINT*, '   WHAT KIND OF CONVERSION DO YOU WANT ? '
      PRINT*, '   INTO DISTANCES -------> TYPE "D" OR "d"   '
      PRINT*, '   INTO DIHEDRAL  -------> TYPE "F" OR "f"   '
C
C      TYPE '(''    Conversion type (def.: into dihedral) --> '',$)'
C      ACCEPT '(A)', CONVER
C
      PRINT*, '     Conversion type (def.: into dihedral) --> '
      READ(5,'(A)') CONVER
      IF (CONVER .EQ. '') CONVER='F'
      IF (CONVER .EQ. 'F' .OR.
     1    CONVER .EQ. 'f' ) THEN
         PRINT*, ' '
C
C         TYPE 
C     $ '(''   NAME FOR DIHEDRAL CONSTR. FILE (def:tejero.dihe): '',$)'
C         ACCEPT '(A)', DIHNAM
C
         PRINT*, '  NAME FOR DIHEDRAL CONSTR. FILE (def:tejero.dihe): '
	 READ(5,'(A)') DIHNAM
         IF (DIHNAM .EQ. '') DIHNAM='tejero.dihe'
         OPEN(UNIT=61,NAME=DIHNAM,STATUS='UNKNOWN')
         WRITE(61,3098)
3098     FORMAT('!',
     1         /'! DIHEDRAL CONSTRAINT FILE TO BE STREAMED FROM MAIN '
     2         /'! INPUT IN CONGEN. ' 
     3         /'! '
     4         /'!*')
         PRINT*, '    '
C
C         TYPE  
C     $   '(''   FORCE FOR DIHEDRAL CONSTRAINTS (def:201.0) '',$)'
C         ACCEPT '(F10.2)', FORCE
C
         PRINT*, '    FORCE FOR DIHEDRAL CONSTRAINTS (def:201.0) '
         READ(5,'(F10.2)') FORCE
         IF (FORCE .EQ. 0.0) FORCE=201.0
      ENDIF
      GOTO 70
 50   CONTINUE
c
c Reading dihedral constraint file
c First DISMAN format
c
 70   IF (DISDIA(1:3) .EQ. 'DIS' .OR. DISDIA(1:3) .EQ. 'dis') THEN
         READ (10,'(A)',END=100,ERR=200) LINEA
         IX=INDEX(LINEA,'#')
         IF (IX.GT.0 .AND. IX.LT.20) THEN
            LINEA(IX:80)=' '
            GOTO 70
         ENDIF
         IF (LINEA(1:3).NE.' ' .OR. LINEA(10:14).NE.' ') 
     1     READ(LINEA,3020,END=100,ERR=200)RESNO,IDVAR,ANG01,ANG02
      ELSE IF (DISDIA(1:3) .EQ. 'DIA' .OR. DISDIA(1:3) .EQ. 'dia') THEN
         READ (10,'(A)',END=100,ERR=200) LINEA
         IX=INDEX(LINEA,'#')
         IF (IX.GT.0 .AND. IX.LT.20) THEN
            LINEA(IX:80)=' '
            GOTO 70
         ENDIF
         IF (LINEA(1:5).NE.' ' .OR. LINEA(10:14).NE.' ') 
     1   READ(LINEA,3021,END=100,ERR=200)RESNO,RESTYP,DIHTYP,ANG01,ANG02
      ELSE IF (DISDIA(1:3) .EQ. 'SYB' .OR. DISDIA(1:3) .EQ. 'syb') THEN
         READ (10,'(A)',END=100,ERR=200) LINEA
         IX=INDEX(LINEA,'#')
         IF (IX.GT.0 .AND. IX.LT.20) THEN
            LINEA(IX:80)=' '
            GOTO 70
         ENDIF
         IF (LINEA(1:5).NE.' ' .OR. LINEA(10:14).NE.' ') 
     1   READ(LINEA,3021,END=100,ERR=200)RESNO,RESTYP,DIHTYP,ANG01,ANG02
      ENDIF
c
c Next lines are a little bit silly as we throw away the info we have
c just to get again the same info but it was done to keep the code
C SIMILAR. RTT, JUL 1995. PLEASE NOTE THAT WE STOP IN CHI1
C IT WOULD BE GREAT TO HAVE CHI2 AND SO ON????
C
      IF (DISDIA(1:3) .EQ. 'SYB' .OR. DISDIA(1:3) .EQ. 'syb' .OR.
     1    DISDIA(1:3) .EQ. 'DIA' .OR. DISDIA(1:3) .EQ. 'dia' ) THEN
         IDVAR=9999
         IF (DIHTYP(1:4) .EQ. 'PHI ') IDVAR=1
         IF (DIHTYP(1:4) .EQ. 'PSI ') IDVAR=2
         IF (DIHTYP(1:4) .EQ. 'CHI1') IDVAR=4
         IF (IDVAR .EQ. 9999) THEN
            PRINT*, ' A dihedral different of PHI, PSI, CHI1 found '
         ENDIF
      ENDIF
C
C CONVERTING DIHEDRAL CONSTRAINT FILE FROM DISMAN INTO CONGEN USING
C THE FLAT-BOTTOM POTENTIAL. FIRST WE NEED TO OPEN A NEW FILE FOR THE
C DIHEDRAL CONSTRAINTS (WE WILL USE UNIT 61)
C
      IF (CONVER .EQ. 'F' .OR.
     1    CONVER .EQ. 'f') THEN
         IF (IDVAR .EQ. 1) DIHTYP=' PHI'
         IF (IDVAR .EQ. 2) DIHTYP=' PSI'
         IF (IDVAR .EQ. 4) DIHTYP='CHI1'
C
C PHI
C
         IF (DIHTYP .EQ. ' PHI') THEN
            ATOM1='  C '
            ATOM2='  N '
            ATOM3=' CA '
            ATOM4=' C  '
            WRITE(61,3031) ID,
     1                 RESNO-1,
     2                 ATOM1,
     *                 ID,
     3                 RESNO,
     4                 ATOM2,
     *                 ID,
     5                 RESNO,
     6                 ATOM3,
     *                 ID,
     7                 RESNO,
     8                 ATOM4,
     9                 FORCE,
     A                 ANG01,
     B                 ANG02
         ENDIF
C
C PSI
C
         IF (DIHTYP .EQ. ' PSI') THEN
            ATOM1='  N '
            ATOM2=' CA '
            ATOM3='  C '
            ATOM4=' N  '
            WRITE(61,3031) ID,
     1                 RESNO,
     2                 ATOM1,
     *                 ID,
     3                 RESNO,
     4                 ATOM2,
     *                 ID,
     5                 RESNO,
     6                 ATOM3,
     *                 ID,
     7                 RESNO+1,
     8                 ATOM4,
     9                 FORCE,
     A                 ANG01,
     B                 ANG02
         ENDIF
C
C CHI1
C
         IF (DIHTYP .EQ. 'CHI1') THEN
            ATOM1='  N '
            ATOM2=' CA '
            ATOM3=' CB '
            ATOM4=' CG '
            IF (CRES(RESNO)(1:3) .EQ. 'CYS') ATOM4=' SG '
            IF (CRES(RESNO)(1:3) .EQ. 'SER') ATOM4=' OG '
            IF (CRES(RESNO)(1:3) .EQ. 'THR') ATOM4='OG1 '
            IF (CRES(RESNO)(1:3) .EQ. 'VAL') ATOM4='CG1 '
            IF (CRES(RESNO)(1:3) .EQ. 'ILE') ATOM4='CG1 '
            WRITE(61,3031) ID,
     1                 RESNO,
     2                 ATOM1,
     *                 ID,
     3                 RESNO,
     4                 ATOM2,
     *                 ID,
     5                 RESNO,
     6                 ATOM3,
     *                 ID,
     7                 RESNO,
     8                 ATOM4,
     9                 FORCE,
     A                 ANG01,
     B                 ANG02
         ENDIF
         GOTO 50
      ENDIF
 3031 FORMAT('CONS DIHE ',A1,' ',I4,' ',A4,' : ',
     1                    A1,' ',I4,' ',A4,' : ',
     2                    A1,' ',I4,' ',A4,' : ',
     3                    A1,' ',I4,' ',A4,' : ',
     4                   ' FORCE ',F5.1,
     5                   '  MIN ', F6.1,
     6                   '  MAX ', F6.1)
      IF (CONVER .EQ. 'D' .OR.
     1    CONVER .EQ. 'd' ) THEN
C
C PHI  THE SAME FOR ALL RESIDUES 
C
      IF (DIHTYP .EQ. ' PHI') THEN
         ANG1=ANG01*DPR
         ANG2=ANG02*DPR
         IF (ANG1 .LT. -PI) ANG1=ANG1+2*PI
         IF (ANG1 .GT.  PI) ANG1=ANG1-2*PI
         IF (ANG2 .LT. -PI) ANG2=ANG2+2*PI
         IF (ANG2 .GT.  PI) ANG2=ANG2-2*PI
         RCC1=DIST(LNCPI1,LNCA,LCACPI,CANCPI1,NCACPI,ANG1)
         RCC2=DIST(LNCPI1,LNCA,LCACPI,CANCPI1,NCACPI,ANG2)
         RMAX=DIST(LNCPI1,LNCA,LCACPI,CANCPI1,NCACPI,PI)
         RMIN=DIST(LNCPI1,LNCA,LCACPI,CANCPI1,NCACPI,0.0)
         ATOM2='C   '
         ATOM1='C   '
         IF (RCC1 .GT. RCC2) THEN
            IF (ANG1 .LT. 0.0 .AND. 
     1          ANG2 .GT. 0.0 .AND.
     2          RCC2 .GT. RMIN) RCC2=RMIN
            IF (ANG1 .GT. 0.0 .AND. 
     1          ANG2 .LT. 0.0 .AND.
     2          RCC1 .LT. RMAX) RCC1=RMAX
             ICONS=ICONS+1
             WRITE(2,3030) ID,RESNO-1,ATOM1,ID,RESNO,ATOM2,
     1                     RCC2-DELTA,RCC1+DELTA,
     1                     DIHTYP,ICONS,ANG1/DPR,ANG2/DPR
         ELSE 
            IF (ANG1 .LT. 0.0 .AND. 
     1          ANG2 .GT. 0.0 .AND.
     2          RCC1 .GT. RMIN) RCC1=RMIN
            IF (ANG1 .GT. 0.0 .AND. 
     1          ANG2 .LT. 0.0 .AND.
     2          RCC2 .LT. RMAX) RCC2=RMAX
             ICONS=ICONS+1
             WRITE(2,3030) ID,RESNO-1,ATOM1,ID,RESNO,ATOM2,
     1                     RCC1-DELTA,RCC2+DELTA,
     1                     DIHTYP,ICONS,ANG1/DPR,ANG2/DPR
         ENDIF 
C
         DEPHAS=DEFASE(LCACB,LCACPI,NCACB,NCACPI,CBCACPI)
         ANG1=ANG1-DEPHAS
         ANG2=ANG2-DEPHAS
         IF (ANG1 .LT. -PI) ANG1=ANG1+2*PI
         IF (ANG1 .GT.  PI) ANG1=ANG1-2*PI
         IF (ANG2 .LT. -PI) ANG2=ANG2+2*PI
         IF (ANG2 .GT.  PI) ANG2=ANG2-2*PI
         RCCB1=DIST(LNCPI1,LNCA,LCACB,CANCPI1,NCACB,ANG1)
         RCCB2=DIST(LNCPI1,LNCA,LCACB,CANCPI1,NCACB,ANG2)
         RMAX=DIST(LNCPI1,LNCA,LCACB,CANCPI1,NCACB,PI)
         RMIN=DIST(LNCPI1,LNCA,LCACB,CANCPI1,NCACB,0.0)
         ATOM1='C   '
         ATOM2='CB  '
         IF (RCCB1 .GT. RCCB2) THEN
            IF (ANG1 .LT. 0.0 .AND. 
     1          ANG2 .GT. 0.0 .AND.
     2          RCCB2 .GT. RMIN) RCCB2=RMIN
            IF (ANG1 .GT. 0.0 .AND. 
     1          ANG2 .LT. 0.0 .AND.
     2          RCCB1 .LT. RMAX) RCCB1=RMAX
             ICONS=ICONS+1
             WRITE(2,3030) ID,RESNO-1,ATOM1,ID,RESNO,ATOM2,
     1                     RCCB2-DELTA,RCCB1+DELTA,
     1                     DIHTYP,ICONS,ANG1/DPR,ANG2/DPR
         ELSE
            IF (ANG1 .LT. 0.0 .AND.
     1          ANG2 .GT. 0.0 .AND.
     2          RCCB1 .GT. RMIN) RCCB1=RMIN          
            IF (ANG1 .GT. 0.0 .AND. 
     1          ANG2 .LT. 0.0 .AND.
     2          RCCB2 .LT. RMAX) RCCB2=RMAX
             ICONS=ICONS+1
             WRITE(2,3030) ID,RESNO-1,ATOM1,ID,RESNO,ATOM2,
     1                     RCCB1-DELTA,RCCB2+DELTA,
     1                     DIHTYP,ICONS,ANG1/DPR,ANG2/DPR
         ENDIF
      ELSE
C
C CHI1
C
      IF (DIHTYP .EQ. 'CHI1') THEN
C
C SPECIAL CASES OF SER, CYS, AND THR
C
C SER  AND  THR
C
         IF (RESTYP .EQ. 'SER' .OR.
     1       RESTYP .EQ. 'THR' ) THEN
            CALL SERTHR(ID,ANG01,ANG02,RESTYP,RESNO,DIHTYP,ICONS)
            GOTO 50
         ENDIF
C
C CYS
C
         IF (RESTYP .EQ. 'CYS') THEN
            CALL CYSTYP(ID,ANG01,ANG02,RESTYP,RESNO,DIHTYP,ICONS)
            GOTO 50
         ENDIF
C
C THE OTHERS
C
         ANG1=ANG01*DPR
         ANG2=ANG02*DPR
         IF (ANG1 .LT. -PI) ANG1=ANG1+2*PI
         IF (ANG1 .GT.  PI) ANG1=ANG1-2*PI
         IF (ANG2 .LT. -PI) ANG2=ANG2+2*PI
         IF (ANG2 .GT.  PI) ANG2=ANG2-2*PI
         RNCG1=DIST(LNCA,LCACB,LCBCG,CBCAN,CACBCG,ANG1)
         RNCG2=DIST(LNCA,LCACB,LCBCG,CBCAN,CACBCG,ANG2)
         RMIN=DIST(LNCA,LCACB,LCBCG,CBCAN,CACBCG,0.0)
         RMAX=DIST(LNCA,LCACB,LCBCG,CBCAN,CACBCG,PI)
         ATOM1='N   '
         ATOM2='CG  '
         IF (RESTYP .EQ. 'VAL') ATOM2='CG1 '
         IF (RNCG1 .GT. RNCG2) THEN
            IF (ANG1 .LT. 0.0 .AND.
     1          ANG2 .GT. 0.0 .AND.
     2          RNCG2 .GT. RMIN) RNCG2=RMIN          
            IF (ANG1 .GT. 0.0 .AND. 
     1          ANG2 .LT. 0.0 .AND.
     2          RNCG1 .LT. RMAX) RNCG1=RMAX
             ICONS=ICONS+1
             WRITE(2,3030) ID,RESNO,ATOM1,ID,RESNO,ATOM2,
     1                     RNCG2-DELTA,RNCG1+DELTA,
     1                     DIHTYP,ICONS,ANG1/DPR,ANG2/DPR
         ELSE 
            IF (ANG1 .LT. 0.0 .AND.
     1          ANG2 .GT. 0.0 .AND.
     2          RNCG1 .GT. RMIN) RNCG1=RMIN          
            IF (ANG1 .GT. 0.0 .AND. 
     1          ANG2 .LT. 0.0 .AND.
     2          RNCG2 .LT. RMAX) RNCG2=RMAX
             ICONS=ICONS+1
             WRITE(2,3030) ID,RESNO,ATOM1,ID,RESNO,ATOM2,
     1                     RNCG1-DELTA,RNCG2+DELTA,
     1                     DIHTYP,ICONS,ANG1/DPR,ANG2/DPR
         ENDIF 
         DEPHAS=DEFASE(LCACPI,LNCA,CBCACPI,CBCAN,NCACPI)
         ANG1=ANG1-DEPHAS
         ANG2=ANG2-DEPHAS
         IF (ANG1 .LT. -PI) ANG1=ANG1+2*PI
         IF (ANG1 .GT.  PI) ANG1=ANG1-2*PI
         IF (ANG2 .LT. -PI) ANG2=ANG2+2*PI
         IF (ANG2 .GT.  PI) ANG2=ANG2-2*PI
         RCPCG1=DIST(LCACPI,LCACB,LCBCG,CBCACPI,CACBCG,ANG1)
         RCPCG2=DIST(LCACPI,LCACB,LCBCG,CBCACPI,CACBCG,ANG2)
         RMIN=DIST(LCACPI,LCACB,LCBCG,CBCACPI,CACBCG,0.0)
         RMAX=DIST(LCACPI,LCACB,LCBCG,CBCACPI,CACBCG,PI)
         ATOM1='C   '
         ATOM2='CG  '
         IF (RESTYP .EQ. 'VAL') ATOM2='CG1 '
         IF (RCPCG1 .GT. RCPCG2) THEN
            IF (ANG1 .LT. 0.0 .AND.
     1          ANG2 .GT. 0.0 .AND.
     2          RCPCG2 .GT. RMIN) RCPCG2=RMIN          
            IF (ANG1 .GT. 0.0 .AND. 
     1          ANG2 .LT. 0.0 .AND.
     2          RCPCG1 .LT. RMAX) RCPCG1=RMAX
             ICONS=ICONS+1
             WRITE(2,3030) ID,RESNO,ATOM1,ID,RESNO,ATOM2,
     1                     RCPCG2-DELTA,RCPCG1+DELTA,
     1                     DIHTYP,ICONS,ANG1/DPR,ANG2/DPR
         ELSE
            IF (ANG1 .LT. 0.0 .AND.
     1          ANG2 .GT. 0.0 .AND.
     2          RCPCG1 .GT. RMIN) RCPCG1=RMIN          
            IF (ANG1 .GT. 0.0 .AND. 
     1          ANG2 .LT. 0.0 .AND.
     2          RCPCG2 .LT. RMAX) RCPCG2=RMAX
             ICONS=ICONS+1
             WRITE(2,3030) ID,RESNO,ATOM1,ID,RESNO,ATOM2,
     1                     RCPCG1-DELTA,RCPCG2+DELTA,
     1                     DIHTYP,ICONS,ANG1/DPR,ANG2/DPR
         ENDIF
      ENDIF
      ENDIF
      ENDIF
      GOTO 50
 100  IF (CONVER .EQ. 'F' .OR.
     1    CONVER .EQ. 'f') THEN
         WRITE(61,3311)
 3311    FORMAT('RETURN ')
      ENDIF
      GOTO 999
 200  PRINT*,'  **** BAD FORMAT FOR THE FILE  >>',NOMBRE,'<<   ****'
      GOTO 999
 4000 PRINT*,
     1  '  THE FILE CALLED  >>',NOMBRE,'<< DOES NOT EXIST IN DIRECTORY'
      GOTO 888
 3002 FORMAT(A1)
C      READ(10,3010,END=100,ERR=200)IRE,IDVAR,VRL,VRR
C 3010 FORMAT(2I5,2F10.1)
 3020 FORMAT(/2I5,2F10.1)
 3021 FORMAT(I4,1X,A5,1X,A5,2F8.1)
 3030 FORMAT('CONS ',A1,I3,1X,A4,1X,
     1               A1,I3,1X,A4,F5.2,2X,F5.2,
     2               8X,'!',A4,7X,I5,2X,2(F8.3,2X))
 999  RETURN
      END

C
C=======================================================================>
      SUBROUTINE SERTHR(ID,ANG01,ANG02,RESTYP,RESNO,DIHTYP,ICONS)
C=======================================================================>
C
      IMPLICIT NONE
      REAL	      ANG1,ANG01,
     1                ANG2,ANG02,
     4                RNOG1,RNOG2,
     5                RCPOG1,RCPOG2,
     6                RMIN,RMAX,PI,DPR,DIST,
     7                DEPHAS,DEFASE    
      CHARACTER*4     RESTYP,
     1                DIHTYP,
     2                ATOM1,ATOM2    
      CHARACTER*1     ID
      INTEGER         RESNO,
     1                ICONS

C$     INCLUDE peptide.par
      INCLUDE 'peptide.par'

      PI=3.141592654
      DPR=PI/180.0
            ANG1=ANG01*DPR
            ANG2=ANG02*DPR
            IF (ANG1 .LT. -PI) ANG1=ANG1+2*PI
            IF (ANG1 .GT.  PI) ANG1=ANG1-2*PI
            IF (ANG2 .LT. -PI) ANG2=ANG2+2*PI
            IF (ANG2 .GT.  PI) ANG2=ANG2-2*PI
            RNOG1=DIST(LNCA,LCACB,LCBOG,CBCAN,CACBOG,ANG1)
            RNOG2=DIST(LNCA,LCACB,LCBOG,CBCAN,CACBOG,ANG2)
            RMIN=DIST(LNCA,LCACB,LCBOG,CBCAN,CACBOG,0.0)
            RMAX=DIST(LNCA,LCACB,LCBOG,CBCAN,CACBOG,PI)
            ATOM1='N   '
            ATOM2='OG  '
            IF (RESTYP .EQ. 'THR') ATOM2='OG1 '
            IF (RNOG1 .GT. RNOG2) THEN
            IF (ANG1 .LT. 0.0 .AND.
     1          ANG2 .GT. 0.0 .AND.
     2          RNOG2 .GT. RMIN) RNOG2=RMIN          
            IF (ANG1 .GT. 0.0 .AND. 
     1          ANG2 .LT. 0.0 .AND.
     2          RNOG1 .LT. RMAX) RNOG1=RMAX
               ICONS=ICONS+1
               WRITE(2,3025) ID,RESNO,ATOM1,ID,RESNO,ATOM2,
     1                       RNOG2-DELTA,RNOG1+DELTA,
     1                       DIHTYP,ICONS,ANG1/DPR,ANG2/DPR
            ELSE 
            IF (ANG1 .LT. 0.0 .AND.
     1          ANG2 .GT. 0.0 .AND.
     2          RNOG1 .GT. RMIN) RNOG1=RMIN          
            IF (ANG1 .GT. 0.0 .AND. 
     1          ANG2 .LT. 0.0 .AND.
     2          RNOG2 .LT. RMAX) RNOG2=RMAX
               ICONS=ICONS+1
               WRITE(2,3025) ID,RESNO,ATOM1,ID,RESNO,ATOM2,
     1                       RNOG1-DELTA,RNOG2+DELTA,
     1                       DIHTYP,ICONS,ANG1/DPR,ANG2/DPR
            ENDIF 
            DEPHAS=DEFASE(LCACPI,LNCA,CBCACPI,CBCAN,NCACPI)
            ANG1=ANG1-DEPHAS
            ANG2=ANG2-DEPHAS
            IF (ANG1 .LT. -PI) ANG1=ANG1+2*PI
            IF (ANG1 .GT.  PI) ANG1=ANG1-2*PI
            IF (ANG2 .LT. -PI) ANG2=ANG2+2*PI
            IF (ANG2 .GT.  PI) ANG2=ANG2-2*PI
            RCPOG1=DIST(LCACPI,LCACB,LCBOG,CBCACPI,CACBOG,ANG1)
            RCPOG2=DIST(LCACPI,LCACB,LCBOG,CBCACPI,CACBOG,ANG2)
            RMAX=DIST(LCACPI,LCACB,LCBOG,CBCACPI,CACBOG,PI)
            RMIN=DIST(LCACPI,LCACB,LCBOG,CBCACPI,CACBOG,0.0)
            ATOM1='C   '
            ATOM2='OG  '
            IF (RESTYP .EQ. 'THR') ATOM2='OG1 '
            IF (RCPOG1 .GT. RCPOG2) THEN
            IF (ANG1 .LT. 0.0 .AND.
     1          ANG2 .GT. 0.0 .AND.
     2          RCPOG2 .GT. RMIN) RCPOG2=RMIN          
            IF (ANG1 .GT. 0.0 .AND. 
     1          ANG2 .LT. 0.0 .AND.
     2          RCPOG1 .LT. RMAX) RCPOG1=RMAX
             ICONS=ICONS+1
             WRITE(2,3025) ID,RESNO,ATOM1,ID,RESNO,ATOM2,
     1                     RCPOG2-DELTA,RCPOG1+DELTA,
     1                     DIHTYP,ICONS,ANG1/DPR,ANG2/DPR
            ELSE
            IF (ANG1 .LT. 0.0 .AND.
     1          ANG2 .GT. 0.0 .AND.
     2          RCPOG1 .GT. RMIN) RCPOG1=RMIN          
            IF (ANG1 .GT. 0.0 .AND. 
     1          ANG2 .LT. 0.0 .AND.
     2          RCPOG2 .LT. RMAX) RCPOG2=RMAX
             ICONS=ICONS+1
             WRITE(2,3025) ID,RESNO,ATOM1,ID,RESNO,ATOM2,
     1                     RCPOG1-DELTA,RCPOG2+DELTA,
     1                     DIHTYP,ICONS,ANG1/DPR,ANG2/DPR
            ENDIF
      
 3025 FORMAT('CONS ',A1,I3,1X,A4,1X,
     1               A1,I3,1X,A4,F5.2,2X,F5.2,
     2               8X,'!',A4,4X,'SER',I5,2X,2(F8.3,2X))
      RETURN
      END

C
C=======================================================================>
            SUBROUTINE CYSTYP(ID,ANG01,ANG02,RESTYP,RESNO,DIHTYP,ICONS)
C=======================================================================>
C
      IMPLICIT NONE
      REAL	      ANG1,ANG01,
     1                ANG2,ANG02,
     4                RNSG1,RNSG2,
     5                RCPSG1,RCPSG2,
     6                RMIN,RMAX,PI,DPR,
     7                DEPHAS,DEFASE,DIST    
      CHARACTER*4     RESTYP,
     1                DIHTYP,
     2                ATOM1,ATOM2    
      CHARACTER*1     ID
      INTEGER         RESNO,
     1                ICONS
C$     INCLUDE peptide.par
       INCLUDE 'peptide.par'

      PI=3.141592654
      DPR=PI/180.0

            ANG1=ANG01*DPR
            ANG2=ANG02*DPR
            IF (ANG1 .LT. -PI) ANG1=ANG1+2*PI
            IF (ANG1 .GT.  PI) ANG1=ANG1-2*PI
            IF (ANG2 .LT. -PI) ANG2=ANG2+2*PI
            IF (ANG2 .GT.  PI) ANG2=ANG2-2*PI
            RNSG1=DIST(LNCA,LCACB,LCBSG,CBCAN,CACBSG,ANG1)
            RNSG2=DIST(LNCA,LCACB,LCBSG,CBCAN,CACBSG,ANG2)
            RMIN=DIST(LNCA,LCACB,LCBSG,CBCAN,CACBSG,0.0)
            RMAX=DIST(LNCA,LCACB,LCBSG,CBCAN,CACBSG,PI)
            ATOM1='N   '
            ATOM2='SG  '
            IF (RNSG1 .GT. RNSG2) THEN
            IF (ANG1 .LT. 0.0 .AND.
     1          ANG2 .GT. 0.0 .AND.
     2          RNSG2 .GT. RMIN) RNSG2=RMIN          
            IF (ANG1 .GT. 0.0 .AND. 
     1          ANG2 .LT. 0.0 .AND.
     2          RNSG1 .LT. RMAX) RNSG1=RMAX
               ICONS=ICONS+1
               WRITE(2,3027) ID,RESNO,ATOM1,ID,RESNO,ATOM2,
     1                       RNSG2-DELTA,RNSG1+DELTA,
     1                       DIHTYP,ICONS,ANG1/DPR,ANG2/DPR
            ELSE 
            IF (ANG1 .LT. 0.0 .AND.
     1          ANG2 .GT. 0.0 .AND.
     2          RNSG1 .GT. RMIN) RNSG1=RMIN          
            IF (ANG1 .GT. 0.0 .AND. 
     1          ANG2 .LT. 0.0 .AND.
     2          RNSG2 .LT. RMAX) RNSG2=RMAX
               ICONS=ICONS+1
               WRITE(2,3027) ID,RESNO,ATOM1,ID,RESNO,ATOM2,
     1                       RNSG1-DELTA,RNSG2+DELTA,
     1                       DIHTYP,ICONS,ANG1/DPR,ANG2/DPR
            ENDIF 
            DEPHAS=DEFASE(LCACPI,LNCA,CBCACPI,CBCAN,NCACPI)
            ANG1=ANG1-DEPHAS
            ANG2=ANG2-DEPHAS
            IF (ANG1 .LT. -PI) ANG1=ANG1+2*PI
            IF (ANG1 .GT.  PI) ANG1=ANG1-2*PI
            IF (ANG2 .LT. -PI) ANG2=ANG2+2*PI
            IF (ANG2 .GT.  PI) ANG2=ANG2-2*PI
            RCPSG1=DIST(LCACPI,LCACB,LCBSG,CBCACPI,CACBSG,ANG1)
            RCPSG2=DIST(LCACPI,LCACB,LCBSG,CBCACPI,CACBSG,ANG2)
            RMIN=DIST(LCACPI,LCACB,LCBSG,CBCACPI,CACBSG,0.0)
            RMAX=DIST(LCACPI,LCACB,LCBSG,CBCACPI,CACBSG,PI)
            ATOM1='C   '
            ATOM2='SG  '
            IF (RCPSG1 .GT. RCPSG2) THEN
            IF (ANG1 .LT. 0.0 .AND.
     1          ANG2 .GT. 0.0 .AND.
     2          RCPSG2 .GT. RMIN) RCPSG2=RMIN          
            IF (ANG1 .GT. 0.0 .AND. 
     1          ANG2 .LT. 0.0 .AND.
     2          RCPSG1 .LT. RMAX) RCPSG1=RMAX
             ICONS=ICONS+1
             WRITE(2,3027) ID,RESNO,ATOM1,ID,RESNO,ATOM2,
     1                     RCPSG2-DELTA,RCPSG1+DELTA,
     1                     DIHTYP,ICONS,ANG1/DPR,ANG2/DPR
            ELSE
            IF (ANG1 .LT. 0.0 .AND.
     1          ANG2 .GT. 0.0 .AND.
     2          RCPSG1 .GT. RMIN) RCPSG1=RMIN          
            IF (ANG1 .GT. 0.0  .AND. 
     1          ANG2 .LT. 0.0  .AND.
     2          RCPSG2 .LT. RMAX) RCPSG2=RMAX
             ICONS=ICONS+1
             WRITE(2,3027) ID,RESNO,ATOM1,ID,RESNO,ATOM2,
     1                     RCPSG1-DELTA,RCPSG2+DELTA,
     1                     DIHTYP,ICONS,ANG1/DPR,ANG2/DPR
            ENDIF
 3027 FORMAT('CONS ',A1,I3,1X,A4,1X,
     1               A1,I3,1X,A4,F5.2,2X,F5.2,
     2               8X,'!',A4,4X,'CYS',I5,2X,2(F8.3,2X))
      RETURN
      END


C
C====================================================================>
      REAL FUNCTION DIST(LNCPI1,LNCA,LCACPI,CANCPI1,NCACPI,ANG)
C====================================================================>
C
      IMPLICIT NONE
      REAL         LNCPI1,
     1             LNCA,
     2             LCACPI,
     3             CANCPI1,
     4             NCACPI,ANG,
     5             ALFA1,ALFA2    
      REAL         A1,B1,C1,D1,PI,DPR,A2,B2

      PI=3.141592654
      DPR=PI/180.0
      ALFA1=CANCPI1*DPR
      ALFA2=NCACPI*DPR
      A1=LNCPI1*SIN(PI-ALFA1)
      B1=LNCA+LCACPI*SIN(ALFA2-(PI/2))+LNCPI1*COS(PI-ALFA1)
      C1=LCACPI*COS(ALFA2-(PI/2))
      D1=LNCPI1*SIN(PI-ALFA1)
      A2=A1*A1+B1*B1+C1*C1
      B2=2*C1*D1
      DIST=SQRT(A2-B2*COS(ANG))
      RETURN
      END
      
C
C=======================================================================>
      REAL FUNCTION DEFASE(LCACB,LCACPI,NCACB,NCACPI,CBCACPI)
C=======================================================================>
C
      IMPLICIT NONE
      REAL        LCACB,LCACPI,NCACB,NCACPI,CBCACPI
      REAL        L1,L2,LP1,LP2,ALFA1,ALFA2,ALFA3
      REAL        LP1C,LP2C,L1C,L2C
      REAL        PI,DPR,NUMER,DENOM
C
      PI=3.141592654
      DPR=PI/180.0
C
      ALFA1=NCACB*DPR
      ALFA2=NCACPI*DPR
      ALFA3=CBCACPI*DPR
      L1=LCACB
      L2=LCACPI
      LP1=L1*COS(ALFA1-(PI/2))
      LP2=L2*COS(ALFA2-(PI/2))
      LP1C=LP1*LP1
      LP2C=LP2*LP2
      L1C=L1*L1
      L2C=L2*L2
      DENOM=2*LP1*LP2
      NUMER=LP1C+LP2C-(L1C+L2C-2*L1*L2*COS(ALFA3))*COS(ALFA1-ALFA2)**2
      DEFASE=ACOS(NUMER/DENOM)
      RETURN
      END

C
C=======================================================================>
      SUBROUTINE REMOVE(VAL,COMMEN,FLAG)
C=======================================================================>
C
      IMPLICIT NONE
      REAL           VAL
      CHARACTER*40   COMMEN
      INTEGER        CONT,FLAG
C
      IF (FLAG .GT. 21) GOTO 400
      CONT=FLAG
 100  CONT=CONT+1
         IF (COMMEN(CONT:CONT) .EQ. 'm') THEN
            VAL=VAL-1.0
            FLAG=CONT
            GOTO 410
            ENDIF
         IF (COMMEN(CONT:CONT) .EQ. 'r') THEN
            VAL=VAL-2.2
            FLAG=CONT
            GOTO 410
            ENDIF
         IF (COMMEN(CONT:CONT) .EQ. 's') THEN
            VAL=VAL-1.7
            FLAG=CONT
            GOTO 410
            ENDIF
         IF (COMMEN(CONT:CONT) .EQ. 'q') THEN
            VAL=VAL-2.4
            FLAG=CONT
            GOTO 410
            ENDIF
         IF (COMMEN(CONT:CONT) .EQ. 'i') THEN
            VAL=VAL-0.6
            FLAG=CONT
            GOTO 410
            ENDIF
 410     IF (COMMEN(CONT+2:CONT+4) .EQ. 'one') THEN
            VAL=VAL*1.122
            FLAG=CONT+4
            ENDIF
         IF (CONT .LE. 20) GOTO 100
C
 400     RETURN
         END
C
C======================================================================>
       SUBROUTINE CHECK(CTERR,NUM1,RES1,ATM1,NUM2,RES2,ATM2,
     1     VAL,CPYCMN,COMMEN)
C======================================================================>
C
         IMPLICIT NONE
         INTEGER          NUM1,NUM2,CTERR
         INTEGER          I,J,LONG,CONT
         CHARACTER*40     CPYCMN,CHKCMM,COMMEN
         CHARACTER*10     COMM1(25), COMM2(25)
         REAL             VAL
         CHARACTER*4      RES1,ATM1,RES2,ATM2
C
C SKIP IF ALREADY DONE OR ALREADY CHECKED FOR OTHER THINGS
C
         IF (CPYCMN(1:8) .EQ. ' ALREADY') RETURN
C
C SKIP WHEN THERE IS NO DATA (HEADER OF CONSTRAINTS)
C
         IF (ATM1(1:4) .EQ. '   ') THEN
            WRITE(98,1001) NUM1,RES1
            GOTO 100
         ENDIF
C
C LOCATE THE # OF COMMENT
C
         CONT=0
 5       CONT=CONT+1
         IF (CONT .GE. 40 ) THEN
            IF (ATM1(1:1) .EQ. 'H' .AND.
     1          ATM2(1:1) .EQ. 'H') GOTO 90
            GOTO 70
         ENDIF
         IF (COMMEN(CONT:CONT) .EQ. '#') GOTO 10
         GOTO 5
C
C CHECK THE COMMENTS
C
 10      CONTINUE
         CALL RMVBLN(CONT,COMMEN)
         CONT=1
         IF (ATM1(1:1) .EQ. 'O' .OR. ATM1(1:2) .EQ. 'SG' .OR.
     1       ATM2(1:1) .EQ. 'O' .OR. ATM2(1:2) .EQ. 'SG') THEN
  6          CONT=CONT+1
             IF (CONT .GE. 38) GOTO 70
             IF (COMMEN(CONT:CONT+2) .EQ. 'SS-') GOTO 90
             IF (COMMEN(CONT:CONT+6) .EQ. 'SS BOND') GOTO 90
             IF (COMMEN(CONT:CONT+5) .EQ. 'H-BOND') GOTO 90
             IF (COMMEN(CONT:CONT+5) .EQ. 'H BOND') GOTO 90
             IF (COMMEN(CONT:CONT+5) .EQ. 'SIDE  ') GOTO 90
             GOTO 6
         ENDIF
C
C  ASSIGN COMMENTS DEPENDING ON ATOM TYPE
C
C ----- QQ ATOM TYPE ----
C
         IF (ATM1(1:2) .EQ. 'QQ') THEN
            COMM1(1)='q,one'
            COMM1(2)='i,one'
            COMM1(3)='r,one'
            COMM1(4)='s,one'
            COMM1(5)='q,dMe'
            COMM1(6)='r,dMe'
            COMM1(7)='s,dMe'
            COMM1(8)='i,dMe'
            COMM1(9)='q,one,dMe'
            COMM1(10)='r,one,dMe'
            COMM1(11)='s,one,dMe'
            COMM1(12)='i,one,dMe'
         ENDIF
         IF (ATM2(1:2) .EQ. 'QQ') THEN
            COMM2(1)='q,one'
            COMM2(2)='i,one'
            COMM2(3)='r,one'
            COMM2(4)='s,one'
            COMM2(5)='q,dMe'
            COMM2(6)='r,dMe'
            COMM2(7)='s,dMe'
            COMM2(8)='i,dMe'
            COMM2(9)='q,one,dMe'
            COMM2(10)='r,one,dMe'
            COMM2(11)='s,one,dMe'
            COMM2(12)='i,one,dMe'
         ENDIF
C
C ----- CZ ATOM TYPE IN RESIDUE ARGININE ----
C
         IF (ATM1(1:3) .EQ. 'CZ ' .AND. RES1 .EQ. 'ARG ') THEN
            COMM1(1)='q'
         ENDIF
         IF (ATM2(1:3) .EQ. 'CZ ' .AND. RES2 .EQ. 'ARG ') THEN
            COMM2(1)='q'
         ENDIF
C
C ----- Q ATOM TYPE ----
C
         IF (ATM1(1:1) .EQ. 'Q' .AND. ATM1(1:2) .NE. 'QQ') THEN
            COMM1(1)='m,one'
            COMM1(2)='m,da'
            COMM1(3)='m,db'
            COMM1(4)='m,dd'
            COMM1(5)='m,dg'
            COMM1(6)='m,de'
            COMM1(7)='m,Me'
            COMM1(8)='m,both'
            COMM1(9)='i,one'
            COMM1(10)='i,da'
            COMM1(11)='i,db'
            COMM1(12)='i,dd'
            COMM1(13)='i,dg'
            COMM1(14)='i,de'
            COMM1(15)='i,Me'
            COMM1(16)='i,both'
            COMM1(17)='i,both,Me'
            COMM1(18)='m,both,Me'
            COMM1(19)='i'
            COMM1(20)='m'
            COMM1(21)='r'
            COMM1(22)='r,dd'
            COMM1(23)='r,de'
         ENDIF
         IF (ATM2(1:1) .EQ. 'Q' .AND. ATM2(1:2) .NE. 'QQ') THEN
            COMM2(1)='m,one'
            COMM2(2)='m,da'
            COMM2(3)='m,db'
            COMM2(4)='m,dd'
            COMM2(5)='m,dg'
            COMM2(6)='m,de'
            COMM2(7)='m,Me'
            COMM2(8)='m,both'
            COMM2(9)='i,one'
            COMM2(10)='i,da'
            COMM2(11)='i,db'
            COMM2(12)='i,dd'
            COMM2(13)='i,dg'
            COMM2(14)='i,de'
            COMM2(15)='i,Me'
            COMM2(16)='i,both'
            COMM2(17)='i,both,Me'
            COMM2(18)='m,both,Me'
            COMM2(19)='i'
            COMM2(20)='m'
            COMM2(21)='r'
            COMM2(22)='r,dd'
            COMM2(23)='r,de'
         ENDIF
C
C ----- Q ATOM TYPE ----
C
         IF (ATM1(1:2) .EQ. 'CA' .AND. RES1(1:3) .EQ. 'GLY') THEN
            COMM1(1)='m,one'
            COMM1(2)='m,da'
            COMM1(3)='m,db'
            COMM1(4)='m,dd'
            COMM1(5)='m,dg'
            COMM1(6)='m,de'
            COMM1(7)='m,Me'
            COMM1(8)='m,both'
            COMM1(9)='i,one'
            COMM1(10)='i,da'
            COMM1(11)='i,db'
            COMM1(12)='i,dd'
            COMM1(13)='i,dg'
            COMM1(14)='i,de'
            COMM1(15)='i,Me'
            COMM1(16)='i,both'
            COMM1(17)='i,both,Me'
            COMM1(18)='m,both,Me'
            COMM1(19)='i'
            COMM1(20)='m'
         ENDIF
         IF (ATM2(1:2) .EQ. 'CA' .AND. RES2(1:3) .EQ. 'GLY') THEN
            COMM2(1)='m,one'
            COMM2(2)='m,da'
            COMM2(3)='m,db'
            COMM2(4)='m,dd'
            COMM2(5)='m,dg'
            COMM2(6)='m,de'
            COMM2(7)='m,Me'
            COMM2(8)='m,both'
            COMM2(9)='i,one'
            COMM2(10)='i,da'
            COMM2(11)='i,db'
            COMM2(12)='i,dd'
            COMM2(13)='i,dg'
            COMM2(14)='i,de'
            COMM2(15)='i,Me'
            COMM2(16)='i,both'
            COMM2(17)='i,both,Me'
            COMM2(18)='m,both,Me'
            COMM2(19)='i'
            COMM2(20)='m'
         ENDIF
C
C ----- CG1 AND/OR CZ4  ATOM TYPE ----
C
         IF (ATM1(1:3) .EQ. 'CG1' .OR. ATM1(1:3) .EQ. 'CZ4') THEN
            COMM1(1)='m,dd'
            COMM1(2)='m,de'
            COMM1(3)='both'
            COMM1(4)='r,dd'
            COMM1(5)='r,de'
            COMM1(6)='r'
            COMM1(7)='m'
            COMM1(8)='r,both'
            COMM1(9)='m,both'
            COMM1(10)='m,one'
            COMM1(11)='r,one'
         ENDIF
         IF (ATM2(1:3) .EQ. 'CG1' .OR. ATM2(1:3) .EQ. 'CZ4') THEN
            COMM2(1)='m,dd'
            COMM2(2)='m,de'
            COMM2(3)='both'
            COMM2(4)='r,dd'
            COMM2(5)='r,de'
            COMM2(6)='r'
            COMM2(7)='m'
            COMM2(8)='r,both'
            COMM2(9)='m,both'
            COMM2(10)='m,one'
            COMM2(11)='r,one'
         ENDIF
C
C ----- H* ATOM TYPE -----
C
         IF (ATM1(1:1) .EQ. 'H') THEN
            COMM1(1)=''
            COMM1(2)='both'
         ENDIF
         IF (ATM2(1:1) .EQ. 'H') THEN
            COMM2(1)=''
            COMM2(2)='both'
         ENDIF
C
C CONSTRAINTS TYPE  QQ --> ANY
C
         IF (ATM1(1:2) .EQ. 'QQ') THEN
C ------ QQ I=12,J=12
            IF (ATM2(1:2) .EQ. 'QQ') THEN
               I=12
               J=12
               CALL CHKCOM(I,J,CONT,COMM1,COMM2,CHKCMM,LONG,COMMEN)
               IF (LONG .EQ. 1) GOTO 90
               GOTO 70
            ENDIF
C -------- Q*, I=12,J=23
            IF (ATM2(1:1) .EQ. 'Q' .AND. ATM2(1:2) .NE. 'QQ') THEN
               I=12
               J=23
               CALL CHKCOM(I,J,CONT,COMM1,COMM2,CHKCMM,LONG,COMMEN)
               IF (LONG .EQ. 1) GOTO 90
               GOTO 70
            ENDIF
C -------- CA, I=12,J=20
            IF (ATM2(1:2) .EQ. 'CA' .AND. RES2 .EQ. 'GLY') THEN
               I=12
               J=20
               CALL CHKCOM(I,J,CONT,COMM1,COMM2,CHKCMM,LONG,COMMEN)
               IF (LONG .EQ. 1) GOTO 90
               GOTO 70
            ENDIF
C --------- CZ, I=12,J=2
            IF (ATM2(1:3) .EQ. 'CZ ' .AND. RES2 .EQ. 'ARG ') THEN
               I=12
               J=2
               CALL CHKCOM(I,J,CONT,COMM1,COMM2,CHKCMM,LONG,COMMEN)
               IF (LONG .EQ. 1) GOTO 90
               GOTO 70
            ENDIF
C -------- CG1, CZ4, I=12,J=11
            IF (ATM2(1:3) .EQ. 'CG1' .OR. ATM2(1:3) .EQ. 'CZ4') THEN
               I=12
               J=11
               CALL CHKCOM(I,J,CONT,COMM1,COMM2,CHKCMM,LONG,COMMEN)
               IF (LONG .EQ. 1) GOTO 90
               GOTO 70
            ENDIF
C -------- H, I=12,J=2
            IF (ATM2(1:1) .EQ. 'H') THEN
               I=12
               J=2
               CALL CHKCOM(I,J,CONT,COMM1,COMM2,CHKCMM,LONG,COMMEN)
               IF (LONG .EQ. 1) GOTO 90
               GOTO 70
            ENDIF
         ENDIF
C
C CONSTRAINTS TYPE  CA --> ANY
C
         IF (ATM1(1:2) .EQ. 'CA' .AND. RES1(1:3) .EQ. 'GLY') THEN
C ----- QQ, I=20,J=12
            IF (ATM2(1:2) .EQ. 'QQ') THEN
               I=20
               J=12
               CALL CHKCOM(I,J,CONT,COMM1,COMM2,CHKCMM,LONG,COMMEN)
               IF (LONG .EQ. 1) GOTO 90
               GOTO 70
            ENDIF
C ------- Q*, I=20,J=23
            IF (ATM2(1:1) .EQ. 'Q' .AND. ATM2(1:2) .NE. 'QQ') THEN 
               I=20
               J=23
               CALL CHKCOM(I,J,CONT,COMM1,COMM2,CHKCMM,LONG,COMMEN)
               IF (LONG .EQ. 1) GOTO 90
               GOTO 70
            ENDIF
C -------- CA, I=20,J=20
            IF (ATM2(1:2) .EQ. 'CA' .AND. RES2(1:3) .EQ. 'GLY') THEN
               I=20
               J=20
               CALL CHKCOM(I,J,CONT,COMM1,COMM2,CHKCMM,LONG,COMMEN)
               IF (LONG .EQ. 1) GOTO 90
               GOTO 70
            ENDIF
C ------- CZ, I=20, J=2
            IF (ATM2(1:3) .EQ. 'CZ ' .AND. RES2 .EQ. 'ARG ') THEN
               I=20
               J=2
               CALL CHKCOM(I,J,CONT,COMM1,COMM2,CHKCMM,LONG,COMMEN)
               IF (LONG .EQ. 1) GOTO 90
               GOTO 70
            ENDIF
C ------- CG1, CZ4, I=20, J=11
            IF (ATM2(1:3) .EQ. 'CG1' .OR. ATM2(1:3) .EQ. 'CZ4') THEN
               I=20
               J=11
               CALL CHKCOM(I,J,CONT,COMM1,COMM2,CHKCMM,LONG,COMMEN)
               IF (LONG .EQ. 1) GOTO 90
               GOTO 70
            ENDIF
C ------ H*, I=20, J=2
            IF (ATM2(1:1) .EQ. 'H') THEN
               I=20
               J=2
               CALL CHKCOM(I,J,CONT,COMM1,COMM2,CHKCMM,LONG,COMMEN)
               IF (LONG .EQ. 1) GOTO 90
               GOTO 70
            ENDIF
         ENDIF
C
C CONSTRAINTS TYPE  Q --> ANY
C
         IF (ATM1(1:1) .EQ. 'Q' .AND. ATM1(1:2) .NE. 'QQ') THEN
C ----- QQ, I=23,J=12
            IF (ATM2(1:2) .EQ. 'QQ') THEN
               I=23
               J=12
               CALL CHKCOM(I,J,CONT,COMM1,COMM2,CHKCMM,LONG,COMMEN)
               IF (LONG .EQ. 1) GOTO 90
               GOTO 70
            ENDIF
C ------- Q*, I=23,J=23
            IF (ATM2(1:1) .EQ. 'Q' .AND. ATM2(1:2) .NE. 'QQ') THEN 
               I=23
               J=23
               CALL CHKCOM(I,J,CONT,COMM1,COMM2,CHKCMM,LONG,COMMEN)
               IF (LONG .EQ. 1) GOTO 90
               GOTO 70
            ENDIF
C -------- CA, I=23,J=20
            IF (ATM2(1:2) .EQ. 'CA' .AND. RES2 .EQ. 'GLY') THEN
               I=23
               J=20
               CALL CHKCOM(I,J,CONT,COMM1,COMM2,CHKCMM,LONG,COMMEN)
               IF (LONG .EQ. 1) GOTO 90
               GOTO 70
            ENDIF
C ------- CZ, I=23, J=2
            IF (ATM2(1:3) .EQ. 'CZ ' .AND. RES2 .EQ. 'ARG ') THEN
               I=23
               J=2
               CALL CHKCOM(I,J,CONT,COMM1,COMM2,CHKCMM,LONG,COMMEN)
               IF (LONG .EQ. 1) GOTO 90
               GOTO 70
            ENDIF
C ------- CG1, CZ4, I=23, J=11
            IF (ATM2(1:3) .EQ. 'CG1' .OR. ATM2(1:3) .EQ. 'CZ4') THEN
               I=23
               J=11
               CALL CHKCOM(I,J,CONT,COMM1,COMM2,CHKCMM,LONG,COMMEN)
               IF (LONG .EQ. 1) GOTO 90
               GOTO 70
            ENDIF
C ------ H*, I=23, J=2
            IF (ATM2(1:1) .EQ. 'H') THEN
               I=23
               J=2
               CALL CHKCOM(I,J,CONT,COMM1,COMM2,CHKCMM,LONG,COMMEN)
               IF (LONG .EQ. 1) GOTO 90
               GOTO 70
            ENDIF
         ENDIF
C
C CONSTRAINTS TYPE  CG1 OR CZ4 --> ANY
C
         IF (ATM1(1:3) .EQ. 'CG1' .OR. ATM1(1:3) .EQ. 'CZ4') THEN
C ------ QQ, I=11, J=12
            IF (ATM2(1:2) .EQ. 'QQ') THEN
               I=11
               J=12
               CALL CHKCOM(I,J,CONT,COMM1,COMM2,CHKCMM,LONG,COMMEN)
               IF (LONG .EQ. 1) GOTO 90
               GOTO 70
            ENDIF
C ------- Q*, I=11, J=23
            IF (ATM2(1:1) .EQ. 'Q' .AND. ATM2(1:2) .NE. 'QQ') THEN
               I=11
               J=23
               CALL CHKCOM(I,J,CONT,COMM1,COMM2,CHKCMM,LONG,COMMEN)
               IF (LONG .EQ. 1) GOTO 90
               GOTO 70
            ENDIF
C -------- CA, I=11,J=20
            IF (ATM2(1:2) .EQ. 'CA' .AND. RES2 .EQ. 'GLY') THEN
               I=11
               J=20
               CALL CHKCOM(I,J,CONT,COMM1,COMM2,CHKCMM,LONG,COMMEN)
               IF (LONG .EQ. 1) GOTO 90
               GOTO 70
            ENDIF
C -------- CZ, I=11, J=2
            IF (ATM2(1:3) .EQ. 'CZ ' .AND. RES2 .EQ. 'ARG ') THEN
               I=11
               J=2
               CALL CHKCOM(I,J,CONT,COMM1,COMM2,CHKCMM,LONG,COMMEN)
               IF (LONG .EQ. 1) GOTO 90
               GOTO 70
            ENDIF
C ------- CG1, CZ4, I=11, J=11
            IF (ATM2(1:3) .EQ. 'CG1' .OR. ATM2(1:3) .EQ. 'CZ4') THEN
               I=11
               J=11
               CALL CHKCOM(I,J,CONT,COMM1,COMM2,CHKCMM,LONG,COMMEN)
               IF (LONG .EQ. 1) GOTO 90
               GOTO 70
            ENDIF
C ------- H*, I=11, J=2
            IF (ATM2(1:1) .EQ. 'H') THEN
               I=11
               J=2
               CALL CHKCOM(I,J,CONT,COMM1,COMM2,CHKCMM,LONG,COMMEN)
               IF (LONG .EQ. 1) GOTO 90
               GOTO 70
            ENDIF
         ENDIF
C
C CONSTRAINTS TYPE  H* --> ANY
C
         IF (ATM1(1:1) .EQ. 'H') THEN
C ------ QQ, I=2, J=12
            IF (ATM2(1:2) .EQ. 'QQ') THEN
               I=2
               J=12
               CALL CHKCOM(I,J,CONT,COMM1,COMM2,CHKCMM,LONG,COMMEN)
               IF (LONG .EQ. 1) GOTO 90
               GOTO 70
            ENDIF
C ----- Q*, I=2, J=23
            IF (ATM2(1:1) .EQ. 'Q' .AND. ATM2(1:2) .NE. 'QQ') THEN
               I=2
               J=23
               CALL CHKCOM(I,J,CONT,COMM1,COMM2,CHKCMM,LONG,COMMEN)
               IF (LONG .EQ. 1) GOTO 90
               GOTO 70
            ENDIF
C -------- CA, I=2,J=20
            IF (ATM2(1:2) .EQ. 'CA' .AND. RES2 .EQ. 'GLY') THEN
               I=2
               J=20
               CALL CHKCOM(I,J,CONT,COMM1,COMM2,CHKCMM,LONG,COMMEN)
               IF (LONG .EQ. 1) GOTO 90
               GOTO 70
            ENDIF
C ---- CZ, I=2, J=2
            IF (ATM2(1:3) .EQ. 'CZ ' .AND. RES2 .EQ. 'ARG ') THEN
               I=2
               J=2
               CALL CHKCOM(I,J,CONT,COMM1,COMM2,CHKCMM,LONG,COMMEN)
               IF (LONG .EQ. 1) GOTO 90
               GOTO 70
            ENDIF
C ----- CG1, CZ4, I=2, J=11
            IF (ATM2(1:3) .EQ. 'CG1' .OR. ATM2(1:3) .EQ. 'CZ4') THEN
               I=2
               J=11
               CALL CHKCOM(I,J,CONT,COMM1,COMM2,CHKCMM,LONG,COMMEN)
               IF (LONG .EQ. 1) GOTO 90
               GOTO 70
            ENDIF
C ----- H*, I=2, J=2
            IF (ATM2(1:1) .EQ. 'H') THEN
               I=2
               J=2
               CALL CHKCOM(I,J,CONT,COMM1,COMM2,CHKCMM,LONG,COMMEN)
               IF (LONG .EQ. 1) GOTO 90
               GOTO 70
            ENDIF
         ENDIF
C
C DON'T CHECK ANY OTHER SPECIAL CONSTRAINTS
C
C        GOTO 90
C
 70     CTERR=CTERR+1
        WRITE(98,1003)
     1                 ATM1,NUM2,RES2,
     2                 ATM2,VAL,COMMEN
C        COMMEN=' ALREADY DONE '
        GOTO 100
 90     CONTINUE
C
C 90     WRITE(98,1002)
C     1                 ATM1,NUM2,RES2,
C     2                 ATM2,VAL,COMMEN
C
         GOTO 100
  200    PRINT*, 'UNCLASSIFIED ERROR *******'
  100    CONTINUE
 1001    FORMAT(I2,1X,A3)
 1002    FORMAT(8X,A4,4X,I2,1X,A3,2X,A4,F7.1,5x,3x,A25)
 1003    FORMAT
     1   (' > -----',A4,'----',I2,'-',
     2       A3,'--',A4,'---',F4.1,'--chk','-->',A25,'<--')
         RETURN 
         END


C
C======================================================================>
         SUBROUTINE CHKCOM(I,J,CONT,COMM1,COMM2,CHKCMM,LONG,COMMEN)
C======================================================================>
C
         IMPLICIT NONE
         INTEGER          I,J,L1,L2,LONG,CONT
         INTEGER          IN, JN, ICOMMN
         CHARACTER*40     CHKCMM,COMMEN
         CHARACTER*10     COMM1(25), COMM2(25)
C
         DO 7298 IN=1,I
            DO 7297 JN=1,J
               L1=INDEX(COMM1(IN),' ')-1
               L2=INDEX(COMM2(JN),' ')-1
               IF (L1 .NE. 0 .AND. L2 .NE. 0) THEN
                  CHKCMM=
     1                 '#'/ /COMM1(IN)(1:L1)/ /','/ /COMM2(JN)(1:L2)
               ELSEIF (L1 .EQ. 0 .AND. L2 .NE. 0) THEN
                  CHKCMM='#'/ /COMM2(JN)(1:L2)/ /' '
               ELSEIF (L1 .NE. 0 .AND. L2 .EQ. 0) THEN
                  CHKCMM='#'/ /COMM1(IN)(1:L1)/ /' '
               ELSEIF (L1 .EQ. 0 .AND. L2 .EQ. 0) THEN
                  CHKCMM='#'/ /' '
               ENDIF
               LONG=INDEX(CHKCMM,' ')-1
               ICOMMN=INDEX(COMMEN,' ')-1
c
c
c for debugging and checking purposes
c
c               if (icommn .lt. 1 .or. icommn .gt. 40) then
c                  write(6,9292)
c 9292             format(' .. error in index ..')
c                  goto 7297
c               endif
c               write(6,9191) icommn, 
c     1                       long, 
c     2                       commen,
c     3                       chkcmm
c 9191          format('icommn=',i3,2x,
c     1                'long  =',i3,2x,
c     2                'commen=(',a18,')',2x,
c     3                'chkcmm=(',a18,')')
c
c
               IF (COMMEN(1:ICOMMN) .EQ. CHKCMM(1:LONG)) THEN
                  LONG=1
                  RETURN
               ENDIF
 7297       CONTINUE
 7298    CONTINUE
C
         LONG=0
         RETURN
         END


C
C======================================================================>
         SUBROUTINE RMVBLN(CONT,COMMEN)
C======================================================================>
C
         IMPLICIT NONE
         CHARACTER*40 COMMEN,TMP
         INTEGER I,J,K,CONT
C
         K=LEN(COMMEN)-CONT+1
         DO 7171 I=1,K
            J=CONT+I-1
            TMP(I:I)=COMMEN(J:J)
 7171    CONTINUE
C
         K=LEN(TMP)
         DO 7272 I=1,K
            COMMEN(I:I)=TMP(I:I)
 7272    CONTINUE
C
         RETURN
         END
         

C
C======================================================================>
       SUBROUTINE CHKATM(CTERR,NUM1,RES1,ATM1,NUM2,RES2,ATM2)
C======================================================================>
C
         IMPLICIT NONE
         INTEGER          NUM1,NUM2,CTERR
         CHARACTER*6      RES1,ATM1,RES2,ATM2
C
         IF (RES1(1:3) .EQ. 'ALA') THEN
            IF 
     1         (ATM1(1:4) .NE. 'HB1 ' .AND.
     1          ATM1(1:4) .NE. 'HB2 ' .AND.
     1          ATM1(1:4) .NE. 'HB3 ' .AND.
     1          ATM1(1:4) .NE. 'CB  ' .AND.
     1          ATM1(1:4) .NE. 'HA  ' .AND.
     1          ATM1(1:4) .NE. 'CA  ' .AND.
     1          ATM1(1:4) .NE. 'N   ' .AND.
     1          ATM1(1:4) .NE. 'HN  ' .AND.
     1          ATM1(1:4) .NE. 'O   ' .AND.
     1          ATM1(1:4) .NE. 'C   ' .AND.
     1          ATM1(1:4) .NE. 'QB  ' ) THEN
            PRINT*, ' ' 
            PRINT*,
     $        ' * CHECK ATM1 -> '
     $        ,NUM1,' ',RES1,' ',ATM1,'     ',NUM2,' ',RES2,' ',ATM2
            PRINT*, ' ' 
            RETURN
            ENDIF
         ENDIF
         IF (RES2(1:3) .EQ. 'ALA') THEN
            IF 
     2         (ATM2(1:4) .NE. 'HB1 ' .AND.
     2          ATM2(1:4) .NE. 'HB2 ' .AND.
     2          ATM2(1:4) .NE. 'HB3 ' .AND.
     2          ATM2(1:4) .NE. 'CB  ' .AND.
     2          ATM2(1:4) .NE. 'CA  ' .AND.
     2          ATM2(1:4) .NE. 'HA  ' .AND.
     2          ATM2(1:4) .NE. 'N   ' .AND.
     2          ATM2(1:4) .NE. 'HN  ' .AND.
     2          ATM2(1:4) .NE. 'O   ' .AND.
     2          ATM2(1:4) .NE. 'C   ' .AND.
     2          ATM2(1:4) .NE. 'QB  ' ) THEN
            PRINT*, ' ' 
            PRINT*,
     $        ' * CHECK ATM2 -> '
     $        ,NUM1,' ',RES1,' ',ATM1,'     ',NUM2,' ',RES2,' ',ATM2
            PRINT*, ' ' 
            RETURN
            ENDIF
         ENDIF
C
         IF (RES1(1:3) .EQ. 'ASN') THEN
            IF 
     1         (ATM1(1:4) .NE. 'HB1 ' .AND.
     1          ATM1(1:4) .NE. 'HB2 ' .AND.
     1          ATM1(1:4) .NE. 'CB  ' .AND.
     1          ATM1(1:4) .NE. 'CA  ' .AND.
     1          ATM1(1:4) .NE. 'HA  ' .AND.
     1          ATM1(1:4) .NE. 'N   ' .AND.
     1          ATM1(1:4) .NE. 'HN  ' .AND.
     1          ATM1(1:4) .NE. 'O   ' .AND.
     1          ATM1(1:4) .NE. 'C   ' .AND.
     1          ATM1(1:4) .NE. 'CG  ' .AND.
     1          ATM1(1:4) .NE. 'OD1 ' .AND.
     1          ATM1(1:4) .NE. 'ND2 ' .AND.
     1          ATM1(1:4) .NE. 'HD21' .AND.
     1          ATM1(1:4) .NE. 'HD22' .AND.
     1          ATM1(1:4) .NE. 'HDE ' .AND.
     1          ATM1(1:4) .NE. 'HDZ ' .AND.
     1          ATM1(1:4) .NE. 'QB  ' .AND.
     1          ATM1(1:4) .NE. 'QD  ' .AND.
     1          ATM1(1:4) .NE. 'QD2 ' ) THEN
            PRINT*, ' ' 
            PRINT*,
     $        ' * CHECK ATM1 -> '
     $        ,NUM1,' ',RES1,' ',ATM1,'     ',NUM2,' ',RES2,' ',ATM2
            PRINT*, ' ' 
            RETURN
            ENDIF
         ENDIF
         IF (RES2(1:3) .EQ. 'ASN') THEN
            IF 
     2         (ATM2(1:4) .NE. 'HB1 ' .AND.
     2          ATM2(1:4) .NE. 'HB2 ' .AND.
     2          ATM2(1:4) .NE. 'CB  ' .AND.
     2          ATM2(1:4) .NE. 'CA  ' .AND.
     2          ATM2(1:4) .NE. 'HA  ' .AND.
     2          ATM2(1:4) .NE. 'N   ' .AND.
     2          ATM2(1:4) .NE. 'HN  ' .AND.
     2          ATM2(1:4) .NE. 'O   ' .AND.
     2          ATM2(1:4) .NE. 'C   ' .AND.
     2          ATM2(1:4) .NE. 'CG  ' .AND.
     2          ATM2(1:4) .NE. 'OD1 ' .AND.
     2          ATM2(1:4) .NE. 'ND2 ' .AND.
     2          ATM2(1:4) .NE. 'HD21' .AND.
     2          ATM2(1:4) .NE. 'HD22' .AND.
     2          ATM2(1:4) .NE. 'HDE ' .AND.
     2          ATM2(1:4) .NE. 'HDZ ' .AND.
     2          ATM2(1:4) .NE. 'QB  ' .AND.
     2          ATM2(1:4) .NE. 'QD  ' .AND.
     2          ATM2(1:4) .NE. 'QD2 ' ) THEN
            PRINT*, ' ' 
            PRINT*,
     $        ' * CHECK ATM2 -> '
     $        ,NUM1,' ',RES1,' ',ATM1,'     ',NUM2,' ',RES2,' ',ATM2
            PRINT*, ' ' 
            RETURN
            ENDIF
         ENDIF
C
         IF (RES1(1:3) .EQ. 'ASP') THEN
            IF 
     1         (ATM1(1:4) .NE. 'HB1 ' .AND.
     1          ATM1(1:4) .NE. 'HB2 ' .AND.
     1          ATM1(1:4) .NE. 'CB  ' .AND.
     1          ATM1(1:4) .NE. 'CA  ' .AND.
     1          ATM1(1:4) .NE. 'HA  ' .AND.
     1          ATM1(1:4) .NE. 'N   ' .AND.
     1          ATM1(1:4) .NE. 'HN  ' .AND.
     1          ATM1(1:4) .NE. 'O   ' .AND.
     1          ATM1(1:4) .NE. 'C   ' .AND.
     1          ATM1(1:4) .NE. 'CG  ' .AND.
     1          ATM1(1:4) .NE. 'OD1 ' .AND.
     1          ATM1(1:4) .NE. 'QB  ' .AND.
     1          ATM1(1:4) .NE. 'OD2 ' ) THEN
            PRINT*, ' ' 
            PRINT*,
     $        ' * CHECK ATM1 -> '
     $        ,NUM1,' ',RES1,' ',ATM1,'     ',NUM2,' ',RES2,' ',ATM2
            PRINT*, ' ' 
            RETURN
            ENDIF
         ENDIF
         IF (RES2(1:3) .EQ. 'ASP') THEN
            IF 
     2         (ATM2(1:4) .NE. 'HB1 ' .AND.
     2          ATM2(1:4) .NE. 'HB2 ' .AND.
     2          ATM2(1:4) .NE. 'CB  ' .AND.
     2          ATM2(1:4) .NE. 'CA  ' .AND.
     2          ATM2(1:4) .NE. 'HA  ' .AND.
     2          ATM2(1:4) .NE. 'N   ' .AND.
     2          ATM2(1:4) .NE. 'HN  ' .AND.
     2          ATM2(1:4) .NE. 'O   ' .AND.
     2          ATM2(1:4) .NE. 'C   ' .AND.
     2          ATM2(1:4) .NE. 'CG  ' .AND.
     2          ATM2(1:4) .NE. 'OD1 ' .AND.
     2          ATM2(1:4) .NE. 'QB  ' .AND.
     2          ATM2(1:4) .NE. 'QD  ' .AND.
     2          ATM2(1:4) .NE. 'OD2 ' ) THEN
            PRINT*, ' ' 
            PRINT*,
     $        ' * CHECK ATM2 -> '
     $        ,NUM1,' ',RES1,' ',ATM1,'     ',NUM2,' ',RES2,' ',ATM2
            PRINT*, ' ' 
            RETURN
            ENDIF
         ENDIF
C
         RETURN
         END

C
C======================================================================>
       SUBROUTINE NWCDIA(CTERR,NUM1,RES1,ATM1,NUM2,RES2,ATM2)
C======================================================================>
C
         IMPLICIT NONE
         INTEGER          NUM1,NUM2,CTERR
         INTEGER          I,J,K
         CHARACTER*6      RES1,ATM1,RES2,ATM2
         CHARACTER*4      TOPDIA(33,20)
C
         DATA TOPDIA/     
     $     'ALA ',
     $     'C   ','O   ','N   ','HN  ','CA  ','HA  ','QB  ','CB  ',
     $     'HB1 ','HB2 ','HB3 ','    ','    ','    ','    ','    ',
     $     '    ','    ','    ','    ','    ','    ','    ','    ',
     $     '    ','    ','    ','    ','    ','    ','    ','    ',
     $     'ARG ',
     $     'C   ','O   ','N   ','HN  ','CA  ','HA  ','CB  ','HB2 ',
     $     'HB3 ','QB  ','CG  ','HG2 ','HG3 ','QG  ','CD  ','HD2 ',
     $     'HD3 ','QD  ','NE  ','HE  ','CZ  ','NH1 ','HH1 ','NH2 ',
     $     'HH21','HH22','QH2 ','    ','    ','    ','    ','    ',
     $     'ASN ',
     $     'C   ','O   ','N   ','HN  ','CA  ','HA  ','CB  ','HB2 ',
     $     'HB3 ','QB  ','CG  ','OD1 ','ND2 ','HD21','HD22','QD2 ',
     $     '    ','    ','    ','    ','    ','    ','    ','    ',
     $     '    ','    ','    ','    ','    ','    ','    ','    ',
     $     'ASP ',
     $     'C   ','O   ','N   ','HN  ','CA  ','HA  ','CB  ','HB2 ',
     $     'HB3 ','QB  ','CG  ','OD1 ','OD2 ','HD2 ','    ','    ',
     $     '    ','    ','    ','    ','    ','    ','    ','    ',
     $     '    ','    ','    ','    ','    ','    ','    ','    ',
     $     'CYS ',
     $     'C   ','O   ','N   ','HN  ','CA  ','HA  ','CB  ','HB2 ',
     $     'HB3 ','QB  ','SG  ','HG  ','    ','    ','    ','    ',
     $     '    ','    ','    ','    ','    ','    ','    ','    ',
     $     '    ','    ','    ','    ','    ','    ','    ','    ',
     $     'GLN ',
     $     'C   ','O   ','N   ','HN  ','CA  ','HA  ','CB  ','HB2 ',
     $     'HB3 ','QB  ','CG  ','HG2 ','HG3 ','QG  ','CD  ','OE1 ',
     $     'NE2 ','HE21','HE22','QE2','    ','    ','    ','    ',
     $     '    ','    ','    ','    ','    ','    ','    ','    ',
     $     'GLU ',
     $     'C   ','O   ','N   ','HN  ','CA  ','HA  ','CB  ','HB2 ',
     $     'HB3 ','QB  ','CG  ','HG2 ','HG3 ','QG  ','CD  ','OE1 ',
     $     'OE2 ','HE2 ','    ','    ','    ','    ','    ','    ',
     $     '    ','    ','    ','    ','    ','    ','    ','    ',
     $     'GLY ',
     $     'C   ','O   ','N   ','HN  ','CA  ','HA1 ','HA2 ','QA  ',
     $     '    ','    ','    ','    ','    ','    ','    ','    ',
     $     '    ','    ','    ','    ','    ','    ','    ','    ',
     $     '    ','    ','    ','    ','    ','    ','    ','    ',
     $     'HIS ',
     $     'C   ','O   ','N   ','HN  ','CA  ','HA  ','CB  ','HB2 ',
     $     'HB3 ','QB  ','CG  ','ND1 ','CD2 ','HD1 ','CE1 ','NE2 ',
     $     'HD2 ','HE1 ','    ','    ','    ','    ','    ','    ',
     $     '    ','    ','    ','    ','    ','    ','    ','    ',
     $     'ILE ',
     $     'C   ','O   ','N   ','HN  ','CA  ','HA  ','CB  ','HB  ',
     $     'QG2 ','CG2 ','HG21','HG22','HG23','CG1 ','HG12','HG13',
     $     'QG1 ','QD1 ','CD1 ','HD11','HD12','HD13','    ','    ',
     $     '    ','    ','    ','    ','    ','    ','    ','    ',
     $     'LEU ',
     $     'C   ','O   ','N   ','HN  ','CA  ','HA  ','CB  ','HB2 ',
     $     'HB3 ','QB  ','CG  ','HG  ','QD1 ','QD2 ','CD1 ','HD11',
     $     'HD12','HD13','CD2 ','HD21','HD22','HD23','QQD ','    ',
     $     '    ','    ','    ','    ','    ','    ','    ','    ',
     $     'LYS ',
     $     'C   ','O   ','N   ','HN  ','CA  ','HA  ','CB  ','HB2 ',
     $     'HB3 ','QB  ','CG  ','HG2 ','HG3 ','QG  ','CD  ','HD2 ',
     $     'HD3 ','QD  ','CE  ','HE2 ','HE3 ','QE  ','NZ  ','HZ1 ',
     $     'HZ2 ','QZ  ','    ','    ','    ','    ','    ','    ',
     $     'MET ',
     $     'C   ','O   ','N   ','HN  ','CA  ','HA  ','CB  ','HB2 ',
     $     'HB3 ','QB  ','CG  ','HG2 ','HG3 ','QG  ','SD  ','QE  ',
     $     'CE  ','HE1 ','HE2 ','HE3 ','    ','    ','    ','    ',
     $     '    ','    ','    ','    ','    ','    ','    ','    ',
     $     'PHE ',
     $     'C   ','O   ','N   ','HN  ','CA  ','HA  ','CB  ','HB2 ',
     $     'HB3 ','QB  ','CG  ','CD1 ','HD1 ','CE1 ','HE1 ','CZ  ',
     $     'HZ  ','CE2 ','HE2 ','CD2 ','HD2 ','QR  ','    ','    ',
     $     '    ','    ','    ','    ','    ','    ','    ','    ',
     $     'PRO ',
     $     'C   ','O   ','N   ','HN  ','CA  ','HA  ','CB  ','HB2 ',
     $     'HB3 ','QB  ','CG  ','HG2 ','HG3 ','QG  ','HD2 ','HD3 ',
     $     'QD  ','    ','    ','    ','    ','    ','    ','    ',
     $     '    ','    ','    ','    ','    ','    ','    ','    ',
     $     'SER ',
     $     'C   ','O   ','N   ','HN  ','CA  ','HA  ','CB  ','HB2 ',
     $     'HB3 ','QB  ','OG  ','HG  ','    ','    ','    ','    ',
     $     '    ','    ','    ','    ','    ','    ','    ','    ',
     $     '    ','    ','    ','    ','    ','    ','    ','    ',
     $     'THR ',
     $     'C   ','O   ','N   ','HN  ','CA  ','HA  ','CB  ','HB  ',
     $     'QG2 ','OG1 ','HG1 ','CG2 ','HG21','HG22','HG23','    ',
     $     '    ','    ','    ','    ','    ','    ','    ','    ',
     $     '    ','    ','    ','    ','    ','    ','    ','    ',
     $     'TRP ',
     $     'C   ','O   ','N   ','HN  ','CA  ','HA  ','CB  ','HB2 ',
     $     'HB3 ','QB  ','CG  ','CD1 ','CD2 ','CE3 ','CE2 ','NE1 ',
     $     'HD1 ','HE3 ','CZ3 ','CZ2 ','HE1 ','HZ3 ','CH2 ','HZ2 ',
     $     'HH2 ','    ','    ','    ','    ','    ','    ','    ',
     $     'TYR ',
     $     'C   ','O   ','N   ','HN  ','CA  ','HA  ','CB  ','HB2 ',
     $     'HB3 ','QB  ','CG  ','CD1 ','HD1 ','CE1 ','HE1 ','CZ  ',
     $     'CE2 ','HE2 ','CD2 ','HD2 ','QR  ','OH  ','HH  ','    ',
     $     '    ','    ','    ','    ','    ','    ','    ','    ',
     $     'VAL ',
     $     'C   ','O   ','N   ','HN  ','CA  ','HA  ','CB  ','HB  ',
     $     'QG1 ','QG2 ','CG1 ','HG11','HG12','HG13','CG2 ','HG21',
     $     'HG22','HG23','QQG ','    ','    ','    ','    ','    ',
     $     '    ','    ','    ','    ','    ','    ','    ','    '/
C
C
C
       DO 910 I=1,20
          IF (RES1(1:3) .NE. TOPDIA(1,I)(1:3)) THEN
             CONTINUE
          ELSE
             K=I
             GOTO 1005
          ENDIF
 910   CONTINUE
C
       PRINT*,
     $      ' * CHECK RES1 -> '
     $      ,NUM1,' ',RES1,' ',ATM1
     $      ,NUM2,' ',RES2,' ',ATM2 
       RETURN
C
 1005  DO 900 J=2,32
          IF (ATM1(1:4) .NE. TOPDIA(J,K)(1:4)) THEN
             CONTINUE
          ELSE
             GOTO 1000
          ENDIF
 900   CONTINUE
C
       PRINT*,
     $      ' * CHECK ATM1 -> '
     $      ,NUM1,' ',RES1,' ',ATM1
     $      ,NUM2,' ',RES2,' ',ATM2
       RETURN
C     
C
 1000  DO 990 I=1,20
          IF (RES2(1:3) .NE. TOPDIA(1,I)(1:3)) THEN
             CONTINUE
          ELSE
             K=I
             GOTO 1050
          ENDIF
 990   CONTINUE
C     
       PRINT*,
     $      ' * CHECK RES2 -> '
     $      ,NUM1,' ',RES1,' ',ATM1
     $      ,NUM2,' ',RES2,' ',ATM2 
       RETURN
C     
 1050  DO 960 J=2,32
          IF (ATM2(1:4) .NE. TOPDIA(J,K)(1:4)) THEN
             CONTINUE
          ELSE
             GOTO 1200
          ENDIF
 960   CONTINUE
C     
       PRINT*,
     $      ' * CHECK ATM2 -> '
     $      ,NUM1,' ',RES1,' ',ATM1
     $      ,NUM2,' ',RES2,' ',ATM2
       RETURN
C
 1200  END

C
C======================================================================>
       SUBROUTINE NWCDIS(CTERR,NUM1,RES1,ATM1,NUM2,RES2,ATM2)
C======================================================================>
C
         IMPLICIT NONE
         INTEGER          NUM1,NUM2,CTERR
         INTEGER          I,J,K
         CHARACTER*6      RES1,ATM1,RES2,ATM2
         CHARACTER*4      TOPDIS(33,20)
C
         DATA TOPDIS/     
     $     'ALA ',
     $     'C   ','O   ','N   ','HN  ','CA  ','HA  ','QB  ','CB  ',
     $     'HB1 ','HB2 ','HB3 ','    ','    ','    ','    ','    ',
     $     '    ','    ','    ','    ','    ','    ','    ','    ',
     $     '    ','    ','    ','    ','    ','    ','    ','    ',
     2     'ARG ',
     $     'C   ','O   ','N   ','HN  ','CA  ','HA  ','CB  ','HB1 ',
     $     'HB2 ','QB  ','CG  ','HG1 ','HG2 ','QG  ','CD  ','HD1 ',
     $     'HD2 ','QD  ','NE  ','HE  ','CZ  ','NH1 ','NH2 ','CZ  ',
     $     '    ','    ','    ','    ','    ','    ','    ','    ',
     3     'ASN ',
     $     'C   ','O   ','N   ','HN  ','CA  ','HA  ','CB  ','HB1 ',
     $     'HB2 ','QB  ','CG  ','OD1 ','ND2 ','HDE ','HDZ ','QD  ',
     $     '    ','    ','    ','    ','    ','    ','    ','    ',
     $     '    ','    ','    ','    ','    ','    ','    ','    ',
     4     'ASP ',
     $     'C   ','O   ','N   ','HN  ','CA  ','HA  ','CB  ','HB1 ',
     $     'HB2 ','QB  ','CG  ','OD1 ','OD2 ','    ','    ','    ',
     $     '    ','    ','    ','    ','    ','    ','    ','    ',
     $     '    ','    ','    ','    ','    ','    ','    ','    ',
     5     'CYS ',
     $     'C   ','O   ','N   ','HN  ','CA  ','HA  ','CB  ','HB1 ',
     $     'HB2 ','QB  ','SG  ','    ','    ','    ','    ','    ',
     $     '    ','    ','    ','    ','    ','    ','    ','    ',
     $     '    ','    ','    ','    ','    ','    ','    ','    ',
     6     'GLN ',
     $     'C   ','O   ','N   ','HN  ','CA  ','HA  ','CB  ','HB1 ',
     $     'HB2 ','QB  ','CG  ','HG1 ','HG2 ','QG  ','CD  ','OE1 ',
     $     'NE2 ','HEE ','HEZ ','QE  ','    ','    ','    ','    ',
     $     '    ','    ','    ','    ','    ','    ','    ','    ',
     7     'GLU ',
     $     'C   ','O   ','N   ','HN  ','CA  ','HA  ','CB  ','HB1 ',
     $     'HB2 ','QB  ','CG  ','HG1 ','HG2 ','QG  ','CD  ','OE1 ',
     $     'OE2 ','    ','    ','    ','    ','    ','    ','    ',
     $     '    ','    ','    ','    ','    ','    ','    ','    ',
     8     'GLY ',
     $     'C   ','O   ','N   ','HN  ','CA  ','HA1 ','HA2 ','    ',
     $     '    ','    ','    ','    ','    ','    ','    ','    ',
     $     '    ','    ','    ','    ','    ','    ','    ','    ',
     $     '    ','    ','    ','    ','    ','    ','    ','    ',
     9     'HIS ',
     $     'C   ','O   ','N   ','HN  ','CA  ','HA  ','CB  ','HB1 ',
     $     'HB2 ','QB  ','CG5 ','ND1 ','CD4 ','HD1 ','CE2 ','NE3 ',
     $     'HD4 ','HE2 ','    ','    ','    ','    ','    ','    ',
     $     '    ','    ','    ','    ','    ','    ','    ','    ',
     9     'ILE ',
     $     'C   ','O   ','N   ','HN  ','CA  ','HA  ','CB  ','HB  ',
     $     'QG2 ','CG2 ','HG3 ','HG4 ','HG5 ','CG1 ','HG1 ','HG2 ',
     $     'QG1 ','QD  ','CD1 ','HD1 ','HD2 ','HD3 ','    ','    ',
     $     '    ','    ','    ','    ','    ','    ','    ','    ',
     1     'LEU ',
     $     'C   ','O   ','N   ','HN  ','CA  ','HA  ','CB  ','HB1 ',
     $     'HB2 ','QB  ','CG  ','HG  ','QD1 ','QD2 ','CD1 ','HD1 ',
     $     'HD2 ','HD3 ','CD2 ','HD4 ','HD5 ','HD6 ','QQD ','    ',
     $     '    ','    ','    ','    ','    ','    ','    ','    ',
     2     'LYS ',
     $     'C   ','O   ','N   ','HN  ','CA  ','HA  ','CB  ','HB1 ',
     $     'HB2 ','QB  ','CG  ','HG1 ','HG2 ','QG  ','CD  ','HD1 ',
     $     'HD2 ','QD  ','CE  ','HE1 ','HE2 ','QE  ','NZ  ','HZ1 ',
     $     'HZ2 ','QZ  ','   ','    ','    ','    ','    ','    ',
     3     'MET ',
     $     'C   ','O   ','N   ','HN  ','CA  ','HA  ','CB  ','HB1 ',
     $     'HB2 ','QB  ','CG  ','HG1 ','HG2 ','QG  ','SD  ','QE  ',
     $     'CE  ','HE1 ','HE2 ','HE3 ','    ','    ','    ','    ',
     $     '    ','    ','    ','    ','    ','    ','    ','    ',
     4     'PHE ',
     $     'C   ','O   ','N   ','HN  ','CA  ','HA  ','CB  ','HB1 ',
     $     'HB2 ','QB  ','CG1 ','CD2 ','HD2 ','CE3 ','HE3 ','CZ4 ',
     $     'HZ4 ','CE5 ','HE5 ','CD6 ','HD6 ','QR  ','    ','    ',
     $     '    ','    ','    ','    ','    ','    ','    ','    ',
     5     'PRO ',
     $     'C   ','O   ','N   ','CA  ','HA  ','CB  ','HB1 ','HB2 ',
     $     'QB  ','CG  ','HG1 ','HG2 ','QG  ','HD1 ','HD2 ','CD  ',
     $     'QD  ','    ','    ','    ','    ','    ','    ','    ',
     $     '    ','    ','    ','    ','    ','    ','    ','    ',
     6     'SER ',
     $     'C   ','O   ','N   ','HN  ','CA  ','HA  ','CB  ','HB1 ',
     $     'HB2 ','QB  ','OG  ','HG  ','    ','    ','    ','    ',
     $     '    ','    ','    ','    ','    ','    ','    ','    ',
     $     '    ','    ','    ','    ','    ','    ','    ','    ',
     7     'THR ',
     $     'C   ','O   ','N   ','HN  ','CA  ','HA  ','CB  ','HB  ',
     $     'QG  ','OG1 ','HG1 ','CG2 ','HG2 ','HG3 ','HG4 ','    ',
     $     '    ','    ','    ','    ','    ','    ','    ','    ',
     $     '    ','    ','    ','    ','    ','    ','    ','    ',
     8     'TRP ',
     $     'C   ','O   ','N   ','HN  ','CA  ','HA  ','CB  ','HB1 ',
     $     'HB2 ','QB  ','CG3 ','CD2 ','CD9 ','CE8 ','NE1 ','CE4 ',
     $     'CZ7 ','CZ5 ','CH6 ','HZ5 ','HH6 ','HE4 ','HZ7 ','HE1 ',
     $     'HD2 ','    ','    ','    ','    ','    ','    ','    ',
     9     'TYR ',
     $     'C   ','O   ','N   ','HN  ','CA  ','HA  ','CB  ','HB1 ',
     $     'HB2 ','QB  ','CG1 ','CD2 ','HD2 ','CE3 ','HE3 ','CZ4 ',
     $     'CE5 ','HE5 ','CD6 ','HD6 ','QR  ','OH  ','HH  ','    ',
     $     '    ','    ','    ','    ','    ','    ','    ','    ',
     9     'VAL ',
     $     'C   ','O   ','N   ','HN  ','CA  ','HA  ','CB  ','HB  ',
     $     'QG1 ','QG2 ','CG1 ','HG1 ','HG2 ','HG3 ','CG2 ','HG4 ',
     $     'HG5 ','HG6 ','QQG ','    ','    ','    ','    ','    ',
     $     '    ','    ','    ','    ','    ','    ','    ','    '/
C
C
       DO 910 I=1,20
          IF (RES1(1:3) .NE. TOPDIS(1,I)(1:3)) THEN
             CONTINUE
          ELSE
             K=I
             GOTO 1005
          ENDIF
 910   CONTINUE
C
       PRINT*,
     $      ' * CHECK RES1 -> '
     $      ,NUM1,' ',RES1,' ',ATM1
     $      ,NUM2,' ',RES2,' ',ATM2 
       RETURN
C
 1005  DO 900 J=2,32
          IF (ATM1(1:4) .NE. TOPDIS(J,K)(1:4)) THEN
             CONTINUE
          ELSE
             GOTO 1000
          ENDIF
 900   CONTINUE
C
       PRINT*,
     $      ' * CHECK ATM1 -> '
     $      ,NUM1,' ',RES1,' ',ATM1
     $      ,NUM2,' ',RES2,' ',ATM2
       RETURN
C     
C
 1000  DO 990 I=1,20
          IF (RES2(1:3) .NE. TOPDIS(1,I)(1:3)) THEN
             CONTINUE
          ELSE
             K=I
             GOTO 1050
          ENDIF
 990   CONTINUE
C     
       PRINT*,
     $      ' * CHECK RES2 -> '
     $      ,NUM1,' ',RES1,' ',ATM1
     $      ,NUM2,' ',RES2,' ',ATM2 
       RETURN
C     
 1050  DO 960 J=2,32
          IF (ATM2(1:4) .NE. TOPDIS(J,K)(1:4)) THEN
             CONTINUE
          ELSE
             GOTO 1200
          ENDIF
 960   CONTINUE
C     
       PRINT*,
     $      ' * CHECK ATM2 -> '
     $      ,NUM1,' ',RES1,' ',ATM1
     $      ,NUM2,' ',RES2,' ',ATM2
       RETURN
C
 1200  END

C
C======================================================================>
       SUBROUTINE NWCSYB(CTERR,NUM1,RES1,ATM1,NUM2,RES2,ATM2)
C======================================================================>
C
         IMPLICIT NONE
         INTEGER          NUM1,NUM2,CTERR
         INTEGER          I,J,K
         CHARACTER*6      RES1,ATM1,RES2,ATM2
         CHARACTER*4      TOPSYB(33,20)
C
         DATA TOPSYB/     
     $     'ALA ',
     $     'C   ','O   ','N   ','H   ','CA  ','HA  ','QB  ','CB  ',
     $     'HB1 ','HB2 ','HB3 ','    ','    ','    ','    ','    ',
     $     '    ','    ','    ','    ','    ','    ','    ','    ',
     $     '    ','    ','    ','    ','    ','    ','    ','    ',
     $     'ARG ',
     $     'C   ','O   ','N   ','H   ','CA  ','HA  ','CB  ','HB1 ',
     $     'HB2 ','QB  ','CG  ','HG1 ','HG2 ','QG  ','CD  ','HD1 ',
     $     'HD2 ','QD  ','NE  ','HE  ','CZ  ','NH2 ','HH22','HH21',
     $     'QH2 ','NH1 ','HH11','HH12','QH1 ','    ','    ','    ',
     $     'ASN ',
     $     'C   ','O   ','N   ','H   ','CA  ','HA  ','CB  ','HB1 ',
     $     'HB2 ','QB  ','CG  ','OD1 ','ND2 ','HD21','HD22','QD2 ',
     $     '    ','    ','    ','    ','    ','    ','    ','    ',
     $     '    ','    ','    ','    ','    ','    ','    ','    ',
     $     'ASP ',
     $     'C   ','O   ','N   ','H   ','CA  ','HA  ','CB  ','HB1 ',
     $     'HB2 ','QB  ','CG  ','OD1 ','OD2 ','    ','    ','    ',
     $     '    ','    ','    ','    ','    ','    ','    ','    ',
     $     '    ','    ','    ','    ','    ','    ','    ','    ',
     $     'CYS ',
     $     'C   ','O   ','N   ','H   ','CA  ','HA  ','CB  ','HB1 ',
     $     'HB2 ','QB  ','SG  ','HG  ','    ','    ','    ','    ',
     $     '    ','    ','    ','    ','    ','    ','    ','    ',
     $     '    ','    ','    ','    ','    ','    ','    ','    ',
     $     'GLN ',
     $     'C   ','O   ','N   ','H   ','CA  ','HA  ','CB  ','HB1 ',
     $     'HB2 ','QB  ','CG  ','HG2 ','HG1 ','QG  ','CD  ','OE1 ',
     $     'NE2 ','HE21','HE22','QE2','    ','    ','    ','    ',
     $     '    ','    ','    ','    ','    ','    ','    ','    ',
     $     'GLU ',
     $     'C   ','O   ','N   ','H   ','CA  ','HA  ','CB  ','HB1 ',
     $     'HB2 ','QB  ','CG  ','HG1 ','HG2 ','QG  ','CD  ','OE1 ',
     $     'OE2 ','    ','    ','    ','    ','    ','    ','    ',
     $     '    ','    ','    ','    ','    ','    ','    ','    ',
     $     'GLY ',
     $     'C   ','O   ','N   ','H   ','CA  ','HA1 ','HA2 ','QA  ',
     $     '    ','    ','    ','    ','    ','    ','    ','    ',
     $     '    ','    ','    ','    ','    ','    ','    ','    ',
     $     '    ','    ','    ','    ','    ','    ','    ','    ',
     $     'HIS ',
     $     'C   ','O   ','N   ','H   ','CA  ','HA  ','CB  ','HB1 ',
     $     'HB2 ','QB  ','CG  ','ND1 ','CD2 ','HD1 ','CE1 ','NE2 ',
     $     'HD2 ','HE1 ','    ','    ','    ','    ','    ','    ',
     $     '    ','    ','    ','    ','    ','    ','    ','    ',
     $     'ILE ',
     $     'C   ','O   ','N   ','H   ','CA  ','HA  ','CB  ','HB  ',
     $     'QG2 ','CG2 ','HG21','HG22','HG23','CG1 ','HG11','HG12',
     $     'QG1 ','QD1 ','CD1 ','HD11','HD12','HD13','    ','    ',
     $     '    ','    ','    ','    ','    ','    ','    ','    ',
     $     'LEU ',
     $     'C   ','O   ','N   ','H   ','CA  ','HA  ','CB  ','HB1 ',
     $     'HB2 ','QB  ','CG  ','HG  ','QD1 ','QD2 ','CD1 ','HD11',
     $     'HD12','HD13','CD2 ','HD21','HD22','HD23','QQD ','    ',
     $     '    ','    ','    ','    ','    ','    ','    ','    ',
     $     'LYS ',
     $     'C   ','O   ','N   ','H   ','CA  ','HA  ','CB  ','HB1 ',
     $     'HB2 ','QB  ','CG  ','HG1 ','HG2 ','QG  ','CD  ','HD1 ',
     $     'HD2 ','QD  ','CE  ','HE1 ','HE2 ','QE  ','NZ  ','HZ1 ',
     $     'HZ2 ','HZ3 ','QZ  ','    ','    ','    ','    ','    ',
     $     'MET ',
     $     'C   ','O   ','N   ','H   ','CA  ','HA  ','CB  ','HB1 ',
     $     'HB2 ','QB  ','CG  ','HG1 ','HG2 ','QG  ','SD  ','QE  ',
     $     'CE  ','HE1 ','HE2 ','HE3 ','    ','    ','    ','    ',
     $     '    ','    ','    ','    ','    ','    ','    ','    ',
     $     'PHE ',
     $     'C   ','O   ','N   ','H   ','CA  ','HA  ','CB  ','HB1 ',
     $     'HB2 ','QB  ','CG  ','CD1 ','HD1 ','CE1 ','HE1 ','CZ  ',
     $     'HZ  ','CE2 ','HE2 ','CD2 ','HD2 ','QR  ','    ','    ',
     $     '    ','    ','    ','    ','    ','    ','    ','    ',
     $     'PRO ',
     $     'C   ','O   ','N   ','H   ','CA  ','HA  ','CB  ','HB1 ',
     $     'HB2 ','QB  ','CG  ','HG1 ','HG2 ','QG  ','HD1 ','HD2 ',
     $     'QD  ','    ','    ','    ','    ','    ','    ','    ',
     $     '    ','    ','    ','    ','    ','    ','    ','    ',
     $     'SER ',
     $     'C   ','O   ','N   ','H   ','CA  ','HA  ','CB  ','HB1 ',
     $     'HB2 ','QB  ','OG  ','HG  ','    ','    ','    ','    ',
     $     '    ','    ','    ','    ','    ','    ','    ','    ',
     $     '    ','    ','    ','    ','    ','    ','    ','    ',
     $     'THR ',
     $     'C   ','O   ','N   ','H   ','CA  ','HA  ','CB  ','HB  ',
     $     'QG2 ','OG1 ','HG1 ','CG2 ','HG21','HG22','HG23','    ',
     $     '    ','    ','    ','    ','    ','    ','    ','    ',
     $     '    ','    ','    ','    ','    ','    ','    ','    ',
     $     'TRP ',
     $     'C   ','O   ','N   ','H   ','CA  ','HA  ','CB  ','HB1 ',
     $     'HB2 ','QB  ','CG  ','CD1 ','CD2 ','CE3 ','CE2 ','NE1 ',
     $     'HD1 ','HE3 ','CZ3 ','CZ2 ','HE1 ','HZ3 ','CH2 ','HZ2 ',
     $     'HH2 ','    ','    ','    ','    ','    ','    ','    ',
     $     'TYR ',
     $     'C   ','O   ','N   ','H   ','CA  ','HA  ','CB  ','HB1 ',
     $     'HB2 ','QB  ','CG  ','CD1 ','HD1 ','CE1 ','HE1 ','CZ  ',
     $     'CE2 ','HE2 ','CD2 ','HD2 ','QR  ','OH  ','HH  ','    ',
     $     '    ','    ','    ','    ','    ','    ','    ','    ',
     $     'VAL ',
     $     'C   ','O   ','N   ','H   ','CA  ','HA  ','CB  ','HB  ',
     $     'QG1 ','QG2 ','CG1 ','HG11','HG12','HG13','CG2 ','HG21',
     $     'HG22','HG23','QQG ','    ','    ','    ','    ','    ',
     $     '    ','    ','    ','    ','    ','    ','    ','    '/
C
C
C
       DO 910 I=1,20
          IF (RES1(1:3) .NE. TOPSYB(1,I)(1:3)) THEN
             CONTINUE
          ELSE
             K=I
             GOTO 1005
          ENDIF
 910   CONTINUE
C
       PRINT*,
     $      ' * CHECK RES1 -> '
     $      ,NUM1,' ',RES1,' ',ATM1
     $      ,NUM2,' ',RES2,' ',ATM2 
       RETURN
C
 1005  DO 900 J=2,32
          IF (ATM1(1:4) .NE. TOPSYB(J,K)(1:4)) THEN
             CONTINUE
          ELSE
             GOTO 1000
          ENDIF
 900   CONTINUE
C
       PRINT*,
     $      ' * CHECK ATM1 -> '
     $      ,NUM1,' ',RES1,' ',ATM1
     $      ,NUM2,' ',RES2,' ',ATM2
       RETURN
C     
C
 1000  DO 990 I=1,20
          IF (RES2(1:3) .NE. TOPSYB(1,I)(1:3)) THEN
             CONTINUE
          ELSE
             K=I
             GOTO 1050
          ENDIF
 990   CONTINUE
C     
       PRINT*,
     $      ' * CHECK RES2 -> '
     $      ,NUM1,' ',RES1,' ',ATM1
     $      ,NUM2,' ',RES2,' ',ATM2 
       RETURN
C     
 1050  DO 960 J=2,32
          IF (ATM2(1:4) .NE. TOPSYB(J,K)(1:4)) THEN
             CONTINUE
          ELSE
             GOTO 1200
          ENDIF
 960   CONTINUE
C     
       PRINT*,
     $      ' * CHECK ATM2 -> '
     $      ,NUM1,' ',RES1,' ',ATM1
     $      ,NUM2,' ',RES2,' ',ATM2
       RETURN
C
 1200  END
