/***************************************************************************
                          AA.cpp  -  description
                             -------------------
    begin                : Mon Aug 21 2000
    copyright            : (C) 2000 by Yuanpeng Janet Huang
    email                : yphuang@cabm.rutgers.edu
 ***************************************************************************/

#include <iostream> 
#include <cstdio>
#include <sstream>
#include <ctype.h>
#include "AA.h"

char AA::get_sym_1() const
{ return symbol_1;
}

string AA::get_special() const
{
  return special; 
}
const Structure* const AA::get_ss() const
{ return ss;
}

AA::AA() 
{
	symbol_1 = (char)0;
	ss = NULL;
}

AA::AA(char symbol) 
{
	symbol_1 = toupper(symbol);
	ss = NULL; 
} 

void AA::set(char symbol) 
{
	symbol_1 = toupper(symbol);
} 

void AA::set_ss(const Structure* s)
{
	ss = s; 
} 

ostream& operator<< (ostream& s, const AA& residue)
{
	s << residue.symbol_1;
	return s; 
}

ostream& operator<<(ostream&s, const AA* residue)
{
	s << *residue;
	return s; 
}

istream& operator>> (istream& s, AA& residue)
{
  string junk;
	string symbol_3;

	s >> junk >> symbol_3;
	
  ios::iostate state = s.rdstate();
	
	if ((state&ios::failbit) && !(state&ios::eofbit))
	{
		cerr << endl << "*** Bad sequence format found: " << endl
				 <<  junk << symbol_3 << " ignored" << endl;	
	}
	
	if (symbol_3.length() == 3)
	  residue.symbol_1 = symbol3_1[symbol_3];
	else if (symbol_3.length() == 1)
	  residue.symbol_1 = symbol_3[0];
	else
	{ 
	   residue.special = symbol_3;
	   residue.symbol_1 = ' ';  
	}	
	return s;
}

