/***************************************************************************
                          AA.h  -  residue in Sequence
                             -------------------
    begin                : Mon Aug 21 2000
    copyright            : (C) 2000 by Yuanpeng Janet Huang
    email                : yphuang@cabm.rutgers.edu
 ***************************************************************************/

#ifndef AA_H
#define AA_H

#include <string>
#include <map>
#include "ss.h"
using namespace std;

// residues in the sequence
// linked to the secondary structure type 
class AA {
private:
	char symbol_1;
	string special; 
	const Structure* ss;
public:
	AA();
	~AA(){}; 
	AA(char); 	// symbol_1
	void set(char);	// symbol_1 
	void set_ss(const Structure*);

	char get_sym_1() const;
	string get_special() const; 
	const Structure* const get_ss() const;

	friend istream& operator>> (istream&, AA&);
	friend ostream& operator<< (ostream&, const AA&);
	friend bool operator< (const AA& x, const AA& y);
};

typedef map<int, AA, less<int> > SEQM; // sequence 

extern map<char, string, less<char> > residue_name; // map to 3 charactor  
extern map<char, map<string, string, less<string> >, less<char> > layer_map;
extern map<string, char, less<string> > symbol3_1;

extern SEQM seq; // sequence of residues
extern map<int, string, less<int> > specialName; // special residues 
#endif
