/***************************************************************************
                          CC4NOESY.cpp  -  description
                             -------------------
    begin                : Mon Aug 21 2000
    copyright            : (C) 2000 by Yuanpeng Janet Huang
    email                : yphuang@cabm.rutgers.edu
 ***************************************************************************/

#include "CC4NOESY.h"

CC4NOESY_HSQC::CC4NOESY_HSQC(bool flag, bool haveIC, float hx1t, float x1t, float hx2t, float x2t, float f, string label)
	:D4NOESY(flag, haveIC, hx1t, x1t, hx2t, x2t, f, label)
{
}
CC4NOESY_HSQC::~CC4NOESY_HSQC()
{
}

const string CC4NOESY_HSQC::Type() const
{
  return "4DCC";
}

bool CC4NOESY_HSQC::canbeMom(const atom* atom1) const
{
	if (atom1->isatt_C())
		return 1; 
	return 0; 
}

bool CC4NOESY_HSQC::canbeDad(const atom* atom1) const
{
	if (atom1->isatt_C())
		return 1;
	return 0;
}



bool CC4NOESY_HSQC::isPossFather(const atom* temp1, pair<float, float> bound) const
{
	deque<atom*> att_C = temp1->att_C();

	for(deque<atom*>::iterator it = att_C.begin();
		it != att_C.end(); it++)
	{
		if (*it)
				if (((*it)->get_shift() <= bound.second) && ((*it)->get_shift() >= bound.first))
				return 1;
	}
	return 0;
} 	

bool CC4NOESY_HSQC::isPossMother(const atom* temp1, pair<float, float> bound) const
{
	deque<atom*> att_C = temp1->att_C();

	for(deque<atom*>::iterator it = att_C.begin();
		it != att_C.end(); it++)
	{
		if (*it)
				if (((*it)->get_shift() <= bound.second) && ((*it)->get_shift() >= bound.first))
				return 1;
	}
	return 0;
} 	
