/***************************************************************************
                          D2NOESY.h  -  description
                             -------------------
    begin                : Mon Aug 21 2000
    copyright            : (C) 2000 by Yuanpeng Janet Huang
    email                : yphuang@cabm.rutgers.edu
 ***************************************************************************/

#ifndef D2NOESY_H
#define D2NOESY_H

#include "experiment.h"

class D2NOESY : public NOESY
{
protected: 
public:
	D2NOESY(){};
	D2NOESY(bool, bool, float, float, float, string);
	~D2NOESY(); 

	// readin the peaklist 
  void  buildPeak(const vector<string>&, int);

	bool nearH2O(const general_peak&) const;
	bool isPossMother(const atom*, pair<float, float>) const; 	
	bool isPossFather(const atom*, pair<float, float>) const;
	bool canbeMom(const atom*) const;
	bool canbeDad(const atom*) const;
	virtual const string Type() const;
	float Validate_Shift(ostream&, ostream&) const;

	virtual void Find_UniqueAH(int, int, method);
	virtual void Find_UniqueBH(int, int, method);

};

class ICD2NOESY : public D2NOESY
{
protected: 
public:
	ICD2NOESY(){};
	ICD2NOESY(bool, bool, float, float, float, string);
	~ICD2NOESY(); 

	virtual const string Type() const;	
	virtual void Find_Secondary(){};

};

#endif 


