/***************************************************************************
                          D3NOESY.cpp  -  description
                             -------------------
    begin                : Mon Aug 21 2000
    copyright            : (C) 2000 by Yuanpeng Janet Huang
    email                : yphuang@cabm.rutgers.edu
 ***************************************************************************/

#include <cmath>
#include <stdlib.h>

#include "D3NOESY.h"
#include "noesy_assign.h"

extern bool DEBUG;
void error(char*, char*);
void error(string, string);

D3NOESY::D3NOESY(bool flag, bool haveIC, float hx1, float x1, float hx2, float f, string label) :
	NOESY(flag, haveIC, hx1, x1, hx2, f, label)
{
}
D3NOESY::~D3NOESY()
{
}


bool D3NOESY::nearH2O(const general_peak& peak) const
{
  return 0;
}


void D3NOESY::buildPeak(const vector<string>& subline, const int j)
{
			if (j >= 4)
			{		
				general_peak temp_peak(3);
				if (!peakControlPtr)
				  error("Peak list format not defined : ", "Can not read in peaklist");
							
				  //int id=0; string label=0;
				  static int id=0;
				  id++;
				  string label=itoa(id);

				  if ((*peakControlPtr)["col.id"] != "")
				  {
				  	id = atoi(subline[atoi((*peakControlPtr)["col.id"].c_str())-1].c_str());
				  }				
				  if ((*peakControlPtr)["col.label"] != "")
				  {
				  	label = subline[atoi((*peakControlPtr)["col.label"].c_str())-1].c_str();
				  }				
					
				  temp_peak.assign_gen(id, label,
					atof(subline[atoi((*peakControlPtr)["col.intensity"].c_str())-1].c_str()),
					atof(subline[atoi((*peakControlPtr)["col.hx1"].c_str())-1].c_str()),
					atof(subline[atoi((*peakControlPtr)["col.x1"].c_str())-1].c_str()),
					atof(subline[atoi((*peakControlPtr)["col.hx2"].c_str())-1].c_str()));
						
				  if ((temp_peak.get_HX1() !=0) || (temp_peak.get_HX2() !=0))	
				  {
				      peakList.push_back(temp_peak);
				      //if (DEBUG)
					NOESY_Assign::outputLog() << "Read as-> " << temp_peak << endl;
				  } else
				  {
				    NOESY_Assign::outputLog() << "Skipped ";				    
				    for(vector<string>::const_iterator i = subline.begin(); i!= subline.end(); i++)
				      {
					NOESY_Assign::outputLog() << *i << " "; 
				      }
				    NOESY_Assign::outputLog() << endl;				    
				  }
			} else
			{
			  error("Bad input format: Cannot Read D3NOESY peaklist from", label());;
			}
}






