/***************************************************************************
                          EC.cpp  -  methods for EC generation
                             -------------------
    begin                : Tue Sept 3 2013
    copyright            : (C) 2013 by Yuanpeng Janet Huang
    email                : yphuang@cabm.rutgers.edu
 ***************************************************************************/

#include <cmath>
#include <stdlib.h>
#include "noesy_assign.h"
#include "EC.h"
#include "atom.h"

#define fabs(x) fabs((double)(x))

extern bool DEBUG;
extern SEQM seq;
SampleStatistic getDistStat(deque<Pdb>& , pair<const atom*, const atom*>, bool);

void get_range(deque<Pdb>&, const atom*, Atom_Index_List&, deque<atom*>&);

int NOESY_Assign::adjustEC(const string fileName, bool dyana, map<HBOND, ECscore, less<HBOND> >& ECList,  Atom_List& atoms, float cut_upl, float cut_upl2)
{
  if (DEBUG) NOESY_Assign::outputLog() << "test in adjustEC " << fileName << " " << dyana << endl;

  int count = 0;
  //violated
/*
  if (fileName != "'")
    {
      ifstream fovw(fileName.c_str());
      if (DEBUG) NOESY_Assign::outputLog() << dyana << "-" << fovw << "-" << endl;

      if ((fovw) && dyana)
	{
	  //ovw = 1;

	  string line;
	  //while(getlineNA(fovw, line) && (line != "Upper"))
	  //  {}
	 if (DEBUG) NOESY_Assign::outputLog() << "in if" << endl;

	  while(getlineNA(fovw, line) && (line.find("VdW") > line.length())) // between "Hydrogen bonds:" and "hydrogen bonds".
	    {
		if (DEBUG) NOESY_Assign::outputLog() << line << endl;

	      if (line.find("Upper") < line.length())
		{
		  vector<string> subline; subline.clear();
		  split(line, subline);
		  int a = atoi(subline[3].c_str());
		  int b = atoi(subline[7].c_str());
		  if (a < b)
			ECList.erase(make_pair(a,b));
		  else
			ECList.erase(make_pair(b,a));

		  //ECList.erase(make_pair(atoi(subline[3].c_str()), atoi(subline[7].c_str())));
		  NOESY_Assign::outputError() << "EC ovw remove " << subline[3] << " " << subline[7] << endl;
		  count++;
		}
	    }
	if (DEBUG) NOESY_Assign::outputLog() << "end of VdW" << line << endl;
	}
    }
  */

  /*  Atom_Index_List atoms_index;
  for(Atom_List::iterator iter = atoms.begin(); iter != atoms.end(); ++iter)
    {
      atoms_index.insert(make_pair((*iter).get_index(), &(*iter)));
    }
  */

  map<HBOND, ECscore, less<HBOND> >::iterator eci;
  //map<HBOND, float, less<HBOND> >notFound; notFound.clear();
  for(eci = ECList.begin(); eci != ECList.end(); eci++)
    {
      if (eci->second.weightAdjust == 0) continue;
      //NOESY_Assign::outputError() << "here" << " " << eci->first.first << " " << eci->first.second << endl;

      SampleStatistic distStat; distStat.reset();
      //NOESY_Assign::outputError() << distStat.min() << " " << _pdbList.size() << endl;

      if (_pdbList.size())
	{
	  //int count = 0;
	  for(deque<Pdb>::iterator iterp=_pdbList.begin(); iterp != _pdbList.end(); iterp++)
	    {
	      float dist = NOMATCH;

	      //count++;
	      //NOESY_Assign::outputError() << "model" << count << endl << *iterp << endl;

	      dist = iterp->get_dist(NOESY_Assign::outputError(), eci->first.first, eci->first.second);
	      //NOESY_Assign::outputError() << eci->first.first << " " << eci->first.second << " " << dist << endl;

	      if (dist != NOMATCH)
		distStat += dist;
	    }
	}

      if ((distStat.oriSamples().size() == _pdbList.size()) && (distStat.min() > cut_upl+eci->second.distance+1.0))
	{
	  //notFound.insert(*eci);
	  count++;
	  //eci->second -= 0.5;
	  eci->second.distanceAdjust = distStat.max();
	  NOESY_Assign::outputError() << "EC adjusted by min distance " << eci->first.first << " " << eci->first.second << " " << eci->second.distanceAdjust << endl;
	}
      else if ((distStat.oriSamples().size() == _pdbList.size()) && (distStat.median() > cut_upl2+eci->second.distance+1.0))
	{
	  //notFound.insert(*eci);
	  //eci->second -=0.5;
	  count++;
	  eci->second.distanceAdjust = distStat.max();
	  NOESY_Assign::outputError() << "EC adjusted by median distance " << eci->first.first << " " << eci->first.second << " " << eci->second.distanceAdjust << endl;
	} else if ((distStat.oriSamples().size() == _pdbList.size()))
	{
	  //eci->second +=0.5;
	}

      /*
      Atom_Index_List::iterator i_lower = atoms_index.lower_bound(eci->first.first);
      Atom_Index_List::iterator i_upper = atoms_index.upper_bound(eci->first.first);

      Atom_Index_List::iterator j_lower = atoms_index.lower_bound(eci->first.second);
      Atom_Index_List::iterator j_upper = atoms_index.upper_bound(eci->first.second);

      int found = 0;
      for(Atom_Index_List::iterator ii = i_lower; ii != i_upper; ii++)
	    {
	      for(Atom_Index_List::iterator ji = j_lower; ji != j_upper; ji++)
		{
		  pair<const atom*, const atom*> ab;
		  if (ii->second < ji->second)
		    ab = make_pair(ii->second, ji->second);
		  else
		    ab = make_pair(ji->second, ii->second);

		  SampleStatistic disStat = getDistStat(NOESY_Assign::pdbList(), ab, 0);
		  if (disStat.oriSamples().size() == NOESY_Assign::pdbList().size())
		    {
		      if (disStat.min() < 5.0)
			{
			  //ECList.insert(make_pair(make_pair(i->first, j->first), 1));
			  //if (DEBUG) NOESY_Assign::outputLog() << "insert " << i->first << " " << j->first << endl;
			  found++;
			  //count++;
			  //break;
			}
		    }
		}
	    }
      if (found < 2)
	{
	  notFound.insert(*eci);
	}
      else
	{
	  //eci->second = 1;
	}
      */
    }
  /*
  for(eci = notFound.begin(); eci != notFound.end(); eci++)
    {
      cout << "ECList erase " << eci->first.first << " " << eci->first.second << endl;
      ECList.erase(eci->first);
      count++;
    }
  */

  return count;
}

int NOESY_Assign::validateEC(const string fileName, bool dyana, map<HBOND, ECscore, less<HBOND> >& ECList,  Atom_List& atoms, float cut_upl, float cut_upl2)
{
  if (DEBUG) NOESY_Assign::outputLog() << "test in validateEC " << fileName << " " << dyana << endl;

  int count = 0;
  //violated


  if (fileName != "")
    {
      ifstream fovw(fileName.c_str());
      if (DEBUG) NOESY_Assign::outputLog() << dyana << "-" << "-" << endl;

      if ((fovw) && dyana)
	{
	  //ovw = 1;

	  string line;
	  //while(getlineNA(fovw, line) && (line != "Upper"))
	  //  {}
	 if (DEBUG) NOESY_Assign::outputLog() << "in if" << endl;

	  while(getlineNA(fovw, line) && (line.find("VdW") > line.length())) // between "Hydrogen bonds:" and "hydrogen bonds".
	    {
		if (DEBUG) NOESY_Assign::outputError() << line << endl;

	      if (line.find("Upper") < line.length())
		{
		  vector<string> subline; subline.clear();
		  split(line, subline);
		  int a = atoi(subline[3].c_str());
		  int b = atoi(subline[7].c_str());
		  int c = atoi(subline[9].c_str());

		  if ((c*1.0)/_pdbList.size() > 0.6)
		    {
		      if (a < b)
			ECList.find(make_pair(a,b))->second.weightAdjust = 0;
		      else
			ECList.find(make_pair(b,a))->second.weightAdjust = 0;

		      //ECList.erase(make_pair(atoi(subline[3].c_str()), atoi(subline[7].c_str())));
		      NOESY_Assign::outputError() << "EC ovw remove " << subline[3] << " " << subline[7] << " " << c*1.0/_pdbList.size() << endl;
		      count++;
		    } else
		    {
		      NOESY_Assign::outputError() << "EC ovw violated " << subline[3] << " " << subline[7] << " " << c*1.0/_pdbList.size() << endl;
		    }
		}
	    }
	if (DEBUG) NOESY_Assign::outputLog() << "end of VdW" << line << endl;
	}
    }


  /*  Atom_Index_List atoms_index;
  for(Atom_List::iterator iter = atoms.begin(); iter != atoms.end(); ++iter)
    {
      atoms_index.insert(make_pair((*iter).get_index(), &(*iter)));
    }
  */

  map<HBOND, ECscore, less<HBOND> >::iterator eci;
  //map<HBOND, float, less<HBOND> >notFound; notFound.clear();
  for(eci = ECList.begin(); eci != ECList.end(); eci++)
    {
      if (eci->second.weightAdjust == 0) continue;
      //if (eci->second.distanceAdjust >
      //else
      //eci->second.weightAdjust += 0.25;

      //NOESY_Assign::outputError() << "here" << " " << eci->first.first << " " << eci->first.second << endl;

      SampleStatistic distStat; distStat.reset();
      //NOESY_Assign::outputError() << distStat.min() << " " << _pdbList.size() << endl;

      if (_pdbList.size()) // && (isAMBI()))
	{
	  //int count = 0;
	  for(deque<Pdb>::iterator iterp=_pdbList.begin(); iterp != _pdbList.end(); iterp++)
	    {
	      float dist = NOMATCH;

	      //count++;
	      //NOESY_Assign::outputError() << "model" << count << endl << *iterp << endl;

	      dist = iterp->get_dist(NOESY_Assign::outputError(), eci->first.first, eci->first.second);
	      //NOESY_Assign::outputError() << eci->first.first << " " << eci->first.second << " " << dist << endl;

	      if ((dist != NOMATCH) && (dist > cut_upl+eci->second.distance)) // cut_up = 5.5?
		{
		  distStat += dist;
		}
	    }
	}

	if (isEC()) // if no violation at all, set weight to 1;
	{
		if ((_pdbList.size() != 0) && (distStat.oriSamples().size() == 0))
		{
			eci->second.weightAdjust = 1;
		}
	}

	  if (isAMBI())
	    {
	      if (distStat.oriSamples().size() > _pdbList.size() / 3.0)
		{
		  eci->second.weightAdjust = 0;
		  eci->second.distanceAdjust = eci->second.distance;
		  count++;
		}
	    }
	  //      if ((distStat.oriSamples().size() == _pdbList.size()) && (distStat.min() > cut_upl))
	{
/*
	  //notFound.insert(*eci);
	  count++;
	  //eci->second -= 0.5;
	  eci->second.weightAdjust = 0;
	  eci->second.distanceAdjust = eci->second.distance;
	  //eci->second.distanceAdjust = distStat.median();
	  NOESY_Assign::outputError() << "EC removed by min distance " << eci->first.first << " " << eci->first.second << " " << eci->second.distanceAdjust << endl;
*/
	}
/*      else if ((distStat.oriSamples().size() == _pdbList.size()) && (distStat.mean() > cut_upl2))
	{
	  //notFound.insert(*eci);
	  eci->second.weightAdjust -= 0.5;
	  eci->second.distanceAdjust = eci->second.distance;
	  count++;
	  //eci->second.distanceAdjust = distStat.median();
	  NOESY_Assign::outputError() << "EC removed by median distance " << eci->first.first << " " << eci->first.second << " " << eci->second.distanceAdjust << endl;
	}
 */
//     else if ((distStat.oriSamples().size() == _pdbList.size()))  // small violations
	{
/*
	  //eci->second +=0.5;
	  eci->second.weightAdjust +=0.5; // increase the weight
	  eci->second.distanceAdjust = eci->second.distance; // use the orignal distance
	  //if (distStat.median() > cut_upl)
	  //  eci->second.distanceAdjust = distStat.median();
*/
	}

      /*
      Atom_Index_List::iterator i_lower = atoms_index.lower_bound(eci->first.first);
      Atom_Index_List::iterator i_upper = atoms_index.upper_bound(eci->first.first);

      Atom_Index_List::iterator j_lower = atoms_index.lower_bound(eci->first.second);
      Atom_Index_List::iterator j_upper = atoms_index.upper_bound(eci->first.second);

      int found = 0;
      for(Atom_Index_List::iterator ii = i_lower; ii != i_upper; ii++)
	    {
	      for(Atom_Index_List::iterator ji = j_lower; ji != j_upper; ji++)
		{
		  pair<const atom*, const atom*> ab;
		  if (ii->second < ji->second)
		    ab = make_pair(ii->second, ji->second);
		  else
		    ab = make_pair(ji->second, ii->second);

		  SampleStatistic disStat = getDistStat(NOESY_Assign::pdbList(), ab, 0);
		  if (disStat.oriSamples().size() == NOESY_Assign::pdbList().size())
		    {
		      if (disStat.min() < 5.0)
			{
			  //ECList.insert(make_pair(make_pair(i->first, j->first), 1));
			  //if (DEBUG) NOESY_Assign::outputLog() << "insert " << i->first << " " << j->first << endl;
			  found++;
			  //count++;
			  //break;
			}
		    }
		}
	    }
      if (found < 2)
	{
	  notFound.insert(*eci);
	}
      else
	{
	  //eci->second = 1;
	}
      */

    }
  /*
  for(eci = notFound.begin(); eci != notFound.end(); eci++)
    {
      cout << "ECList erase " << eci->first.first << " " << eci->first.second << endl;
      ECList.erase(eci->first);
      count++;
    }
  */

  return count;
}

int NOESY_Assign::findECfromSS(SS& auto_ss, deque<HBOND>& anti_register, deque<HBOND>& para_register, map<HBOND, ECscore, less<HBOND> >& ECList)
{
  if (DEBUG) NOESY_Assign::outputLog() << "test in findECfromSS " << endl;

  int count = 0;
    ///////////////
    // b-stands  //
    ///////////////

    //-- step1: find all possible HBONDs from secondary structure
    multimap<int, int, less<int> > ssEC; ssEC.clear();

    // antiparallel
    for(deque<HBOND>::iterator iterH=anti_register.begin(); iterH!=anti_register.end();iterH++)
    {
      NOESY_Assign::outputError() << "anti " << iterH->first << " " << iterH->second << endl;

      const Chain& chain1 = seq.find((*iterH).first)->second.get_ss()->get_chain();
      const Chain& chain2 = seq.find((*iterH).second)->second.get_ss()->get_chain();

      // if both are not in the beta, skip, same for hbond.cpp
      if ((seq.find(iterH->first)->second.get_ss()->get_type() != -1) && (seq.find(iterH->first)->second.get_ss()->get_type() != -1))
        continue;

      // find the co-starting point
      Chain::reverse_iterator j = (Chain::reverse_iterator) chain2.rbegin();
      Chain::iterator i = chain1.begin();

      int di = abs((*i)-(*iterH).first);
      int dj = abs((*j)-(*iterH).second);

      int d;
      if (di < dj)
      {
        d = di;
        while (j != chain2.rend())
	      {
	        if (fabs((*j)-(*iterH).second) >= d+1)
	          j++;
	        else
	          break;
	      }
      }
      else
      {
        d = dj;
        while (i != chain1.end())
	      {
	        if (fabs((*i)-(*iterH).first) > d)
	          i++;
	        else
	          break;
	      }
      }

      // identify the ends of b-strands
      int n1 = *(chain1.begin());
      int n2= *(chain2.rbegin());
      int c1 = *(chain1.rbegin());
      int c2 = *(chain2.begin());

      //starting walking
      // not include the ends of b-strands
      while (i != chain1.end()) //exclude the c-terminal residue
      {
        if (j != chain2.rend())
	       {

           NOESY_Assign::outputError() <<  *i  << " " << *j << " " << endl;

           int a = *i;
           int b = *j;
           if (b < a)
           {
             a = *j; b= *i;
           }

           map<HBOND, ECscore, less<HBOND> >::iterator kk; kk=ECList.find(make_pair(a,b));
           ECscore escore;
           /*
           escore.distance = 6.0;
           escore.distanceAdjust = 6.0;
           */
           escore.distance = 5.0;
           escore.distanceAdjust = 5.0;

           escore.weight = 1;
           escore.weightAdjust = 1;
           escore.comment ="SS anti ";

           if (kk != ECList.end())
           {
             kk->second.weightAdjust = 1;
             kk->second.distanceAdjust = 5.0;
             kk->second.comment +="SS anti";
             //NOESY_Assign::outputError() << "add " << i->first << " " << j->first << " " << kk->second.distance << " " << kk->second.weight << " " << kk->second.weightAdjust << endl;
             NOESY_Assign::outputError() << "add " << a << " " << b << " " << kk->second.distance << " " << kk->second.weight << " " << kk->second.weightAdjust << endl;
             //NOESY_Assign::outputError() << disStat.max() << " " << &*miter << endl << *diter << endl;
           } else
     	     {
     	       ECList.insert(make_pair(make_pair(a,b), escore));
             NOESY_Assign::outputError() << "add new EC " << a << " " << b << " " << kk->second.distance << " " << kk->second.weight << " " << kk->second.weightAdjust << endl;
     	     }
           count++;

	         i++;
	         j++;
        } else // if
        {
          break;
        }
	   } //while
   } // for

    for(deque<HBOND>::iterator iterH=para_register.begin(); iterH!=para_register.end();iterH++)
    {
      NOESY_Assign::outputError() << "para " << iterH->first << " " << iterH->second << endl;

      const Chain& chain1 = seq.find((*iterH).first)->second.get_ss()->get_chain();
      const Chain& chain2 = seq.find((*iterH).second)->second.get_ss()->get_chain();

      // if both are not in the beta, skip, same for hbond.cpp
      if ((seq.find(iterH->first)->second.get_ss()->get_type() != -1) && (seq.find(iterH->first)->second.get_ss()->get_type() != -1))
        continue;


	    // find the co-starting point
	    Chain::const_iterator j = chain2.begin();
	    Chain::const_iterator i = chain1.begin();

	    int di = abs((*i)-(*iterH).first);
	    int dj = abs((*j)-(*iterH).second);
	    int d;
	    if (di < dj)
	    {
	      d = di;
	      while (j != chain2.end())
		    {
		      if (fabs((*j)-(*iterH).second) > d)
		        j++;
		      else
		        break;
		    }
	    }
	    else
	    {
	      d = dj;
	      while (i != chain1.end())
		    {
		      if (fabs((*i)-(*iterH).first) > d)
		        i++;
		      else
		        break;
		    }
	    }

  	    // identify the ends of b-strands
        // 	ends of b-strands

	    //starting walking
	    while (i != chain1.end())
	    {
	      if (j != chain2.end())
		    {

          int a = *i;
          int b = *j;
          if (b < a)
          {
            a = *j; b= *i;
          }

          map<HBOND, ECscore, less<HBOND> >::iterator kk; kk=ECList.find(make_pair(a,b));
          ECscore escore;
          /*
          escore.distance = 6.0;
          escore.distanceAdjust = 6.0;
          */
          escore.distance = 5.0;
          escore.distanceAdjust = 5.0;

          escore.weight = 1;
          escore.weightAdjust = 1;
          escore.comment ="SS para ";

          if (kk != ECList.end())
          {
            kk->second.weightAdjust = 1;
            kk->second.distanceAdjust = 5.0;
            kk->second.comment +="SS para ";
            //NOESY_Assign::outputError() << "add " << i->first << " " << j->first << " " << kk->second.distance << " " << kk->second.weight << " " << kk->second.weightAdjust << endl;
            NOESY_Assign::outputError() << "add " << a << " " << b << " " << kk->second.distance << " " << kk->second.weight << " " << kk->second.weightAdjust << endl;
            //NOESY_Assign::outputError() << disStat.max() << " " << &*miter << endl << *diter << endl;
          } else
          {
            ECList.insert(make_pair(make_pair(a,b), escore));
            NOESY_Assign::outputError() << "add new EC " << a << " " << b << " " << kk->second.distance << " " << kk->second.weight << " " << kk->second.weightAdjust << endl;
          }
          count++;

          i++;
          j++;

			} else
      {
        break;
      }
    }
  }
  return count;
}



int NOESY_Assign::findEC(map<HBOND, ECscore, less<HBOND> >& ECList, const SEQM& seq, Atom_List& atoms)
{
  if (DEBUG) NOESY_Assign::outputLog() << "test in findEC " << endl;

  int count = 0;

  // initilize the atomllistmap
  Atom_Index_List atommap; atommap.clear();
  for(Atom_List::iterator iatom = NOESY_Assign::atoms().begin(); iatom != NOESY_Assign::atoms().end(); iatom++)
  {
    atommap.insert(make_pair(iatom->get_index(), &(*iatom)));
  }

  map<HBOND, ECscore, less<HBOND> > newECs; newECs.clear();
  for(Atom_List::iterator miter = NOESY_Assign::atoms().begin(); miter != NOESY_Assign::atoms().end(); ++miter)
    {
      deque<atom*> drange; drange.clear();
      get_range(_pdbList, &*miter, atommap, drange);

      //bool found = 0;

      if (DEBUG)
	NOESY_Assign::outputError() << "-->" << *miter << endl;
      for(deque<atom*>::const_iterator diter = drange.begin(); diter != drange.end(); diter++)
	{
	  if (*(*diter) < *miter) continue;
	  if (*(*diter) == *miter) continue;

	  if (DEBUG)
	    NOESY_Assign::outputError() << "-->" << *diter << " " << endl;

	  int mint = miter->get_index();
	  int dint = (*diter)->get_index();

	  if ((abs((*diter)->get_index()-miter->get_index()) >=5))
	    {

	      if (newECs.find(make_pair(mint, dint)) == newECs.end())
		{

		  pair<const atom*, const atom*> ab;
		  if (&*miter < *diter)
		    ab = make_pair(&*miter, *diter);
		  else
		    ab = make_pair(*diter, &*miter);
		  SampleStatistic disStat = getDistStat(NOESY_Assign::pdbList(), ab, 0);
		  if (disStat.oriSamples().size() == NOESY_Assign::pdbList().size())
		    {
		      if (disStat.max() < 5.0)
			{
			  //if (newECs.find(make_pair(i->first, j->first)) == newECs.end())
			  //if (newECs.find(make_pair(mint, dint)) == newECs.end())
			  {
			    //map<HBOND, ECscore, less<HBOND> >::iterator kk; kk = ECList.find(make_pair(i->first, j->first));
			    map<HBOND, ECscore, less<HBOND> >::iterator kk; kk=ECList.find(make_pair(mint, dint));
			    ECscore escore;
			    escore.distance = 5.0;
			    escore.distanceAdjust = 5.0;
			    escore.weight = 1;
			    escore.weightAdjust =1;
          escore.comment ="pdb ";
			    count++;
			    if (kk != ECList.end())
			      {

				//ECList.insert(make_pair(make_pair(i->first, j->first), 1));
				kk->second.weightAdjust = 1;
				kk->second.distanceAdjust = kk->second.distance;

        if (!kk->second.comment.find("pdb") != string::npos)
        {
          kk->second.comment +="pdb ";
        }
				//NOESY_Assign::outputError() << "add " << i->first << " " << j->first << " " << kk->second.distance << " " << kk->second.weight << " " << kk->second.weightAdjust << endl;
				NOESY_Assign::outputError() << "add " << mint << " " << dint << " " << kk->second.distance << " " << kk->second.weight << " " << kk->second.weightAdjust << endl;
				NOESY_Assign::outputError() << disStat.max() << " " << &*miter << endl << *diter << endl;
				//found = 1;
				//count++;

				//				break;
			      } else
			      {
				//ECscore escore;
				//escore.distance = 5.0;
				//escore.distanceAdjust = 5.0;
				//escore.weight = 1;
				//escore.weightAdjust = 1;
				ECList.insert(make_pair(make_pair(mint, dint), escore));
			      }

			    newECs.insert(make_pair(make_pair(mint,dint), escore));
			  }
			}
		    }
		}
	    }
	  //if (found)
	  //  {
	  //    break;
	  //  }
	} // end for
    }

  /*
  int count = 0;
  //new one

  Atom_Index_List atoms_index;
  for(Atom_List::iterator iter = atoms.begin(); iter != atoms.end(); ++iter)
    {
      atoms_index.insert(make_pair((*iter).get_index(), &(*iter)));
    }

  for(SEQM::const_iterator i = seq.begin(); i != seq.end(); ++i)
    {
      for(SEQM::const_iterator j = i; j != seq.end(); ++j)
	{
	  if (j->first < i->first + 5)
	    continue;

          Atom_Index_List::iterator i_lower = atoms_index.lower_bound(i->first);
          Atom_Index_List::iterator i_upper = atoms_index.upper_bound(i->first);

	  Atom_Index_List::iterator j_lower = atoms_index.lower_bound(j->first);
	  Atom_Index_List::iterator j_upper = atoms_index.upper_bound(j->first);

	  bool found = 0;

	  for(Atom_Index_List::iterator ii = i_lower; ii != i_upper; ii++)
	    {
	      for(Atom_Index_List::iterator ji = j_lower; ji != j_upper; ji++)
		{
		  pair<const atom*, const atom*> ab;
		  if (ii->second < ji->second)
		    ab = make_pair(ii->second, ji->second);
		  else
		    ab = make_pair(ji->second, ii->second);

		  SampleStatistic disStat = getDistStat(NOESY_Assign::pdbList(), ab, 0);
		  if (disStat.oriSamples().size() == NOESY_Assign::pdbList().size())
		    {
		      if (disStat.max() < 5.0)
			{
			  map<HBOND, ECscore, less<HBOND> >::iterator kk; kk = ECList.find(make_pair(i->first, j->first));
			  if (kk != ECList.end())
			    {
			      //ECList.insert(make_pair(make_pair(i->first, j->first), 1));
			      kk->second.weightAdjust = 1;
			      kk->second.distanceAdjust = kk->second.distance;
			      NOESY_Assign::outputError() << "add " << i->first << " " << j->first << " " << kk->second.distance << " " << kk->second.weight << " " << kk->second.weightAdjust << endl;
			      NOESY_Assign::outputError() << disStat.max() << " " << ii->second << endl << ji->second << endl;
			      found = 1;
			      count++;
			      break;
			    } else
			    {
			      ECscore escore;
			      escore.distance = 5.0;
			      escore.distanceAdjust = 5.0;
			      escore.weight = 1;
			      escore.weightAdjust = 1;
			      ECList.insert(make_pair(make_pair(i->first, j->first), escore));
			    }
			}
		    }
		}
	      if (found)
		{
		  break;
		}
	    } // end for
	}
    }
  */

  return count;
}

istream& operator>> (istream& s, map<HBOND, ECscore, less<HBOND> >& l)
{
  int i; int r; float tt;
  float dmin; float dmax;

  int count=0;

  while (s >> i >> r >> dmin >> dmax >> tt)
    {
      float score;

      score = tt;
/*
      if (count <= 0.5*seq.size())
	score = 1;
      else if (count <= seq.size())
	score = 0.5;
*/
      if (score < 0.5)
	score = 0;

      if (tt == -1)
	score = 0;

      ECscore escore;
      /*
      escore.distance = 6.0;
      escore.distanceAdjust = 6.0;
      */
      escore.distance = dmax;
      escore.distanceAdjust = dmax;

      escore.weight = score;
      escore.weightAdjust = score;

      escore.comment = "input ";
      if (i <= r)
	{
	  l.insert(make_pair(make_pair(i,r), escore));
	}
      else
	{
	  l.insert(make_pair(make_pair(r,i), escore));
	}
      count++;
    }

  ios::iostate state = s.rdstate();
  if ((state&ios::failbit) && !(state&ios::eofbit))
    {
      cerr << endl << "*** bad EC format found: " << endl << i << " " << r << " Stop reading" << endl;
    }
  return s;
}
