/***************************************************************************
                          HSQCC13NOESY.h  -  description
                             -------------------
    begin                : Mon Aug 21 2000
    copyright            : (C) 2000 by Yuanpeng Janet Huang
    email                : yphuang@cabm.rutgers.edu
 ***************************************************************************/

#ifndef C13NOESYHSQC_H
#define C13NOESYHSQC_H

#include "D3NOESY.h"

typedef pair<float, float> HXX; 
typedef pair<HXX, float> HXXH; 


class C13NOESY_HSQC : public D3NOESY {
private: 
public: 
	C13NOESY_HSQC(){};
	C13NOESY_HSQC(bool, bool, float, float, float, float, string);
	~C13NOESY_HSQC();

	//--- just match by loose tol ---//	
	virtual bool isPossMother(const atom*, pair<float, float>) const; 	
	virtual bool isPossFather(const atom*, pair<float, float>) const;
	virtual bool canbeMom(const atom*) const;
	bool canbeDad(const atom*) const;

 	virtual void Find_UniqueHH(int, int, method){};
	virtual void Find_UniqueAH(int, int, method);
	virtual void Find_UniqueBH(int, int, method);

	virtual const string Type() const;
};	

class AROC13NOESY_HSQC : public C13NOESY_HSQC{
private: 
public: 
	AROC13NOESY_HSQC(){};
	AROC13NOESY_HSQC(bool, bool, float, float, float, float, string);
	~AROC13NOESY_HSQC();

	virtual const string Type() const;
 	virtual void Find_UniqueHH(int, int, method){};
	virtual void Find_UniqueAH(int, int, method){};
	virtual void Find_UniqueBH(int, int, method){};
	virtual void Find_UniqueAA(int, int, method){};
	virtual void Find_UniqueAB(int, int, method){};

	virtual bool canbeMom(const atom*) const;		
};
	
class ALIC13NOESY_HSQC : public C13NOESY_HSQC{
private: 
public: 
	ALIC13NOESY_HSQC(){};
	ALIC13NOESY_HSQC(bool, bool, float, float, float, float, string);
	~ALIC13NOESY_HSQC();

	virtual const string Type() const;

	virtual bool canbeMom(const atom*) const;		
};	

// will be private inherance
class ICC13NOESY_HSQC : public C13NOESY_HSQC{
private: 
public: 
	ICC13NOESY_HSQC(){};
	ICC13NOESY_HSQC(bool, bool, float, float, float, float, string);
	~ICC13NOESY_HSQC();

	virtual const string Type() const;
	
	
	virtual void Find_Expect_IntraSeq(){};

  // maybe find inter-chain secondary structures in the future --- to be implemented
	virtual void Find_Secondary(){};
	
};	
#endif





