/***************************************************************************
                          HSQCN15NOESY.h  -  description
                             -------------------
    begin                : Mon Aug 21 2000
    copyright            : (C) 2000 by Yuanpeng Janet Huang
    email                : yphuang@cabm.rutgers.edu
 ***************************************************************************/

#ifndef N15NOESYHSQC_H
#define N15NOESYHSQC_H

#include "D3NOESY.h"

class N15NOESY_HSQC : public D3NOESY
{
private: 
public:
	N15NOESY_HSQC(){};
	N15NOESY_HSQC(bool, bool, float, float, float, float, string);
	~N15NOESY_HSQC(); 

	//--- just match by loose tol ---//
	bool isPossMother(const atom*, pair<float, float>) const; 	
	bool isPossFather(const atom*, pair<float, float>) const;
	bool canbeMom(const atom*) const ;
	bool canbeDad(const atom*) const;

	virtual void Find_UniqueAH(int, int, method);
	virtual void Find_UniqueBH(int, int, method);
	virtual void Find_UniqueAA(int, int, method){};
	virtual void Find_UniqueAB(int, int, method){};
		
	virtual const string Type() const;
 };

class ICN15NOESY_HSQC : public N15NOESY_HSQC
{
private: 
public:
	ICN15NOESY_HSQC(){};
	ICN15NOESY_HSQC(bool, bool, float, float, float, float, string);
	~ICN15NOESY_HSQC(); 

	virtual const string Type() const;

	virtual void Find_Secondary(){};

};
#endif





