/***************************************************************************
                          Jval.h  -  description
                             -------------------
    begin                : Mon Aug 21 2000
    copyright            : (C) 2000 by Yuanpeng Janet Huang
    email                : yphuang@cabm.rutgers.edu
 ***************************************************************************/

#ifndef JVAL_H
#define JVAL_H

#include <string>
#include <map>

using namespace std;

enum Jvaltype { J3HNHA, 
		J3HAHB2, J3HAHB3, 
		J3NHB2, J3NHB3, 
		J3HAN, 
		J3HNC, J3HNCB, 
		J3CHB2, J3CHB3, J3CCB, J3CCG1, J3CC
};

enum RDJvaltype { RDHNHB, RDHAHB, RJHAHB, RJHNHB };
		
class RDJval {
 private:
  RDJvaltype type;
  string label; 
  float upper;
  float lower;
  int index; 
 public:
  RDJval(){ type = RDHNHB; label = ""; index = 0; upper = 0; lower = 0;};
  ~RDJval(){};
  RDJval(RDJvaltype itype, int iindex, float iupper, float ilower)
    {
      type = itype; index = iindex; upper = iupper; lower = ilower;
    }
  const RDJvaltype& get_type() const { return type;};
  int get_index() const { return index;};
  float get_upper() const { return upper;};
  float get_lower() const { return lower;};
};

class Jval {
 private:
 	int id;
  Jvaltype type;
  string label; 
  float error;
  float value;
  int index; // the index of the first atom
 public:
  Jval(){ id = 0; type = J3HNHA; label = ""; index = 0; value = 0; index = 0;};
  ~Jval(){};

  Jval(int iid, Jvaltype itype, string ilabel, int iindex, float ivalue, float ierror)
    {
      id = iid; type = itype; label = ilabel; index = iindex; value = ivalue; error = ierror;
    }

  const Jvaltype& get_type() const { return type;};
  int get_index() const { return index;};
  float get_upper() const { return value+error;};
  float get_lower() const { return value-error;};
	int get_id() const { return id;};
	float get_value() const { return value; };
	float get_error() const {return error; };
  friend ostream& operator<< (ostream&, const Jval&);
  friend istream& operator>> (istream&, Jval&);
};

typedef multimap<int, Jval, less<int> > JvalList;
typedef multimap<int, RDJval, less<int> > RDJvalList; 

extern JvalList JList;
extern RDJvalList RDJList;

#endif
