#ifndef K3DTREE_H
#define K3DTREE_H


#include <list>

using namespace std;

struct kdnode {
	double x,y,z;  // x or y or z data
	int dir;  // x or y or z direction
        double location; 
	struct kdnode *left, *right;	/* negative/positive side */
};

struct res_node {
	struct kdnode *item;
	double dist_sq;
	struct res_node *next;
};

struct point_node {
   double x,y,z;
   point_node(){}; 
   point_node(double a,double b,double c) {x=a; y=b; z=c;}; 
};

typedef list<point_node> point_list;

class K3Dtree{
 private: 
  kdnode* kd1;  
  kdnode* kdtree (point_node pointList[], int, int);
  int range_search(kdnode*, const double*, double, point_node res[]);
  int linear_search(point_node nodes[], int, const double*, double, point_node res1[]);
 public: 
  int count_all;  // range search return number
  int total_num; //all tree nodes 
  K3Dtree(point_list::const_iterator, point_list::const_iterator, int);
  ~K3Dtree(){};
  void reset_count();
  int getRetCount();
  int getTreeSize();
  point_list call_range_search(point_node&, double);
  point_list call_linear_search(point_list&, point_node&, double);
};

#endif
