/***************************************************************************
                          SmplStat.h  -  description
                             -------------------
    begin                : Mon Aug 21 2000
    copyright            : (C) 2000 by Yuanpeng Janet Huang
    email                : yphuang@cabm.rutgers.edu
 ***************************************************************************/

#ifndef SMPLSTAT_H
#define SMPLSTAT_H

#include <set>
#include <vector>

using namespace std;

typedef vector<double> SmplVect;
typedef multiset<double, less<double> > SmplData; 

class SampleStatistic {
 protected:
  int n;
  double x; // mean
  double x2; // varience * n-1
  double nstdDev; 
  double minValue, maxValue;
  SmplVect mdata;
  SmplData mdataSet;

 public:
    
  SampleStatistic();
  SampleStatistic(double);
  ~SampleStatistic();
  void reset(); 
  
  void operator+=(double);
  int  count() const;
  double mean() const;
  double mean_no_outliner() const;
  double stdDev() const;
  double stdDev_no_outliner() const;
  double var() const;
  double min() const;
  double max() const;
  double median() const;
  double median2() const; 
  
  double confidence(int p_percentage) const;
  double confidence(double p_value) const;
  const SmplData& samples() const;
  const SmplVect& oriSamples() const;
};

#endif
