/***************************************************************************
                          asdp.cpp  -  the interface between rosetta and asdp 

                             -------------------
    begin                : Tue Aug 22 2011
    copyright            : (C) 2011 by Yuanpeng Janet Huang
    email                : yphuang@cabm.rutgers.edu
 ***************************************************************************/
#include <unistd.h>
#include <cstdlib>

#include "asdp.h"
CSIMap indexFilter; // CSI and secondary structure
CSIMap indexCaRaw;
CSIMap indexCbRaw;

string outputDir;
ControlMap control;
Command command;	
string controlFileName = "";
set<int, less<int> > rdcORI;

map<char, string, less<char> > residue_name;
map<char, map<string, string, less<string> >, less<char> > layer_map;
map<string, char, less<string> > symbol3_1;
map<int, string, less<int> > specialName; // not used anymore 

//int faces[1000][1000]; // 1-> same faces, 0-> na. -1->different faces
int faces[1000][1000];
Faces contactFaces;
  
bool DEBUG;
int LLength;
bool hasRDC; 

//seq list
SEQM seq;

//resonance assignment list
//peak list
PeakListDeque peakListDeque;

// used in secondary structure determination
// and hyper dihedral angle constraint generation
JvalList JList;
RDJvalList RDJList;

set<int, less<int> > CISPeptideBond;
set<pair<int,int>, less<pair<int, int> > > SSBond;

void init(); 

Asdp::Asdp()
{
  init(); // initation --- more work, should be remove and move to lib directiory
  DEBUG=1;
  LLength=0;
  hasRDC = 0; 
  outputDir = "rpf.out";
  createOutputDir(outputDir);
}
	
void Asdp::readCFile(string controlFileNameI)
{	
  controlFileName = controlFileNameI; 
  // readin and analysis controlfile 	
  readControlFile(controlFileName, control, peakListDeque, command);
	
  //////////////////////////////////////
  // start NOESY_Assign               //
  //////////////////////////////////////
  // readin input file that listed in the control-file
  na.readInputFile(controlFileName);
  na.runSimpleMatch();
}

float Asdp::runRecall()
{}
float Asdp::runPrecision()
{}
float Asdp::runRPF(Pdb& pdb, int type) const
{
  //if (pdbList.notEmpty())
    {
      erasePrint(cout, " Reading ComparePdbFile from pose ");
      //na.setPdb(pdb);
	tms timeLockS; clock_t startT = times(&timeLockS); 
      float dp =  na.runRPF(pdb, 3);
	tms timeLockE; clock_t endT = times(&timeLockE); 
	runSummary(NOESY_Assign::outputOvwRPF(), startT, endT, timeLockS, timeLockE); 
	return dp;  
//	return 1; 
    }
}


	
