/***************************************************************************
                          faces.h  -  description
                             -------------------
    begin                : Tue May 13 2003
    copyright            : (C) 2003 by Yuanpeng Janet Huang
    email                : yphuang@cabm.rutgers.edu
 ***************************************************************************/

#ifndef FACES_H
#define FACES_H

#include "utility.h"

/**
  *@author Yuanpeng Janet Huang
  */

// side-chain to side-chain contacts (no hn, ha)

// -1, difference faces
// 1, same faces
// 0, donot know
class Faces {
private:
	map<pair<int, int>, int> helixLocalFaces; // local
	map<pair<int, int>, int> sheetLocalFaces; // local
	map<pair<int, int>, int> helixFaces; // plane
	map<pair<int, int>, int > sheetFaces; // plane

	multimap<pair<int, int>, int > ctFaces;
	set<pair<pair<int, int>, pair<string, string> > > ctAtoms;
	
	map<pair<int, int>, int> ctHelixLocalFaces;
	map<pair<int, int>, int> ctSheetLocalFaces;
	map<pair<int, int>, int> ctHelixFaces; // helix plane
	map<pair<int, int>, int> ctSheetFaces; // sheet plane
	
public: 
	Faces();
	~Faces();

	void insertHelix(int, int, int); // only generated once
	void insertHelixLocal(int, int, int);
	void insertSheet(int,int,int); // only generated once
	void insertSheetLocal(int, int, int);
	void resetSS();
	void extendSS();
	
	void insertCTatoms(int, string, int, string);// may change during different cycles
	void insertCT(); 
	void resetCT();
	void combineSSCT();

	int get_ctFace(int, int); // commonly used interface

	// some detail handling
	int get_helixFace(int, int);
	int get_sheetFace(int, int);
	
	int get_ctHelixPlaneFace(int, int);
	int get_ctSheetPlaneFace(int, int);
	int get_ctHelixLocalFace(int,int);
	int get_ctSheetLocalFace(int,int);
};

#endif
