/***************************************************************************
                          init.cpp  -  description
                             -------------------
    begin                : Mon Aug 21 2000
    copyright            : (C) 2000 by Yuanpeng Janet Huang
    email                : yphuang@cabm.rutgers.edu
 ***************************************************************************/

#include <map>
#include <string>

using namespace std;

extern map<char, string, less<char> > residue_name;
extern map<string, char, less<string> > symbol3_1;
extern map<char, map<string, string, less<string> >, less<char> > layer_map;

// will be put into the libaries

void init()
{	
	symbol3_1.insert(pair<const string, char>("ALA", 'A'));
	symbol3_1.insert(pair<const string, char>("CYS", 'C'));
	symbol3_1.insert(pair<const string, char>("ASP", 'D'));
	symbol3_1.insert(pair<const string, char>("GLU", 'E'));
	symbol3_1.insert(pair<const string, char>("PHE", 'F'));
	symbol3_1.insert(pair<const string, char>("GLY", 'G'));
	symbol3_1.insert(pair<const string, char>("HIS", 'H'));
	symbol3_1.insert(pair<const string, char>("ILE", 'I'));
	symbol3_1.insert(pair<const string, char>("LYS", 'K'));
	symbol3_1.insert(pair<const string, char>("LEU", 'L'));
	symbol3_1.insert(pair<const string, char>("MET", 'M'));
	symbol3_1.insert(pair<const string, char>("ASN", 'N'));
	symbol3_1.insert(pair<const string, char>("PRO", 'P'));
	symbol3_1.insert(pair<const string, char>("GLN", 'Q'));
	symbol3_1.insert(pair<const string, char>("ARG", 'R'));
	symbol3_1.insert(pair<const string, char>("SER", 'S'));
	symbol3_1.insert(pair<const string, char>("THR", 'T'));
	symbol3_1.insert(pair<const string, char>("VAL", 'V'));
	symbol3_1.insert(pair<const string, char>("TRP", 'W'));
	symbol3_1.insert(pair<const string, char>("TYR", 'Y'));

	residue_name.insert(pair<const char, string>('A', "ALA"));
	residue_name.insert(pair<const char, string>('C', "CYS"));
	residue_name.insert(pair<const char, string>('D', "ASP"));
	residue_name.insert(pair<const char, string>('E', "GLU"));
	residue_name.insert(pair<const char, string>('F', "PHE"));
	residue_name.insert(pair<const char, string>('G', "GLY"));
	residue_name.insert(pair<const char, string>('H', "HIS"));
	residue_name.insert(pair<const char, string>('I', "ILE"));
	residue_name.insert(pair<const char, string>('K', "LYS"));
	residue_name.insert(pair<const char, string>('L', "LEU"));
	residue_name.insert(pair<const char, string>('M', "MET"));
	residue_name.insert(pair<const char, string>('N', "ASN"));
	residue_name.insert(pair<const char, string>('P', "PRO"));
	residue_name.insert(pair<const char, string>('Q', "GLN"));
	residue_name.insert(pair<const char, string>('R', "ARG"));
	residue_name.insert(pair<const char, string>('S', "SER"));
	residue_name.insert(pair<const char, string>('T', "THR"));
	residue_name.insert(pair<const char, string>('V', "VAL"));
	residue_name.insert(pair<const char, string>('W', "TRP"));
	residue_name.insert(pair<const char, string>('Y', "TYR"));
	
	map<string, string, less<string> > tempMap;

	tempMap.clear();
	tempMap.insert(pair<const string, string>("N", "N"));
	tempMap.insert(pair<const string, string>("H", "N"));
	tempMap.insert(pair<const string, string>("C", "C"));
	tempMap.insert(pair<const string, string>("CA", "A"));
	tempMap.insert(pair<const string, string>("HA", "A"));
	tempMap.insert(pair<const string, string>("CB", "B"));
	tempMap.insert(pair<const string, string>("HB", "B"));
	layer_map.insert(make_pair('A', tempMap));

	tempMap.clear();
	tempMap.insert(pair<const string, string>("N",  "N"));
	tempMap.insert(pair<const string, string>("H",  "N"));
	tempMap.insert(pair<const string, string>("C",  "C"));
	tempMap.insert(pair<const string, string>("CA", "A"));
	tempMap.insert(pair<const string, string>("HA", "A"));
	tempMap.insert(pair<const string, string>("CB", "B"));
	tempMap.insert(pair<const string, string>("HB2","B"));
	tempMap.insert(pair<const string, string>("HB3","B"));
	tempMap.insert(pair<const string, string>("QB", "B"));
	tempMap.insert(pair<const string, string>("SG", "G"));
	tempMap.insert(pair<const string, string>("HG", "G"));
	layer_map.insert(make_pair('C', tempMap));

	tempMap.clear();
	tempMap.insert(pair<const string, string>("N",  "N"));
	tempMap.insert(pair<const string, string>("H",  "N"));
	tempMap.insert(pair<const string, string>("C",  "C"));
	tempMap.insert(pair<const string, string>("CA", "A"));
	tempMap.insert(pair<const string, string>("HA", "A"));
	tempMap.insert(pair<const string, string>("CB", "B"));
	tempMap.insert(pair<const string, string>("HB2","B"));
	tempMap.insert(pair<const string, string>("HB3","B"));
	tempMap.insert(pair<const string, string>("QB", "B"));
	tempMap.insert(pair<const string, string>("CG", "G"));
	tempMap.insert(pair<const string, string>("OD1", "D1"));
	tempMap.insert(pair<const string, string>("OD2", "D2"));
	tempMap.insert(pair<const string, string>("HD2", "D2"));
	layer_map.insert(make_pair('D', tempMap));

	tempMap.clear();
	tempMap.insert(pair<const string, string>("N",  "N"));
	tempMap.insert(pair<const string, string>("H",  "N"));
	tempMap.insert(pair<const string, string>("C",  "C"));
	tempMap.insert(pair<const string, string>("CA", "A"));
	tempMap.insert(pair<const string, string>("HA", "A"));
	tempMap.insert(pair<const string, string>("CB", "B"));
	tempMap.insert(pair<const string, string>("HB2","B"));
	tempMap.insert(pair<const string, string>("HB3","B"));
	tempMap.insert(pair<const string, string>("QB", "B"));
	tempMap.insert(pair<const string, string>("CG", "G"));
	tempMap.insert(pair<const string, string>("HG2","G"));
	tempMap.insert(pair<const string, string>("HG3","G"));
	tempMap.insert(pair<const string, string>("QG", "G"));
	tempMap.insert(pair<const string, string>("CD", "D"));
	tempMap.insert(pair<const string, string>("OE1","E1"));
	tempMap.insert(pair<const string, string>("OE2","E2"));
	tempMap.insert(pair<const string, string>("HE2","E2"));
	layer_map.insert(make_pair('E', tempMap));

	tempMap.clear();
	tempMap.insert(pair<const string, string>("N",  "N"));
	tempMap.insert(pair<const string, string>("H",  "N"));
	tempMap.insert(pair<const string, string>("C",  "C"));
	tempMap.insert(pair<const string, string>("CA", "A"));
	tempMap.insert(pair<const string, string>("HA", "A"));
	tempMap.insert(pair<const string, string>("CB", "B"));
	tempMap.insert(pair<const string, string>("HB2","B"));
	tempMap.insert(pair<const string, string>("HB3","B"));
	tempMap.insert(pair<const string, string>("QB", "B"));
	tempMap.insert(pair<const string, string>("CG", "G"));
	tempMap.insert(pair<const string, string>("CD1","D1"));
	tempMap.insert(pair<const string, string>("HD1","D1"));
	tempMap.insert(pair<const string, string>("CD2","D2"));
	tempMap.insert(pair<const string, string>("HD2","D2"));
	tempMap.insert(pair<const string, string>("QCD","D"));
	tempMap.insert(pair<const string, string>("QD", "D"));
	tempMap.insert(pair<const string, string>("CE1","E1"));
	tempMap.insert(pair<const string, string>("HE1","E1"));
	tempMap.insert(pair<const string, string>("CE2","E2"));
	tempMap.insert(pair<const string, string>("HE2","E2"));
	tempMap.insert(pair<const string, string>("QCE","E"));
	tempMap.insert(pair<const string, string>("QE", "E"));
	tempMap.insert(pair<const string, string>("CZ", "Z"));
	tempMap.insert(pair<const string, string>("HZ", "Z"));
	layer_map.insert(make_pair('F', tempMap));

	tempMap.clear();
	tempMap.insert(pair<const string, string>("N",  "N"));
	tempMap.insert(pair<const string, string>("H",  "N"));
	tempMap.insert(pair<const string, string>("C",  "C"));
	tempMap.insert(pair<const string, string>("CA", "A"));
	tempMap.insert(pair<const string, string>("HA2","A"));
	tempMap.insert(pair<const string, string>("HA3","A"));
	tempMap.insert(pair<const string, string>("QA", "A"));
	layer_map.insert(make_pair('G', tempMap));

	tempMap.clear();
	tempMap.insert(pair<const string, string>("N",  "N"));
	tempMap.insert(pair<const string, string>("H",  "N"));
	tempMap.insert(pair<const string, string>("C",  "C"));
	tempMap.insert(pair<const string, string>("CA", "A"));
	tempMap.insert(pair<const string, string>("HA", "A"));
	tempMap.insert(pair<const string, string>("CB", "B"));
	tempMap.insert(pair<const string, string>("HB2","B"));
	tempMap.insert(pair<const string, string>("HB3","B"));
	tempMap.insert(pair<const string, string>("QB", "B"));
	tempMap.insert(pair<const string, string>("CG", "G"));
	tempMap.insert(pair<const string, string>("ND1","D1"));
	tempMap.insert(pair<const string, string>("HD1","D1"));
	tempMap.insert(pair<const string, string>("CD2","D2"));
	tempMap.insert(pair<const string, string>("HD2","D2"));
	tempMap.insert(pair<const string, string>("CE1","E1"));
	tempMap.insert(pair<const string, string>("HE1","E1"));
	tempMap.insert(pair<const string, string>("NE2","E2"));
	tempMap.insert(pair<const string, string>("HE2","E2"));
	layer_map.insert(make_pair('H', tempMap));

	tempMap.clear();
	tempMap.insert(pair<const string, string>("N",  "N"));
	tempMap.insert(pair<const string, string>("H",  "N"));
	tempMap.insert(pair<const string, string>("C",  "C"));
	tempMap.insert(pair<const string, string>("CA", "A"));
	tempMap.insert(pair<const string, string>("HA", "A"));
	tempMap.insert(pair<const string, string>("CB", "B"));
	tempMap.insert(pair<const string, string>("HB", "B"));
	tempMap.insert(pair<const string, string>("CG2","G2"));
	tempMap.insert(pair<const string, string>("HG2","G2"));
	tempMap.insert(pair<const string, string>("CG1","G1"));
	tempMap.insert(pair<const string, string>("HG12","G1"));
	tempMap.insert(pair<const string, string>("HG13","G1"));
	tempMap.insert(pair<const string, string>("QG1", "G1"));
	tempMap.insert(pair<const string, string>("CD1","D1"));
	tempMap.insert(pair<const string, string>("HD1","D1"));
	layer_map.insert(make_pair('I', tempMap));

	tempMap.clear();
	tempMap.insert(pair<const string, string>("N",  "N"));
	tempMap.insert(pair<const string, string>("H",  "N"));
	tempMap.insert(pair<const string, string>("C",  "C"));
	tempMap.insert(pair<const string, string>("CA", "A"));
	tempMap.insert(pair<const string, string>("HA", "A"));
	tempMap.insert(pair<const string, string>("CB", "B"));
	tempMap.insert(pair<const string, string>("HB2","B"));
	tempMap.insert(pair<const string, string>("HB3","B"));
	tempMap.insert(pair<const string, string>("QB", "B"));
	tempMap.insert(pair<const string, string>("CG", "G"));
	tempMap.insert(pair<const string, string>("HG2","G"));
	tempMap.insert(pair<const string, string>("HG3","G"));
	tempMap.insert(pair<const string, string>("QG", "G"));
	tempMap.insert(pair<const string, string>("CD", "D"));
	tempMap.insert(pair<const string, string>("HD2","D"));
	tempMap.insert(pair<const string, string>("HD3","D"));
	tempMap.insert(pair<const string, string>("QD", "D"));
	tempMap.insert(pair<const string, string>("CE", "E"));
	tempMap.insert(pair<const string, string>("HE2","E"));
	tempMap.insert(pair<const string, string>("HE3","E"));
	tempMap.insert(pair<const string, string>("QE", "E"));
	tempMap.insert(pair<const string, string>("NZ", "Z"));
	tempMap.insert(pair<const string, string>("HZ", "Z"));

	layer_map.insert(make_pair('K', tempMap));
	
	tempMap.clear();
	tempMap.insert(pair<const string, string>("N",  "N"));
	tempMap.insert(pair<const string, string>("H",  "N"));
	tempMap.insert(pair<const string, string>("C",  "C"));
	tempMap.insert(pair<const string, string>("CA", "A"));
	tempMap.insert(pair<const string, string>("HA", "A"));
	tempMap.insert(pair<const string, string>("CB", "B"));
	tempMap.insert(pair<const string, string>("HB2","B"));
	tempMap.insert(pair<const string, string>("HB3","B"));
	tempMap.insert(pair<const string, string>("QB", "B"));
	tempMap.insert(pair<const string, string>("CG", "G"));
	tempMap.insert(pair<const string, string>("HG", "G"));
	tempMap.insert(pair<const string, string>("CD1","D1"));
	tempMap.insert(pair<const string, string>("HD1","D1"));
	tempMap.insert(pair<const string, string>("CD2","D2"));
	tempMap.insert(pair<const string, string>("HD2","D2"));
	tempMap.insert(pair<const string, string>("QCD","D"));
	tempMap.insert(pair<const string, string>("QD", "D"));
	layer_map.insert(make_pair('L', tempMap));

	tempMap.clear();
	tempMap.insert(pair<const string, string>("N",  "N"));
	tempMap.insert(pair<const string, string>("H",  "N"));
	tempMap.insert(pair<const string, string>("C",  "C"));
	tempMap.insert(pair<const string, string>("CA", "A"));
	tempMap.insert(pair<const string, string>("HA", "A"));
	tempMap.insert(pair<const string, string>("CB", "B"));
	tempMap.insert(pair<const string, string>("HB2","B"));
	tempMap.insert(pair<const string, string>("HB3","B"));
	tempMap.insert(pair<const string, string>("QB", "B"));
	tempMap.insert(pair<const string, string>("CG", "G"));
	tempMap.insert(pair<const string, string>("HG2","G"));
	tempMap.insert(pair<const string, string>("HG3","G"));
	tempMap.insert(pair<const string, string>("QG", "G"));
	tempMap.insert(pair<const string, string>("SD", "D"));
	tempMap.insert(pair<const string, string>("CE", "E"));
	tempMap.insert(pair<const string, string>("HE", "E"));
	layer_map.insert(make_pair('M', tempMap));

	tempMap.clear();
	tempMap.insert(pair<const string, string>("N",  "N"));
	tempMap.insert(pair<const string, string>("H",  "N"));
	tempMap.insert(pair<const string, string>("C",  "C"));
	tempMap.insert(pair<const string, string>("CA", "A"));
	tempMap.insert(pair<const string, string>("HA", "A"));
	tempMap.insert(pair<const string, string>("CB", "B"));
	tempMap.insert(pair<const string, string>("HB2","B"));
	tempMap.insert(pair<const string, string>("HB3","B"));
	tempMap.insert(pair<const string, string>("QB", "B"));
	tempMap.insert(pair<const string, string>("CG", "G"));
	tempMap.insert(pair<const string, string>("OD1","D1"));
	tempMap.insert(pair<const string, string>("ND2","D2"));
	tempMap.insert(pair<const string, string>("HD21","D2"));
	tempMap.insert(pair<const string, string>("HD22","D2"));
	tempMap.insert(pair<const string, string>("QD2", "D2"));
	layer_map.insert(make_pair('N', tempMap));

	tempMap.clear();
	tempMap.insert(pair<const string, string>("N",  "N"));
	tempMap.insert(pair<const string, string>("H",  "N"));
	tempMap.insert(pair<const string, string>("C",  "C"));
	tempMap.insert(pair<const string, string>("CA", "A"));
	tempMap.insert(pair<const string, string>("HA", "A"));
	tempMap.insert(pair<const string, string>("CB", "B"));
	tempMap.insert(pair<const string, string>("HB2","B"));
	tempMap.insert(pair<const string, string>("HB3","B"));
	tempMap.insert(pair<const string, string>("QB", "B"));
	tempMap.insert(pair<const string, string>("CG", "G"));
	tempMap.insert(pair<const string, string>("HG2","G"));
	tempMap.insert(pair<const string, string>("HG3","G"));
	tempMap.insert(pair<const string, string>("QG", "G"));
	tempMap.insert(pair<const string, string>("CD", "D"));
	tempMap.insert(pair<const string, string>("HD2","D"));
	tempMap.insert(pair<const string, string>("HD3","D"));
	tempMap.insert(pair<const string, string>("QD", "D"));
	layer_map.insert(make_pair('P', tempMap));

	tempMap.clear();
	tempMap.insert(pair<const string, string>("N",  "N"));
	tempMap.insert(pair<const string, string>("H",  "N"));
	tempMap.insert(pair<const string, string>("C",  "C"));
	tempMap.insert(pair<const string, string>("CA", "A"));
	tempMap.insert(pair<const string, string>("HA", "A"));
	tempMap.insert(pair<const string, string>("CB", "B"));
	tempMap.insert(pair<const string, string>("HB2","B"));
	tempMap.insert(pair<const string, string>("HB3","B"));
	tempMap.insert(pair<const string, string>("QB", "B"));
	tempMap.insert(pair<const string, string>("CG", "G"));
	tempMap.insert(pair<const string, string>("HG2","G"));
	tempMap.insert(pair<const string, string>("HG3","G"));
	tempMap.insert(pair<const string, string>("QG", "G"));
	tempMap.insert(pair<const string, string>("CD", "D"));
	tempMap.insert(pair<const string, string>("OE1","E1"));
	tempMap.insert(pair<const string, string>("NE2","E2"));
	tempMap.insert(pair<const string, string>("HE21","E2"));
	tempMap.insert(pair<const string, string>("HE22","E2"));
	tempMap.insert(pair<const string, string>("QE2", "E2"));
	layer_map.insert(make_pair('Q', tempMap));

	tempMap.clear();
	tempMap.insert(pair<const string, string>("N",  "N"));
	tempMap.insert(pair<const string, string>("H",  "N"));
	tempMap.insert(pair<const string, string>("C",  "C"));
	tempMap.insert(pair<const string, string>("CA", "A"));
	tempMap.insert(pair<const string, string>("HA", "A"));
	tempMap.insert(pair<const string, string>("CB", "B"));
	tempMap.insert(pair<const string, string>("HB2","B"));
	tempMap.insert(pair<const string, string>("HB3","B"));
	tempMap.insert(pair<const string, string>("QB", "B"));
	tempMap.insert(pair<const string, string>("CG", "G"));
	tempMap.insert(pair<const string, string>("HG2","G"));
	tempMap.insert(pair<const string, string>("HG3","G"));
	tempMap.insert(pair<const string, string>("QG", "G"));
	tempMap.insert(pair<const string, string>("CD", "D"));
	tempMap.insert(pair<const string, string>("HD2","D"));
	tempMap.insert(pair<const string, string>("HD3","D"));
	tempMap.insert(pair<const string, string>("QD", "D"));
	tempMap.insert(pair<const string, string>("NE", "E"));
	tempMap.insert(pair<const string, string>("HE", "E"));
	tempMap.insert(pair<const string, string>("CZ", "Z"));
	tempMap.insert(pair<const string, string>("NH1","H1"));
	tempMap.insert(pair<const string, string>("HH11","H1"));
	tempMap.insert(pair<const string, string>("HH12","H1"));
	tempMap.insert(pair<const string, string>("QH1", "H1"));
	tempMap.insert(pair<const string, string>("NH2","H2"));
	tempMap.insert(pair<const string, string>("HH21","H2"));
	tempMap.insert(pair<const string, string>("HH22","H2"));
	tempMap.insert(pair<const string, string>("QH2", "H2"));
	tempMap.insert(pair<const string, string>("QH", "H"));
	tempMap.insert(pair<const string, string>("QNH","H"));
	layer_map.insert(make_pair('R', tempMap));

	tempMap.clear();
	tempMap.insert(pair<const string, string>("N",  "N"));
	tempMap.insert(pair<const string, string>("H",  "N"));
	tempMap.insert(pair<const string, string>("C",  "C"));
	tempMap.insert(pair<const string, string>("CA", "A"));
	tempMap.insert(pair<const string, string>("HA", "A"));
	tempMap.insert(pair<const string, string>("CB", "B"));
	tempMap.insert(pair<const string, string>("HB2","B"));
	tempMap.insert(pair<const string, string>("HB3","B"));
	tempMap.insert(pair<const string, string>("QB", "B"));
	tempMap.insert(pair<const string, string>("OG", "G"));
	tempMap.insert(pair<const string, string>("HG", "G"));
	layer_map.insert(make_pair('S', tempMap));

	tempMap.clear();
	tempMap.insert(pair<const string, string>("N",  "N"));
	tempMap.insert(pair<const string, string>("H",  "N"));
	tempMap.insert(pair<const string, string>("C",  "C"));
	tempMap.insert(pair<const string, string>("CA", "A"));
	tempMap.insert(pair<const string, string>("HA", "A"));
	tempMap.insert(pair<const string, string>("CB", "B"));
	tempMap.insert(pair<const string, string>("HB", "B"));
	tempMap.insert(pair<const string, string>("OG1","G1"));
	tempMap.insert(pair<const string, string>("HG1","G1"));
	tempMap.insert(pair<const string, string>("CG2","G2"));
	tempMap.insert(pair<const string, string>("HG2","G2"));
	layer_map.insert(make_pair('T', tempMap));

	tempMap.clear();
	tempMap.insert(pair<const string, string>("N",  "N"));
	tempMap.insert(pair<const string, string>("H",  "N"));
	tempMap.insert(pair<const string, string>("C",  "C"));
	tempMap.insert(pair<const string, string>("CA", "A"));
	tempMap.insert(pair<const string, string>("HA", "A"));
	tempMap.insert(pair<const string, string>("CB", "B"));
	tempMap.insert(pair<const string, string>("HB", "B"));
	tempMap.insert(pair<const string, string>("CG1","G1"));
	tempMap.insert(pair<const string, string>("HG1","G1"));
	tempMap.insert(pair<const string, string>("CG2","G2"));
	tempMap.insert(pair<const string, string>("HG2","G2"));
	tempMap.insert(pair<const string, string>("QCG","G"));
	tempMap.insert(pair<const string, string>("QG", "G"));
	layer_map.insert(make_pair('V', tempMap));

	tempMap.clear();
	tempMap.insert(pair<const string, string>("N",  "N"));
	tempMap.insert(pair<const string, string>("H",  "N"));
	tempMap.insert(pair<const string, string>("C",  "C"));
	tempMap.insert(pair<const string, string>("CA", "A"));
	tempMap.insert(pair<const string, string>("HA", "A"));
	tempMap.insert(pair<const string, string>("CB", "B"));
	tempMap.insert(pair<const string, string>("HB2","B"));
	tempMap.insert(pair<const string, string>("HB3","B"));
	tempMap.insert(pair<const string, string>("QB", "B"));
	tempMap.insert(pair<const string, string>("CG", "G"));
	tempMap.insert(pair<const string, string>("CD1","D1"));
	tempMap.insert(pair<const string, string>("HD1","D1"));
	tempMap.insert(pair<const string, string>("CD2","D2"));
	tempMap.insert(pair<const string, string>("NE1","E1"));
	tempMap.insert(pair<const string, string>("HE1","E1"));
	tempMap.insert(pair<const string, string>("CE2","E2"));
	tempMap.insert(pair<const string, string>("CE3","E3"));
	tempMap.insert(pair<const string, string>("HE3","E3"));
	tempMap.insert(pair<const string, string>("CZ2","Z2"));
	tempMap.insert(pair<const string, string>("HZ2","Z2"));
	tempMap.insert(pair<const string, string>("CZ3","Z3"));
	tempMap.insert(pair<const string, string>("HZ3","Z3"));
	tempMap.insert(pair<const string, string>("CH2","H2"));
	tempMap.insert(pair<const string, string>("HH2","H2"));
	layer_map.insert(make_pair('W', tempMap));

	tempMap.clear();
	tempMap.insert(pair<const string, string>("N",  "N"));
	tempMap.insert(pair<const string, string>("H",  "N"));
	tempMap.insert(pair<const string, string>("C",  "C"));
	tempMap.insert(pair<const string, string>("CA", "A"));
	tempMap.insert(pair<const string, string>("HA", "A"));
	tempMap.insert(pair<const string, string>("CB", "B"));
	tempMap.insert(pair<const string, string>("HB2","B"));
	tempMap.insert(pair<const string, string>("HB3","B"));
	tempMap.insert(pair<const string, string>("QB", "B"));
	tempMap.insert(pair<const string, string>("CG", "G"));
	tempMap.insert(pair<const string, string>("CD1","D1"));
	tempMap.insert(pair<const string, string>("HD1","D1"));
	tempMap.insert(pair<const string, string>("CD2","D2"));
	tempMap.insert(pair<const string, string>("HD2","D2"));
	tempMap.insert(pair<const string, string>("QCD","D"));
	tempMap.insert(pair<const string, string>("QD", "D"));
	tempMap.insert(pair<const string, string>("CE1","E1"));
	tempMap.insert(pair<const string, string>("HE1","E1"));
	tempMap.insert(pair<const string, string>("CE2","E2"));
	tempMap.insert(pair<const string, string>("HE2","E2"));
	tempMap.insert(pair<const string, string>("QCE","E"));
	tempMap.insert(pair<const string, string>("QE", "E"));
	tempMap.insert(pair<const string, string>("CZ", "Z"));
	tempMap.insert(pair<const string, string>("OH", "H"));
	tempMap.insert(pair<const string, string>("HH", "H"));
	layer_map.insert(make_pair('Y', tempMap));
}

