/***************************************************************************
                          io_xeasy.cpp  -  description
                             -------------------
    begin                : Tue Feb 25 2003
    copyright            : (C) 2003 by Yuanpeng Janet Huang
    email                : yphuang@cabm.rutgers.edu
 ***************************************************************************/

#include <iostream>
#include "atom.h"
#include "AA.h"
#include <iomanip>

void prtXeasyShift(ostream& s, const Atom_List& atoms)
{
	int id=0;
	for(Atom_List::const_iterator i = atoms.begin(); i!= atoms.end(); ++i)
	{
		++id;
		
		string name = i->get_name();
		if (i->get_name() == "H")
		{
			name = "HN";
		}
		
		// GLY
		else if ((i->get_sym_1() == 'G') && (i->get_name() == "HA3"))
		{
			name = "HA1";
		}
		
		// ALA
		else if ((i->get_sym_1() == 'A') && (i->get_name() == "HB"))
		{
			name = "QB";
		}
		// MET
		else if ((i->get_sym_1() == 'M') && (i->get_name() == "HE"))
		{
			name = "QE";
		}
		// THR
		else if ((i->get_sym_1() == 'T') && (i->get_name() == "HG2"))
		{
			name = "QG2";
		}
		
		//VAL
		else if ((i->get_sym_1() == 'V') && (i->get_name() == "HG1"))
		{
			name = "QG1";
		}
		else if ((i->get_sym_1() == 'V') && (i->get_name() == "HG2"))
		{
			name = "QG2";
		}
		else if ((i->get_sym_1() == 'V') && (i->get_name() == "QG"))
		{
			name = "QQG";
		}
		else if ((i->get_sym_1() == 'V') && (i->get_name() == "QCG"))
		{
			name = "CG1";
		}
		//LEU
		else if ((i->get_sym_1() == 'L') && (i->get_name() == "HD1"))
		{
			name = "QD1";
		}
		else if ((i->get_sym_1() == 'L') && (i->get_name() == "HD2"))
		{
			name = "QD2";
		}
		else if ((i->get_sym_1() == 'L') && (i->get_name() == "QD"))
		{
			name = "QQD";
		}
		else if ((i->get_sym_1() == 'L') && (i->get_name() == "QCD"))
		{
			name = "CD1";
		}
		//ILE
		else if ((i->get_sym_1() == 'I') && (i->get_name() == "HD1"))
		{
			name = "QD1";
		}
		else if ((i->get_sym_1() == 'I') && (i->get_name() == "HG2"))
		{
			name = "QG2";
		}
		
		// PHE/TYR
		else if (((i->get_sym_1() == 'F') || (i->get_sym_1() == 'Y')) && (i->get_name() == "QCE"))
		{
			name = "CE1";
		}
		else if (((i->get_sym_1() == 'F') || (i->get_sym_1() == 'Y')) && (i->get_name() == "QCD"))
		{
			name = "CD1";
		}
		
		s << id << " " << setw(7) << i->get_shift() << "   " << "0.000  " << name << " " << i->get_index() << endl;
	}
}

