/***************************************************************************
                          nc4noesy_hsqc.h  -  description
                             -------------------
    begin                : Mon Mar 3 2003
    copyright            : (C) 2003 by Yuanpeng Janet Huang
    email                : yphuang@cabm.rutgers.edu
 ***************************************************************************/

#ifndef NC4NOESY_HSQC_H
#define NC4NOESY_HSQC_H

#include "D3NOESY.h"
#include "D4NOESY.h"

/**
  *@author Yuanpeng Janet Huang
  */

class NC3NOESY_HSQC : public D3NOESY  {
public: 
	NC3NOESY_HSQC();
	~NC3NOESY_HSQC();

	NC3NOESY_HSQC(bool, bool, float, float, float, float, string);

	bool isPossMother(const atom*, pair<float, float>) const;
	bool isPossFather(const atom*, pair<float, float>) const;
	bool canbeMom(const atom*) const;
	bool canbeDad(const atom*) const;

	virtual void Find_UniqueAH(int, int, method);
	virtual void Find_UniqueBH(int, int, method);

	const string Type() const;
};

class NC4NOESY_HSQC : public D4NOESY  {
public: 
	NC4NOESY_HSQC();
	~NC4NOESY_HSQC();

	NC4NOESY_HSQC(bool, bool, float, float, float, float, float, string);

	bool isPossMother(const atom*, pair<float, float>) const;
	bool isPossFather(const atom*, pair<float, float>) const;
	bool canbeMom(const atom*) const;
	bool canbeDad(const atom*) const;

	virtual void Find_UniqueHH(int, int, method){};
	virtual void Find_UniqueAH(int, int, method){};
	virtual void Find_UniqueBH(int, int, method){};

	virtual void Assign_MLoc(const Locref&){};

	const string Type() const;
};

class CN4NOESY_HSQC : public D4NOESY  {
public:
	CN4NOESY_HSQC();
	~CN4NOESY_HSQC();

	CN4NOESY_HSQC(bool, bool, float, float, float, float, float, string);

	bool isPossMother(const atom*, pair<float, float>) const;
	bool isPossFather(const atom*, pair<float, float>) const;
	bool canbeMom(const atom*) const;
	bool canbeDad(const atom*) const;

	virtual void Find_UniqueHH(int, int, method){};
	virtual void Find_UniqueAH(int, int, method){};
	virtual void Find_UniqueBH(int, int, method){};

	virtual void Assign_MLoc(const Locref&){};

	const string Type() const;
};

#endif
