/***************************************************************************
                          nn4noesy_hsqc.cpp  -  description
                             -------------------
    begin                : Mon Mar 3 2003
    copyright            : (C) 2003 by Yuanpeng Janet Huang
    email                : yphuang@cabm.rutgers.edu
 ***************************************************************************/

#include "nn4noesy_hsqc.h"

NN4NOESY_HSQC::NN4NOESY_HSQC(){
}
NN4NOESY_HSQC::~NN4NOESY_HSQC(){
}

NN4NOESY_HSQC::NN4NOESY_HSQC(bool flag, bool haveIC, float hx1t, float x1t, float hx2t, float x2t, float f, string label)
	:D4NOESY(flag, haveIC, hx1t, x1t, hx2t, x2t, f, label)
{
}

const string NN4NOESY_HSQC::Type() const
{
  return "4DNN";
}

bool NN4NOESY_HSQC::canbeMom(const atom* atom1) const
{
	if (atom1->isatt_N())
		return 1;
	return 0;
}

bool NN4NOESY_HSQC::canbeDad(const atom* atom1) const
{
	if (atom1->isatt_N())
		return 1;
	return 0;
}

bool NN4NOESY_HSQC::isPossFather(const atom* temp1, pair<float, float> bound) const
{
	if (temp1->isatt_N() && (((temp1->att_N()->get_shift()) <= bound.second) && ((temp1->att_N()->get_shift()) >= bound.first)))
		return 1;
	return 0;
}

bool NN4NOESY_HSQC::isPossMother(const atom* temp1, pair<float, float> bound) const
{
	if (temp1->isatt_N() && (((temp1->att_N()->get_shift()) <= bound.second) && ((temp1->att_N()->get_shift()) >= bound.first)))
		return 1;
	return 0;
}
