/***************************************************************************
                          par.cpp  -  description
                             -------------------
    begin                : Tue Nov 20 2001
    copyright            : (C) 2001 by Yuanpeng Janet Huang
    email                : yphuang@cabm.rutgers.edu
 ***************************************************************************/

#include <fstream>
#include <sstream>
#include <string>

#include "par.h"

Par::Par()
{
	pdb.type = 1;
	initp.type = 0;
}
istream& operator>>(istream& s, Par& parR)
{
	string inputLine; char delim = '\n';
  while (getline(s, inputLine, delim))
  {
  	if (inputLine.find("#") < inputLine.length())
	  	inputLine = inputLine.substr(0, inputLine.find("#"));
	
    //remove the leading white space and ending white space
    if (inputLine.find_first_not_of(" \t\n\v") < inputLine.length())
      inputLine = inputLine.substr(inputLine.find_first_not_of(" \t\n\v"),
  				        inputLine.length() - inputLine.find_first_not_of(" \t\n\v"));
    if (inputLine.find_last_not_of(" \t\n\v") < inputLine.length())
      inputLine = inputLine.substr(0, inputLine.find_last_not_of(" \t\n\v")+1);

    istringstream j(inputLine.c_str());
    string token; j >> token;
  	    	
  		if (token == "EXPECT")
  			j >> parR.expect.htol >> parR.expect.xtol;
  	 	else if (token == "CF")
  			j >> parR.cf.freq >> parR.cf.htol >> parR.cf.xtol;
  		else if (token == "SYM")
  			j >> parR.sym.hsym >> parR.sym.xsym >> parR.sym.htol >> parR.sym.xtol >> parR.sym.smallCutoff >> parR.sym.largeCutoff;
  		else if (token == "RING")
  			j >> parR.ring.htol >> parR.ring.xtol >> parR.ring.meanCutoff >> parR.ring.meanCutoff2;
  		else if (token =="UNIQUE")
  			j >> parR.unique.htol >> parR.unique.xtol;
  		else if (token =="AMBI")
  			j >> parR.ambi.htol >> parR.ambi.xtol;
  		else if (token == "PDB")
  			j >> parR.pdb.meanCutoff >> parR.pdb.nextOff >> parR.pdb.nextCutoff >> parR.pdb.nextOff2
  				>> parR.pdb.meanCutoff2 >> parR.pdb.meanCutoff3 >> parR.pdb.std >> parR.pdb.htol >> parR.pdb.xtol;
  		else if (token == "INITF")
  			j >> parR.initp.meanCutoff >> parR.initp.nextOff >> parR.initp.nextCutoff >> parR.initp.nextOff2
  				>> parR.initp.meanCutoff2 >> parR.initp.meanCutoff3 >> parR.initp.std >> parR.initp.htol >> parR.initp.xtol;
  		else if (token == "VIO")
  			j >> parR.vio.wCutoff >> parR.vio.wPerc >> parR.vio.sCutoff >> parR.vio.sPerc
  				>> parR.vio.gOne >> parR.vio.hV;
  		else if (token == "LOCREF")
  			j >> parR.locref.htol >> parR.locref.xtol >> parR.locref.htol2 >> parR.locref.xtol2;
  		else if (token == "SEC")
  			j >> parR.sec.ap >> parR.sec.p >> parR.sec.jH >> parR.sec.jS >> parR.sec.htol >> parR.sec.xtol;
  		else if (token =="HBOND")
  			j >> parR.hbond.lowerOH >> parR.hbond.lowerON >> parR.hbond.upperOH >> parR.hbond.upperON;

	}
	
	return s;
}

ostream& operator<<(ostream& s, const Par& parR)
{
	s << "EXPECT:" << parR.expect.htol << " " << parR.expect.xtol << endl;
	s << "CF:    " << parR.cf.freq << " " << parR.cf.htol << " " << parR.cf.xtol << endl;
	s << "SYM:   " << parR.sym.hsym << " " << parR.sym.htol << " " << parR.sym.xtol << endl;
	s << "RING:   " << parR.ring.htol << " " << parR.ring.xtol << endl;
	s << "UNIQUE:" << parR.unique.htol << " " <<  parR.unique.xtol << endl;
	s << "AMBI:  " << parR.ambi.htol << " " <<  parR.ambi.xtol << endl;
	s << "PDB:   " << parR.pdb.meanCutoff << " " <<  parR.pdb.nextOff << " " <<  parR.pdb.nextCutoff << " " <<  parR.pdb.nextOff2
  				<< " " <<  parR.pdb.meanCutoff2 << " " <<  parR.pdb.meanCutoff3 << " " <<  parR.pdb.std << " " <<  parR.pdb.htol << " " <<  parR.pdb.xtol << endl;
	s << "INITF:   " << parR.initp.meanCutoff << " " <<  parR.initp.nextOff << " " <<  parR.initp.nextCutoff << " " <<  parR.initp.nextOff2
  				<< " " <<  parR.initp.meanCutoff2 << " " <<  parR.initp.meanCutoff3 << " " <<  parR.initp.std << " " <<  parR.initp.htol << " " <<  parR.initp.xtol << endl;
  s << "VIO:   " << parR.vio.wCutoff << " " <<  parR.vio.wPerc << " " <<  parR.vio.sCutoff << " " <<  parR.vio.sPerc
  				<< " " <<  parR.vio.gOne << " " <<  parR.vio.hV << endl;
  s << "LOCREF:" << parR.locref.htol << " " <<  parR.locref.xtol << " " <<  parR.locref.htol2 << " " <<  parR.locref.xtol2 << endl;
  s << "SEC:   " << parR.sec.ap << " " <<  parR.sec.p << " " <<  parR.sec.jH << " " <<  parR.sec.jS << " " << parR.sec.htol << " " << parR.sec.xtol << endl;
  s << "HBOND: " << parR.hbond.lowerOH << " " <<  parR.hbond.lowerON << " " <<  parR.hbond.upperOH << " " <<  parR.hbond.upperON << endl;

	return s;
}

