/***************************************************************************
                          par.h  -  description
                             -------------------
    begin                : Fri Nov 9 2001
    copyright            : (C) 2001 by Yuanpeng Janet Huang
    email                : yphuang@cabm.rutgers.edu
 ***************************************************************************/

#ifndef PAR_H
#define PAR_H

#include <iostream>
using namespace std;

struct Expect { float htol; float xtol;};
struct Cf {int freq; float htol; float xtol;};
struct Sym {float hsym; float xsym; float htol; float xtol; float largeCutoff; float smallCutoff;};
struct Ring {float htol; float xtol; float meanCutoff; float meanCutoff2;};
struct Ambi{float htol; float xtol;};
struct PdbP {int type; float meanCutoff; float nextOff; float nextCutoff; float nextOff2;
						float meanCutoff2; float meanCutoff3; float std; float htol; float xtol;};
struct Vio {float wCutoff; float wPerc; float sCutoff; float sPerc; bool gOne; bool hV;};
struct Locref {float htol; float xtol; float htol2; float xtol2; float htol3; float xtol3;};
struct Sec {float ap; float p; int jH; int jS; float htol; float xtol;};
struct Hbond {float lowerOH; float lowerON; float upperOH; float upperON;};

class Par {
public:
	Expect expect;
	Cf cf;
	Sym sym;
	Ambi unique;
	Ambi ambi;
	PdbP pdb;
	PdbP initp;
	Vio vio;
	Locref locref;
	Sec sec;
	Hbond hbond;
	Ring ring;
	Par();
	~Par() {};

	friend istream& operator>>(istream&, Par&);
	friend ostream& operator<<(ostream&, const Par&);
};

#endif

