/***************************************************************************
                          peaklist.cpp  -  description
                             -------------------
    begin                : Mon Aug 21 2000
    copyright            : (C) 2000 by Yuanpeng Janet Huang
    email                : yphuang@cabm.rutgers.edu
 ***************************************************************************/

#include <iostream>
#include <sstream>
#include <iomanip>
#include "peaklist.h"

extern bool DEBUG;

/************************
general_peak
************************/
general_peak::general_peak() 
{
	D = 0;
	peak_ID    = 0; 
	Label = (char)0;
	Intensity = 0;

	HX1 = 0; X1 = 0;
	HX2 = 0; X2 = 0; 
}

general_peak::general_peak(int in_D) 
{
	D = in_D;
	peak_ID    = 0; 
	Label = (char)0;
	Intensity = 0;

	HX1 = 0; X1 = 0;
	HX2 = 0; X2 = 0; 
}

general_peak::general_peak(int in_ID, string in_Label, float in_Intensity) 
{
	D = 0;
	peak_ID = in_ID;
	Label = in_Label;
	Intensity = in_Intensity; 
}

general_peak::general_peak(int in_ID, string in_Label, float in_Intensity, float in_HX1, float in_HX2) 
{
	D = 2; 
	peak_ID = in_ID;
	Label = in_Label;
	Intensity = in_Intensity; 

	HX1 = in_HX1; 
	HX2 = in_HX2;
}
general_peak::general_peak(int in_ID, string in_Label, float in_Intensity, float in_HX1, float in_X1, float in_HX2) 
{
	D = 3; 
	peak_ID = in_ID;
	Label = in_Label;
	Intensity = in_Intensity; 

	HX1 = in_HX1; X1 = in_X1; 
	HX2 = in_HX2;
}
general_peak::general_peak(int in_ID, string in_Label, float in_Intensity, float in_HX1, float in_X1, float in_HX2, float in_X2) 
{
	D = 4; 
	peak_ID = in_ID;
	Label = in_Label;
	Intensity = in_Intensity; 

	HX1 = in_HX1; X1 = in_X1; 
	HX2 = in_HX2; X2 = in_X2;
}

void general_peak::assign_gen(int in_ID, string in_Label, float in_Intensity) 
{
	D = 0;
	peak_ID = in_ID; 
	Label = in_Label;
	Intensity = in_Intensity; 
}

void general_peak::assign_gen(int in_ID, string in_Label, float in_Intensity, float in_HX1, float in_HX2) 
{
	D = 2; 
	peak_ID = in_ID;
	Label = in_Label;
	Intensity = in_Intensity; 

	HX1 = in_HX1; X1 = 0; 
	HX2 = in_HX2; X2 = 0;
}
void general_peak::assign_gen(int in_ID, string in_Label, float in_Intensity, float in_HX1, float in_X1, float in_HX2) 
{
	D = 3; 
	peak_ID = in_ID;
	Label = in_Label;
	Intensity = in_Intensity; 

	HX1 = in_HX1; X1 = in_X1; 
	HX2 = in_HX2; X2 = 0;
}
void general_peak::assign_gen(int in_ID, string in_Label, float in_Intensity, float in_HX1, float in_X1, float in_HX2, float in_X2) 
{
	D = 4; 
	peak_ID = in_ID;
	Label = in_Label;
	Intensity = in_Intensity; 

	HX1 = in_HX1; X1 = in_X1; 
	HX2 = in_HX2; X2 = in_X2;
}

void general_peak::setSWSF(float HX1, float HX2)
{
  fSWSF_HX1 = HX1;
  fSWSF_HX2 = HX2;
  fSWSF_X1 = 1000;
  fSWSF_X2 = 1000;
}

void general_peak::setSWSF(float HX1, float X1, float HX2)
{
  fSWSF_HX1 = HX1;
  fSWSF_HX2 = HX2;
  fSWSF_X1  = X1;
  fSWSF_X2 = 1000;
}

void general_peak::setSWSF(float HX1, float X1, float HX2, float X2)
{
  fSWSF_HX1 = HX1;
  fSWSF_HX2 = HX2;
  fSWSF_X1  = X1;
  fSWSF_X2  = X2; 
}

float general_peak::SWSF_HX1() const
{
	return fSWSF_HX1; 
}
float general_peak::SWSF_HX2() const
{
	return fSWSF_HX2; 
}
float general_peak::SWSF_X1() const
{
	return fSWSF_X1; 
}
float general_peak::SWSF_X2() const
{
	return fSWSF_X2; 
}

float operator+(float a1, general_peak& a2)
{

	return a1+a2.Intensity; 
}

void general_peak::adjast_assign(float in_Xppm, float in_Yppm)
{
	HX1 += in_Xppm;
	HX2 += in_Yppm;
}

void general_peak::adjast_assign(float in_HXppm, float in_Hppm, float in_Xppm)
{
	HX1  += in_HXppm;
	HX2  += in_Hppm;
	X1   += in_Xppm; 
}

void general_peak::adjast_assign(float in_HX1ppm, float in_HX2ppm, float in_X1ppm, float in_X2ppm)
{
	HX1  += in_HX1ppm;
	HX2  += in_HX2ppm;
	X1   += in_X1ppm; 
	X2   += in_X2ppm;
}

float general_peak::get_HX1() const
{ return HX1; }
float general_peak::get_X1() const
{ if (D > 2) 
	return X1; 
  else return NOTEXIST;
}
float general_peak::get_X2() const
{ if (D > 3)
	return X2;
  else return NOTEXIST;
}

float general_peak::get_HX2() const
{ return HX2; }

string general_peak::print_header() const
{
	if (D == 2) return "Peak_ID\tLabel\tH1\tH2\tIntensity";
	else if (D == 3) return "Peak_ID\tLabel\tHX\tH\tX\tIntensity";
	else if (D == 4) return "Peak_ID\tLabel\tHX1\tHX2\tX1\tX2Intensity";
	else return ""; 	
}

/***************************
D2_peak 
***************************/
D2_peak::D2_peak() : general_peak(2) 
{
}

D2_peak::D2_peak(int in_ID, string in_Label, float in_Xppm, 
	float in_Yppm, float in_Intensity) : general_peak(in_ID, in_Label, in_Intensity, in_Xppm, in_Yppm)
{
}

void D2_peak::assign(int in_ID, string in_Label, float in_Xppm, 
	float in_Yppm, float in_Intensity)
{
	assign_gen(in_ID, in_Label, in_Intensity, in_Xppm, in_Yppm); // general_peak's member function
}


/*******************************
D3_peak
*******************************/
D3_peak::D3_peak() : general_peak(3) 
{
}

D3_peak::D3_peak(int in_ID, string in_Label, float in_Xppm, 
	float in_Yppm, float in_Zppm, float in_Intensity) : general_peak(in_ID, in_Label, in_Intensity, in_Xppm, in_Zppm, in_Yppm)
{
}

void D3_peak::assign(int in_ID,string in_Label, float in_Xppm, 
	float in_Yppm, float in_Zppm, float in_Intensity)
{
	assign_gen(in_ID,in_Label, in_Intensity, in_Xppm, in_Zppm, in_Yppm); // general_peak's member function 
}


/*******************************
D4_peak
*******************************/
D4_peak::D4_peak() : general_peak(4) 
{
}

D4_peak::D4_peak(int in_ID, string in_Label, float in_Xppm, 
	float in_Yppm, float in_Zppm, float in_Uppm, float in_Intensity) : general_peak(in_ID, in_Label, in_Intensity, in_Xppm, in_Zppm, in_Yppm, in_Uppm)
{
}

void D4_peak::assign(int in_ID,string in_Label, float in_Xppm, 
	float in_Yppm, float in_Zppm, float in_Uppm, float in_Intensity)
{
	assign_gen(in_ID,in_Label, in_Intensity, in_Xppm, in_Zppm, in_Yppm, in_Uppm); // general_peak's member function 
}

/**************************************
input/ouput of the peak of different types
operator<<
operator>>
***************************************/

/*************************
output the peak and peaklist's content
*************************/
ostream& operator<<(ostream& s, const general_peak& peak)
{
  s.setf(ios::right, ios::adjustfield);
  s << "peak: " 
	<< setw(5) 
	<< peak.peak_ID 
//	<< peak.get_ID()
	<< " ";
  s.setf(ios::left, ios::adjustfield);
  s << "(hx1)" 
	<< setw(5) 
	<< peak.HX1 << " ";
	//<< peak.get_HX1() << " ";
  s << "(hx2)" 
	<< setw(5) 
	<< peak.HX2;
	//<< peak.get_HX2() << " ";

	if ((peak.D == 3) || (peak.D == 4))
	{
	  s << " (x1)" << setw(5) << peak.X1;
	 //s << " (x1)" << setw(5) << peak.get_X1(); 
	}
	
	if (peak.D == 4)
	{
	  s << " (x2)" << setw(5) << peak.X2 << " ";
	  //s << " (x2)" << setw(5) << peak.get_X2() << " ";
	}
  s.setf(ios::right, ios::adjustfield);
	//s << "  " << peak.get_Intensity() << " " << "(label)" << peak.get_Label() << " "; // << peak.Type();
	s << "  " << peak.Intensity << " " << "(label)" << peak.Label << " "; // << peak.Type();
	return s;
}

ostream& operator<<(ostream& s, const general_peak* peak)
{
  s << (*peak);
	return s;
}

