/***************************************************************************
                          peaklist.h  -  description
                             -------------------
    begin                : Mon Aug 21 2000
    copyright            : (C) 2000 by Yuanpeng Janet Huang
    email                : yphuang@cabm.rutgers.edu
 ***************************************************************************/

#ifndef PEAKLIST_H
#define PEAKLIST_H

#include <string>
using namespace std;

/*******
general_peak will have the common attribution of the 
different experiments's peak
********/
const int NOTEXIST = 999;

class general_peak {
protected: 
	int D; 
	int peak_ID; 
  string Label;             // user's label, may be modified by the user
  float  Intensity;

	float HX1; 
	float X1; 
	float HX2; 
	float X2; 

	float fSWSF_X1;
	float fSWSF_X2;
	float fSWSF_HX1;
	float fSWSF_HX2;

public:
	// initalizition 
  general_peak(); // all equal 0
	virtual ~general_peak(){};

	general_peak(int); // D
  general_peak(int, string, float);   // peak_ID, Label, Intensity
	general_peak(int, string, float, float, float); // peak_ID, Label, Intensity, HX1, HX2; 
	general_peak(int, string, float, float, float, float); // peak_ID, Label, Intensity, 
							// HX1, X1, HX2
	general_peak(int, string, float, float, float, float, float); // peak_ID, Label, Intensity,
							// HX1, X1, HX2, X2

	void assign_gen(int, string, float);     // peak_ID, Label, Intensity 
	void assign_gen(int, string, float, float, float); // peak_ID, Label, Intensity, HX1, HX2; 
	void assign_gen(int, string, float, float, float, float); // peak_ID, Label, Intensity, 
							// HX1, X1, HX2
	void assign_gen(int, string, float, float, float, float, float); // peak_ID, Label, Intensity,
							// HX1, X1, HX2, X2

	void adjast_assign(float, float); 
	void adjast_assign(float, float, float);
	void adjast_assign(float, float, float, float);

	friend float operator+(float, general_peak&); // addition of intensity

	// access the private members 
	int    get_D()  const       { return D; };
	int    get_ID() const       { return peak_ID; };
  const string& get_Label()  const   { return Label;   };
  float  get_Intensity() const { return Intensity; };
  virtual string Type() const {return "";};
	float get_HX1() const; float get_X1() const;
	float get_HX2()const; float get_X2() const; 	
	string print_header() const;

	friend ostream& operator<< (ostream&, const general_peak&);
	friend ostream& operator<< (ostream&, const general_peak*);
	friend istream& operator>> (istream&, general_peak&); 
	
	void setSWSF(float, float);
  	void setSWSF(float, float, float);
	void setSWSF(float, float, float, float);
	
	float SWSF_HX1() const;
	float SWSF_HX2() const; 
	float SWSF_X1() const; 
	float SWSF_X2() const;
}; 

/********
Two Dimension NOESY's peak
********/
class D2_peak : public general_peak {
public: 
	D2_peak();
	virtual ~D2_peak(){};
        D2_peak(int, string, float, float, float); // peak_ID, label, internsity, H1, H2
	void assign(int, string, float, float, float);
	
};

/*********
Three Dimension NOESY's peak
*********/
class D3_peak : public general_peak {
public:
	D3_peak();
	virtual ~D3_peak(){};
	D3_peak(int, string, float, float, float, float); // peak_ID,label, HX, X, H, internsity
	
	void assign(int, string, float, float, float, float);
};

/*********
Four Dimension NOESY's peak
*********/
class D4_peak : public general_peak {
public:
	D4_peak();
	virtual ~D4_peak(){};
	D4_peak(int, string, float, float, float, float, float); 
	
	void assign(int, string, float, float, float, float, float);
};

#endif
