/***************************************************************************
                          qscore.cpp  -  description
                             -------------------
    begin                : Fri Aug 1 2003
    copyright            : (C) 2003 by Yuanpeng Janet Huang
    email                : yphuang@cabm.rutgers.edu
 ***************************************************************************/

#include <iostream>
#include <cmath>
#include "qscore.h"

float Ffactor(ASDP::ratio& FN, ASDP::ratio& FP, float weight)
{
	float FNratio = FN.first*weight/(float)FN.second;
	float FPratio = FP.first/(float)FP.second;

	return floor(1000*2*(1-FNratio)*(1-FPratio)/(2-FNratio-FPratio) + 0.5000001)/(float)1000;
}

void Qscore::reset()
{
	FN.first = 0;
	FN.second = 0;
	FP.first = 0;
	FP.second = 0;
	FNR.first = 0;
	FNR.second = 0;
	FPR.first = 0;
	FPR.second = 0;
	FPI.first = 0;
	FPI.second = 0;
	FPL.first = 0;
	FPL.second = 0;
}

void Qscore::operator+= (const Qscore& a)
{
	FN.first += a.FN.first;
	FN.second += a.FN.second;
	FP.first += a.FP.first;
	FP.second += a.FP.second;

	FNR.first += a.FNR.first;
	FNR.second += a.FNR.second;
	FPR.first += a.FPR.first;
	FPR.second += a.FPR.second;
	
	FNI.first += a.FNI.first;
	FNI.second += a.FNI.second;
	FPI.first += a.FPI.first;
	FPI.second += a.FPI.second;

	FNL.first += a.FNL.first;
	FNL.second += a.FNL.second;
	FPL.first += a.FPL.first;
	FPL.second += a.FPL.second;
}
