/***************************************************************************
                          qscore.h  -  description
                             -------------------
    begin                : Fri Aug 1 2003
    copyright            : (C) 2003 by Yuanpeng Janet Huang
    email                : yphuang@cabm.rutgers.edu
 ***************************************************************************/

#ifndef QSCORE_H
#define QSCORE_H

using namespace std; 

//#include <stl.h>
namespace ASDP
{
typedef pair<float, float> ratio;
}

using namespace ASDP;

struct Qscore
{
  ASDP::ratio FN; // for query structure
  ASDP::ratio FP; 
  ASDP::ratio FNR; // for freely rotating chain 
  ASDP::ratio FPR;
  ASDP::ratio FNI; // for ideal structure
  ASDP::ratio FPI;
  ASDP::ratio FNL; // for low quality structure, with no long range NOEs
  ASDP::ratio FPL; // for low quality structure, with no long range NOEs
	
	Qscore(){reset();};
	~Qscore(){};
	void reset();
	void operator+=(const Qscore& y);
};

float Ffactor(ASDP::ratio&, ASDP::ratio&, float);
#endif
