/***************************************************************************
                          ss.cpp  -  description
                             -------------------
    begin                : Mon Aug 21 2000
    copyright            : (C) 2000 by Yuanpeng Janet Huang
    email                : yphuang@cabm.rutgers.edu
 ***************************************************************************/
#include "stdlib.h"
#include "ss.h"

extern bool DEBUG;

Structure::Structure()
{
	ID        = ""; 
	strand_ID = 0; 
	type      = 0;  
}

Structure::Structure(bool temp, string id)
{
	type = temp;
	ID   = id; 
}

void Structure::addinChain(int ID)
{
	chain.insert(ID); 
}

const string& Structure::get_ID() const
{
	return ID;
}

//deque<int>& Structure::get_chain()
const Chain& Structure::get_chain() const
{
	return chain;
}

int Structure::get_type() const
{
	return type;
} 

ostream& operator<<(ostream& s, const Structure& structure)
{
  switch (structure.type)
  {
    case 1:
      s << "Helix ";
      break;
    case -1:
      s << "Sheet ";
      break;
    case 0:
      s << "Coil  ";
      break;
    default:
      break;
  }
	
  s << (*structure.chain.begin()) << "-";
  s << (*structure.chain.rbegin());
	return s;
}

istream& operator>>(istream& s, Structure& structure)
{
	string name;
	s >> name;
	if (name == "SHEET")
	{
		structure.type = -1;
	} else if (name == "HELIX")
	{
		structure.type = 1;
	} else if (name == "COIL")
	{
		structure.type = 0;
	} else
	  return s;

	string num, id;
	s >> num >> id;
	structure.ID = num + id;
	structure.strand_ID = atoi(num.c_str());
	structure.chain.clear();
	int begin, end;
	s >> begin >> end;
	for(int i = begin; i <= end; i++)
		structure.chain.insert(i);
	return s;
}		

ostream& operator<<(ostream& s, const pair<const string, Structure>& temp)
{
	s << "Strand ID=" << temp.first << "\t" << temp.second;
	return s;
}






