/***************************************************************************
                          ss.h  -  secondary structure
                             -------------------
    begin                : Mon Aug 21 2000
    copyright            : (C) 2000 by Yuanpeng Janet Huang
    email                : yphuang@cabm.rutgers.edu
 ***************************************************************************/

#ifndef STRUCTURE_H
#define STRUCTURE_H

#include <string>
#include <set>
#include <map>
#include <iostream>
using namespace std;

typedef set<int, less<int> > Chain;



class Structure 
{
private:
	int   type; // 0 --- coil, 1 --- helix, -1 --- sheet 
	string ID; // num + id
	int   strand_ID; // num
	Chain chain; 
public:
	Structure();
	~Structure(){}; 
	Structure(bool, string); 
	void addinChain(int); // seqID
	
	friend ostream& operator<<(ostream& s, const Structure&);
	friend istream& operator>>(istream& s, Structure&);
	
	void set_type(int T) { type = T;};
	void set_strand_ID(int I) { strand_ID = I; };
	void erase() { type = 0; strand_ID = 0; chain.clear();};
	int get_type() const;
	const string& get_ID() const;
	int get_strand_ID() const { return strand_ID;}
	const Chain& get_chain() const;
};

typedef map<string, Structure, less<string> > SS;

#endif
