/***************************************************************************
                          support.cpp  -  description
                             -------------------
    begin                : Tue Mar 4 2003
    copyright            : (C) 2003 by Yuanpeng Janet Huang
    email                : yphuang@cabm.rutgers.edu
 ***************************************************************************/

#include "experiment.h"

SUPPORT::SUPPORT(){
	clear();
}
SUPPORT::~SUPPORT(){
}

void SUPPORT::clear()
{
	mdSetM.clear();
	mdPAMapM.clear();
	ContactBin.clear();
	MomDadBin.clear();
	ContactBinUniqueSYM.clear();
}

void SUPPORT::insert(const SUPPORT& addsp)
{
 	// adding support
  for(MomDadPeakAtomMap::const_iterator pmdi = addsp.mdPAMapM.begin(); pmdi != addsp.mdPAMapM.end(); ++pmdi)
  {
 		int i = pmdi->first.first->get_index();
 		int j = pmdi->first.second->get_index();
 		pair<int, int> ij;
 		if (i<j) ij = make_pair(i,j);
 		else ij = make_pair(j,i);

	  	MomDadPeakAtomMap::const_iterator pmdi2;
 		MomDadPeakAtomMap::const_iterator pmdl2 = mdPAMapM.lower_bound(pmdi->first);
 		MomDadPeakAtomMap::const_iterator pmdu2 = mdPAMapM.upper_bound(pmdi->first);
 		for(pmdi2 = pmdl2; pmdi2 != pmdu2; ++pmdi2)
 		{
 			if ((pmdi2->second.first == pmdi->second.first) && (pmdi2->second.second == pmdi->second.second))
 				break;
 		}

  	if (pmdi2 == pmdu2) // no such peak-momdad entry in the list
  	{
  		if (pmdl2 == pmdu2) // no such momdad entry
  		{
  			MomDadBin.insert(make_pair(ij, pmdi->first));
  			ContactBin.insert(ij);
  			mdSetM.insert(pmdi->first);
  		}
  		mdPAMapM.insert(make_pair(MomDadBin.find(ij)->second, pmdi->second));
  	}
	}
}


