/***************************************************************************
                          utility.h  -  description
                             -------------------
    begin                : Mon Dec 10 2001
    copyright            : (C) 2001 by Yuanpeng Janet Huang
    email                : yphuang@cabm.rutgers.edu
 ***************************************************************************/

#ifndef UTILITY_H
#define UTILITY_H

#include <fstream>
#include <iostream>
#include <string>
#include <map>
#include <deque>
#include <vector>
#include <iomanip>
#include <unistd.h>
#include <time.h>
#include <sys/times.h>
#include <sys/stat.h>

using namespace std;

typedef map<string, string, less<string> > ControlMap;
typedef deque<ControlMap>	PeakListDeque;

struct Command
{
	string refine;
	string hyper;
	string viewer;
	string dyana;
	string cyana;
	string cns;
	string xplor;
};


string itoa(int);
void error(const char*, const char*);
void error(const string, const string);
ostream& erasePrint(ostream&, const string);
istream& getlineNA(istream&, string&, char delim='\n');
string versionHeader();
string getHelp();

void split(const string, vector<string>&, const string= " \t\n\v");

void readControlFile(const string&, ControlMap&, PeakListDeque&, Command&);		
void runSummary(ostream&, const clock_t&, const clock_t&, const tms&, const tms&);
void createOutputDir(string);

#endif
