/*$Id: DriverForEvaluate.c,v 3.32 2003/10/06 12:13:32 roberto Exp roberto $ */
#include "pdbstat.h"

extern char IsThereAModel(void) ;
extern void resetResidueNumbers(char Model[10], short NewResOrig) ;

extern FILE *safeopen(char *, char *, int longit);

extern void any_distance(char mod[5], 
			 char res1[5], char atomi[6], 
			 char res2[5], char atomj[6],
			 FILE *,
			 float cutoff,
			 char Detailed,
			 char Reverse) ;

extern void any_distance_backbone(float cutoff, FILE *);

extern void any_dihedral(char mod[5], 
			 char res1[5], char atomi[6], 
			 char res2[5], char atomj[6],
			 char res3[5], char atomk[6],
			 char res4[5], char atoml[6],
			 FILE *) ;

extern void any_angle(char mod[5], 
		      char res1[5], char atomi[6], 
		      char res2[5], char atomj[6],
		      char res3[5], char atomk[6],
		      FILE *,
		      char Detailed) ;
extern void RadiusOfGyration(int Model);

int DriverEvaluate(char options[50]) {
     static FILE  *distances='\0' ;
     static char  t1[10], t2[10], t3[10], t4[10], t5[10], t6[10], t7[10], t8[10], t9[10];
     static short i,k ;
     static float DistOff;
     static char  Answer[MAXLINE];
     static double Daxrho[2], Euler[3];
     
     
     /*  Evaluate ANY dihedral, angle or distance */
     if (!IsThereAModel()) {
	  fprintf(stdout,"> MAIN: First you MUST read a model with coordinates\n");
	  return (-1);
     }
     
     for (i = 0; i < 10; i++)
	  t1[i] = t2[i] = t3[i] = t4[i] = t5[i] = t6[i] = t7[i] = t8[i] = t9[i] = '\0';
     
     /*
      * The different evaluations available: 
      *     dihedral
      *     angle
      *     distance
      *     residue
      *     OMEGA
      *     PHI
      *     PSI
      */
     sscanf(options,"%*s %s %*s %*s",t1);
     /*
      * open file to store measurements and initialize varibales
      * used in reading input line
      */
     distances=safeopen("Selected_Measurements","w",21) ;
     if  (strncasecmp(t1,"library",3)==0) {  /* Library for hyper */
	  fprintf(distances," library \' Standard peptide geometry \' \n");
	  fprintf(distances,"{ \n");
	  fprintf(distances,"     --      BOND/ANGLE      VALUES\n");
	  fprintf(distances,"     --     -----------    --------\n");
	  any_distance("*","#","n","#","ca",distances,atof("9999.99"),FALSE,FALSE) ;
	  any_distance("*","#","c","i1","n",distances,atof("9999.99"),FALSE,FALSE) ;
	  any_distance("*","#","n","#","h",distances,atof("9999.99"),FALSE,FALSE) ;
	  any_distance("*","#","ca","#","cb",distances,atof("9999.99"),FALSE,FALSE) ;
	  any_distance("*","#","ca","#","c",distances,atof("9999.99"),FALSE,FALSE) ;
	  any_distance("*","#","ca","#","ha",distances,atof("9999.99"),FALSE,FALSE) ;
	  any_angle("*","#","h","#","n","#","ca",distances,FALSE) ;
	  any_angle("*","#","n","#","ca","#","ha",distances,FALSE) ;
	  any_angle("*","#","n","#","ca","#","cb",distances,FALSE) ;
	  any_angle("*","#","n","#","ca","#","c",distances,FALSE) ;
	  any_angle("*","#","ca","#","cb","#","hb",distances,FALSE) ;
	  any_angle("*","#","ca","#","c","i1","n",distances,FALSE) ;
	  any_angle("*","#","c","i1","n","i1","h",distances,FALSE) ;
	  fprintf(distances,"} \n");
     } else if  (strncasecmp(t1,"calibrat",3)==0) { /* for calibration */ 
	  (void) strcpy(t1,"*") ;
	  (void) strcpy(t2,"*") ;
	  (void) strcpy(t3,"h*") ;
	  (void) strcpy(t4,"*") ;
	  (void) strcpy(t5,"h*") ;
	  fprintf(stdout,"\n -------- ALL HYDROGENS --------");
	  any_distance(t1,t2,t3,t4,t5,distances,9.5,FALSE,FALSE);
	  any_distance(t1,t2,t3,t4,t5,distances,9.0,FALSE,FALSE);
	  any_distance(t1,t2,t3,t4,t5,distances,8.5,FALSE,FALSE);
	  any_distance(t1,t2,t3,t4,t5,distances,8.0,FALSE,FALSE);
	  any_distance(t1,t2,t3,t4,t5,distances,7.5,FALSE,FALSE);
	  any_distance(t1,t2,t3,t4,t5,distances,7.0,FALSE,FALSE);
	  any_distance(t1,t2,t3,t4,t5,distances,6.5,FALSE,FALSE);
	  any_distance(t1,t2,t3,t4,t5,distances,6.0,FALSE,FALSE);
	  any_distance(t1,t2,t3,t4,t5,distances,5.5,FALSE,FALSE);
	  any_distance(t1,t2,t3,t4,t5,distances,5.0,FALSE,FALSE);
	  any_distance(t1,t2,t3,t4,t5,distances,4.5,FALSE,FALSE);
	  any_distance(t1,t2,t3,t4,t5,distances,4.0,FALSE,FALSE);
	  any_distance(t1,t2,t3,t4,t5,distances,3.5,FALSE,FALSE);
	  any_distance(t1,t2,t3,t4,t5,distances,3.0,FALSE,FALSE);
	  fprintf(stdout,"\n --------    BACKBONE   --------");
	  any_distance_backbone(9.5,distances);
	  any_distance_backbone(9.0,distances);
	  any_distance_backbone(8.5,distances);
	  any_distance_backbone(8.0,distances);
	  any_distance_backbone(7.5,distances);
	  any_distance_backbone(7.0,distances);
	  any_distance_backbone(6.5,distances);
	  any_distance_backbone(6.0,distances);
	  any_distance_backbone(5.5,distances);
	  any_distance_backbone(5.0,distances);
	  any_distance_backbone(4.5,distances);
	  any_distance_backbone(4.0,distances);
	  any_distance_backbone(3.5,distances);
	  any_distance_backbone(3.0,distances);
     } else if  (strncasecmp(t1,"dihedral",3)==0) { /* Dihedral evaluation */
	  sscanf(options,"%*s %*s %s %s %s %s %s %s %s %s %s",
		 t1,t2,t3,t4,t5,t6,t7,t8,t9);
	  if (strcmp(t9,"")==0) {
	       printf("> MAIN: Atom ID's ?_: ");
	       GetFromKeyBoard(options, MAXWORD, stdin);
	       sscanf(options,"%s %s %s %s %s %s %s %s %s", t1,t2,t3,t4,t5,t6,t7,t8,t9);
	       
	       printf("\n> ANY_DIH: Printing Selected DIHEDRALS for molecule\n\n");
	       fprintf(distances, "\n> ANY_DIH: Printing Selected DIHEDRALS for molecule\n\n");
	       (void) any_dihedral(t1, t2, t3, t4, t5, t6, t7, t8, t9,distances);
	  } else {
	       printf("\n> ANY_DIH: Printing Selected DIHEDRALS for molecule\n\n");
	       fprintf(distances, "\n> ANY_DIH: Printing Selected DIHEDRALS for molecule\n\n");
	       (void) any_dihedral(t1, t2, t3, t4, t5, t6, t7, t8, t9,distances);
	  }
     } else if (strncasecmp(t1,"angle",3)==0) {    /* Angle evaluation */
	  sscanf(options,"%*s %*s %s %s %s %s %s %s %s", t1, t2, t3, t4, t5, t6, t7) ;
	  if (strcmp(t7,"")==0) {
	       printf("> MAIN: Atom ID's ?_: ");
	       GetFromKeyBoard(options, MAXWORD, stdin);
	       sscanf(options,"%s %s %s %s %s %s %s", t1, t2, t3, t4, t5, t6, t7);
	       
	       printf("\n> ANY_ANG: Printing Selected ANGLES for molecule\n\n");
	       fprintf(distances, "\n> ANY_ANG: Printing Selected ANGLES for molecule\n\n");
	       (void) any_angle(t1, t2, t3, t4, t5, t6, t7,distances,TRUE);
	  } else {
	       printf("\n> ANY_ANG: Printing Selected ANGLES for molecule\n\n");
	       fprintf(distances, "\n> ANY_ANG: Printing Selected ANGLES for molecule\n\n");
	       (void) any_angle(t1, t2, t3, t4, t5, t6, t7,distances,TRUE);
	  }
     } else if (strncasecmp(t1,"distance",3)==0) {  /* distance evaluation */
	  (void) strcpy(t6,"9999.99") ;  /* Evaluate ALL distances */ 
	  sscanf(options,"%*s %*s %*s %*s %*s %*s %*s %s %s", t8,t9);
	  if (strncasecmp(t8,"lower",2)==0) 
	       DistOff=atof(t9);
	  else
	       DistOff=9999.99;
	  sscanf(options,"%*s %*s %s %s %s %s %s", t1, t2, t3, t4, t5);
	  if (strncasecmp(t1,"lower",2)==0) {
	       sscanf(options,"%*s %*s %*s %s",t6);
	       if (strcmp(t6,"9999.99")==0) {
		    printf("> MAIN: Distance cut-off ?_: ");
		    GetFromKeyBoard(t6, MAXWORD, stdin);
	       }
	       if (strncasecmp(t3,"backbone",2)==0)
		    any_distance_backbone(atof(t6),distances);
	       else {
		    (void) strcpy(t1,"*") ;
		    (void) strcpy(t2,"*") ;
		    (void) strcpy(t3,"h*") ;
		    (void) strcpy(t4,"*") ;
		    (void) strcpy(t5,"h*") ;
		    any_distance(t1,t2,t3,t4,t5,distances,atof(t6),FALSE,FALSE);
	       }
	  } else if ((strcmp(t1,"")==0) || (strcmp(t2,"")==0) || 
		     (strcmp(t3,"")==0) || (strcmp(t4,"")==0) ||
		     (strcmp(t5,"")==0)) {
	       printf("> MAIN: Atom ID's ?_: ");
	       GetFromKeyBoard(options, MAXWORD, stdin);
	       sscanf(options,"%s %s %s %s %s", t1, t2, t3, t4, t5) ;  
	       printf("\n> ANY_DIST: Printing Selected distances for molecule\n\n");
	       fprintf(distances, "\n> ANY_DIST: Printing Selected distances for molecule\n\n");  
	       any_distance(t1,t2,t3,t4,t5,distances,9999.99,TRUE,TRUE);
	  } else {
	       printf("\n> ANY_DIST: Printing Selected distances for molecule\n\n");
	       fprintf(distances, "\n> ANY_DIST: Printing Selected distances for molecule\n\n");  
	       any_distance(t1,t2,t3,t4,t5,distances,DistOff,TRUE,TRUE);
	  }
     } else if (strncasecmp(t1,"residue",3)==0) {  /* residue evaluation */ 
	  /* 
	   * To evaluate geometry of a residue
	   * Much of these were reported because were needed to check HYPER
	   * code. 
	   * RTT, CABM, July 1997
	   */
	  sscanf(options,"%*s %*s %s %s", t1, t8);
	  
	  if (isalpha(t1[0])) {
	       strcpy(t9,t1);
	       k = 1  ;
	  } else
	       goto out_get_set ;
	  
     new_residue:
	  
	  if (isalpha(t9[0])) {
	       sprintf(t1,"\n");
	       sprintf(t2,"\n");
	       sprintf(t3,"\n");
	       for (i = k; i <= MODELS[1].number_of_residues; i++) 
		    if (strncasecmp(seqres[i],t9,3)==0) {
			 sprintf(t1,"%d",i);
			 k = i + 1;
			 goto out_get_set ;
		    }
	  }
	  goto final_ciclo ;
	  
     out_get_set:
	  /* Store residue numbers of previous and next */
	  sprintf(t2,"%d",atoi(t1)-1) ;
	  sprintf(t3,"%d",atoi(t1)+1) ;
	  printf("\n  **EVALUATING selected set for residue %s %s\n",
		 seqres[atoi(t1)], t1) ;
	  fprintf(distances, "\n  **EVALUATING selected set for residue %s %s\n",
		  seqres[atoi(t1)],t1) ;
	  
	  if ((strncasecmp(t8,"distances",3)==0) || (strncasecmp(t8,"bonds",3)==0) ||	(strcmp(t8,"")==0)) {
	       printf("\n> ANY_DIST: Printing Selected distances for molecule\n\n");
	       fprintf(distances, "\n> ANY_DIST: Printing Selected distances for molecule\n\n");  
	       any_distance("*",t1,"c",t3,"n",distances,atof("9999.99"),TRUE,FALSE) ;
	       any_distance("*",t1,"n",t1,"ca",distances,atof("9999.99"),TRUE,FALSE) ;
	       any_distance("*",t1,"n",t1,"h",distances,atof("9999.99"),TRUE,FALSE) ;
	       any_distance("*",t1,"ca",t1,"c",distances,atof("9999.99"),TRUE,FALSE) ;
	       any_distance("*",t1,"ca",t1,"cb",distances,atof("9999.99"),TRUE,FALSE) ;
	       any_distance("*",t1,"ca",t1,"ha*",distances,atof("9999.99"),TRUE,FALSE) ;
	       any_distance("*",t1,"cb",t1,"hb*",distances,atof("9999.99"),TRUE,FALSE) ;
	  }
	  if ((strncasecmp(t8,"angles",3)==0) || (strcmp(t8,"")==0)) {
	       printf("\n> ANY_ANG: Printing Selected ANGLES for molecule\n\n");
	       fprintf(distances,"\n> ANY_ANG: Printing Selected ANGLES for molecule\n\n");
	       any_angle("*",t1,"n",t1,"ca",t1,"cb",distances,TRUE) ;
	       any_angle("*",t1,"n",t1,"ca",t1,"c",distances,TRUE) ;
	       any_angle("*",t1,"cb",t1,"ca",t1,"c",distances,TRUE) ;
	       any_angle("*",t1,"n",t1,"ca",t1,"ha*",distances,TRUE) ;
	       any_angle("*",t1,"h",t1,"n",t1,"ca",distances,TRUE) ;
	       any_angle("*",t1,"ca",t1,"cb",t1,"hb*",distances,TRUE) ;
	       any_angle("*",t1,"ha*",t1,"ca",t1,"c",distances,TRUE) ;
	       any_angle("*",t1,"hb*",t1,"cb",t1,"hb*",distances,TRUE) ;
	       any_angle("*",t1,"ca",t1,"c",t3,"n",distances,TRUE) ;
	       any_angle("*",t1,"c",t3,"n",t3,"h",distances,TRUE) ;
	  }
	  if ((strncasecmp(t8,"dihedrals",3)==0) || (strcmp(t8,"")==0)) {
	       printf("\n> ANY_DIH: Printing Selected DIHEDRALS for molecule\n\n");
	       fprintf(distances,"\n> ANY_DIH: Printing Selected DIHEDRALS for molecule\n\n");
	       any_dihedral("*",t2,"c",t1,"n",t1,"ca",t1,"c",distances);
	       any_dihedral("*",t1,"n",t1,"ca",t1,"c",t3,"n",distances);
	       any_dihedral("*",t1,"ca",t1,"c",t1,"n",t3,"ca",distances);
	       any_dihedral("*",t1,"n",t1,"ca",t1,"cb",t1,"cg*",distances);
	       any_dihedral("*",t1,"n",t1,"ca",t1,"cb",t1,"og*",distances);
	       any_dihedral("*",t1,"n",t1,"ca",t1,"cb",t1,"sg*",distances);
	  }
	  /*
	   * This part to check for planarity in amide sidechains ann TRP
	   * ring residues and TYR and PHE
	   * This is being developped.
	   */
	  
	  if ((strncasecmp(t8,"planarity",3)==0) || (strncasecmp(t8,"dihedrals",3)==0) ||
	      (strcmp(t8,"")==0)) {
	       printf("\n> ANY_DIH: Printing Special DIHEDRALS for molecule if any\n\n");
	       fprintf(distances,"\n> ANY_DIH: Printing Special DIHEDRALS for molecule if any \n\n");
	       /*
		* Check for planarity of ARG (arginine, -R-)
		*/
	       any_dihedral("*",t1,"ne",t1,"nh1",t1,"nh2",t1,"cz",distances);
	       any_dihedral("*",t1,"cz",t1,"1HH1",t1,"2HH1",t1,"NH1",distances);
	       any_dihedral("*",t1,"cz",t1,"1HH2",t1,"2HH2",t1,"NH2",distances);
	       
	       /*
		* Check for planarity of rings
		* TYR (tyrosine -Y-) and PHE (phenilalanine -F-)
		*/
	       any_dihedral("*",t1,"cb",t1,"cg",t1,"cd1",t1,"ce1",distances);
	       any_dihedral("*",t1,"cg",t1,"cd1",t1,"ce1",t1,"cz",distances);
	       any_dihedral("*",t1,"cd1",t1,"ce1",t1,"cz",t1,"ce2",distances);
	       any_dihedral("*",t1,"ce1",t1,"cz",t1,"ce2",t1,"cd2",distances);
	       any_dihedral("*",t1,"cz",t1,"ce2",t1,"cd2",t1,"cg",distances);
	       any_dihedral("*",t1,"ce2",t1,"cd2",t1,"cg",t1,"cb",distances);
	       any_dihedral("*",t1,"cb",t1,"cg",t1,"cd1",t1,"hd1",distances);
	       any_dihedral("*",t1,"hd1",t1,"cd1",t1,"ce1",t1,"he1",distances);
	       any_dihedral("*",t1,"he1",t1,"ce1",t1,"cz",t1,"hz",distances);
	       any_dihedral("*",t1,"hz",t1,"cz",t1,"ce2",t1,"he2",distances);
	       any_dihedral("*",t1,"he2",t1,"ce2",t1,"cd2",t1,"hd2",distances);
	       any_dihedral("*",t1,"hd2",t1,"cd2",t1,"cg",t1,"cb",distances);
	       
	       /*
		* Check for planarity of Amide sidechains
		* We are looking at two residues: ASN (asparagine -N-) and 
		* GLN (glutamine -Q-)
		*/
	       any_dihedral("*",t1,"cb",t1,"od1",t1,"nd2",t1,"cg",distances);  /* N */
	       any_dihedral("*",t1,"cb",t1,"cg",t1,"nd2",t1,"1hd2",distances); /* N */
	       any_dihedral("*",t1,"cb",t1,"cg",t1,"nd2",t1,"2hd2",distances); /* N */
	       any_dihedral("*",t1,"cg",t1,"oe1",t1,"ne2",t1,"cd",distances);  /* Q */
	       any_dihedral("*",t1,"cg",t1,"cd",t1,"ne2",t1,"1he2",distances); /* Q */
	       any_dihedral("*",t1,"cg",t1,"cd",t1,"ne2",t1,"2he2",distances); /* Q */
	  }
	  if (isalpha(t9[0]) && i < MODELS[1].number_of_residues) goto new_residue ;
     } else if (strncasecmp(t1,"omega",3)==0) {             /* OMEGA evaluation */ 
	  sscanf(options,"%*s %*s %s", t1);
	  if ((strcmp(t1,"")==0) || (strcmp(t1,"*")==0)) { 
	       strcpy(t1,"*") ;
	       i = 1 ;
	  } else 
	       i = atoi(t1) ;
	  if ( i > AverageModel ) {
	       i = total_models ;
	       sprintf(t1,"%d",i) ;
	  }
	  if ( i <= 0 ) {
	       i = 1;
	       sprintf(t1,"%d",i) ;
	  }
	  any_dihedral(t1,"#","ca","#","c","i1","n","i1","ca",distances);
     } else if (strncasecmp(t1,"psi",3)==0) {                 /* PSI evaluation */ 
	  sscanf(options,"%*s %*s %s", t1);
	  if ((strcmp(t1,"") ==0) || (strcmp(t1,"*")==0)) { 
	       strcpy(t1,"*") ;
	       i = 1 ;
	  } else
	       i = atoi(t1) ;
	  if ( i > AverageModel ) {
	       i = total_models ;
	       sprintf(t1,"%d",i) ;
	  }
	  if ( i <= 0 ) {
	       i = 1;
	       sprintf(t1,"%d",i) ;
	  }
	  any_dihedral(t1,"#","n","#","ca","#","c","i1","n",distances);
     } else if (strncasecmp(t1,"phi",3)==0) {                  /* PHI evaluation */ 
	  sscanf(options,"%*s %*s %s", t1);
	  if ((strcmp(t1,"") ==0) || (strcmp(t1,"*")==0)) { 
	       strcpy(t1,"*") ;
	       i = 1 ;
	  } else
	       i = atoi(t1) ;
	  if ( i > AverageModel ) {
	       i = total_models ;
	       sprintf(t1,"%d",i) ;
	  }
	  if ( i <= 0 ) {
	       i = 1;
	       sprintf(t1,"%d",i) ;
	  }
	  any_dihedral(t1,"#","c","i1","n","i1","ca","i1","c",distances);
     } else {       /* There is NO default to evaluate so tell the user */
	  printf("> EVALUATE: ** Warning: `%s' NO such item to evaluate \n", t1);
     }
     
 final_ciclo:
     fclose(distances);
     /* Restore the original residue numbers */
     /* (void) resetResidueNumbers("all",tempvar) ; */
     
     return (0) ;
}



