/*$Id: InitStructs.c,v 1.6 2003/10/06 12:13:32 roberto Exp roberto $*/

#include "pdbstat.h"

/* 
 * Miscelaneous code related to structures, here we initialize structures with
 * values.  Values of -1 are so then further we can consider them as uninitialized
 * in other parts of the code.
 *
 * Roberto Tejero, CABM Rutgers University, 2003.
 */

void InitNoeRecord(struct noe *Noe) {
	static int itmp ;

 	Noe->Number = 0 ;  
	
	for (itmp = 0; itmp < 8; itmp++) {
		Noe->HyperName[itmp] = '\0' ;
	}

	Noe->LastRes1 = Noe->LastRes2 = FALSE ;
	Noe->FirstRes1 = Noe->FirstRes2 = FALSE ;
	
	for (itmp = 0; itmp < 6; itmp++) {
		Noe->atom_type1[itmp] = '\0' ;
		Noe->Atom1Ecepp[itmp] = '\0' ;
		Noe->Atom1Disman[itmp] = '\0' ;
		Noe->Atom1Diana[itmp] = '\0' ;
		Noe->Atom1Dyana[itmp] = '\0' ;
		Noe->Atom1Cyana[itmp] = '\0' ;
		Noe->Atom1Congen[itmp] = '\0' ;
		Noe->Atom1Xplor[itmp] = '\0' ;
		Noe->Atom1Pdb[itmp] = '\0' ;

		Noe->atom_type2[itmp] = '\0' ;
		Noe->Atom2Ecepp[itmp] = '\0' ;
		Noe->Atom2Disman[itmp] = '\0' ;
		Noe->Atom2Diana[itmp] = '\0' ;
		Noe->Atom2Dyana[itmp] = '\0' ;
		Noe->Atom2Cyana[itmp] = '\0' ;
		Noe->Atom2Congen[itmp] = '\0' ;
		Noe->Atom2Xplor[itmp] = '\0' ;
		Noe->Atom2Pdb[itmp] = '\0' ;
	}
	
	for (itmp = 0; itmp < 2; itmp++) {
		Noe->chain_id_1[itmp] = '\0' ;
		Noe->chain_id_2[itmp] = '\0' ;
		Noe->code[itmp] = '\0';
	}
	
	for (itmp = 0; itmp < 5; itmp++) {
		Noe->residue_type1[itmp] = '\0' ;	
		Noe->residue_type2[itmp] = '\0' ;
		Noe->segid_1[itmp] = '\0' ;
		Noe->segid_2[itmp] = '\0' ;
	}
	
	for (itmp = 0; itmp < MAXWORD; itmp++)
		Noe->comment[itmp] = '\0' ;	

	for (itmp = 0; itmp < 20; itmp++) {
		Noe->iat1[itmp] = 0 ;
		Noe->iat2[itmp] = 0 ;
	}

	for ( itmp = 0; itmp < MAXMODELS; itmp++) {
		Noe->Dist[itmp] = 0.0 ;
	}

	Noe->ToPrint = TRUE ;
	Noe->residue_number1 = Noe->residue_number2 = 0 ;
	Noe->atom_number1 = Noe->atom_number2 = 0 ;
	Noe->volume = 0.0;
	Noe->upper = Noe->lower = Noe->equil = Noe->rgupp = Noe->rglow = 0.0 ;

	Noe->next = NULL ;
	return ;
}


/* This is not by far complete */
void InitPDBRecord(struct atom_pdb *PDB) {
	static int itmp ;

	for (itmp = 0; itmp < 8; itmp++) {
		PDB->pdb_key[itmp]='\0';
	}
	
	for (itmp = 0; itmp < 6; itmp++) {
		PDB->pdb_iupac[itmp]='\0';
	}
	
	for (itmp = 0; itmp < 10; itmp++) {
		PDB->chain[itmp]='\0';
		PDB->type[itmp]='\0';
	}
	
	for (itmp = 0; itmp < 5; itmp++) {
		PDB->pdb_res[itmp]='\0';
		PDB->segid[itmp]='\0';
	}
	
	for (itmp = 0; itmp < 2; itmp++) {
		PDB->AtomType[itmp]='\0';
		PDB->pdb_chain_id[itmp]='\0';
	}

	return ;
}

