/*$Id: amino_codes.c,v 3.32 2003/10/06 12:13:32 roberto Exp roberto $*/

#include "pdbstat.h"

#define MAXNAME 25     /* max. length of a complete resisdue name  */ 
#define AMINOS  20     /* current number of aminoacids             */

extern char IsThereAModel(void);
void amino_codes(void) ;
void assign_names(void) ;
char *OneToThree(char Name[5]) ;

static char all_letter[AMINOS+1][MAXNAME], one_letter[AMINOS+1][2], thr_letter[AMINOS+1][5];

void amino_codes(void) 
{  
  static short i,j,k ;
  static struct models *model ;

  (void) assign_names() ;

  /* if (IsThereAModel) return ; */
  if ( DEBUG > 4 )
    fprintf(stdout," > amino_codes(): starting assigning Res codes \n");

  for (i = 1 ; i <= total_models ; i++) {  /* loop  number of models */
    model = MODELS+i ;
    for (j = 1 ; j <= model->number_of_residues ; j++)
      for (k = 1 ; k <= AMINOS+1 ; k++) { /* loop number of common aminos */
	if (strcasecmp(model->DIH[j].resname,thr_letter[k])==0) {
	  strcpy(model->DIH[j].oneletter,one_letter[k]) ;
	  strcpy(model->DIH[j].thrletter,thr_letter[k]) ;
	  strcpy(model->DIH[j].fullname,all_letter[k]) ;
	  if ( DEBUG > 5 )
	    fprintf(stdout," > amino_codes(): assigning %s - %s %s %s \n",
		    model->DIH[j].resname,
		    model->DIH[j].oneletter,
		    model->DIH[j].thrletter,
		    model->DIH[j].fullname);
	  break ;
	}
	if (strcasecmp(model->DIH[j].resname,one_letter[k])==0) {
	  strcpy(model->DIH[j].thrletter,thr_letter[k]) ;
	  strcpy(model->DIH[j].fullname,all_letter[k]) ;
	  strcpy(model->DIH[j].resname,thr_letter[k]) ;
	  if ( DEBUG > 5 )
	    fprintf(stdout," > amino_codes(): assigning %s - %s %s %s \n",
		    model->DIH[j].resname,
		    model->DIH[j].oneletter,
		    model->DIH[j].thrletter,
		    model->DIH[j].fullname);
	  break ;
	}
	if (strcasecmp(model->DIH[j].resname,all_letter[k])==0) {
	  strcpy(model->DIH[j].oneletter,one_letter[k]) ;
	  strcpy(model->DIH[j].thrletter,thr_letter[k]) ;
	  if ( DEBUG > 5 )
	    fprintf(stdout," > amino_codes(): assigning %s - %s %s %s \n",
		    model->DIH[j].resname,
		    model->DIH[j].oneletter,
		    model->DIH[j].thrletter,
		    model->DIH[j].fullname);
	  break ;
	}
      }
  }
  return ;
}

/*
 * Simply copy and assign all the names, one and three letter codes
 * to the aminos
 */

void assign_names(void)
{  
  strcpy(all_letter[ 1],"Alanine");
  strcpy(one_letter[ 1],"A")  ;
  strcpy(thr_letter[ 1],"ALA") ;
  
  strcpy(all_letter[ 2],"Arginine");
  strcpy(one_letter[ 2],"R")  ;
  strcpy(thr_letter[ 2],"ARG");
  
  strcpy(all_letter[ 3],"Asparagine")      ;
  strcpy(one_letter[ 3],"N")  ;
  strcpy(thr_letter[ 3],"ASN");
  
  strcpy(all_letter[ 4],"Aspartic acid")   ;
  strcpy(one_letter[ 4],"D")  ;
  strcpy(thr_letter[ 4],"ASP");
  
  strcpy(all_letter[ 5],"Cysteine")       ;
  strcpy(one_letter[ 5],"C")  ;
  strcpy(thr_letter[ 5],"CYS");
  
  strcpy(all_letter[ 6],"Glutamic acid")   ;
  strcpy(one_letter[ 6],"E")  ;
  strcpy(thr_letter[ 6],"GLU");
  
  strcpy(all_letter[ 7],"Glutamine")       ;
  strcpy(one_letter[ 7],"Q")  ;
  strcpy(thr_letter[ 7],"GLN");
  
  strcpy(all_letter[ 8],"Glycine") ;
  strcpy(one_letter[ 8],"G")  ;
  strcpy(thr_letter[ 8],"GLY") ;

  strcpy(all_letter[ 9],"Histidine") ;
  strcpy(one_letter[ 9],"H") ;  
  strcpy(thr_letter[ 9],"HIS") ;         
  
  strcpy(all_letter[10],"Isoleucine") ;      
  strcpy(one_letter[10],"I");  
  strcpy(thr_letter[10],"ILE");
  
  strcpy(all_letter[11],"Leucine") ;         
  strcpy(one_letter[11],"L") ;  
  strcpy(thr_letter[11],"LEU") ;         
  
  strcpy(all_letter[12],"Lysine") ;          
  strcpy(one_letter[12],"K") ;  
  strcpy(thr_letter[12],"LYS") ;
  
  strcpy(all_letter[13],"Methionine") ;      
  strcpy(one_letter[13],"M") ;  
  strcpy(thr_letter[13],"MET") ;         
  
  strcpy(all_letter[14],"Phenylalanine") ;   
  strcpy(one_letter[14],"F") ; 
  strcpy(thr_letter[14],"PHE") ;
  
  strcpy(all_letter[15],"Proline") ;         
  strcpy(one_letter[15],"P") ; 
  strcpy(thr_letter[15],"PRO") ;         
  
  strcpy(all_letter[16],"Serine") ;          
  strcpy(one_letter[16],"S") ; 
  strcpy(thr_letter[16],"SER") ;
  
  strcpy(all_letter[17],"Threonine")  ;      
  strcpy(one_letter[17],"T") ; 
  strcpy(thr_letter[17],"THR") ;         
  
  strcpy(all_letter[18],"Tryptophan") ;     
  strcpy(one_letter[18],"W")  ; 
  strcpy(thr_letter[18],"TRP") ;
  
  strcpy(all_letter[19],"Tyrosine") ;        
  strcpy(one_letter[19],"Y") ; 
  strcpy(thr_letter[19],"TYR") ;         
  
  strcpy(all_letter[20],"Valine") ;          
  strcpy(one_letter[20],"V") ; 
  strcpy(thr_letter[20],"VAL") ;

  return ;
}


char *OneToThree(char Name[5])
{  
  switch (Name[0]) {
  case 'A' :
    return("ALA") ;

  case 'R' :
    return("ARG");

  case 'N' : 
    return("ASN");
    
  case 'D' :  
    return("ASP");
  
  case 'C' :  
    return("CYS");

  case 'E' :  
    return("GLU");
  
  case 'Q' :  
    return("GLN");
  
  case 'G' :  
    return("GLY") ;

  case 'H' :
    return("HIS") ;         
  
  case 'I' : 
    return("ILE");
    
  case 'L' :   
    return("LEU") ;         
  
  case 'K' : 
    return("LYS") ;

  case 'M' :   
    return("MET") ;         
  
  case 'F' :
    return("PHE") ;
  
  case 'P' :  
    return("PRO") ;         
 
  case 'S' :
    return("SER") ;
  
  case 'T' :  
    return("THR") ;         
  
  case 'W' :   
    return("TRP") ;

  case 'Y' : 
    return("TYR") ;         
  
  case 'V' : 
    return("VAL") ;
  
  default :
    fprintf(stderr,"\n amino_codes(): ** Residue Name `%s' NOT recognaized ** \n", Name);
    exit (-1) ;
    break ;
  }
  return ("KKK") ;
}
