/*$Id: calc_rmsd_driver.c,v 3.32 2003/10/06 12:13:32 roberto Exp roberto $*/

#include "pdbstat.h"

FILE *safeopen(char *file, char *mode, int longit);
extern void do_average_coords(char tipo[MAXWORD]);
extern void do_average_selected(char tipo[MAXWORD]);
extern void do_copy_model(int from, int to);
extern float rmsd_coords(int reference, int kompar, int residue_range,
			 int orientmode, char tipo[MAXWORD]);
extern void optimal_rotate(int reference, int kompar, int residue_range,
			   int orientmode, char tipo[MAXWORD]);
extern float rmsd_dihedrals(char clave[MAXWORD]);


void calc_rmsd_driver(char orden[MAXWORD])
{
     /*
      * Driver for rmsd's calculations
      */
     static int  lk, reference, tempvar;
     static float tempif ;
     static char t[MAXWORD], tt[MAXWORD], ttt[MAXWORD] ;
     static char TMPSELECTED ;
     
     static float *rmsd_rtt, rmsd_mean;
     static short i,j, SelectedModels=0 ;
     
     /* Allocate memory space for rmsd_rtt */
     rmsd_rtt = (float *)malloc(sizeof(float) * (total_models+3)) ;
     
     /* Initialize silly variables */
     (void) strcpy(t,"");
     (void) strcpy(tt,"");
     (void) strcpy(ttt,"");
     
     (void) sscanf(orden,"%s",t) ;
     (void) sscanf(orden,"%*s %s",tt);
     (void) sscanf(orden,"%*s %*s %s",ttt);
     
     lk = 0 ;     /* 0 means normal rmsd calculations, no best  */
     
     if (strncmp(tt,"best",2)==0) {
	  sscanf(orden,"%*s %*s %s",ttt);
	  
	  if ( !SELECTED )
	       for (i = 1; i <= total_models; i++) 
		    (MODELS+i)->Selected = TRUE;
	  
	  if (strcmp(ttt,"")==0) {
	       lk = 1 ;   /* 1 means we are in BACKBONE calcs */
	       (void) strcpy(t,"average");
	       (void) strcpy(ttt,"backbone");
	       /* BACKBONE calcs */
	  } else if (strncmp(ttt,"backbone",3)==0) {
	       lk = 10 ;
	       (void) strcpy(t,"average");
	       (void) strcpy(ttt,"backbone");
	       /* HEAVY calcs */
	  } else if (strncmp(ttt,"heavy",3)==0) {
	       lk = 10 ;
	       (void) strcpy(t,"average");
	       (void) strcpy(ttt,"heavy");
	  } else {
	       printf("> RMSD : No valid option for best, assuming backbone");
	       lk = 10 ;   /* 1 means we are in BACKBONE calcs */
	       (void) strcpy(t,"average");
	       (void) strcpy(ttt,"backbone");
	  }      
	  
	  goto best_order ;
    
     best_heavy:
	  lk = 2 ; /* 2 means we are in HEAVY calcs */
	  (void) strcpy(t,"average");
	  (void) strcpy(ttt,"heavy");
	  goto best_order ;
     }
     
     if (strncasecmp(tt,"selected",2)==0) {
	  lk = 0;
	  if (strcmp(ttt,"")==0) 
	       (void) strcpy(t,"average");
	  else 
	       (void) strcpy(t,ttt);
	  (void) strcpy(ttt,"selected");
	  RANGES.number = 1;
	  RANGES.from[1] = MODELS[1].PDB[1].pdb_num_res ;
	  RANGES.to[1] = MODELS[1].number_of_residues+MODELS[1].PDB[1].pdb_num_res;
	  if ( MODELS[1].PDB[1].pdb_num_res >= 1 )
	       RANGES.to[1]-- ;
	  
	  goto best_order;
     }
     
     RANGES.number = 1;
     RANGES.from[1] = MODELS[1].PDB[1].pdb_num_res;
     RANGES.to[1] = MODELS[1].number_of_residues+MODELS[1].PDB[1].pdb_num_res;
     if ( MODELS[1].PDB[1].pdb_num_res >= 1 )
	  RANGES.to[1]-- ;
     
     (void) strcpy(ttt,"") ;
     (void) sscanf(orden,"%*s %s",ttt);
     
     if (strcmp(ttt,"")==0) {
	  printf("> RMSD : Coordinates or dihedrals ?_ :  ");
	  GetFromKeyBoard(ttt, MAXWORD, stdin);
     }
     
     if (strncmp(ttt,"coords",2)==0) {
	  (void) strcpy(ttt,"") ;
	  (void) sscanf(orden,"%*s %*s %s",ttt);
	  
	  if (strcmp(ttt,"")==0) {
	       printf("> RMSD : backbone, backO, backCB, heavy, all ?_ :  ");
	       (void) GetFromKeyBoard(ttt, MAXWORD, stdin);
	  }
	  
	  if ((strncmp(ttt,"backb",5)!=0) && (strncmp(ttt,"backO",5)!=0) &&
	      (strncmp(ttt,"backC",5)!=0) && (strncmp(ttt,"heavy",3)!=0) &&
	      (strncmp(ttt,"all",3)!=0))
	       (void) strcpy(ttt,"all");
	  
	  sprintf(history[count_history],"rmsd coords %s",ttt);
	  printf("> RMSD_coords : How many ranges ?_ : ");
	  (void) GetFromKeyBoard(t, MAXWORD, stdin);
	  
	  if (t[0] == '\0') 
	       RANGES.number = 1 ;
	  else
	       RANGES.number = atoi(t);
	  
	  TMPSELECTED = SELECTED;
	  if ( !SELECTED )
	       for (i = 1; i <= total_models; i++)
		    (MODELS+i)->Selected = TRUE;
	  SELECTED = FALSE;
	  
	  for (i = 1; i <= RANGES.number; ++i) {
	       printf ("> RMSD_coords : Range  %d  from: space to: ",  i);
	       (void) GetFromKeyBoard(t, MAXWORD, stdin);
	       
	       if (t[0] == '\0') {
		    t[0]='1' ;
		    t[1]='\0' ;
		    RANGES.from[i] = MODELS[1].PDB[1].pdb_num_res ;
		    RANGES.to[i] = MODELS[1].number_of_residues + MODELS[1].PDB[1].pdb_num_res ;
		    if ( MODELS[1].PDB[1].pdb_num_res >= 1 )
			 RANGES.to[i]--;
	       } else
		    sscanf(t,"%d %d",&RANGES.from[i],&RANGES.to[i]);
	  }
	  
	  printf("> RMSD_coords : Reference structure (1-%d) or (average) ?_  ", total_models);
	  (void) GetFromKeyBoard(t, MAXWORD, stdin);
	  
     best_order:
	  if (strncasecmp(t,"average",2)==0) {
	       if (strncasecmp(ttt,"selected",2)==0) 
		    (void) do_average_selected("selected");
	       else 
		    (void) do_average_coords(ttt);
	       reference = AverageModel ;
	  } else {
	       if (t[0] == '\0') {
		    t[0]='1';
		    t[1]='\0';
	       }
	       if ((atoi(t) > total_models) || (atoi(t) < 1))  {
		    printf("> RMSD_coords: Reference model should be in (1-%d) \n", total_models);
		    printf("> RMSD_coords: Taking as reference model 1 \n");
		    reference = 1;
	       } else
		    reference = atoi(t);
	  }
	  
	  if (strcmp(tt,"best")==0 && lk == 1) {
	       t[0]='r';
	       t[1]='m';
	       t[2]='s';
	       t[3]='d';
	       t[4]='_';
	       t[5]='b';
	       t[6]='e';
	       t[7]='s';
	       t[8]='t';
	       t[9]='.';
	       t[10]='p';
	       t[11]='d';
	       t[12]='b';	
	       t[13]='s';
	       t[14]='t';
	       t[15]='a';
	       t[16]='t';
	       t[17]='\0';
	  } else if (( lk == 0 ) || (( lk == 10) && (strcmp(tt,"best")==0))) {
	       printf("> RMSD_coords : File name for RMSDs (def. `rmsd.pdbstat')?_ : ");
	       (void) GetFromKeyBoard(t, MAXWORD, stdin);
	       
	       if (t[0]=='\0') {
		    t[0]='r';
		    t[1]='m';
		    t[2]='s';
		    t[3]='d';
		    t[4]='.';
		    t[5]='p';
		    t[6]='d';
		    t[7]='b';
		    t[8]='s';
		    t[9]='t';
		    t[10]='a';
		    t[11]='t';
		    t[12]='\0' ;
	       }
	       
	       fprintf(stdout,"\n");
	  }
	  
	  /* Opening the file ONLY if best and lk = 1 or if no best */
	  if (( lk == 1 ) || ( lk == 10 ) || (lk == 0))
	       fpi = safeopen(t,"w",(int)strlen(t)) ;
	  
	  for (i = 1 ; i <= total_models ; i++) {
	       key_model = i ;
	       if ( (strncasecmp(ttt,"selected",2)==0) && (MODELS+i)->Selected ) 
		    (void) CenterMass(995);
	       else
		    (void) CenterMass(999);
	  }
	  
	  if (lk == 2)
	       (void) fprintf(fpi,"\n\n");
	  
	  if (( lk == 1 ) || ( lk == 10 )) {
	       (void) fprintf(fpi," > \n > Kabsch RMSD data for family `%s' \n",
			      name_of_the_file_coords);
	       (void) fprintf(fpi," > \n");
	  }
	  
	  fprintf(stdout,"\n");
	  
	  /* Evaluating RMSD for models */
	  SelectedModels = 0;
	  for (i = 1 ; i <= total_models ; i++)
	       if ( (MODELS+i)->Selected ) {
		    SelectedModels++ ;
		    key_model = i ;
		    (void) optimal_rotate(reference,key_model,100,1,ttt);
		    rmsd_rtt[key_model]=rmsd_coords(reference,key_model,100,1,ttt);
		    MODELS[key_model].rmsd = rmsd_rtt[key_model]; 
		    fprintf(stdout," > Kabsch RMSD of %s atoms in res. ",ttt);
		    fprintf(fpi," > Kabsch RMSD of %s atoms in res. ",ttt);
		    
		    for (j = 1 ; j <= RANGES.number ; ++j) {
			 fprintf(stdout,"%s[%d..%d],", RANGES.chain_id[j], RANGES.from[j], RANGES.to[j]);
			 fprintf(fpi,"%s[%d..%d],", RANGES.chain_id[j], RANGES.from[j], RANGES.to[j]);
		    }
		    
		    fprintf(stdout,"for model %2d is: %.3f\n",key_model,rmsd_rtt[key_model]);
		    fprintf(fpi,"for model %2d is: %.3f\n", key_model, rmsd_rtt[key_model]);
	       }
	  
	  /* Ordering rmsd values */
	  for (j = 2 ; j <= total_models ; j++)
	       if ( (MODELS+j)->Selected ) {
		    tempif = rmsd_rtt[j];
		    i = j - 1 ;
		    while ((i > 0) && (rmsd_rtt[i] > tempif)) {
			 rmsd_rtt[i+1] = rmsd_rtt[i];
			 i--;
		    }
		    rmsd_rtt[i+1] = tempif;
	       }
	  
	  /*
	   * Making statistics, mean and range
	   */
	  rmsd_mean=0.0;
	  for (j = 1 ; j <= total_models ; j++)
	       rmsd_mean=rmsd_mean+rmsd_rtt[j]/SelectedModels ;
	  
	  /*
	   * Writing the results for screen and file
	   */
	  fprintf(stdout," >\n > Kabsch RMSD statistics for %d structures: \n",
		  total_models);
	  fprintf(fpi," >\n > Kabsch RMSD statistics for %d structures: \n",
		  total_models);
	  
	  if (reference == AverageModel) {
	       fprintf(stdout," > Mean RMSD using as refer. str. `average' for res.");
	       fprintf(fpi," > Mean RMSD using as refer. str. `average' for res.");
	  } else {
	       fprintf(stdout, " > Mean RMSD using reference struct. %d for res.", reference);
	       fprintf(fpi, " > Mean RMSD using reference struct. %d for res.", reference);
	  }
	  for (j = 1 ; j <= RANGES.number ; ++j) {
	       fprintf(stdout,"[%d..%d],",  RANGES.from[j],   RANGES.to[j]);
	       fprintf(fpi,"[%d..%d],",  RANGES.from[j],  RANGES.to[j]);
	  }
	  fprintf(stdout," is: %.3f \n", rmsd_mean);
	  fprintf(fpi," is: %.3f \n",  rmsd_mean);
	  
	  fprintf(stdout, " > Range of RMSD values to reference struct. is %.3f to %.3f\n\n",
		  rmsd_rtt[1], rmsd_rtt[total_models]);
	  fprintf(fpi, " > Range of RMSD values to reference struct. is %.3f to %.3f \n",
		  rmsd_rtt[1], rmsd_rtt[total_models]);
	  
	  if ((strcmp(tt,"best") == 0) && (lk == 1))
	       goto best_heavy ;
	  
	  SELECTED = TMPSELECTED ;
	  
	  (void) fclose(fpi) ; 
	  free(rmsd_rtt);	
	  return ;
     }
     
     if (strncmp(ttt,"dihedrals",3)==0) {
	  printf("> RMSD_dih: for backbone or all dihedrals (up to ch1) ?_ ");
	  GetFromKeyBoard(ttt, MAXWORD, stdin);
     }
     
     if (strncmp(ttt,"all",2)==0) (void) strcpy(ttt,"all up to chi1");
     if (strncmp(ttt,"back",2)==0) (void) strcpy(ttt,"backbone");
     sprintf(history[count_history],"rmsd_dihedrals %s",ttt);
     if ((fpi=fopen("DELETE.ME","w"))==NULL) {
	  perror("> RMSD_dih:  *NO* write permission in this directory \n");
	  free(rmsd_rtt);
	  return ;
     }
     printf("> RMSD_dih: Select reference structure (1-%d) or average ?_  ", total_models);
     GetFromKeyBoard(t, MAXWORD, stdin);
     do_lower_case(t);
     if (strncmp(t,"average",3)==0) {
	  printf("> RMSD_dih: ... Making average ... \n");
	  do_average_coords("backbone");
	  printf("> RMSD_dih: ... Calculating dihedrals for average as ref... \n");
	  key_model = AverageModel;
	  phi_psi_chi(fpi,0);
	  MODELS[key_model].modelno = AverageModel;
     } else {
	  if (atoi(t) > total_models)
	       printf("> RMSD_dih: ** Reference should be between 1 and %d\n", total_models);
	  do_copy_model(atoi(t),AverageModel);
	  printf("> RMSD_dih: ... Calculating dihedrals for %d as reference... \n", atoi(t));
	  tempvar = key_model;
	  key_model = AverageModel;
	  phi_psi_chi(fpi,0);
	  MODELS[key_model].modelno = atoi(t);
	  key_model = tempvar;
     }
     printf("> RMSD_dih: .. Calculating dihedrals for %d models in family .\n", total_models);
     i=0;
     tempvar = key_model;
     fprintf(stdout,"> RMSD_dih: ... Model: %3d", i);
     for (i = 1; i <= total_models ; i++) {
	  fprintf(stdout,"\b\b\b%3d", i);
	  key_model = i;
	  phi_psi_chi(fpi,0);
     }
     fclose(fpi);
     fprintf(stdout,"\n");
     fprintf(stdout, "> RMSD_dih: rmsd for %s dihedrals is %.3f for %d models\n",
	     ttt, rmsd_dihedrals(ttt), key_model);
     key_model = tempvar;
     free(rmsd_rtt);
     return ;
}
