/*$Id: check_pdb.c,v 3.32 2003/10/06 12:13:32 roberto Exp roberto $*/
#include "pdbstat.h"

void clean_pdb(int i) ;
void clean_asp(int, int, int, int, int, int, int, int) ;
void clean_glu(int, int, int, int, int, int, int, int) ;
void clean_leu(int, int, int, int, int, int, int, int) ;
void clean_ile(int, int, int, int, int, int, int, int) ;
void clean_thr(int, int, int, int, int, int, int, int) ;
void clean_aro(int, int, int, int, int, int, int, int) ;
void clean_val(int, int, int, int, int, int, int, int) ;

/* ========================================================================= */
void check_label_pdb(int koption)
 /*
  *   To change labels acoording to IUPAC, the option should be
  *
  *   10   OPTIon 10 reserved for ECEPP formats
  *    3   for PDB  XPLOR format
  *    2   for PDB  CONGEN format
  *    1   for DISMAN input file
  *    0   for CONGEN input file
  * 
  * (Roberto Tejero, RTT, June 1993, CABM-Rutgers University).
  *
  */
{
  int    ii,
         contres;
  int    tmp;
  char   sigue[1];
  static short i;
  struct models *model ;

  /*  
      int inires, endres ;
      int  p_n, p_ca, p_cb, p_cg, p_cg1, p_cg2, p_cd1, p_cd2 ; 
      int  p_ha, p_hb ; 
      int  change = 0 ;
  */

  tmp = 9999;
  contres = 0;  
  model = MODELS+key_model ;

  MAX = model->number_of_atoms + 1;
  
  /* 
   * Writing sequence data to another array, this time is sequence array.
   * Also double writing to DIH array. This is really NOT needed
   */
  for (i = 1; i < MAX ; i++)  /* Loop through ALL atoms in model */
    if (model->PDB[i].pdb_num_res != tmp) {
      contres++;           /* residue counter */
      if ( model->PDB[i].pdb_num_res_orig > MAXRESIDUES ) {
	      fprintf(stdout,"\n  **Error**  Residue number in PDB file (%5d )greater than MAXRESIDUES (%5d) \n",
			      model->PDB[i].pdb_num_res_orig, MAXRESIDUES);
	      fprintf(stdout,"  **Error**  please increase MAXRESIDUES in general.h \n");
	      exit (-1) ;
      }
      strcpy(seqres[model->PDB[i].pdb_num_res_orig],model->PDB[i].pdb_res);
      seqres[model->PDB[i].pdb_num_res_orig][4]='\0';
      seqres[model->PDB[i].pdb_num_res_orig][5]='\0';
      strcpy(model->DIH[contres].resname,model->PDB[i].pdb_res);
      tmp = model->PDB[i].pdb_num_res ;
    }
 
  model->starting_res = model->PDB[1].pdb_num_res_orig ;

  /*
   * Some checking about number of residues. 
   * I HAVE to fix this some day !!!! (I wrote this in Jan, 1997)
   */
  if (contres != model->number_of_residues) {
    printf("\n");
    printf("> CHK_pdb: ** Number of residues don't agree !! \n");
    printf("> CHK_pdb: ** in MODEL # is %3d in CHECK_PDB  # is %3d \n",
	   model->number_of_residues, contres);
    printf("> CHK_pdb: Hit return to resume or EXIT to exit ");
    GetFromKeyBoard(sigue, MAXWORD, stdin);
    if (strncmp(sigue,"exit",1)==0) return;
  }
  
  tmp = 0;
  
  for (i = 1; i < MAX ; i++) {
    /*
     * This first lines are to take into account some weird errors in
     * programs about writing PDB. Sometimes you can find a PDB name
     * as "HB12 " instead of " HB12" or the more common "2HB1 "
     */
    if (model->PDB[i].pdb_iupac[0] == 'H') {
      for (ii = 4 ; ii >= 1 ; ii--)
	model->PDB[i].pdb_iupac[ii] = model->PDB[i].pdb_iupac[ii-1];
      model->PDB[i].pdb_iupac[0] = ' ';
    }
    
    /*
     * usual conversion to our convention in names and storage
     */
    if (strncmp(model->PDB[i].pdb_iupac," HN",3)==0)
      strcpy(model->PDB[i].pdb_iupac," H   ");
    
    /*
     * If we are reading ECEPP we need this as ECEPP program
     * does not distinguish between betas or deltas or gammas and
     * always applies the same label for the two or three atoms in question
     * HA for the three alphas of GLY or HB for the two betas in TYR, PRO, 
     * etc.
     */
    if (koption != 10) goto after_ecepp ;  /* This is NOT ECEPP input */
    
    /*
     * two alphas of GLY
     */
    if (strncmp(model->PDB[i].pdb_res,"GLY",3)==0)  {
      if (strncmp(model->PDB[i].pdb_iupac," HA",3)==0) {
	strcpy(model->PDB[i].pdb_iupac,"1HA  ");
	if (strncmp(model->PDB[i-1].pdb_iupac,"1HA  ",5)==0) 
	  strcpy(model->PDB[i].pdb_iupac,"2HA  ");
      }
    }
    
    /*
     * three betas of ALA
     */
    if (strncmp(model->PDB[i].pdb_res,"ALA",3)==0) {
      if (strncmp(model->PDB[i].pdb_iupac," HB",3)==0) {
	strcpy(model->PDB[i].pdb_iupac,"1HB  ");
	if (strncmp(model->PDB[i-1].pdb_iupac,"1HB  ",5)==0) 
	  strcpy(model->PDB[i].pdb_iupac,"2HB  ");
	if (strncmp(model->PDB[i-1].pdb_iupac,"2HB  ",5)==0) 
	  strcpy(model->PDB[i].pdb_iupac,"3HB  ");
      }
    }
    
    /*
     * two betas in general for fifteen residues
     */
    if ((strncmp(model->PDB[i].pdb_res,"TYR",3)==0) ||
	(strncmp(model->PDB[i].pdb_res,"TRP",3)==0) ||
	(strncmp(model->PDB[i].pdb_res,"SER",3)==0) ||
	(strncmp(model->PDB[i].pdb_res,"PHE",3)==0) ||
	(strncmp(model->PDB[i].pdb_res,"ASP",3)==0) ||
	(strncmp(model->PDB[i].pdb_res,"ARG",3)==0) ||
	(strncmp(model->PDB[i].pdb_res,"HIS",3)==0) ||
	(strncmp(model->PDB[i].pdb_res,"GLN",3)==0) ||
	(strncmp(model->PDB[i].pdb_res,"CYS",3)==0) ||
	(strncmp(model->PDB[i].pdb_res,"ASN",3)==0) ||
	(strncmp(model->PDB[i].pdb_res,"LEU",3)==0) ||
	(strncmp(model->PDB[i].pdb_res,"GLU",3)==0) ||
	(strncmp(model->PDB[i].pdb_res,"MET",3)==0) ||
	(strncmp(model->PDB[i].pdb_res,"PRO",3)==0) ||
	(strncmp(model->PDB[i].pdb_res,"LYS",3)==0)) {
      if (strncmp(model->PDB[i].pdb_iupac," HB",3)==0)  {
	strcpy(model->PDB[i].pdb_iupac,"1HB  ");
	if (strncmp(model->PDB[i-1].pdb_iupac,"1HB  ",5)==0) 
	  strcpy(model->PDB[i].pdb_iupac,"2HB  ");
      }
    }
    
    /*
     * gammas
     */
    if ((strncmp(model->PDB[i].pdb_res,"PRO",3)==0) ||
	(strncmp(model->PDB[i].pdb_res,"MET",3)==0) ||
	(strncmp(model->PDB[i].pdb_res,"GLU",3)==0) ||
	(strncmp(model->PDB[i].pdb_res,"GLN",3)==0) ||
	(strncmp(model->PDB[i].pdb_res,"ARG",3)==0) ||
	(strncmp(model->PDB[i].pdb_res,"LYS",3)==0)) {
      if (strncmp(model->PDB[i].pdb_iupac," HG",3)==0)  {
	strcpy(model->PDB[i].pdb_iupac,"1HG  ");
	if (strncmp(model->PDB[i-1].pdb_iupac,"1HG  ",5)==0) 
	  strcpy(model->PDB[i].pdb_iupac,"2HG  ");
      }
    }
    
    if (strncmp(model->PDB[i].pdb_res,"THR",3)==0)  {
      if (strncmp(model->PDB[i].pdb_iupac," HG2",4)==0)  {
	strcpy(model->PDB[i].pdb_iupac,"1HG2 ");
	if (strncmp(model->PDB[i-1].pdb_iupac,"1HG2 ",5)==0) 
	  strcpy(model->PDB[i].pdb_iupac,"2HG2 ");
	if (strncmp(model->PDB[i-1].pdb_iupac,"2HG2 ",5)==0) 
	  strcpy(model->PDB[i].pdb_iupac,"3HG2 ");
      }
    }

    if (strncmp(model->PDB[i].pdb_res,"VAL",3)==0) {
      if (strncmp(model->PDB[i].pdb_iupac," HG1",4)==0) {
	strcpy(model->PDB[i].pdb_iupac,"1HG1 ");
	if (strncmp(model->PDB[i-1].pdb_iupac,"1HG1 ",5)==0) 
	  strcpy(model->PDB[i].pdb_iupac,"2HG1 ");
	if (strncmp(model->PDB[i-1].pdb_iupac,"2HG1 ",5)==0) 
	  strcpy(model->PDB[i].pdb_iupac,"3HG1 ");
      }
      if (strncmp(model->PDB[i].pdb_iupac," HG2",4)==0) {
	strcpy(model->PDB[i].pdb_iupac,"1HG2 ");
	if (strncmp(model->PDB[i-1].pdb_iupac,"1HG2 ",5)==0) 
	  strcpy(model->PDB[i].pdb_iupac,"2HG2 ");
	if (strncmp(model->PDB[i-1].pdb_iupac,"2HG2 ",5)==0) 
	  strcpy(model->PDB[i].pdb_iupac,"3HG2 ");
      }
    }

    if (strncmp(model->PDB[i].pdb_res,"ILE",3)==0) {
      if (strncmp(model->PDB[i].pdb_iupac," HG1",4)==0) {
	strcpy(model->PDB[i].pdb_iupac,"1HG1 ");
	if (strncmp(model->PDB[i-1].pdb_iupac,"1HG1 ",5)==0) 
	  strcpy(model->PDB[i].pdb_iupac,"2HG1 ");
      }
      if (strncmp(model->PDB[i].pdb_iupac," HG2",4)==0) {
	strcpy(model->PDB[i].pdb_iupac,"1HG2 ");
	if (strncmp(model->PDB[i-1].pdb_iupac,"1HG2 ",5)==0) 
	  strcpy(model->PDB[i].pdb_iupac,"2HG2 ");
	if (strncmp(model->PDB[i-1].pdb_iupac,"2HG2 ",5)==0) 
	  strcpy(model->PDB[i].pdb_iupac,"3HG2 ");
      }
    }

    /*
     * deltas
     * case PRO, LYS, ARG
     */
    if ((strncmp(model->PDB[i].pdb_res,"PRO",3)==0) ||
	(strncmp(model->PDB[i].pdb_res,"LYS",3)==0) ||
	(strncmp(model->PDB[i].pdb_res,"ARG",3)==0)) {
      if (strncmp(model->PDB[i].pdb_iupac," HD",3)==0)  {
	strcpy(model->PDB[i].pdb_iupac,"1HD  ");
	if (strncmp(model->PDB[i-1].pdb_iupac,"1HD  ",5)==0) 
	  strcpy(model->PDB[i].pdb_iupac,"2HD  ");
      }
    }

    /*
     * Case ASN
     */
    if (strncmp(model->PDB[i].pdb_res,"ASN",3)==0) {
      if (strncmp(model->PDB[i].pdb_iupac," HD2 ",5)==0)  {
	strcpy(model->PDB[i].pdb_iupac,"1HD2 ");
	if (strncmp(model->PDB[i-1].pdb_iupac,"1HD2 ",5)==0) 
	  strcpy(model->PDB[i].pdb_iupac,"2HD2 ");
      }
    }

    /*
     * Case ILE
     */
    if (strncmp(model->PDB[i].pdb_res,"ILE",3)==0) {
      if (strncmp(model->PDB[i].pdb_iupac," HD",3)==0)  {
	strcpy(model->PDB[i].pdb_iupac,"1HD1 ");
	if (strncmp(model->PDB[i-1].pdb_iupac,"1HD1 ",5)==0) 
	  strcpy(model->PDB[i].pdb_iupac,"2HD1 ");
	if (strncmp(model->PDB[i-1].pdb_iupac,"2HD1 ",5)==0) 
	  strcpy(model->PDB[i].pdb_iupac,"3HD1 ");
      }
    }
    
    /*
     * Case LEU
     */
    if (strncmp(model->PDB[i].pdb_res,"LEU",3)==0) {
      if (strncmp(model->PDB[i].pdb_iupac," HD1",4)==0) {
	strcpy(model->PDB[i].pdb_iupac,"1HD1 ");
	if (strncmp(model->PDB[i-1].pdb_iupac,"1HD1 ",5)==0) 
	  strcpy(model->PDB[i].pdb_iupac,"2HD1 ");
	if (strncmp(model->PDB[i-1].pdb_iupac,"2HD1 ",5)==0) 
	  strcpy(model->PDB[i].pdb_iupac,"3HD1 ");
      }
    }
    
    if (strncmp(model->PDB[i].pdb_res,"LEU",3)==0) {
      if (strncmp(model->PDB[i].pdb_iupac," HD2 ",5)==0) {
	strcpy(model->PDB[i].pdb_iupac,"1HD2 ");
	if (strncmp(model->PDB[i-1].pdb_iupac,"1HD2 ",5)==0) 
	  strcpy(model->PDB[i].pdb_iupac,"2HD2 ");
	if (strncmp(model->PDB[i-1].pdb_iupac,"2HD2 ",5)==0) 
	  strcpy(model->PDB[i].pdb_iupac,"3HD2 ");
      }
    }

    /*
     * epsilons
     *
     * case LYS
     */
    if (strncmp(model->PDB[i].pdb_res,"LYS",3)==0) {
      if (strncmp(model->PDB[i].pdb_iupac," HE",3)==0)  {
	strcpy(model->PDB[i].pdb_iupac,"1HE  ");
	if (strncmp(model->PDB[i-1].pdb_iupac,"1HE  ",5)==0) 
	  strcpy(model->PDB[i].pdb_iupac,"2HE  ");
      }
    }

    /*
     * case GLN
     */
    if (strncmp(model->PDB[i].pdb_res,"GLN",3)==0) {
      if (strncmp(model->PDB[i].pdb_iupac," HE2",4)==0)  {
	strcpy(model->PDB[i].pdb_iupac,"1HE2 ");
	if (strncmp(model->PDB[i-1].pdb_iupac,"1HE2 ",5)==0) 
	  strcpy(model->PDB[i].pdb_iupac,"2HE2 ");
      }
    }
    
    /*
     * case MET
     */
    if ((strncmp(model->PDB[i].pdb_res,"MET",3)==0)) {
      if (strncmp(model->PDB[i].pdb_iupac," HE",3)==0) {
	strcpy(model->PDB[i].pdb_iupac,"1HE  ");
	if (strncmp(model->PDB[i-1].pdb_iupac,"1HE  ",5)==0) 
	  strcpy(model->PDB[i].pdb_iupac,"2HE  ");
	if (strncmp(model->PDB[i-1].pdb_iupac,"2HE  ",5)==0) 
	  strcpy(model->PDB[i].pdb_iupac,"3HE  ");
      }
    }

    /*
     * zetas (Z)
     */
    if (strncmp(model->PDB[i].pdb_res,"LYS",3)==0) {
      if (strncmp(model->PDB[i].pdb_iupac," HZ",3)==0) {
	strcpy(model->PDB[i].pdb_iupac,"1HZ  ");
	if (strncmp(model->PDB[i-1].pdb_iupac,"1HZ  ",5)==0) 
	  strcpy(model->PDB[i].pdb_iupac,"2HZ  ");
	if (strncmp(model->PDB[i-1].pdb_iupac,"2HZ  ",5)==0) 
	  strcpy(model->PDB[i].pdb_iupac,"3HZ  ");
      }
    }
    
    /*
     * etas (H)
     */
    if (strncmp(model->PDB[i].pdb_res,"ARG",3)==0) {
      if (strncmp(model->PDB[i].pdb_iupac," HH1",4)==0) {
	strcpy(model->PDB[i].pdb_iupac,"1HH1  ");
	if (strncmp(model->PDB[i-1].pdb_iupac,"1HH1  ",5)==0) 
	  strcpy(model->PDB[i].pdb_iupac,"2HH1  ");
      }
      if (strncmp(model->PDB[i].pdb_iupac," HH2",4)==0) {
	strcpy(model->PDB[i].pdb_iupac,"1HH2  ");
	if (strncmp(model->PDB[i-1].pdb_iupac,"1HH2  ",5)==0) 
	  strcpy(model->PDB[i].pdb_iupac,"2HH2  ");
      }
    }
    
  after_ecepp:
    
    /*
     * This for input NOT in ECEPP format
     * DISMAN, DIANA, XPLOR, CONGEN, PDB, etc
     *
     */

    /*
     * ASN OR GLN  DISMAN or DIANA
     */
    if ((strncmp(model->PDB[i].pdb_res,"ASN",3)==0) ||
	(strncmp(model->PDB[i].pdb_res,"GLN",3)==0)) {
      if (strncmp(model->PDB[i].pdb_iupac," HEE ",5)==0) 
	strcpy(model->PDB[i].pdb_iupac," HE21");
      if (strncmp(model->PDB[i].pdb_iupac," HEZ ",5)==0) 
	strcpy(model->PDB[i].pdb_iupac," HE22");
      if (strncmp(model->PDB[i].pdb_iupac," HDE ",5)==0) 
	strcpy(model->PDB[i].pdb_iupac," HD21");
      if (strncmp(model->PDB[i].pdb_iupac," HDZ ",5)==0) 
	strcpy(model->PDB[i].pdb_iupac," HD22");
    }

    /*
     * HIS DISMAN or DIANA
     */
    if (strncmp(model->PDB[i].pdb_res,"HIS",3)==0) {
      if (strncmp(model->PDB[i].pdb_iupac," HD4 ",5)==0) 
	strcpy(model->PDB[i].pdb_iupac," HD2 ");
      if (koption != 0) /* NOT pdb */
	if (strncmp(model->PDB[i].pdb_iupac," HE2 ",5)==0) 
	  strcpy(model->PDB[i].pdb_iupac," HE1 ");
      if (strncmp(model->PDB[i].pdb_iupac," CG5 ",5)==0) 
	strcpy(model->PDB[i].pdb_iupac," CG  ");
      if (strncmp(model->PDB[i].pdb_iupac," CD4 ",5)==0) 
	strcpy(model->PDB[i].pdb_iupac," CD2 ");
      if (strncmp(model->PDB[i].pdb_iupac," NE3 ",5)==0) 
	strcpy(model->PDB[i].pdb_iupac," NE2 ");
      if (strncmp(model->PDB[i].pdb_iupac," CE2 ",5)==0) 
	strcpy(model->PDB[i].pdb_iupac," CE1 ");
    }

    /*
     * ILE DISMAN or DIANA
     */
    if (strncmp(model->PDB[i].pdb_res,"ILE",3)==0)  {
      if (strncmp(model->PDB[i].pdb_iupac," HG1 ",5)==0) 
	strcpy(model->PDB[i].pdb_iupac," HG11");
      if (strncmp(model->PDB[i].pdb_iupac," HG2 ",5)==0) 
	strcpy(model->PDB[i].pdb_iupac," HG12");
      if (strncmp(model->PDB[i].pdb_iupac," HG3 ",5)==0) 
	strcpy(model->PDB[i].pdb_iupac," HG21");
      if (strncmp(model->PDB[i].pdb_iupac," HG4 ",5)==0) 
	strcpy(model->PDB[i].pdb_iupac," HG22");
      if (strncmp(model->PDB[i].pdb_iupac," HG5 ",5)==0) 
	strcpy(model->PDB[i].pdb_iupac," HG23");

      if (koption > 1) { /* This is PDB format from CONGEN or XPLOR */
	/* 
	   if (strncmp(model->PDB[i].pdb_iupac," CD1 ",5)==0) 
	   strcpy(model->PDB[i].pdb_iupac," CD  ");
	*/
	if ((strncmp(model->PDB[i].pdb_iupac," HD11",5)==0) ||
	    (strncmp(model->PDB[i].pdb_iupac,"1HD1 ",5)==0))
	  strcpy(model->PDB[i].pdb_iupac," HD1 ");
	if ((strncmp(model->PDB[i].pdb_iupac," HD11",5)==0) ||
	    (strncmp(model->PDB[i].pdb_iupac,"2HD1 ",5)==0))
	  strcpy(model->PDB[i].pdb_iupac," HD2 ");
	if ((strncmp(model->PDB[i].pdb_iupac," HD13",5)==0) ||
	    (strncmp(model->PDB[i].pdb_iupac,"3HD1 ",5)==0))
	  strcpy(model->PDB[i].pdb_iupac," HD3 ");
      }
    }
    
    if (strncmp(model->PDB[i].pdb_res,"LEU",3)==0)  {
      if (strncmp(model->PDB[i].pdb_iupac," HD1 ",5)==0) 
	strcpy(model->PDB[i].pdb_iupac," HD11");
      if (strncmp(model->PDB[i].pdb_iupac," HD2 ",5)==0) 
	strcpy(model->PDB[i].pdb_iupac," HD12");
      if (strncmp(model->PDB[i].pdb_iupac," HD3 ",5)==0) 
	strcpy(model->PDB[i].pdb_iupac," HD13");
      if (strncmp(model->PDB[i].pdb_iupac," HD4 ",5)==0) 
	strcpy(model->PDB[i].pdb_iupac," HD21");
      if (strncmp(model->PDB[i].pdb_iupac," HD5 ",5)==0) 
	strcpy(model->PDB[i].pdb_iupac," HD22");
      if (strncmp(model->PDB[i].pdb_iupac," HD6 ",5)==0) 
	strcpy(model->PDB[i].pdb_iupac," HD23");
    }
    
    if (strncmp(model->PDB[i].pdb_res,"SER",3)==0) 
      if (strncmp(model->PDB[i].pdb_iupac," HG  ",5)==0) 
	strcpy(model->PDB[i].pdb_iupac," HG1 ");
    
    if (strncmp(model->PDB[i].pdb_res,"THR",3)==0)  {
      if (strncmp(model->PDB[i].pdb_iupac," HG2 ",5)==0) 
	strcpy(model->PDB[i].pdb_iupac," HG21");
      if (strncmp(model->PDB[i].pdb_iupac," HG3 ",5)==0) 
	strcpy(model->PDB[i].pdb_iupac," HG22");
      if (strncmp(model->PDB[i].pdb_iupac," HG4 ",5)==0) 
	strcpy(model->PDB[i].pdb_iupac," HG23");
    }
    
    if (koption == 1)  { /* This is a DISMAN input */
      if ((strncmp(model->PDB[i].pdb_res,"TYR",3)==0) ||
	  (strncmp(model->PDB[i].pdb_res,"PHE",3)==0)) {
	if (strncmp(model->PDB[i].pdb_iupac," HZ4 ",5)==0) 
	  strcpy(model->PDB[i].pdb_iupac," HZ  ");
	if (strncmp(model->PDB[i].pdb_iupac," HD2 ",5)==0) 
	  strcpy(model->PDB[i].pdb_iupac," HD1 ");
	if (strncmp(model->PDB[i].pdb_iupac," HE3 ",5)==0) 
	  strcpy(model->PDB[i].pdb_iupac," HE1 ");
	if (strncmp(model->PDB[i].pdb_iupac," HE5 ",5)==0) 
	  strcpy(model->PDB[i].pdb_iupac," HE2 ");
	if (strncmp(model->PDB[i].pdb_iupac," HD6 ",5)==0) 
	  strcpy(model->PDB[i].pdb_iupac," HD2 ");
	if (strncmp(model->PDB[i].pdb_iupac," CG1 ",5)==0) 
	  strcpy(model->PDB[i].pdb_iupac," CG  ");
	if (strncmp(model->PDB[i].pdb_iupac," CZ4 ",5)==0) 
	  strcpy(model->PDB[i].pdb_iupac," CZ  ");
	if (strncmp(model->PDB[i].pdb_iupac," CD2 ",5)==0) 
	  strcpy(model->PDB[i].pdb_iupac," CD1 ");
	if (strncmp(model->PDB[i].pdb_iupac," CD6 ",5)==0) 
	  strcpy(model->PDB[i].pdb_iupac," CD2 ");
	if (strncmp(model->PDB[i].pdb_iupac," CE5 ",5)==0) 
	  strcpy(model->PDB[i].pdb_iupac," CE2 ");
	if (strncmp(model->PDB[i].pdb_iupac," CE3 ",5)==0) 
	  strcpy(model->PDB[i].pdb_iupac," CE1 ");
      }
      
      if (strncmp(model->PDB[i].pdb_res,"TRP",3)==0) {
	if (strncmp(model->PDB[i].pdb_iupac," CD2 ",5)==0) 
	  strcpy(model->PDB[i].pdb_iupac," CD1 ");
	if (strncmp(model->PDB[i].pdb_iupac," CG3 ",5)==0) 
	  strcpy(model->PDB[i].pdb_iupac," CG  ");
	if (strncmp(model->PDB[i].pdb_iupac," CE4 ",5)==0) 
	  strcpy(model->PDB[i].pdb_iupac," CE3 ");
	if (strncmp(model->PDB[i].pdb_iupac," CD9 ",5)==0) 
	  strcpy(model->PDB[i].pdb_iupac," CD2 ");
	if (strncmp(model->PDB[i].pdb_iupac," CE8 ",5)==0) 
	  strcpy(model->PDB[i].pdb_iupac," CE2 ");
	if (strncmp(model->PDB[i].pdb_iupac," CZ5 ",5)==0) 
	  strcpy(model->PDB[i].pdb_iupac," CZ3 ");
	if (strncmp(model->PDB[i].pdb_iupac," CZ7 ",5)==0) 
	  strcpy(model->PDB[i].pdb_iupac," CZ2 ");
	if (strncmp(model->PDB[i].pdb_iupac," CH6 ",5)==0) 
	  strcpy(model->PDB[i].pdb_iupac," CH2 ");
	if (strncmp(model->PDB[i].pdb_iupac," HE4 ",5)==0) 
	  strcpy(model->PDB[i].pdb_iupac," HE3 ");
	if (strncmp(model->PDB[i].pdb_iupac," HZ5 ",5)==0) 
	  strcpy(model->PDB[i].pdb_iupac," HZ3 ");
	if (strncmp(model->PDB[i].pdb_iupac," HH6 ",5)==0) 
	  strcpy(model->PDB[i].pdb_iupac," HH2 ");
	if (strncmp(model->PDB[i].pdb_iupac," HZ7 ",5)==0) 
	  strcpy(model->PDB[i].pdb_iupac," HZ2 ");
	if (strncmp(model->PDB[i].pdb_iupac," HD2 ",5)==0) 
	  strcpy(model->PDB[i].pdb_iupac," HD1 ");
      }
    }
    
    if (strncmp(model->PDB[i].pdb_res,"VAL",3)==0) {
      if (strncmp(model->PDB[i].pdb_iupac," HG1 ",5)==0) 
	strcpy(model->PDB[i].pdb_iupac," HG11");
      if (strncmp(model->PDB[i].pdb_iupac," HG2 ",5)==0) 
	strcpy(model->PDB[i].pdb_iupac," HG12");
      if (strncmp(model->PDB[i].pdb_iupac," HG3 ",5)==0) 
	strcpy(model->PDB[i].pdb_iupac," HG13");
      if (strncmp(model->PDB[i].pdb_iupac," HG4 ",5)==0) 
	strcpy(model->PDB[i].pdb_iupac," HG21");
      if (strncmp(model->PDB[i].pdb_iupac," HG5 ",5)==0) 
	strcpy(model->PDB[i].pdb_iupac," HG22");
      if (strncmp(model->PDB[i].pdb_iupac," HG6 ",5)==0) 
	strcpy(model->PDB[i].pdb_iupac," HG23"); 
    }
    
    /*
     * Change ALL hydrogen names to PDB convention, i. e., put the
     * number for that hydrogen in character 0th of the array.
     * Examples:
     *  ' HB2 '   ->   '2HB  '
     *  ' HG12'   ->   '2HG1 '
     * and so on ...
     * The character string goes from 0..4, so we check if char 4 is
     * space and then if char 3 is _NOT_ a letter. This last check
     * is due to the fact of terminal hydrogens like ' HXT ' that in
     * the past were _NOT_ properly recognized by PDBStat.
     *
     */
    if ((model->PDB[i].pdb_iupac[1] == 'H') &&
	(model->PDB[i].pdb_iupac[0] == ' ')) {
      if ( (model->PDB[i].pdb_iupac[4] == ' ') && 
	   isdigit(model->PDB[i].pdb_iupac[3]) ) {
	model->PDB[i].pdb_iupac[0] = model->PDB[i].pdb_iupac[3];
	model->PDB[i].pdb_iupac[3] = ' ';
      } else {
	model->PDB[i].pdb_iupac[0] = model->PDB[i].pdb_iupac[4];
	model->PDB[i].pdb_iupac[4] = ' ';
      }
    }      
    
    /*
     * BOC and TIMG were special cases I was studying in Valencia
     * and I needed this to make PDBStat read the files.
     */
    if (((model->PDB[i].pdb_iupac[2] == '1') ||
	 (model->PDB[i].pdb_iupac[2] == '2') ||
	 (model->PDB[i].pdb_iupac[2] == '3')) && 
	(model->PDB[i].pdb_iupac[1] != 'N') &&     /* This added for TIMG */
	(model->PDB[i].pdb_iupac[1] != 'O') &&     /* This added for BOC */
	(model->PDB[i].pdb_iupac[1] != 'C')) {     /* This added for BOC */
      model->PDB[i].pdb_iupac[0] = 
	model->PDB[i].pdb_iupac[2];
      model->PDB[i].pdb_iupac[2] = ' ';
    }

    if (koption == 3) { /* This is PDB XPLOR format */
      if ((strncmp(model->PDB[i].pdb_iupac,"1H   ",5)==0)||
	  (strncmp(model->PDB[i].pdb_iupac,"1HT  ",5)==0))
	strcpy(model->PDB[i].pdb_iupac," HT1 "); 
      if ((strncmp(model->PDB[i].pdb_iupac,"2H   ",5)==0)||
	  (strncmp(model->PDB[i].pdb_iupac,"2HT  ",5)==0))
	strcpy(model->PDB[i].pdb_iupac," HT2 "); 
      if ((strncmp(model->PDB[i].pdb_iupac,"3H   ",5)==0) ||
	  (strncmp(model->PDB[i].pdb_iupac,"3HT  ",5)==0))
	strcpy(model->PDB[i].pdb_iupac," HT3 "); 
      if ((strncmp(model->PDB[i].pdb_iupac," O   ",5)==0) &&
	  (model->PDB[i].pdb_num_res ==
	   model->number_of_residues))
	strcpy(model->PDB[i].pdb_iupac," OT1 "); 
      if (strncmp(model->PDB[i].pdb_iupac," OXT ",5)==0) 
	strcpy(model->PDB[i].pdb_iupac," OT2 "); 
      if (strncmp(model->PDB[i].pdb_iupac," NT  ",5)==0) 
	strcpy(model->PDB[i].pdb_iupac," N   "); 
      if (strncmp(model->PDB[i].pdb_iupac," H   ",5)==0) 
	strcpy(model->PDB[i].pdb_iupac," HN  "); 
    }
  }
 
  /* Create XPLOR names */

  /* Create DIANA names */

  /*
   * Cleaning coordinates to fullfill IUPAC-IUB and PDB requirements
   */
  
  if (koption == 0)
    for ( i = 1 ; i < MAX ; ++i)
      clean_pdb(i);
  
  /*AAAA
   * Cleaning chirality of residues 
   */
  
  /* VAL */
  
  /*
     if (koption == 0)
     for ( i = 1 ; i < MAX ; ++i){
     while (strncmp(model->PDB[i].pdb_res,"VAL",3)==0) {
	    if (!change) 
	      {
		inires = i ;
		++change ;
	      }
	    endres = i ;
	    if (strncmp(model->PDB[i].pdb_iupac," N  ",4)==0) 
	      p_n   = i ;
	    if (strncmp(model->PDB[i].pdb_iupac," CA ",4)==0) 
	      p_ca  = i ;
	    if (strncmp(model->PDB[i].pdb_iupac," CB ",4)==0) 
	      p_cb  = i ;
	    if (strncmp(model->PDB[i].pdb_iupac," CG1",4)==0) 
	      p_cg1 = i ;
	    if (strncmp(model->PDB[i].pdb_iupac," CG2",4)==0) 
	      p_cg2 = i ;
	    if (strncmp(model->PDB[i].pdb_iupac," HB ",4)==0) 
	      p_hb  = i ;
	  }
	if (valine)
	  {
	    clean_val(inires, endres, p_n, p_ca, p_cb, p_cg1, p_cg2, p_hb) ;
	    valine = 0 ;
	  }
      }
  change = 0 ;
  */

  /* TYR and PHE */

  /*
  if (koption == 0)
    for ( i = 1 ; i < MAX ; ++i)
      {
	while ((strncmp(model->PDB[i].pdb_res,"PHE",3)==0) ||
	       (strncmp(model->PDB[i].pdb_res,"TYR",3)==0))
	  {
	    if (!change) 
	      {
		inires = i ;
		++change ;
	      }
	    endres = i ;
	    if (strncmp(model->PDB[i].pdb_iupac," N  ",4)==0) 
	      p_n   = i ;
	    if (strncmp(model->PDB[i].pdb_iupac," CA ",4)==0) 
	      p_ca  = i ;
	    if (strncmp(model->PDB[i].pdb_iupac," CB ",4)==0) 
	      p_cb  = i ;
	    if (strncmp(model->PDB[i].pdb_iupac," CG ",4)==0) 
	      p_cg  = i ;
	    if (strncmp(model->PDB[i].pdb_iupac," CD1",4)==0) 
	      p_cd1 = i ;
	    if (strncmp(model->PDB[i].pdb_iupac," CD2",4)==0) 
	      p_cd2 = i ;
	    if (strncmp(model->PDB[i].pdb_iupac," HB ",4)==0) 
	      p_hb  = i ;
	  }
	clean_aro(inires,endres,p_n,p_ca,p_cb,p_cg,p_cd1,p_cd2) ;
      }
      */
  return ;
}


/* ========================================================================= */
void clean_pdb(int i)
{  
  struct models *model ;

  model = MODELS+key_model ;

  /*
   * This is new (Aug, 96). PHE, TYR and HIS has HD1,HD2,HE1,HE2
   * Added ASP HD2 and GLU HE2, 2002.
   */
  if ((strncmp(model->PDB[i].pdb_res,"PHE",3)==0) || (strncmp(model->PDB[i].pdb_res,"TYR",3)==0) ||
      (strncmp(model->PDB[i].pdb_res,"ASP",3)==0) || (strncmp(model->PDB[i].pdb_res,"GLU",3)==0) ||
      (strncmp(model->PDB[i].pdb_res,"HIS",3)==0)) {
    if ((strncmp(model->PDB[i].pdb_iupac,"1HE",3)==0) ||
	(strncmp(model->PDB[i].pdb_iupac,"2HE",3)==0) ||
	(strncmp(model->PDB[i].pdb_iupac,"1HD",3)==0) ||
	(strncmp(model->PDB[i].pdb_iupac,"2HD",3)==0)) {
      model->PDB[i].pdb_iupac[3] = model->PDB[i].pdb_iupac[0] ;
      model->PDB[i].pdb_iupac[0] = ' ';
    }
  }
  
  /*
   * ILE is CD1 and 1HD1, 2HD1, 3HD1 in PDB
   */
  if (strncmp(model->PDB[i].pdb_res,"ILE",3)==0) {
    if (strncmp(model->PDB[i].pdb_iupac," CD",3)==0)
      model->PDB[i].pdb_iupac[3]='1';
    /* This is kind of redundant as this SHOULD be done before */
    if (model->PDB[i].pdb_iupac[1]=='H' &&
	model->PDB[i].pdb_iupac[2]=='D')
      model->PDB[i].pdb_iupac[3]='1';
  }

  /*
   * SER has OG and then HG ( *not* HG1)
   */
  if (strncmp(model->PDB[i].pdb_res,"SER",3)==0)
    if (model->PDB[i].pdb_iupac[1]=='H' &&
	model->PDB[i].pdb_iupac[2]=='G') {
      model->PDB[i].pdb_iupac[0]=' ';
      model->PDB[i].pdb_iupac[1]='H';
      model->PDB[i].pdb_iupac[2]='G';
      model->PDB[i].pdb_iupac[3]=' ';
    }
  
  /*
   * THR should be HG1 ( *not* 1HG)
   * Thanks, Janet!!
   */
  if (strncmp(model->PDB[i].pdb_res,"THR",3)==0)
    if (model->PDB[i].pdb_iupac[0]=='1' &&
	model->PDB[i].pdb_iupac[1]=='H' &&
	model->PDB[i].pdb_iupac[2]=='G' &&
	model->PDB[i].pdb_iupac[3]==' ') {
      model->PDB[i].pdb_iupac[0]=' ';
      model->PDB[i].pdb_iupac[1]='H';
      model->PDB[i].pdb_iupac[2]='G';
      model->PDB[i].pdb_iupac[3]='1';
    }
  
  /*
   * TRP has slightly different name conventions
   * HD1, HD2 instead of 1HD, 2HD and so on
   */
  if (strncmp(model->PDB[i].pdb_res,"TRP",3)==0)
    if (model->PDB[i].pdb_iupac[1]=='H' &&
	((model->PDB[i].pdb_iupac[2]=='D') ||
	 (model->PDB[i].pdb_iupac[2]=='E') ||
	 (model->PDB[i].pdb_iupac[2]=='Z') ||
	 (model->PDB[i].pdb_iupac[2]=='H'))) {
      model->PDB[i].pdb_iupac[3]=
	model->PDB[i].pdb_iupac[0] ;
      model->PDB[i].pdb_iupac[0]=' ';
    }  
  return ;
}






/* ========================================================================= */
/*   Here should go the routines for checking chirality */
/* ========================================================================= */
/*
void clean_asp(int inires, int endres, int p_n, int pc_a, int p_cb, int p_cg,
	       int p_cd1, int p_cd2) 
{
  return ;
}

void clean_glu(int inires, int endres, int p_n, int pc_a, int p_cb, int p_cg,
	       int p_cd1, int p_cd2) 
{
  return ;
}

void clean_leu(int inires, int endres, int p_n, int pc_a, int p_cb, int p_cg,
	       int p_cd1, int p_cd2) 
{
  return ;
}

void clean_val(int inires, int endres, int p_n, int p_ca, int p_cb, int p_cg1,
	       int p_cg2, int p_hb) 
{
  if (((dihang(p_n,p_ca,p_cb,p_cg1)-dihang(p_n,p_ca,p_cb,p_hb)) <
       ((dihang(p_n,p_ca,p_cb,p_cg1)-dihang(p_n,p_ca,p_cb,p_hb)))))
      printf(" --- a cambiar VAL \n ");
  return ;
}

void clean_ile(int inires, int endres, int p_n, int pc_a, int p_cb, int p_cg,
	       int p_cd1, int p_cd2) 
{
  return ;
}

void clean_thr(int inires, int endres, int p_n, int pc_a, int p_cb, int p_cg,
	       int p_cd1, int p_cd2) 
{
  return ;
}


void clean_aro(int inires, int endres, int p_n, int pc_a, int p_cb, int p_cg,
	       int p_cd1, int p_cd2) 
{
  return ;
}
*/
