/*$Id: check_planar_sc.c,v 3.32 2003/10/06 12:13:32 roberto Exp roberto $*/

#include "pdbstat.h"

char *check_planar_sc(char buenos[10])
{
     static short ll, jcis  ;
     static short badomega, badphipsi, badchir;
     static short i,j,k ;
     extern int   flag_chiral;
     static int    tempvar ;
     static short  tempcount ;
     static struct models *model ;
     
     i=0;
     j=0;
     k=0;
     ll=0;
     jcis=0;
     badomega=0;
     badphipsi=0;
     badchir=0;
     
     for (i = 1; i <= total_models ; i++) {
	  model=MODELS+i;
	  model->BadOmega = FALSE ;
	  model->BadChiral = FALSE ;
	  model->BadSideChain = FALSE ;
	  model->BadRama = FALSE ;
	  model->Cis = FALSE ;
     }
     
     tempvar = key_model;
     fprintf(stdout,"> CHK_chiral: ... Model: %3d", i);
     
     if ((fpi=fopen("DELETE.ME","w"))==NULL) {
	  perror("\n> check_chiral_sc: *NO* write premission in this directory");
	  return ("done") ;
     }
     
     for (i = 1; i <= total_models ; i++) {
	  fprintf(stdout,"\b\b\b%3d", i);
	  key_model = i;
	  phi_psi_chi(fpi,0);
	  fflush(stdout);
     }
     
     fclose(fpi);
     
     if (strncmp(buenos,"show",3)!=0)
	  fprintf(stdout," ... Last model: %3d \n\n",total_models);
     
     for (i = 1 ; i <= total_models ; i++) {
	  model=MODELS+i;
	  for (k = 1; k <= model->number_of_residues ; k++) {
	       if (model->DIH[k].chiral <= 0.0) {
		    model->BadChiral = TRUE ;
		    model->DIH[k].BadResidue = TRUE ;
		    j++; 
		    badchir++;
		    if (strncmp(buenos,"show",3)!=0)
			 printf("> CHK_chiral: >>> Model %2d(%2d),"\
				" residue `%s' %3d is mirror, chiral %f\n",
				i,
				model->modelno,
				model->DIH[k].resname,
				model->DIH[k].resnumber,
				model->DIH[k].chiral);
	       }
	       if (model->DIH[k].chiral_sc <= 0.0) {
		    model->BadSideChain = TRUE ;
		    model->DIH[k].BadResidue = TRUE ;
		    ll++; 
		    badchir++;
		    if (strncmp(buenos,"show",3)!=0)
			 printf("> CHK_chiral: >>> Model %2d(%2d),"\
				" residue `%s' %3d is bad, sc_chir: %8.3f \n",
				i,
				model->modelno,
				model->DIH[k].resname,
				model->DIH[k].resnumber,
				model->DIH[k].chiral_sc);
	       }
	       if ((fabs(model->DIH[k].omega) < 150.0) &&
		   (fabs(model->DIH[k].omega) > 15.0)) {
		    badomega++;
		    model->DIH[k].BadResidue = TRUE ;
		    model->BadOmega = TRUE ;
		    model->BadModel = TRUE ;
		    if (strncmp(buenos,"show",3)!=0)
			 printf("> CHK_omega : >>> Model %2d(%2d),"\
				" residue `%s' %3d is bad, omega= %8.3f \n",
				i,
				model->modelno,
				model->DIH[k].resname,
				model->DIH[k].resnumber,
				model->DIH[k].omega);
	       } else if (fabs(model->DIH[k].omega) <= 15.0) {
		    /*
		     * Look for any CIS residues but PROLINES
		     * We assume PRO can be CIS without trouble
		     */
		    jcis++;
		    model->Cis = TRUE ;
		    if (strncmp(model->DIH[k].resname,"PRO",2)!=0) {
			 model->BadModel = TRUE ;
			 model->DIH[k].BadResidue = TRUE ;
			 if (strncmp(buenos,"show",3)!=0)
			      printf("> CHK_cstrns: >>> Model %2d(%2d),"\
				     " residue `%s' %4d is CIS, omega= %8.3f \n",
				     i,
				     model->modelno,
				     model->DIH[k].resname,
				     model->DIH[k].resnumber,
				     model->DIH[k].omega);
		    } else {
			 if (strncmp(buenos,"show",3)!=0)
			      printf("> CHK_cstrns: *** Model %2d(%2d),"\
				     " residue `%s' %4d is CIS, omega= %8.3f \n",
				     i,
				     model->modelno,
				     model->DIH[k].resname,
				     model->DIH[k].resnumber,
				     model->DIH[k].omega);
		    }
	       }
	       
	       /*
		*  Look for bad values for Ramachandran plots.
		*  If phi is greater than 0.0 and psi lower than 0.0
		*/
	       if ((strcmp(model->DIH[k].resname,"GLY")!=0) &&
		   (model->DIH[k].resnumber > 1) &&
		   ((model->DIH[k].phi > 0.0 &&
		     model->DIH[k].psi < 0.0))) {
		    badphipsi++;
		    model->BadRama = TRUE ;
		    model->BadModel = TRUE ;
		    model->DIH[k].BadResidue = TRUE ;
	       }
	  }
     }
     
     tempcount = 0;
     if (strncmp(buenos,"show",3)!=0) {
	  if ((j!=0) || (ll!=0) || (badomega!=0) || (badchir!=0) ||
	      (jcis!=0) || (badphipsi!=0)) {
	       fprintf(stdout,"> CHK_models: --- Bad model/s are .. \n     " );
	       for (i = 1 ; i <= total_models ; i++) {
		    model = MODELS+i ;
		    if ((model->BadOmega) || (model->BadRama) ||
			(model->BadChiral) || (model->BadModel)) {
			 if (!(tempcount++ % 16)) fprintf(stdout,"\n     ");
			 fprintf(stdout,"%4d",i);
		    }
	       }
	       printf("\n");
	       fprintf(stdout,"> CHK_models: --- Good model/s are .. \n     " );
	       tempcount = 0;
	       for (i = 1 ; i <= total_models ; i++) {
		    model = MODELS+i ;
		    if (!(model->BadOmega) && !(model->BadRama) &&
			!(model->BadChiral) && !(model->BadModel)) {
			 if (!(tempcount++ % 16)) fprintf(stdout,"\n     ");
			 fprintf(stdout,"%4d",i);
		    }	     
	       }
	       printf("\n");
	  } else 
	       fprintf(stdout,"> CHK_models: --- There are NO bad models (hope is good for you!)");
	  printf("\n");
     }
    
     if (strncmp(buenos,"show",3)!=0) {
	  if (badchir == 0) {
	       if (j == 0)
		    printf("> CHK_chiral: --- No mirror detected \n");
	       else
		    printf("> CHK_chiral: >>> MIRROR/S detected \n");
	       if (ll == 0)
		    printf("> CHK_chiral: --- No side chain mirror detected \n");
	       else
		    printf("> CHK_chiral: >>> SIDE CHAIN MIRROR/S detected \n");
	  }
	  if (jcis == 0)
	       printf("> CHK_omega : --- No cis omega detected \n");
	  else
	       printf("> CHK_omega : >>> BAD. CIS omega detected <<<\n");
	  if (badomega == 0)
	       printf("> CHK_omega : --- No bad omega detected \n");
	  else
	       printf("> CHK_omega : >>> BAD omega/s detected <<<\n");
	  if (badphipsi == 0)
	       printf("> CHK_Ramach: --- No bad Ramachandran detected \n");
	  else
	       printf("> CHK_Ramach: >>> BAD Ramachandran detected <<<\n");
     }
     key_model = tempvar;
     if (strncmp(buenos,"bad",2) == 0) {
	  flag_chiral+=99;
	  return ("delete bad");
     }
     if (strncmp(buenos,"good",2) == 0) {
	  flag_chiral+=99;
	  return ("delete good");
     }
     return ("done");
}

