/*$Id: classify_by_energy_insight.c,v 3.32 2003/10/06 12:13:32 roberto Exp roberto $*/

#include "pdbstat.h"

extern void do_copy_model( int from, int to);

void classify_by_energy_insight(void)
{
     /*
      * This routine uses a fast bubble sort algorithm to sort the
      * energies of the models
      * The algorithm can be found in Numerical Recipies..
      */
     static short    i,j, veces;
     static short    StoreModel;
     static div_t    Cont ;
     
     StoreModel = AverageModel+1 ; /* Place to swap models */
     veces = 0 ; 
     if ( DEBUG >= 0 ) {
	     fprintf(stdout,"\n   Sorting models by energy ...   ");
     }
     /* Bubble sort */
     for (j = 2 ; j <= total_models ; j++) {
	  do_copy_model(j,StoreModel); 
	  i = j - 1 ;
	  while ((i > 0) && (MODELS[i].energy > MODELS[StoreModel].energy)) {
	       do_copy_model(i,i+1);
	       i--;
	  }
	  do_copy_model(StoreModel,i+1); 
	  veces++ ;
	  if ( DEBUG >= 0 ) {
	          Cont = div(veces,4);
	          if (Cont.rem == 1) fprintf(stdout,"\b\b/ ");
	          if (Cont.rem == 2) fprintf(stdout,"\b\b- ");
	          if (Cont.rem == 3) fprintf(stdout,"\b\b\\ ");
	          if (Cont.rem == 0) fprintf(stdout,"\b\b| ");
	          fflush(stdout);
	  }
     }
     if ( DEBUG >= 0 ) {
	     fprintf(stdout,"\n");
     }
     
     /* Print out a reversed list of the ordered energies   */
     for (i=total_models;i>=1;i--)
	  printf("> CLASS_enrgy: Family %10s, Model %3d(%3d), energy: %8.3f\n",
		 MODELS[i].family, i, MODELS[i].modelno, MODELS[i].energy);
     
     /* finally give the name and number of lowest energy   */
     printf("\n> CLASS_enrgy: Lowest energy is:%.4f for model (conformer) %d\n",
	    MODELS[1].energy, MODELS[1].modelno);
     
     /* Renumber SerialNumber for all odered models */
     for (i=1; i<=total_models;i++)
	  (MODELS+i)->SerialNumber = i;
     
     return ;
}


void classify_by_sequence(void)
{
  /*
   * This routine uses a fast bubble sort algorithm to sort the
   * models in function of sequence length
   * The algorithm can be found in Numerical Recipies..
   */
  static short    i,j;
  static short    StoreModel ;
  
  StoreModel = AverageModel+1 ;

  /* Bubble sort */
  for (j = 2 ; j <= total_models ; j++) {
    do_copy_model(j,StoreModel);
    i = j - 1 ;
    while ((i > 0) && (MODELS[i].number_of_residues < MODELS[StoreModel].number_of_residues)) {
      do_copy_model(i,i+1);
      i--;
    }
    do_copy_model(StoreModel,i+1);
  }
  
  /* Renumber SerialNumber for all odered models */
  for (i=1; i<=total_models;i++)
    (MODELS+i)->SerialNumber = i;
  
  return ;
}

