/*$Id: delete_model.c,v 3.32 2003/10/06 12:13:32 roberto Exp roberto $*/

/*
 * Little routine to delete selectively models from a list o models
 * being worked out in memory.
 * Also the user can delete selected sets of models for example 
 * good ot bad ones.
 *
 */

#include "pdbstat.h"
extern void do_copy_model(int from, int to);


char  *delete_model(char buenos[MAXWORD], char otros[MAXWORD], char orden[MAXWORD])
{
  static char tmp_char[30] ;
  static int from, to, tempvar ;
  extern int flag_chiral ;
  static short i,k, tempcount ;
  static char cutoff[10];

  from = 0 ;
  to = 0 ;

allofthem:
  if ((strncmp(buenos,"goo",2)==0) || (strncmp(buenos,"bad",2)==0))  {
    if (strncmp(buenos,"bad",2)==0) 
      	sprintf(history[count_history],"delete bad models ");
    
    if (strncmp(buenos,"goo",2)==0) 
      	sprintf(history[count_history],"delete good models ");
    
    if (strncmp(otros,"ramachandran",2)==0){
      	sprintf(history[count_history], "delete bad ramachandran models ");
    }
    
    if (strncmp(otros,"chiral",2)==0){
      	sprintf(history[count_history], "delete bad chiral models ");
    }

    if ((flag_chiral == 0) && ((strncmp(otros,"chiral",2)==0) ||
        (strncmp(otros,"ramachan",2)==0))) {	   
      		printf("> DELETE_MDL: *** Making chiral first for all models ... \n");
       		return ("chiral") ; 
    }

    /* Delete models with bad value of Det(U) in superpositions or fitting */
    if (strncasecmp(otros,"dete",2)==0) {
      tempvar = total_models ;
      if (DEBUG > 5) printf("\n> DELETE_MDL: Looking for DET(U) ");
      for (i = tempvar; i >= 1; i--) {
	if (strncasecmp(buenos,"bad",2)==0) {
	  if (DEBUG > 5) printf("\n> DELETE_MDL: Deleting bad determ");
	  if (MODELS[i].determ == TRUE) {
	    if (DEBUG > 5) 
	      printf("\n> DELETE_MDL: Model %d is bad DET(U)", i);
	    if (i == total_models) {
	      haz_ceros(i);
	    } else {
	      for (k = i+1 ; k <= total_models ; k++)
		do_copy_model(k,k-1);
	    }
	    models-- ;
	    total_models-- ;
	  }
	} else {
	  if (DEBUG > 5) printf("\n> DELETE_MDL: Deleting good determ");
	  if (MODELS[i].determ == FALSE) {
	    if (i == total_models) {
	      haz_ceros(i);
	    } else {
	      for (k = i+1 ; k <= total_models ; k++)
		do_copy_model(k,k-1);
	    }
	    models-- ;
	    total_models-- ;
	  }
	}
      }
      printf("\n");
      (void) strcpy(buenos,"            ");
       return("done"); 
    }

    /* Delete models with energy > cutoff */
    if (strncasecmp(otros,"energy",2)==0) {
      if (ENERGY_CUTOFF == 9999.0) {
        printf("> DELETE_MDL: Energy cutoff : ?_ " ) ;
	GetFromKeyBoard(cutoff, MAXWORD, stdin) ;
        ENERGY_CUTOFF = atof(cutoff) ;
      } 
      printf("> DELETE_MDL: Using ENERGY_CUTOFF of %.3f\n", ENERGY_CUTOFF);
      for (i = total_models; i >= 1; i--) {
	if (strncasecmp(buenos,"bad",2)==0) {
	  if (MODELS[i].energy > ENERGY_CUTOFF) {
	    if (i == total_models) {
	      haz_ceros(i);
	    } else {
	      for (k = i+1 ; k <= total_models ; k++)
		do_copy_model(k,k-1);
	    }
	    models-- ;
	    total_models-- ;
	  }
	} else {
	  if (MODELS[i].energy < ENERGY_CUTOFF) {
	    if (i == total_models) {
	      haz_ceros(i);
	    } else {
	      for (k = i+1 ; k <= total_models ; k++)
		do_copy_model(k,k-1);
	    }
	    models-- ;
	    total_models-- ;
	  }
	}
      }
      printf("\n");
      (void) strcpy(buenos,"            ");
      return("done"); 
    }

    /* Delete models with rmsd > cutoff */
    if (strncasecmp(otros,"rmsd",2)==0) {
      if (RMSD_MODEL_CUTOFF == 9999.0) {
        printf("> DELETE_MDL: Rmsd  cutoff : ?_ " ) ;
	GetFromKeyBoard(cutoff, MAXWORD, stdin);
        RMSD_MODEL_CUTOFF = atof(cutoff) ;
      }
      printf("> DELETE_MDL: Using RMSD_MODEL_CUTOFF of %.2f\n", RMSD_MODEL_CUTOFF);
      for (i = total_models; i >= 1; i--) 
	if (strncasecmp(buenos,"bad",2)==0) {
	  if (MODELS[i].rmsd > RMSD_MODEL_CUTOFF) {
	    if (i == total_models) {
	      haz_ceros(i);
	    } else {
	      for (k = i+1 ; k <= total_models ; k++)
		do_copy_model(k,k-1);
	    }
	    models-- ;
	    total_models-- ;
	  }
	} else {
	  if (MODELS[i].rmsd <= RMSD_MODEL_CUTOFF) {
	    if (i == total_models) {
	      haz_ceros(i);
	    } else {
	      for (k = i+1 ; k <= total_models ; k++)
		do_copy_model(k,k-1);
	    }
	    models-- ;
	    total_models-- ;
	  }
	}
      printf("\n");
      (void) strcpy(buenos,"            ");
      return("done"); 
    }

    /* Delete models with bad ramachandran and/or chiral */
    if (strncmp(buenos,"bad",2)==0) {   /* Deleting bad models */
      fprintf(stdout,"> DELETE_MDL: ... Removing bad models .. \n     ");
      tempcount = 0;
      for (i = total_models ; i >= 1 ; i--)
	if ((MODELS[i].BadModel) ||
            ((strncmp(otros,"ramachandran",2)==0) && (MODELS[i].BadRama))|| 
	    ((strncmp(otros,"chiral",2)==0) && (MODELS[i].BadChiral))) {
	  if  (!(tempcount++ % 16)) fprintf(stdout,"\n     ");
	  fprintf(stdout,"%4d",i);
	  if (i == total_models) 
	    haz_ceros(i);
	  else {
	    for (k = i + 1 ; k <= total_models ; k++)
	      do_copy_model(k,k-1);
	  }
	  total_models-=1;
	  models-=1;
	}
      AverageModel = models+1 ;
      printf("\n");
      (void) strcpy(buenos,"            ");
      return ("done") ; 
    } else if (strncmp(buenos,"goo",2)==0) { /* Deleting good models */
      fprintf(stdout,"> DELETE_MDL: ... Removing good models .. \n     ");
      tempcount = 0;
      for (i = total_models ; i >= 1 ; i--)
	if ((MODELS[i].BadModel) || ((strncmp(otros,"ramachandran",2)==0) && 
				     (MODELS[i].BadRama)) || 
	    ((strncmp(otros,"chiral",2)==0) && (MODELS[i].BadChiral))) {
	  if (!(tempcount++ % 16)) fprintf(stdout,"\n    ");
	  fprintf(stdout,"%4d",i);
	  if (i == total_models) 
	    haz_ceros(i);
	  else {
	    for (k = i + 1 ; k <= total_models ; k++)
	      do_copy_model(k,k-1);
	  }
	  total_models-=1;
	  models-=1;
	}
      AverageModel = models + 1;
      printf("\n");
      (void) strcpy(buenos,"            ");
      return ("done") ;
    }
  }
  
  /* Deleting selected model/s */
  sscanf(orden,"%*s %d %s", &from, tmp_char);
  if ( strncasecmp(tmp_char,"total_m",3)==0 || strncasecmp(tmp_char,"last",3)==0) {
	  to = total_models ;
  } else if ( isdigit(tmp_char[0]) ) {
	  to = atoi(tmp_char);
  } else {
	  to = -1 ;
  }

  if (from == 0) {
    fprintf(stdout, "> DELETE_MDL: Which model/s (no. [or range, two numbers])? : \n");
    GetFromKeyBoard(buenos, MAXWORD, stdin);
    if (strncmp(buenos,"bad",2)==0) goto allofthem;
    sscanf(buenos," %d %d",&from,&to);
  }
  
  if (to <= 0) to = from;
  
  sprintf(history[count_history],"delete model from %d to %d", from,to);
  
  if ((from >= to+1) || (to > AverageModel-1) || (from > AverageModel-1) ||
      (from <= 0) || (to > total_models) || (from > total_models)) {
    printf("> DELETE_MDL: ============================================\n");
    printf("> DELETE_MDL: *** Wrong selection!, Play it again Sam! ***\n");
    printf("> DELETE_MDL: *** when trying to delete from %d to %d  ***\n", from, to);
    printf("> DELETE_MDL: *** This time with the right number, OK? ***\n");
    printf("> DELETE_MDL: ============================================\n");
    return ("done") ;
  }
  
  tempvar = to - from + 1;
  printf("> DELETE_MDL: *** Deleting %2d models from %2d to %2d \n", tempvar, from, to);
  
  if (from == total_models) {
    haz_ceros(from);
    total_models-- ;
    models-- ;
  } else {
    for (i = to + 1 ; i <= total_models ; i++) {
      printf("> DELETE_MDL: --- Moving model %2d(%2d) to %2d(%2d) [of %2d total models]\n", 
             i, MODELS[i].modelno, i-tempvar, MODELS[i-tempvar].modelno, total_models-tempvar); 
      haz_ceros(i-tempvar);  
      do_copy_model(i,(i-tempvar));
    }
    total_models -= tempvar;
    models -= tempvar;
  }
  /* Give them a serial number as found in memory */
  for (i=1; i<= total_models; i++) 
	  MODELS[i].SerialNumber = i;
  AverageModel = models+1 ;
   return ("done") ; 
}
