/*$Id: do_codes_for_constraints.c,v 3.32 2003/10/06 12:13:32 roberto Exp roberto $*/

#include "pdbstat.h"

/*
  ---
  --- CONTACT.OUT
  --- Here we are going to produce an output (table) with the following data
  ---     atom1          atom2        code
  ---    res. num      res. num.    a,b or c 
  --- 
  ---  meanings -> a : backbone-backbone; b: backbone - sidechain
  ---              c : sidechain - sidechain.
  ---
  --- The creation of the output has been commented out as we only want
  --- at this moment the info about the code for constraints. Look 
  --- cautiously at the code as it is highly experimental. Actually this
  --- module has been checked but you should like to change the selection
  ---
  --- As always I assume that the IUPAQ label for the atoms (atom names)
  --- begins in 0th position of the string and with NO spaces before as
  --- we are dealing with NOE structure (At some point I need to fix this
  --- dicotomie between PDB and NOE structures).
  ---
  --- (Roberto Tejero, RTT, June 1993, CABM-Rutgers University)
  ---
*/

void do_codes_for_constraints()
{
     static struct noe *Noe;
     
     /*
      *   Be aware that the selection for the backbone and/or side chain in
      *   this module is more or less whimsical. You should change the code
      *   here for a more rigorous selection of backbone 
      */
     if (DEBUG > 0) printf("> do_codes_for_constraints: entering ..\n");
     Noe = &NOE[1] ;
     while ( Noe->next != NULL ) {
	  if ( !Noe->ToPrint ) {
	       Noe++ ;
	       continue ;   
	  }
	  Noe->code[1]='\0';
	  if (DEBUG >= 3) {
	       fprintf(stdout,"  do_codes_for_constraints(): %s %s \n", Noe->atom_type1,Noe->atom_type2);
	  }
	  if ((strcmp(Noe->atom_type1,"N") == 0) || (strcmp(Noe->atom_type1,"N ") == 0) || 
	      (strcmp(Noe->atom_type1,"CA") == 0) || (strcmp(Noe->atom_type1,"CA ") == 0) ||
	      (strcmp(Noe->atom_type1,"C") == 0) || (strcmp(Noe->atom_type1,"C ") == 0) ||
	      (strcmp(Noe->atom_type1,"O") == 0) || (strcmp(Noe->atom_type1,"O ") == 0) ||
	      (strcmp(Noe->atom_type1,"HN") == 0) || (strcmp(Noe->atom_type1,"HN ") == 0) ||
	      (strcmp(Noe->atom_type1,"H") == 0) || (strcmp(Noe->atom_type1,"H ") == 0) ||
	      (strcmp(Noe->atom_type1,"HA ") == 0) || (strcmp(Noe->atom_type1,"HA") == 0)) {
	       if ((strcmp(Noe->atom_type2,"N") == 0) || (strcmp(Noe->atom_type2,"N ") == 0) || 
		   (strcmp(Noe->atom_type2,"CA") == 0) || (strcmp(Noe->atom_type2,"CA ") == 0) ||
		   (strcmp(Noe->atom_type2,"C") == 0) || (strcmp(Noe->atom_type2,"C ") == 0) ||
		   (strcmp(Noe->atom_type2,"O") == 0) || (strcmp(Noe->atom_type2,"O ") == 0) ||
		   (strcmp(Noe->atom_type2,"HN") == 0) || (strcmp(Noe->atom_type2,"HN ") == 0) ||
		   (strcmp(Noe->atom_type2,"H") == 0) || (strcmp(Noe->atom_type2,"H ") == 0) ||
		   (strcmp(Noe->atom_type2,"HA ") == 0) || (strcmp(Noe->atom_type2,"HA") == 0)) {
		    Noe->code[0]='a';
	       } else {
		    Noe->code[0]='b';
	       }
	  } else {
	       if ((strcmp(Noe->atom_type2,"N") == 0) || (strcmp(Noe->atom_type2,"N ") == 0) || 
		   (strcmp(Noe->atom_type2,"CA") == 0) || (strcmp(Noe->atom_type2,"CA ") == 0) ||
		   (strcmp(Noe->atom_type2,"C") == 0) || (strcmp(Noe->atom_type2,"C ") == 0) ||
		   (strcmp(Noe->atom_type2,"O") == 0) || (strcmp(Noe->atom_type2,"O ") == 0) ||
		   (strcmp(Noe->atom_type2,"HN") == 0) || (strcmp(Noe->atom_type2,"HN ") == 0) ||
		   (strcmp(Noe->atom_type2,"H") == 0) || (strcmp(Noe->atom_type2,"H ") == 0) ||
		   (strcmp(Noe->atom_type2,"HA ") == 0) || (strcmp(Noe->atom_type2,"HA") == 0)) {
		    Noe->code[0]='b';
	       } else {
		    Noe->code[0]='c';
	       }
	  }
	  Noe++ ;
     }
     if (DEBUG > 0) printf("> do_codes_for_constraints: leaving ..\n");
     fflush(stdout);
     fflush(stdout);
     return;
}
