/*$Id: general.h,v 3.32 2003/10/06 12:13:32 roberto Exp roberto $*/

/* 
 * General definitions, declarations and dimensions 
 * Roberto Tejero.
 */  

#include <ctype.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <math.h>

#include "version.h"
#ifndef VERSION
#define VERSION " Version X.XX - With no date and no comments "
#endif

/*
 * Different dimensions for the program. Change as needed
 * The user should only change the maximum number of models or the
 * maximum number of residues. The others should be adjusted automatically
 * as experience dictates .
 */

#define MAXMODELS        900
#define MAXRESIDUES     5000          /* Maximum number of residues per model */
#define MAXATOMS     MAXRESIDUES*17  /* 17 atoms by residue */
#define MAXJCOUP     MAXRESIDUES*15  /* We assume a maximum of 30 J/residue */
#define MAXNOES       100000 
#define MAXWORD          300
#define MAXLINE          300
#define MAXRANGES         60           /* Maximum number of superposition ranges */
#define MAXREMARKRECS    901
#define MAXREMARKMODRECS 101
#define MAXPDBLINES   900000

/*
 * Some mathematical definitions
 */
#define radperdeg   0.01745329251994  /* Radians per degree */
#ifndef PI                            /* Avoid Linux Warnings! */
#define PI   3.14159265358979323846   /* Pi definition */
#endif

/*
 * Global TRUE and FALSE
 */
#define TRUE (char)1
#define FALSE (char)0

/*
 * static char rcsid[] = "$Id" ;
 */

/* ----------------------------------------------------------- */
