/*$Id: info_mol.c,v 3.32 2003/10/06 12:13:32 roberto Exp roberto $*/

#include "pdbstat.h"

/* ========================================================================= */
int info_res(int moledo)
/*
  --- 
  --- Give info for selected model 'moledo'.
  ---
  --- (Roberto Tejero, RTT, June 1993, CABM-Rutgers University).
  --- DEC, 1994. Se anyade la palabra moledo (a posta, es una rotatesis de
  --- modelo) para tratar de aislar un problema en LINUX. Tambien se convierte
  --- la rutina de void en int 
  ---
*/
{
  static int     count, index, res_tmp, critical ;
  static int     natural_res[31] ;
  static char    residue[31][4];
  static struct  models *model ;

  res_tmp = 0;  

  for (index = 1 ; index < 31 ; index++) {
    natural_res[index] = 0;
    strcpy(residue[index],"   ");
  }

  if ((MAX <= 0) || (moledo == 0)) {
    printf("> INFO_res: ** No molecule read ** \n");
    return 0;
  }
  
  model = MODELS + moledo ;

  MAX = model->number_of_atoms + 1;
  
  for (count = 1 ; count < MAX ; count++)
    if (res_tmp != model->PDB[count].pdb_num_res) {
      res_tmp = model->PDB[count].pdb_num_res ;
      if      (strncmp(model->PDB[count].pdb_res,"ALA",3)==0) index = 1;
      else if (strncmp(model->PDB[count].pdb_res,"ARG",3)==0) index =  2;
      else if (strncmp(model->PDB[count].pdb_res,"ASN",3)==0) index =  3;
      else if (strncmp(model->PDB[count].pdb_res,"ASP",3)==0) index =  4;
      else if (strncmp(model->PDB[count].pdb_res,"CYS",3)==0) index =  5;
      else if (strncmp(model->PDB[count].pdb_res,"GLN",3)==0) index =  6;
      else if (strncmp(model->PDB[count].pdb_res,"GLU",3)==0) index =  7;
      else if (strncmp(model->PDB[count].pdb_res,"GLY",3)==0) index =  8;
      else if (strncmp(model->PDB[count].pdb_res,"HIS",3)==0) index =  9;
      else if (strncmp(model->PDB[count].pdb_res,"ILE",3)==0) index = 10;
      else if (strncmp(model->PDB[count].pdb_res,"LEU",3)==0) index = 11;
      else if (strncmp(model->PDB[count].pdb_res,"LYS",3)==0) index = 12;
      else if (strncmp(model->PDB[count].pdb_res,"MET",3)==0) index = 13;
      else if (strncmp(model->PDB[count].pdb_res,"PHE",3)==0) index = 14;
      else if (strncmp(model->PDB[count].pdb_res,"PRO",3)==0) index = 15;
      else if (strncmp(model->PDB[count].pdb_res,"SER",3)==0) index = 16;
      else if (strncmp(model->PDB[count].pdb_res,"THR",3)==0) index = 17;
      else if (strncmp(model->PDB[count].pdb_res,"TYR",3)==0) index = 18;
      else if (strncmp(model->PDB[count].pdb_res,"TRP",3)==0) index = 19;
      else if (strncmp(model->PDB[count].pdb_res,"VAL",3)==0) index = 20;
      else if (strncmp(model->PDB[count].pdb_res,"ORN",3)==0) index = 21;
      else index = 22 ;
      natural_res[index]++ ;
      if ( index < 22)
	strcpy(residue[index],model->PDB[count].pdb_res);
      else 
	strcpy(residue[index],"FUN");
    }
  
  critical = 1;
  
  for (index = 1 ; index < 23 ; index++) {
    if ( natural_res[index] > 0 ) {
      if ((critical ==  1) || (critical ==  7) || (critical == 13) || 
	  (critical == 19) || (critical == 25) || (critical == 31))
	printf ("\n> INFO_res: %3d %s  ", 
		natural_res[index], residue[index]);
      else
	printf( " %3d %s  ", 
		natural_res[index], residue[index]);
      critical++;
    }
  }
  printf("\n");
  if (disulfide_bonds == 0) {
    printf("> INFO_res: DISULFIDE: ** NO INFO FOR DISULFIDES IN FILE \n");
  } else {
    printf("> INFO_res: DISULFIDE\n");
    printf("> INFO_res: %4d\n",disulfide_bonds);
    for ( index = 1 ; index <= disulfide_bonds && index <= 10 ; index++)
      printf("> INFO_res:%5d%5d \n", infodisu[index][1],infodisu[index][2]);
  }
  return  1 ;
}
