/*$Id: initialize.c,v 3.32 2003/10/06 12:13:32 roberto Exp roberto $*/
#include "pdbstat.h"
/* ===================================================================== */
void haz_ceros(int modelok)
/*
  ---
  --- Just for initializing everything 
  --- The name of the routine is the spanish translation of do_zeroes(), 
  --- telling people that here we are suposed to initialize EVERYTHING for
  --- further use in the program. (RTT, May 1993, CABM-Rutgers University)
  ---
  --- (Roberto Tejero, RTT, May 1993, CABM-Rutgers University)
  ---
*/
{
  unsigned short     ii,  kk;
  static struct models    *Model ;
  
  temporalcount = 0 ;

  /*
   *  999 means that we are initializing from the beginning.
   *  if not 999 that means we are initializing model by model
   *
   *  So, in this part we are going to initialize 'all' models
   */
  if (modelok > TOPMODELS) {
    
    if (modelok == 999)
      total_models = AverageModel ;
    
    printf("\n> INIT: ** Initializing  `%d' models, wait a moment please.\n", total_models-1);
    
    /* Disulfide info */    
    for (ii = 0 ; ii <= 10 ; ii++)
      for (kk = 0 ; kk <= 2 ; kk++)
	infodisu[ii][kk] = 0;
    
    /* Sequence, TRUE if read, FALSE if not read */
    sequence_true = FALSE ;
    
    if (DEBUG > 0) 
      printf("> INIT: ... Initializing RANGES ...\n");  
    
    /* Ranges for superpositions */
    RANGES.number = 1 ;
    for (ii = 0 ; ii < MAXRANGES ; ii++) {
      RANGES.from[ii] = 1 ;
      RANGES.to[ii] = MODELS[0].number_of_residues ;
      strcpy(RANGES.quality[ii],"good");
    }
    
    if (DEBUG > 0) 
      printf("> INIT: ... Initializing NOE values ...\n");  
    
    /* NOE stuff */
    for (ii = 0 ; ii < MODELS[0].number_of_residues ; ii++) { 
      seqres[ii][0] = '\0';
    }
    
    kount_jcoup=0;
    free(JCOUP);
    JCOUP = (struct jcoup *)malloc(sizeof(struct jcoup) ) ;
   
    free(NOE);
    constraintcount = 0;
    ConsTrue = FALSE ;
    NOE = (struct noe *)malloc(sizeof(struct noe) ) ;
    
    free(ACO) ;
    acocount = 0 ;
    AcoTrue = FALSE ;
    ACO = (struct aco *)malloc(sizeof(struct aco) ) ;
    
    free(MODELS) ;
    total_models = 1 ;
    MODELS = (struct models *)malloc(sizeof(struct models) * 3 ) ;
    
    free(DIH) ;
    DIH = (struct dihedral *)malloc(sizeof(struct dihedral) );
    
    
    if (DEBUG > 0)
      printf ("> INIT: ... Initializing General variables ...\n");
    
    allowed_d = 0.0;
    allowed_j = 0.0;
    
    MAX = 0;
    modelo = 1;
    key_model = 0;
    constraintcount = 0;
    
    name_of_the_file[0]='\0';
    name_of_the_file_coords[0]='\0';
    name_of_the_file_constr[0]='\0';
    name_of_the_file_sequence[0]='\0';
    
    strcpy(entrada,"\0");
    strcpy(output_name,"\0");
    strcpy(line,"\0");
    strcpy(cadena,"\0");
    
    option = 0;
    disulfide_bonds = 0;
    lee = 0;
    escribe = 0;
    numero_de_residuos = 0;
    kount_dist = 0;
    kount_jcoup = 0;
    models = 0;
    q_atoms = 0;
    normal_atoms = 0;
    cristal = 0;
    total_models = 0;
    AverageModel = 0;
    
    /*
     *  Initializing Requested model/s only
     */
  } else {
    Model = MODELS + modelok ;
    
    if (DEBUG > 0)
      printf("\n> INIT:  ** Initializing model %d\n",modelok);
    
    allowed_d = 0.0;
    allowed_j = 0.0;
    q_atoms = 0;
    normal_atoms = 0;
    cristal = 0;
    option = 0;
    lee = 0;
    escribe = 0;
    
    Model->energy = 9999.0;
    Model->written = FALSE ;
    Model->determ = FALSE ;
    Model->rmsd = 9999.0 ;
    Model->BadOmega = FALSE ;
    Model->BadChiral = FALSE ;
    Model->BadSideChain = FALSE ;
    Model->BadModel = FALSE ;
    Model->Cis = FALSE ;
    Model->modelno = 9999;
    Model->number_of_residues = 0;
    Model->number_of_atoms = 0;
    
    if (DEBUG > 0)
      printf("> INIT:  ** Initializing DIH for model %d\n",modelok);
    
    for (ii = 0 ; ii <= Model->number_of_residues; ii++) {
      seqres[ii][0] = '\0';  
      Model->DIH[ii].resnumber = 9999;
      strcpy(Model->DIH[ii].resname,"\0");
      Model->DIH[ii].omega = 11111.0;
      Model->DIH[ii].phi = 11111.0;
      Model->DIH[ii].psi = 11111.0;
      Model->DIH[ii].chi1 = 11111.0;
      Model->DIH[ii].planar_o = 11111.0;
      Model->DIH[ii].planar_h = 11111.0;
      Model->DIH[ii].chiral = 11111.0;
      Model->DIH[ii].chiral_sc = 11111.0;
    }
    
    if (DEBUG > 0)
      printf("> INIT:  ** Initializing NOE for model %d\n",modelok);
    
    if (DEBUG > 0)
      printf("> INIT:  ** Initializing JCOUP for model %d\n",modelok);
    
    if (DEBUG > 0)
      printf("> INIT:  ** Initializing PDB for model %d\n",modelok);

    for (ii = 0; ii < Model->number_of_atoms+1; ii++) {      
      strcpy(Model->PDB[ii].pdb_key," ");
      Model->PDB[ii].written = FALSE ;
      Model->PDB[ii].pdb_num=0;
      strcpy(Model->PDB[ii].pdb_iupac," ");
      strcpy(Model->PDB[ii].pdb_res," ");
      strcpy(Model->PDB[ii].pdb_chain_id," ");
      Model->PDB[ii].pdb_chain_id[1]='\0';
      strcpy(Model->PDB[ii].segid," ");
      Model->PDB[ii].segid[4]='\0';
      strcpy(Model->PDB[ii].chain," ");
      strcpy(Model->PDB[ii].type," ");
      Model->PDB[ii].pdb_num_res=0;
      Model->PDB[ii].pdb_num_res_orig=0;
      Model->PDB[ii].orden=0;
      Model->PDB[ii].pdb_xcrd=0.0;
      Model->PDB[ii].pdb_ycrd=0.0;
      Model->PDB[ii].pdb_zcrd=0.0;
      Model->PDB[ii].pdb_oldx=0.0;
      Model->PDB[ii].pdb_oldy=0.0;
      Model->PDB[ii].pdb_oldz=0.0;
      Model->PDB[ii].coord[0]=0.0;
      Model->PDB[ii].coord[1]=0.0;
      Model->PDB[ii].coord[2]=0.0;
      Model->PDB[ii].pdb_data1=1.0;
      Model->PDB[ii].pdb_data2=0.0;
      Model->PDB[ii].pdb_masa=0.0;
    }
  }
  return ;
}


void init_dihedrals(void)
{
  unsigned short     i, k;
  struct models *Model ;
  
  for (k = 1 ; k <= total_models ; k++) {
    Model = MODELS + k ;
    for (i = 0 ; i <= Model->number_of_residues ; i++) {
      Model->DIH[i].omega = 11111.0;
      Model->DIH[i].phi = 11111.0;
      Model->DIH[i].psi = 11111.0;
      Model->DIH[i].chi1 = 11111.0;
      Model->DIH[i].planar_o = 11111.0;
      Model->DIH[i].planar_h = 11111.0;
      Model->DIH[i].chiral = 11111.0;
      Model->DIH[i].chiral_sc = 11111.0;
    }
  }
}  

