/* $Id: pdbstat_help.c,v 3.32 2003/10/06 12:13:32 roberto Exp roberto $*/

/* ========================================================================= */
/*
  ---
  ---  HERE we are going to include the project of a help file
  ---  directly copied from RasMol. The idea is begin to implement
  ---  the help for PDBSTAT in this file. Finally I have decided
  ---  calling it as Ayuda_PDBSTAT.hlp and it *MUST* reside in
  ---  /usr/local/lib to PDBSTAT to work properly or have environment
  ---  variable AyudaPATH set.
  ---
  ---  AQUI vamos a incluir el proyecto de un fichero de ayuda totalmente
  ---  copiado de RasMol. La idea es ir implementando la ayuda de
  ---  PDBSTAT en este fichero. Finalemente he decidio llamar a este
  ---  fichero Ayuda_PDBSTAT.hlp y *DEBE* residir en /usr/local/bin
  ---  para que el programa trabaje como debe o bien tener la variable de
  ---  entorno AyudaPATH definida.
  ---
  ---  pdbstat_help.c
  ---  Fichero para ayudas tomado del codigo de RasMol
  ---
  ---  ( Roberto Tejero, RTT, Jun 1995, CABM-RUTGERS University
  ---                         Mar 1997, Valencia University )
  ---  
  ---
 */

#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>
#include <string.h>
/* #define AYUDADIR "/usr/local/lib/PDBSTAT" */

#include "help.h"

void WriteChar( int );
void WriteString( char* );
void AyudaFatalExit( char* );

char DataFileName[256];
int CommandActive;

int ProcessCharacter( int );

int ProcessCharacter();

#include <pwd.h>

#define DirChar  '/'
#define HelpPool   16
char *HelpFileName; 
static char HelpFileBuf[80];
static HlpEntry __far *FreeInfo;
HlpEntry __far *HelpInfo; 
char *TokenPtr; 

/* Function Prototypes */
static int PrefixString( char __far*, char __far* );
static HlpEntry __far *EnterHelpInfo( char *text );

static int PrefixString( str1, str2 )
    register char __far *str1, __far *str2;
{
    while( *str1 == *str2++ )
	if( *str1++ == '\0' )
	    return( True );
    return( *str1 == '\0' );
}

static HlpEntry __far *EnterHelpInfo( text )
    register char *text;
{
    register HlpEntry __far * __far *tmp;
    register HlpEntry __far *ptr;
    register int res,len,i;
    register char ch;

    char keyword[32];

    ptr = (void __far*)0;
    while( *text && (*text!='\n') )
    {   while( *text && (*text!='\n') && (*text==' ') )
	    text++;

	len = 0;
	while( *text && (*text!='\n') && (*text!=' ') )
	    if( len<31 )
	    {   ch = *text++;
		keyword[len++] = ToUpper(ch);
	    } else text++;
	keyword[len]='\0';

	if( ptr )
	{   tmp = &ptr->info;
	    ptr = (void __far*)0;
	} else tmp = &HelpInfo;

	while( *tmp )
	{   res = _fstrcmp(keyword,(*tmp)->keyword);
	    if( res==0 ) /* Exact Match */
	    {   ptr = *tmp;
		break;
	    } else if( res<0 )
		break;
	    tmp = &(*tmp)->next;
	}

	if( !ptr )
	{   if( !FreeInfo )
	    {   ptr = (HlpEntry __far*)_fmalloc(HelpPool*sizeof(HlpEntry));
		if( !ptr ) 
		    AyudaFatalExit("*** Command Error: Insufficient memory!");
		for( i=1; i<HelpPool; i++ )
		{   ptr->next = FreeInfo;
		    FreeInfo = ptr++;
		}
	    } else
	    {   ptr = FreeInfo;
		FreeInfo = ptr->next;
	    }

	    ptr->keyword = (char __far*)_fmalloc(len+1);
	    for( i=0; i<=len; i++ )
		ptr->keyword[i] = keyword[i];

	    ptr->info = (void __far*)0;
	    ptr->next = *tmp;
	    ptr->fpos = 0;
	    *tmp = ptr;
	}
    }
    return( ptr );
}

/* static void InitHelpFile(void) */
void InitHelpFile(void) 
{
    register char *src,*dst;
    register HlpEntry __far *fix;
    register HlpEntry __far *ptr;
    register FILE *fp;
    register Long pos;

    char buffer[82];

    HelpFileName = "Ayuda_PDBSTAT.hlp";
    fp=fopen(HelpFileName,"r");

    if( !fp && (src=(char*)getenv("AyudaPATH")) )
    {   HelpFileName = dst = HelpFileBuf; 
	while( *src )
	    *dst++ = *src++;
	if( (dst!=HelpFileBuf) && (*(dst-1)!=DirChar) )
	    *dst++ = DirChar;

	src = "Ayuda_PDBSTAT.hlp"; 
	while( (*dst++ = *src++) );
	fp = fopen(HelpFileName,"r");
    }

#ifdef AYUDADIR
    if( !fp )
    {   src = AYUDADIR;
	HelpFileName = dst = HelpFileBuf;
	while( *src )
	    *dst++ = *src++;
	if( (dst!=HelpFileBuf) && (*(dst-1)!=DirChar) )
	    *dst++ = DirChar;

	src = "Ayuda_PDBSTAT.hlp"; 
	while( (*dst++ = *src++) );
	fp = fopen(HelpFileName,"r");
    }
#endif

    if( !fp )
    {   if( CommandActive )
	    WriteChar('\n');
	CommandActive = False;
	WriteString("*** Unable to find Ayuda_PDBSTAT.hlp help file!  \n");
	WriteString("*** AyudaPATH is __not__ set, or is set __wrong__\n");
	WriteString("*** Please set AyudaPATH to the place where library");
	WriteString(" files reside\n\n");
	HelpFileName = NULL;
	return;
    }

    pos = 0;
    fgets(buffer,80,fp);
    while( !feof(fp) )
    {    fix = (void __far*)0;
	 while( *buffer=='?' )
	 {   if( (ptr = EnterHelpInfo(buffer+1)) )
	     {   ptr->info = fix;
		 fix = ptr;
	     }

	     pos = (int) ftell(fp);
	     if( !fgets(buffer,80,fp) )
		 break;
	 }

	 while( fix )
	 {   ptr = fix->info;
	     fix->info = (void __far*)0;
	     fix->fpos = pos;
	     fix = ptr;
	 }

	 while( fgets(buffer,80,fp) )
	     if( *buffer=='?' )
		 break;
    }
    fclose(fp);
}

/* static void FindHelpInfo(void) */
void FindHelpInfo(void) 
{
    register HlpEntry __far * __far *tmp;
    register HlpEntry __far *ptr;
    register int res,len;
    register Long pos;
    register FILE *fp;
    register char ch;

    char keyword[32];
    char buffer[82];

    while( *TokenPtr && (*TokenPtr==' ') )
	TokenPtr++;

    if( *TokenPtr )
    {   ptr = NULL;
	do {
	    len = 0;
	    while( *TokenPtr && (*TokenPtr!=' ') )
		if( len<31 )
		{   ch = *TokenPtr++;
		    keyword[len++] = ToUpper(ch);
		} else TokenPtr++;
	    keyword[len]='\0';

	    if( ptr )
	    {   tmp = &ptr->info;
		ptr = (void __far*)0;
	    } else tmp = &HelpInfo;

	    while( *tmp )
	    {   res = _fstrcmp(keyword,(*tmp)->keyword);
		if( res<0 )
		{   if( PrefixString(keyword,(*tmp)->keyword) )
		    {   ptr = *tmp;
			if( ptr->next && 
			    PrefixString(keyword,ptr->next->keyword) )
			{   if( CommandActive ) WriteChar('\n');
			    WriteString("Ambiguous help topic requested!\n");
			    CommandActive = False;
			    return;
			} else break;
		    } else break;
		} else if( res==0 ) 
		{   ptr = *tmp;
		    break;
		}
		tmp = &(*tmp)->next;
	    }

	    while( *TokenPtr && (*TokenPtr==' ') )
		TokenPtr++;
	} while( *TokenPtr && ptr );

	if( !ptr || !ptr->fpos )
	{   if( CommandActive )
		WriteChar('\n');
	    WriteString("No available help on requested topic!\n");
	    CommandActive=False;
	    return;
	} else pos=ptr->fpos;
    } else pos=0;


    if( !(fp=fopen(HelpFileName,"r")) )
	AyudaFatalExit("*** Command Error: Unable to reopen help file!");

    if( CommandActive )
/*	WriteChar('\n'); */
      ;
    CommandActive = False;

    fseek(fp,pos,0);
    while( fgets(buffer,80,fp) )
	if( *buffer!='?' )
	{   WriteString(buffer);
	} else break;
    fclose(fp);
}

void WriteChar( ch )
    char ch;
{   putc(ch,stdout);
}

void WriteString( ptr )
    char *ptr;
{   fputs(ptr,stdout);
}

void AyudaFatalExit( msg )
    char *msg;
{
    WriteChar('\n');
    WriteString(msg);
    WriteChar('\n');
    WriteChar(0x07);
    exit(1);
}
