/*$Id: pdbstat_main.c,v 3.32 2003/10/06 12:13:32 roberto Exp roberto $*/

#include "pdbstat.h"

extern void Copyright_Notice(void) ;
extern void GetKnownDistances(FILE *InputFile) ;
extern FILE  *efopen(char *, char *);
extern FILE *libfopen(char *, char *);
extern int GetLibraryData(FILE *InputFile) ; 

/* ========================================================================= */
int main()
/*
  --- 
  --- The code for this program is more or less (much more than less) awful
  --- but IT WORKS!. May be the structure is not the best one possible but
  --- I think this one can be easily improved and made bigger. The central
  --- structures PDB, NOE and JCOUP (defined above) can be easily improved
  --- and changed to include more info in the whole program.
  ---
  --- After checking the program we should change the definition of varia
  --- bles general to the whole code (I mean the external ones)
  ---
  --- Enjoy the code and have fun running it!. 
  ---
  --- (Roberto Tejero, RTT, May 1993, CABM-Rutgers University)
  ---
*/
{
  static short i;
  FILE *DistFile, *LibFile ;
  static int LibRecords ;
  
  (void) Copyright_Notice();
  (void) print_version();

  /*
   * Check for AyudaPATH variable and tell user if it is NOT set
   */
  if  ( !(char*)getenv("AyudaPATH") ) {
    fprintf(stderr,"\n");
    fprintf(stderr,"************************************************************************\n");
    fprintf(stderr,"***************************** DIAGNOSTICS ****************************** \n");
    fprintf(stderr,"*** \n");
    fprintf(stderr,"***  AyudaPATH variable is _UNSET_, while the program may work, it is \n");
    fprintf(stderr,"***  _MANDATORY_ to have AyudaPATH set for PDBStat to work properly. \n");
    fprintf(stderr,"*** \n");
    fprintf(stderr,"************************************************************************\n");
    fprintf(stderr,"************************************************************************\n");
    fprintf(stderr,"\n  ... Exiting now!\n\n");
    exit (-1);
  }

  DEBUG = 0 ;

  /*
   * No header by default
   */
  for ( i = 0 ; i < MAXREMARKRECS; i++) 
	  strcpy(HeaderPdb[i],"STOP");	

  /*
   * Some defaults to write 
   */
  WriteHeader = TRUE ;     /* default, do not write header for all models */
  WriteModelHeader = TRUE ; /* def. write remark header for each model */
   
  /*
   * Allocation of minimum space for each 'general' structure 
   * The re-allocation should be done in the corresponding routine
   */
  JCOUP = (struct jcoup *)malloc(sizeof(struct jcoup) ) ;
  NOE = (struct noe *)malloc(sizeof(struct noe) ) ;
  ACO = (struct aco *)malloc(sizeof(struct aco) ) ;
  DIH = (struct dihedral *)malloc(sizeof(struct dihedral)  );
  MODELS = (struct models *)malloc(sizeof(struct models) * 3); 
  
  /* Clear ranges info */
  RANGES.number = 0;
  for ( i = 0; i < MAXRANGES; i++) RANGES.from[i] = RANGES.to[i] = 0;

  /* Loading database of Known distances for analysis */
  fprintf(stdout,"\n  --> ... Reading/Loading Distances file  ...");
  fflush(stdout); 
  DistFile = libfopen("Distances.Lib","r");
  (void) GetKnownDistances(DistFile);
  (void) fclose(DistFile);
  fprintf(stdout," %4d distance records read\n", MaxDistKnown); 

  /* Loading Dihedral Lib data */
  fprintf(stdout,"  --> ... Reading/Loading Dihedral Library ..");
  fflush(stdout); 
  LibFile = libfopen("GenCons.Lib","r");
  LibRecords=GetLibraryData(LibFile);
  fclose(LibFile);
  fprintf(stdout," %4d library records read\n", LibRecords); 

  /*  (void) haz_ceros(999); */
  (void) menu();
  return 0;
}
