/*$Id: pdbstat_menu.c,v 3.32 2003/10/06 12:13:32 roberto Exp roberto $*/

/****************************************************************************
 *
 * This program is intended to read and translate among different kind of pro
 * grams, namely, CONGEN, IMPACT, DISCOVER, DISMAN. As now (Feb. 1993) it is 
 * able to take input files from DISMAN, IMPACT and CONGEN and translate 
 * among them. The idea is keep implementing in  this new module all the 
 * software previously developped in fortran (dismantocongen.f, orientocongen
 * .f, etc.) and also keep programming in C to gain portability.
 *
 *
 *   (Roberto Tejero, RTT, Feb 1993, CABM-Rutgers University).
 *
 * Since comment above PDBStat has experienced deep changes and now is able
 * to do much more things than translate amongst different formats.
 * I should fix this and add more comments and explanations.
 *
 ***************************************************************************/


#include "pdbstat_main.h"
#include <unistd.h>
#include "Tokens.h"

char *AddWhiteSpace(char Option[MAXWORD]) ;
void SelectResidueRanges(char Option1[MAXWORD]) ;
void SelectModelRanges(char Option1[MAXWORD]) ;
char IsAtomName(char Option[MAXWORD]);
char IsResidueName(char Option[MAXWORD]);
char SelectAtom(int model, int atom, char Option3[MAXWORD]) ;
char ValidModelNumber(int modelo, int minimum, int maximum) ;
void InitializeCommand(void) ;
void InitializeOptions(void) ;
int GetToken(char Command[MAXWORD]);

extern void ComputeS(int Model, char res1[5], char at1[6], char res2[5], char at2[6], double *B, double **S);
extern void RadiusOfGyration(int Model, double *X, double *Y, double *Z);
extern void ToPDB(void) ;
extern void ToIUPAC(void) ;
extern void XplorToIUPAC(void) ;
extern void ToXPLOR(void) ;
extern void ToDYANA(void) ;
extern int  DriverEvaluate(char options[50]);
extern void ShowModel(char options[MAXWORD ]);
extern char ModelHasAtoms(int ModelN);
extern char IsThereAModel(void) ;
extern char IsThereConstraints(void) ;
extern char IsThereSequence(void) ;
extern void selec_dis_for_hyper(void);
extern void for_hyper(void);
extern FILE *safeopen(char *, char *, int longit);
extern void ps_drawgraph(FILE *);
extern void do_average_coords(char tipo[MAXWORD]);
extern void do_copy_model(int from, int to);
extern void optimal_rotate(int reference, int kompar, int residue_range,
			   int orientmode, char tipo[MAXWORD]);
extern void translate(int mode);
extern void calc_order_parameters(float cutoff) ;
extern void align_sequences(char Option2[MAXWORD]) ;
extern char *delete_model(char Option2[MAXWORD],char Option3[MAXWORD], char Command[MAXWORD]);
extern  char *check_planar_sc(char buenos[10]) ;
extern void calc_rmsd_driver(char orden[MAXWORD]) ;
extern void classify_by_energy_insight(void) ;
extern void atom_properties(int Model) ;
extern void amino_codes(void) ;
extern void model_properties(int modelo) ;
extern void resetResidueNumbers(char Model[10], short NewResOrig) ;
extern void restoreResidueNumbers(char Model[10]) ;
/* extern void dmncgn_(void) ; */
extern void GetDistancesFromTemplate(unsigned short TotalAtoms, int NDis, float NCut, long NSeed) ;
extern int ChangeAtoms(char AlignmentFile[MAXWORD], char Format[10], char BaseName[MAXWORD], int Acols) ;
extern void Copyright_Notice(void) ;
extern int GetLibraryData(FILE *InputFile) ;      
extern void CheckPDBNames(int LibRecords,char option[3]) ; 
extern int is_allowed(char Id, int resnumber, int modelnumber) ;
extern void EliminateNoeSelected(struct noe *Noe, char Type[MAXWORD]) ;
extern int  EliminateNoRestriction(struct noe *Noe) ;
extern int  EliminateDuplicatedNoes(struct noe *Noe) ;
extern void ShowKnownDistances(struct KnownDist *kd) ;

/*
 * Help stuff. The routine holding all definitions is pdbstat_help.c
 * and the include file help.h holds the definitions.
 */
#include "help.h"
extern void FindHelpInfo(void) ;
extern void InitHelpFile(void) ; 
extern char *HelpFileName;
extern HlpEntry __far *HelpInfo; 
extern char *TokenPtr;

/*
 * GenCons.Lib library stuff
 */
extern struct Library *Lib;
extern int LibRecords;
extern int MaxLib;
extern void SeeDihedralLibraryData(char Option2[MAXWORD]);
extern void SeeLibraryData(char Option2[MAXWORD], char Descriptor[6]);
extern void SeeNoes(char FileName[MAXWORD], char Average[10]);
extern void SeeAco(char FileName[MAXWORD]);
extern void SeeResidualViol(char FileName[MAXWORD], char Average[10], float Threshold);
extern void SeeViolAco(char Salida[MAXWORD], float Threshold);
extern FILE *efopen(char *file, char *mode);
extern FILE *libfopen(char *file, char *mode);
int    LibRecords;
FILE   *LibFile ;
FILE   *closecontact ;
struct noe *Cons ;

/* Checking */
int    flag_chiral;      /* 1 if chiral done, 0 if not */
char   Option1[MAXWORD], Option2[MAXWORD], Option3[MAXWORD], Command[MAXWORD];
char   Option4[MAXWORD], Option5[MAXWORD], TmpChar[MAXWORD];

/* ========================================================================= */
/*
 * Here it comes ... this signle, BIG monster of a routine I am not really happy
 * with, some day someone has to someway fixing it ... right now IT WORKS.
 * (Roberto Tejero, RTT, May 1993, CABM-Rutgers University).
 */

void menu(void)
{
     int    j, ll, lk, from, to ;
     int    tempvar;  
     char   tempchar[6];
     float cutoff ;
     short i,k,l ;  
     struct models *Model ;
     float CutUpl=0.0, CutAco=0.0, NCut = -100.0; 
     int NDis = -100;
     long NSeed = 0;
     char Format[10] , BaseName[MAXWORD] ;
     double B[3], **S, Xaxe[3], Yaxe[3], Zaxe[3] ;
     
     S = (double **)malloc(sizeof(double) * 3) ;
     for (i=0;i<3;i++)  S[i] = (double *)malloc(sizeof(double) * 3) ;
     
     tempvar = 0 ;
     count_history = 0 ;
     flag_chiral = 0 ;
     
     ll = 0; 
     lk = 0;
     Format[0] = BaseName [0] = '\0';
    
     /* Some general variables */
     constraintcount = 0 ;
     acocount = 0 ;

     printf("\n> MAIN: [rea]d [hel]p [his]tory [men]u [phi] [qui]t...");
     printf("\n> MAIN: ?_  ");
     InitializeOptions(); 
     
     /*
      * This next dummy thing has become necessary to avoid core dump when
      * certain combination of commands were done to the program.
      * For example, typing first 'rama' and then 'relax' produced a core
      * dumped
      */
     if (IsAtomName("N")) ;
     
     GetFromKeyBoard(Command, MAXWORD, stdin) ;
     
     while ( GetToken(Command) != END ) {
Special:
	  count_history+=1;
	  Model = MODELS+1 ;
	  switch (GetToken(Command)) {
	  case (AUTHOR):
		  strcpy(Command,"help auth");
		  goto Special ;
		  break;
          case (DISTANCES):
	  case (NOES):
	       InitializeOptions();
	       sscanf(Command,"%*s %s",Option1);
	       switch (GetToken(Option1)) {
	       case (MODIFY):
	       case (CLEAR):
		    fprintf(stdout," > %5d Duplicated NOEs  \n", EliminateDuplicatedNoes(&NOE[1])) ;
		    fprintf(stdout," > %5d Meaningless NOEs \n", EliminateNoRestriction(&NOE[1])) ;
		    break;
	       case (REMOVE):
		    sscanf(Command,"%*s %*s %s",Option2);
		    (void)EliminateNoeSelected(&NOE[1],Option2);
		    break;
	       default:
		    break;
	       }
	       break;
	  case (BLANK):
	       break ;
	  case (UNKNOWN):
	       sprintf(history[count_history]," `%s' *UNKNOWN* command", Command);
	       printf("\n> MAIN: `%s' *Unknown* command, try `help command'", Command);
	       break;
	  case (TO):
	       InitializeOptions();
	       sscanf(Command,"%*s %s",Option1);
	       do_lower_case(Option1) ;
	       sprintf(history[count_history]," To %s  ",Option1);
	       switch (GetToken(Option1)) {
	       case (IUPAC):
		    XplorToIUPAC();
		    break;
	       case (PDBFORMAT):
		    ToPDB();
		    break;
	       case (XPLOR):
		    ToXPLOR();
		    break;
	       case (DIANA):
	       case (DYANA):
		    XplorToIUPAC();
		    ToDYANA();
		    for (i = 1 ; i <= total_models ; i++) {
			 Model = MODELS+i ;
			 for (j = 1 ; j <= Model->number_of_atoms ; j++)
			      Model->PDB[j].pdb_chain_id[0] = ' ';
		    }
		    break ;
	       }
	       break ;
	  case (WRITE):
	       strcpy(history[count_history]," Write");
	       writing(Command);
	       break;
	  case (READ) :
	       InitializeOptions();
	       sscanf(Command,"%*s %s",Option1);
	       do_lower_case(Option1) ;
	       strcpy(history[count_history]," Read ");
	       switch (GetToken(Option1)) {
	       case (JCOUP):
		    sscanf(Command,"%*s %*s %s %s",Option2,Option3);
		    reading(Option1,Option2,Option3);
		    break;
	       case (SEQUENCE):
		    sscanf(Command,"%*s %*s %s",Option3);
		    reading(Option1,Option2,Option3);
		    break ;
	       case (UPL):
	       case (LOL):
	       case (NOES):
	       case (COORDINATES):
		    sscanf(Command,"%*s %*s %s %s %s",Option2,Option3,tempchar) ;
		    if ( strncasecmp(tempchar,"hom",3)==0 ) 
			 HomolConstraints = TRUE ;
		    do_lower_case(Option2) ;     
		    reading(Option1,Option2,Option3);
		    break;
	       case (ACO):
		    sscanf(Command,"%*s %*s %s %s ",Option2, Option3) ;
		    do_lower_case(Option2) ;     
		    reading(Option1,Option2,Option3);
		    break ;
	       default:
		    InitializeOptions();
		    reading(Option1,Option2,Option3);
		    break;
	       }
	       if (DEBUG > 0) printf(" > MAIN: We are back at MAIN ... \n") ;
	       fflush(stderr);
	       fflush(stdout);
	       fprintf(stdout,"\n") ;   
	       break;
	  case (HOMOLOGY):
	       InitializeOptions();
	       Option1[0] = Option2[0] = Option3[0] = Option4[0] = '\0' ;
	       strcpy(Option1,"coord");
	       strcpy(Option2,"pdb");
	       sscanf(Command,"%*s %s %s", Option3, Option4);
	       HomolConstraints = TRUE ;
	       /* Template -- coordinate file -- PDB */
	       if ( Option3[0] == '\0' ) {
		    printf("> HoMMEr: Name of template PDB coords: ");
		    GetFromKeyBoard(Option3,MAXWORD,stdin);
	       }
	       reading(Option1, Option2, Option3);
	       /* alignment file */
	       if ( Option4[0] == '\0' ) {
		    printf("> HoMMEr: Name of alignment file: ");
		    GetFromKeyBoard(Option4,MAXWORD,stdin);
	       }
	       /* Check for having a model and atoms in memory */
	       if (!IsThereAModel()) {
		    printf("> HoMMEr: First you MUST read a model with coordinates\n");
		    break ;
	       } 
	       if (!ModelHasAtoms(key_model)) {
		    printf("> HoMMEr: First you MUST read a model with coordinates\n");
		    break ;
	       }
	       /* Scanning command for arg values */
	       sscanf(Command,"%*s %*s %*s %s %s %s",  Format, BaseName, Option5);
	       if ( isdigit(Format[0]) ) {
		    sscanf(Command,"%*s %*s %*s %d", &NDis);
		    sscanf(Command,"%*s %*s %*s %*s %f", &NCut);
		    sscanf(Command,"%*s %*s %*s %*s %*s %ld", &NSeed);
		    sscanf(Command,"%*s %*s %*s %*s %*s %*s %s %s", Format, BaseName);
		    sscanf(Command,"%*s %*s %*s %*s %*s %*s %*s %*s %s", Option5);
	       }
	       
	       /*  Default values */
	       Model = MODELS+1;
	       if ( NDis  <= 0 ) NDis = (Model->number_of_residues * 25) * 3 ;
	       if ( NCut  <= 0.0 ) NCut = ( 3.5 * Model->RadiusOfGyration );
	       if ( NSeed <= 0 ) NSeed = -31415 ;
	       if ( atoi(Option5) != 4 && atoi(Option5) != 6) strcpy(Option5,"4") ;
	       
	       /* Printing out some info */
	       fprintf(stdout,"\n > HOMA: Number of distances  :  %6d  ", NDis);
	       fprintf(stdout,"\n > HOMA: Longest distance     :  %6.1f", NCut);
	       fprintf(stdout,"\n > HOMA: Seed for random      :  %6ld ", NSeed);
	       fprintf(stdout,"\n > HOMA: Alignment file cols. :  %6d ", atoi(Option5));
	       
	       /* Finally calling the two routines in charge of doing the job */
	       GetDistancesFromTemplate((unsigned short)MAX, NDis, NCut, NSeed) ;
	       tempvar = ChangeAtoms(Option4,Format,BaseName,atoi(Option5)) ;
	       break;
	  case (GET):
	       InitializeOptions();
	       sprintf(history[count_history],"%s\n",Option1) ;
	       if (!IsThereAModel()) {
		    printf("> MAIN: First you MUST read a model with coordinates\n");
		    break ;
	       } if (!ModelHasAtoms(key_model)) {
		    printf("> MAIN: First you MUST read a model with coordinates\n");
		    break ;
	       }
	       GetDistancesFromTemplate((unsigned short)MAX, NDis, NCut, NSeed) ;
	       break;
	  case (CHANGE):
	       InitializeOptions();
	       sprintf(history[count_history]," %s ",Option1) ;
	       tempvar = ChangeAtoms("NoName", Format, BaseName,atoi(Option5)) ;
	       break ;
	  case (CLEAR):
	       strcpy(history[count_history]," Clear ");
	       for (i = 1 ; i < 60 ; i++) printf("\n");
	       break;
	  case (CLOSE):   /* Close contact search */
	       InitializeOptions();
	       sscanf(Command,"%*s %s",Option1);
	       if (total_models == 1) strcpy(Option1,"1");
	       switch ( GetToken(Option1) ) {
	       case (ANYNUM):
		    if ( !ValidModelNumber(atoi(Option1),1,total_models) ) {
			 strcpy(Option1,"exit");
			 break;
		    }
		    key_model = atoi(Option1);
		    from = to = key_model ;
		    break;
	       case (AVERAGE):
		    strcpy(Option2,"backbone");
		    for (i=1;i<=total_models;i++)
			 (MODELS+i)->Selected = TRUE;
		    do_average_coords(Option2);
		    key_model = AverageModel;
		    from = to = key_model ;
		    break ;
	       case (UNKNOWN):
	       default:
		    printf("> MAIN_cntcts: Which model do you want [1-%d, all, average] ?_: ", total_models);
		    GetFromKeyBoard(Option1, MAXWORD, stdin);
		    switch ( GetToken(Option1) ) {
		    case (AVERAGE):
			 strcpy(Option2,"backbone");
			 for (i=1;i<=total_models;i++)
			      (MODELS+i)->Selected = TRUE;
			 do_average_coords(Option2);
			 key_model = AverageModel;
			 from = to = key_model ;
			 break ;
		    case (ALLMODELS):
			 from = 1;
			 to = total_models ;
			 break;
		    case (ANYNUM):
		    default:
			 if ( !ValidModelNumber(atoi(Option1),1,total_models) ) {
			      strcpy(Option1,"exit");
			      break;
			 }
			 key_model = atoi(Option1);
			 from = to = key_model ;
			 break;
		    }
		    break;
	       }
	       /* key_model = atoi(Option1); */
	       if (strncmp(Option1,"exit",4)==0) 
		    break;
	       strcpy(history[count_history]," Close contact search");
	       printf("> MAIN_cntcts: distance cutoff ?:_   ");
	       GetFromKeyBoard(Option1, MAXWORD, stdin);
	       if (strcasecmp(Option1,"")==0) {  
		    Option1[0]='1';
		    Option1[1]='.';
		    Option1[2]='7';
		    Option1[3]='5';
		    Option1[4]='\0';
	       }
	       if (strncmp(Option1,"exit",4)==0) 
		    break;
	       printf("> CLOSE_cntcts: atom type (hydr, heavy, all) ?:_  ");
	       GetFromKeyBoard(Option2, MAXWORD, stdin);
	       if (strncmp(Option2,"exit",4)==0) 
		    break;
	       
	       /* Loop over all models choosen */
	       for (key_model = from; key_model <= to; key_model++) {
		    /* Open output file to sto:re calcs */
		    strcpy(output_name,"");
		    sprintf(output_name,"%s_Close_cntcts_model%d",name_of_the_file,key_model);
		    if ((closecontact=fopen(output_name,"w"))==NULL) {
			 printf(" CLOSE_cntcts: Something was wrong opening output file \n");
			 exit (-1);
		    }
		    Model = MODELS + key_model ;
		    MAX = Model->number_of_atoms + 1;
		    if (MAX <= 0) {
			 printf("> MAIN_cntcts: ** No molecule read **\n");
			 break;
		    }
		    do_lower_case(Option2) ;
		    close_cntcts(atof(Option1),Option2,closecontact);
		    fclose(closecontact);
	       }
	       break;
	  case (RESTRICT):
	       /*
		* Select or restrict a set of models, residues or atoms
		* This is a new feature developped in Valencia in Dec. 1998-Jan. 1999
		* It tries to give the user the capacity of selectively pick models,
		* residues and/or atoms.
		*/
	       
	       /* Clear residue ranges info  to allow additive slections */
	       RANGES.number = 0;
	       for ( i = 0; i < MAXRANGES; i++) {
		    RANGES.chain_id[i][0] = '.';
		    RANGES.from[i] = RANGES.to[i] = 0;
	       }
	       /* Clear model ranges info to allow additive selections */
	       MODELRANGES.number = 0;
	       for ( i = 0; i < MAXMODELS; i++) {
		    MODELRANGES.chain_id[i][0] = '.';
		    MODELRANGES.from[i] = MODELRANGES.to[i] = 0;
	       }
	       InitializeOptions();
	       strcpy(Option1,"");
	       strcpy(Option2,"");
	       strcpy(Option3,"");
	       sscanf(Command,"%*s %s %s %s",Option1,Option2,Option3);
	       /*
		* Very special case developed only for a study I did in Valencia
		* It selects only a number of residues from C terminal up in the
		* sequence (3 to 5 residues). The peptides under study were alatos
		* tatins, from that the name....
		*/
	       /* ************* special begins   ************ */
	       if ( strncasecmp(Option1,"alatostatinas",4)==0 ) {
		    SELECTED = TRUE ;
		    
		    if (strcmp(Option2,"")==0) strcpy(Option2,"3");
		    if ( (atoi(Option2) <= 0) || (atoi(Option2) > 5) )
			 strcpy(Option2,"3");
		    tempvar = atoi(Option2);
		    
		    if (strcmp(Option3,"")==0) strcpy(Option3,"backbone");
		    strcpy(tempchar,AddWhiteSpace(Option3));
		    
		    for ( i = 1; i <= total_models; i++ ) {
			 Model = MODELS + i ;
			 Model->Selected = TRUE  ;
			 Model->AtomsSelected = TRUE  ;
			 Model->ResiduesSelected = TRUE ;
			 Model->ranges.number = 1 ;
			 Model->ranges.from[1] = Model->number_of_residues - tempvar;
			 Model->ranges.to[1] = Model->number_of_residues - 1;
			 for ( k = 1; k <= Model->number_of_atoms; k++)
			      if ((Model->PDB[k].pdb_num_res >= (Model->number_of_residues-tempvar)) && 
				  (Model->PDB[k].pdb_num_res <= (Model->number_of_residues-1)) &&
				  (SelectAtom(i,k,tempchar))) 
				   Model->PDB[k].Selected = TRUE;
		    }
		    goto get_out;
	       }
	       /* ************* special finishes ************ */
	       /* ********************* MODEL SELECTION ********************* */
	       switch ( GetToken(Option1) ) {                     /* Model selection */
	       case (RESET):
		    strcpy(Option2,"reset");
		    strcpy(Option3,"reset");
		    for (i = 0; i <= total_models; i++) {
			 Model = MODELS+i;
			 Model->Selected = FALSE;
			 Model->ResiduesSelected = FALSE;
			 Model->AtomsSelected = FALSE;
			 for (j=1; j<= Model->number_of_atoms; j++)    
			      Model->PDB[j].Selected=FALSE;
			 for (j=1; j<= Model->number_of_residues; j++) 
			      Model->DIH[j].Selected=FALSE;
		    }
		    /* Clear residue ranges info */
		    RANGES.number = 0;
		    for ( i = 0; i < MAXRANGES; i++) {
			 RANGES.chain_id[i][0] = '.';
			 RANGES.from[i] = RANGES.to[i] = 0;
		    }
		    /* Clear model ranges info */
		    MODELRANGES.number = 0;
		    for ( i = 0; i <= MAXMODELS; i++) {
			 MODELRANGES.chain_id[i][0] = '.';
			 MODELRANGES.from[i] = MODELRANGES.to[i] = 0;
		    }
		    SELECTED = FALSE;
		    break;
	       case (ANY):   /* arg is an asterisk */
		    MODELRANGES.number = 1;
		    MODELRANGES.from[1] = 1;
		    MODELRANGES.to[1] = total_models;
		    MODELRANGES.chain_id[1][0]='*';
		    for (i = 1; i <= total_models; i++) {
			 (MODELS+i)->Selected = TRUE ;
			 (MODELS+i)->AtomsSelected = FALSE ;
			 (MODELS+i)->ResiduesSelected = FALSE  ;
			  if ( DEBUG == 1 )
				fprintf(stdout," -- MODEL SELECTION, Located model: %3d \n",
					(MODELS+i)->SerialNumber);
		    }
		    SELECTED = TRUE;
		    break;
	       case (ANYNUM):   /* arg is a digit */
		    k = 0;
		    SelectModelRanges(Option1);
		    for (i = 1; i <= total_models; i++) {
			 for (j = 1; j <= MODELRANGES.number; j++)
			      if ( (MODELS+i)->SerialNumber >= MODELRANGES.from[j] && (MODELS+i)->SerialNumber <= MODELRANGES.to[j] ) {
				   (MODELS+i)->Selected = TRUE  ;
				   (MODELS+i)->AtomsSelected = FALSE ;
				   (MODELS+i)->ResiduesSelected = FALSE  ;
				   if ( DEBUG == 1 )
					fprintf(stdout," -- MODEL SELECTION, Located model: %3d \n",
						(MODELS+i)->SerialNumber);
			      }
		    }
		    SELECTED = TRUE ;
		    break;
	       default:
		    fprintf(stdout,"> SelectModule: *no* model selection given. Option reads: `%s' \n", Option1);
		    break;
	       }
	       /* ********************* RESIDUE SELECTION ***************** */
	       switch ( GetToken(Option2) ) {                    /* Residue Selection */
	       case (RESET):
		    break;
	       case (BESTSUPER):  /* range of residues that superpose best */
		    /* First, transfed stored RANGES data to proper arrays */
     		    for (i = 1; i <= total_models; i++) {
	               RANGES.number = (MODELS+i)->ranges.number ;
		       for (k = 1; k <= RANGES.number; k++) {
		              strcpy(RANGES.chain_id[k], (MODELS+i)->ranges.chain_id[k] );
		              RANGES.from[k] = (MODELS+i)->ranges.from[k] ;
		              RANGES.to[k] = (MODELS+i)->ranges.to[k] ;
		       }
		    }
     
		    for (i = 1; i <= total_models; i++) {
			 Model = MODELS + i ;
			 /* Store residue ranges in each model */
			 for (l = 1; l <= MODELRANGES.number; l++) {
			      if ( Model->SerialNumber >= MODELRANGES.from[l] &&
				   Model->SerialNumber <= MODELRANGES.to[l] ) { 
				   Model->ResiduesSelected = TRUE;
				   Model->ranges.number = RANGES.number ;
				   for (ll = 1; ll <= RANGES.number; ll++) {
					Model->ranges.chain_id[ll][0] = RANGES.chain_id[ll][0];
					Model->ranges.from[ll] = RANGES.from[ll];
					Model->ranges.to[ll] = RANGES.to[ll];
				   }
				   /* Locate selected residues */
				   for (j = 1; j <= Model->number_of_residues; j++) {
					for (ll = 1; ll <= Model->ranges.number; ll++) {
					     if ( (Model->DIH[j].resnumber >= Model->ranges.from[ll]) && 
						  ( Model->DIH[j].resnumber <= Model->ranges.to[ll]) ) {
						  Model->DIH[j].Selected = TRUE ;
						  if ( DEBUG == 1 )
						       fprintf(stdout," -- RES. SELECTION, Located model: %3d Res: %3d,  --BESTSUPER--\n",
							       Model->SerialNumber, Model->DIH[j].resnumber);
					     }
					}
				   }
			      }
			 }
		    }
		    SELECTED = TRUE ;
		    break;
	       case (ANY):
		    RANGES.number = 1;
		    RANGES.from[1] = Model->PDB[1].pdb_num_res ;
		    RANGES.to[1] = Model->number_of_residues + Model->PDB[1].pdb_num_res ;
		    RANGES.chain_id[1][0] = '*' ;
		    if ( Model->PDB[1].pdb_num_res >= 1 )
			RANGES.to[1]--;
				   
		    for (i = 1; i <= total_models; i++) {
			 Model = MODELS + i ;
			 for (l = 1; l <= MODELRANGES.number; l++) {
			      if ( Model->SerialNumber >= MODELRANGES.from[l] && Model->SerialNumber <= MODELRANGES.to[l] ) { 
				   Model->ranges.number = 1;
				   Model->ranges.chain_id[l][0] = '*';
				   Model->ranges.from[l] = Model->PDB[1].pdb_num_res ;
				   Model->ranges.to[l] = Model->number_of_residues + Model->PDB[1].pdb_num_res ;
				   
				   if ( Model->PDB[1].pdb_num_res >= 1 )
					Model->ranges.to[1]--;
				   
				   Model->ResiduesSelected = TRUE;
				   for (j = 1; j <= Model->number_of_residues; j++) {
					Model->DIH[j].Selected = TRUE ;
				 	if ( DEBUG == 1 )
					       fprintf(stdout," -- RES. SELECTION, Located model: %3d Res: %3d,  --ANY-- \n",
						       Model->SerialNumber, Model->DIH[j].resnumber);
				   }
			      }
			 }
		    }
		    SELECTED = TRUE ;
		    break;
	       case (ANYNUM):
		    k = 0;
		    SelectResidueRanges(Option2);
		    for (i = 1; i <= total_models; i++) {
			 Model = MODELS + i ;
			 /* Store residue ranges in each model */
			 for (l = 1; l <= MODELRANGES.number; l++) {
			      if ( Model->SerialNumber >= MODELRANGES.from[l] &&
				   Model->SerialNumber <= MODELRANGES.to[l] ) { 
				   Model->ResiduesSelected = TRUE;
				   Model->ranges.number = RANGES.number ;
				   for (ll = 1; ll <= RANGES.number; ll++) {
					Model->ranges.chain_id[ll][0] = RANGES.chain_id[ll][0];
					Model->ranges.from[ll] = RANGES.from[ll];
					Model->ranges.to[ll] = RANGES.to[ll];
				   }
				   /* Locate selected residues */
				   for (j = 1; j <= Model->number_of_residues; j++) {
					for (ll = 1; ll <= Model->ranges.number; ll++) {
					     if ( (Model->DIH[j].resnumber >= Model->ranges.from[ll]) && 
						  ( Model->DIH[j].resnumber <= Model->ranges.to[ll]) ) {
						  Model->DIH[j].Selected = TRUE ;
						  if ( DEBUG == 1 )
						       fprintf(stdout," -- RES. SELECTION, Located model: %3d Res: %3d,  --ANYNUM--\n",
							       Model->SerialNumber, Model->DIH[j].resnumber);
					     }
					}
				   }
			      }
			 }
		    }
		    SELECTED = TRUE ;
		    break;
	       case (ALPHANUM):
		    k = 0;
		    SelectResidueRanges(Option2);
		    for (i = 1; i <= total_models; i++) {
			 Model = MODELS + i ;
			 /* Store residue ranges in each model */
			 for (l = 1; l <= MODELRANGES.number; l++) {
			      if ( Model->SerialNumber >= MODELRANGES.from[l] &&
				   Model->SerialNumber <= MODELRANGES.to[l] ) { 
				   Model->ResiduesSelected = TRUE;
				   Model->ranges.number = RANGES.number ;
				   for (ll = 1; ll <= RANGES.number; ll++) {
					Model->ranges.chain_id[ll][0] = RANGES.chain_id[ll][0]; 
					Model->ranges.from[ll] = RANGES.from[ll];
					Model->ranges.to[ll] = RANGES.to[ll];
				   }
				   /* Locate selected residues */
				   for (j = 1; j <= Model->number_of_residues; j++) {
					for (ll = 1; ll <= Model->ranges.number; ll++) {
					     if ( (Model->DIH[j].resnumber >= Model->ranges.from[ll]) && 
						  (Model->DIH[j].resnumber <= Model->ranges.to[ll]) &&
						  ((Model->DIH[j].chain_id[0] == Model->ranges.chain_id[ll][0]) ||
						   (Model->ranges.chain_id[ll][0] == '*')) ) {
						  Model->DIH[j].Selected = TRUE ;
						  if ( DEBUG == 1 )
						       fprintf(stdout," -- RES. SELECTION, Located model: %3d, Chain: %s, Res: %3d,   --ALPHANUM--\n",  
							       Model->SerialNumber, Model->ranges.chain_id[ll], Model->DIH[j].resnumber);
					     }
					}
				   }
			      }
			 }
		    }
		    SELECTED = TRUE ;
		    break;
	       case (RESIDUENAME):
		    for (i = 1; i <= total_models; i++) {
			 Model = MODELS + i ;
			 Model->ranges.number = 0;
			 /* Store ranges in each selected model */
			 for (l = 1; l <= MODELRANGES.number; l++) {
			      if (Model->SerialNumber >= MODELRANGES.from[l] &&
				  Model->SerialNumber <= MODELRANGES.to[l] ) { 
				   for (j = 1; j <= Model->number_of_residues; j++)
					if (strcasecmp(Model->DIH[j].resname, Option2)==0) {
					     
					     Model->ranges.number++ ;
					     Model->ranges.from[Model->ranges.number] = 
						  Model->ranges.to[Model->ranges.number] = Model->DIH[j].resnumber;
					     
					     if ( DEBUG == 1 )
						  fprintf(stdout," -- RES. SELECTION, Located model: %3d, chain: %s, Res: %3d,  --RESIDUENAME--\n",
							  Model->SerialNumber, Model->DIH[j].chain_id, Model->DIH[j].resnumber);
					     
					     Model->ResiduesSelected = TRUE ;
					}
			      }
			 }
		    }
		    break;
	       default:
		    fprintf(stdout,"> SelectResidue: *no* residue selection given \n");
		    break;
	       }
	       /* ************************ ATOM SELECTION **************** */
	       switch ( GetToken(Option3) ) {                       /* Atom Selection */
	       case (RESET):
		    SELECTED = FALSE;
		    break;
	       default:
		    strcpy(tempchar,"");
		    strcpy(tempchar,AddWhiteSpace(Option3));
		    for (i = 1; i <= total_models; i++) {
		           Model = MODELS+i;
		           for (l = 1; l <= MODELRANGES.number; l++) {
			      if ( Model->SerialNumber >= MODELRANGES.from[l] && Model->SerialNumber <= MODELRANGES.to[l] ) {
				   for (j = 1; j <= Model->number_of_atoms; j++) {
					SELECTED = TRUE;
					if  ( is_allowed(Model->PDB[j].pdb_chain_id[0],Model->PDB[j].pdb_num_res,i)==0 && 
							SelectAtom(i,j,tempchar) && !(Model->PDB[j].Selected) ) {
					     Model->PDB[j].Selected=TRUE;
					     if ( DEBUG == 1 ) 
						  fprintf(stdout," -- ATOM SELECTION, range: %2d, Located model: %3d, Chain: %s, Res: %3d, Atom:  %4d\n", 
							  l, Model->SerialNumber, Model->PDB[j].pdb_chain_id, 
							  Model->PDB[j].pdb_num_res, Model->PDB[j].orden);
					}
				   }
				   Model->AtomsSelected=TRUE;
			      }
			 }
		    }
		    break;
	       }
	  get_out:
	       break;
	  case (CHOOSE):
	       InitializeOptions();
	       sscanf(Command,"%*s %s",Option1);
	       if (total_models == 1) strcpy(Option1,"1");
	       switch ( GetToken(Option1) ) {
	       case (AVERAGE):
		    key_model = AverageModel;
		    break;
	       case (ANYNUM):
		    if ( !ValidModelNumber(atoi(Option1),1,total_models) ) {
			 strcpy(Option1,"exit");
			 break;
		    }
		    key_model = atoi(Option1);
		    break;
	       default:
		    printf("> SELECT_mdl: What model do you want ?_ :  ");
		    GetFromKeyBoard(Option1, MAXWORD, stdin);
		    if ( !ValidModelNumber(atoi(Option1),1,total_models) ) {
			 strcpy(Option1,"exit");
			 break;
		    }
		    key_model = atoi(Option1);	
		    break;
	       }
	       if (strcmp(Option1,"exit")==0) break;
	       sprintf(history[count_history],"select model %d",atoi(Option2));
	       printf("\n> WHAT_mdl: of %d models in memory, the %d is being worked out\n",
		      total_models, key_model);
	       break;
	  case (CONTACTS):
	       /* 
		*  Contact map for molecule. It is possible to make the contact from
		*  coordinates or constraints. 
		*  Case from coordinates:
		*         - it calls close_cncts
		*         - it calls to do_codes_for_constraints
		*         - it calls to Draw_maps
		*  Case from constraints:
		*         - it calls to do_codes_for_constraints
		*         - it calls to Draw_maps
		*/
	       printf("> DRAW_cntct: from coordinates or constraints (coor/cons) ?:_ ");
	       GetFromKeyBoard(Option1, MAXWORD, stdin);
	       
	       switch (GetToken(Option1)) {
	       case (COORDINATES):       /* From coordinates */
		    InitializeOptions();
		    sscanf(Command,"%*s %s",Option1);
		    fprintf(stdout,"> MAIN_cntct: What model do you want (1-%d) or average ?_ :", 
			    total_models);
		    GetFromKeyBoard(Option1, MAXWORD, stdin);
		    if (total_models > 1) {
			 switch ( GetToken(Option1) ) {
			 case (ANYNUM): 
			      if ( !ValidModelNumber(atoi(Option1),1,total_models) ) {
				   strcpy(Option1,"exit");
				   break;
			      } 
			      key_model = atoi(Option1) ;
			      break ;
			 case (AVERAGE):
			      strcpy(Option2,"backbone");
			      for (i=1;i<=total_models;i++)
				   (MODELS+i)->Selected = TRUE;
			      do_average_coords(Option2);
			      key_model = AverageModel;
			      break;
			 case (UNKNOWN):
			      fprintf(stdout,"> MAIN_cntct: What model do you want (1-%d) or average ?_ :", 
				      total_models);
			      GetFromKeyBoard(Option1, MAXWORD, stdin);
			      if ( !ValidModelNumber(atoi(Option1),1,total_models) ) {
				   strcpy(Option1,"exit");
				   break;
			      } 
			      key_model = atoi(Option1);
			 }
		    }
		    if (strcmp(Option1,"exit")==0) break;
		    Model = MODELS + key_model ;
		    MAX = Model->number_of_atoms + 1;
		    if (MAX <= 0) {
			 fprintf(stdout,"> MAIN_cntct: ** No molecule read **\n");
			 break;
		    }
		    strcpy(history[count_history]," Contact map from coords");
		    fprintf(stdout,"> MAIN_cntct: distance cutoff ?:_   ");
		    GetFromKeyBoard(Option1, MAXWORD, stdin);
		    if (strcmp(Option1,"")==0) { 
			 Option1[0]='1';
			 Option1[1]='.';
			 Option1[2]='7';
			 Option1[3]='5';
			 Option1[4]='\0';
		    }
		    if (strncmp(Option1,"exit",4)==0) break;
		    printf("> MAIN_cntct: atom type (hydr, heavy, all) ?:_  ");
		    GetFromKeyBoard(Option2, MAXWORD, stdin);
		    if (strncasecmp(Option2,"exit",4)==0) break;
		    /* Open output file to store calcs */
		    strcpy(output_name,"");
		    sprintf(output_name,"%s_Close_cntcts_model%d",name_of_the_file,key_model);
		    if ((closecontact=fopen(output_name,"w"))==NULL) {
			 printf(" CLOSE_cntcts: Something was wrong opening output file \n");
			 exit (-1);
		    }
		    close_cntcts(atof(Option1),Option2,closecontact);       /* Calling calc of close */
		    fclose(closecontact);
		    fprintf(stdout,"> MAIN_cntct: Making contact map PS file \n");
		    do_codes_for_constraints();                
		    strcpy(name_of_the_file,name_of_the_file_coords);
		    Draw_maps(name_of_the_file,Model->number_of_residues);
		    break;
	       case (NOES):      /* from constraints */
		    if (kount_dist <= 0) {
			 fprintf(stdout,"> MAIN_cntct: ** First read a constraint file **\n");
			 break;
		    }
		    if (!sequence_true) {
			 fprintf(stdout,"> MAIN_cntct: ** First read a sequence file **\n");
			 break;
		    }
		    strcpy(history[count_history], " Contact map from constraints");
		    do_codes_for_constraints();
		    strcpy(name_of_the_file,name_of_the_file_constr);
		    Draw_maps(name_of_the_file,(MODELS)->number_of_residues);
		    break;
	       default:
		    printf("\n> MAIN: *Error* -> `%s' is *not* valid", Option1);
		    printf("\n> MAIN: *Error* -> You have to type 'coord' or 'constr' ");
		    break;
	       }
	       break;
	  case (RELAX):
	       InitializeOptions();
	       fpi=efopen("DELETE.ME","w") ;
	       printf ("> RELAX_calc: ... Calculating dihedrals for %d models in family  %s ...\n",
		       total_models, name_of_the_file);
	       printf("> RELAX_calc: ... Don't be nervous, wait a momment please ! \n");
	       i=0;
	       for (i = 1; i <= total_models ; i++) {
		    if ( !(i%16) ) fprintf(stdout,"\n");
		    fprintf(stdout,"%4d",i);
		    key_model = i;
		    phi_psi_chi(fpi,0);
	       }
	       fclose(fpi);
	       fprintf(stdout,"\n");
	       sscanf(Command,"%*s %s",Option1);
	       if (total_models == 1) strcpy(Option1,"1");
	       switch ( GetToken(Option1) ) {
	       case (AVERAGE):
		    strcpy(Option2,"backbone");
		    for (i=1;i<=total_models;i++) (MODELS+i)->Selected = TRUE;
		    do_average_coords(Option2);
		    from = AverageModel;
		    to = AverageModel;
		    fpi=efopen("DELETE.ME","w") ;
		    key_model=AverageModel;
		    phi_psi_chi(fpi,0);
		    fclose(fpi);
		    break;
	       case (ALLMODELS):
		    from = 1 ;
		    to = total_models;
		    break;
	       case (ANYNUM):
		    if ( !ValidModelNumber(atoi(Option1),1,total_models) ) {
			 strcpy(Option1,"exit");
			 break ;
		    }
		    from = to = atoi(Option1);
		    break ;
	       default:
		    printf("> RELAX_calc: What model do you want (1-%d), average or all ?_ :  ",
			   total_models);
		    GetFromKeyBoard(Option1, MAXWORD, stdin);
		    switch ( GetToken(Option1) ) {
		    case (ALLMODELS):
			 from = 1;
			 to = total_models;
			 break;
		    case (AVERAGE):
			 strcpy(Option2,"backbone");
			 for (i=1;i<=total_models;i++) (MODELS+i)->Selected = TRUE;
			 do_average_coords(Option2);
			 from = AverageModel;
			 to = AverageModel;
			 fpi=efopen("DELETE.ME","w") ;
			 key_model=AverageModel;
			 phi_psi_chi(fpi,0);
			 fclose(fpi);
			 break;
		    default:
			 if ( !ValidModelNumber(atoi(Option1),1,total_models) ) {
			      strcpy(Option1,"exit");
			      break;
			 }
			 from = to = atoi(Option1);
			 break;
		    }
	       }
	       if (strcmp(Option1,"exit")==0) break;
	       printf("> RELAX_calc: File name for output ?_ : ");
	       GetFromKeyBoard(Option2, MAXWORD, stdin);
	       fpi=efopen(Option2,"w");
	       strcpy(history[count_history]," Relaxation  ");
	       strcat(history[count_history], Option2);
	       ll = 0;
	       tempvar = 0;
	       for (key_model = from ; key_model <= to ; key_model++) {
		    Model = MODELS + key_model ;
		    for (i = 1 ; i <= Model->number_of_atoms ; i++)
			 for (j = i+1 ; j <=  Model->number_of_atoms && 
				   Model->PDB[i].pdb_num_res_orig == Model->PDB[j].pdb_num_res_orig ; j++)
			      for (k = j+1 ; k <= Model->number_of_atoms && 
					Model->PDB[i].pdb_num_res_orig == Model->PDB[k].pdb_num_res_orig ; k++)
				   if ((strncmp(Model->PDB[i].pdb_iupac," N  ",4)==0) &&
				       (strncmp(Model->PDB[j].pdb_iupac," CA ",4)==0) &&
				       (strncmp(Model->PDB[k].pdb_iupac," C  ",4)==0)) {
					for (lk = k + 1 ; lk < Model->number_of_atoms && 
						  Model->PDB[i].pdb_num_res_orig + 1 >= Model->PDB[lk].pdb_num_res_orig ; lk++)
					     if (strncmp(Model->PDB[lk].pdb_iupac," CA ",4)==0) 
						  break ;
					
					MAX = Model->number_of_atoms + 1;
					if (tempvar != key_model)  {
					     tempvar = key_model ;
					     printf(" \n\n> RELAX_calc: \t --- MODEL: %4d \n", Model->modelno);
					     printf("> RELAX_calc:                                    "\
						    "                  angle   i, i+1  \n");
					     printf("> RELAX_calc:     RESIDUE    PHI     PSI   OMEGA"\
						    "    CHI1   d(N-CA) N-CA-C d(CA-CA) \n");
					     printf("> RELAX_calc:     -------  ------- ------  ------  "\
						    "------  ------  ------ -------  \n");
					     /* Writing to file */
					     fprintf(fpi," \n\n \t --- MODEL: %4d \n", Model->modelno);
					     fprintf(fpi,"                                            "\
						     "       angle   i, i+1  \n");
					     fprintf(fpi,"   RESIDUE    PHI     PSI   OMEGA    CHI1  d(N-CA) "\
						     "N-CA-C d(CA-CA) \n");
					     fprintf(fpi,"   -------  ------- ------  ------  ------ ------  "\
						     "------ -------- \n");
					}
					ll++;
					/*
					  if ((fmod(ll,22) == 0) && (total_models == 1)) {
					  printf("\n> ... Hit return or 'q'+return ...");
					  GetFromKeyBoard(Option2, MAXWORD, stdin);
					  }
					*/
					if (lk >= Model->number_of_atoms - 4 )
					     printf("> RELAX_calc: \t %s %6.3f %8.2f   --- \n", 
						    Model->angulos[Model->PDB[i].orden],
						    distance(i,j), angulo(i,j,k)/radperdeg);
					else
					     printf("> RELAX_calc: \t %s %6.3f %8.2f %6.3f \n", 
						    Model->angulos[Model->PDB[i].orden],
						    distance(i,j), angulo(i,j,k)/radperdeg,
						    distance(j,lk));
					
					if (lk >= Model->number_of_atoms - 4 )
					     fprintf(fpi,"  %s %6.3f %7.2f   ---  \n", 
						     Model->angulos[Model->PDB[i].orden],
						     distance(i,j), angulo(i,j,k)/radperdeg);
					else
					     fprintf(fpi,"  %s %6.3f %7.2f %6.3f \n", 
						     Model->angulos[Model->PDB[i].orden],
						     distance(i,j), angulo(i,j,k)/radperdeg,
						     distance(j,lk));
				   }
	       }
	       fclose(fpi);
	       break;
	  case (INFO):
	       InitializeOptions();
	       sscanf(Command,"%*s %s",Option1);
	       sprintf(history[count_history]," Info  `%s'",Option1);
	       if (total_models == 1) strcpy(Option1,"1"); 
	       switch ( GetToken(Option1) ) {
	       case (AVERAGE):
		    key_model = AverageModel;
		    break;
	       case (ANYNUM):
		    if ( !ValidModelNumber(atoi(Option1),1,total_models) ) {
			 strcpy(Option1,"exit");
			 break;
		    }
		    key_model = atoi(Option1);
		    break;
	       default:
		    printf("> WHAT_mdl: What model do you want ?_ :  ");
		    GetFromKeyBoard(Option1, MAXWORD, stdin);
		    if ( !ValidModelNumber(atoi(Option1),1,total_models) ) {
			 strcpy(Option1,"exit");
			 break;
		    }
		    key_model=atoi(Option1);
		    break;
	       }
	       if (strcmp(Option1,"exit")==0) break;
	       if (!IsThereAModel()) {
		    printf("> INFO_model: **NO MODELS** in memory ... going back ... ");
		    printf("\n> INFO_model: **First you *MUST* read some model ... \n ");
		    break ;
	       }
	       if (!ModelHasAtoms(key_model)) {
		    fprintf(stdout,"> INFO_mol: ** No molecule read ** \n");
		    break;
	       }
	       printf("\n\n");
	       printf("> =============================== INFO ================================ \n");
	       MolWeight(1);
	       CenterMass(1);
	       if (info_res(key_model) < 1) printf(" *** Error Getting info *** \n");
	       printf("> ===================================================================== \n");
	       printf("\n") ;
	       key_model = 1 ;
	       break ;
	  case (PROGRAMVERS):
	       strcpy(history[count_history]," Version ");
	       Copyright_Notice();
	       printf("\n> MAIN:   ==================> CURRENT SETS <=====================");
	       printf("\n> MAIN:   -- Version %s --",VERSION);
	       printf("\n> MAIN:   -------------------------------------------------------");
	       printf("\n> MAIN:                                           ");
	       printf("\n> MAIN:          Max. Number of models       : %6d",TOPMODELS-1);
	       printf("\n> MAIN:          Max. number of residues/mod : %6d",MAXRESIDUES);
	       printf("\n> MAIN:          Max. number of atoms/model  : %6d",MAXATOMS);
	       printf("\n> MAIN:          Max. Number of noes/model   : %6d",MAXNOES);
	       printf("\n> MAIN:          Max. Number of JCOUP        : %6d",MAXJCOUP);
	       printf("\n> MAIN:                                        ");
	       printf("\n> MAIN:   =======================================================\n");
	       strcpy(Option1,"\0");
	       break;
	  case (CENTER):
	       /* Calculating and translating to center of Masses */  
	       strcpy(history[count_history]," Center (get center masses) ");
	       if (!IsThereAModel()) {
		    printf("> MAIN: First you MUST read a model with coordinates\n");
		    break ;
	       } else if (!ModelHasAtoms(key_model)) {
		    printf("> MAIN: First you MUST read a model with coordinates\n");
		    break ;
	       }
	       CenterMass(0) ;
	       break;
	  case (DEBUGLEVEL):
	       sscanf(Command,"%*s %s ", Option2);
	       if ( strcmp(Option2,"\0")==0 || strcmp(Option2,"unknown")==0 ) {
		    printf(" > DEBUG: level ?_: ") ;
		    GetFromKeyBoard(Option1, MAXWORD, stdin);
		    DEBUG=atoi(Option1);
	       }  else
		    DEBUG = atoi(Option2) ; 
	       printf(" > DEBUG: level now : %d", DEBUG) ;
	       sprintf(history[count_history]," Debug  %d ",DEBUG);
	       break ;
	  case (CONGEN):
	       printf("  > PREP_CGEN: Base file name (i.e, tejero in 'tejero.noe')_?:");
	       GetFromKeyBoard(Option1, MAXWORD, stdin) ;
	       printf("  > PREP_CGEN: Chain identication (one letter, i.e., R) _?: ");
	       GetFromKeyBoard(Option2, MAXWORD, stdin) ;
	       sprintf(history[count_history]," Congen %s %s", Option1, Option2);
	       prepare_congen(Option1,Option2);
	       break;
	  case (RMSD):
	       sprintf(history[count_history]," %s", Command);
	       calc_rmsd_driver(Command) ;
	       break;
	  case (DIHEDRAL): 
	       InitializeOptions();
	       tempvar = key_model ;
	       sscanf(Command,"%*s %s",Option1);
	       if (total_models == 1) strcpy(Option1,"1");
	       switch ( GetToken(Option1) ) {
	       case (AVERAGE):
		    key_model = AverageModel;
		    break;
	       case (ALLMODELS):
		    strcpy(Option2,"all");
		    strcpy(Option1,"999");
		    key_model = 1;
		    break;
	       default:
		    printf("> PHI_PSI_CHI_eval: What model do you want ?_ :  ");
		    GetFromKeyBoard(Option1, MAXWORD, stdin);
		    if (strncasecmp(Option1,"all",1)==0) {
			 strcpy(Option2,"all");
			 strcpy(Option1,"1");
		    } else if ( !ValidModelNumber(atoi(Option1),1,total_models) ) {
			 strcpy(Option1,"exit");
			 break;
		    }
		    key_model = atoi(Option1);
		    break;
	       }
	       sprintf(history[count_history]," %s", Command);
	       if (strcmp(Option1,"exit")==0) break;
	       Model = MODELS + key_model ;
	       MAX = Model->number_of_atoms + 1;
	       if ((MAX <= 0) || (MAX > MAXATOMS)) {
		    printf("> PHI_PSI_CHI_prep: ** No molecule read or atoms > MAXATOMS \n");
		    break;
	       }
	       printf("> PHI_PSI_CHI_eval: Name for output file ?:_  ");
	       GetFromKeyBoard(Option1, MAXWORD, stdin);
	       if (strncasecmp(Option1,"exit",4)==0) break;
	       fpi=efopen(Option1,"w") ;
	       printf("> PHI_PSI_CHI_eval: Calculating phi, psi and chi. Wait please ...\n");
	       
	       if (strncmp(Option2,"all",2) == 0)
		    for (key_model = 1 ; key_model <= total_models ; key_model++)
			 phi_psi_chi(fpi,999);
	       else
		    phi_psi_chi(fpi,1);
	       fclose(fpi);
	       key_model = tempvar ;
	       break;
	  case (RESET):
	       if ( !IsThereAModel() ) {
		    fprintf(stdout,"> MAIN: First you MUST read a model with coordinates\n");
		    break ;
	       }
	       InitializeOptions();
	       sscanf(Command,"%*s %s %*s",Option1) ;
	       sscanf(Command,"%*s %*s %s",Option2) ;
	       if (strcmp(Option1,"")==0) {
		    fprintf(stdout,"> RESET_resnum: Which model?_ ");
		    GetFromKeyBoard(Option1, MAXWORD, stdin);
	       }
	       if (strcmp(Option2,"")==0) {
		    fprintf(stdout,"> RESET_resnum: New Initial number?_ ");
		    GetFromKeyBoard(Option2, MAXWORD, stdin);
	       }
	       sprintf(history[count_history]," Reset  %s %s ",Option1,Option2);
	       resetResidueNumbers(Option1,atoi(Option2)) ;
	       amino_codes();
	       tempvar = key_model ;
	       for ( key_model = 1; key_model <= total_models; key_model++)
		    atom_properties(key_model);
	       key_model = tempvar ;
	       break; 
	  case (RESTORE):
	       InitializeOptions();
	       sscanf(Command,"%*s %s",Option2);
	       if (strcmp(Option2,"")==0) {
		    fprintf(stdout,"> MAIN: What model [def. all models] ?_: ");
		    GetFromKeyBoard(Option2, MAXWORD, stdin);
	       }
	       if (strcmp(Option2,"")==0) strcpy(Option2,"all");
	       restoreResidueNumbers(Option2) ;
	       sprintf(history[count_history]," Restore %s", Option2);
	       break;
	  case (ALIGN):   
	       sscanf(Command,"%*s %s",Option2);
	       do_lower_case(Option2) ;
	       align_sequences(Option2);
	       sprintf(history[count_history]," Align %s", Option2);
	       break;
	  case (COPY):
	       sscanf(Command,"%*s %d %d", &from, &to);
	       sprintf(history[count_history]," Copy  %d  %d",from,to);
	       if ( !ValidModelNumber(from,1,total_models) ||
		    !ValidModelNumber(to,1,total_models)) {
		    printf ("> COPY_mdl: *** Check model # %d or %d in copy %d %d\n",
			    from,to, from,to);
		    break;
	       }
	       /* I think here is an *ERROR* in code, Watch this Roberto! */
	       if (to > total_models) {
		    total_models++ ;
		    models++ ;
		    MODELS = (struct models *)realloc(MODELS,sizeof(struct models)*
						      (total_models+3)) ;
	       }
	       do_copy_model(from,to);
	       break;
	  case (SHOW):
	       sprintf(history[count_history]," %s", Command);
	       ShowModel(Command);
	       break;   
	  case (EVALUATE):
	       sprintf(history[count_history]," %s", Command);
	       sscanf(Command,"%*s %s",Option1);
	       switch ( GetToken(Option1) ) {
	       case (GYRATION):
	       case (INERTIA):
		    if ( !SELECTED ) {
			 fprintf(stdout,"> MENU: *No* selction, make a selection first\n");
			 break;
		    }
		    for (i=1; i<= total_models; i++) 
			 if ( (MODELS+i)->Selected ) {
			      RadiusOfGyration(i, Xaxe, Yaxe, Zaxe);	
			 } 
		    break;
	       default:
		    tempvar = DriverEvaluate(Command) ;
		    break;
	       }
	       break;
	  case (SET):
	       /* Set atom properties */
	       sscanf(Command,"%*s %s %s",Option1,Option2) ;
	       if ( strncasecmp(Option1,"Header",4)==0 ) WriteHeader = TRUE ;
	       if ( strncasecmp(Option2,"header",5)==0 ) WriteModelHeader = TRUE ;
	       if ( strncasecmp(Option1,"model",5)==0 ) {
		       WriteModelHeader = TRUE ;
	       }

	       if ( strncasecmp(Option1,"CutUpl",4)==0 ) CutUpl = atof(Option2);
	       if ( strncasecmp(Option1,"Cut_Upl",5)==0 ) CutUpl = atof(Option2);
	       if ( strncasecmp(Option1,"CutAco",4)==0 ) CutAco = atof(Option2);
	       if ( strncasecmp(Option1,"Cut_Aco",5)==0 ) CutAco = atof(Option2);
	       if ( strncasecmp(Option1,"proper",2)==0 ) {
		    tempvar = key_model;
		    for ( key_model=1; key_model <= total_models; key_model++)
			 atom_properties(key_model) ;
		    key_model = tempvar;
	       }
	       /* set maximum number of models */
	       if (strncasecmp(Option1,"MODELS",3)==0 || 
		   strncasecmp(Option1,"TOP",3)==0) {
		    sscanf(Command,"%*s %*s %s", Option3);
		    if (strcmp(Option3,"")==0) {
			 printf("> MAIN: Maximum number of models ?_ : ");
			 GetFromKeyBoard(Option3, MAXWORD, stdin);
		    }
		    TOPMODELS = atoi(Option3)+1;
	       }
	       
	       /* Set the values of ENERGY_CUTOFF or RMSD_MODEL_CUTOFF */
	       if (strncasecmp(Option1,"energy",2)==0) {
		    sscanf(Command,"%*s %*s %s",Option3);
		    if (strcmp(Option3,"")==0) {
			 printf("> MAIN: Cutoff for energy ?_ :");
			 GetFromKeyBoard(Option3, MAXWORD, stdin);
		    }
		    ENERGY_CUTOFF = atof(Option3);
	       }
	       if (strncasecmp(Option1,"rmsd",2)==0) {
		    sscanf(Command,"%*s %*s %s",Option3);
		    if (strcmp(Option3,"")==0) {
			 printf("> MAIN: Cutoff for rmsd ?_ :");
			 GetFromKeyBoard(Option3, MAXWORD, stdin);
		    }
		    RMSD_MODEL_CUTOFF = atof(Option3);
	       }
	       if (strncasecmp(Option1,"segid",3)==0) {
		    for (i = 1 ; i <= total_models ; i++) {
			 Model = MODELS+i ;
			 for (j = 1 ; j <= Model->number_of_atoms ; j++) {
			      strcpy(Model->PDB[j].segid,Option2);
			      Model->PDB[j].segid[4] = '\0';
			 }
		    }
	       }
	       sprintf(history[count_history]," Set %s %s", Option2, Option3);
	       break;
	  case (REMOVE):
	       /* Look for more options in delete command */
	       InitializeOptions() ;
	       i = 0;
	       to = 0;
	       from = 0;
	       tempvar = 0;
	       sscanf(Command,"%*s %s %s", Option2, Option3);
	       strcpy(Option1,delete_model(Option2,Option3,Command)) ;
	       if (strcmp(Option1,"chiral")==0) continue ;
	       if (DEBUG > 3) 
		    printf(" > MAIN: Models after deletion = %d \n", total_models);
	       
	       MODELS = (struct models *)realloc(MODELS,sizeof(struct models)*
						 (total_models+3)) ;
	       AverageModel = total_models+1 ;
	       key_model = total_models ;
	       sprintf(history[count_history]," %s", Command);
	       break;
	  case (SEE):
	       fflush(stderr); fflush(stdout);
	       InitializeOptions();
	       strcpy(Option2,"all");   /* default value for Lib */
	       sscanf(Command," %*s %s %s %s", Option1, Option2, Option3) ;
	       if (strncmp(Option3,"unk",3)==0) strcpy(Option3,""); 
	       switch (GetToken(Option1)) {
	       case (ACO):
		    Option2[0]='\0';  
		    sscanf(Command," %*s %*s %s", Option2) ;
		    SeeAco(Option2) ;
		    Option2[0]='\0';  
		    break ;
	       case (LIBRARY):
		    switch(GetToken(Option2)) {
		    case (NMR):
		    case (NOES):
			 SeeLibraryData(Option3,"NMR ");
			 break;
		    case (DIHEDRAL):
			 SeeDihedralLibraryData("all");
			 break;
		    case (ATOM):
			 SeeLibraryData(Option3,"ATOM");
			 break;
		    case (DISTANCES):
			 ShowKnownDistances(&DistKnown[1]);
			 break;
		    default:
			 SeeDihedralLibraryData(Option2);
			 SeeLibraryData(Option2,"all");
			 break;
		    }
		    break;
	       case (NOES):
		    Option2[0]='\0';  
		    Option3[0]='\0';  
		    sscanf(Command," %*s %*s %s %s", Option3, Option2) ;
		    if ( strncasecmp(Option3,"format",3)==0 ) {
			 strcpy(Option2,"");
			 strcpy(Option3,"format");
		    } else if (strncasecmp(Option3,"sum",3)!=0 && strncasecmp(Option3,"ave",3)!=0 && 
				    strncasecmp(Option3,"cen",3)!=0) {
			 strcpy(Option2,Option3);
			 strcpy(Option3,"ave");
		    }
		    SeeNoes(Option2,Option3) ;
		    Option2[0]='\0';  
		    break ;
	       case (VIOL):
		    Option1[0]='\0';  
		    Option2[0]='\0';  
		    Option3[0]='\0';  
		    sscanf(Command," %*s %*s %s %s %s", Option1, Option3, Option2) ;
		    if ( strncasecmp(Option1,"sum",3)==0 || strncasecmp(Option1,"ave",3)==0 || 
			 strncasecmp(Option1,"cen",3)==0 ) {
			 strcpy(Option2,Option3);
			 strcpy(Option3,Option1);
			 strcpy(Option1,"");
		    } else if ( strncasecmp(Option1,"noe",3)!=0 && strncasecmp(Option1,"aco",3)!=0 ) {
			 if ( isdigit(Option1[0]) ) {
			      CutUpl = atof(Option1);
			      strcpy(Option3,"ave");
			      strcpy(Option1,"");
			 } else {
			      strcpy(Option2,Option1);
			      strcpy(Option3,"ave");
			      strcpy(Option1,"");
			 }
		    } 
		    if ( strncasecmp(Option3,"sum",3)!=0 && strncasecmp(Option3,"ave",3)!=0 && 
			 strncasecmp(Option3,"cen",3)!=0 ) {
			 strcpy(Option2,Option3);
			 strcpy(Option3,"ave");
			 if (strncasecmp(Option1,"noe",3)!=0 && strncasecmp(Option1,"aco",3)!=0 ) {
			      strcpy(Option1,"");
			 }
		    }
		    if ( ConsTrue && (strncasecmp(Option1,"noe",3)==0 || 
				      strncasecmp(Option1,"cons",4)==0 || strcmp(Option1,"")==0) ) {
			 fprintf(stdout,"\n  Writing Residual Violations greater than %.2f to file: `%s'\n",
				 CutUpl, Option2);
			 SeeResidualViol(Option2,Option3,CutUpl);
		    }
		    if ( AcoTrue && (strncasecmp(Option1,"aco",3)==0 || strcmp(Option1,"")==0) ) {
			 fprintf(stdout,"  Writing ACO Violations to file: `%s'\n",Option2);
			 SeeViolAco(Option2, CutAco) ;
		    }
		    fflush(stdout);
		    Option1[0]='\0';  
		    Option2[0]='\0';  
		    Option3[0]='\0';  
		    break;
	       case (PAF):
		    for (i=1;i<=total_models;i++)
			 fprintf(stdout," Models:  %-20s %4d %10.3f %10.3f %10.3f\n", 
				 (MODELS+i)->family, (MODELS+i)->SerialNumber, 
				 (MODELS+i)->PrincipalAxisFrame[0], 
				 (MODELS+i)->PrincipalAxisFrame[1], 
				 (MODELS+i)->PrincipalAxisFrame[2]);
		    break;
	       case (PROPERTIES):
	       case (MODELPICKT):
	       default:
		    if (strncasecmp(Option1,"all",1)==0) {
			 for (i = 1; i <= total_models; i++)
			      fprintf(stdout," Models in memory:  %-20s %4d atoms: %6d \n", 
				      (MODELS+i)->family, (MODELS+i)->SerialNumber, (MODELS+i)->number_of_atoms);
			 break;
		    }
		    if ( isdigit(Option1[0]) ) strcpy(Option2,Option1) ;
		    if (strcmp(Option2,"") == 0) {
			 fprintf(stdout,"> MODEL_prop: What model do you like?:_ ");
			 GetFromKeyBoard(Option2, MAXWORD, stdin);
		    }
		    if (atoi(Option2) <= 1)  strcpy(Option2,"1") ;
		    if (atoi(Option2) > (AverageModel+1)) {
			 printf("> MAIN: ** Wanted Num. (%d) greater than Num. of models "\
				"(%d)\n", atoi(Option1), AverageModel-1) ;
			 printf("> MAIN: ** Working last model (%d) instead \n", AverageModel-1) ;
			 sprintf(Option2,"%d",total_models);
		    }
		    model_properties(atoi(Option2)) ;
		    break;
	       }
	       sprintf(history[count_history]," See %s %s", Option1, Option2);
	       break ;
	  case (TRANSLATE):
	       sprintf(history[count_history]," Translate to center of masses ");
	       translate(-1) ;
	       break;
	  case (DETRANSLATE):
	       sprintf(history[count_history]," DeTranslate from center of masses ");
	       translate(+1) ;
	       break;
	  case (CHAIN_ID):
	       sscanf(Command,"%*s %s",Option2);
	       if (strcmp(Option2,"")==0) {
		    printf("> CHANGE_ID: New ID for chain ?_ ");
		    GetFromKeyBoard(Option2, MAXWORD, stdin);
	       }
	       sprintf(history[count_history]," Chain %s ",Option2);
	       if (strncasecmp(Option2,"blank",3)==0) Option2[0] = ' ';
	       for (i = 1 ; i <= total_models ; i++) {
		    Model = MODELS+i ;
		    for (j = 1 ; j <= Model->number_of_atoms ; j++) {
			 Model->PDB[j].pdb_chain_id[0] = Option2[0];
			 Model->PDB[j].pdb_chain_id[1] = '\0';
		    }
	       }
	       break;
	  case (ENERGY):
	       sprintf(history[count_history]," Energy");
	       for (i = 1 ; i <= total_models ; i++) {
		    Model = MODELS + i;
		    printf("> ENERGY: For model %2d(%2d) the energy is: %.3f \n",
			   i, Model->modelno, Model->energy);
	       }
	       break;
	  case (CLASS):
	       sprintf(history[count_history]," Classify by energy ");
	       classify_by_energy_insight() ;
	       break;
	  case (AVERAGE):
	       InitializeOptions();
	       sscanf(Command,"%*s %s",Option1);
	       if ( strcmp(Option1,"unknown")==0 ) {
		    printf("> MAIN: Backbone, heavy or all ?_: ");
		    GetFromKeyBoard(Option1, MAXWORD, stdin);
	       }
	       sprintf(history[count_history]," Average %s", Option1);
	       for (i=1;i<=total_models;i++)
		    (MODELS+i)->Selected=TRUE;
	       do_average_coords(Option1);
	       break;
	  case (MISSING):
	       InitializeOptions();
	       /* Load Library Data */
	       if (Lib == NULL) {
		    if (DEBUG > 0) printf(" > pdbstat_menu(): Opening Library Data ..\n");
		    LibFile = libfopen("GenCons.Lib","r");
		    if (DEBUG > 0) printf(" > pdbstat_menu(): Getting Library Data ..\n");
		    LibRecords=GetLibraryData(LibFile);
		    if (DEBUG > 0) printf(" > pdbstat_menu(): Closing Library Data ..\n");
		    fclose(LibFile);
	       } else
		    LibRecords = MaxLib ;
	       sscanf(Command,"%*s %s",Option1);
	       if ( Option1[0] == '\0' || strcasecmp(Option1,"unknown")==0 ) 
		    strcpy(Option1,"1"); 
	       CheckPDBNames(LibRecords,Option1) ;
	       sprintf(history[count_history]," %s", Command);
	       break;
	  case (FITT):
	       InitializeOptions();
	       sscanf(Command,"%*s %s %s",Option1,Option2) ;
	       if ( Option1[0] == '\0' || strcasecmp(Option1,"unknown")==0 ) 
		    to=1;
	       else {
		    if (strncasecmp(Option1,"all",1)==0) 
			 sprintf(Option1,"%d",AverageModel);
		    to=atoi(Option1);
	       }
	       if (to > (total_models+1) ) to = total_models ;
	       if (to <= 0)           to = 1 ;
	       if ( Option2[0] == '\0' || strcasecmp(Option2,"unknown")==0 )  
		    strcpy(Option2,"backbone") ;
	       fprintf(stdout,"\n> MAIN: Fitting `%s' atoms to model %d \n",
		       Option2,atoi(Option1));
	       for (from = 1; from <= total_models; from++) {
		    fprintf(stdout," ... calling optimal rotate for %2d over %2d\n",
			    from, to);
		    optimal_rotate(to,from,100,1,Option2);   
	       }
	       sprintf(history[count_history]," %s", Command);
	       break;
	  case (ANALYSIS):
	       if ((!IsThereAModel()) && (!sequence_true)) {
		    fprintf(stdout, "> MAIN: First you *MUST* read sequence data\n");
		    break ;
	       } else if (!IsThereConstraints()) {
		    fprintf(stdout, "> MAIN: First you *MUST* read constraint data\n");
		    break ;
	       }
	       strcpy(history[count_history]," Analyze");
	       write_analysis();
	       break;
	  case (KABSCH):
	       InitializeOptions();
	       sscanf(Command,"%*s %s",Option1);
	       switch ( GetToken(Option1) ) {
	       case (AVERAGE):
		    strcpy(Option1,"average");
		    break;
	       case (ANYNUM):
		    if ( !ValidModelNumber(atoi(Option1),1,total_models) ) {
			 strcpy(Option1,"exit");
			 break;
		    }
		    break;	
	       case (ALLMODELS):
		    break ;
	       default:
		    printf("> WHAT_mdl: What model do you want ?_ :  ");
		    GetFromKeyBoard(Option1, MAXWORD, stdin);
		    if (strncasecmp(Option1,"all",2)!=0 &&
			!ValidModelNumber(atoi(Option1),1,total_models) ) {
		 	strcpy(Option1,"exit");
		 	break;
	    	    }
		    break;
	       }
	       if (strcmp(Option1,"exit")==0) break;
	       sprintf(history[count_history]," Kabsch %s", Option1);
	       kabsch_sander(Option1);
	       break;
	  case (WHICH):
	  case (WHAT):
	       strcpy(history[count_history]," What model?");
	       printf("\n> WHAT_mdl: ** %d models are in memory,"\
		      " %d model is being worked out\n",
		      total_models, key_model);
	       break;
	  case (ORDER):
	       /*
		* Calculating order parameters for PHI and PSI . Order parameter for
		* Dihedrals PHI and PSI are calculated as described in:
		*
		* Hyberts, SG, Golderbg, MS, Havel, TF, Wagner, G.,1992, "The solution
		* structure of eglin c based on measurements of many NOEs and coupling 
		* constants and its comparison with X-ray structures". 
		* Protein Sci., 1:736-751.
		*
		*/
	       InitializeOptions();
	       sscanf(Command,"%*s %s",Option1);
	       if ( Option1[0] == '\0' || strcasecmp(Option1,"unknown")==0 ) {
		    printf("> ORDER_param: Order parameter cutoff ?:_  ");
		    GetFromKeyBoard(Option1, MAXWORD, stdin);
	       }
	       do_lower_case(Option1) ;
	       cutoff=atof(Option1) ;
	       sprintf(history[count_history], " Order %.2f cutoff", cutoff);
	       if (strncmp(Option2,"exit",4)==0) break;
	       calc_order_parameters(cutoff) ;
	       break ;
	  case (RAMACHANDRAN):
	       /*
		* Producing ouput of PHI-PSI for Ramachandran plots
		* this is an intermediate file for further use with ORIENT
		*/
	       fpi = efopen("DELETE.ME","w") ;    /* Check if we have write perm */
	       tempvar = key_model;
	       fprintf(stdout,"> RAMA: Evaluating dihedrals for model/s .. ");
	       for (i=1; i<=total_models; i++) {
		    key_model = i;
		    fprintf(stdout, "%3d\b\b\b",key_model);
		    phi_psi_chi(fpi,0);
	       }
	       fclose(fpi);
	       printf("\n");
	       fpi=fopen("RAMACHANDRAN.OUT","w");
	       fprintf(stdout,"> RAMA: Creating Ramachandran plot, model ..");
	       for (i = 1 ; i <= total_models ; i++) {
		    Model = MODELS + i;
		    fprintf(stdout,"%3d\b\b\b",i);
		    fprintf(fpi,"RAMACHANDRAN   MODEL    %3d\n", i);
		    for (k = 2 ; k <= MODELS[i].number_of_residues - 1 ; k++) {
			 fprintf(fpi," %s  %3d  %8.3f %8.3f \n",
				 Model->DIH[k].resname,
				 k,
				 Model->DIH[k].phi,
				 Model->DIH[k].psi);
		    }
	       }
	       fclose(fpi);
	       printf("\n");
	       /* Producing the PS output file  */
	       InitializeCommand();
	       printf("> RAMA: Name for PostScript output file ?_: ");
	       GetFromKeyBoard(Command, MAXWORD, stdin);
	       fpi=safeopen(Command,"w",(int)strlen(Command));
	       ps_drawgraph(fpi);
	       fclose(fpi);
	       sprintf(history[count_history]," Ramachandran %s", Command);
	       break;
	  case (HISTORY):
	       strcpy(history[count_history]," History");
	       printf("\n   ------- Sequence (history) of commands ------ \n");
	       for (i=1;i<=count_history;i++)
		    printf(" %3d command: %s \n",i,history[i]);
	       printf("\n");
	       break;
	  case (HYPER):
	       InitializeOptions();
	       sscanf(Command,"%*s %s",Option1);
	       if (total_models == 1) strcpy(Option1,"1");  
	       if (total_models == 0) { /* We read constraints */
		    strcpy(Option1,"1");
		    total_models = 1;
	       }
	       switch (GetToken(Option1)) {
	       case (AVERAGE):
		    key_model = AverageModel;
		    break ;
	       case (ANYNUM):
		    if ( !ValidModelNumber(atoi(Option1),1,total_models) ) {
			 strcpy(Command,"exit");
			 break;
		    }
		    key_model = atoi(Option1);
		    break;	
	       default:
		    printf("> WHAT_mdl: What model do you want ?_ :  ");
		    GetFromKeyBoard(Option1, MAXWORD, stdin);
		    if ( !ValidModelNumber(atoi(Option1),1,total_models) ) {
			 strcpy(Command,"exit");
			 break;
		    }
		    key_model = atoi(Option1);
		    break;
	       }
	       if (strcmp(Option1,"exit")==0) break;
	       sprintf(history[count_history]," Hyper %s", Option1);
	       InitializeOptions();
	       printf("\n> HYPER_builder: allowed range in distances (def. 0.5 A) :_ ");
	       GetFromKeyBoard(Option1, MAXWORD, stdin);
	       strcat(history[count_history],Option1);
	       if (strncmp(Option1,"exit",4)==0) break;
	       strcat(history[count_history]," A allowed");
	       if (strcmp(Option1,"")==0) strcpy(Option1,"0.5");
	       allowed_d = atof(Option1);
	       if ((allowed_d <= 0.0) || (allowed_d > 2.5)) allowed_d=0.5;
	       printf("> HYPER_builder: allowed range in jcoup (def. 1.0 Hz) :_  ");
	       GetFromKeyBoard(Option1, MAXWORD, stdin);
	       if (strcmp(Option1,"")==0) strcpy(Option1,"1.0");
	       strcat(history[count_history],Option1);
	       if (strncmp(Option1,"exit",4)==0) break;
	       strcat(history[count_history]," Hertz allowed");
	       allowed_j = atof(Option1);
	       if ((allowed_j < 0.0) || (allowed_j > 4.0)) allowed_j=1.0;
	       printf ("> HYPER_builder: Constraints or coordinates input file ?:_  ");
	       GetFromKeyBoard(Option1, MAXWORD, stdin);
	       switch ( GetToken(Option1) ) {
	       case (COORDINATES):
		    Model = MODELS + key_model ;
		    MAX = Model->number_of_atoms + 1;
		    if (MAX <= 0) {
			 printf("> HYPER_prep: ** No molecule read ** \n");
			 break;
		    }
		    strcat(history[count_history]," from coordi file");
		    phi_psi_chi(fpi,0);
		    selec_dis_for_hyper();
		    break;
	       case (NOES):
		    strcat(history[count_history]," from constr file");
		    for_hyper();
		    break;
	       case (FIN):
		    strcat(history[count_history]," *Exit* detected ");
		    break;
	       default:
		    sprintf(history[count_history],"`%s'",Option1);
		    strcat(history[count_history]," ->  *NOT* availlable ");
		    printf("\n> MAIN: *Option* `%s' *NOT* available \n", Option1 );
		    break;
	       }
	       break;
	  case (MENU): /* Give a list with ALL comands */
	       for (i = 1 ; i < 60 ; i++) printf("\n");
	       if ( !HelpFileName ) InitHelpFile();
	       if ( !HelpFileName ) break ;
	       TokenPtr = "commands" ;
	       if ( HelpInfo ) FindHelpInfo();
	       break;
	  case (HELP):
	       Option1[0]='\0';
	       Option2[0]='\0';
	       Option3[0]='\0';
	       /*
		* This is an ugly way of clean the screen 
		*/
	       for (i = 1 ; i < 60 ; i++) printf("\n");
	       if ( !HelpFileName ) InitHelpFile();
	       sprintf(history[count_history]," Help ") ;
	       sscanf(Command,"%*s %s %s", Option2, Option3) ;
	       if ( !HelpFileName ) break ;
	       if ( Option2[0]=='\0' || strcasecmp(Option2,"unknown")==0 ) {
		    strcpy(Option2,"help");
	       } else {
		    strcat(Option2," ");
		    strcat(Option2,Option3);
	       }
	       TokenPtr = Option2 ;
	       if ( HelpInfo ) FindHelpInfo();
	       printf(" ......................... End of help ........................ \n");
	       break;
	  case (HYDROBONDS):
	       InitializeOptions();
	       sscanf(Command,"%*s %s",Option1);
	       switch ( GetToken(Option1) ) {
	       case (AVERAGE):
		    key_model = AverageModel;
		    break ;
	       case (ANYNUM):
		    if ( !ValidModelNumber(atoi(Option1),1,total_models) ) {
			 strcpy(Option1,"exit");
			 break;
		    }
		    key_model = atoi(Option1);
		    break;
	       case (ALLMODELS):
		    strcpy(tempchar,"all");
		    sscanf(Command,"%*s %*s %s %s",Option2,Option3);
		    if ( strcmp(Option2,"")==0 || strncmp(Option2,"unk",3)==0 ) strcpy(Option2,"3.40");
		    if ( strcmp(Option3,"")==0 || strncmp(Option3,"unk",3)==0 ) strcpy(Option3,"120.0");
	            hydrogen_bonds(atof(Option2),atof(Option3),tempchar);
		    break ;
	       default:
		    printf("> CLOSE_cntcts: What model do you want ?_ :  ");
		    GetFromKeyBoard(Option1, MAXWORD, stdin);
		    if ( !ValidModelNumber(atoi(Option1),1,total_models) ) {
		 	strcpy(Option1,"exit");
		 	break;
		    }
		    key_model = atoi(Option1);
		    break ;
	       }
	       /*
		* The code down here is very, very messy, on Feb 2003 I keep it to have things working as I am in a hurry
		* but this has to be cleaned
		*/
	       sprintf(history[count_history]," %s", Command);
	       if ( strncasecmp(Option1,"all",2)!= 0 ) {
		    if (strcmp(Option1,"exit")==0) break ;
		    InitializeOptions();
		    Model = MODELS + key_model ;
		    MAX = Model->number_of_atoms + 1;
		    if (MAX <= 0) {
			 printf("> HYDROGEN_prep: ** No molecule read \n");
			 break;
		    }
		    strcpy(history[count_history],"hydrogen bond account");
		    if (cristal==1) {
			 printf("> HYDRGN_bnd: Working model with *NO* hydrogens \n") ;
			 printf("> HYDRGN_bnd: This is a crystal structure, I guess ... \n") ;
		    }
		    printf("> HYDRGN_bnd: distance cutoff (donor - acceptor) [def. 3.50 Angs.] ?:_ ");
		    GetFromKeyBoard(Option1, MAXWORD, stdin);
		    do_lower_case(Option1);
		    strcat(history[count_history],Option1);
		    if (strncmp(Option1,"exit",4)==0) break;
		    if (cristal==0)
			 printf("> HYDRGN_bnd: angle cutoff (donor-hydrogen-accept) [def. 120 deg.] ?:_ ");
		    if (cristal==1)
			 printf("> HYDRGN_bnd: angle cutoff (donor-accept-antecedant) [def. 60 deg.] ?:_ ");
		    GetFromKeyBoard(Option2, MAXWORD, stdin);   
		    do_lower_case(Option2);
		    strcat(history[count_history],Option2);
		    if (strncmp(Option2,"exit",4)==0) break;
		    sprintf(tempchar,"%d",key_model);
		    hydrogen_bonds(atof(Option1),atof(Option2),tempchar);
	       }
	       break;
	  case (MOVE):
	       sscanf(Command,"%*s %d %d", &from, &to);
	       sprintf(history[count_history]," Move  %d  %d",from,to);
	       if ( !ValidModelNumber(from,1,total_models) ||
		    !ValidModelNumber(to,1,total_models) ) {
		    printf ("> MOVE_mdl: *** Check model # %d or %d in copy %d %d\n",
			    from,to, from,to);
		    break;
	       }
	       do_copy_model(from,to);
	       sprintf(Option1,"delete");
	       sprintf(Command,"delete  %d %d", from, to);
	       continue;
	       /* break; */
	  case (CHIRAL):
	       sprintf(history[count_history]," Check chirality, omega, etc. ");
	       strcpy(Option1,check_planar_sc(Option2)) ;
	       if (strcmp(Option1,"done")==0)
		    break ;
	       else
		    continue ;
	       /* break;   */
	  case (INITIALIZE):
	       InitializeOptions();
	       sscanf(Command,"%*s %s",Option2);
	       if ((strcmp(Option2,"")==0) || (strncmp(Option2,"all",1)==0)) {
		    sprintf(history[count_history]," Initialize all ");
		    haz_ceros(999);
	       } else {
		    if ((atoi(Option2) <= 0) || (atoi(Option2) > AverageModel)) 
			 strcpy(Option2,"999");
		    sprintf(history[count_history]," Iniatlize model `%d' ",atoi(Option2));
		    haz_ceros(atoi(Option2));
	       }
	       fprintf(stdout,"> INIT: ... Initialization DONE \n");
	       break;
	  case (FIN):
	       sprintf(history[count_history]," Exit %s", Command);
	       printf ("\n> MAIN:  *END* of program detected, BYE! ...\n\n");
	       /*
		* Delete unnecessary file DELETE.ME that may be was created
		* in other stages of the program. This should be fixed at some
		* moment. This file is used mainly to check if we have write 
		* permissions in the directory where PDBSTAT is launched.
		*/
	       if ((fpi = fopen("DELETE.ME","r")) != NULL) {
		    fclose(fpi);
		    execl("/bin/rm","rm","-f","DELETE.ME",(char *) 0);
	       }

	       /*
		* Delete RandomDistances file that was written to hold
		* homology constraints
		*/
	       if ((fpi = fopen("RandomDistances","r")) != NULL) {
		    fclose(fpi);
		    execl("/bin/rm","rm","RandomDistances",(char *) 0);
	       }
	      
	       /*
		* In case of no Error in Noes delete file
		*/
	       if ( !ErrorsInNoes && ConsTrue ) {
		    execl("/bin/rm","rm","-f","ErrorsInNoes",(char *) 0);
	       }
	       exit (0);
	  default:
	       if (GetToken(Command) == UNKNOWN ) {
		    printf("\n> MAIN: ** *Oops* we should never get here.!");
		    printf("\n> MAIN: ** Maybe AyudaPATH environment variable is not set");
		    printf("\n> MAIN: ** If AyudaPATH is set, please report this!\n");
	       } else {
		    printf("\n> MAIN: `%s' not a valid command, try `help command'\n",
			   Command);
	       }
	       break ;
	  }
	  printf("\n> MAIN: [rea]d [hel]p [his]tory [men]u [phi] [qui]t...");
	  printf("\n> MAIN: ?_  ");
	  InitializeCommand(); 
	  GetFromKeyBoard(Command, MAXWORD, stdin) ;
     }
}


int GetToken(char Command[MAXWORD]) {
     if      (strncasecmp(Command,"read",3)==0)        return READ ;
     else if (strcasecmp(Command,"best")==0)           return BESTSUPER ;  
     else if (strcasecmp(Command,"")==0)               return BLANK ;  
     else if (strncasecmp(Command,"*",1)==0)           return ANY ;  
     else if (strncasecmp(Command,"aco",3)==0)         return ACO;  
     else if (strncasecmp(Command,"align",3)==0)       return ALIGN;  
     else if (strncasecmp(Command,"all",3)==0)         return ALLMODELS;  
     else if (strncasecmp(Command,"analysis",3)==0)    return ANALYSIS;
     else if (strncasecmp(Command,"angle",3)==0)       return ACO;  
     else if (strncasecmp(Command,"atom",3)==0)        return ATOM;
     else if (strncasecmp(Command,"author",3)==0)      return AUTHOR;  
     else if (strncasecmp(Command,"average",3)==0)     return AVERAGE;
     else if (strncasecmp(Command,"Bfield",2)==0)      return BFIELD;
     else if (strncasecmp(Command,"cambia",3)==0)      return CHANGE ;
     else if (strncasecmp(Command,"center",3)==0)      return CENTER;
     else if (strncasecmp(Command,"chain",4)==0)       return CHAIN_ID;
     else if (strncasecmp(Command,"check",4)==0)       return CHIRAL;
     else if (strncasecmp(Command,"chiral",4)==0)      return CHIRAL;
     else if (strncasecmp(Command,"change",4)==0)      return CHANGE ;
     else if (strncasecmp(Command,"charmm",4)==0)      return CHARMM ;
     else if (strncasecmp(Command,"choose",3)==0)      return CHOOSE ;
     else if (strncasecmp(Command,"clear",3)==0)       return CLEAR;
     else if (strncasecmp(Command,"class",3)==0)       return CLASS;
     else if (strncasecmp(Command,"close",3)==0)       return CLOSE;
     else if (strncasecmp(Command,"cns",3)==0)         return CNS ;
     else if (strncasecmp(Command,"congen",4)==0)      return CONGEN;
     else if (strncasecmp(Command,"constraints",4)==0) return NOES ;
     else if (strncasecmp(Command,"contacts",4)==0)    return CONTACTS ;
     else if (strncasecmp(Command,"coordinates",3)==0) return COORDINATES ;
     else if (strncasecmp(Command,"copy",3)==0)        return COPY;
     else if (strncasecmp(Command,"cyana",3)==0)       return CYANA ;
     else if (strncasecmp(Command,"delet",3)==0)       return REMOVE;
     else if (strncasecmp(Command,"debug",3)==0)       return DEBUGLEVEL;
     else if (strncasecmp(Command,"detranslate",3)==0) return DETRANSLATE;
     else if (strncasecmp(Command,"diana",4)==0)       return DIANA ;
     else if (strncasecmp(Command,"dihedral",3)==0)    return DIHEDRAL;
     else if (strncasecmp(Command,"dimension",3)==0)   return PROGRAMVERS ;
     else if (strncasecmp(Command,"dipolar",3)==0)     return RDC;
     else if (strncasecmp(Command,"discover",4)==0)    return DISCOVER ;
     else if (strncasecmp(Command,"disman",4)==0)      return DISMAN ;
     else if (strncasecmp(Command,"distances",4)==0)   return DISTANCES ;
     else if (strncasecmp(Command,"dyana",4)==0)       return DYANA ;
     else if (strncasecmp(Command,"ecepp",3)==0)       return ECEPP;
     else if (strncasecmp(Command,"energy",3)==0)      return ENERGY;
     else if (strncasecmp(Command,"exit",3)==0)        return FIN;
     else if (strncasecmp(Command,"evaluate",3)==0)    return EVALUATE;
     else if (strncasecmp(Command,"fitt",3)==0)        return FITT ;
     else if (strncasecmp(Command,"frame",3)==0)       return PAF;
     else if (strncasecmp(Command,"get",3)==0)         return GET ;
     else if (strncasecmp(Command,"gyration",3)==0)    return GYRATION ;
     else if (strncasecmp(Command,"giration",3)==0)    return GYRATION ;
     else if (strncasecmp(Command,"help",3)==0)        return HELP ;
     else if (strncasecmp(Command,"hyper",3)==0)       return HYPER ;
     else if (strncasecmp(Command,"?",1)==0)           return HELP ;
     else if (strncasecmp(Command,"history",3)==0)     return HISTORY ;
     else if (strncasecmp(Command,"hydro",3)==0)       return HYDROBONDS ;
     else if (strncasecmp(Command,"hbond",3)==0)       return HYDROBONDS ;
     else if (strncasecmp(Command,"homa ",4)==0)       return HOMOLOGY ;
     else if (strncasecmp(Command,"homme",4)==0)       return HOMOLOGY ;
     else if (strncasecmp(Command,"homol",4)==0)       return HOMOLOGY ;
     else if (strncasecmp(Command,"identi",3)==0)      return CHAIN_ID;
     else if (strncasecmp(Command,"impact",3)==0)      return IMPACT ;
     else if (strncasecmp(Command,"initial",3)==0)     return INITIALIZE;
     else if (strncasecmp(Command,"inertia",3)==0)     return INERTIA;   
     else if (strncasecmp(Command,"info",3)==0)        return INFO;
     else if (strncasecmp(Command,"insight",3)==0)     return INSIGHT ;
     else if (strncasecmp(Command,"iupac",3)==0)       return IUPAC;
     else if (strncasecmp(Command,"jcoup",3)==0)       return JCOUP ;
     else if (strncasecmp(Command,"kabsch",3)==0)      return KABSCH;
     else if (strncasecmp(Command,"library",3)==0)     return LIBRARY;
     else if (strncasecmp(Command,"lol",3)==0)         return LOL ;
     else if (strncasecmp(Command,"menu",3)==0)        return MENU ;
     else if (strncasecmp(Command,"missing",3)==0)     return MISSING;
     else if (strncasecmp(Command,"model",4)==0)       return MODELPICKT;
     else if (strncasecmp(Command,"modif",4)==0)       return MODIFY ;
     else if (strncasecmp(Command,"move",3)==0)        return MOVE;
     else if (strncasecmp(Command,"noes",3)==0)        return NOES;
     else if (strncasecmp(Command,"nmr",3)==0)         return NMR;
     else if (strncasecmp(Command,"order",3)==0)       return ORDER;
     else if (strncasecmp(Command,"pdb",3)==0)         return PDBFORMAT ;
     else if (strncasecmp(Command,"phi",3)==0)         return DIHEDRAL;
     else if (strncasecmp(Command,"paf",3)==0)         return PAF;
     else if (strncasecmp(Command,"print",3)==0)       return SEE;
     else if (strncasecmp(Command,"properties",3)==0)  return PROPERTIES;
     else if (strncasecmp(Command,"quit",3)==0)        return FIN;
     else if (strncasecmp(Command,"ramachandr",3)==0)  return RAMACHANDRAN;
     else if (strncasecmp(Command,"rdc",3)==0)         return RDC;
     else if (strncasecmp(Command,"relax",3)==0)       return RELAX;
     else if (strncasecmp(Command,"remove",3)==0)      return REMOVE;
     else if (strncasecmp(Command,"reset",4)==0)       return RESET;
     else if (strncasecmp(Command,"residual",4)==0)    return VIOL ;
     else if (strncasecmp(Command,"restore",4)==0)     return RESTORE;
     else if (strncasecmp(Command,"rmsd",3)==0)        return RMSD;
     else if (strncasecmp(Command,"select",3)==0)      return RESTRICT;
     else if (strncasecmp(Command,"see",3)==0)         return SEE;
     else if (strncasecmp(Command,"set",3)==0)         return SET;
     else if (strncasecmp(Command,"show",3)==0)        return SHOW;
     else if (strncasecmp(Command,"sequence",3)==0)    return SEQUENCE ;
     else if (strncasecmp(Command,"translate",3)==0)   return TRANSLATE;
     else if (strncasecmp(Command,"to ",3)==0)         return TO;
     else if (strncasecmp(Command,"upl",3)==0)         return UPL ;
     else if (strncasecmp(Command,"version",3)==0)     return PROGRAMVERS ;
     else if (strncasecmp(Command,"violation",3)==0)   return VIOL ;
     else if (strncasecmp(Command,"which",3)==0)       return WHICH ;
     else if (strncasecmp(Command,"what",3)==0)        return WHAT ;
     else if (strncasecmp(Command,"write",3)==0)       return WRITE ;
     else if (strncasecmp(Command,"xplor",3)==0)       return XPLOR  ;
     else if (strncasecmp(Command,"x-plor",3)==0)      return XPLOR  ;
     else if ( IsAtomName(Command) )                   return ATOMNAME ;
     else if ( IsResidueName(Command) )                return RESIDUENAME ;
     else if ( isdigit(Command[0]) )                   return ANYNUM ;
     else if ( isalnum(Command[0]) )                   return ALPHANUM ;
     else {
	  if (DEBUG > 0)
	       fprintf(stderr," > Token: %s, is UNKNOWN \n", Command);
	  return UNKNOWN ;
     }
}


void InitializeCommand(void) {
     static short Cnt ;
     strcpy(Option1,"unknown"); 
     strcpy(Option2,"unknown");
     strcpy(Option3,"unknown");
     strcpy(Option4,"unknown");
     strcpy(Command,"unknown");
     for ( Cnt = (int)strlen("unknown"); Cnt < MAXWORD; Cnt++ )
	  Option1[Cnt] = Option2[Cnt] = Option3[Cnt] = Option4[Cnt] = Command[Cnt] = '\0';
     
     return;
}


void InitializeOptions(void) { 
     static short Cnt;
     strcpy(Option1,"unknown"); 
     strcpy(Option2,"unknown");
     strcpy(Option3,"unknown");
     strcpy(Option4,"unknown");
     strcpy(Option5,"unknown");
     for ( Cnt = (int)strlen("unknown"); Cnt < MAXWORD; Cnt++ )
	  Option1[Cnt] = Option2[Cnt] = Option3[Cnt] = Option4[Cnt] = Option5[Cnt] = '\0';
     
     return ;
}


char ValidModelNumber(int modelo, int minimum, int maximum) {
     if ((modelo < minimum) || (modelo > maximum+1)) {
	  printf("> SELECT_mdl: ** Model should be between 1 - %d \n", maximum);
	  return FALSE;
     } else
	  return TRUE;
}



char SelectAtom(int model, int atom, char Descrip[MAXWORD]) {
     /*
      * SelectAtoms
      * Routine used to select atom names in selections.
      * It checks PDB records for
      *     type:      hydrogen or heavy
      *     chain:     backbone or sidechain
      *     pdb_iupac: PDB code for the atoms
      *       *:       Wildcard, it maches ANY name.
      */
     static int Largo ;
     static int  ik=0,kk=0,Add=0;
     static char TmpChr1[MAXWORD], TmpChr2[MAXWORD];
     static char Encontrado = FALSE;
     
     Encontrado = FALSE ;
     kk = 0;
     
     for (ik=0; ik<=(int)strlen(Descrip); ik++) {
	  if (Descrip[ik] == ',') {
	       copy(TmpChr1, Descrip, kk, ik-1);
	       if (TmpChr1[0] != ' ')
		    strcpy(TmpChr2,AddWhiteSpace(TmpChr1));
	       else 
		    strcpy(TmpChr2,TmpChr1);
	       strcat(TmpChr2," ");
	       if (DEBUG > 5) 
		    printf(" > SelectAtom(): Comma found, trying `%s' \n", TmpChr2);
	       kk = ik+1 ;
	       goto Busca ;
	  } else if ( ik == (int) strlen(Descrip) ) {
	       copy(TmpChr1, Descrip, kk, ik-1);
	       if (TmpChr1[0] != ' ')
		    strcpy(TmpChr2,AddWhiteSpace(TmpChr1));
	       else
		    strcpy(TmpChr2,TmpChr1);
	       if (Descrip[ik-1] != '*') {
		    Add=0;
		    strcat(TmpChr2," ");
	       } else {
		    Add=-1;
	       }
	       if (DEBUG > 5) 
		    printf(" > SelectAtom(): trying `%s' \n", TmpChr2);
	       goto Busca;
	  } else { 
	       goto Otro;
	  }
     Busca:
	  Largo = (int)strlen(TmpChr2)+Add;
	  if ((strncasecmp((MODELS+model)->PDB[atom].chain,TmpChr2,2)==0) || 
	      (strncasecmp((MODELS+model)->PDB[atom].pdb_iupac,TmpChr2,Largo)==0) ||
	      (strncasecmp((MODELS+model)->PDB[atom].type,TmpChr2,2)==0) ||
	      (strncmp(TmpChr2," *",2)==0) || (strncmp(TmpChr2,"*",1)==0) )
	       Encontrado = TRUE ;
     Otro:
	  ;
     }
     return Encontrado ;
}



void SelectResidueRanges(char Option[MAXWORD]) {
     /*
      * SelectResidueRanges
      * Routine used to decode ranges in selections. Ranges can be:
      * 1-2,3-4,10-50      1-10,30-60
      */
     static short i=0, k=0 ;
     static char tempchar[10] ;
     static char HasComma = FALSE ;
     static char HasDash = FALSE ;
   
     HasComma = FALSE ;
     HasDash = FALSE ;
     i = k = 0 ;
     /* Start selection */
     for (i = 0; i <= (int)strlen(Option); i++) {
	  if (Option[i] == '-') {    /* A dash has been found */
	       RANGES.number++ ;
	       copy(tempchar,Option,k,i-1);
	       if ( isalpha(tempchar[0]) ) {
		    RANGES.chain_id[RANGES.number][0] = toupper(tempchar[0]);
		    tempchar[0]=' ';
	       } else {
		    RANGES.chain_id[RANGES.number][0] = '*';
	       }
	       RANGES.from[RANGES.number] = atoi(tempchar);
	       HasDash = TRUE;
	       k = i+1;
	  } else if (Option[i] == ',') { /* A comma has been found */
	       if (HasDash) {
		    copy(tempchar,Option,k,i-1);
		    if ( isalpha(tempchar[0]) ) {
			 RANGES.chain_id[RANGES.number][0] = toupper(tempchar[0]);
			 tempchar[0]=' ';
		    } else {
			 RANGES.chain_id[RANGES.number][0] = '*';
		    }
		    RANGES.to[RANGES.number] = atoi(tempchar);	
		    HasDash = FALSE;
	       } else {
		    RANGES.number++ ;
		    copy(tempchar,Option,k,i-1);
		    if ( isalpha(tempchar[0]) ) {
			 RANGES.chain_id[RANGES.number][0] = toupper(tempchar[0]);
			 tempchar[0]=' ';
		    } else {
			 RANGES.chain_id[RANGES.number][0] = '*';
		    }
		    RANGES.from[RANGES.number] = RANGES.to[RANGES.number] = atoi(tempchar);
	       }
	       HasComma = TRUE ;
	       k = i+1;
	  } else if (i == (int)strlen(Option)) { /* End of string detected */
	       copy(tempchar,Option,k,i);
	       if (!HasDash && HasComma) {
		    RANGES.number++ ;
		    if ( isalpha(tempchar[0]) ) {
			 RANGES.chain_id[RANGES.number][0] = toupper(tempchar[0]);
			 tempchar[0]=' ';
		    } else {
			 RANGES.chain_id[RANGES.number][0] = '*';
		    }
		    RANGES.from[RANGES.number] = RANGES.to[RANGES.number] = atoi(tempchar);
	       } else if ( !HasComma && !HasDash )  {  /* no comma, no dash, only a number */
		    RANGES.number++;
		    if ( isalpha(tempchar[0]) ) {
			 RANGES.chain_id[RANGES.number][0] = toupper(tempchar[0]);
			 tempchar[0]=' ';
		    } else {
			 RANGES.chain_id[RANGES.number][0] = '*';
		    }
		    RANGES.from[RANGES.number] = RANGES.to[RANGES.number] = atoi(tempchar);
	       } else {    
		    if ( isalpha(tempchar[0]) ) {
			 RANGES.chain_id[RANGES.number][0] = toupper(tempchar[0]);
			 tempchar[0]=' ';
		    } else {
			 RANGES.chain_id[RANGES.number][0] = '*';
		    }
		    RANGES.to[RANGES.number] = atoi(tempchar);
	       }
	  }
     }
     
     /* DEBUG and check */
     if (RANGES.from[RANGES.number] == 0 && RANGES.to[RANGES.number] == 0)
	  RANGES.number-- ;
     
     for ( i = 1; i <= RANGES.number; i++) {
	  if ( DEBUG > 0 ) fprintf(stdout," > SelectResidueRanges(): Range # %3d, Chain %s, from %3d, to %3d\n",
				   i, RANGES.chain_id[i], RANGES.from[i], RANGES.to[i]);
	  if (RANGES.from[RANGES.number] == 0 || RANGES.to[RANGES.number] == 0 )
	       fprintf(stderr," SelectResidueRanges():  *Oops* something wrong in slection \n");
     }
     
     /* go back */
     return ;
}

void SelectModelRanges(char Option[MAXWORD]) {
     /*
      * SelectModelRanges
      * Routine used to decode ranges in selections. Ranges can be:
      * 1-2,3-4,10-50      1-10,30-60
      */
     static short i=0, k=0 ;
     static char tempchar[10] ;
     static char HasComma = FALSE ;
     static char HasDash = FALSE ;
   
     HasComma = FALSE ;
     HasDash = FALSE ;
     i = k = 0; 
     /* Start selection */
     for (i = 0; i <= (int)strlen(Option); i++) {
	  if (Option[i] == '-') {    /* A dash has been found */
	       MODELRANGES.number++ ;
	       copy(tempchar,Option,k,i-1);
	       if ( isalpha(tempchar[0]) ) {
		    MODELRANGES.chain_id[MODELRANGES.number][0] = toupper(tempchar[0]);
		    tempchar[0]=' ';
	       } else {
		    MODELRANGES.chain_id[MODELRANGES.number][0] = '*';
	       }
	       MODELRANGES.from[MODELRANGES.number] = atoi(tempchar);
	       HasDash = TRUE;
	       k = i+1;
	  } else if (Option[i] == ',') { /* A comma has been found */
	       if (HasDash) {
		    copy(tempchar,Option,k,i-1);
		    if ( isalpha(tempchar[0]) ) {
			 MODELRANGES.chain_id[MODELRANGES.number][0] = toupper(tempchar[0]);
			 tempchar[0]=' ';
		    } else {
			 MODELRANGES.chain_id[MODELRANGES.number][0] = '*';
		    }
		    MODELRANGES.to[MODELRANGES.number] = atoi(tempchar);
		    HasDash = FALSE ;
	       } else {
		    MODELRANGES.number++ ;
		    copy(tempchar,Option,k,i-1);
		    if ( isalpha(tempchar[0]) ) {
			 MODELRANGES.chain_id[MODELRANGES.number][0] = toupper(tempchar[0]);
			 tempchar[0]=' ';
		    } else {
			 MODELRANGES.chain_id[MODELRANGES.number][0] = '*';
		    }
		    MODELRANGES.from[MODELRANGES.number] = MODELRANGES.to[MODELRANGES.number] = atoi(tempchar);
	       }
	       HasComma = TRUE ;
	       k = i+1;
	  } else if (i == (int)strlen(Option)) { /* End of string detected */
	       copy(tempchar,Option,k,i-1);
	       if (!HasDash && HasComma) {
		    MODELRANGES.number++ ;
		    if ( isalpha(tempchar[0]) ) {
			 MODELRANGES.chain_id[MODELRANGES.number][0] = toupper(tempchar[0]);
			 tempchar[0]=' ';
		    } else {
			 MODELRANGES.chain_id[MODELRANGES.number][0] = '*';
		    }
		    MODELRANGES.from[MODELRANGES.number] = MODELRANGES.to[MODELRANGES.number] = atoi(tempchar);
	       } else if ( !HasComma && !HasDash )  {
		    MODELRANGES.number++;
		    if ( isalpha(tempchar[0]) ) {
			 MODELRANGES.chain_id[MODELRANGES.number][0] = toupper(tempchar[0]);
			 tempchar[0]=' ';
		    } else {
			 MODELRANGES.chain_id[MODELRANGES.number][0] = '*';
		    }
		    MODELRANGES.from[MODELRANGES.number] = MODELRANGES.to[MODELRANGES.number] = atoi(tempchar);
	       } else {    
		    if ( isalpha(tempchar[0]) ) {
			 MODELRANGES.chain_id[MODELRANGES.number][0] = toupper(tempchar[0]);
			 tempchar[0]=' ';
		    } else {
			 MODELRANGES.chain_id[MODELRANGES.number][0] = '*';
		    }
		    MODELRANGES.to[MODELRANGES.number] = atoi(tempchar);
	       }
	  }
     }
     
     
     /* DEBUG and check */
     if (MODELRANGES.from[MODELRANGES.number] == 0 && MODELRANGES.to[MODELRANGES.number] == 0)
	  MODELRANGES.number-- ;
     
     for ( i = 1; i <= MODELRANGES.number; i++) {
	  if ( DEBUG > 0 ) 
	       fprintf(stdout," > SelectModelRanges(): Range # %3d, chain %2s from %3d, to %3d\n",
		       i, MODELRANGES.chain_id[i], MODELRANGES.from[i], MODELRANGES.to[i]);
	  if (MODELRANGES.from[MODELRANGES.number] == 0 || MODELRANGES.to[MODELRANGES.number] == 0 )
	       fprintf(stderr," SelectModelRanges():  *Oops* something wrong in slection \n");
     }
     
     /* go back */
     return ;
}




char *AddWhiteSpace(char Option[MAXWORD]) {
     /*
      * AddWhiteSpace.
      * Routine used for inserting a white space at the beginning of the string
      * defining atom name if the atom name begins with C,N,S,O,H,
      * This is so because atoms are stored in memory as ' CA' rather than 'CA'
      * to fullfill PDB rules. In the first place of atom names there is only
      * a number 1-3 or white space.
      *   CA
      *  1HB
      *   C
      *   O
      */
     static short int i=0;
     
     if ( (strncasecmp(Option,"hea",3)!=0) && (strncasecmp(Option,"sid",3)!=0) &&
	  (strncasecmp(Option,"hyd",3)!=0) && (strncasecmp(Option,"bac",3)!=0) ) {
	  if ( (strncasecmp(Option,"N",1)==0) ||
	       (strncasecmp(Option,"C",1)==0) ||
	       (strncasecmp(Option,"O",1)==0) ||
	       (strncasecmp(Option,"H",1)==0) ||
	       (strncasecmp(Option,"S",1)==0) ) {
	       TmpChar[0] = ' '; TmpChar[1] = '\0';
	       for (i=1;i <= (int)strlen(Option); i++)
		    TmpChar[i] = Option[i-1];
	  } else {
	       for (i=0;i <= (int)strlen(Option); i++)
		    TmpChar[i] = Option[i];
	  }
     } else 
	  for (i=0;i <= (int)strlen(Option); i++)
	       TmpChar[i] = Option[i];
     
     /* Finish the string */
     TmpChar[i] = '\0';
     
     if (DEBUG == -1) 
	  fprintf(stdout," > Atom: %s \n", TmpChar);
     
     return TmpChar;
}


char IsResidueName(char Option[MAXWORD]) {
     static struct Library *registro;
     static FILE *LibFile;
     static int LibRecords;
     static char Found = FALSE;
     
     Found = FALSE ;
     if ( (Lib == NULL) || (MaxLib <=0) ) {
	  /* Load Library Data */
	  if (DEBUG >= 1) printf(" > IsResidueName(): Opening Library Data ..\n");
	  if ( (LibFile = libfopen("GenCons.Lib","r")) == (FILE *) NULL ) {
	       printf(" > IsResidueName(): Unable to open Library data file\n");
	       printf(" > IsResidueName(): AyudaPATH is _UNSET_ or set wrong\n\n");
	       return UNKNOWN;
	  }
	  if (DEBUG >= 1) printf(" > IsResidueName(): Getting Library Data ..\n");
	  LibRecords=GetLibraryData(LibFile);
	  if (DEBUG >= 1) printf(" > IsResidueName(): Closing Library Data ..\n");
	  fclose(LibFile);
     } else
	  LibRecords = MaxLib ;
     
     if ( MaxLib <= 0 ) {
	  printf("\n > IsResidueName(): * No records in library \n\n");
	  return UNKNOWN;
     }
     
     registro = &Lib[1] ;
      while ( registro->next != NULL ) {
	  if (strcasecmp(registro->ResidueName,Option)==0) { 
	       Found = TRUE ;
	       break ;
	  }
	  registro++ ;
     }
     return Found ;
}    


char IsAtomName(char Option[MAXWORD]) {
     static struct Library *registro;
     static FILE *LibFile;
     static int LibRecords;
     static char Found = FALSE ;
     
     Found = FALSE ;
     if ( (Lib == NULL) || (MaxLib <= 0) ) {
	  /* Load Library Data */
	  if (DEBUG >= 1) printf(" > IsAtomName(): Opening Library Data ..\n");
	  if ( (LibFile = libfopen("GenCons.Lib","r")) == (FILE *) NULL ) {
	       printf(" > IsAtomName(): Unable to open Library data file needed\n");
	       printf(" > IsAtomName(): AyudaPATH is _UNSET_ or is set wrong \n\n");
	       return UNKNOWN;
	  }
	  if (DEBUG >= 1) printf(" > IsAtomName(): .. Getting Library Data ..\n");
	  LibRecords=GetLibraryData(LibFile);
	  if (DEBUG >= 1) printf(" > IsAtomName(): .. Closing Library Data ..\n");
	  fclose(LibFile);
     } else
	  LibRecords = MaxLib ;
     
     if ( MaxLib <= 0 ) {
	  printf("\n > IsAtomName(): * No records in library \n\n");
	  return UNKNOWN;
     }
     
     registro = &Lib[1] ;
      while ( registro->next != NULL ) { 
	  if (strcasecmp(registro->PdbName,Option)==0) {
	       Found = TRUE ;
	       break ;
	  }
	 registro++ ;
     }
     return Found ;
}    
