/*$Id: prepare_congen.c,v 3.32 2003/10/06 12:13:32 roberto Exp roberto $*/

#include "pdbstat.h"

char  from_previous_disman ;
char  from_previous_congen ;

void prepare_congen(char filenamen[MAXWORD+1],char catena[])
{
  static int   k, h, i ;
  static FILE *filecongen, *filetemplate ;
  static char  nombrefich[MAXWORD+1], template[MAXWORD+1] ;
  static char  *TEMPLATEDIR ;
  static char  ene[4] ;
  static char  have_disu[MAXWORD] ;
  static char  ffield[MAXWORD];
  static char  have_dih[10] ;
  static char  sum_or_average[MAXWORD];
  static int   from_disu[20] , tooo_disu[20], nmbr_disu = 0 ;
  static struct models *Model ;

  from_previous_disman = FALSE ;
  from_previous_congen = FALSE ;
  
  Model = MODELS + key_model ;

  /*
   *
   * Prepare files for input in CONGEN 
   * I started to write this code just to facilitate people at CABM
   * to run CONGEN
   * The main goal is to have PDBSTAT creating the whole set of iles
   * needed to run CONGEN
   * We NEED:
   *   a sequence file to prepare the chiral and sidechain.chiral files
   *
   */
  TEMPLATEDIR = (char *)getenv("AyudaPATH") ;


  /* if (key_model == 0) key_model = 1; */

  strcpy(nombrefich,filenamen);
  strcat(nombrefich,".seq");
  if ((filecongen=fopen(nombrefich,"w")) == NULL) {
    printf("\n  -> PREP_CGEN:  ** Something went wrong opening output SEQ file ");
    return ;
  }

  write_sequence(filecongen,"congen","three");
  printf("\n");
  fclose(filecongen);
  printf("\n  -> PREP_CGEN:  --- Sequence file done!!!");

  strcpy(nombrefich,filenamen);
  strcat(nombrefich,"_chiral.inp");
  if ((filecongen=fopen(nombrefich,"w")) == NULL) {
    printf("\n  -> PREP_CGEN:  ** Something went wrong opening output file **");
    return ;
  }
  
  fprintf(filecongen,
	  "!  ==============> CHIRAL ANGLE CONSTRAINT FILE <================="\
	  "\n");
  fprintf(filecongen,
	  "! THIS SHOULD MAINTAIN RIGHT CHIRALITY IN THE CALUCLATIONS AT"\
	  " HIGH TEMPERATURES.\n");
  fprintf(filecongen," \n");
  fprintf(filecongen,
	  "! REMEMBER TO REMOVE (OR COMMENT OUT) ALL GLY RESIDUES IN THIS "\
	  "FILE\n");
  fprintf(filecongen,
	  "! CURRENTLY IT COVERS UP TO 70 RESIDUES. ADDING MORE RESIDUES "\
	  "SHOULD BE\n");
  fprintf(filecongen,
	  "! STRAIGHTFORWARD. REMEMBER ALSO TO CHANGE THE ONE LETTER "\
	  "IDENTIFICATION \n\n");
  fprintf(filecongen,
	  "!  This file has been produced by *PDBSTAT* remember to check "\
	  "it before use.\n\n");
  fprintf(filecongen,
	  "! Happy calculations, Roberto Tejero, Jul., 1995 (RTT)\n");
  fprintf(filecongen,
	  "! RTT, CABM-Rutgers University and University of Valencia\n");
  fprintf(filecongen,"!*\n");
  
  for (k = 1 ; k <= Model->number_of_residues ; k++) {
    if (k == 1) strcpy(ene,"N") ;
    else strcpy(ene,"N") ;
    if (strncasecmp(seqres[k],"GLY",3)!=0) {
      fprintf(filecongen,\
	      "CONS DIHE %s %2d CA : %s %2d %2s : %s %2d  C : %s %2d CB : "\
	      "FORCE 500.0 MIN 32.0 MAX 36.0 \n",
	      catena, 
	      k,
	      catena,
	      k,
	      ene,
	      catena,
	      k,
	      catena,
	      k) ;
    }
  }

  fprintf(filecongen,"RETURN\n");
  fclose(filecongen) ;
  printf("\n  -> PREP_CGEN:  --- Chiral constraint file done!!!");
  
  strcpy(nombrefich,filenamen);
  strcat(nombrefich,"_sidechain_chiral.inp");
  if ((filecongen=fopen(nombrefich,"w")) == NULL) {
    printf("\n  -> PREP_CGEN:  ** Something went wrong opening CHIRAL output"\
	   " file **");
    return ;
  }
  
  fprintf(filecongen,
	  "!  ==============> SIDE CHAIN CHIRAL ANGLE CONSTRAINT FILE "\
	  "<=================\n");
  fprintf(filecongen,
	  "!  THIS SHOULD MAINTAIN RIGHT SIDE CHAIN CHIRALITY IN THE CALCS"\
	  " AT HIGH TEMPERATURES.\n");
  fprintf(filecongen,
	  "!  YOU NEED TO CHECK WHAT THE RESIDUE NUMBER FOR THE ILE AND THR"\
	  " ARE IN YOUR STRUCTURE AND\n");
  fprintf(filecongen,
	  "!  ADD THEM IN THIS FILE. \n");
  fprintf(filecongen,
	  "!  This file has been produced by *PDBSTAT* remember to check "\
	  "it before use.\n\n");
  fprintf(filecongen,
	  "!  Happy calculations, Roberto Tejero, Jul., 1995 (RTT)\n");
  fprintf(filecongen,
	  "!  RTT, CABM-Rutgers University and University of Valencia\n");
  fprintf(filecongen,
	  "!*\n");

  for (k = 1 ; k <= Model->number_of_residues ; k++) {
    if (strncasecmp(seqres[k],"ILE",3)==0) {
      fprintf(filecongen,
	      "CONS DIHE %s %2d CB : %s %2d CG1 : %s %2d CG2 : %s %2d "\
	      "CA : FORCE 500.0 MIN 32.0 MAX 36.0 \n",
	      catena,
	      k,
	      catena,
	      k,
	      catena,
	      k,
		  catena,
	      k) ;
    }
    else  if (strncasecmp(seqres[k],"THR",3)==0) {
      fprintf(filecongen,
	      "CONS DIHE %s %2d CB : %s %2d OG1 : %s %2d CG2 : %s %2d "\
	      "CA : FORCE 500.0 MIN 32.0 MAX 36.0 \n",
	      catena,
	      k,
	      catena,
	      k,
	      catena,
	      k,
	      catena,
	      k) ;
    }
  }
  fprintf(filecongen,"RETURN\n");
  fclose(filecongen) ;
  printf("\n  -> PREP_CGEN:  --- Sidechain_hiral constraint file done!!!");
  
  strcpy(nombrefich,filenamen);
  strcat(nombrefich,"_omega.inp");
  if ((filecongen=fopen(nombrefich,"w")) == NULL) {
    printf("\n  -> PREP_CGEN:  ** Something wrong opening SIDE CHAIN CHIRAL"\
	   " output file **");
    return ;
  }
  
  fprintf(filecongen,
	  "!  ==============> OMEGA ANGLE CONSTRAINT FILE <================="\
	  "\n");
  fprintf(filecongen,
	  "!   THIS SHOULD MAINTAIN PLANARITY OF PEPTIDE BOND (180 degrees)\n");
  fprintf(filecongen,
	  "!   This file has been produced by PDBSTAT. Remember to check it."\
	  "\n\n");
  fprintf(filecongen,
	  "!   Happy calculations. Roberto Tejero, Jul., 1995 (RTT)\n");
  fprintf(filecongen,\
	  "!   RTT, CABM-Rutgers University and University of Valencia\n");
  fprintf(filecongen,
	  "!*\n");
  
  for (k = 1 ; k <= Model->number_of_residues-1 ; k++) {
    fprintf(filecongen,\
	    "CONS DIHE %s %2d CA : %s %2d C : %s %2d N : %s %2d CA : "\
	    "FORCE 500.0 MIN 178.0 MAX -178.0 \n",
	    catena,
	    k,
	    catena,
	    k,
	    catena,
	    k+1,
	    catena,
	    k+1) ;
  }
  fprintf(filecongen,"RETURN\n");
  fclose(filecongen) ;
  printf("\n  -> PREP_CGEN:  --- Omega constraint file done!!!");
  /*
   * dihedral constraint file
   */
  printf("\n\n > Do you have DIHEDRAL constraints file (yes/no) ?_ : ");
  GetFromKeyBoard(have_dih, MAXWORD, stdin);
  if (strncasecmp(have_dih,"yes",1)!=0) strcpy(have_dih,"no");
  if (strncasecmp(have_dih,"yes",1)==0) {
   printf("\n > Please NOTE that a file called `%s.dihe' *MUST*"\
          " be present in order to run CONGEN", filenamen);
   }
  /*
   *  Disulphides
   */
  printf("\n\n > Are there disulfides your molecule (y/n) ?_ :  ") ;
  GetFromKeyBoard(have_disu, MAXWORD, stdin);
  do_lower_case(have_disu) ;
  if (strncasecmp(have_disu,"yes",1)==0) {
    printf(" > How many disulfides ?_ :  ") ;
    GetFromKeyBoard(template, MAXWORD, stdin);
    nmbr_disu = atoi(template);
    for (i=1 ; i <= nmbr_disu ; i++) {
      printf(" > From residue# to residue# (integer space integer) ?_ :  " ) ;
      GetFromKeyBoard(template, MAXWORD, stdin) ;
      sscanf(template,"%d %d",&from_disu[i],&tooo_disu[i]) ;
    }
  }

  /*
   *  Simulated annealing
   */
  printf("\n > Do you want SA protocol from DISMAN (or prev. CONGEN) or "\
	 "EXTENDED (dis/cong/ext) ?_: ");
  GetFromKeyBoard(template, MAXWORD, stdin);
  
  strcpy(nombrefich,filenamen);
  strcat(nombrefich,"_0.inp");
  
  if (strncasecmp(template,"extend",2)==0)  {
    strcpy(template,TEMPLATEDIR) ;
    strcat(template,"/sa_fromext_0.inp") ;
  }
  if (strncasecmp(template,"disman",2)==0)  {
    from_previous_disman = TRUE ;
    strcpy(template,TEMPLATEDIR) ;
    strcat(template,"/sa_fromdis_0.inp") ;
  }
  if (strncasecmp(template,"congen",2)==0)  {
    from_previous_congen = TRUE ;
    strcpy(template,TEMPLATEDIR) ;
    strcat(template,"/sa_fromcgn_0.inp") ;
  }
  
  if ((filecongen=fopen(nombrefich,"w")) == NULL) {
    printf("\n  -> PREP_CGEN:  ** Something went wrong opening PROTOCOL "\
	   "output file **");
    return ;
    }
  if ((filetemplate=fopen(template,"r")) == NULL) {
    printf("\n  -> PREP_CGEN:  ** Something went wrong opening TEMPLATE SA "\
	   "input file %s **",template);
    return ;
  }
  
  printf("\n > Do you want SUM or AVERAGE for the constraints (sum/ave) ?_: ");
  GetFromKeyBoard(sum_or_average, MAXWORD, stdin);
  if (strncasecmp(sum_or_average,"sum",1)==0)  {
    strcpy(sum_or_average,"SUM");
  }
  else if (strncasecmp(sum_or_average,"ave",1)==0)  {
    strcpy(sum_or_average,"AVERAGE");
  }
  else {
    strcpy(sum_or_average,"SUM");
  }

  printf("\n > Which force field (amber/charmm) should I use [amber] ?_: ");
  GetFromKeyBoard(ffield, MAXWORD, stdin);
  if (strcasecmp(ffield,"")==0) 
    strcpy(ffield,"amber");
  else if ((strncasecmp(ffield,"amber",2)!=0) &&
           (strncasecmp(ffield,"charm",2)!=0)) {
           strcpy(ffield,"amber");
  }
  
  while  (GetLine(line,MAXLINE,filetemplate) > 0)  {
    i = 0 ;
    while (i <= (int) strlen(line)) {
      if (strncasecmp(have_dih,"yes",2)==0) {
       if ((line[1]     == '#') &&
           (line[i+1]   == 'D') &&
           (line[i+2]   == 'I') &&
           (line[i+3]   == 'H')) {
         fprintf(filecongen,"\n");
         fprintf(filecongen,"OPEN UNIT 12 NAME TOPOL:%s.dihe FORM READ\n", filenamen);
         fprintf(filecongen,"STREAM UNIT 12 \nCLOSE UNIT 12\n");
       }
      }
      if ((line[i]     == '#') &&
          (line[i+1]   == 'F') &&
          (line[i+2]   == 'F') &&
          (line[i+3]   == 'I') &&
          (line[i+4]   == 'E') &&
          (line[i+5]   == 'L') &&
          (line[i+6]   == 'D') &&
          (line[i+7]   == '_') &&
          (line[i+8]   == 'T') &&
          (line[i+9]   == 'O') &&
          (line[i+10]  == 'P')) {
	if (strncasecmp(ffield,"amber",2)==0) {
	  fprintf(filecongen,"\n");
	  fprintf(filecongen,"OPEN UNIT 01 NAME CGDATA:AMBER94RTF.MOD READ UNFORM \n");
	} else if (strncasecmp(ffield,"charmm",2)==0) {
	  fprintf(filecongen,"\n");
	  fprintf(filecongen,"OPEN UNIT 01 NAME CGDATA:RTOPALLH8.MOD READ UNFORM \n");
	}
	fprintf(filecongen,"READ RTF FILE UNIT 01 \n");
	fprintf(filecongen,"CLOSE UNIT 01 \n");
      }
      if ((line[i]     == '#') &&
          (line[i+1]   == 'F') &&
          (line[i+2]   == 'F') &&
          (line[i+3]   == 'I') &&
          (line[i+4]   == 'E') &&
          (line[i+5]   == 'L') &&
          (line[i+6]   == 'D') &&
          (line[i+7]   == '_') &&
          (line[i+8]   == 'P') &&
          (line[i+9]   == 'R') &&
          (line[i+10]  == 'M')) {
	if (strncasecmp(ffield,"amber",2)==0) {
	  fprintf(filecongen,"\n");
	  fprintf(filecongen,"OPEN UNIT 02 NAME CGDATA:AMBER94PARM.MOD READ UNFORM \n");
	} else if (strncasecmp(ffield,"charmm",2)==0) {
	  fprintf(filecongen,"\n");
	  fprintf(filecongen,"OPEN UNIT 02 NAME CGDATA:REFINE_PAR.MOD READ UNFORM \n");
	}
	fprintf(filecongen,"READ PARA FILE UNIT 02 \n");
	fprintf(filecongen,"CLOSE UNIT 02 \n");
      }
      if ((line[i]     == '#') &&
          (line[i+1]   == 'F') &&
          (line[i+2]   == 'F') &&
          (line[i+3]   == 'I') &&
          (line[i+4]   == 'E') &&
          (line[i+5]   == 'L') &&
          (line[i+6]   == 'D') &&
          (line[i+7]   == '_') &&
          (line[i+8]   == 'S') &&
          (line[i+9]   == 'P') &&
          (line[i+10]  == 'C')) {
	if (strncasecmp(ffield,"amber",2)==0) {
	  fprintf(filecongen,"\n");
	  fprintf(filecongen,"OPEN UNIT 02 NAME CGDATA:SPECIAL_AMBER94.MOD READ UNFORM \n");
	} else if (strncasecmp(ffield,"charmm",2)==0) {
	  fprintf(filecongen,"\n");
	  fprintf(filecongen,"OPEN UNIT 02 NAME CGDATA:SPECIAL.MOD READ UNFORM \n");
	}
	fprintf(filecongen,"READ PARA FILE UNIT 02 \n");
	fprintf(filecongen,"CLOSE UNIT 02 \n");
      }
      if ((line[i]     == '#') &&
          (line[i+1]   == 'F') &&
          (line[i+2]   == 'F') &&
          (line[i+3]   == 'I') &&
          (line[i+4]   == 'E') &&
          (line[i+5]   == 'L') &&
          (line[i+6]   == 'D') &&
          (line[i+7]   == '_') &&
          (line[i+8]   == 'S') &&
          (line[i+9]   == 'E') &&
          (line[i+10]  == 'Q')) {
          if (strncasecmp(ffield,"amber",2)==0) {
            fprintf(filecongen,"\n");
            fprintf(filecongen,"READ SEQU CARD UNIT 03 A94P \n");
          } else if (strncasecmp(ffield,"charmm",2)==0) {
            fprintf(filecongen,"\n");
            fprintf(filecongen,"READ SEQU CARD UNIT 03 ALLH \n");
          }
      }
      if ((line[i]     == '#') &&
          (line[i+1]   == 'F') &&
          (line[i+2]   == 'F') &&
          (line[i+3]   == 'I') &&
          (line[i+4]   == 'E') &&
          (line[i+5]   == 'L') &&
          (line[i+6]   == 'D') &&
          (line[i+7]   == '_') &&
          (line[i+8]   == 'I') &&
          (line[i+9]   == 'C')) {
          if (strncasecmp(ffield,"amber",2)==0) {
            fprintf(filecongen,"\n");
            fprintf(filecongen,"IC SEED 1 N 1 CA 1 C \n");
          } else if (strncasecmp(ffield,"charmm",2)==0) {
            fprintf(filecongen,"\n");
            fprintf(filecongen,"IC SEED 2 NT 2 CA 2 C \n");
          }
      }
      if ((line[i]     == '#') &&
          (line[i+1]   == 'F') &&
          (line[i+2]   == 'F') &&
          (line[i+3]   == 'I') &&
          (line[i+4]   == 'E') &&
          (line[i+5]   == 'L') &&
          (line[i+6]   == 'D') &&
          (line[i+7]   == '_') &&
          (line[i+8]   == 'G') &&
          (line[i+9]   == 'E') &&
          (line[i+10]  == 'N')) {
          if (strncasecmp(ffield,"amber",2)==0) {
            strcpy(line,"GENERATE MOLE_ID ANGLES TORSIONS ALL DONORS ACCEPTORS");
            strcat(line,"\0");
          } else if (strncasecmp(ffield,"charmm",2)==0) {
            strcpy(line,"GENERATE MOLE_ID");
	    strcat(line,"\0");
          }
      }

      if ((line[i]    == '#') &&
	  (line[i+1]  == 'D') &&
	  (line[i+2]  == 'I') &&
	  (line[i+3]  == 'S') &&
	  (line[i+4]  == 'U')) {
	if (strncasecmp(have_disu,"yes",1)==0) {
	  line[0]='\0' ;
	  fprintf(filecongen,"DISULPHIDE\n") ;
	  fprintf(filecongen,"%5d\n",nmbr_disu) ;
	  for (h=1 ; h<= nmbr_disu; h++)
	    fprintf(filecongen,"%5d%5d\n",from_disu[h],tooo_disu[h]) ;
	  
	  fprintf(filecongen,"\n");
	  fprintf(filecongen,"DYNA - \n");
	  fprintf(filecongen,"   VERL STRT NSTEP  4000 TIMESTP 0.001 TLIMIT "\
		  "5000.0 -\n");
	  fprintf(filecongen,"        FIRSTT 1000.0 FINALT 1000.0 TSTRUC "\
		  "1000.0 -\n");
	  fprintf(filecongen,"        ATOM EPS 1.0 CUTNB 10.0 WRNMXD 3.0 -\n");
	  fprintf(filecongen,"        IHBFRQ 50 INBFRQ 50 -\n");
	  fprintf(filecongen,"        IUNWRI 16 IASORS 1  IASVEL 1 - \n");
	  fprintf(filecongen,"        IEQFRQ 100 TWINDL -50.0 TWINDH 50.0 -\n");
	  fprintf(filecongen,"	NPRINT 500 IPRFRQ 500 NTRFRQ 100\n");
	  fprintf(filecongen,"REWIND UNIT 16\n");
	}
      }
      
      if ((line[i]    == 'M') &&
	  (line[i+1]  == 'O') &&
	  (line[i+2]  == 'L') &&
	  (line[i+3]  == 'E') &&
	  (line[i+4]  == 'C') &&
	  (line[i+5]  == 'U') &&
	  (line[i+6]  == 'L') &&
	  (line[i+7]  == 'A') &&
	  (line[i+8]  == 'U') &&
	  (line[i+9]  == 'S') &&
	  (line[i+10] == 'U') &&
	  (line[i+11] == 'A') &&
	  (line[i+12] == 'R') &&
	  (line[i+13] == 'I') &&
	  (line[i+14] == 'O')) {
	for ( h = 0 ; h <= (int) strlen(filenamen)-1 ; h++)
	  line[i+h] = filenamen[h] ;
	for ( h = i+(int) strlen(filenamen) ; h <= (int) strlen(line) ; h++)
	  line[h] = line[h+15-(int) strlen(filenamen)] ;
      }
      if ((line[i]    == 'M') &&
	  (line[i+1]  == 'O') &&
	  (line[i+2]  == 'L') &&
	  (line[i+3]  == 'E') &&
	  (line[i+4]  == '_') &&
	  (line[i+5]  == 'I') &&
	  (line[i+6]  == 'D')) {
	for ( h = 0 ; h <= (int) strlen(catena)-1 ; h++)
	  line[i+h] = catena[h] ;
	for ( h = i+(int) strlen(catena) ; h <= (int) strlen(line) ; h++)
	  line[h] =  line[h+7-(int) strlen(catena)] ;
      }
      if ((line[i]    == 'S') &&
	  (line[i+1]  == 'U') &&
	  (line[i+2]  == 'M') &&
	  (line[i+3]  == '-') &&
	  (line[i+4]  == 'A') &&
	  (line[i+5]  == 'V') &&
	  (line[i+6]  == 'E')) {
	for ( h = 0 ; h <= (int) strlen(sum_or_average)-1 ; h++)
	  line[i+h] = sum_or_average[h] ;
	for (h = i+(int) strlen(sum_or_average) ; h <= (int) strlen(line) ; h++)
	  line[h] =  line[h+7-(int) strlen(sum_or_average)] ;
      }
      i++ ;
    }
    /*
     * Avoid to print directive # records
     */
    if (line[0] != '#')
      fprintf(filecongen,"%s",line) ;
  }
  fclose(filecongen) ;
  fclose(filetemplate) ;
  printf("\n  -> PREP_CGEN:  --- Input for CONGEN done !!!");
  
  /*
   *  Run auto cgen shell script
   */
  
  strcpy(template,TEMPLATEDIR);
  
  if (from_previous_congen == TRUE) {
    strcat(template,"/run_fromcgn_cgen.csh");
    strcpy(nombrefich,"run_auto_fromcgen_");
  }
  else   if (from_previous_disman == TRUE) {
    strcat(template,"/run_fromdisman_cgen.csh");
    strcpy(nombrefich,"run_auto_fromdism_");
  }
  else {
    strcat(template,"/run_auto_cgen.csh");
    strcpy(nombrefich,"run_auto_");
  }

  strcat(nombrefich,filenamen);
  strcat(nombrefich,".csh");
  
  if ((filecongen=fopen(nombrefich,"w")) == NULL) {
    printf("\n  -> PREP_CGEN:  ** Something went wrong opening DRIVER "\
	   "output file **");
    return ;
  }
  if ((filetemplate=fopen(template,"r")) == NULL) {
    printf("\n  -> PREP_CGEN:  ** Something went wrong opening SHELL DRIVER"\
	   " input file file ****");
    return ;
  }
  k=0;
  while  (GetLine(line,MAXLINE,filetemplate) > 0)  {
    i = 0 ;
    while (i <= (int) strlen(line)) {
      if ((line[i]    == 'M') &&
	  (line[i+1]  == 'O') &&
	  (line[i+2]  == 'L') &&
	  (line[i+3]  == 'E') &&
	  (line[i+4]  == 'C') &&
	  (line[i+5]  == 'U') &&
	  (line[i+6]  == 'L') &&
	  (line[i+7]  == 'A') &&
	  (line[i+8]  == 'U') &&
	  (line[i+9]  == 'S') &&
	  (line[i+10] == 'U') &&
	  (line[i+11] == 'A') &&
	  (line[i+12] == 'R') &&
	  (line[i+13] == 'I') &&
	  (line[i+14] == 'O')) {
	if ((line[i-11] == 'd') &&
	    (line[i-10] == 'i') &&
	    (line[i-9]  == 'r') &&
	    (line[i-8]  == 'e') &&
	    (line[i-7]  == '=') &&
	    (line[i-6]  == '`') &&
	    (line[i-5]  == 'p') &&
	    (line[i-4]  == 'w') &&
	    (line[i-3]  == 'd') &&
	    (line[i-2]  == '`') &&
	    (line[i-1]  == '/'))
	  for ( h = 0 ; h <= (int) strlen(filenamen)-1 ; h++)
	    line[i+h] = toupper(filenamen[h]) ;
	else
	  for ( h = 0 ; h <= (int) strlen(filenamen)-1 ; h++)
	    line[i+h] = tolower(filenamen[h]) ;
	
	for ( h = i+(int) strlen(filenamen) ; h <= (int) strlen(line) ; h++)
	  line[h] = line[h+15-(int) strlen(filenamen)] ;
	k++ ;
      }
      if ((from_previous_congen == TRUE) || (from_previous_disman == TRUE))
	if ((line[i]    == 'M') &&
	    (line[i+1]  == 'O') &&
	    (line[i+2]  == 'L') &&
	    (line[i+3]  == 'E') &&
	    (line[i+4]  == '_') &&
	    (line[i+5]  == 'I') &&
	    (line[i+6]  == 'D')) {
	  for ( h = 0 ; h <= (int) strlen(catena)-1 ; h++)
	    line[i+h] = catena[h] ;
	  for ( h = i+(int) strlen(catena) ; h <= (int) strlen(line) ; h++)
	    line[h] =  line[h+7-(int) strlen(catena)] ;
	}
      i++ ;
    }
    fprintf(filecongen,"%s",line) ;
  }
  fclose(filecongen) ;
  fclose(filetemplate) ;
  printf("\n  -> PREP_CGEN:  --- Shell to run auto CONGEN done !!! \n");

  /*
   * 
   * Finally the NOE files (the whole series just to run CONGEN)
   * As I am telling before all this stuff was done between Jul, 15 and Jul, 16
   * while I was visiting CABM again, so check it carefully before use, please
   * I am *NOT* responsible if you lost the love of your partner for using
   * this software without care.
   * 
   */
  printf("\n > Name for the file with CONSTRAINTS CONGEN formatted ?_: ");
  GetFromKeyBoard(template, MAXWORD, stdin);
  if ((filetemplate=fopen(template,"r")) == NULL) {
    printf("\n  -> PREP_CGEN:  ** Something wrong opening NOE input file file **");
    return ;
  }

  strcpy(nombrefich,filenamen) ;
  strcat(nombrefich,".w1.noe") ;
  if ((filecongen=fopen(nombrefich,"w")) == NULL) {
    printf("\n  -> PREP_CGEN:  ** Something went wrong opening NOE input "\
	   "file **");
    return ;
  }
  while (GetLine(line,MAXLINE,filetemplate) > 0)  {
    i = 0 ;
    while (i <= (int) strlen(line)) {
      if ((line[i]    == 'W') &&
	  (line[i+1]  == 'E') &&
	  (line[i+2]  == 'I') &&      
	  (line[i+3]  == 'G') &&      
	  (line[i+4]  == 'H') &&      
	  (line[i+5]  == 'T')) {
	line[i+7]='1' ;
	line[i+8]='.' ;
	line[i+9]='0' ; 
	line[i+10]='\n' ; 
	line[i+11]='\0' ;
      }
      /*
       * look for old naming convention in CONGEN.
       * if we are using AMBER atom type HT* doesn't exist so we
       * should change it to the new convention H1
       */
      if (strncasecmp(ffield,"amber",2)==0) {
        if ((line[i]   == 'H') &&
       	    (line[i+1] == 'T') &&
       	    (line[i+2] == '*')) {
       	   line[i]   = 'H' ;
       	   line[i+1] = '+' ;
           line[i+2] = ' ' ;
         }
       }
      i++ ;
    }
    fprintf(filecongen,"%s",line);
  }
  rewind(filetemplate);
  fclose(filecongen);
  printf("\n  -> PREP_CGEN:  ... done weight   1.0 ");

  /*
   *  Files to run checks ,
   *  run_cheknoes_MOLECULAUSUARIO 
   *  chk_0.inp
   */
  strcpy(template,TEMPLATEDIR);
  strcat(template,"/run_checknoes.csh");
  strcpy(nombrefich,"run_checknoes_");
  strcat(nombrefich,filenamen);
  strcat(nombrefich,".csh");
  if ((filecongen=fopen(nombrefich,"w")) == NULL) {
    printf("\n  -> PREP_CGEN:  ** Something went wrong opening DRIVER output "\
	   "file **");
    return ;
  }
  if ((filetemplate=fopen(template,"r")) == NULL) {
    printf("\n  -> PREP_CGEN:  ** Something went wrong opening SHELL DRIVER"\
	   " input file **");
    return ;
  }
  k=0;
  while  (GetLine(line,MAXLINE,filetemplate) > 0)  {
    i = 0 ;
    while (i <= (int) strlen(line)) {
      if ((line[i]    == 'M') &&
	  (line[i+1]  == 'O') &&
	  (line[i+2]  == 'L') &&
	  (line[i+3]  == 'E') &&
	  (line[i+4]  == 'C') &&
	  (line[i+5]  == 'U') &&
	  (line[i+6]  == 'L') &&
	  (line[i+7]  == 'A') &&
	  (line[i+8]  == 'U') &&
	  (line[i+9]  == 'S') &&
	  (line[i+10] == 'U') &&
	  (line[i+11] == 'A') &&
	  (line[i+12] == 'R') &&
	  (line[i+13] == 'I') &&
	  (line[i+14] == 'O')) {
	for ( h = 0 ; h <= (int) strlen(filenamen)-1 ; h++)
	  line[i+h] = filenamen[h] ;
	for ( h = i+(int) strlen(filenamen) ; h <= (int) strlen(line) ; h++)
	  line[h] = line[h+15-(int) strlen(filenamen)] ;
      }
      if ((line[i]    == 'M') &&
	  (line[i+1]  == 'O') &&
	  (line[i+2]  == 'L') &&
	  (line[i+3]  == 'E') &&
	  (line[i+4]  == '_') &&
	  (line[i+5]  == 'I') &&
	  (line[i+6]  == 'D'))
	{
	  for ( h = 0 ; h <= (int) strlen(catena)-1 ; h++)
	    line[i+h] = catena[h] ;
	  for ( h = i+(int) strlen(catena) ; h <= (int) strlen(line) ; h++)
	    line[h] =  line[h+7-(int) strlen(catena)] ;
	}
      i++ ;
    }
    fprintf(filecongen,"%s",line) ;
  }
  fclose(filecongen) ;
  fclose(filetemplate) ;
  printf("\n  -> PREP_CGEN:  ... done run_chknoes.csh. ");
  
  strcpy(template,TEMPLATEDIR);
  strcat(template,"/chk_0.inp");
  strcpy(nombrefich,"chk_");
  strcat(nombrefich,filenamen);
  strcat(nombrefich,"_0.inp");
  if ((filecongen=fopen(nombrefich,"w")) == NULL) {
    printf("\n  -> PREP_CGEN:  ** Something went wrong opening chk_0.inp "\
	   "file **");
    return ;
  }
  if ((filetemplate=fopen(template,"r")) == NULL) {
    printf("\n  -> PREP_CGEN:  ** Something went wrong opening template chk "\
	   "input file **");
    return ;
  }
  k=0;
  while  (GetLine(line,MAXLINE,filetemplate) > 0)  {
    i = 0 ;
    while (i <= (int) strlen(line)) {
      if (strncasecmp(have_dih,"yes",2)==0) {
       if ((line[1]     == '#') &&
           (line[i+1]   == 'D') &&
           (line[i+2]   == 'I') &&
           (line[i+3]   == 'H')) {
         fprintf(filecongen,"\n");
         fprintf(filecongen,"OPEN UNIT 12 NAME TOPOL:%s.dihe FORM READ\n", filenamen);
         fprintf(filecongen,"STREAM UNIT 12 \nCLOSE UNIT 12\n");
       }
      }
      if ((line[i]     == '#') &&
          (line[i+1]   == 'F') &&
          (line[i+2]   == 'F') &&
          (line[i+3]   == 'I') &&
          (line[i+4]   == 'E') &&
          (line[i+5]   == 'L') &&
          (line[i+6]   == 'D') &&
          (line[i+7]   == '_') &&
          (line[i+8]   == 'T') &&
          (line[i+9]   == 'O') &&
          (line[i+10]  == 'P')) {
	if (strncasecmp(ffield,"amber",2)==0) {
	  fprintf(filecongen,"\n");
	  fprintf(filecongen,"OPEN UNIT 01 NAME CGDATA:AMBER94RTF.MOD READ UNFORM \n");
	} else if (strncasecmp(ffield,"charmm",2)==0) {
	  fprintf(filecongen,"\n");
	  fprintf(filecongen,"OPEN UNIT 01 NAME CGDATA:RTOPALLH8.MOD READ UNFORM \n");
	}
	fprintf(filecongen,"READ RTF FILE UNIT 01 \n");
	fprintf(filecongen,"CLOSE UNIT 01 \n");
      }
      if ((line[i]     == '#') &&
          (line[i+1]   == 'F') &&
          (line[i+2]   == 'F') &&
          (line[i+3]   == 'I') &&
          (line[i+4]   == 'E') &&
          (line[i+5]   == 'L') &&
          (line[i+6]   == 'D') &&
          (line[i+7]   == '_') &&
          (line[i+8]   == 'P') &&
          (line[i+9]   == 'R') &&
          (line[i+10]  == 'M')) {
	if (strncasecmp(ffield,"amber",2)==0) {
	  fprintf(filecongen,"\n");
	  fprintf(filecongen,"OPEN UNIT 02 NAME CGDATA:AMBER94PARM.MOD READ UNFORM \n");
	} else if (strncasecmp(ffield,"charmm",2)==0) {
	  fprintf(filecongen,"\n");
	  fprintf(filecongen,"OPEN UNIT 02 NAME CGDATA:REFINE_PAR.MOD READ UNFORM \n");
	}
	fprintf(filecongen,"READ PARA FILE UNIT 02 \n");
	fprintf(filecongen,"CLOSE UNIT 02 \n");
      }
      if ((line[i]     == '#') &&
          (line[i+1]   == 'F') &&
          (line[i+2]   == 'F') &&
          (line[i+3]   == 'I') &&
          (line[i+4]   == 'E') &&
          (line[i+5]   == 'L') &&
          (line[i+6]   == 'D') &&
          (line[i+7]   == '_') &&
          (line[i+8]   == 'S') &&
          (line[i+9]   == 'P') &&
          (line[i+10]  == 'C')) {
	if (strncasecmp(ffield,"amber",2)==0) {
	  fprintf(filecongen,"\n");
	  fprintf(filecongen,"OPEN UNIT 02 NAME CGDATA:SPECIAL_AMBER94.MOD READ UNFORM \n");
	} else if (strncasecmp(ffield,"charmm",2)==0) {
	  fprintf(filecongen,"\n");
	  fprintf(filecongen,"OPEN UNIT 02 NAME CGDATA:SPECIAL.MOD READ UNFORM \n");
	}
	fprintf(filecongen,"READ PARA FILE UNIT 02 \n");
	fprintf(filecongen,"CLOSE UNIT 02 \n");
      }
      if ((line[i]     == '#') &&
          (line[i+1]   == 'F') &&
          (line[i+2]   == 'F') &&
          (line[i+3]   == 'I') &&
          (line[i+4]   == 'E') &&
          (line[i+5]   == 'L') &&
          (line[i+6]   == 'D') &&
          (line[i+7]   == '_') &&
          (line[i+8]   == 'S') &&
          (line[i+9]   == 'E') &&
          (line[i+10]  == 'Q')) {
          if (strncasecmp(ffield,"amber",2)==0) {
            fprintf(filecongen,"\n");
            fprintf(filecongen,"READ SEQU CARD UNIT 03 A94P \n");
          } else if (strncasecmp(ffield,"charmm",2)==0) {
            fprintf(filecongen,"\n");
            fprintf(filecongen,"READ SEQU CARD UNIT 03 ALLH \n");
          }
      }
      if ((line[i]     == '#') &&
          (line[i+1]   == 'F') &&
          (line[i+2]   == 'F') &&
          (line[i+3]   == 'I') &&
          (line[i+4]   == 'E') &&
          (line[i+5]   == 'L') &&
          (line[i+6]   == 'D') &&
          (line[i+7]   == '_') &&
          (line[i+8]   == 'I') &&
          (line[i+9]   == 'C')) {
          if (strncasecmp(ffield,"amber",2)==0) {
            fprintf(filecongen,"\n");
            fprintf(filecongen,"IC SEED 1 N 1 CA 1 C \n");
          } else if (strncasecmp(ffield,"charmm",2)==0) {
            fprintf(filecongen,"\n");
            fprintf(filecongen,"IC SEED 2 NT 2 CA 2 C \n");
          }
      }
      if ((line[i]     == '#') &&
          (line[i+1]   == 'F') &&
          (line[i+2]   == 'F') &&
          (line[i+3]   == 'I') &&
          (line[i+4]   == 'E') &&
          (line[i+5]   == 'L') &&
          (line[i+6]   == 'D') &&
          (line[i+7]   == '_') &&
          (line[i+8]   == 'G') &&
          (line[i+9]   == 'E') &&
          (line[i+10]  == 'N')) {
          if (strncasecmp(ffield,"amber",2)==0) {
            strcpy(line,"GENERATE MOLE_ID ANGLES TORSIONS ALL DONORS ACCEPTORS");
            strcat(line,"\0");
          } else if (strncasecmp(ffield,"charmm",2)==0) {
            strcpy(line,"GENERATE MOLE_ID");
	    strcat(line,"\0");
          }
      }
      if ((line[i]    == '#') &&
	  (line[i+1]  == 'D') &&
	  (line[i+2]  == 'I') &&
	  (line[i+3]  == 'S') &&
	  (line[i+8]  == 'U')) {
	if (strncasecmp(have_disu,"yes",1)==0) {
	  line[0]='\0' ;
	  fprintf(filecongen,"DISULPHIDE\n") ;
	  fprintf(filecongen,"%5d\n",nmbr_disu) ;
	  for (h=1 ; h<= nmbr_disu; h++)
	    fprintf(filecongen,"%5d%5d\n",from_disu[h],tooo_disu[h]) ;
	  fprintf(filecongen,"\n");
	}
      }
      
      if ((line[i]     == '#') &&
          (line[i+1]   == 'F') &&
          (line[i+2]   == 'F') &&
          (line[i+3]   == 'I') &&
          (line[i+4]   == 'E') &&
          (line[i+5]   == 'L') &&
          (line[i+6]   == 'D') &&
          (line[i+7]   == '_') &&
          (line[i+8]   == 'T') &&
          (line[i+9]   == 'B') &&
          (line[i+10]  == 'L')) {
          if (strncasecmp(ffield,"amber",2)==0) {
            strcpy(line,"       PRINT TABLE PRETTY SYSTEM AMBER FORCE FIELD $ \n ");
            strcat(line,"\0");
          } else if (strncasecmp(ffield,"charmm",2)==0) {
            strcpy(line,"       PRINT TABLE PRETTY SYSTEM CHARMM FORCE FIELD $ \n ");
	    strcat(line,"\0");
          }
      }

      if ((line[i]    == 'M') &&
	  (line[i+1]  == 'O') &&
	  (line[i+2]  == 'L') &&
	  (line[i+3]  == 'E') &&
	  (line[i+4]  == 'C') &&
	  (line[i+5]  == 'U') &&
	  (line[i+6]  == 'L') &&
	  (line[i+7]  == 'A') &&
	  (line[i+8]  == 'U') &&
	  (line[i+9]  == 'S') &&
	  (line[i+10] == 'U') &&
	  (line[i+11] == 'A') &&
	  (line[i+12] == 'R') &&
	  (line[i+13] == 'I') &&
	  (line[i+14] == 'O')) {
	if (k==0)
	  for ( h = 0 ; h <= (int) strlen(filenamen)-1 ; h++)
	    line[i+h] = toupper(filenamen[h]) ;
	else
	  for ( h = 0 ; h <= (int) strlen(filenamen)-1 ; h++)
	    line[i+h] = tolower(filenamen[h]) ;
	for ( h = i+(int) strlen(filenamen) ; h <= (int) strlen(line) ; h++)
	  line[h] = line[h+15-(int) strlen(filenamen)] ;
	k++ ;
      }
      if ((line[i]    == 'M') &&
	  (line[i+1]  == 'O') &&
	  (line[i+2]  == 'L') &&
	  (line[i+3]  == 'E') &&
	  (line[i+4]  == '_') &&
	  (line[i+5]  == 'I') &&
	  (line[i+6]  == 'D')) {
	for ( h = 0 ; h <= (int) strlen(catena)-1 ; h++)
	  line[i+h] = catena[h] ;
	for ( h = i+(int) strlen(catena) ; h <= (int) strlen(line) ; h++)
	  line[h] =  line[h+7-(int) strlen(catena)] ;
      }
      i++ ;
    }
    if (line[0] != '#')
      fprintf(filecongen,"%s",line) ;
  }
  fclose(filecongen) ;
  fclose(filetemplate) ;
  printf("\n  -> PREP_CGEN:  ... chk_0.inp done ");
  printf("\n");
  
  printf("\n  -> PREP_CGEN: --- All done preparing set of files for CONGEN. ") ;
  printf("\n  -> PREP_CGEN: --- You *MUST* check before use, You have been "\
	 "*WARNED* ");
  printf("\n  -> PREP_CGEN: --- In any case will be responsible for any loss"\
	 " caused by using ");
  printf("\n  -> PREP_CGEN: --- this software, even if you lost the love of "\
	 "your partner ");
  printf("\n");

  printf("\n  -> PREP_CGEN:     >>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<"\
	 "<<<<<<<<<<");
  printf("\n  -> PREP_CGEN:     >>>  Remember, you *MUST* check the files    "\
	 "       <<<");
  printf("\n  -> PREP_CGEN:     >>>  Mainly the sequence file as I have no "\
	 "created  <<<");
  printf("\n  -> PREP_CGEN:     >>>  the needed INFO for disulfides          "\
	 "       <<<");
  printf("\n  -> PREP_CGEN:     >>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<"\
	 "<<<<<<<<<<\n");

  printf("\n  -> PREP_CGEN: --- Now you can *QUIT*  PDBSTAT.") ;
  printf("\n  -> PREP_CGEN: --- Have fun running CONGEN ");
  printf("\n");
  
  return ;
}

