/*$Id: read_constraints_disdya.c,v 1.7 2003/10/06 12:13:32 roberto Exp roberto $*/

#include "pdbstat.h"
extern int DihToNames(char Residue[5], char Dih[5]) ;
extern void InitNoeRecord(struct noe *Noe) ;
struct DiheLib *DihLib ;
extern void iatNoe(struct noe *N) ;

/* ========================================================================= */
int  read_jcoup_diana(FILE *rtti)
{
     static short  lineno, iii ;
     static short len, Jcoup ;
     struct jcoup *J ;
     
     Jcoup = 1;
     lineno = 1;
     
     fprintf(stdout,"> CNSTR_rdr: Reading JCOUP file in DYANA format ...");
     
     while ((len=GetLine(line,MAXLINE,rtti)) > 0) 
	  if ((len > 1) && (Jcoup < 5000)) {
	       lineno++;
	       for ( iii=0; iii<=10; iii++)
		    if (line[iii] == '#') goto CommentLine ;
	       JCOUP = (struct jcoup *)realloc(JCOUP,sizeof(struct jcoup)*(Jcoup+1)) ;
	       J = JCOUP + Jcoup ;
	       sscanf(line,"%d %s %s %s  %f %f",
		      &J->residue_number1, J->residue_type1, J->atom_type1, J->atom_type2, 
		      &J->jc, &J->error);
	       /* Assign J name based on atom names */
	       if (strcmp(J->atom_type1,"HN")==0) {
		    if (strcmp(J->atom_type2,"HA")==0) { /* jhn-ha */
			 strcpy(J->nickname,"jhn-ha ");	  
			 strcpy(J->name,"j1");	  
			 strcpy(J->flag,"y");
		    }
	       } else if (strcmp(J->atom_type1,"N")==0) {
		    if (strcmp(J->atom_type2,"HB2")==0) {    /* jn-hb*  */
			 strcpy(J->nickname,"jn-hb2 ");	  
			 strcpy(J->name,"j4");	  
			 strcpy(J->flag,"y");
		    }
		    if (strcmp(J->atom_type2,"HB3")==0) { 
			 strcpy(J->nickname,"jn-hb3 ");	  
			 strcpy(J->name,"j5");	  
			 strcpy(J->flag,"y");
		    }
		    if (strcmp(J->atom_type2,"HA")==0) {  /* jha-n */
			 strcpy(J->nickname,"jha-n ");	  
			 strcpy(J->name,"j6");	  
			 strcpy(J->flag,"y");
		    }
	       } else if (strcmp(J->atom_type1,"HA")==0) { 
		    if (strcmp(J->atom_type2,"HB2")==0) {      /* jha-hb*  */
			 strcpy(J->nickname,"jha-hb2");
			 strcpy(J->name,"j2");	  
			 strcpy(J->flag,"y");
		    }
		    if (strcmp(J->atom_type2,"HB3")==0) {
			 strcpy(J->nickname,"jha-hb3");
			 strcpy(J->name,"j3");	  
			 strcpy(J->flag,"y");
		    }
		    if (strcmp(J->atom_type2,"HN")==0) {   /* jhn-ha */
			 strcpy(J->nickname,"jhn-ha ");
			 strcpy(J->name,"j1");	  
			 strcpy(J->flag,"y");
		    }
		    if (strcmp(J->atom_type2,"N")==0) {    /* jha-n */
			 strcpy(J->nickname,"jha-n  ");
			 strcpy(J->name,"j6");	  
			 strcpy(J->flag,"y");
		    }
	       } else if (strcmp(J->atom_type1,"HB2")==0) {
		    if (strcmp(J->atom_type2,"C'")==0)  {
			 strcpy(J->nickname,"jhb2-c ");
			 strcpy(J->name,"j9");	  
			 strcpy(J->flag,"y");
		    }
	       } else if (strcmp(J->atom_type1,"HB3")==0) {
		    if (strcmp(J->atom_type2,"C'")==0)  {
			 strcpy(J->nickname,"jhb3-c ");
			 strcpy(J->name,"j10");	  
			 strcpy(J->flag,"y");
		    }
	       }
	       Jcoup++ ;
	  CommentLine:
	       ;
	  }
     return Jcoup-- ;
}

/* ========================================================================= */
int  read_upl_disman(FILE *rtti, char disdia[10], char LowUpp[10])
/*
  --- New version, re-written, on Feb 2003, CABM, Rutgers Univ, Roberto Tejero.
  ---
  --- (Roberto Tejero, RTT, May 1993, CABM-Rutgers University).
  ---
*/
{
     static char    FullLine = FALSE, HalfLine = FALSE ;
     static char    TmpLine[MAXLINE], temprestype[5] ;
     static int     i, len, check, lineno, tempresno, countnoe ;
     static struct  noe *Noe ;
     
     lineno = 0;
     
     if ( constraintcount == 0 )
	  countnoe = 1 ;
     else
	  countnoe = constraintcount+1 ;
     
     for (i = 0; i < MAXLINE; i++) 
	     line[i] = ' ';

     line[MAXLINE] = '\0' ;
     
     while ((len = GetLine(TmpLine,MAXLINE,rtti)) > 0) 
	  if ((len > 1) && (countnoe < MAXNOES)) {
	       lineno++;
	      
	       /* Clean line each time */
	       /*
	       for (i = 0; i < MAXLINE; i++ )
		       line[i]=' ' ;
	       */
	       /* Skip comment lines */
	       for (i = 0; i <= 5; i++)
		    if (TmpLine[i] == '#') 
			 goto out_loop ;
	       
	       if (TmpLine[0] == '*')         /* for PDB deposited files style formats */
		    goto out_loop ;
	       
	       /* Strip new line and trailing spaces */
	       for (i = MAXLINE-1 ; i > 0; i--)
		    if ( TmpLine[i] == ' ' || TmpLine[i] == '\n' ) {
			 TmpLine[i] = '\0' ;
		    } else {
			 break;
		    }

	       /* pad spaces until beginning of second field */
	       for (i = 0; i < 30; i++)
		       if ( TmpLine[i] == '\0' )
			       TmpLine[i] = ' ' ;
	       
	       /* Strip heading spaces */
	       for (check = 0; check < MAXLINE; check++)
		    if ( TmpLine[check] != ' ' ) 
			 break ; 
	       
	       /* Transfer info to our line for further processing */
	       for (i = check; i < MAXLINE; i++)
		    line[i] = TmpLine[i] ;
	       
	       HalfLine = FullLine = FALSE ;
	       if ( (int)strlen(line) > 30 ) 
		    FullLine = TRUE ;
	       else
		    HalfLine = TRUE ;
	      
	       if ( HalfLine ) 
		       goto out_loop ;
	       
	       /* loop of reading and storing constraints  */
	       if ( FullLine && countnoe < MAXNOES) {
		    
		    /* Re-allocating space */
		    NOE = (struct noe *)realloc(NOE,sizeof(struct noe)* (countnoe+2)) ;
		    Noe = NOE + countnoe ;
		    
		    InitNoeRecord(Noe) ; 
		    InitNoeRecord(Noe+1) ; 
		    
		    sscanf(line,"%d %s %s %d %s %s %f %s",
				&tempresno, temprestype,  Noe->atom_type1, 
				&Noe->residue_number2, Noe->residue_type2, Noe->atom_type2, 
				&Noe->upper, Noe->comment);

		    Noe->residue_number1 = tempresno;
		    copy(Noe->residue_type1,temprestype,0,3);
		    Noe->chain_id_1[0]='A' ;
		    Noe->chain_id_1[1]='\0';
		    Noe->chain_id_2[0]='A' ;
		    Noe->chain_id_2[1]='\0';
		    
		    /* storing data */
		    Noe->lower = 0.0;
		    Noe->equil = Noe->upper ;
		    Noe->rgupp = Noe->upper - Noe->equil ;
		    Noe->rglow = Noe->equil - Noe->lower ;
		    Noe->Number = countnoe ;
		    Noe->next = Noe ;
		   
		    /* Some Debug just in case */
		    if ( DEBUG == -1 ) {
			    fprintf(stdout," read_cons_disdya(): %5d line is -> %s", lineno, line);
			    fprintf(stdout," read_cons_disdya(): %5d Cons is ->", countnoe);
			    fprintf(stdout," %3d %3s  %-5s %3d %3s  %-5s %6.2f\n",
					    Noe->residue_number1, Noe->residue_type1, Noe->atom_type1,
					    Noe->residue_number2, Noe->residue_type2, Noe->atom_type2,
					    Noe->upper);
		    }
		    /* Check for same atom constraint */
		    if ( strcmp(Noe->atom_type1,Noe->atom_type2)==0 && Noe->residue_number1 == Noe->residue_number2 ) {
			 fprintf(stdout,"  ** Warning, _IGNORING_ same atom constraint, for '%s' '%s' %3d   '%s' '%s' %3d %.2f %.2f, around line %5d \n",
				 Noe->atom_type1, Noe->residue_type1, Noe->residue_number1,
				 Noe->atom_type2, Noe->residue_type2, Noe->residue_number2,
				 Noe->lower, Noe->upper, lineno+1);
		    } else { 
			iatNoe(Noe) ;
		    	countnoe+=1 ;
		    }
	       }
	  out_loop:
	       for (i = 0; i < MAXLINE; i++) 
		    TmpLine[i] = ' ';
	       TmpLine[MAXLINE] = '\0' ;
	  }
     ConsTrue = TRUE ;
     constraintcount = countnoe - 1 ;
     return constraintcount ;
}

/* ========================================================================= */
int  read_lol_disman(FILE *rtti, char disdia[10], char LowUpp[10])
/*
  ---
  --- Once we had a reader of constraints in CONGEN format we need more format
  --- possibilities, ... and here is another one ...
  ---
  --- (Roberto Tejero, RTT, May 1993, CABM-Rutgers University).
  ---
*/
{
     static int   tempresno, resnumber2 ;
     static char  temprestype[5], restype2[5], atom_type1[6], atom_type2[6];
     static int   len, check, lineno;
     static short i ;
     static char  FOUND = FALSE, TmpLine[MAXLINE] ;
     static float bound ;
     struct noe   *Noe, *NoeOld ;
     static char FullLine = FALSE, HalfLine = FALSE ;
     
     lineno = 0;
     for (i = 0; i < MAXLINE; i++) 
	     line[i] = ' ';
     line[MAXLINE] = '\0' ;

     constraintcount += 1 ;
     
     while ((len=GetLine(TmpLine,MAXLINE,rtti)) > 0) 
	  if ((len > 1) && (constraintcount < MAXNOES)) {
	       FOUND = FALSE ;
	       lineno++;
	       
	       /* Skip comment lines */
	       for (i = 0; i <= 5; i++)
		    if (TmpLine[i]=='#') 
			 goto out_loop ;
	       
	       if (TmpLine[0]=='*')         /* for PDB deposited files style formats */
		    goto out_loop ;
	       
	       /* Strip new line and trailing spaces */
	       for (i = MAXLINE-1 ; i > 0; i--)
		    if ( TmpLine[i] == ' ' || TmpLine[i] == '\n' ) {
			 TmpLine[i] = '\0' ;
		    } else {
			 break;
		    }

	       /* pad spaces until beginning of second field */
	       for (i = 0; i < 30; i++)
		       if ( TmpLine[i] == '\0' )
			       TmpLine[i] = ' ' ;
	       
	       /* Strip heading spaces */
	       for (check = 0; check < MAXLINE; check++)
		    if ( TmpLine[check] != ' ' ) {
			 break ;
		    }
	       
	       for (i = check; i < MAXLINE; i++)
		    line[i] = TmpLine[i] ;
	       
	       HalfLine = FullLine = FALSE ;
	       if ( (int)strlen(line) > 30 ) 
		    FullLine = TRUE ;
	       else
		    HalfLine = TRUE ;

	       if ( HalfLine ) 
		       goto out_loop ;
	       
	       /* loop of reading and storing constraints  */
	       if ( FullLine && (constraintcount < MAXNOES) ) {
		    /*
		     * Avoid comment lines to celanup a little
		     * Be careful, *ANY* # from posion 0 -> 35 is considered as a
		     * comment and consequently throwed away ...
		     */
		    for (i = 0; i <= 35; i++)
			 if (line[i]=='#') 
				 goto out_loop ;
		    
		    sscanf(line,"%d %s %s %d %s %s %f",
				&tempresno, temprestype, atom_type1, &resnumber2, restype2, atom_type2, &bound);
		    
		    /* Locate possible upper bound */
		    NoeOld = NOE + 1 ;
		    while ( NoeOld->next != NULL ) {
			 if ( NoeOld->residue_number1 == tempresno && NoeOld->residue_number2 == resnumber2 &&
			      strcmp(NoeOld->atom_type1,atom_type1)==0 && strcmp(NoeOld->atom_type2,atom_type2)==0 ) {
			      NoeOld->lower = bound ;
			      FOUND = TRUE ;
			      break ;
			 }
			 NoeOld++ ;
		    }
		    if ( !FOUND ) {
			 fprintf(stdout,"\n  ** UPL not found, re-allocating space for NOE, line %4d",lineno);
			 fprintf(stdout,"\n  ** line reads: %s", line);
			 /* Actualice constraintcount, reallocate NOE and store data */
			 NOE = (struct noe *)realloc(NOE,sizeof(struct noe)* (constraintcount+1)) ;
			 Noe = NOE + constraintcount ;
			 
			 InitNoeRecord(Noe);
			 Noe->next = Noe ;

			 sscanf(line," %d %s %s %d %s %s %f %s", 
				&tempresno, temprestype,
				Noe->atom_type1, &Noe->residue_number2,
				Noe->residue_type2, Noe->atom_type2, &Noe->lower,
				Noe->comment);
			 Noe->residue_number1 = tempresno;
			 copy(Noe->residue_type1,temprestype,0,3);
			 Noe->chain_id_1[0]='A' ;
			 Noe->chain_id_1[1]='\0';
			 Noe->chain_id_2[0]='A' ;
			 Noe->chain_id_2[1]='\0';
			 /* storing data */
			 Noe->upper = 99.99;
			 Noe->equil = Noe->lower ;
			 Noe->rgupp = Noe->upper - Noe->equil ;
			 Noe->rglow = Noe->equil - Noe->lower ;
			 
			 Noe->Number = constraintcount ;
			 /* Check for same atom constraint */
			 if ( strcmp(Noe->atom_type1,Noe->atom_type2) == 0 && Noe->residue_number1 == Noe->residue_number2 )
			      fprintf(stdout,"  ** Warning, same atom constraint, for '%s' '%s' %3d   '%s' '%s' %3d %.2f %.2f, around line %5d \n",
				      Noe->atom_type1, Noe->residue_type1, Noe->residue_number1,
				      Noe->atom_type2, Noe->residue_type2, Noe->residue_number2,
				      Noe->lower, Noe->upper, lineno+1);
			 else 	
			 	constraintcount += 1 ;
		    }
	       }
	  out_loop: 
	       for (i = 0; i < MAXLINE; i++) 
		    TmpLine[i] = ' ';
	       TmpLine[MAXLINE] = '\0' ;
	  }
     ConsTrue = TRUE ;
     constraintcount -= 1;
     return constraintcount ;
}

/* ========================================================================= */
int  read_aco_dyana(FILE *rtti)
/*
  ---
  ---
*/
{
     static int   len, lineno, Reg;
     static short i ;
     struct aco *Aco = NULL ;
     
     acocount += 1 ;
     lineno = 0;
     
     while ((len=GetLine(line,MAXLINE,rtti)) > 0) {
	  if ((len > 1) && (acocount < MAXNOES)) {
	       lineno++;
	       
	       /* Just to see the first two lines in the file */
	       if (lineno < 3) printf("> CNSTR_rdr: %s",line);
	       
	       /* Skip comment lines */
	       for (i=0;i<=5;i++)
		    if (line[i]=='#') goto no_count_as_constraint ;
	       
	       /* Making a counter of constraints in file */
	       if (acocount == 10)
		    fprintf(stdout,"> CNSTR_rdr: I'm readinggg!! (he) .... ");
	       /*
		 if (fmod(acocount,10)==0.0)
		 fprintf(stdout,"%4d\b\b\b\b",acocount);
	       */
	       /*
		* Avoid comment lines to cleanup a little
		* Be careful, *ANY* # from posion 0 -> 35 is considered as a
		* comment and consequently throwed away ...
		*/
	       for (i = 0; i <= 35; i++)
		    if (line[i]=='#') goto no_count_as_constraint ;
	       
	       /*  Actual reading of file  */  
	       ACO = (struct aco *)realloc(ACO,sizeof(struct aco)* (acocount+1)) ;
	       Aco = ACO + acocount ;
	       Aco->next = Aco ;

	       /* Initialize */
	       Aco->Weight = 1.0 ;
	       Aco->AngleMin = 9999.9999 ;
	       Aco->AngleMax = 9999.9999 ;
	       strcpy(Aco->AngleName,"UNK");
	       strcpy(Aco->chain_id,"A");
	       
	       /* Read and assign data */
	       sscanf(line," %d %s %s %f %f %f", 
		      &Aco->residue_number,  Aco->residue_type,
		      Aco->AngleName, &Aco->AngleMin, &Aco->AngleMax, &Aco->Weight);
	       if ( Aco->Weight == 0.0 ) Aco->Weight = 1.0 ;
	       Aco->Number = acocount ;
	       Aco->Res1 = Aco->Res2 = Aco->Res3 = Aco->Res4 = Aco->residue_number ;
	       Aco->residue_type[3] = Aco->residue_type[4] = '\0';
	       if (strcmp(Aco->AngleName,"PHI")==0) 
		    Aco->Res1 = Aco->residue_number -1 ;
	       if (strcmp(Aco->AngleName,"PSI")==0) 
		    Aco->Res4 = Aco->residue_number +1 ;
	       
	       /* switch back to 0->180 and -180->0*/
	       if (Aco->AngleMin > 180.0) Aco->AngleMin-=360.0 ;
	       if (Aco->AngleMax > 180.0) Aco->AngleMax-=360.0 ;
	       
	       /* Evaluate Equilibrium value and range */
	       if (Aco->AngleMin > Aco->AngleMax) {
		    Aco->AngleEq = (360.0 + Aco->AngleMin + Aco->AngleMax)/2. ;
		    if (Aco->AngleEq > 180.0)  Aco->AngleEq -= 360.0 ;
	       } else {
		    Aco->AngleEq = (Aco->AngleMin + Aco->AngleMax)/2. ;
		    if (Aco->AngleEq > 180.0)  Aco->AngleEq -= 360.0 ;
	       } 
	       if (Aco->AngleMax < 0.0 && Aco->AngleMin >= 0.0)
		    Aco->AngleRg = fabs(360.0 + Aco->AngleMax - Aco->AngleMin);
	       else if ( Aco->AngleMin > Aco->AngleMax ) 
		    Aco->AngleRg = fabs(360.0 - fabs(Aco->AngleMax - Aco->AngleMin));
	       else
		    Aco->AngleRg = fabs(Aco->AngleMax - Aco->AngleMin);
	       Aco->AngleRg = Aco->AngleRg / 2;
	       
	       Reg = DihToNames(Aco->residue_type,Aco->AngleName);
	       strcpy(Aco->Atom1,DihLib[Reg].Atom1);
	       strcpy(Aco->Atom2,DihLib[Reg].Atom2);
	       strcpy(Aco->Atom3,DihLib[Reg].Atom3);
	       strcpy(Aco->Atom4,DihLib[Reg].Atom4);
	       
	       acocount+=1 ;
	  }
     no_count_as_constraint: /* do nothing */
	  ;
     }
     
     AcoTrue = TRUE;
     return --acocount;
}

