/*$Id: read_constraints_ecepp.c,v 1.7 2003/10/06 12:13:32 roberto Exp roberto $*/

#include <ctype.h>
#include "pdbstat.h"
extern int NamesToDih(char Residue[5], char At1[6], char At2[6], char At3[6], char At4[6]) ;
struct DiheLib *DihLib ;


/* ========================================================================= */
int  read_constraints_ecepp(FILE *rtti)
/*
 * ECEPP format for distance and angle constraints
 * (Roberto Tejero, RTT, May 2002, CABM-Rutgers University).
 */
{
	static int len, lineno, countaco, countnoe, DihType;
  	struct aco *Aco ;
  	struct noe *Noe ;

	countaco = countnoe = 1 ;
        lineno = 0;

        while ( (len = GetLine(line,MAXLINE,rtti)) > 0) {
             lineno++;
	     if ( line[0] == '!' ) continue ;     /* Avoid Comment lines */
	     if ( strncasecmp(line,"DIHEDRAL",8)==0 ) {
		    ACO = (struct aco *)realloc(ACO,sizeof(struct aco)* (countaco+1)) ;
		    Aco = ACO + countaco ;
		    Aco->next = Aco ;
	            sscanf(line," %*s %d %d %f %f %f \n",
		           &Aco->residue_number, &DihType, 
			   &Aco->AngleEq, &Aco->AngleRg, &Aco->Weight);
		    /* Analysis of ACO will follow */
		    if ( DihType == 1 ) {
			    strcpy(Aco->AngleName,"PHI");
			    Aco->Res1 = Aco->residue_number - 1;
			    Aco->Res2 = Aco->Res3 = Aco->Res4 = Aco->residue_number ;
			    strcpy(Aco->Atom1,"C-");
			    strcpy(Aco->Atom2,"N");
			    strcpy(Aco->Atom3,"CA");
			    strcpy(Aco->Atom4,"C");
		    } else if ( DihType == 2 ) {
			    strcpy(Aco->AngleName,"PSI");
			    Aco->Res4 = Aco->residue_number + 1;
			    Aco->Res1 = Aco->Res2 = Aco->Res3 = Aco->residue_number ;
			    strcpy(Aco->Atom1,"N");
			    strcpy(Aco->Atom2,"CA");
			    strcpy(Aco->Atom3,"C");
			    strcpy(Aco->Atom4,"N+");
		    }
		    Aco->AngleMin = Aco->AngleEq - Aco->AngleRg ;
		    Aco->AngleMax = Aco->AngleEq + Aco->AngleRg ;

		    if (Aco->AngleMin > 180.0) Aco->AngleMin -= 360.0 ;
		    if (Aco->AngleMax > 180.0) Aco->AngleMax -= 360.0 ;

		    strcpy(Aco->chain_id,"A");
		    Aco->Number = countaco ;
		    countaco++;
	     } else {
		    NOE = (struct noe *) realloc(NOE,sizeof(struct noe)*(countnoe+1)) ;
	            Noe = NOE + countnoe ;
		    Noe->next = Noe ;
	            sscanf(line," %*d %d  %s %*d %d %s %f %f \n",
		           &Noe->residue_number1, Noe->atom_type1,
		           &Noe->residue_number2, Noe->atom_type2,
		           &Noe->lower, &Noe->upper);
		strcpy(Noe->residue_type1,seqres[Noe->residue_number1]);
		strcpy(Noe->residue_type2,seqres[Noe->residue_number2]);
		/* Number data */
		Noe->equil = (Noe->upper + Noe->lower) / 2.0 ;
	  	Noe->rgupp = Noe->upper - Noe->equil ;
	  	Noe->rglow = Noe->equil - Noe->lower ;
		Noe->Number = countnoe ;
		strcpy(Noe->chain_id_1,"A");
		strcpy(Noe->chain_id_2,"A");
		strcpy(Noe->comment,"");
		countnoe++;  
	     }	     
	}

	if ( countaco > 0 ) {
		AcoTrue = TRUE ;
		acocount = countaco-1 ;
    		fprintf(stdout, "   %5d ACO constraints read\n", acocount);
	}
	if ( countnoe > 0 ) {
		ConsTrue = TRUE ;
        	constraintcount = countnoe-1 ;
    		fprintf(stdout, "   %5d NOE-distance constraints read\n", constraintcount);
	}
	return (countaco + countnoe);
}


