/*$Id: read_constraints_xplor.c,v 1.7 2003/10/06 12:13:32 roberto Exp roberto $*/

#include "pdbstat.h"
extern int NamesToDih(char Residue[5], char At1[6], char At2[6], char At3[6], char At4[6]) ;
extern void InitNoeRecord(struct noe *Noe) ;
void ScanAtomNoeXplor(char Desc[MAXLINE],struct noe *Noe, int Atomo) ;
void ScanAtomAcoXplor(char Desc[MAXLINE], struct aco *Aco, int Atomo) ;
char IsMultipleDesc(char s[MAXLINE], int idx) ;
extern void iatNoe(struct noe *N) ;

struct DiheLib *DihLib ;


/* ========================================================================= */
#include <ctype.h>
int  read_constraints_xplor(FILE *rtti)
/*
 * General routine to read _ANY_ kind of constraint in XPLOR/CNS formats.
 * As of Nov 2002 it deals with
 * 	1 distance constraint
 * 	2 dihedral constraints
 * (Roberto Tejero, RTT, May 2000, CABM-Rutgers University).
 */
{
     static short  lineno, itmp, idx=0, jdx=0 ;
     int           len ;
     static short  atx, ndx, atomdes, curridx, countaco, countnoe, Reg;
     static char   AtomDesc[21][MAXLINE], Numbers[MAXLINE], Key[10];
     static char   Read[MAXLINE], Stored[MAXLINE], Lineblank[MAXLINE] ;
     static char   DONE = FALSE, MoreLines = TRUE ;
     struct aco *Aco ;
     struct noe *Noe ;
     
     /* Initialize variables */
     if ( acocount == 0 )
	    countaco = 1;
     else
     	    countaco = acocount+1;
     
     if ( constraintcount == 0 )
	     countnoe = 1 ;
     else
     	     countnoe = constraintcount+1 ;

     lineno = 0;
     idx = 0;
     DONE = FALSE ;
     MoreLines = TRUE ;
     
     for (idx = 0; idx < 10; idx++)
	  Key[idx]='\0';
     
     for (idx = 0; idx < MAXLINE; idx++) {
	  Lineblank[idx]=' ';
	  Read[idx] = '\0' ;
	  Stored[idx] = '\0' ;
	  line[idx] = '\0' ;
     }
     
     for (idx = 0; idx < 21; idx++) {
	  for (jdx = 0; jdx < MAXLINE; jdx++)
	       AtomDesc[idx][jdx]='\0' ;
     }
     
     for (jdx = 0; jdx < MAXLINE; jdx++)
	  Numbers[jdx]='\0' ;
     
     Lineblank[MAXLINE-1] = '\0';
     
     atomdes = 0;
     curridx = 0;
     
     /* Start the fun */
     while ( MoreLines ) {
	  len = GetLine(line,MAXLINE,rtti) ;
	  if ( len <= 0 ) {
	       MoreLines = FALSE ;
	       DONE = TRUE ;
	       strcpy(line,"Final\n") ;
	       line[6]='\0';
	  }
	  
	  if ( MoreLines )  lineno++;
	  if ( line[0] == '\n' ) continue ;
	  
	  /* Strip new line */
	  for (idx = 0; idx <= (int)strlen(line); idx++)
	       if ( line[idx] == '\n' ) line[idx]='\0';
	  
	  /* Locate comment sign */
	  for (itmp=0; itmp <= (int)strlen(line); itmp++)
	       if ( line[itmp] == '!' ) {
		    idx = itmp ;
		    break ;
	       }
	  for (itmp = idx; itmp < (int)strlen(line); itmp++) 
	       line[itmp]='\0';
	  
	  /* skip blank lines */
	  line[MAXLINE-1]='\0';
	  if ( strcmp(line,Lineblank)==0 && MoreLines ) 
	       continue ;
	  
	  /* Strip leading blanks */
	  for (itmp = 0; itmp <= (int)strlen(line); itmp++)
	       if ( line[itmp] != ' ' ) break ;
	  
	  for (idx = 0; idx <= (int)strlen(line); idx++)
	       line[idx] = line[idx+itmp];
	  
	  sscanf(line,"%s",Key);
	  if ( DEBUG > 10 ) {
	       fprintf(stdout," read_constraints_xplor():   line: %s  Key: %s lineno: %5d\n", line, Key, lineno);
	  }
	  
	  if ( strncasecmp(Key,"end",3)==0 ) {
	       DONE = TRUE ;
	  } else if ( strncasecmp(Key,"Final",5)==0 ) {
	       DONE = TRUE ;
	       MoreLines = FALSE ;
	  }
	  
	  /* Analyze first field on line and if it is not aA, oO, ( skip it */
	  if ( Key[0] != 'a' && Key[0] != 'A' && Key[0] != 'o' && Key[0] != 'O' &&
	       Key[0] != '(' && !DONE && MoreLines) 
	       continue ;
	  
	  /* Analize line just read appending lines when necessary */
	  if ( Read[0] == '\0' ) {
	       if (strncasecmp(Key,"assi",4) != 0 && MoreLines ) {
		    continue ;
	       }
	       for (itmp = 0; itmp <= (int)strlen(line); itmp++) {
		    if ( line[itmp] == '\0' || line[itmp] == '\n' ) break;
		    Read[itmp] = line[itmp] ;
	       }
	  } else {
	       if ( strncasecmp(Key,"assi",4) == 0 || DONE ) {
		    DONE = TRUE ;
		    for (itmp = 0; itmp <= (int)strlen(Read); itmp++)
			 Stored[itmp] = Read[itmp];
		    for (itmp = 0; itmp < MAXLINE; itmp++)
			 Read[itmp] = '\0' ;
		    for (idx = 0; idx < 10 ; idx++) /* Initialize Key for next round */
			 Key[idx]='\0' ;
	       } else {
		    strcat(Read," ");
		    strcat(Read,line);
	       }
	  }
	  
	  if ( !DONE && MoreLines ) continue ;
	  strcpy(Read,line);
	  
	  /* We are done getting line so, extract atom descriptions in line 
	   * atom descriptions are between parenthesis, check for multiple */
	  for (idx = 0; idx < (int)strlen(Stored); idx++) {
	       jdx = idx ;
	       if ( Stored[idx] == '\0' ) 
		       break;
	       if ( Stored[idx] == '(' ) {                     /* Begin of atom description */
	       	    while ( Stored[idx] == '(' ) { idx++ ; }   /* Get rid of multiple ('s */
		    atomdes++ ;
		    atx = 0;
		    jdx = idx ;
		    while ( Stored[jdx] != ')' ) {              /* End of atom description */
			 AtomDesc[atomdes][atx++] = Stored[jdx++];
		    }
		    AtomDesc[atomdes][atx++] = ' ';              /* add two white spaces */
		    AtomDesc[atomdes][atx++] = ' ';
	  	    while ( IsMultipleDesc(Stored,jdx) ) {
	       	    	while ( Stored[jdx] != '(' ) { jdx++ ; } /* move to next '('   */
	       	    	while ( Stored[jdx] == '(' ) { jdx++ ; } /* discard any extra '(' */ 
		    	while ( Stored[jdx] != ')' ) {           /* end of atom description   */
			 	AtomDesc[atomdes][atx++] = Stored[jdx++];
			}
		    	while ( Stored[jdx] == ')' ) { jdx++ ; } /* Discard any extra ')' */
		    	AtomDesc[atomdes][atx++] = ' ';          /* add twp white spaces */
			AtomDesc[atomdes][atx++] = ' ';
	  	     } 
		    curridx = jdx + 1 ;
	       }
	       idx = jdx ;
	  }
	  
	  /* extract numbers --bounds-- in line */
	  ndx = 0 ;
	  while (Stored[curridx] != '\0' && Stored[curridx] != '\n' ) {
		  if ( Stored[curridx] == ')' ) { 
			  curridx++ ;
			  continue ;
		  }
	       Numbers[ndx++] = Stored[curridx++] ;
	  }
	  
	  if ( DONE ) {
	       DONE = FALSE ;
	       if ( atomdes < 2 ) {
		    goto End ;
		    /* ---- DISTANCE constraints ---- */
	       } else if ( atomdes == 2 ) {
		    /* allocate space for new NOE */	
		    NOE = (struct noe *) realloc(NOE,sizeof(struct noe) * (countnoe+1) ) ;
		    Noe = NOE + countnoe ;
		    InitNoeRecord(Noe) ;

		    /* assign (segid A and resid 2 and name HG2#) (segid A and resid 3 and name HN) 4.0 2.2 1.5 	*/
		    if ( DEBUG > 2 ) {
			 fprintf(stdout,"    AtomDesc1: '%s' \n    AtomDesc2: '%s' \n", AtomDesc[1], AtomDesc[2]);
			 fprintf(stdout,"    Numbers  : %s\n", Numbers);
		    }
		    ScanAtomNoeXplor(AtomDesc[1], Noe, 1);		    
		    ScanAtomNoeXplor(AtomDesc[2], Noe, 2) ;
		    sscanf(Numbers, "%f %f %f", &Noe->equil, &Noe->rglow, &Noe->rgupp);
		    strcpy(Noe->residue_type1,seqres[Noe->residue_number1]);
		    strcpy(Noe->residue_type2,seqres[Noe->residue_number2]);
		  
		    /* Number data */
		    Noe->upper = Noe->equil + Noe->rgupp ; 
		    Noe->lower = Noe->equil - Noe->rglow ; 
		    Noe->Number = countnoe ;
		    
		    /* Check for same atom constraint */
		    if ( strcmp(Noe->atom_type1,Noe->atom_type2) == 0 && Noe->residue_number1 == Noe->residue_number2 ) {
			 fprintf(stdout,"  ** Warning, _IGNORING_ same atom constraint, for '%s' '%s' %3d   "
				 "'%s' '%s' %3d %.2f %.2f, around line %5d \n",
				 Noe->atom_type1, Noe->residue_type1, Noe->residue_number1,
				 Noe->atom_type2, Noe->residue_type2, Noe->residue_number2,
				 Noe->lower, Noe->upper, lineno-1);
			 countnoe -= 1 ;
		    }
		    
		    /* strcpy(Noe->comment,""); */
		    if ( DEBUG >= 10 ) 
			 fprintf(stdout," '%s'  '%s'  %3d   '%s'  '%s'  %3d %.2f %.2f\n",
				 Noe->atom_type1, Noe->residue_type1, Noe->residue_number1,
				 Noe->atom_type2, Noe->residue_type2, Noe->residue_number2,
				 Noe->lower, Noe->upper);

		    Noe->next = Noe ;
		    countnoe += 1 ;
		    
		    /* -----  ANGLE constraints ----- */
	       } else if (atomdes == 3) {
		    fprintf(stdout,"  -- Angle constraint ?? \n");
		    goto End ;
		    
		    /* ---- DIHEDRAL constraints ---- */
	       } else if (atomdes == 4) {
		    /*  Actual reading of file 	 */  
		    ACO = (struct aco *)realloc(ACO,sizeof(struct aco)* (countaco+1)) ;
		    Aco = ACO + countaco ;
		    Aco->next = Aco ;
		   
		    /* 
		     * Obsolete way of reading ACO info from file
		     *
		    sscanf(AtomDesc[1],"%*s %d %*s %*s %s", &Aco->Res1, Aco->Atom1 );
		    sscanf(AtomDesc[2],"%*s %d %*s %*s %s", &Aco->Res2, Aco->Atom2 );
		    sscanf(AtomDesc[3],"%*s %d %*s %*s %s", &Aco->Res3, Aco->Atom3 );
		    sscanf(AtomDesc[4],"%*s %d %*s %*s %s", &Aco->Res4, Aco->Atom4 );
		    */

		    /* New way to extract segid, resid and name from record */
		    ScanAtomAcoXplor(AtomDesc[1], Aco, 1);		    
		    ScanAtomAcoXplor(AtomDesc[2], Aco, 2);
		    ScanAtomAcoXplor(AtomDesc[3], Aco, 3);		    
		    ScanAtomAcoXplor(AtomDesc[4], Aco, 4);

		    sscanf(Numbers,"%f %f %f", &Aco->Weight, &Aco->AngleEq, &Aco->AngleRg);

		    Aco->residue_number = Aco->Res2 ;
		    
		    /* Correct for PHI and PSI */
		    if (Aco->Res1 == Aco->Res2-1) strcpy(Aco->Atom1,"C-");
		    if (Aco->Res4 == Aco->Res3+1) strcpy(Aco->Atom4,"N+");
		    
		    strcpy(Aco->residue_type,seqres[Aco->residue_number]);
		    
		    Reg = NamesToDih(Aco->residue_type,Aco->Atom1,Aco->Atom2,Aco->Atom3,Aco->Atom4);
		    strcpy(Aco->AngleName,DihLib[Reg].DihName);
		    
		    if ( Aco->AngleEq < 0 ) Aco->AngleEq += 360.0 ;
		    
		    Aco->AngleMin = Aco->AngleEq - Aco->AngleRg ;
		    Aco->AngleMax = Aco->AngleEq + Aco->AngleRg ;
		    
		    if (Aco->AngleMin > 180.0) Aco->AngleMin -= 360.0 ;
		    if (Aco->AngleMax > 180.0) Aco->AngleMax -= 360.0 ;
		    
		    strcpy(Aco->chain_id,"A");
		    Aco->Number = countaco ;
		    countaco += 1 ;
	       } else if (atomdes == 5) {
		    fprintf(stdout,"  -- shift constraint\n");
		    goto End ;
		    
	       } else if (atomdes == 6) {
		    /* fprintf(stdout,"  -- SANI constraint\n"); */
		    sanicount++ ;
		    goto End ;
		    
	       }
	  } /* if (DONE) */
	  
     End:
	  if ( !MoreLines ) break ;
	  
	  /* Initialize for new cycle of reading */
	  for (itmp = 0; itmp < MAXLINE; itmp++) {
	       if (strncasecmp(Read,"assi",4)!=0) Read[itmp] = '\0' ;
	       Stored[itmp] = '\0' ;
	  }
	  for (ndx=0; ndx < 6; ndx++)
	       for (idx=0; idx < MAXLINE; idx++) 
		    AtomDesc[ndx][idx]='\0' ;
	  ndx = curridx = atomdes = 0;
     }
     
     if ( countaco > 1 ) {
	  AcoTrue = TRUE ;
	  acocount = countaco - 1 ;
	  fprintf(stdout, "   %5d ACO constraints read\n", acocount);
     } else {
	  AcoTrue = FALSE ;
	  acocount = 0;
     }
     
     if ( countnoe > 1 ) {
	  ConsTrue = TRUE ;
	  constraintcount = countnoe - 1 ;
	  fprintf(stdout, "   %5d NOE-distance constraints read\n", constraintcount);
     } else {
	  ConsTrue = FALSE ;
	  constraintcount = 0;
     }

     if ( sanicount > 0 ) {
	     SaniTrue = TRUE ;
	     fprintf(stdout, "   %5d SANI-RDC constraints detected -- not worked out\n", sanicount);
     }

     return (constraintcount + acocount);
}


/* Scan record for multiple definitons, looking for 'or', 'OR' */
char IsMultipleDesc(char s[MAXLINE], int idx)
{
	static int   kdx ;
	static char  Ans = FALSE; 
	
	Ans = FALSE ;
	kdx = idx ;
	while ( s[kdx] != '(' && s[kdx] != '\0' ) {
		if ( (s[kdx] == 'o' || s[kdx] == 'O') &&
		     (s[kdx+1] == 'r' || s[kdx+1] == 'R') ) {
			Ans = TRUE ;
			break ;
		}
		kdx++ ;
	}
	return (Ans);
}


/* Scan atom description for the different atom data */
/* 
 * It can be fed with multiple data but as of now, March 2003 this routine goes 
 * all the way down to the end of the records keeping only the data last read, 
 * _TO_BE_DEVELOPED_ 
 * */
void ScanAtomNoeXplor(char Desc[MAXLINE], struct noe *Noe, int Atomo)
{
     short sik=0, slk=0, num=0 ;
     char Word = FALSE ;
     char Tok[90][10] ;
     
     for ( sik = 0; sik < 50; sik++)
	  for ( slk = 0; slk < 20; slk++)
	       Tok[sik][slk] = '\0';
     
     Desc[(int)strlen(Desc)+1] = '\0';
     
     sik = slk = 0 ;
     num = -1 ;
     Word = FALSE ;
     
     /* Extracting tokens (words) from atom description line */
     while ( Desc[sik++] != '\0') {
	  if ( Desc[sik-1] == ' ' || Desc[sik-1] == '\t' ) {
	       slk = 0 ;
	       Word = FALSE ;
	       continue;
	  } else if ( Word == FALSE ) {
	       Word = TRUE ;
	       Tok[++num][slk++] = Desc[sik-1] ;
	  } else if ( Word == TRUE ) {
	       Tok[num][slk++] = Desc[sik-1] ;
	  }
     }
     
     if ( DEBUG > 3 ) {
	  for ( sik = 0 ; sik <= num; sik++)
	       fprintf(stdout,"   -> ScanAtomNoeXplor()[read_constraints_xplor()]   Token '%d' is '%-9s'\n", sik, Tok[sik]);
	  fprintf(stdout,"\n");
     }
     
     /* Assign data to Noe */
     if ( Atomo == 1 ) {
	  Noe->chain_id_1[0] = 'A';
	  for ( sik = 0 ; sik <= num; sik++) { 
	       if ( strncasecmp(Tok[sik],"resid",3)==0 )
		    Noe->residue_number1 = atoi(Tok[sik+1]) ;
	       
	       /* For segid remove the doble quotes that sometimes appear */
	       if ( strncasecmp(Tok[sik],"segid",3)==0 ) {
		    for (slk = 0 ; slk < 5; slk++) 
			 if ( Tok[sik+1][slk] == '"' )
			      Tok[sik+1][slk] = Tok[sik+1][slk+1] ;
		    Noe->chain_id_1[0] = Tok[sik+1][0] ;
		    strncpy(Noe->segid_1,Tok[sik+1],4) ;
	       }
	       
	       if ( strncasecmp(Tok[sik],"name",3)==0 ) {
		       sscanf(Tok[sik+1],"%s",Noe->atom_type1);
	       }
	  }
	  Noe->chain_id_1[0] = toupper(Noe->chain_id_1[0]);
	  
     } else if ( Atomo == 2 ) {
	  Noe->chain_id_2[0] = 'A';
	  for ( sik = 0 ; sik <= num; sik++) {
	       if ( strncasecmp(Tok[sik],"resid",3)==0 )
		    Noe->residue_number2 = atoi(Tok[sik+1]) ;
	       
	       /* For segid remove the doble quotes that sometimes appear */
	       if ( strncasecmp(Tok[sik],"segid",3)==0 ) {
		    for (slk = 0 ; slk < 5; slk++)
			 if ( Tok[sik+1][slk] == '"' )
			      Tok[sik+1][slk] = Tok[sik+1][slk+1] ;
		    Noe->chain_id_2[0] = Tok[sik+1][0] ;
		    strncpy(Noe->segid_2,Tok[sik+1],4) ;
	       }
	       
	       if ( strncasecmp(Tok[sik],"name",3)==0 ) {
		       sscanf(Tok[sik+1],"%s",Noe->atom_type2);
	       }
	  }
	  Noe->chain_id_2[0] = toupper(Noe->chain_id_2[0]);
     }
     Noe->next = Noe ;
     if ( Atomo == 2 ) {
     	iatNoe(Noe) ;
     }
     return ;
}




/* Scan atom description from an ACO --dihedral constraint-- record in X-PLOR */
/* 
 * It can be fed with multiple data but as of now, March 2003 this routine goes 
 * all the way down to the end of the records keeping only the data last read, 
 * _TO_BE_DEVELOPED_ 
 * */
void ScanAtomAcoXplor(char Desc[MAXLINE], struct aco *Aco, int Atomo)
{
     short sik=0, slk=0, num=0 ;
     char Word = FALSE ;
     char Tok[90][10] ;
     
     for ( sik = 0; sik < 50; sik++)
	  for ( slk = 0; slk < 20; slk++)
	       Tok[sik][slk] = '\0';
     
     Desc[(int)strlen(Desc)+1] = '\0';
     
     sik = slk = 0 ;
     num = -1 ;
     Word = FALSE ;
     
     /* Extracting tokens (words) from atom description line */
     while ( Desc[sik++] != '\0') {
	  if ( Desc[sik-1] == ' ' || Desc[sik-1] == '\t' ) {
	       slk = 0 ;
	       Word = FALSE ;
	       continue;
	  } else if ( Word == FALSE ) {
	       Word = TRUE ;
	       Tok[++num][slk++] = Desc[sik-1] ;
	  } else if ( Word == TRUE ) {
	       Tok[num][slk++] = Desc[sik-1] ;
	  }
     }
     
     if ( DEBUG > 3 ) {
	  for ( sik = 0 ; sik <= num; sik++)
	       fprintf(stdout,"   -> ScanAtomAcoXplor()[read_constraints_xplor()]   Token '%d' is '%-9s'\n", sik, Tok[sik]);
	  fprintf(stdout,"\n");
     }
     
     /* Assign data to Aco */
     Aco->chain_id[0] = 'A';
     for ( sik = 0 ; sik <= num; sik++) { 
         if ( strncasecmp(Tok[sik],"resid",3)==0 ) {
		 switch (Atomo) {
			 case 1:
	      			Aco->Res1 = atoi(Tok[sik+1]) ;
				break;
			 case 2:
	      			Aco->Res2 = atoi(Tok[sik+1]) ;
				break;
			 case 3:
	      			Aco->Res3 = atoi(Tok[sik+1]) ;
				break;
			 case 4:
	      			Aco->Res4 = atoi(Tok[sik+1]) ;
				break;
			 default:
				fprintf(stderr," ** Error scanning Resid  in ScanAtomAcoXplor, info is: %s %d\n",
						Desc, Atomo);
				exit(-1);
		 }
	 }
	 
         /* For segid remove the doble quotes that sometimes appear */
         if ( strncasecmp(Tok[sik],"segid",3)==0 ) {
	      for (slk = 0 ; slk < 5; slk++) 
		   if ( Tok[sik+1][slk] == '"' )
		        Tok[sik+1][slk] = Tok[sik+1][slk+1] ;
	      Aco->chain_id[0] = Tok[sik+1][0] ;
	      strncpy(Aco->chain_id,Tok[sik+1],4) ;
         }
       
         if ( strncasecmp(Tok[sik],"name",3)==0 ) {
		switch (Atomo) {
			case 1:
	       			sscanf(Tok[sik+1],"%s",Aco->Atom1);
				break;
			case 2:
	       			sscanf(Tok[sik+1],"%s",Aco->Atom2);
				break;
			case 3:
	       			sscanf(Tok[sik+1],"%s",Aco->Atom3);
				break;
			case 4:
	       			sscanf(Tok[sik+1],"%s",Aco->Atom4);
				break;
			 default:
				fprintf(stderr," ** Error scanning Atom name in ScanAtomAcoXplor, info is: %s %d\n",
						Desc, Atomo);
				exit(-1);
		}

         }
     }
     return ;
}
