/*$Id: read_coords_congen.c,v 1.7 2003/10/06 12:13:32 roberto Exp roberto $*/
#include "pdbstat.h"
extern short MoreModelsThanAllowed(int nmodels);
extern void atom_properties(int Model) ;
extern void amino_codes(void);


/* ========================================================================= */
void read_coords_congen(FILE *rtti)
/*
  --- 
  --- This code has been able to read CONGEN and CHARMM formats
  --- (as it should be because they are almost the same)
  ---
  --- Be careful, this code is still under development and it doesn't
  --- make checks at all. The input file is supposed to be in the right
  --- format!.
  ---
  --- (Roberto Tejero, RTT, June 1993, CABM-Rutgers University).
  ---
*/
{
  int       cont, nter=0, cter=0, countRes = 0, CountAtomRes = 0,
            commen_num, 
            count, 
            atoms, 
            tempi ;
  static int TempiRes = 0;

  char      commen[MAXWORD];
  static struct models *Model ;
  struct atom_pdb *At ;

  commen_num=0;
  cont = 0;
  count = 0;
  q_atoms = 0;
  atoms = 0;
  
  for (count = 1; count <= 10 ; count++)
    strcpy(commen,"");

  /*
   * This is the place for the driver in reading the coordinates
   * as now (Jul 1993) it assumes that the title lines are lt. 10
   * (look at the for loop) number and the last one is a line with 
   * an asterisk alone (asterisk and new line), after this the file 
   * is actually readed. A lot of improvements and/or checks should 
   * be placed here!
   * Any idea/code/etc is welcome! (RTT)
   */
  while (fgets(line,MAXLINE,rtti) != NULL) {
    commen_num++;
    sscanf(line,"%s",commen);
    printf("> CGEN_rdr: %s",line);
    /* We assume that everything is correct in the file and start reading
     * coordinates after finding an asterisk by itself */
    count = (int)strlen(line)-1 ;
    while ( count >= 0 ) {
	    --count ;
	    if ((line[count] == '*') || (line[count] != ' ')) break;
    }
    if ( count <= 1 ) 
	    goto lee ;
    else 
	    continue ;
  }
  /*
   *  We are reading the input file!. We throw away some info
   *  that it is present in charmm type files
   *  The following is a sample of CHARMM format
   *
   * *PDB1INS.ENT                                                              
   * *HEADER    HORMONE                                 10-JUL-80   1INS      1
   * *COMPND    INSULIN                                                       1
   * *SOURCE    PIG (SUS SCROFA)                                              1
   * *AUTHOR    G.G.DODSON,E.J.DODSON,D.C.HODGKIN,N.W.ISAACS,M.VIJAYAN        1
   * *
   *   240
   *     1    1 PHE  N     18.21300  11.68600  -3.85200 INSD 1      54.70000
   *     2    1 PHE  CA    16.93800  11.21800  -4.40400 INSD 1      24.25000
   *   ...    . ...  ..    ........  ........  ........ ......      ........
   *   239   30 ALA  CB    -4.45200  21.92900 -10.42300 INSD 30     41.62000
   *   240   30 ALA  OT2   -3.72300  22.60900 -13.45500 INSD 30     44.63000
   */
lee:
  key_model++;
  AverageModel++ ;
  models++;
  total_models = key_model;
  /*
   * Allocate space for model
   */
  MODELS = (struct models *)realloc(MODELS,sizeof(struct models)*(AverageModel+2)) ;
  Model = MODELS + key_model ;
  Model->SerialNumber = key_model ;
  Model->modelno = key_model;

  fgets(line,MAXLINE,rtti);
  sscanf(line,"%d",&atoms);
  count=0;
  tempi = 9999;
  
  while(fgets(line,MAXLINE,rtti) != NULL) {
    count++;
    At = (Model->PDB) + count ;
    sscanf(line,"%d %d %s %*s %f %f %f",
	   &cont,
	   &TempiRes,
	   At->pdb_res,
	   &At->pdb_xcrd,
	   &At->pdb_ycrd,
	   &At->pdb_zcrd);
    
    /*
     * Storing properly ALL coordinates
     */
    At->coord[0] = At->pdb_xcrd;
    At->coord[1] = At->pdb_ycrd;
    At->coord[2] = At->pdb_zcrd;
    
    At->pdb_oldx = At->pdb_xcrd;
    At->pdb_oldy = At->pdb_ycrd;
    At->pdb_oldz = At->pdb_zcrd;
    
    At->pdb_num = cont;
    
    copy(At->pdb_iupac,line,15,19);

    /* Try to decode segid info into chan_id info */
    copy(At->segid,line,51,54);
    At->pdb_chain_id[0] = toupper(At->segid[0]) ;
    if ( !isalpha(At->pdb_chain_id[0]) )
	    At->pdb_chain_id[0] = 'A' ;
    
    if ((strncmp(At->pdb_res,"NTER",3)==0) &&
	(strncmp(At->pdb_iupac," HT1",4)==0))
      nter++ ;
    
    if (strncmp(At->pdb_res,"CTER",3)==0)
      cter++ ;
    
    At->pdb_num_res_orig = At->pdb_num_res = TempiRes - (nter + cter) ;
    
    /*===================================================*/
    /*
     * Storing residue number and name in DIH array structure
     */
    if (At->pdb_num_res != Model->PDB[count-1].pdb_num_res) {
      countRes++ ;
      /* Allocate space for residue number */
      DIH = (struct dihedral *) realloc(DIH,sizeof(struct dihedral)*(countRes+1)) ;
      CountAtomRes = 1;
      copy(Model->DIH[countRes].resname, At->pdb_res,0,2);
      Model->DIH[countRes].resnumber       = TempiRes - (nter + cter) ;
      Model->DIH[countRes].resnumber_orig  = TempiRes - (nter + cter) ;
      Model->DIH[countRes].number_of_atoms = CountAtomRes ;
      Model->DIH[countRes].orden           = countRes ;
      At->orden              = countRes ;
      strcpy(Model->DIH[countRes].chain_id,At->pdb_chain_id);
    } else {
      CountAtomRes++ ;
      Model->DIH[countRes].number_of_atoms =  CountAtomRes ;
      At->orden = countRes ;
    }
    
    /* strcpy(At->pdb_chain_id,"A"); */
    
    if (strncmp(At->pdb_iupac," HT1",4)==0)
      strncpy(At->pdb_iupac,"1H  ",4);
    
    if (strncmp(At->pdb_iupac," HT2",4)==0)
      strncpy(At->pdb_iupac,"2H  ",4);
    
    if (strncmp(At->pdb_iupac," HT3",4)==0)
      strncpy(At->pdb_iupac,"3H  ",4);
    
    if (strncmp(At->pdb_iupac," NT ",4)==0)
      strncpy(At->pdb_iupac," N  ",4);
    
    if (strncmp(At->pdb_iupac," OT1",4)==0)
      strncpy(At->pdb_iupac," O  ",4);
    
    /*
     * Charmm has a OCT1 and OCT2 as terminating (last residue) atoms
     * whereas in CONGEN are OT1 and OT2 
     */
    if (strncmp(At->pdb_iupac," OCT1",5)==0)
      strncpy(At->pdb_iupac," O   ",5);
    
    if (strncmp(At->pdb_iupac," OT2",4)==0)
      strncpy(At->pdb_iupac," OXT",4);

    if (strncmp(At->pdb_iupac," OCT2",5)==0)
      strncpy(At->pdb_iupac," OXT ",5);
    
    if (At->pdb_iupac[1] == 'Q') q_atoms++;    
  }
  
  MAX = count+1;
  Model->number_of_atoms = count;
  tempi = 0;

  for (cont = 1 ; cont < MAX ; cont++) {
    if (strncmp(Model->PDB[cont].pdb_res,"NTER",3)==0) {
      strcpy(Model->PDB[cont].pdb_res,
	     Model->PDB[cont+3].pdb_res);
      Model->PDB[cont].pdb_num_res = 
	Model->PDB[cont+3].pdb_num_res ;
    }
    if (strncmp(Model->PDB[cont].pdb_res,"CTER",3)==0) {
      strcpy(Model->PDB[cont].pdb_res,
	     Model->PDB[cont-3].pdb_res);
      Model->PDB[cont].pdb_num_res = 
	Model->PDB[cont-3].pdb_num_res ;
    }
    if ( tempi != Model->PDB[cont].pdb_num_res ) {
      tempi++;
      Model->DIH[tempi].resnumber = tempi ;
      strcpy(Model->DIH[tempi].resname,
	     Model->PDB[cont].pdb_res);
    }	  
  }
  
  normal_atoms = count - q_atoms ;
  
  if (normal_atoms != atoms) {
    printf("> CGEN_rdr: ** Check file, number of atoms and records don't agree\n");
    return ;
  }
  
  printf("> CGEN_rdr: %4d records read, %4d atoms and %3d atoms Q DISMAN type \n\n",
	 count, normal_atoms, q_atoms);
  
  Model->number_of_residues = Model->PDB[MAX-1].pdb_num_res ;
  Model->starting_res = Model->PDB[1].pdb_num_res ;
  
  /*
   * Check number of atoms and number of residues
   */
  if (Model->number_of_atoms > MAXATOMS) {
    printf("> CONGEN_rdr: *** More atoms (%d) than allowed (%d) \n",
	   Model->number_of_atoms,
	   MAXATOMS);
    return;
  }
  
  if (Model->number_of_residues > MAXRESIDUES) {
    printf("> CONGEN_rdr: *** More residues (%d) than allowed (%d) \n",
	   Model->number_of_residues, MAXRESIDUES);
    return;
  }
  
  check_label_pdb(0);
  
  (void) atom_properties(key_model) ; 
  /*
   * Asking for some info about the file just read
   */
  printf("> =============================== INFO ================================ \n");
  MolWeight(1);
  CenterMass(2);
  info_res(key_model);
  printf("> ===================================================================== \n");
  if (DEBUG > 0) 
    printf("> CONGEN_rdr: Going back to MAIN ... \n");

  sequence_true = TRUE ;
  return ;
}
