/*$Id: read_coords_insight.c,v 1.7 2003/10/06 12:13:32 roberto Exp roberto $*/

#include "pdbstat.h"
extern short MoreModelsThanAllowed(int nmodels);
extern void atom_properties(int Model) ;
extern void amino_codes(void);

/* ========================================================================= */
void read_coords_insight(FILE *rtti)
     /*
       --- 
       --- (Roberto Tejero, RTT, Sept. 1993, Valencia University).
       ---
     */
{
  int       cont, i, count, countRes , CountAtomRes ,
            commen_num,
            insi_models, tempi;
  char      commen[12][MAXWORD],
            temp[MAXWORD];
  char      numermod[15][100];
  struct models *Model ;
  struct atom_pdb *At ;

  countRes = 0 ;
  commen_num=0;
  cont = 0;
  count = 0;
  q_atoms = 0;
  tempi = 0;
  insi_models = 0 ;

  for (count = 1; count <= 10 ; count++)
    strcpy(commen[count]," ");

  /*
   * Scanning input file and counting models
   */
  fprintf (stdout, "> INSIGHT_rdr: Counting models in file `%s'; Model: ",
	   name_of_the_file_coords);
  
  while (fgets(line,MAXLINE,rtti) != NULL) { 
    commen_num++;
    if (commen_num > 40000) {
      printf("> INSIGHT_rdr: >>> OOPS buddy!, something wrong in \n");
      printf("> INSIGHT_rdr: >>> input file, better check it!!!! \n");
      printf("> INSIGHT_rdr: \n");
      printf("> INSIGHT_rdr: ...... Exiting! ..... \n\n");
      exit (-1);
    }
    
    copy(temp,line,0,10);
    
    /* Storing energy for this model */
    if (strncmp(temp,"input f",5)==0) {
      tempi++;
      MODELS = (struct models *) 
	realloc(MODELS, sizeof(struct models) * (tempi + 2)) ;
      sscanf(line,"%*s %*s %*s %*s %f", &MODELS[tempi].energy);
    }
    
    if ((strncmp(temp,"!MODEL",6)==0) ||
	(strncmp(temp,"! MODE",6)==0) ||
	(strncmp(temp,"!  MOD",6)==0) ||
	(strncmp(temp,"!   MOD",7)==0) ||
	(strncmp(temp,"!    MOD",8)==0) ||
	(strncmp(temp,"!     MOD",9)==0) ||
	(strncmp(temp,"!      MOD",10)==0)) {
      insi_models++;
      
      copy(numermod[insi_models],line,12,25);
      commen_num = 0;
      fprintf (stdout,"%3d\b\b\b", insi_models);
    }
  }
  
  rewind(rtti);
  
  if (insi_models == 0) insi_models = 1;
  
  printf("\n");
  printf("> INSIGHT_rdr: There are %d models in file `%s' \n",
	 insi_models,  name_of_the_file);
  
  AverageModel = insi_models+1 ;
  
  MODELS = (struct models *)
    realloc(MODELS,sizeof(struct models) * (AverageModel+2)) ;
  
  commen_num = 0;
  
  /*
   * Reading models
   */
  fprintf(stdout,"> INSIGHT_rdr: Reading model:    ");
  
 lee_de_nuevo:
  
  if (key_model > insi_models ) goto insi_finished ;
  
  while (fgets(line,MAXLINE,rtti) != NULL) {
    commen_num++;
    if (commen_num > 10) {
      printf("\n> INSIGHT_rdr: >>> Comment no. greater than maximum "\
	     "allowed (10) \n");
      exit (-1);
    }
    sscanf(line,"%s",commen[commen_num]);
    if (strncmp(commen[commen_num],"!DATE",5)==0) 
      goto lee;
  }
  
  goto insi_finished ;
  
  /*
   * We are reading the input file!. We throw away some info
   * that it is present in insight type files
   * The following is a sample of INSIGHT format
   *

   * !BIOSYM archive 2
   * PBC=OFF
   * input file for discover
   * !DATE Wed Oct 13 17:46:05 1993
   * N        0.114695311   -0.104534358   -0.000000030 TYRN   1  N3 N 
   * HN1     -0.248689622    0.386650354    0.829209805 TYRN   1  H3 H 
   * HN2     -0.247139066    0.347188443   -0.852010787 TYRN   1  H3 H 
   * HN3     -0.190752879   -1.087937474    0.022799922 TYRN   1  H3 H 
   * ...
   * ...
   * ...
   * O        6.259712219   11.607169151   -3.491920471 OH     5  OH O 
   * HO       5.673999786   12.161562920   -4.012677670 OH     5  HO H 
   * end                                                                     
   * end                                              
   */

 lee:

  CountAtomRes = 1;
  countRes = 0;
  key_model++;
  total_models++;
  models++;
  
  if (key_model > insi_models ) {
    key_model--;
    total_models--;
    models--;
    goto insi_finished ;
  }
  
  Model = MODELS + key_model ;
  Model->modelno = atoi(numermod[key_model]);
  
  normal_atoms = 0;
  q_atoms = 0;
  count = 0;
  cont = 0;
  
  fprintf(stdout,"\b\b\b%3d", key_model);
  
  while (fgets(line,MAXLINE,rtti) != NULL) {
    sscanf(line,"%s", commen[1]);
    if (strcasecmp(commen[1],"end") != 0) {
      count++;
      
      /* Allocate space for atom records */
      PDB = (struct atom_pdb *) 
	realloc(PDB, sizeof(struct atom_pdb) * (count+1)) ;
      At = (Model->PDB) + count ;
      At->pdb_num     = count;
      sscanf(line,"%*s %f %f %f ",
	     &At->pdb_xcrd,
	     &At->pdb_ycrd,
	     &At->pdb_zcrd);

      At->coord[0] = At->pdb_xcrd;
      At->coord[1] = At->pdb_ycrd;
      At->coord[2] = At->pdb_zcrd;
      
      At->pdb_oldx = At->pdb_xcrd;
      At->pdb_oldy = At->pdb_ycrd;
      At->pdb_oldz = At->pdb_zcrd;
      
      copy(At->pdb_iupac,line,0,3);
      copy(At->pdb_res,line,51,53);
      copy(temp,line,55,60);
      At->pdb_num_res = atoi(temp);
      At->pdb_num_res_orig = atoi(temp);
      
      /*===================================================*/
      
      /* Storing residue number and name in array structure  */
      if (At->pdb_num_res != Model->PDB[count-1].pdb_num_res) {
	countRes++;
	/* Allocate space for residue number */
	DIH = (struct dihedral *)
	realloc(DIH,sizeof(struct dihedral)*(countRes+1)) ;
	CountAtomRes = 1;
	copy(Model->DIH[countRes].resname, At->pdb_res,0,2);
	Model->DIH[countRes].resnumber       = atoi(temp) ;
	Model->DIH[countRes].resnumber_orig  = atoi(temp) ;
	Model->DIH[countRes].number_of_atoms = CountAtomRes ;
	Model->DIH[countRes].orden           = countRes ;
	At->orden              = countRes ;
      } else {
	CountAtomRes++ ;
	Model->DIH[countRes].number_of_atoms =  CountAtomRes ;
	At->orden = countRes ;
      }


      /*===================================================*/
      
      i = 4;
      while (i > 0) {
	At->pdb_iupac[i] = At->pdb_iupac[i-1];
	i-- ;
      }

      At->pdb_iupac[0]=' ';
      
      At->pdb_num = cont;
      /* strcpy(At->pdb_chain_id,"A"); */
      
      if (strncmp(At->pdb_res,"NTER",4)==0)
	At->pdb_num_res =  Model->PDB[count+3].pdb_num_res ;
      
      if (strncmp(At->pdb_res,"CTER",4)==0)
	At->pdb_num_res = Model->PDB[count-3].pdb_num_res ;
      
      if (strncmp(At->pdb_iupac," HN1",4)==0)
	strncpy(At->pdb_iupac,"1H  ",4);
      
      if (strncmp(At->pdb_iupac," HN2",4)==0)
	strncpy(At->pdb_iupac,"2H  ",4);
      
      if (strncmp(At->pdb_iupac," HN3",4)==0)
	strncpy(At->pdb_iupac,"3H  ",4);
      
      if (strncmp(At->pdb_iupac," NT ",4)==0)
	strncpy(At->pdb_iupac," N  ",4);
      
      if (strncmp(At->pdb_iupac," OT1",4)==0)
	strncpy(At->pdb_iupac," O  ",4);
      
      if (strncmp(At->pdb_iupac," OT2",4)==0)
	strncpy(At->pdb_iupac," OXT",4);
      
      if (At->pdb_iupac[1] == 'Q') 
	q_atoms++;
    } else {
      goto final ;
    }
  }
  
  goto insi_finished ;
  
final:
  
  MAX = count+1;  
  Model->number_of_atoms = count;
  Model->starting_res = Model->PDB[1].pdb_num_res ;
  Model->number_of_residues = Model->PDB[MAX-5].pdb_num_res -
    Model->PDB[3].pdb_num_res + 1 ;
  
  for (cont = 1 ; cont < MAX ; cont++) {
    if (strncmp(Model->PDB[cont].pdb_res,"NTER",4)==0)
      strcpy(Model->PDB[cont].pdb_res, Model->PDB[cont+3].pdb_res);
    
    if (cont > (Model->number_of_atoms - 4))
      if (strncmp(Model->PDB[cont].pdb_res,"OH",2)==0)  {
	strcpy(Model->PDB[cont].pdb_res, Model->PDB[MAX-5].pdb_res);
	Model->PDB[cont].pdb_num_res = Model->PDB[cont-3].pdb_num_res ;
      }
  }
  
  normal_atoms = count - q_atoms ;
  
  if (insi_models == 1)
    printf("\n> INSIGHT_rdr: %4d records read, %4d atoms and %3d atoms Q DISMAN type \n\n",
	   count, normal_atoms, q_atoms);

  /* Check number of atoms and number of residues   */
  if (Model->number_of_atoms > MAXATOMS) {
    printf("> INSIGHT_rdr: >>> More atoms (%d) than allowed (%d) \n",
	   Model->number_of_atoms,  MAXATOMS);
    return;
  }

  if (Model->number_of_residues > MAXRESIDUES) {
    printf("> INSIGHT_rdr: >>> More residues (%d) than allowed (%d) \n",
	   Model->number_of_residues,  MAXRESIDUES);
    return;
  }
  
  /* Check atom names looking for errors in labels   */
  check_label_pdb(0);
  
  /* Asking for some info about the file just read   */
  if ((insi_models > 1) && (key_model <= insi_models ))  {
    commen_num = 0;
    MolWeight(0);
    CenterMass(0);
    goto lee_de_nuevo;
  }
  
  (void) atom_properties(key_model) ;
  if (insi_models == 1) {
    printf("> =============================== INFO ================================ \n");
    MolWeight(1);
    CenterMass(2);
    info_res(key_model);
    printf("> ===================================================================== \n");
  }
  
 insi_finished:
  printf("\n");
  return;
}

