/*$Id: read_coords_pdb.c,v 1.8 2003/10/06 12:13:32 roberto Exp roberto $*/

#include "pdbstat.h"

extern short MoreModelsThanAllowed(int nmodels);
extern void atom_properties(int Model) ;
extern void amino_codes(void);
extern void InitPDBRecord(struct atom_pdb *PDB) ;


/* ========================================================================= */
void read_coords_pdb(FILE *rtti)
/*
 * Some improvements added!!
 *
 * (Roberto Tejero, RTT, May 1993, CABM-Rutgers University).
 */
{
     static int    i, k, l, inicio=0, final=0, diana=0, count_err = 0,
	    count=0, countRes=0, CountAtomRes=0, CountRecords=0,
	    CountIUPACAtoms=0, CountQAtoms=0, CountLonePairs=0,
	    model_wanted, model_from, model_to , modelno, actual_model, 
	    modelnotemp = 0;
     static int    count_lines, check_read_pdb_names, recon_lines;
     static char   texto[80], num[20], num1[10], num2[10], energy_temp[80];
     static char   target[80], temporary[MAXWORD],  new_chain[2] ;
     static long   CurrentPositionInFile ;
     static struct models *Model ;
     static struct atom_pdb *At ;
     static char   TruePdb = FALSE, Remark_Exhausted = FALSE, Remark_Model_Exhausted = FALSE ;
     static char   ModelAlreadyFound = FALSE ;
     
     /* Initialize */
     count = 0 ;
     count_err = 0 ;
     count_lines = 0 ;
     recon_lines = 0 ;
     lone_pairs = 0 ;
     check_read_pdb_names = 0 ;
     q_atoms = 0;
     normal_atoms = 0;
     models = 0;  
     disulfide_bonds = 0;
     model_wanted = 0;
     model_from = 0;
     model_to = 0;
     modelno = 0;
     strcpy(texto," ");
     strcpy(num," ");
     strcpy(num1,"");
     strcpy(num2,"");
     for ( i = 0; i < 80; i++ )
     	target[i] = '\0';

     TruePdb = FALSE ;
     Remark_Exhausted = FALSE ;
     i = k = 0;
     ModelAlreadyFound = FALSE ;

     /*
      * AverageModel is going to be the 'fake' model used to copy and move
      * models. Also it is supposed to store 'average' model, i.e. a model
      * whose coordinates are the average of all the others.
      */
     AverageModel++ ;
     actual_model = 1 ;
     
     /*
      * Scanning pdb file (counting models).
      * and making some checking at the same time
      */
     while ( fgets(line,MAXLINE,rtti) != NULL ) {
	  count_lines++ ;
	  if ( count_lines > MAXPDBLINES ) {
	       fprintf(stderr,">\n PDB_rdr: ** Warning: TOO MANY lines for one single file ** \n");
	       fprintf(stderr,"> PDB_rdr: ** either is and error or increase MAXPDBLINES [current: %6d] ** \n\n",
			       MAXPDBLINES);
	       return ; 
	  }
	  /*
	   * Check for short lines (no info) or lines that do not start with a letter 
	   * mark them as suspicious.
	   */
	  if ( (int) strlen(line) <= 2 || !isalpha(line[0]) )  {
	        count_err++;
		fprintf(stdout,"> PDB_rdr: --->>>>> **Error**  Check weird PDB line #%4d in file `%s'\n",
			   count_lines, name_of_the_file_coords);
	  }
	  sscanf(line,"%s",texto);
	  
	  /* Print first five lines to see header in file */
	  if (count_lines <= 5) {
	       printf("> PDB_rdr: >> %s",line);
	  }
	  
	  /*
	   * Current accepted keywords in PDB file. Only records with these are read in
	   * This is a very 'picky' behavior, all other records are dicarded (jumped).
	   * only s subset of all words are accepted for reading/storing, the others are
	   * graciously ignored.
	   */
	  if ( (strncmp(texto,"TITLE",4) == 0) || (strncmp(texto,"JRNL",4)   == 0) ||
	       (strncmp(texto,"KEYWDS",4) == 0) || (strncmp(texto,"REVDAT",4) == 0) ||
	       (strncmp(texto,"COMPND",4) == 0) || (strncmp(texto,"SOURCE",4) == 0) ||
	       (strncmp(texto,"HELIX",4) == 0) || (strncmp(texto,"SHEET",4)  == 0) ||
	       (strncmp(texto,"AUTHOR",4) == 0) || (strncmp(texto,"MODRES",4)  == 0) ||
	       (strncmp(texto,"EXPDTA",4) == 0) || (strncmp(texto,"REMARKS",4) == 0) || 
	       (strncmp(texto,"MODEL",5) == 0) ||  (strncmp(texto,"HEADER",4) == 0)) {
		        /* if MODEL found, do not store general header */
		        if (strncmp(texto,"MODEL",5) == 0 || ModelAlreadyFound ) { 
				ModelAlreadyFound = TRUE ;
				goto Addrecon;
			}
			recon_lines++ ;
			if ( recon_lines >= MAXREMARKRECS-1 && !Remark_Exhausted ) {
				fprintf(stdout,"\n\n  ** Warning: read_coords_pdb(): capacity for records exhausted \n");
			        fprintf(stdout,"  ** Storing only first %d record lines and continuing \n", MAXREMARKRECS-1);
				fprintf(stdout,"  ** Warning: please consider increasing MAXREMARKRECS");
				fprintf(stdout," [current: %4d] and recompiling \n\n", MAXREMARKRECS); 
				Remark_Exhausted = TRUE ;
			} 
			if ( !Remark_Exhausted ) { 
				strcpy(HeaderPdb[recon_lines], line) ;
				strcpy(HeaderPdb[recon_lines+1],"STOP");
			}
	  }
Addrecon:
	  /* strcpy(HeaderPdb[recon_lines+1],"STOP"); */

	  if ( !TruePdb )
	       if ((strncmp(texto,"ATOM",4)   == 0) || (strncmp(texto,"MODEL",4)   == 0) ||
		   (strncmp(texto,"SSBOND",4) == 0) || (strncmp(texto,"REMARKS",4) == 0) ||
		   (strncmp(texto,"CONECT",4) == 0) || (strncmp(texto,"HEADER",4)  == 0) ||
		   (strncmp(texto,"HELIX",4)  == 0) || (strncmp(texto,"SHEET",4)   == 0) ||
		   (strncmp(texto,"EXPDTA",4) == 0)) {
	 		TruePdb = TRUE ;
	       }

	  if ( !TruePdb ) {
	       printf("> PDB_rdr: *** \n");
	       printf("> PDB_rdr: *** Weird error in format ... \n");
	       printf("> PDB_rdr: *** Probably the file is *NOT* PDB format \n");
	       printf("> PDB_rdr: *** CHECK file and try again \n");
	       printf("> PDB_rdr: *** \n");
	       exit (-1); 
	  }
	  
	  /* Counting models */        
	  if (strcmp(texto,"MODEL") == 0) {
	       models++ ;
	       if (models == 2)
		    fprintf (stdout,"> PDB_rdr: Counting models in file `%s'; Model: ", name_of_the_file_coords);
	       fprintf (stdout,"%3d\b\b\b",models);
	  }
	  fflush(stdout) ;
	  
	  /*
	   * Reading Disulfide info
	   * On April 1997 the code for checking > 10 was added to avoid segmentation
	   * fault in files were the SSBOND info is written for EVERY model in the
	   * structure (generally NMR). For example 1pit.pdb from MOLMOL.
	   */
	  if ((strncmp(line,"SSBOND",6)==0) && disulfide_bonds < 21) {
	       disulfide_bonds++;
	       if (disulfide_bonds > 20) {
		    printf("> PDB_rdr: ** More disulfides than allocated (20) in file \n");
		    printf("> PDB_rdr: ** Discarding further SSBOND info in file ...  \n");
	       } else {
		    copy(temporary,line,17,21);
		    infodisu[disulfide_bonds][1]=atoi(temporary) ;
		    copy(temporary,line,31,35);
		    infodisu[disulfide_bonds][2]=atoi(temporary) ;
	       }
	  }
     }    /* --- while fgets --- */

     /* Exit if some error (blank or starting with no letter) */
     if ( count_err > 0 ) {
	     exit (-1) ;
     }
     
     i = 1;
     if (models > 1) printf("\n");
     
     /* May be the file has no word MODEL so we count at least ONE model */
     if (models <= 0) models = 1;         
     rewind(rtti);
     ModelAlreadyFound = FALSE ;
     
     printf("> PDB_rdr: After scanning there is(are) %d model(s) \n",models);
     
     /* Check if in the file are more models than allowed */
     if (MoreModelsThanAllowed(models)) {
	  printf("\n More models -%d- than allowed -%d-.\n"\
		 " You should set TOPMODELS to a greater value. \n\n",
		 models, TOPMODELS);
	  return ;
     }
     
     if (models > 1) {
     lee_de_nuevo:
	  printf("> PDB_rdr: what model do you want [(1 to %d) or all] ?_ ", models);
	  GetFromKeyBoard(num, MAXWORD, stdin);
	  sscanf(num,"%s %s",num1,num2);
	  if (strncmp(num,"exit",1)==0) 
	       return;    /* look for exit of this module */
	  model_from = atoi(num1);
	  if (strcmp(num2,"") != 0)	
	       model_to = atoi(num2) ;
	  else
	       model_to = model_from ;
	  model_wanted = model_from ;
	  modelo = model_wanted ; 
	  
	  /*
	   *   Manage multiple models
	   *   Reading multiple models in same file
	   */
	  if (strncmp(num,"all",2)==0)
	       fprintf(stdout,"> PDB_rdr: Reading *all* models in file %s\n", name_of_the_file_coords);
	  
	  if ((strncmp(num,"all",2)==0) || (model_to != model_from)) {
	       
	       if (strncmp(num,"all",2)==0)
		    fprintf(stdout,"> PDB_rdr: Reading a total of (%d) models in file\n", models);
	       
	       if (model_to != model_from)
		    fprintf(stdout,"> PDB_rdr: Reading a total of (%d) models in file\n", model_to-model_from+1);
	       
	       if (DEBUG <= 0)
		    fprintf(stdout,"> PDB_rdr: I'm reading!, model %3d", key_model); 
	       
	  lee_all:

	       ModelAlreadyFound = FALSE ;
	       if (DEBUG <= 0) 
		    if (key_model > 0) {
			 if ((key_model % ChainsInModel == 0) && (key_model > ChainsInModel))
			      fprintf(stdout,"\b\b\b\b\b\b\b\b\b\b\b\b%3d, %d chain", key_model, ChainsInModel); 
			 else if ((key_model % ChainsInModel == 0) && (key_model == ChainsInModel))
			      fprintf(stdout,"\b\b\b%3d, %d chain", key_model, ChainsInModel); 
			 else if (key_model < ChainsInModel)
			      fprintf(stdout,"\b\b\b%3d",key_model); 
			 else
			      fprintf(stdout,"\b\b\b\b\b\b\b\b\b\b\b\b%3d         ", key_model);
			 fflush(stdout);
		    }
	       if ((actual_model <= models) || (model_wanted < model_to))  goto lee;
	      
	       if (DEBUG <= 0)      /* Needed new line when writing models */ 
		    fprintf(stdout,"\n"); 
	       
	       fprintf(stdout,"\n> PDB_rdr: *** SUMMARY ***\n");
	       fprintf(stdout,"> PDB_rdr: --> %5d ATOM records read from file\n",CountRecords);
	       fprintf(stdout,"> PDB_rdr: --> %5d Regular IUPAC Atoms \n", CountIUPACAtoms);
	       fprintf(stdout,"> PDB_rdr: --> %5d Pseudo-atoms (DISMAN type) \n",CountQAtoms);
	       fprintf(stdout,"> PDB_rdr: --> %5d Lone pairs\n", CountLonePairs);
	       fprintf(stdout,"> PDB_rdr: Bye ... \n");
	       sequence_true = TRUE;
	       fflush(stdout);
	       return;
	  }
	  
	  /* Selecting and reading _only_ one model */
	  if ((atoi(num1) > models) || (atoi(num1) <= 0)) {
	       fprintf(stdout,"> PDB_rdr: *** Wanted model should be in: 1 to %2d\n",models);
	       goto lee_de_nuevo;
	  }
	  while (fgets(line,MAXLINE,rtti) != NULL) {
	       sscanf(line,"%s",texto);
	       if (strcmp(texto,"MODEL") == 0)  {
		       ModelAlreadyFound = TRUE ;
		    sscanf(line,"%*s %d",&modelno);
		    if (model_wanted == modelno) {
			 printf("> PDB_rdr: I'm reading file %s %s %5d \n", name_of_the_file_coords, texto, modelno);
			 if (model_from == model_to)
			      modelnotemp = 5432 ;
			 goto lee;
		    }
	       }
	  }
     }    /* if ( models > 1 ) */
     
     /*
      * Reading pdb file 
      * Format and explanations at right column as comments.
      * The format (in FORTRAN notation) for the whole line is:
      *    FORMAT(6A1,I5,1X,A4,A1,A3,1X,A1,I4,A1,3X,3F8.3,2F6.2,1X,I3)
      */
 lee:
   
     normal_atoms = 0;
     q_atoms = 0 ;
     lone_pairs = 0 ;
     key_model++ ;
     AverageModel++ ;
     actual_model++ ;
     total_models = key_model ;
     Remark_Model_Exhausted = FALSE ;
     
     if (DEBUG > 5) {
	  printf("\n Key_mdl: %3d, Ttl_mdls: %3d, Actl_mdl: %3d,  Rfrnc_mdl: %3d ",
		 key_model, total_models, actual_model, AverageModel);
     }
     countRes = 0 ;
     count = 1 ;  

     /* Allocate space for the model/s being read in */
     MODELS = (struct models *) realloc(MODELS, sizeof(struct models) * (AverageModel + 2)) ;
     
     Model = MODELS+key_model ;
     Model->SerialNumber = key_model ;

     for ( recon_lines = 0 ; recon_lines < MAXREMARKMODRECS; recon_lines++) 
	     strcpy(Model->HeaderPdbModel[++recon_lines],"STOP");

     recon_lines = 0 ;
     
     /*
      * Initialize number of residues of zeroth element to some really
      * strange number to avoid errors counting residues. This way numbering 
      * of residues in file is allowed to be any number I guess.
      */
     Model->PDB[0].pdb_num_res = -99999 ;
     
     /* If we are reading only one model, store model number */
     if ((strncasecmp(num,"all",2) != 0) && key_model == 1)
	  MODELS[1].modelno = modelno ;
     
     /* Get a name for the family of models */
     strcpy(Model->family, name_of_the_file_coords);
     
     while ((fgets(line, MAXLINE, rtti) != NULL ) &&
	    (line[0] >= 'A') && (line[0] <= 'Z') && (line[0] != ' ') &&
	    (line[0] != '\n') && (line[0] != '\t')) { 
	  
	  /*
	   * Store current position in file so we can get back in case
	   * we need. This has been implemented to allow for reading of
	   * more than one chain.
	   */
	  CurrentPositionInFile = ftell(rtti) ;
	  
	  At = (Model->PDB) + count ;
	  sscanf(line,"%s", At->pdb_key);      
	  
	  /* Check for alternate location data and discard B */
	  if (strcmp(At->pdb_key,"ATOM")==0 && line[16] != ' ' ) {
	       if ( line[16] == 'A' )  {
		    line[16] = ' ';
	       } else if ( line[16] == 'B' ) {
		    fprintf(stdout,"\n PDB_reader: record with alternate data, discarding it");
		    continue;
	       } else {
		    fprintf(stdout,"\n PDB_reader: some strange char in line");
	       }
	  }
	  
	  for (l = (int)strlen(At->pdb_key); l <= 7; l++)
	       At->pdb_key[l] = '\0';

	  if (modelnotemp != 5432)
	       if ((key_model >= 1) && (key_model < TOPMODELS))
		    if (strncasecmp(At->pdb_key,"MODEL",4)==0) {
			 sscanf(line,"%*s %d", &modelnotemp) ;
			 Model->modelno = modelnotemp ;
		    }
	  /*
	   * This is for our lab in Valencia. We usually put the energy in 
	   * HEADER record between parenthesis or brackets, then after a E: 
	   * a number gives the energy of that model.
	   */
	  if ((strncasecmp(line,"HEADER",3) == 0) || (strncasecmp(line,"MODEL",3) == 0)) {
	       for (i = 1; i <= (int)strlen(line); ++i) 
		    if ((line[i]=='(') || (line[i]=='['))
			 inicio = i ;
		    else if ((line[i]==')') || (line[i]==']'))
			 final = i ;
		    else if ((line[i]=='f') && (line[i+1]=='=')) {  /* For Diana */
			 diana = 1;
			 inicio = i+1;
			 final = (int)strlen(line)+1 ;
		    } else if ((line[i]=='f') && (line[i+2]=='=')) {  /* For Dyana */
			 diana = 1;
			 inicio = i+3;
			 final = (int)strlen(line)-9 ; /* Final places are for date */
		    }
	       copy(energy_temp,line,inicio+1,final-1) ;
	       if ( diana == 1)
		    sscanf(energy_temp,"%f", &Model->energy);
	       else
		    sscanf(energy_temp,"%*s %f", &Model->energy);
	  }

	  if ( ModelAlreadyFound && strncasecmp(line,"REMARK ",6)==0 ) {
		  recon_lines++ ;
		  if ( recon_lines >= MAXREMARKMODRECS-1 && !Remark_Model_Exhausted ) {
			  fprintf(stdout,"\n\n  ** Warning:  read_coords_pdb(): capacity for records exhausted \n");
			  fprintf(stdout,"  ** Storing only first %d record lines and continuing \n",
					  MAXREMARKMODRECS-1);
			  fprintf(stdout,"  ** Warning: please consider increasing MAXREMARKMODRECS");
			  fprintf(stdout," [current: %4d] and recompiling \n", MAXREMARKMODRECS); 
			  Remark_Model_Exhausted = TRUE ;
		  } 
		  if ( !Remark_Model_Exhausted ) {
		  	strcpy(Model->HeaderPdbModel[recon_lines], line) ;
		  }
	  }

	  /*
	   * To extract energy from an output of ECEPP
	   * Usually the energy record comes in REMARK record after the 
	   * word ENERGY.
	   * example:
	   * REMARK CONFORMATION    1 ENERGY-0.63177E+02 KCAL/MOLE
	   * Code added Jan, 1998. RTT
	   */
	  
	  if (strncasecmp(line,"REMARK CONFORMATION ",10) == 0) {
	       copy(energy_temp, line,31,43);
	       if (DEBUG > 0)
		    fprintf(stdout," record in ecepp file: %s\n", energy_temp);
	       sscanf(energy_temp,"%e",&Model->energy);
	  }
	  /*
	   * Extract energy from a file from CNS
	   * usually they put energy afer 'overall'
	   */
	  if (strncasecmp(line,"REMARK OVERALL = ",13) == 0) {
	       if ( (int)strlen(line) < 80 )	  
	           copy(energy_temp, line,17,(int)strlen(line));
	       else
	           copy(energy_temp, line,17,79);

	       if (DEBUG > 0)
		    fprintf(stdout," record in CNS file: %s\n", energy_temp);
	       sscanf(energy_temp,"%e",&Model->energy);
	  }
	  /*
	   * Extract energy from a file from XPLOR
	   * usually they put energy afer 'energies'
	   */
	  if (strncasecmp(line,"REMARK energies: ",13) == 0) {
	       if ( (int)strlen(line) < 80 )	  
		       copy(energy_temp, line,17,(int)strlen(line));
	       else	
		       copy(energy_temp, line,17,79);
		       
	       if (DEBUG > 0)
		    fprintf(stdout," record in CNS file: %s\n", energy_temp);
	       sscanf(energy_temp,"%e",&Model->energy);
	  }
	  /*
	   * Version that comes with XPLOR-NIH
	   */
	  if (strncasecmp(line,"REMARK          overall :",25) == 0) {
	       if ( (int)strlen(line) < 80 )	  
		       copy(energy_temp, line,25,(int)strlen(line));
	       else
		       copy(energy_temp, line,25,79);

	       if (DEBUG > 0)
		    fprintf(stdout," record in CNS file: %s\n", energy_temp);
	       sscanf(energy_temp,"%f",&Model->energy);
	  }
	  
	  /*
	   * My new version of writing XPLOR files
	   */
	  if (strncasecmp(line,"REMARK             overall :",28) == 0) {
	       if ( (int)strlen(line) < 80 )	  
		       copy(energy_temp, line,28,(int)strlen(line));
	       else
		       copy(energy_temp, line,28,79);
	       
	       if (DEBUG > 0)
		    fprintf(stdout," record in CNS file: %s\n", energy_temp);
	       sscanf(energy_temp,"%e",&Model->energy);
	  }
	  
	  if (strncasecmp(At->pdb_key,"ENDMDL",3) == 0)
	       goto fin;
	  
	  /*
	   * Take care of standard (ATOM) *only* -no standard (HETATM)- atom types
	   * The explanations about the PDB format appear as comments at the right
	   * with the right format. 
	   * The numbers in the copy are one less than in the format because in C
	   * the strings begin with zero. a[0] to a[5].
	   */	
	  if (strcmp(At->pdb_key,"ATOM")==0) {
	       
	       /* Allocate space for atom records */
	       PDB = (struct atom_pdb *) realloc(PDB, sizeof(struct atom_pdb) * (count)) ;
	       
	       /* Is there more than one chain?? */
	       copy(new_chain,line,21,21);

	       /*  1-4  ATOM    or 1-6   HETATM */
	       copy(At->pdb_key,line,0,6); 
	       for (l = (int)strlen(At->pdb_key); l <= 7; l++)
		    At->pdb_key[l] = '\0';
	       
	       /*  7-11  Atom serial no. */
	       copy(target,line,6,11);
	       At->pdb_num=count;
	       for (l = 7; l < 80; l++)
		       target[l] = '\0';
	       
	       /* 13-16  Atom name */
	       copy(At->pdb_iupac,line,12,16);     
	       for (l=(int)strlen(At->pdb_iupac);l<=5;l++)
		    At->pdb_iupac[l]='\0';
	       
	       /* 17-17  Alternate location   indicator    */
	       
	       /* 18-20  Residue name */
	       copy(At->pdb_res,line,17,19);  
	       for (l=(int)strlen(At->pdb_res);l<=4;l++)
		    At->pdb_res[l]='\0';
	       
	       /* 22-22  Chain identifier */
	       copy(At->pdb_chain_id,line,21,21);  
	       if (At->pdb_chain_id[0] == '1') strcpy(At->pdb_chain_id,"A");      
	       if (At->pdb_chain_id[0] == ' ') strcpy(At->pdb_chain_id,"A");
	       
	       /* 73-76 Segid -- segment identification*/
	       if ( (int)strlen(line) > 72 ) 
		       copy(At->segid,line,72,75);
	       
	       At->segid[4]='\0';
	       
	       /* Little hack to get chain id from segid in XPLOR files 
		* usually XPLOR writes is segid zone the code for chain id */
	       if ( XplorFmt ) {
		       At->pdb_chain_id[0] = At->segid[0];
	       }
	       
	       copy(target,line,22,26);
	       for (l = 6; l < 80; l++)
		       target[l] = '\0';
	       
	       /*
		* Sometimes we have more than one chain and people uses to type
		* A1 meaning chain A residue 1.
		*/
	       for (k = 0 ; k <= 3 ; k++) {
		    if ((target[k] == 'A') || (target[k] == 'a') ||
			(target[k] == 'B') || (target[k] == 'b') ||
			(target[k] == 'C') || (target[k] == 'c') ||
			(target[k] == 'D') || (target[k] == 'd') ||
			(target[k] == 'D') || (target[k] == 'd')) {
			 target[k] = ' ';
		    }
	       }
	       
	       At->pdb_num_res = atoi(target) ;   
	       At->pdb_num_res_orig = atoi(target) ;   
	       
	       /*===================================================*/
	       /*
		* Storing residue number and name in DIH array structure
		*/
	       if (At->pdb_num_res != Model->PDB[count-1].pdb_num_res) {
		    countRes++ ;
		    /* Allocate space for residue number */
		    DIH = (struct dihedral *) realloc(DIH,sizeof(struct dihedral)*(countRes+1)) ;
		    CountAtomRes = 1;
		    copy(Model->DIH[countRes].resname, At->pdb_res,0,2);
		    for (l=(int)strlen(Model->DIH[countRes].resname);l<=4;l++)
			 Model->DIH[countRes].resname[l]='\0';
		    /* copy(seqres[atoi(target)],At->pdb_res,0,2); */
		    copy(seqres[countRes],At->pdb_res,0,2); 
		    Model->DIH[countRes].resnumber       = atoi(target) ;
		    Model->DIH[countRes].resnumber_orig  = atoi(target) ;
		    Model->DIH[countRes].number_of_atoms = CountAtomRes ;
		    Model->DIH[countRes].orden           = countRes ;
		    At->orden              = countRes ;
		    strcpy(Model->DIH[countRes].chain_id,At->pdb_chain_id);
	       } else {
		    CountAtomRes++ ;
		    Model->DIH[countRes].number_of_atoms =  CountAtomRes ;
		    At->orden = countRes ;
	       }
	       
	       /*  27   Code for insertion   of residues */
	       
	       /*===================================================*/
	       copy(target,line,30,37); At->pdb_xcrd = atof(target);  /* 31-38 X coord  */
	       copy(target,line,38,45); At->pdb_ycrd = atof(target);  /* 39-46 Y coord  */ 
	       copy(target,line,46,53); At->pdb_zcrd = atof(target);  /* 47-54 Z coord  */

	       /* Storing properly ALL coordinates */
	       At->coord[0] = At->pdb_xcrd;
	       At->coord[1] = At->pdb_ycrd;
	       At->coord[2] = At->pdb_zcrd;
	       
	       At->pdb_oldx = At->pdb_xcrd;
	       At->pdb_oldy = At->pdb_ycrd;
	       At->pdb_oldz = At->pdb_zcrd;
	       
	       /* Right now we do nothing with the following positions on PDB record */
	       
	       /* 55-60 Occupancy */
	       
	       /* 61-66 Temperature factor */
	       
	       /* 68-70 Footnote number */
	       
	       if (strncmp(At->pdb_iupac," Q",2)==0) {
		    q_atoms++;
		    CountQAtoms++ ;
	       } else if ((strncasecmp(At->pdb_iupac," LP",3)==0) ||
			  (strncasecmp(At->pdb_iupac,"LP",2)==0)) {
		    lone_pairs++ ;
		    CountLonePairs++;
	       } else {
		    normal_atoms++;
		    CountIUPACAtoms++ ;
		    count++;           /* This only count Regular IUPAC atoms */
	       }

	       At->Changed = FALSE ;
	       CountRecords++ ;
	  }  /* if ATOM   */
     }  /* while */
     
 fin:
     MAX = count;
     Model->number_of_atoms = count - 1;
     Model->number_of_residues = MODELS->number_of_residues = countRes ;
     Model->starting_res = MODELS->starting_res = Model->PDB[1].pdb_num_res ;
     
     /* Check number of atoms and number of residues */
     if (Model->number_of_atoms > MAXATOMS) {
	  printf("> PDB_rdr: *** More atoms (%d) than allowed (%d) \n",
		 Model->number_of_atoms, MAXATOMS);
	  return;
     }
     
     if (Model->number_of_residues > MAXRESIDUES) {
	  printf("> PDB_rdr: *** More residues (%d) than allowed (%d) \n",
		 Model->number_of_residues, MAXRESIDUES);
	  return;
     }
     
     /*
      * Printing summary of records, normal IUPAC atoms, pseudo-atoms and
      * Lone Pairs in the file just read in.
      */
     if ((strncmp(num,"all",2) != 0) && (model_wanted == model_to)) {
	  if (model_wanted == model_to) printf("\n");
	  printf("> PDB_rdr: *** SUMMARY ***\n");
	  printf("> PDB_rdr: --> %5d ATOM records read from file \n", CountRecords);
	  printf("> PDB_rdr: --> %5d Regular IUPAC Atoms \n", CountIUPACAtoms);
	  printf("> PDB_rdr: --> %5d Pseudo-atoms (DISMAN type) \n",CountQAtoms);
	  printf("> PDB_rdr: --> %5d Lone pairs\n", CountLonePairs);
	  printf("> PDB_rdr: Bye ... \n");
     }
     
     /* Check PDB file looking for label errors */
     check_label_pdb(0);
     
     (void) atom_properties(key_model) ;

     /* Asking for some info about the file just read */
     if ((strncmp(num,"all",2)==0) || (model_from != model_to)) {
	  MolWeight(0);
	  CenterMass(0);
     } else {
	  printf("> =============================== INFO ================================ \n");
	  MolWeight(1);
	  CenterMass(2);
     }
     
     if ((strncmp(num,"all",2)!=0) && (model_from  == model_to)) {
	  info_res(key_model);             /* Getting info for model read in */
	  amino_codes() ;                  /* Assign all names for residues */
	  printf("> ===================================================================== \n");
     }
     
     /* Multiple models in file */
     if ((strncmp(num,"all",2)==0) || (model_wanted < model_to)) {
	  model_wanted++ ;
	  count = 0;
	  goto lee_all;
     }
     
     sequence_true = TRUE ;

     return ;
} /* end reading PDB coordinates */
