/*$Id: read_sequence.c,v 3.32 2003/10/06 12:13:32 roberto Exp roberto $*/

#include "pdbstat.h"
extern void amino_codes(void) ;

/* ========================================================================= */
int reading_sequence(FILE *rtti)
/*
  ---
  --- As now the routine is only able to read in A3 (more or less) format
  --- it should be able to read in other more free format.
  --- The program needs to know about the sequence to make some test and
  --- for certains applications
  ---
  --- (Roberto Tejero, RTT, May 1993, CABM-Rutgers University).
  ---
*/
{
  char     RESIDUES[27][4];
  int      resno=1, check=1 ; 
  int      i=1, k=1, l=0;
  char     InData[5];
  struct models *KeyMod, *Mod0, *Modi;

  i = 1;
  k = 1;
  
  Mod0 = MODELS ;

  strcpy(InData,"");
  resno = 1;
  check = 1;
  
  for (i=1; i < MAXRESIDUES; i++) strcpy(seqres[i],"   ");

  /*
   * Defining the aminoacids and special kinds
   */
  strcpy(RESIDUES[1],"ALA");
  strcpy(RESIDUES[2],"ARG");
  strcpy(RESIDUES[3],"ASN");
  strcpy(RESIDUES[4],"ASP");
  strcpy(RESIDUES[5],"CYS");
  strcpy(RESIDUES[6],"GLN");
  strcpy(RESIDUES[7],"GLU");
  strcpy(RESIDUES[8],"GLY");
  strcpy(RESIDUES[9],"HIS");
  strcpy(RESIDUES[10],"ILE");
  strcpy(RESIDUES[11],"LEU");
  strcpy(RESIDUES[12],"LYS");
  strcpy(RESIDUES[13],"MET");
  strcpy(RESIDUES[14],"PHE");
  strcpy(RESIDUES[15],"PRO");
  strcpy(RESIDUES[16],"SER");
  strcpy(RESIDUES[17],"THR");
  strcpy(RESIDUES[18],"TYR");
  strcpy(RESIDUES[19],"TRP");
  strcpy(RESIDUES[20],"VAL");
  strcpy(RESIDUES[21],"ORN");
  strcpy(RESIDUES[22],"GLX"); 
  strcpy(RESIDUES[23],"ASX");
  strcpy(RESIDUES[24],"LYP"); /* special case for 22 peptide */
  strcpy(RESIDUES[25],"APP"); /* special case for 22 peptide */

  /*
   * Reading in free format (I hope!) the sequence file or any
   * ordered list of residues
   */
  fprintf(stdout,">READ_sequence: Starting residue number [def:1] ?_: ");
  GetFromKeyBoard(InData, MAXWORD, stdin);
  if (strcmp(InData,"")!=0)  resno = atoi(InData);
  Mod0->starting_res = resno;

  fprintf(stdout,">READ_sequence: Starting at residue number %d\n",Mod0->starting_res);
  
  while (fgets(line,MAXLINE,rtti) != NULL) {
    if (DEBUG > 6) fprintf(stdout,"READ_SEQ.debug: ** %s **",line);
    check++;
    if (check > 5000)  {
      fprintf(stderr," >READ_sequence: *** Better check sequence file \n");
      return 0 ;
    }
    
    /*
     * Here should go a mild check of input to detect weird lines
     * in file and doing so avoid the awful core dumped.
     * Also must be improved to read in free (more or less) format
     */
    i = 0;
    while ((line[i] != '\n') && (i <= (int)strlen(line) - 2)) {
      /*
       * We throw away the letter F (and f) as there is NO residue
       * beginning with that letter right now. If we have a residue
       * beginning with that letter you need to fix the code, buddy!
       */
      if ((((line[i] >= 'A') && (line[i] <= 'Z') && (line[i-1] != 'F') && (line[i-1] != 'T')) ||
	   ((line[i] >= 'a') && (line[i] <= 'z') && (line[i-1] != 'f') && (line[i-1] != 't'))) &&
	  ((line[i+3] == ' ') || (line[i+3] == '\n'))) {
	copy(seqres[resno],line,i,i+2);
	for (l=(int)strlen(seqres[resno]);l<=5;l++) seqres[resno][l]='\0';
      }
      for (k = 1 ; k <= 25 ; k++) {
	if (strncmp(seqres[resno],RESIDUES[k],3)==0) {
	  resno++;
	  DIH = (struct dihedral *) realloc(DIH,sizeof(struct dihedral)*(resno+1));
	}
      }
      i++;
    }
  }
  
  Mod0->number_of_residues = resno - (Mod0->starting_res) + 1;
  
  if (constraintcount > 1)
    for (i = 1 ; i <= constraintcount; i++) {
      if ((NOE[i].residue_number1 > MAXRESIDUES || NOE[i].residue_number2 > MAXRESIDUES)) {
	printf ("> READ_seq: * Something incongruent in constr file?!, BUDDY \n");
	printf ("> READ_seq: * residue number .GT. MAXIMUM allowed RESIDUES \n");
	printf ("> READ_seq: * can you believe that? .....\n");
	printf ("> READ_seq: -> Better check line %d (res. %d or %d) in constr. file \n",
		i + NOE[i].residue_number1, NOE[i].residue_number1, NOE[i].residue_number2);
	return 0 ;
      }
      copy(NOE[i].residue_type1,seqres[NOE[i].residue_number1],0,2);
      copy(NOE[i].residue_type2,seqres[NOE[i].residue_number2],0,2);   
      for (l=(int)strlen(NOE[i].residue_type1);l<=5;l++) NOE[i].residue_type1[l]='\0';
      for (l=(int)strlen(NOE[i].residue_type2);l<=5;l++) NOE[i].residue_type2[l]='\0';
    }
  
  /*
   * Messy code from the past to store info in the structures
   * Key_model has been changed to zero.
   */
  key_model = 0;
  KeyMod = MODELS+key_model ;
  
  MAX = KeyMod->number_of_atoms + 1;
  
  if (MAX > 0) {
    for (i = 1 ; i <= total_models ; i++) {
      Modi = MODELS+i ;
      Modi->starting_res = Mod0->starting_res ;
      Modi->number_of_residues = resno - (Mod0->starting_res);
      for (k = 1 ; k <= Modi->number_of_residues ; k++) {
	copy(Modi->DIH[k].resname, seqres[k+(Mod0->starting_res)-1],0,2);
	for (l=(int)strlen(Modi->DIH[k].resname);l<=5;l++) Modi->DIH[k].resname[l]='\0';
      }
    }
    
    for (i = 0 ; i < MAX ; i++) {
      copy(KeyMod->PDB[i].pdb_res, seqres[KeyMod->PDB[i].pdb_num_res],0,2);
      for (l=(int)strlen(KeyMod->PDB[i].pdb_res);l<=5;l++) KeyMod->PDB[i].pdb_res[l]='\0';
    }
  }
  
  for (k = 1 ; k <= Mod0->number_of_residues ; k++) {
    copy(Mod0->DIH[k].resname, seqres[k],0,2);
    for (l=(int)strlen(Mod0->DIH[k].resname);l<=5;l++) Mod0->DIH[k].resname[l]='\0';
  }

  amino_codes();
  
  /*
   * Writing the whole sequence 
   */
  printf("> SEQ_rdr: ");
  for (i = 1 ; i < resno ;i++) {
    printf("%s ",seqres[i]);
    if (fmod(i,10)==0) printf("\n> SEQ_rdr: ");
  }
  
  printf("\n> SEQ_rdr: %d residues have been read. Returning to menu \n", resno-(Mod0->starting_res));
  sequence_true = TRUE ;
  return (resno - (Mod0->starting_res));
}
