/*$Id: reading_all.c,v 3.32 2003/10/06 12:13:32 roberto Exp roberto $*/

#include "pdbstat.h"
#include "Tokens.h"

extern int GetToken(char Command[MAXWORD]);
extern void amino_codes(void) ;
extern void init_dihedrals(void) ;
extern void atom_properties(int Model) ;
extern int GetLibraryData(FILE *InputFile) ;      
extern FILE *libfopen(char *, char *);
extern void AssignSequenceNameToNOE(void) ;
extern void AssignLibraryNames(struct noe *Puntero,int LibRecords,int option, char KeyAss[5]) ;
extern void CheckLibraryNames(int LibRecords,int option, int from) ; 
extern char IsThereSequence(void) ;
  
extern struct Library *Lib;
extern int MaxLib ;

/* extern register int comp; */

/* ========================================================================= */
void reading(char what[20], char tipo[20], char nombre[MAXWORD])
/*
  ---
  --- Module in charge of reading different things. 
  ---
  --- (Roberto Tejero, RTT, May 1993, CABM-Rutgers University).
  ---
*/
{
     FILE   *LibFile ;
     int     i, LibRecords, currnoe, curraco;
     
     while ( GetToken(what) != FIN ) {
	  switch ( GetToken(what) ) {
	  case (UNKNOWN):
	       printf("> READER: Coords, constraints, aco or sequence file? :_ ");
	       GetFromKeyBoard(what, MAXWORD, stdin);
	       do_lower_case(what);
	       break ;      
	  case (ACO):  /* Angle constraint file */
	       curraco = acocount ;
	       if (tipo[0] == '\0') {
		    printf("> RDR_aco: Format(congen|diana|xplor|cns)? : ");
		    GetFromKeyBoard(tipo, MAXWORD, stdin);
		    do_lower_case(tipo);
	       }
	       strcat(history[count_history]," constraints");
	       switch ( GetToken(tipo) ) {
	       case (DIANA):
		    strcat(history[count_history]," diana ");
		    option = 8;
		    break ;
	       case (CYANA):
		    strcat(history[count_history]," cyana ");
		    option = 8;
		    break ;
	       case (DYANA):
		    strcat(history[count_history]," dyana ");
		    option = 8;
		    break ;
	       case (CONGEN):
		    strcat(history[count_history]," congen ");
		    option = 9;
		    break ;
	       case (XPLOR):
		    strcat(history[count_history]," xplor ");
		    option = 10;
		    break ;
	       case (CNS):
		    strcat(history[count_history]," cns ");
		    option = 10;
		    break ;
	       case (ECEPP):
		    strcat(history[count_history]," ecepp ");
		    option = 20;
		    break ;
	       default:
		    printf("\n> READING_all: *Format `%s' is *NOT* implemented \n",tipo);
		    printf("> RDR_cnstr: Format(congen/discover/impact/disman/diana)? : ");
		    GetFromKeyBoard(tipo, MAXWORD, stdin);
		    do_lower_case(tipo);
		    continue ;
	       }
	       if (locate_file(nombre) == 0) return;
	       else {
		    if ( !sequence_true ) {
			 fprintf(stderr,"\n> reading_all(): * First you *HAVE TO* read a sequence file ");
			 return ;
		    }
		    lee = 1;
		    key_model = 0;
		    readwrite(fpi,TRUE,TRUE);    /* reading of constraint file */
		    fclose(fpi);
		    strcpy(name_of_the_file_aco, name_of_the_file);
		    
		    if ( ConsTrue && !AlreadyAssignedNoes ) {
			 if (Lib == NULL) {  /* Load Library Data */
			      LibFile = libfopen("GenCons.Lib","r");
			      LibRecords=GetLibraryData(LibFile);
			      fclose(LibFile);
			 } else
			      LibRecords = MaxLib ;
			 
			 lee=0;
			 /* ACO -- Assign Library names to each atom 
			  * in ACO constraints it is simpler as DISMAN=DIANA=DYANA
			  */
			 if ( option ==  9 ) option = 1; /* CONGEN */
			 if ( option ==  8 ) option = 3; /* DISMAN, DIANA, DYANA */
			 if ( option == 10 ) option = 6; /* XPLOR */
			 if ( option == 20 ) option = 8; /* ECEPP assign lib */
			 if (DEBUG > 0 ) printf("> reading_all: .. assigning residue names after ACO \n");
			 if (acocount >= 1) {
			      AssignSequenceNameToNOE() ;
			      CheckLibraryNames(LibRecords,option,curraco) ;
			      /* assign the different atom names, X-PLOR, DIANA, CONGEN, etc. */
			      for (i = 1; i <= acocount-1; i++) 
				   AssignLibraryNames(&NOE[i],LibRecords,option,"NMR");
			 }
		    }
	       }
	       strcpy(what,"exit");
	       break;
	  case (LOL):
	  case (UPL):
	  case (NOES):
	       currnoe = constraintcount ;
	       if (tipo[0] == '\0') {
		    printf("> RDR_cnstr: Format(congen|discover|impact|disman|diana|dyana|xplor|cns)? : ");
		    GetFromKeyBoard(tipo, MAXWORD, stdin);
		    do_lower_case(tipo);
	       }
	       strcat(history[count_history]," constraints");
	       switch ( GetToken(tipo) ) {
	       case (CONGEN):
		    strcat(history[count_history]," congen ");
		    option = 1;
		    break ;
	       case (DISMAN):
		    strcat(history[count_history]," disman ");
		    switch ( GetToken(what) ) {
		    case NOES:
		    case UPL:
			 option = 2;
			 break;
		    case LOL:
			 option = 21;
			 break;
		    default:
			 fprintf(stderr,"\n\n Error (9002) \n");
			 exit (-1);
			 break;
		    }
		    break;
	       case (DYANA):
		    strcat(history[count_history]," dyana ");
		    switch ( GetToken(what) ) {
		    case NOES:
		    case UPL:
			 option = 3;
			 break;
		    case LOL:
			 option = 31;
			 break;
		    default:
			 fprintf(stderr,"\n\n Error (9003) \n");
			 exit (-1);
			 break;
		    }
		    break ;
	       case (DIANA):
	       case (CYANA):
		    strcat(history[count_history]," diana ");
		    switch ( GetToken(what) ) {
		    case NOES:
		    case UPL:
			 option = 300;
			 break;
		    case LOL:
			 option = 301;
			 break;
		    default:
			 fprintf(stderr,"\n\n Error (9003) \n");
			 exit (-1);
			 break;
		    }
		    break ;
	       case (IMPACT):
		    strcat(history[count_history], " impact ");
		    option = 4;
		    break;
	       case (DISCOVER):
		    strcat(history[count_history]," discover ");
		    option = 5;
		    break ;
	       case (CNS):
	       case (XPLOR):
		    strcat(history[count_history]," xplor|cns ");
		    option = 6;
		    break ;
	       case (ECEPP):
		    strcat(history[count_history]," ecepp ");
		    option = 205;
		    break ;
	       case (FIN):
		    strcat(history[count_history]," *** exit *** ");
		    break ;
	       default:
		    printf("\n> READING_all: ** Format `%s' is UNKNOWN or *NOT* implemented ",tipo);
		    printf("\n> READING_all: -- Please give one of the formats named in the line below\n");
		    printf("> RDR_cnstr: Format(congen|discover|impact|disman|diana|dyana|xplor|cns)? : ");
		    GetFromKeyBoard(tipo, MAXWORD, stdin);
		    do_lower_case(tipo);
		    continue ;
	       }    
	       if (locate_file(nombre) == 0) return;
	       else {
		    if ( !sequence_true ) {
			 printf("\n> reading_all(): * First you *HAVE TO* read a sequence file ");
			 return ;
		    }
		    
		    lee=1;
		    key_model = 0;
		    readwrite(fpi,TRUE,TRUE);    /* reading of constraint file */
		    fclose(fpi);
		    strcpy(name_of_the_file_constr, name_of_the_file);
		    
		    if (Lib == NULL) {  /* Load Library Data */
			 if (DEBUG > 0) 
			      printf("> reading_all(): .. Opening Library Data ..\n");
			 LibFile = libfopen("GenCons.Lib","r");
			 if (DEBUG > 0) printf("> reading_all: .. Getting Library Data ..\n");
			 LibRecords=GetLibraryData(LibFile);
			 if (DEBUG > 0) printf("> reading_all: .. Closing Library Data ..\n");
			 fclose(LibFile);
		    } else
			 LibRecords = MaxLib ;
		    
		    lee=0;
		    /* Assigning library names to each atom 
		     * This is rather complicated as over time the name conventions have
		     * changed from DISMAN to DIANA and then to DYANA.
		     * Option 200 is for a file with DIANA format records and DISMAN atom names
		     */
		    if ( option ==  31 ) option =   3; /* DYANA,CYANA */
		    if ( option ==  21 ) option =   2; /* DISMAN */
		    if ( option == 301 ) option = 300; /* DIANA  */
		    if ( option == 205 ) option =   8; /* ECEPP assign lib */
		    if (DEBUG > 0 ) printf("> reading_all: .. assigning residue names \n");
		    if (constraintcount >= 1) {
			 AssignSequenceNameToNOE() ;
			 CheckLibraryNames(LibRecords,option,currnoe) ;
			 /* assign the different atom names, X-PLOR, DIANA, CONGEN, etc. */
			 if (DEBUG > 0 ) 
			      printf("> reading_all: .. assigning library names \n");
			 for (i = 1; i <= constraintcount; i++)
			      AssignLibraryNames(&NOE[i],LibRecords,option,"NMR");
		    }
	       }
	       strcpy(what,"exit");
	       break;
	  case (COORDINATES):
	       strcat(history[count_history]," coordinates ");
	       if ( (tipo[0] == '\0') || (strcmp(tipo,"unknown")==0) ) {
		    printf("> CRD_rdr: File type (pdb/disman/congen/charmm/insight) ? : ");
		    GetFromKeyBoard(tipo, MAXWORD, stdin);
		    do_lower_case(tipo);
	       }
	       switch ( GetToken(tipo) ) {
	       case (FIN):
		    strcat(history[count_history]," *** exit *** ");
		    strcpy(what,"exit");
		    return ;
	       case (XPLOR):
	       case (PDBFORMAT):
		    if (strncasecmp(tipo,"xpdb",3)==0) {
			 XplorFmt = TRUE;
			 strcat(history[count_history],"xpl ");
		    } else {
			 strcat(history[count_history],"pdb ");
		    }
		    if (locate_file(nombre) == 0) return ;
		    else {
			 strcpy(name_of_the_file_coords,name_of_the_file);
			 read_coords_pdb(fpi);
			 fclose(fpi);
			 amino_codes() ;
			 init_dihedrals() ;
			 /* atom_properties() ; */
			 strcpy(what,"exit");
			 break;
		    }
		    /* break; */
	       case (DISMAN):
		    strcat(history[count_history],"disman ");
		    if (locate_file(nombre) == 0) return;
		    else {
			 strcpy(name_of_the_file_coords, name_of_the_file);
			 read_coords_disman(fpi);
			 fclose(fpi);
			 amino_codes() ;
			 init_dihedrals() ;
			 /* atom_properties() ;  */
			 strcpy(what,"exit");
			 break;	
		    }
		    /*	break; */
	       case (CONGEN):
	       case (CHARMM):
		    switch ( GetToken(tipo) ) {
		    case (CONGEN):
			 strcat(history[count_history],"congen ");
		    case (CHARMM):
			 strcat(history[count_history],"charmm ");
		    default:
			 break ;
		    }
		    if (locate_file(nombre) == 0) return;
		    else {
			 strcpy(name_of_the_file_coords, name_of_the_file);
			 read_coords_congen(fpi);
			 fclose(fpi);
			 amino_codes() ;
			 init_dihedrals() ;
			 /* atom_properties() ;  */
			 if (DEBUG > 0) printf("> READER_drv: Going back to MAIN ... \n");
			 fflush(stderr) ;
			 fflush(stdout) ;
			 strcpy(what,"exit");
			 break;
		    }
		    /*	break; */
	       case (INSIGHT):
	       case (DISCOVER):
		    strcat(history[count_history],"insight ");
		    if (locate_file(nombre) == 0) return;
		    else {
			 strcpy(name_of_the_file_coords, name_of_the_file);
			 read_coords_insight(fpi);
			 fclose(fpi);
			 amino_codes() ;
			 init_dihedrals() ;
			 /* atom_properties() ; */
			 if (DEBUG > 0) printf("> READER_drv: Going back to MAIN ... \n");
			 fflush(stderr);
			 fflush(stdout);
			 strcpy(what,"exit");
			 break;	
		    }
	       case (UNKNOWN):
	       default:
		    printf("> CRD_rdr: *FORMAT* `%s' *NOT* available \n", tipo);
		    printf("> CRD_rdr: File type (pdb/disman/congen/charmm/insight) ? : ");
		    GetFromKeyBoard(tipo, MAXWORD, stdin);
		    do_lower_case(tipo);
		    break;
	       }
	       break;
	  case (JCOUP):
	       strcat(history[count_history]," J Coupling ");
	       option = 50;
	       lee = 1 ;
	       if (locate_file(nombre) == 0) return;
	       else {
		    key_model = 1 ;
		    readwrite(fpi,TRUE,TRUE);
		    fclose(fpi);
		    strcpy(what,"exit");
		    break ;	
	       }
	  case (SEQUENCE):
	       strcat(history[count_history]," sequence ");
	       if (locate_file(nombre) == 0) return;
	       else {
		    strcpy(name_of_the_file_sequence, name_of_the_file);
		    key_model = 1 ;
		    MODELS[key_model].number_of_residues = reading_sequence(fpi);
		    sequence_true = TRUE ;
		    fclose(fpi);
		    amino_codes() ;
		    strcpy(what,"exit");
		    break ;	
	       }
	       /*      break ; */
	  case (FIN):
	       strcat(history[count_history]," *** exit *** ");
	       strcpy(what,"exit");
	       break ;
	  default:
	       printf("> READER: *Read Option* `%s' *NOT* available \n", what);
	       printf("> READER: Coords, constraints, aco or sequence file? :_ ");
	       GetFromKeyBoard(what, MAXWORD, stdin); 
	       strcpy(tipo,"");
	       break ;
	  }
	  continue ;
     }
     return ;
}
