/*$Id: readwrite.c,v 3.32 2003/10/06 12:13:32 roberto Exp roberto $*/

#include "pdbstat.h"
extern void write_constraints_diana(FILE *rtto) ;
extern void write_constraints_diana_lol(FILE *rtto) ;
extern void write_constraints_dyana(FILE *rtto) ;
extern void write_constraints_dyana_lol(FILE *rtto) ;
extern void write_constraints_charmm(FILE *rtto) ;
extern void write_constraints_ecepp(FILE *rtto) ;
extern int  read_jcoup_diana(FILE *InputFile);

/* ========================================================================= */
void readwrite(FILE *entrasale, char WriteUPL, char WriteLOL)
/*
  ---
  --- (Roberto Tejero, RTT, May 1993, CABM-Rutgers University).
  ---
*/
{
  switch (option)  {
  case 1 :
    if (lee == 1)	{
      printf("\n> CNSTR_rdr: Converting congen input file \n");
      kount_dist = read_constraints_congen(entrasale);
      printf("\n> CNSTR_rdr:  %4d constraints read \n",kount_dist);
    }
    if (escribe == 1) write_constraints_congen(entrasale);
    break;
    
  case 2 :
    if (lee == 1) {
      printf("\n> CNSTR_rdr:  Converting disman UPL input file \n");
      kount_dist = read_upl_disman(entrasale,"disman","upl");
      printf("\n> CNSTR_rdr:  %4d constraints read \n",kount_dist);
    }
    if (escribe == 1) 
	    write_constraints_disman(entrasale);
    break;

  case 20 :
    if (lee == 1) {
      printf("\n> CNSTR_rdr:  Converting ECEPP constraint file \n");
      kount_dist = read_constraints_ecepp(entrasale);
      printf("\n> CNSTR_rdr:  %4d constraints read \n",kount_dist);
    }
    if (escribe == 1) 
	    write_constraints_ecepp(entrasale);
    break;

  case 21 :
    if (lee == 1) {
      printf("\n> CNSTR_rdr:  Converting disman LOL input file \n");
      kount_dist = read_lol_disman(entrasale,"disman","lol");
      printf("\n> CNSTR_rdr:  %4d constraints read \n",kount_dist);
    }
    if (escribe == 1) 
	    write_constraints_disman(entrasale);
    break;
    
  case 3 :
    if (lee == 1) {
      printf("\n> CNSTR_rdr:  Converting DYANA UPL input file \n");
      kount_dist = read_upl_disman(entrasale,"diana","upl");
      printf("\n> CNSTR_rdr:  %4d constraints read \n",kount_dist);
    }
    if (escribe == 1) {
       write_constraints_dyana(entrasale);
       if ( WriteLOL )
       		write_constraints_dyana_lol(entrasale); 
    }
    break;

  case 31 :
    if (lee == 1) {
      printf("\n> CNSTR_rdr:  Converting DYANA LOL input file \n");
      kount_dist = read_lol_disman(entrasale,"diana","lol");
      printf("\n> CNSTR_rdr:  %4d constraints read \n",kount_dist);
    }
    if (escribe == 1) {
       /* write_constraints_dyana(entrasale); */
       write_constraints_dyana_lol(entrasale);
    }
    break;
    
  case 300 :
    if (lee == 1) {
      printf("\n> CNSTR_rdr:  Converting DIANA UPL input file \n");
      kount_dist = read_upl_disman(entrasale,"diana","upl");
      printf("\n> CNSTR_rdr:  %4d constraints read \n",kount_dist);
    }
    if (escribe == 1) {
       write_constraints_diana(entrasale);
       if (WriteLOL)
       		write_constraints_diana_lol(entrasale); 
    }
    break;

  case 301 :
    if (lee == 1) {
      printf("\n> CNSTR_rdr:  Converting DIANA LOL input file \n");
      kount_dist = read_lol_disman(entrasale,"diana","lol");
      printf("\n> CNSTR_rdr:  %4d constraints read \n",kount_dist);
    }
    if (escribe == 1) {
       /* write_constraints_diana(entrasale); */
       write_constraints_diana_lol(entrasale);
    }
    break;
    
  case 4:
    if (lee == 1) {
      printf("\n> CNSTR_rdr:  Converting impact input file \n");
      kount_dist = read_constraints_impact(entrasale);
      printf("\n> CNSTR_rdr:  %4d constraints read \n",kount_dist);
    }
    if (escribe == 1) write_constraints_impact(entrasale);
    break;
    
  case 5:
    if (lee == 1) {
      printf("\n> CNSTR_rdr:  Converting discover input file \n");
      kount_dist = read_constraints_discover(entrasale);
      printf("\n> CNSTR_rdr:  %4d constraints read \n",kount_dist);
    }
    if (escribe == 1) write_constraints_discover(entrasale);
    break;
    
  case 6:
    if (lee == 1) {
      kount_dist = read_constraints_xplor(entrasale) - acocount ;
      printf("   %5d TOTAL constraints read \n", kount_dist + acocount);
    }
    if (escribe == 1) write_constraints_xplor(entrasale);
    break;
    
  case 7:
    if (lee == 1) {
      printf("\n> CNSTR_rdr: **** NOT YET DEVELOPPED !!\n");
    }
    if (escribe == 1) write_constraints_charmm(entrasale);
    break;

  case 8:
    if (lee == 1) {
      printf("\n> CNSTR_rdr:  Reading DIANA or DYANA ACO file \n");
      kount_dist = read_aco_dyana(entrasale);
      printf("\n> CNSTR_rdr:  %4d constraints read \n",kount_dist);
    }
    break;

  case 9:
    if (lee == 1) {
      printf("\n> CNSTR_rdr:  Reading CONGEN ACO file ... ");
      kount_dist = read_aco_congen(entrasale);
      printf(" %4d constraints read \n",kount_dist);
    }
    break;

  case 10:
    if (lee == 1) {
      kount_dist = read_constraints_xplor(entrasale);
      printf("   %5d TOTAL constraints read \n",kount_dist);
    }
    break;

  case 50:
    if (lee == 1) {
      kount_jcoup = read_jcoup_diana(entrasale);
      printf("\n   %5d JCOUP constraints in DYANA format read \n",kount_jcoup);
    }
    break;

  default :
    printf("> CNSTR_rdr: We *never* should get here, please report this!, Err31416 \n");
    exit(-1);
    break;
  }
  if (DEBUG > 0) fprintf(stderr,"\n" );  
  return ;
}

