/*$Id: write_constraints.c,v 3.32 2003/10/06 12:13:32 roberto Exp roberto $*/

#include "pdbstat.h"
static int i;


/* ========================================================================= */
void write_aco(FILE *rtto, int option) 
{
  static struct aco *Aco ;
  static short Angle ;
  
  Aco = ACO+1 ;
  switch (option) {
  case 1:   /* Congen format */
    fprintf(rtto,"!\n! ACO file produced by PDBStat");
    fprintf(rtto,"\n! Version: %s\n!", VERSION) ;
    fprintf(rtto,"\n") ;
    while (Aco->next != NULL) {
      if (strncmp(Aco->Atom1,"C-",2)==0) strcpy(Aco->Atom1,"C");
      fprintf(rtto," CONS DIHE %2s %3d %-4s : ", Aco->chain_id, Aco->Res1, Aco->Atom1);
      fprintf(rtto," %2s %3d %-4s : ", Aco->chain_id, Aco->Res2, Aco->Atom2);
      fprintf(rtto," %2s %3d %-4s : ", Aco->chain_id, Aco->Res3, Aco->Atom3);
      if (strncmp(Aco->Atom4,"N+",2)==0) strcpy(Aco->Atom4,"N");
      fprintf(rtto," %2s %3d %-4s ", Aco->chain_id, Aco->Res4, Aco->Atom4);
      fprintf(rtto," FORCE 100.0 MIN %8.2f MAX %8.2f\n", Aco->AngleMin, Aco->AngleMax);
      Aco++;
    }
    break ;
  case 2:    /* disman */
  case 3:    /* diana, dyana, cyana */
    fprintf(rtto,"#--\n#--  Torsion Angle Constraints\n#--  ACO file produced by PDBStat\n#--  Version: %s\n#--\n", VERSION);
    while (Aco->next != NULL) {
      fprintf(rtto," %3d %-6s%-6s", Aco->residue_number, Aco->residue_type, Aco->AngleName);
      fprintf(rtto,"%7.1f %7.1f %4.2f\n", Aco->AngleMin, Aco->AngleMax, Aco->Weight);
      Aco++;
    }
    break ;
  case 4:    /* Impact */
    while (Aco->next != NULL) {
      fprintf(rtto,"  assign (resid %3d and name %-4s)", Aco->residue_number, Aco->Atom1);
      fprintf(rtto,"  (resid %3d and name %-4s)", Aco->residue_number, Aco->Atom2);
      fprintf(rtto,"  (resid %3d and name %-4s)", Aco->residue_number, Aco->Atom3);
      fprintf(rtto,"  (resid %3d and name %-4s)", Aco->residue_number, Aco->Atom4);
      fprintf(rtto,"   1  %8.2f %8.2f  2\n", Aco->AngleMin, Aco->AngleMax);
      Aco++;
    }
    break ;
  case 5:    /* X-Plor */
  case 6:    /* CNS */
    fprintf(rtto,"!\n! ACO file produced by PDBStat");
    fprintf(rtto,"\n! Version: %s\n!", VERSION) ;
    fprintf(rtto,"\n") ;
    fprintf(rtto," dihedral\n");
    while ( Aco->next != NULL ) {
      if (strncmp(Aco->Atom1,"C-",2)==0) strcpy(Aco->Atom1,"C");
      fprintf(rtto,"   assign (resid %3d and name %-4s)", Aco->Res1, Aco->Atom1);
      fprintf(rtto,"   (resid %3d and name %-4s)\n", Aco->Res2, Aco->Atom2);
      fprintf(rtto,"          (resid %3d and name %-4s)", Aco->Res3, Aco->Atom3);
      if (strncmp(Aco->Atom4,"N+",2)==0) strcpy(Aco->Atom4,"N");
      fprintf(rtto,"   (resid %3d and name %-4s)", Aco->Res4, Aco->Atom4);
      fprintf(rtto,"   %2.1f  %8.2f %8.2f   2 \n", Aco->Weight, Aco->AngleEq, Aco->AngleRg);
      Aco++;
    }
    fprintf(rtto," end\n");
    break ;
  case 7:     /* Charmm */
    while (Aco->next != NULL) {
      fprintf(rtto,"  assign (resid %3d and name %-4s)\n", Aco->Res1, Aco->Atom1);
      fprintf(rtto,"         (resid %3d and name %-4s)\n", Aco->Res2, Aco->Atom2);
      fprintf(rtto,"         (resid %3d and name %-4s)\n", Aco->Res3, Aco->Atom3);
      fprintf(rtto,"         (resid %3d and name %-4s) ", Aco->Res4, Aco->Atom4);
      fprintf(rtto,"  1 %8.2f %8.2f 2\n", Aco->AngleMin, Aco->AngleMax);
      Aco++;
    }
  case 8:     /* Ecepp */
    fprintf(rtto,"!\n! ACO file produced by PDBStat\n!\n");
    /* 
     * ECEPP always add a residue at the beginning and another at end
     * so residue number must be incremented by adding one
     */
    while (Aco->next != NULL) {
      if (strcasecmp(Aco->AngleName,"PHI")==0) 
	    Angle=1;
      else if (strcasecmp(Aco->AngleName,"PSI")==0) 
	    Angle=2;
      fprintf(rtto,"DIHEDRAL %4d %9d  %8.2f  %8.2f  1000.0 \n", 
	 Aco->residue_number+1, Angle, Aco->AngleEq, Aco->AngleRg);
      Aco++;
    }
    break ;
  default:
    fprintf(stderr,"\n Internal error in code (2356)\n");
    exit (-2356) ;
    break ;
  }
  fflush(stdout);
  fflush(stderr);
  fflush(rtto);
  return ;
}
		
/* ========================================================================= */
void write_constraints_ecepp(FILE *rtto)
/*
 * Write constraints in ECEPP format for eceppak program 
 * There are been a lot of changes in eceppak and also a slight
 * bug that this code takes into account, when writing the AC)
 * file DIHEDRAL is added at the very beginning of each line. This 
 * was not needed in previous eceppak versions. 
 */
{
     /*
       i           1   1 CA      1  29 CA      7.186   7.942  10.000
       i           1   2 CA      1   3 CA      3.615   3.996  10.000
       i           1   2 CA      1   4 CA      6.362   7.032  10.000
     */
     static struct noe *Noe ;
     static int Mol = 1;
     
     fprintf(rtto,"! Distance bounds written by PDBStat\n");
     fprintf(rtto,"! %4d  -- distance bounds written\n", constraintcount);
     Noe = NOE + 1;
     while ( Noe->next != NULL) {
	  if ( !Noe->ToPrint ) {
	       Noe++ ;
	       continue ;
	  }
	  /*
	   * ECEPP always add a residue at the beginning and other at the 
	   * end so the residue numbers must be incremented by adding one
	   */
	   fprintf(rtto," %11d %3d %-4s %4d %3d %-4s  %7.3f %7.3f %7.3f \n",
	       Mol, Noe->residue_number1+1, Noe->Atom1Ecepp, 
	       Mol, Noe->residue_number2+1, Noe->Atom2Ecepp,
	       Noe->lower, Noe->upper, 20.0);
	  Noe++ ;
     }
     if (AcoTrue) write_aco(rtto,8);
     fflush(rtto);
     return ;
}

/* ========================================================================= */
void write_constraints_xplor(FILE *rtto)
/*
  ---
  --- (Roberto Tejero, RTT, June 1993, CABM-Rutgers University).
  ---
*/
{
  static float    minus, plus;
  static char     xpl_tmp[MAXWORD];
  static struct noe *Noe ;

  minus = 0.0;
  plus = 0.0;
  
  printf("\n> XPLOR_writer: percentage range for upper bound (upp+range)?: ");
  GetFromKeyBoard(xpl_tmp,MAXWORD,stdin);
  plus = atof(xpl_tmp)/100.0;
  
  printf("> XPLOR_writer: range for lower bound (low-range)?: ");
  GetFromKeyBoard(xpl_tmp,MAXWORD,stdin);
  if (strncasecmp(xpl_tmp,"vdw",3)!=0) minus = atof(xpl_tmp);
  
  printf("> XPLOR_writer: ... writing ... wait \n");
  Noe = NOE + 1 ;

  while ( Noe->next != NULL ) {
       if ( !Noe->ToPrint ) {
	     Noe++ ;
	     continue ;
       }
       if (strncasecmp(xpl_tmp,"vdw",3)==0) Noe->rglow = Noe->upper - 1.8;
       if (strncasecmp(xpl_tmp,"0.0",3)==0) Noe->rglow = Noe->upper ;
       if ( plus != 0.0 ) 
	    Noe->rgupp = Noe->equil * plus ;
       if ( Noe->chain_id_1[0] != ' ' && Noe->chain_id_2[0] != ' ') {
	    fprintf(rtto," assign (segid %2s and resid %3d and name %-5s)"
		    " (segid %2s and resid %3d and name %-5s) %5.2f %5.2f %5.2f\n",
		    Noe->chain_id_1, Noe->residue_number1, Noe->Atom1Xplor, 
		    Noe->chain_id_2, Noe->residue_number2, Noe->Atom2Xplor,
		    Noe->equil, Noe->rglow, Noe->rgupp);
       } else {
	    fprintf(rtto," assign (resid %3d and name %-5s)"
		    " (resid %3d and name %-5s) %5.2f %5.2f %5.2f\n",
		    Noe->residue_number1, Noe->Atom1Xplor, 
		    Noe->residue_number2, Noe->Atom2Xplor,
		    Noe->equil, Noe->rglow, Noe->rgupp);
       }
       Noe++ ;
  }
  fflush(rtto);
  return ;
}


/* ========================================================================= */
void write_constraints_disman(FILE *rtto)
/*
  ---
  --- 
  --- (Roberto Tejero, RTT, May 1993, CABM-Rutgers University).
  ---
*/
{
  static struct noe *Noe ;
  static char FirstRecord ;

  Noe = NOE + 1;
  FirstRecord = TRUE ;

  while ( Noe->next != NULL ) {
       if ( !Noe->ToPrint ) {
	     Noe++ ;
	     continue ;
       }
       if ( FirstRecord ) {
	        FirstRecord = FALSE ;
       		fprintf(rtto,"%2d %3s \n",Noe->residue_number1, Noe->residue_type1);
       		fprintf(rtto,"        %-6s%4d %3s  %-5s%6.1f\n",
	       		Noe->Atom1Disman, Noe->residue_number2,
	       		Noe->residue_type2, Noe->Atom2Disman,
	       		Noe->upper);
       }
       if ((Noe->residue_number1 == (Noe-1)->residue_number1))
	    fprintf(rtto,"        %-6s%4d %3s  %-5s%6.1f         %s\n",
		    Noe->Atom1Disman, Noe->residue_number2,
		    Noe->residue_type2, Noe->Atom2Disman,
		    Noe->upper, Noe->comment);
       else {
	    fprintf(rtto,"%2d %3s \n",Noe->residue_number1,
		    Noe->residue_type1);
	    fprintf(rtto,"        %-6s%4d %3s  %-5s%6.1f         %s\n",
		    Noe->Atom1Disman, Noe->residue_number2,
		    Noe->residue_type2, Noe->Atom2Disman,
		    Noe->upper, Noe->comment);
       }
       Noe++ ;
  }
  fflush(rtto);
  return ;
}

/* ========================================================================= */
void write_constraints_dyana(FILE *rtto)
/*
  --- 
  --- (Roberto Tejero, RTT, May 1993, CABM-Rutgers University).
  ---
*/
{
  static struct noe *Noe ;
  static char Full, FirstRecord ;
  static int PrintedNoes=0 ;
  
  PrintedNoes = 0 ;
  Full = TRUE ;
  FirstRecord = TRUE ;
  Noe = NOE + 1;
  fprintf(rtto,"#\n# UPL file\n#\n");
  if ( Full ) {
       while ( Noe->next != NULL ) {
	    if ( !Noe->ToPrint ) {
		 Noe++ ;
		 continue ;
	    }
	    PrintedNoes++ ; 
	    fprintf(rtto,"%3d %3s  %-5s%4d %3s  %-5s %6.2f         %s\n",
		    Noe->residue_number1, Noe->residue_type1, Noe->Atom1Dyana, 
		    Noe->residue_number2, Noe->residue_type2, Noe->Atom2Dyana,
		    Noe->upper, Noe->comment);
	    Noe++ ;
       }
  } else {
       while ( Noe->next != NULL ) {
	    if ( !Noe->ToPrint ) {
		 Noe++ ;
		 continue ;
	    }
	    if ( FirstRecord ) {
		 FirstRecord = FALSE ;
		 fprintf(rtto,"%3d %3s\n",Noe->residue_number1, Noe->residue_type1);
		 fprintf(rtto,"         %-5s%4d %3s  %-5s%6.1f\n",
			 Noe->Atom1Dyana, Noe->residue_number2,
			 Noe->residue_type2, Noe->Atom2Dyana,
			 Noe->upper);
	    }
	    if ( Noe->residue_number1 == (Noe-1)->residue_number1 ) {
		 fprintf(rtto,"         %-5s%4d %3s  %-5s%6.1f         %s\n",
			 Noe->Atom1Dyana, Noe->residue_number2,
			 Noe->residue_type2, Noe->Atom2Dyana,
			 Noe->upper, Noe->comment);
	    } else {
		 fprintf(rtto,"%3d %3s\n",Noe->residue_number1, Noe->residue_type1);
		 fprintf(rtto,"         %-5s%4d %3s  %-5s%6.1f         %s\n",
			 Noe->Atom1Dyana, Noe->residue_number2,
			 Noe->residue_type2, Noe->Atom2Dyana,
			 Noe->upper, Noe->comment);
	    }
	    PrintedNoes++ ; 
	    Noe++ ;
       }
  }
  fprintf(stdout," > write_constraints_dyana():  %5d Final NOEs written \n", PrintedNoes );
  fflush(rtto);
  return ;
}


/* ========================================================================= */
void write_constraints_dyana_lol(FILE *rtto)
/*
  ---
  --- (Roberto Tejero, RTT, May 1993, CABM-Rutgers University).
  ---
*/
{
  static struct noe *Noe ;
  static char FirstRecord ;

  FirstRecord = FALSE ;
  Noe = NOE + 1 ;
  
  fprintf(rtto,"#\n# LOL file\n#\n");
  while ( Noe->next != NULL ) {
       if ( !Noe->ToPrint ) {
	    Noe++ ;
	    continue ;
       }
       if ( FirstRecord ) {
	    FirstRecord = FALSE ;
	    fprintf(rtto,"%3d %3s\n",Noe->residue_number1, Noe->residue_type1);
	    fprintf(rtto,"         %-5s%4d %3s  %-5s%6.1f\n",
		    Noe->Atom1Dyana, Noe->residue_number2,
		    Noe->residue_type2, Noe->Atom2Dyana,
		    Noe->lower);
       }
       if ((Noe->residue_number1 == (Noe-1)->residue_number1)) {
	    fprintf(rtto,"         %-5s%4d %3s  %-5s%6.1f         %s\n",
		    Noe->Atom1Dyana, Noe->residue_number2,
		    Noe->residue_type2, Noe->Atom2Dyana,
		    Noe->lower, Noe->comment);
       } else {
	    fprintf(rtto,"%3d %3s\n",Noe->residue_number1, Noe->residue_type1);
	    fprintf(rtto,"         %-5s%4d %3s  %-5s%6.1f         %s\n",
		    Noe->Atom1Dyana, Noe->residue_number2,
		    Noe->residue_type2, Noe->Atom2Dyana,
		    Noe->lower, Noe->comment);
       }
       Noe++ ;
  }
  fflush(rtto);
  return ;
}


/* ========================================================================= */
void write_constraints_diana(FILE *rtto)
/*
  --- 
  --- (Roberto Tejero, RTT, May 1993, CABM-Rutgers University).
  ---
*/
{
  static struct noe *Noe ;
  static char FirstRecord ;

  Noe = NOE + 1;
  FirstRecord = TRUE ;

  fprintf(rtto,"#\n# UPL file\n#\n");
  while ( Noe->next != NULL ) {
       if ( !Noe->ToPrint ) {
	    Noe++ ;
	    continue ;
       }
       if ( FirstRecord ) {
	    FirstRecord = FALSE ;
	    fprintf(rtto,"%3d %3s\n",Noe->residue_number1, Noe->residue_type1);
	    fprintf(rtto,"         %-5s%4d %3s  %-5s%6.1f\n",
		    Noe->Atom1Diana, Noe->residue_number2,
		    Noe->residue_type2, Noe->Atom2Diana,
		    Noe->upper);
       }
       if ((Noe->residue_number1 == (Noe-1)->residue_number1)) {
	    fprintf(rtto,"         %-5s%4d %3s  %-5s%6.1f         %s\n",
		    Noe->Atom1Diana, Noe->residue_number2,
		    Noe->residue_type2, Noe->Atom2Diana,
		    Noe->upper, Noe->comment);
       } else {
	    fprintf(rtto,"%3d %3s\n",Noe->residue_number1,
		    Noe->residue_type1);
	    fprintf(rtto,"         %-5s%4d %3s  %-5s%6.1f         %s\n",
		    Noe->Atom1Diana, Noe->residue_number2,
		    Noe->residue_type2, Noe->Atom2Diana,
		    Noe->upper, Noe->comment);
       }
       Noe++ ;
  }
  fflush(rtto);
  return ;
}


/* ========================================================================= */
void write_constraints_diana_lol(FILE *rtto)
/*
  ---
  --- (Roberto Tejero, RTT, May 1993, CABM-Rutgers University).
  ---
*/
{
     
     static struct noe *Noe ;
     static char FirstRecord ;
     
     Noe = NOE + 1;
     FirstRecord = TRUE ;
     
     fprintf(rtto,"#\n# LOL file\n#\n");
     while ( Noe->next != NULL ) {
	  if ( !Noe->ToPrint ) {
	       Noe++ ;
	       continue ;
	  }
	  if ( FirstRecord ) {
	       FirstRecord = FALSE ;
	       fprintf(rtto,"%3d %3s\n",Noe->residue_number1, Noe->residue_type1);
	       fprintf(rtto,"         %-5s%4d %3s  %-5s%6.1f\n",
		       Noe->Atom1Diana, Noe->residue_number2,
		       Noe->residue_type2, Noe->Atom2Diana,
		       Noe->lower);
	  }
	  if ((Noe->residue_number1 == (Noe-1)->residue_number1))
	       fprintf(rtto,"         %-5s%4d %3s  %-5s%6.1f         %s\n",
		       Noe->Atom1Diana, Noe->residue_number2,
		       Noe->residue_type2, Noe->Atom2Diana,
		       Noe->lower, Noe->comment);
	  else {
	       fprintf(rtto,"%3d %3s\n",Noe->residue_number1,
		       Noe->residue_type1);
	       fprintf(rtto,"         %-5s%4d %3s  %-5s%6.1f         %s\n",
		       Noe->Atom1Diana, Noe->residue_number2,
		       Noe->residue_type2, Noe->Atom2Diana,
		       Noe->lower, Noe->comment);
	  }
	  Noe++ ;
     }
     fflush(rtto);
     return ;
}


/* ========================================================================= */
void write_constraints_impact(FILE *rtto)
/*
  ---
  --- (Roberto Tejero, RTT, May 1993, CABM-Rutgers University).
  ---
*/
{
     static struct noe *Noe ;

     Noe = NOE + 1 ;
     while ( Noe->next != NULL ) {
	  if ( !Noe->ToPrint ) {
	       Noe++ ;
	       continue ;
	  }
	  fprintf(rtto,"%4d %-4s %4d %-4s %6.1f %6.1f\n",
		  Noe->residue_number1, Noe->atom_type1,
		  Noe->residue_number2, Noe->atom_type2,
		  Noe->lower, Noe->upper);
	  Noe++ ;
     }
     fflush(rtto);
     return ;
}

/* ========================================================================= */
void write_constraints_congen(FILE *rtto)
/*
  ---
  ---
  --- (Roberto Tejero, RTT, May 1993, CABM-Rutgers University).
  ---
*/
{

     static struct noe *Noe ;
     Noe = NOE + 1 ;

     fprintf(rtto,"*----- \n*  Title default produced by analconstraint\n*\n");
     fprintf(rtto,"TYPE NOE\nWEIGHT 1.0\n");

     while ( Noe->next != NULL ) {
	  if ( !Noe->ToPrint ) {
	       Noe++ ;
	       continue ;
	  }
	  if (Noe->lower <= 0.0 ) Noe->lower = 1.80 ;
	  if ( strcmp(Noe->chain_id_1,"")==0 || strcmp(Noe->chain_id_1," ")==0 ) 
	       strcpy(Noe->chain_id_1,"A");
	  if ( strcmp(Noe->chain_id_2,"")==0 || strcmp(Noe->chain_id_2," ")==0 ) 
	       strcpy(Noe->chain_id_2,"A");
	  fprintf(rtto, "CONS ATOM %s %3d %-4s : ATOM %s %3d %-4s  LOWE %7.2f  UPPE %7.2f  !%6d\n",
		  Noe->chain_id_1, Noe->residue_number1, Noe->Atom1Congen,
		  Noe->chain_id_2, Noe->residue_number2, Noe->Atom2Congen,
		  Noe->lower, Noe->upper, i);
	  Noe++ ;
     }
     fflush(rtto);
     return ;
}

/* ========================================================================= */
void write_constraints_charmm(FILE *rtto)
/*
  ---
  ---
  --- (Roberto Tejero, RTT, May 1993, CABM-Rutgers University).
  ---
*/
{
     static struct noe *Noe ;
     static float  KMIN=10.0, KMAX=10.0 ;
     
     Noe = NOE + 1;

     /*
      *  Print title and defaults 
      */
     fprintf(rtto,"* \n*  Title default produced by analconstraint\n*\n");
     fprintf(rtto,"NOE \n  RESET\n");
     while ( Noe->next != NULL ) {
	  if ( !Noe->ToPrint ) {
	       Noe++ ;
	       continue ;
	  }
	  Noe->lower = 1.80 ;
	  fprintf(rtto, "ASSIGN SELE ATOM %s %3d %-4s END  SELE ATOM %s %3d %-4s  END "\
		  "RMIN %7.2f RMAX %7.2f KMIN %7.2f KMAX %7.2f \n",
		  Noe->chain_id_1, Noe->residue_number1, Noe->Atom1Congen,
		  Noe->chain_id_2, Noe->residue_number2, Noe->Atom2Congen,
		  Noe->lower, Noe->upper, KMIN,KMAX);
	  Noe++ ;
     }
     fprintf(rtto,"END \n");
     fflush(rtto);
     return ;
}

/* ========================================================================= */
void write_constraints_discover(FILE *rtto)
/*
  ---
  ---
  --- (Roberto Tejero, RTT, May 1993, CABM-Rutgers University).
  ---
*/
{
     static struct noe *Noe ;

     Noe = NOE + 1;
     fprintf(rtto,"!BIOSYM restraint 1 \n#NOE_distance \n");
     while ( Noe->next != NULL ) {
	  if ( !Noe->ToPrint ) {
	       Noe++ ;
	       continue ;
	  }
	  if (Noe->residue_number1 == 1)
	       fprintf(rtto,"1:%sN_%1s%1d:%s\t1:%s_%1s%1d:%s\t%5.2f  %5.2f  0.0  100.0  100.0  1000.0 \n",
		       Noe->residue_type1, Noe->chain_id_1, Noe->residue_number1, Noe->atom_type1,	      
		       Noe->residue_type1, Noe->chain_id_2, Noe->residue_number2, Noe->atom_type2,
		       Noe->lower, Noe->upper);
	  if (Noe->residue_number2 == 1)
	       fprintf(rtto,"1:%s_%1s%1d:%s\t1:%sN_%1s%1d:%s\t%5.2f  %5.2f  0.0  100.0  100.0  1000.0 \n",
		       Noe->residue_type1, Noe->chain_id_1, Noe->residue_number1, Noe->atom_type1,	      
		       Noe->residue_type1, Noe->chain_id_2, Noe->residue_number2, Noe->atom_type2,
		       Noe->lower,
		       Noe->upper);
	  if ((Noe->residue_number1 != 1) && (Noe->residue_number2 !=1))
	       fprintf(rtto,"1:%s_%1s%1d:%s\t1:%s_%1s%1d:%s\t%5.2f  %5.2f  0.0  100.0  100.0  1000.0 \n",
		       Noe->residue_type1, Noe->chain_id_1, Noe->residue_number1, Noe->atom_type1,	      
		       Noe->residue_type1, Noe->chain_id_2, Noe->residue_number2, Noe->atom_type2,
		       Noe->lower, Noe->upper);
	  Noe++ ;
     }
     fflush(rtto);
     return ;
}


/* ====== end of module's code ====== */

