/*$Id: write_coordinates.c,v 3.32 2003/10/06 12:13:32 roberto Exp roberto $*/

#include "pdbstat.h"	

extern int FindSameAtom(int reference, int kompar, int iatom) ;
extern int FindSameSelectedAtom(int reference, int kompar, int iatom, char who[3]) ;
extern void optimal_rotate(int reference, int kompar, int residue_range,
			   int orientmode, char tipo[MAXWORD]);
void do_average_coords(char tipo[MAXWORD]);
void do_average_selected(char tipo[MAXWORD]);
void write_aco(FILE *rtto, int option); 
void DumpHeader(FILE *rtto);
void DumpModelHeader(FILE *rtto, struct models *model);

extern int flagall ; /* defined in DriverForWriting.c */
static int  i, k;

/* ========================================================================= */
void write_coords_pdb(FILE *rtto, int loption)
 /* 
  * Please NOTE: NEEDS a lot of improvements. For example only
  * writes down the fields up to the coordinates. May be is in
  * teresting also to make more independent the output format
  * to have HB1 and 1HB atom types. (This has been done on June 1993, I mean
  * the possibility to wrote down HB11 or 1HB1).
  *
  * NOTE that the fields pdb_data1 and pdb_data2 contain no useful data
  * (at least now) so my behaviour with these two guys is sometimes 'funny'
  * even 'erratic' (sometimes I take care of them, sometimes not).
  *
  * loption is an option that should take care of different formats.
  * Right now it only takes TWO values: 6 or 7, 6 is for RasMol format.
  *
  * (Roberto Tejero, RTT, May 1993, CABM-Rutgers University).
  *
  */   
{
     int         resi, ResNumber, bucle, ResTer = 0 ;
     register int    tmp_cntr, recon_line=0 ;
     char          tmp_name[MAXWORD], Identificador[MAXWORD], TmpChainId[2] ;
     static struct models *model ;
     
     /*
      * Initializing and checking things 
      * for the chain ID there are 64 different identifiers -- all the letters
      * plus the numbers --
      */
     strcpy(Identificador,"-ABCDEFGHIJKLMNOPQRSTUVWXYZ") ;
     strcat(Identificador,"abcdefghijklmnopqrstuvwxyz") ;
     resi = 0;
     model = MODELS+key_model ;
     
     MAX = model->number_of_atoms + 1;
     strcpy(TmpChainId, model->PDB[1].pdb_chain_id);
     
     if (MAX <= 0) {
	  printf("> WRITE_coords_pdb: ** No molecule read ** \n");
	  return;
     }
     
     for (i = 1 ; i < MAX ; i++)
	  if (model->written == TRUE) 
	       model->PDB[i].written = TRUE ;
	  else
	       model->PDB[i].written = FALSE ;
     for (i = 0 ; i <= strlen(name_of_the_file_coords) ; i++)
	  tmp_name[i] = toupper(name_of_the_file_coords[i]);
     
     /*
      * Header information
      */
     resi = 1;
    
     /* Multiple models */
     if ((flagall == 1) && (key_model > 1)) goto muchos;
     
     /* Only one model */
     if (flagall == 1) {
          fprintf(rtto,"REMARK   PdbStat --  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n");
	  fprintf(rtto,"REMARK   PdbStat --  PDB COORDINATES FOR %s, %d MODEL/S  %s  \n",
		  tmp_name, total_models, tmp_name);
          fprintf(rtto,"REMARK   PdbStat --  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n");
	  temporalcount = 0 ;  /* To reflect new behavior in PDB resetting numbers for each model */
	  /* Print header stored from original file */
     } else {
	  fprintf(rtto,"HEADER     PDB COORDINATES FOR %s, MODEL/S %d  %s  \n",
		  tmp_name, key_model, tmp_name);
	  temporalcount = 0 ;
	  /* Print header stored from original file */
     }

     /*
      * Sequence information
      */
     fprintf(rtto,"SEQRES%4d %1s %4d  ",
	     resi,model->PDB[1].pdb_chain_id, model->number_of_residues);
     
     for(i = 1 ; i <= model->number_of_residues ; i++) {
	  fprintf(rtto,"%3s ",model->DIH[i].resname); 
	  if (fmod(i,13) == 0.0)  {
	       resi++;
	       fprintf(rtto,"\nSEQRES%4d %1s %4d  ",
		       resi,model->PDB[1].pdb_chain_id, model->number_of_residues);
	  }
     }
     
     /*
      * SSBOND information
      */
     
     if ((disulfide_bonds > 0) && (flagall == 0)) {
	  for ( i = 1 ; i <= disulfide_bonds ; i++)
	       fprintf(rtto,"\nSSBOND%4d %3s%7d    %3s%7d", 
		       i,
		       seqres[infodisu[i][1]], infodisu[i][1],
		       seqres[infodisu[i][2]], infodisu[i][2]);
     }
     
     /*
      * A white end of line needed to continue printing nicely
      */
     fprintf(rtto,"\n");
     
 muchos:
     
     /*
      * Coordinates
      */
    
     recon_line = 0 ;

     if (loption == 6)          
	  /* RasMol type, we don't like MODEL in file */
	  ;
     else {                      
	  /* Regular PDB type, we like MODEL in file */
	  
	  if (ChainsInModel > 1) 
	       if (key_model % ChainsInModel != 0) 
		    fprintf(rtto,"MODEL     %4d\n", key_model);
	  
	  if (ChainsInModel == 1) {
	       fprintf(rtto,"MODEL     %4d\n", key_model);

	       /* Header - Remark lines for each model ??? */
	       if ( WriteModelHeader )
	             DumpModelHeader(rtto,model);

	       /*
		* This is meant to write ENERGY and FAMILY info in the file
		*/
	       
	       if (model->energy != 9999.0)
		    fprintf(rtto,"REMARK CONFORMATION%5d ENERGY%12.4f \n", model->modelno, model->energy);
	       fprintf(rtto,"REMARK    FAMILY or FILE: %s\n",model->family);
	       
	  }
     }	
     
     for (i = 1 ; i < MAX ; i++) {    
	  /*
	   * Skiping pseudo-atoms Q type
	   */
	  if ((strncmp(model->PDB[i].pdb_iupac,"Q",1)==0) || (strncmp(model->PDB[i].pdb_iupac," Q",2)==0)) 
	       model->PDB[i].written = TRUE ;
	  
	  /*
	   * Skiping Lone Pairs
	   */
	  if ((strncmp(model->PDB[i].pdb_iupac,"LP",2)==0) || (strncmp(model->PDB[i].pdb_iupac," LP",3)==0)) 
	       model->PDB[i].written = TRUE ;
     }
     
     for (i = 1 ; i < MAX ; i++) {        
	  /*
	   * If the user likes writing with different selections of atoms
	   */
	  
	  if (SELECTED) {
	       if (!model->PDB[i].Selected)
		    model->PDB[i].written = TRUE ;
	  } else
	       model->PDB[i].written = FALSE ;
	  
	  if (HEAVY) {
	       if (strncasecmp(model->PDB[i].type,"heavy",3)!=0) 
		    model->PDB[i].written = TRUE ;
	  }
	  
	  if (BACKBONE) {
	       if (strncasecmp(model->PDB[i].chain,"backbone",3)!=0)
		    model->PDB[i].written = TRUE ;
	  }
     }
     
     for (i = 1 ; i < MAX ; i++) {        
	  /*
	   * Trying to make REAL PDB writing
	   * N,CA,C,O,sidechain and finally hydrogens
	   */
	  
	  ResNumber = model->PDB[i].orden ;
	  
	  /*
	   * 29 is the maximum number of atoms as far as I know (counting ALL
	   * pseudo, lone pairs and real atoms). This number is for ARG
	   */
	  if ( i < 30 )
	       bucle = 1 ;
	  else
	       bucle = i - 29 ;
	  
	  for (tmp_cntr = bucle ; tmp_cntr <= model->DIH[ResNumber].number_of_atoms+i; tmp_cntr++) 
	       if ((model->PDB[tmp_cntr].written == FALSE) &&
		   (model->PDB[i].pdb_num_res == model->PDB[tmp_cntr].pdb_num_res)) 
		    if ((strncmp(model->PDB[tmp_cntr].chain,"backbon",3)==0) ||
			(strncmp(model->PDB[tmp_cntr].pdb_iupac," O  ",4)==0)){
			 model->PDB[tmp_cntr].written = TRUE ;
			 goto fuera ;
		    }
	  
	  /*
	   * HEAVY atoms.
	   * I know the way we print the atoms (algorithm) looks pretty ugly
	   * in some moment somebody in someplace should fix it
	   */
	  for (tmp_cntr = bucle ; tmp_cntr <= model->DIH[ResNumber].number_of_atoms+i; tmp_cntr++) 
	       if ((model->PDB[tmp_cntr].written == FALSE) &&
		   (model->PDB[i].pdb_num_res == model->PDB[tmp_cntr].pdb_num_res)) 
		    if ((strncmp(model->PDB[tmp_cntr].type,"heavy",5)==0) &&
			(model->PDB[tmp_cntr].pdb_iupac[2]=='A')) {
			 model->PDB[tmp_cntr].written = TRUE ;
			 goto fuera ;
		    }
	  
	  /* Special case for BOC */
	  for (tmp_cntr = bucle ; tmp_cntr <= model->DIH[ResNumber].number_of_atoms+i; tmp_cntr++) 
	       if ((model->PDB[tmp_cntr].written == FALSE) &&
		   (model->PDB[i].pdb_num_res == model->PDB[tmp_cntr].pdb_num_res)) 
		    if ((strncmp(model->PDB[tmp_cntr].type,"heavy",5)==0) &&
			((model->PDB[tmp_cntr].pdb_iupac[2]=='1') ||
			 (model->PDB[tmp_cntr].pdb_iupac[2]=='2') ||
			 (model->PDB[tmp_cntr].pdb_iupac[2]=='3') ||
			 (model->PDB[tmp_cntr].pdb_iupac[2]=='4'))) {
			 model->PDB[tmp_cntr].written = TRUE ;
			 goto fuera ;
		    }
	  
	  for (tmp_cntr = bucle ; tmp_cntr <= model->DIH[ResNumber].number_of_atoms+i; tmp_cntr++) 
	       if ((model->PDB[tmp_cntr].written == FALSE) &&
		   (model->PDB[i].pdb_num_res == model->PDB[tmp_cntr].pdb_num_res)) 
		    if ((strncmp(model->PDB[tmp_cntr].type,"heavy",5)==0) &&
			(model->PDB[tmp_cntr].pdb_iupac[2]=='B')) {
			 model->PDB[tmp_cntr].written = TRUE ;
			 goto fuera ;
		    }
	  
	  for (tmp_cntr = bucle ; tmp_cntr <= model->DIH[ResNumber].number_of_atoms+i; tmp_cntr++) 
	       if ((model->PDB[tmp_cntr].written == FALSE) &&
		   (model->PDB[i].pdb_num_res == model->PDB[tmp_cntr].pdb_num_res)) 
		    if ((strncmp(model->PDB[tmp_cntr].type,"heavy",5)==0) &&
			(model->PDB[tmp_cntr].pdb_iupac[2]=='G') &&
			(model->PDB[tmp_cntr].pdb_iupac[3]=='1')) {
			 model->PDB[tmp_cntr].written = TRUE ;
			 goto fuera ;
		    }
	  
	  for (tmp_cntr = bucle ; tmp_cntr <= model->DIH[ResNumber].number_of_atoms+i; tmp_cntr++) 
	       if ((model->PDB[tmp_cntr].written == FALSE) &&
		   (model->PDB[i].pdb_num_res == model->PDB[tmp_cntr].pdb_num_res)) 
		    if ((strncmp(model->PDB[tmp_cntr].type,"heavy",5)==0) &&
			(model->PDB[tmp_cntr].pdb_iupac[2]=='G') &&
			(model->PDB[tmp_cntr].pdb_iupac[3]=='2')) {
			 model->PDB[tmp_cntr].written = TRUE ;
			 goto fuera ;
		    }
	  
	  for (tmp_cntr = bucle; tmp_cntr <= model->DIH[ResNumber].number_of_atoms+i; tmp_cntr++) 
	       if ((model->PDB[tmp_cntr].written == FALSE) &&
		   (model->PDB[i].pdb_num_res == model->PDB[tmp_cntr].pdb_num_res)) 
		    if ((strncmp(model->PDB[tmp_cntr].type,"heavy",5)==0) &&
			(model->PDB[tmp_cntr].pdb_iupac[2]=='G')) {
			 model->PDB[tmp_cntr].written = TRUE ;
			 goto fuera ;
		    }
	  
	  for (tmp_cntr = bucle; tmp_cntr <= model->DIH[ResNumber].number_of_atoms+i; tmp_cntr++) 
	       if ((model->PDB[tmp_cntr].written == FALSE) &&
		   (model->PDB[i].pdb_num_res == model->PDB[tmp_cntr].pdb_num_res)) 
		    if ((strncmp(model->PDB[tmp_cntr].type,"heavy",5)==0) &&
			(model->PDB[tmp_cntr].pdb_iupac[2]=='D')) {
			 model->PDB[tmp_cntr].written = TRUE ;
			 goto fuera ;
		    }
	  
	  for (tmp_cntr = bucle; tmp_cntr <= model->DIH[ResNumber].number_of_atoms+i; tmp_cntr++) 
	       if ((model->PDB[tmp_cntr].written == FALSE) &&
		   (model->PDB[i].pdb_num_res == model->PDB[tmp_cntr].pdb_num_res)) 
		    if ((strncmp(model->PDB[tmp_cntr].type,"heavy",5)==0) &&
			(model->PDB[tmp_cntr].pdb_iupac[2]=='E')) {
			 model->PDB[tmp_cntr].written = TRUE ;
			 goto fuera ;
		    }
	  
	  for (tmp_cntr = bucle; tmp_cntr <= model->DIH[ResNumber].number_of_atoms+i; tmp_cntr++) 
	       if ((model->PDB[tmp_cntr].written == FALSE) &&
		   (model->PDB[i].pdb_num_res == model->PDB[tmp_cntr].pdb_num_res)) 
		    if ((strncmp(model->PDB[tmp_cntr].type,"heavy",5)==0) &&
			(model->PDB[tmp_cntr].pdb_iupac[2]=='Z')) {
			 model->PDB[tmp_cntr].written = TRUE ;
			 goto fuera ;
		    }
	  
	  for (tmp_cntr = bucle; tmp_cntr <= model->DIH[ResNumber].number_of_atoms+i; tmp_cntr++) 
	       if ((model->PDB[tmp_cntr].written == FALSE) &&
		   (model->PDB[i].pdb_num_res == model->PDB[tmp_cntr].pdb_num_res)) 
		    if ((strncmp(model->PDB[tmp_cntr].type,"heavy",5)==0) &&
			(model->PDB[tmp_cntr].pdb_iupac[2]=='H')) {
			 model->PDB[tmp_cntr].written = TRUE ;
			 goto fuera ;
		    }
	  
	  /*
	   * Oxigen in N terminal, OXT
	   */
	  for (tmp_cntr = bucle; tmp_cntr <= model->DIH[ResNumber].number_of_atoms+i; tmp_cntr++) 
	       if ((model->PDB[tmp_cntr].written == FALSE) &&
		   (model->PDB[i].pdb_num_res == model->PDB[tmp_cntr].pdb_num_res)) 
		    if ((strncmp(model->PDB[tmp_cntr].type,"heavy",5)==0) &&
			(model->PDB[tmp_cntr].pdb_iupac[2]=='X')) {
			 model->PDB[tmp_cntr].written = TRUE ;
			 goto fuera ;
		    }
	  
	  
	  /*
	   * Oxigens in N terminal, OT1, OT2
	   */
	  for (tmp_cntr = bucle; tmp_cntr <= model->DIH[ResNumber].number_of_atoms+i; tmp_cntr++) 
	       if ((model->PDB[tmp_cntr].written == FALSE) &&
		   (model->PDB[i].pdb_num_res == model->PDB[tmp_cntr].pdb_num_res)) 
		    if ((strncmp(model->PDB[tmp_cntr].type,"heavy",5)==0) &&
			(model->PDB[tmp_cntr].pdb_iupac[2]=='T')) {
			 model->PDB[tmp_cntr].written = TRUE ;
			 goto fuera ;
		    }
	  
	  /*
	   * And now the HYDROGENS.
	   * Again as in HEAVIES this is not the most efficient nor the more
	   * elegant way to write the coordinates, so same comment as before
	   * some moment in some place someone should ...
	   * We start by writing first the hydrogens for the C terminal
	   * residue.
	   */
	  for (tmp_cntr = bucle; tmp_cntr <= model->DIH[ResNumber].number_of_atoms+i; tmp_cntr++) 
	       if ((model->PDB[tmp_cntr].written == FALSE) &&
		   (model->PDB[i].pdb_num_res == model->PDB[tmp_cntr].pdb_num_res)) 
		    if ((strncmp(model->PDB[tmp_cntr].type,"hydrogen",5)==0) &&
			((strncmp(model->PDB[tmp_cntr].pdb_iupac,"1HT",3)==0)||
			 (strncmp(model->PDB[tmp_cntr].pdb_iupac,"2HT",3)==0)||
			 (strncmp(model->PDB[tmp_cntr].pdb_iupac,"3HT",3)==0))){
			 model->PDB[tmp_cntr].written = TRUE ;
			 goto fuera ;
		    }
	  
	  /* XPLOR, CONGEN, cases */
	  for (tmp_cntr = bucle; tmp_cntr <= model->DIH[ResNumber].number_of_atoms+i; tmp_cntr++) 
	       if ((model->PDB[tmp_cntr].written == FALSE) &&
		   (model->PDB[i].pdb_num_res == model->PDB[tmp_cntr].pdb_num_res)) 
		    if ((strncmp(model->PDB[tmp_cntr].type,"hydrogen",5)==0) &&
			((strncmp(model->PDB[tmp_cntr].pdb_iupac," HT1",4)==0)||
			 (strncmp(model->PDB[tmp_cntr].pdb_iupac," HT2",4)==0)||
			 (strncmp(model->PDB[tmp_cntr].pdb_iupac," HT3",4)==0))){
			 model->PDB[tmp_cntr].written = TRUE ;
			 goto fuera ;
		    }
	  
	  for (tmp_cntr = bucle; tmp_cntr <= model->DIH[ResNumber].number_of_atoms+i; tmp_cntr++) 
	       if ((model->PDB[tmp_cntr].written == FALSE) &&
		   (model->PDB[i].pdb_num_res == model->PDB[tmp_cntr].pdb_num_res)) 
		    if ((strncmp(model->PDB[tmp_cntr].type,"hydrogen",5)==0) &&
			((strncmp(model->PDB[tmp_cntr].pdb_iupac,"1H ",3)==0)||
			 (strncmp(model->PDB[tmp_cntr].pdb_iupac,"2H ",3)==0)||
			 (strncmp(model->PDB[tmp_cntr].pdb_iupac,"3H ",3)==0))){
			 model->PDB[tmp_cntr].written = TRUE ;
			 goto fuera ;
		    }
	  
	  for (tmp_cntr = bucle; tmp_cntr <= model->DIH[ResNumber].number_of_atoms+i; tmp_cntr++) 
	       if ((model->PDB[tmp_cntr].written == FALSE) &&
		   (model->PDB[i].pdb_num_res == model->PDB[tmp_cntr].pdb_num_res)) 
		    if ((strncmp(model->PDB[tmp_cntr].type,"hydrogen",5)==0) &&
			(strncmp(model->PDB[tmp_cntr].pdb_iupac," H ",3)==0)){
			 model->PDB[tmp_cntr].written = TRUE ;
			 goto fuera ;
		    }
	  
	  /* HN for XPLOR, DIANA, etc */
	  for (tmp_cntr = bucle; tmp_cntr <= model->DIH[ResNumber].number_of_atoms+i; tmp_cntr++) 
	       if ((model->PDB[tmp_cntr].written == FALSE) &&
		   (model->PDB[i].pdb_num_res == model->PDB[tmp_cntr].pdb_num_res)) 
		    if ((strncmp(model->PDB[tmp_cntr].type,"hydrogen",5)==0) &&
			(strncmp(model->PDB[tmp_cntr].pdb_iupac," HN ",4)==0)){
			 model->PDB[tmp_cntr].written = TRUE ;
			 goto fuera ;
		    }
	  
	  for (tmp_cntr = bucle; tmp_cntr <= model->DIH[ResNumber].number_of_atoms+i; tmp_cntr++) 
	       if ((model->PDB[tmp_cntr].written == FALSE) &&
		   (model->PDB[i].pdb_num_res == model->PDB[tmp_cntr].pdb_num_res)) 
		    if ((strncmp(model->PDB[tmp_cntr].type,"hydrogen",5)==0) &&
			(model->PDB[tmp_cntr].pdb_iupac[2]=='A')) {
			 model->PDB[tmp_cntr].written = TRUE ;
			 goto fuera ;
		    }
	  
	  for (tmp_cntr = bucle; tmp_cntr <= model->DIH[ResNumber].number_of_atoms+i; tmp_cntr++) 
	       if ((model->PDB[tmp_cntr].written == FALSE) &&
		   (model->PDB[i].pdb_num_res ==
		    model->PDB[tmp_cntr].pdb_num_res)) 
		    if ((strncmp(model->PDB[tmp_cntr].type,"hydrogen",5)==0) &&
			(model->PDB[tmp_cntr].pdb_iupac[2]=='B')) {
			 model->PDB[tmp_cntr].written = TRUE ;
			 goto fuera ;
		    }
	  
	  /* Special case for BOC N terminal residue */
	  for (tmp_cntr = bucle; tmp_cntr <= model->DIH[ResNumber].number_of_atoms+i; tmp_cntr++) 
	       if ((model->PDB[tmp_cntr].written == FALSE) &&
		   (model->PDB[i].pdb_num_res == model->PDB[tmp_cntr].pdb_num_res)) 
		    if ((strncmp(model->PDB[tmp_cntr].type,"hydrogen",5)==0) &&
			(model->PDB[tmp_cntr].pdb_iupac[2]=='C')) {
			 model->PDB[tmp_cntr].written = TRUE ;
			 goto fuera ;
		    }
	  
	  /* XPLOR special */
	  for (tmp_cntr = bucle; tmp_cntr <= model->DIH[ResNumber].number_of_atoms+i; tmp_cntr++) 
	       if ((model->PDB[tmp_cntr].written == FALSE) &&
		   (model->PDB[i].pdb_num_res == model->PDB[tmp_cntr].pdb_num_res)) 
		    if ((strncmp(model->PDB[tmp_cntr].type,"hydrogen",5)==0) &&
			(model->PDB[tmp_cntr].pdb_iupac[0]=='H') &&
			(model->PDB[tmp_cntr].pdb_iupac[1]=='G') &&
			(model->PDB[tmp_cntr].pdb_iupac[2]=='1'))  {
			 model->PDB[tmp_cntr].written = TRUE ;
			 goto fuera ;
		    }
	  for (tmp_cntr = bucle; tmp_cntr <= model->DIH[ResNumber].number_of_atoms+i; tmp_cntr++) 
	       if ((model->PDB[tmp_cntr].written == FALSE) &&
		   (model->PDB[i].pdb_num_res == model->PDB[tmp_cntr].pdb_num_res)) 
		    if ((strncmp(model->PDB[tmp_cntr].type,"hydrogen",5)==0) &&
			(model->PDB[tmp_cntr].pdb_iupac[0]=='H') &&
			(model->PDB[tmp_cntr].pdb_iupac[1]=='G') &&
			(model->PDB[tmp_cntr].pdb_iupac[2]=='2'))  {
			 model->PDB[tmp_cntr].written = TRUE ;
			 goto fuera ;
		    }
	  for (tmp_cntr = bucle; tmp_cntr <= model->DIH[ResNumber].number_of_atoms+i; tmp_cntr++) 
	       if ((model->PDB[tmp_cntr].written == FALSE) &&
		   (model->PDB[i].pdb_num_res == model->PDB[tmp_cntr].pdb_num_res)) 
		    if ((strncmp(model->PDB[tmp_cntr].type,"hydrogen",5)==0) &&
			(model->PDB[tmp_cntr].pdb_iupac[0]=='H') &&
			(model->PDB[tmp_cntr].pdb_iupac[1]=='G') &&
			(model->PDB[tmp_cntr].pdb_iupac[2]=='3'))  {
			 model->PDB[tmp_cntr].written = TRUE ;
			 goto fuera ;
		    }
	  
	  /* Gammas */  
	  for (tmp_cntr = bucle; tmp_cntr <= model->DIH[ResNumber].number_of_atoms+i; tmp_cntr++) 
	       if ((model->PDB[tmp_cntr].written == FALSE) &&
		   (model->PDB[i].pdb_num_res == model->PDB[tmp_cntr].pdb_num_res)) 
		    if ((strncmp(model->PDB[tmp_cntr].type,"hydrogen",5)==0) &&
			(model->PDB[tmp_cntr].pdb_iupac[2]=='G') &&
			(model->PDB[tmp_cntr].pdb_iupac[3]=='1')) {
			 model->PDB[tmp_cntr].written = TRUE ;
			 goto fuera ;
		    }
	  
	  for (tmp_cntr = bucle; tmp_cntr <= model->DIH[ResNumber].number_of_atoms+i; tmp_cntr++) 
	       if ((model->PDB[tmp_cntr].written == FALSE) &&
		   (model->PDB[i].pdb_num_res == model->PDB[tmp_cntr].pdb_num_res)) 
		    if ((strncmp(model->PDB[tmp_cntr].type,"hydrogen",5)==0) &&
			(model->PDB[tmp_cntr].pdb_iupac[2]=='G') &&
			(model->PDB[tmp_cntr].pdb_iupac[3]=='2')) {
			 model->PDB[tmp_cntr].written = TRUE ;
			 goto fuera ;
		    }
	  
	  for (tmp_cntr = bucle; tmp_cntr <= model->DIH[ResNumber].number_of_atoms+i; tmp_cntr++) 
	       if ((model->PDB[tmp_cntr].written == FALSE) &&
		   (model->PDB[i].pdb_num_res == model->PDB[tmp_cntr].pdb_num_res)) 
		    if ((strncmp(model->PDB[tmp_cntr].type,"hydrogen",5)==0) &&
			(model->PDB[tmp_cntr].pdb_iupac[2]=='G')) {
			 model->PDB[tmp_cntr].written = TRUE ;
			 goto fuera ;
		    }
	  
	  for (tmp_cntr = bucle; tmp_cntr <= model->DIH[ResNumber].number_of_atoms+i; tmp_cntr++) 
	       if ((model->PDB[tmp_cntr].written == FALSE) &&
		   (model->PDB[i].pdb_num_res == model->PDB[tmp_cntr].pdb_num_res)) 
		    if ((strncmp(model->PDB[tmp_cntr].type,"hydrogen",5)==0) &&
			(model->PDB[tmp_cntr].pdb_iupac[2]=='D')) {
			 model->PDB[tmp_cntr].written = TRUE ;
			 goto fuera ;
		    }
	  
	  /* XPLOR special */
	  for (tmp_cntr = bucle; tmp_cntr <= model->DIH[ResNumber].number_of_atoms+i; tmp_cntr++) 
	       if ((model->PDB[tmp_cntr].written == FALSE) &&
		   (model->PDB[i].pdb_num_res == model->PDB[tmp_cntr].pdb_num_res)) 
		    if ((strncmp(model->PDB[tmp_cntr].type,"hydrogen",5)==0) &&
			(model->PDB[tmp_cntr].pdb_iupac[0]=='H') &&
			(model->PDB[tmp_cntr].pdb_iupac[1]=='D') &&
			(model->PDB[tmp_cntr].pdb_iupac[2]=='1'))  {
			 model->PDB[tmp_cntr].written = TRUE ;
			 goto fuera ;
		    }
	  for (tmp_cntr = bucle; tmp_cntr <= model->DIH[ResNumber].number_of_atoms+i; tmp_cntr++) 
	       if ((model->PDB[tmp_cntr].written == FALSE) &&
		   (model->PDB[i].pdb_num_res == model->PDB[tmp_cntr].pdb_num_res)) 
		    if ((strncmp(model->PDB[tmp_cntr].type,"hydrogen",5)==0) &&
			(model->PDB[tmp_cntr].pdb_iupac[0]=='H') &&
			(model->PDB[tmp_cntr].pdb_iupac[1]=='D') &&
			(model->PDB[tmp_cntr].pdb_iupac[2]=='2'))  {
			 model->PDB[tmp_cntr].written = TRUE ;
			 goto fuera ;
		    }
	  for (tmp_cntr = bucle; tmp_cntr <= model->DIH[ResNumber].number_of_atoms+i; tmp_cntr++) 
	       if ((model->PDB[tmp_cntr].written == FALSE) &&
		   (model->PDB[i].pdb_num_res == model->PDB[tmp_cntr].pdb_num_res)) 
		    if ((strncmp(model->PDB[tmp_cntr].type,"hydrogen",5)==0) &&
			(model->PDB[tmp_cntr].pdb_iupac[0]=='H') &&
			(model->PDB[tmp_cntr].pdb_iupac[1]=='D') &&
			(model->PDB[tmp_cntr].pdb_iupac[2]=='3'))  {
			 model->PDB[tmp_cntr].written = TRUE ;
			 goto fuera ;
		    }
	  
	  for (tmp_cntr = bucle; tmp_cntr <= model->DIH[ResNumber].number_of_atoms+i; tmp_cntr++) 
	       if ((model->PDB[tmp_cntr].written == FALSE) &&
		   (model->PDB[i].pdb_num_res == model->PDB[tmp_cntr].pdb_num_res)) 
		    if ((strncmp(model->PDB[tmp_cntr].type,"hydrogen",5)==0) &&
			(model->PDB[tmp_cntr].pdb_iupac[2]=='E') &&
			(model->PDB[tmp_cntr].pdb_iupac[3]=='1'))  {
			 model->PDB[tmp_cntr].written = TRUE ;
			 goto fuera ;
		    }
	  
	  for (tmp_cntr = bucle; tmp_cntr <= model->DIH[ResNumber].number_of_atoms+i; tmp_cntr++) 
	       if ((model->PDB[tmp_cntr].written == FALSE) &&
		   (model->PDB[i].pdb_num_res == model->PDB[tmp_cntr].pdb_num_res)) 
		    if ((strncmp(model->PDB[tmp_cntr].type,"hydrogen",5)==0) &&
			(model->PDB[tmp_cntr].pdb_iupac[2]=='E') &&
			(model->PDB[tmp_cntr].pdb_iupac[3]=='2')) {
			 model->PDB[tmp_cntr].written = TRUE ;
			 goto fuera ;
		    }
	  
	  /* XPLOR special */
	  for (tmp_cntr = bucle; tmp_cntr <= model->DIH[ResNumber].number_of_atoms+i; tmp_cntr++) 
	       if ((model->PDB[tmp_cntr].written == FALSE) &&
		   (model->PDB[i].pdb_num_res == model->PDB[tmp_cntr].pdb_num_res)) 
		    if ((strncmp(model->PDB[tmp_cntr].type,"hydrogen",5)==0) &&
			(model->PDB[tmp_cntr].pdb_iupac[0]=='H') &&
			(model->PDB[tmp_cntr].pdb_iupac[1]=='E') &&
			(model->PDB[tmp_cntr].pdb_iupac[2]=='1'))  {
			 model->PDB[tmp_cntr].written = TRUE ;
			 goto fuera ;
		    }
	  for (tmp_cntr = bucle; tmp_cntr <= model->DIH[ResNumber].number_of_atoms+i; tmp_cntr++) 
	       if ((model->PDB[tmp_cntr].written == FALSE) &&
		   (model->PDB[i].pdb_num_res == model->PDB[tmp_cntr].pdb_num_res)) 
		    if ((strncmp(model->PDB[tmp_cntr].type,"hydrogen",5)==0) &&
			(model->PDB[tmp_cntr].pdb_iupac[0]=='H') &&
			(model->PDB[tmp_cntr].pdb_iupac[1]=='E') &&
			(model->PDB[tmp_cntr].pdb_iupac[2]=='2'))  {
			 model->PDB[tmp_cntr].written = TRUE ;
			 goto fuera ;
		    }
	  for (tmp_cntr = bucle; tmp_cntr <= model->DIH[ResNumber].number_of_atoms+i; tmp_cntr++) 
	       if ((model->PDB[tmp_cntr].written == FALSE) &&
		   (model->PDB[i].pdb_num_res == model->PDB[tmp_cntr].pdb_num_res)) 
		    if ((strncmp(model->PDB[tmp_cntr].type,"hydrogen",5)==0) &&
			(model->PDB[tmp_cntr].pdb_iupac[0]=='H') &&
			(model->PDB[tmp_cntr].pdb_iupac[1]=='E') &&
			(model->PDB[tmp_cntr].pdb_iupac[2]=='3'))  {
			 model->PDB[tmp_cntr].written = TRUE ;
			 goto fuera ;
		    }
	  
	  for (tmp_cntr = bucle; tmp_cntr <= model->DIH[ResNumber].number_of_atoms+i; tmp_cntr++) 
	       if ((model->PDB[tmp_cntr].written == FALSE) &&
		   (model->PDB[i].pdb_num_res == model->PDB[tmp_cntr].pdb_num_res)) 
		    if ((strncmp(model->PDB[tmp_cntr].type,"hydrogen",5)==0) &&
			(model->PDB[tmp_cntr].pdb_iupac[2]=='E')) {
			 model->PDB[tmp_cntr].written = TRUE ;
			 goto fuera ;
		    }
	  
	  for (tmp_cntr = bucle; tmp_cntr <= model->DIH[ResNumber].number_of_atoms+i; tmp_cntr++) 
	       if ((model->PDB[tmp_cntr].written == FALSE) &&
		   (model->PDB[i].pdb_num_res == model->PDB[tmp_cntr].pdb_num_res)) 
		    if ((strncmp(model->PDB[tmp_cntr].type,"hydrogen",5)==0) &&
			(model->PDB[tmp_cntr].pdb_iupac[2]=='Z')) {
			 model->PDB[tmp_cntr].written = TRUE ;
			 goto fuera ;
		    }
	  /* XPLOR special */
	  for (tmp_cntr = bucle; tmp_cntr <= model->DIH[ResNumber].number_of_atoms+i; tmp_cntr++) 
	       if ((model->PDB[tmp_cntr].written == FALSE) &&
		   (model->PDB[i].pdb_num_res == model->PDB[tmp_cntr].pdb_num_res)) 
		    if ((strncmp(model->PDB[tmp_cntr].type,"hydrogen",5)==0) &&
			(model->PDB[tmp_cntr].pdb_iupac[0]=='H') &&
			(model->PDB[tmp_cntr].pdb_iupac[1]=='H') &&
			(model->PDB[tmp_cntr].pdb_iupac[2]=='1'))  {
			 model->PDB[tmp_cntr].written = TRUE ;
			 goto fuera ;
		    }
	  for (tmp_cntr = bucle; tmp_cntr <= model->DIH[ResNumber].number_of_atoms+i; tmp_cntr++) 
	       if ((model->PDB[tmp_cntr].written == FALSE) &&
		   (model->PDB[i].pdb_num_res == model->PDB[tmp_cntr].pdb_num_res)) 
		    if ((strncmp(model->PDB[tmp_cntr].type,"hydrogen",5)==0) &&
			(model->PDB[tmp_cntr].pdb_iupac[0]=='H') &&
			(model->PDB[tmp_cntr].pdb_iupac[1]=='H') &&
			(model->PDB[tmp_cntr].pdb_iupac[2]=='2'))  {
			 model->PDB[tmp_cntr].written = TRUE ;
			 goto fuera ;
		    }
	  for (tmp_cntr = bucle; tmp_cntr <= model->DIH[ResNumber].number_of_atoms+i; tmp_cntr++) 
	       if ((model->PDB[tmp_cntr].written == FALSE) &&
		   (model->PDB[i].pdb_num_res == model->PDB[tmp_cntr].pdb_num_res)) 
		    if ((strncmp(model->PDB[tmp_cntr].type,"hydrogen",5)==0) &&
			(model->PDB[tmp_cntr].pdb_iupac[0]=='H') &&
			(model->PDB[tmp_cntr].pdb_iupac[1]=='H') &&
			(model->PDB[tmp_cntr].pdb_iupac[2]=='3'))  {
			 model->PDB[tmp_cntr].written = TRUE ;
			 goto fuera ;
		    }
	  
	  for (tmp_cntr = bucle; tmp_cntr <= model->DIH[ResNumber].number_of_atoms+i; tmp_cntr++) 
	       if ((model->PDB[tmp_cntr].written == FALSE) &&
		   (model->PDB[i].pdb_num_res == model->PDB[tmp_cntr].pdb_num_res)) 
		    if ((strncmp(model->PDB[tmp_cntr].type,"hydrogen",5)==0) &&
			(model->PDB[tmp_cntr].pdb_iupac[2]=='H')) {
			 model->PDB[tmp_cntr].written = TRUE ;
			 goto fuera ;
		    }
	  
	  if (model->PDB[i].written == TRUE) continue ;
	  
	  /*
	   * If we get here something was wrong in the selections before
	   * so we try to produce an informative warning for the user
	   */
	  (void) fprintf(stderr,"> WRITE_coords_pdb: *WARNING* something went wrong with atom %s \n", 
			 model->PDB[i].pdb_iupac);
	  
	  /*
	   * Finally, writing the file
	   */  
     fuera:
	  temporalcount++;
	  
	  if (model->PDB[tmp_cntr].pdb_chain_id[0] == '1')
	       model->PDB[tmp_cntr].pdb_chain_id[0]='A';
	  
	  if (( loption != 7 ) && ( loption != 0 ) && model->PDB[tmp_cntr].pdb_chain_id[0] != ' ') 
	       model->PDB[tmp_cntr].pdb_chain_id[0] = Identificador[key_model%64] ;
	  
	  /*
	   * Usually we work with NMR data so the fields for data1 and data2 
	   * are meaningless and we set data1 to 1.00 and data2 to 0.0
	   */
	  model->PDB[tmp_cntr].pdb_data1 = 1.0 ;
	  model->PDB[tmp_cntr].pdb_data2 = 0.0 ;
	  
	  if ( model->PDB[tmp_cntr].pdb_chain_id[0] != TmpChainId[0] ) {
	       strcpy(TmpChainId,model->PDB[tmp_cntr].pdb_chain_id);
	       ResTer = tmp_cntr ;
	       fprintf(rtto,"TER   %5d      %3s %1s%4d\n",
		       ++temporalcount,
		       model->PDB[ResTer-1].pdb_res,
		       model->PDB[ResTer-1].pdb_chain_id,
		       model->PDB[ResTer-1].pdb_num_res);
	  }

	  fprintf(rtto, "ATOM  %5d %-5s%3s %1s%4d    %8.3f%8.3f%8.3f%6.2f%6.2f      %-4s %-1s \n",
		  temporalcount,
		  model->PDB[tmp_cntr].pdb_iupac,
		  model->PDB[tmp_cntr].pdb_res,
		  model->PDB[tmp_cntr].pdb_chain_id,
		  model->PDB[tmp_cntr].pdb_num_res,
		  model->PDB[tmp_cntr].pdb_xcrd,
		  model->PDB[tmp_cntr].pdb_ycrd,
		  model->PDB[tmp_cntr].pdb_zcrd,
		  model->PDB[tmp_cntr].pdb_data1,
		  model->PDB[tmp_cntr].pdb_data2,
		  model->PDB[tmp_cntr].segid,
		  model->PDB[tmp_cntr].AtomType);
	  ResTer = tmp_cntr ;
     }
     
     /*
      * we need a line with TER word on it
      */
     fprintf(rtto,"TER   %5d      %3s %1s%4d\n",
	     ++temporalcount,
	     model->PDB[ResTer].pdb_res,
	     model->PDB[ResTer].pdb_chain_id,
	     model->PDB[ResTer].pdb_num_res);
     if (loption == 6) 
	  ;
     else {
	  if (ChainsInModel > 1) 
	       if (key_model % ChainsInModel == 0)
		    fprintf(rtto,"ENDMDL\n");
	  if (ChainsInModel == 1) 
	       fprintf(rtto,"ENDMDL\n");
     } 
     fflush(rtto);
     return ;
}



/* ========================================================================= */
/*

   To be developed

void write_coords_disman(FILE *rtti)
{
 printf(" ***** NOT YET DEVELOPPED ****** ");
}

*/


/* ========================================================================= */
void do_average_coords(char tipo[MAXWORD])
/*
  ---
  --- Trying to obtain the average coordinates (independently of the format)
  --- PDB or DISMAN or any.
  ---
  --- Be careful, is TOTALLY experimental right now!!!!!!
  ---
  --- (Roberto Tejero, RTT, July 1993, CABM-Rutgers University).
  ---
*/
{
     float         sumax=0.0, sumay=0.0, sumaz=0.0 ;
     int           FoundModels=0, katom=-1, CountWarns=0;
     char          WarnMess=FALSE;
     static struct models *model, *ModRef, *Mod1 ;
     static char   Tipo[MAXWORD];
     
     Mod1 = MODELS + 1 ; 
     ModRef = MODELS+AverageModel ;
     
     switch (tipo[0]) {
     case 'B':
     case 'b':
	  strcpy(Tipo,"backbone");
	  break;
     case 'H':
     case 'h':
	  strcpy(Tipo,"heavy");
	  break;
     case 'A':
     case 'a':
	  strcpy(Tipo,"all");
	  break;
     default:
	  strcpy(Tipo,"");
	  break;
     }
     
     if (strcmp(Tipo,"")==0) strcpy(Tipo,"backbone");
     printf("> do_average_coords(): Making average for %s atoms \n",Tipo);

     printf("> do_average_coords(): Calculating center of masses \n");  
     for (i = 1 ; i <= total_models ; i++) {
	  key_model = i ;
	  /* if ( (MODELS+i)->Selected ) */
	  CenterMass(999) ;
     }
     
     /*
      * Optimally rotate the coordinates for all models in the set
      */
     printf("> do_average_coords(): Calling optimal rotation for %s \n", Tipo);  
     for (i = 2 ; i <= total_models ; i++) {
	  /* if ( (MODELS+i)->Selected ) */
	  (void) optimal_rotate(1,i,100,1,Tipo);
     }
     
     /*
      * Make average of coordinates, we assume we have optimally rotated
      * the structure. 
      *
      * As JUL-AUG 97 it does a check to find the right atoms in the set
      * it takes much more time but it's safer finding the right atoms in the
      * other molecules (maybe the numbering is different through the different
      * coordinates.
      */
     printf("> do_average_coords(): Calc. average coordinates %s \n", Tipo);  
     
     for (k = 1 ; k <= Mod1->number_of_atoms ; k++) {
	  sumax = 0.0 ;
	  sumay = 0.0 ;
	  sumaz = 0.0 ; 
	  FoundModels = 0;
	  
	  for (i = 1 ; i <= total_models ; i++)  {
	       /* if ( (MODELS+i)->Selected ) { */
	       model = MODELS+i ;
	       if ((katom = FindSameAtom(i,1,k)) != -1) {
		    FoundModels++;
		    sumax = sumax + model->PDB[katom].pdb_xcrd ;
		    sumay = sumay + model->PDB[katom].pdb_ycrd ;
		    sumaz = sumaz + model->PDB[katom].pdb_zcrd ;
	       } else {
		    CountWarns++;
		    if (CountWarns < 5) {
			 fprintf(stderr," *** do_average_coords(): *DIFFERENT* model %d Res %s%d Atom %s\n",
				 i,Mod1->PDB[k].pdb_res, Mod1->PDB[k].pdb_num_res, Mod1->PDB[k].pdb_iupac);
			 WarnMess = TRUE;
		    }
	       }
	       
	       if ((WarnMess == TRUE) && (i == total_models) && (k == Mod1->number_of_atoms)) {
		    WarnMess = FALSE;
		    fprintf(stderr," *** do_average_coords(): Expect wrong values\n");
	       }  
	  }
	  
	  /*
	   * Copying relevant info from one of the models --model 1--
	   * to average model
	   */
	  strcpy(ModRef->PDB[k].chain, Mod1->PDB[k].chain);
	  strcpy(ModRef->PDB[k].type, Mod1->PDB[k].type);
	  strcpy(ModRef->PDB[k].pdb_key, Mod1->PDB[k].pdb_key);
	  
	  ModRef->PDB[k].written = FALSE;
	  
	  ModRef->PDB[k].TruePdb  = Mod1->PDB[k].TruePdb;
	  ModRef->PDB[k].Selected = Mod1->PDB[k].Selected;
	  ModRef->PDB[k].pdb_num  = Mod1->PDB[k].pdb_num;
	  
	  ModRef->PDB[k].pdb_xcrd = sumax / FoundModels ;
	  ModRef->PDB[k].pdb_ycrd = sumay / FoundModels ;
	  ModRef->PDB[k].pdb_zcrd = sumaz / FoundModels ;
	  
	  ModRef->PDB[k].coord[0] = sumax / FoundModels ;
	  ModRef->PDB[k].coord[1] = sumay / FoundModels ;
	  ModRef->PDB[k].coord[2] = sumaz / FoundModels ;
	  
	  ModRef->PDB[k].pdb_masa    = Mod1->PDB[k].pdb_masa;
	  ModRef->PDB[k].pdb_num_res = Mod1->PDB[k].pdb_num_res;
	  ModRef->PDB[k].pdb_num_res_orig = Mod1->PDB[k].pdb_num_res_orig;
	  ModRef->PDB[k].pdb_data1   = Mod1->PDB[k].pdb_data1;
	  ModRef->PDB[k].pdb_data2   = Mod1->PDB[k].pdb_data2;
	  
	  strcpy(ModRef->DIH[Mod1->PDB[k].pdb_num_res].resname, Mod1->DIH[Mod1->PDB[k].pdb_num_res].resname);
	  strcpy(ModRef->DIH[Mod1->PDB[k].pdb_num_res].thrletter, Mod1->DIH[Mod1->PDB[k].pdb_num_res].thrletter);
	  strcpy(ModRef->DIH[Mod1->PDB[k].pdb_num_res].oneletter, Mod1->DIH[Mod1->PDB[k].pdb_num_res].oneletter);
	  strcpy(ModRef->DIH[Mod1->PDB[k].pdb_num_res].fullname, Mod1->DIH[Mod1->PDB[k].pdb_num_res].fullname);
	  ModRef->DIH[Mod1->PDB[k].pdb_num_res].resnumber = Mod1->DIH[Mod1->PDB[k].pdb_num_res].resnumber ;
	  ModRef->DIH[Mod1->PDB[k].pdb_num_res].resnumber_orig = Mod1->DIH[Mod1->PDB[k].pdb_num_res].resnumber_orig ;
	  ModRef->DIH[Mod1->PDB[k].pdb_num_res].number_of_atoms = Mod1->DIH[Mod1->PDB[k].pdb_num_res].number_of_atoms ;
	  ModRef->DIH[Mod1->PDB[k].pdb_num_res].orden = Mod1->DIH[Mod1->PDB[k].pdb_num_res].orden ;
	  
	  strcpy(ModRef->PDB[k].pdb_iupac,	Mod1->PDB[k].pdb_iupac);
	  strcpy(ModRef->PDB[k].pdb_res,  	Mod1->PDB[k].pdb_res); 
	  strcpy(ModRef->PDB[k].pdb_key,  	Mod1->PDB[k].pdb_key);
	  strcpy(ModRef->PDB[k].pdb_chain_id, Mod1->PDB[k].pdb_chain_id);
	 
	  /*
	  if (strcmp(ModRef->PDB[k].pdb_chain_id,"1")==0) 
	       strcpy(ModRef->PDB[k].pdb_chain_id,"A");
	  */
     }
     
     ModRef->number_of_atoms    = Mod1->number_of_atoms ;
     ModRef->modelno            = AverageModel ;
     ModRef->SerialNumber       = AverageModel ;
     ModRef->number_of_residues = Mod1->number_of_residues ;
     ModRef->starting_res       = Mod1->starting_res ;
     key_model = AverageModel ;
     CenterMass(999);
     key_model = 1 ;
     return;
}


/* ========================================================================= */
void do_average_selected(char tipo[MAXWORD])
/*
 * Trying to obtain the average coordinates (independently of the format)
 * for a selected subset. This routine is totally similar to the one
 * above only is changed the behaviour to look for selected atoms for the
 * average coordinates.
 *
 * IMPORTANT NOTE: It seems to work reliably BUT is is NOT foolproof yet.
 * 
 * (Roberto Tejero, RTT, Valencia 1999, CABM-Rutgers University).
 */
{
     float         sumax=0.0, sumay=0.0, sumaz=0.0 ;
     int           FoundModels=0, katom=-1, CountWarns=0;
     int           NumberOfAtoms=0, NumberOfResidues=0;
     char          WarnMess=FALSE, TmpResName[4];
     static struct models *model, *ModRef, *Mod1 ;
     int           ReferenceModel ;
    
     /* Look for first selected model */
     for ( i = 1 ; i <= total_models; i++)
	     if ( (MODELS+i)->Selected ) {
		     ReferenceModel = i ;
		     break ;
	     }
     Mod1 = MODELS + ReferenceModel ; 
     ModRef = MODELS+AverageModel ;
     
     printf("> do_average_selected(): Calculating center of masses \n");  
     for (i = 1 ; i <= total_models ; i++) {
	  key_model = i ;
	  if ( (MODELS+i)->Selected )  
	       CenterMass(995) ;
     }
     
     /*
      * Optimally rotate the coordinates for all models around selected set
      */
     printf("> do_average_selected(): Calling optimal rotation for %s \n", tipo);  
     for (i = 2 ; i <= total_models ; i++) {
	  if ( (MODELS+i)->Selected ) 
	       (void) optimal_rotate(ReferenceModel,i,100,1,"selected");
     }
     
     /*
      * Make average of coordinates, we assume we have optimally rotated
      * the structure. ONLY selected atoms are going to be worked out.
      */
     printf("> do_average_selected(): Calc. average coordinates %s \n", tipo);  
     
     NumberOfAtoms = 0;
     NumberOfResidues = 0;
     
     /*
      * This is used to check if one atom has been already studied. The variable
      * written is set to FALSE (not used yet) of TRUE (used) for each residue.
      * This way we avoid to confuse two residues when they have the same name
      * but different number. The main use of this variable is in routine
      * FindSameSelectedAtom whose task is to locate the atom taking care of
      * if it has been used before or not..
      */
     for (i = 1; i <= total_models; i++) {
	  model = MODELS + i;
	  for (k = 1; k <= model->number_of_atoms; k++)
	       model->PDB[k].written = FALSE;
     }
     
     /*
      * Looking process start running through all atoms in Model 1 (arbitrary
      * decision) and then going through all models one by one looking for 
      * exactly the 'same' selected atom. Please note that here the 'same' 
      * selected atom might be an atom in same residue name BUT different
      * residue number. If we like to use ONLY atoms (i.e. no residue number nor
      * name at all) one should change this routine.
      *
      * Another difference is we start using NumberOfAtoms and NumberOfResidues
      * to account for the atoms and residues found in the 'selection'.
      */
     for (k = 1 ; k <= Mod1->number_of_atoms ; k++)
	  if ( (Mod1->PDB[k].Selected) && !(Mod1->PDB[k].written) ) {
	       sumax = 0.0 ;      sumay = 0.0 ;      sumaz = 0.0 ; 
	       NumberOfAtoms++ ;
	       if (strcmp(TmpResName,Mod1->PDB[k].pdb_res)!=0) {
		    strcpy(TmpResName,Mod1->PDB[k].pdb_res);
		    NumberOfResidues++ ;
	       }
	       
	       if (DEBUG >= 3)
		    printf("> do_average_selected(): Working .. %3d %s%-3d %s %5d \n",
			   Mod1->modelno,
			   Mod1->PDB[k].pdb_res,
			   Mod1->PDB[k].pdb_num_res,
			   Mod1->PDB[k].pdb_iupac,
			   NumberOfAtoms);
	       
	       FoundModels = 0;
	       
	       for (i = 1 ; i <= total_models ; i++) 
		    if ( (MODELS+i)->Selected ) {
			 model = MODELS+i ;
			 if ( ((katom = FindSameSelectedAtom(i,1,k,"ave")) != -1) &&
			      !(MODELS+i)->PDB[katom].written ) {
			      model->PDB[katom].written = TRUE;
			      FoundModels++;
			      sumax = sumax + model->PDB[katom].pdb_xcrd ;
			      sumay = sumay + model->PDB[katom].pdb_ycrd ;
			      sumaz = sumaz + model->PDB[katom].pdb_zcrd ;
			 } else {
			      CountWarns++;
			      if (CountWarns < 5) {
				   fprintf(stderr," * do_average_selected(): *DIFFERENT* "
					   " %3d  %s%-3d  %s  --  %3d  %s%-3d  %s \n",
					   i,Mod1->PDB[k].pdb_res,
					   Mod1->PDB[k].pdb_num_res,
					   Mod1->PDB[k].pdb_iupac,
					   i,model->PDB[k].pdb_res,
					   model->PDB[k].pdb_num_res,
					   model->PDB[k].pdb_iupac);
				   WarnMess = TRUE;
			      }
			 }
		    }
	       
	       if ((WarnMess == TRUE) && (i==total_models) && 
		   (k == Mod1->number_of_atoms)) {
		    WarnMess = FALSE;
		    fprintf(stderr," *** do_average_coords(): Expect wrong values\n");
	       }        
	       
	       strcpy(ModRef->PDB[NumberOfAtoms].chain, Mod1->PDB[k].chain);
	       strcpy(ModRef->PDB[NumberOfAtoms].type, Mod1->PDB[k].type);
	       
	       ModRef->PDB[NumberOfAtoms].written = FALSE;
	       
	       ModRef->PDB[NumberOfAtoms].Selected = Mod1->PDB[k].Selected;
	       ModRef->PDB[NumberOfAtoms].pdb_num  = Mod1->PDB[k].pdb_num;
	       
	       ModRef->PDB[NumberOfAtoms].pdb_xcrd = sumax / FoundModels ;
	       ModRef->PDB[NumberOfAtoms].pdb_ycrd = sumay / FoundModels ;
	       ModRef->PDB[NumberOfAtoms].pdb_zcrd = sumaz / FoundModels ;
	       
	       ModRef->PDB[NumberOfAtoms].coord[0] = sumax / FoundModels ;
	       ModRef->PDB[NumberOfAtoms].coord[1] = sumay / FoundModels ;
	       ModRef->PDB[NumberOfAtoms].coord[2] = sumaz / FoundModels ;
	       
	       ModRef->PDB[NumberOfAtoms].pdb_masa    = Mod1->PDB[k].pdb_masa;
	       ModRef->PDB[NumberOfAtoms].pdb_num_res = Mod1->PDB[k].pdb_num_res;
	       ModRef->PDB[NumberOfAtoms].pdb_data1   = Mod1->PDB[k].pdb_data1;
	       ModRef->PDB[NumberOfAtoms].pdb_data2   = Mod1->PDB[k].pdb_data2;
	       
	       strcpy(ModRef->DIH[NumberOfResidues].resname,
		      Mod1->DIH[Mod1->PDB[k].pdb_num_res].resname);
	       
	       strcpy(ModRef->PDB[NumberOfAtoms].pdb_iupac,   Mod1->PDB[k].pdb_iupac);
	       strcpy(ModRef->PDB[NumberOfAtoms].pdb_res,     Mod1->PDB[k].pdb_res); 
	       strcpy(ModRef->PDB[NumberOfAtoms].pdb_key,     Mod1->PDB[k].pdb_key);
	       strcpy(ModRef->PDB[NumberOfAtoms].pdb_chain_id,Mod1->PDB[k].pdb_chain_id);
	       
	       if (strcmp(ModRef->PDB[NumberOfAtoms].pdb_chain_id,"1")==0)
		    strcpy(ModRef->PDB[NumberOfAtoms].pdb_chain_id,"A");
	  }
     
     ModRef->number_of_atoms    = NumberOfAtoms ;
     ModRef->number_of_residues = NumberOfResidues;
     ModRef->modelno            = AverageModel ;
     ModRef->SerialNumber       = AverageModel ;
     ModRef->starting_res       = MODELS->starting_res ;
     key_model = AverageModel ;
     CenterMass(995); /* 995 only for selected atoms */
     key_model = 1 ;
     return;
}


/* ========================================================================= */
/*
 *  * Routine to dump the general header (for all models) stored when the coordinates
 *   * were read in.
 *    */
void DumpHeader(FILE *rtto)
{
     static short recon_line = 0 ;
     recon_line = 0;
     while ( WriteHeader && strncmp(HeaderPdb[++recon_line],"STOP",4)!=0) {
             if ( recon_line >= MAXREMARKRECS-1 ) break ;
             fprintf(rtto,"%s",HeaderPdb[recon_line]);
     }
     return ;
}
                                                                                                                                                                    
                                                                                                                                                                    
/* ========================================================================= */
/*
 *  * Routine to dump a header file composed of REMARK records stored when the
 *   * coordinates were read in.  It is the same as above with records that are
 *    * not REMARK removed.
 *     */
void DumpModelHeader(FILE *rtto, struct models *model)
{
     static short recon_line = 0;
     recon_line = 0;
     while ( WriteModelHeader && strncmp(model->HeaderPdbModel[++recon_line],"STOP",4)!=0 ) {
             if ( recon_line >= MAXREMARKMODRECS-1 ) break ;
             fprintf(rtto,"%s",model->HeaderPdbModel[recon_line]);
     }
     return ;
}

