/*$Id: write_sequence.c,v 3.32 2003/10/06 12:13:32 roberto Exp roberto $*/

#include "pdbstat.h"	
static short i ;

/*
 * Con fecha de Enero de 1997 ha pasado a ser un nuevo modulo.
 * Se le ha aadido como opcion el poder seleccionar dos tipos
 * de formato para la escritura de secuencia
 *     o     CONGEN - formato PDB para inputs de CONGEN
 *     o     DISMAN - formato A3 una sola linea por residuo
 */

/* ========================================================================= */
void write_sequence(FILE *rtto, char formato[10], char type[10])
     /*
      * This routine prepares an input of sequence for the program CONGEN.
      * Writes down a few lines as title and the the number of residues
      * in the equivalent of format I5 and then the sequence as A5 with
      * lines of 10 residues long.
      *
      * (Roberto Tejero, RTT, May 1993, CABM-Rutgers University).
      */
{
     static short  TotalRes ;
     static char   tmp_name[MAXWORD];
     static struct models *KeyMod;
     
     /* KeyMod = MODELS + key_model ; */
     
     KeyMod = MODELS+1 ;
     printf("\n");
     
     if (KeyMod->number_of_residues <= 0) {
	  printf("> WRITE_sequence: ** No data about sequence to write ** \n");
	  return;
     }
     
     TotalRes = KeyMod->number_of_residues + KeyMod->starting_res - 1;
     
     if (DEBUG > 5) {
	  fprintf(stdout," DEBUG: write_sequence(), writing %4d residues, starting at %2d (%3d)\n",
		  KeyMod->number_of_residues, KeyMod->starting_res, TotalRes);
     }
     
     if (name_of_the_file_sequence[0] == '\0')
	  strcpy(name_of_the_file_sequence, name_of_the_file_coords);
     
     for (i = 0 ; i <= strlen(name_of_the_file_sequence) ; i++)
	  tmp_name[i] = toupper(name_of_the_file_sequence[i]);
     
     if (strcasecmp(formato,"congen")==0) {
	  printf("> WRITE_seq: ==== SEQUENCE DATA FOR  `%s' === \n",tmp_name);
	  printf("> WRITE_seq: *\n");
	  printf("> WRITE_seq:%5d\n",KeyMod->number_of_residues);
	  printf("> WRITE_seq:");
	  
	  fprintf(rtto,"\n ==== SEQUENCE DATA FOR  `%s' === \n*\n",tmp_name);
	  fprintf(rtto,"%5d\n",KeyMod->number_of_residues);
	  
	  for(i = KeyMod->starting_res ; i <= TotalRes ; i++) {
	       fprintf(rtto,"%-5s",seqres[i]);
	       printf("%-5s",seqres[i]);
	       if (fmod(i,13) == 0.0) {
		    fprintf(rtto,"\n");
		    printf("\n> WRITE_seq:");
	       }
	  }
	  
	  /*
	   * Info about disulfides. This is for CONGEN purposes
	   */
	  if (disulfide_bonds == 0)
	       fprintf(rtto,"\n! DISULFIDE: ** NO INFO FOR DISULFIDES IN FILE \n");
	  else {
	       fprintf(rtto,"\nDISULFIDE\n");
	       fprintf(rtto," %4d\n",disulfide_bonds);
	       for ( i = 1 ; i <= disulfide_bonds ; i++)
		    fprintf(rtto,"%5d%5d \n", infodisu[i][1],infodisu[i][2]);
	  }
	  fprintf(rtto,"\n");
     } else if (strncasecmp(formato,"disman",3)==0) {
	  for(i = 1 ; i <= TotalRes ; i++) 
	       if (strncasecmp(type,"three",2)==0) {
		    fprintf(rtto,"%-4s\n",seqres[i]);
		    printf("%-4s\n",seqres[i]);
	       } else if (strncasecmp(type,"full",2)==0)	   {
		    fprintf(rtto,"%-4s\n",KeyMod->DIH[i].fullname);
		    printf("%-4s\n",KeyMod->DIH[i].fullname);
	       } else if (strncasecmp(type,"one",2)==0)	  {
		    fprintf(rtto,"%s",KeyMod->DIH[i].oneletter);
		    printf("%s",KeyMod->DIH[i].oneletter);
	       }      
	  
	  if (strncasecmp(type,"one",2)==0) {
	       fprintf(rtto,"\n");
	       printf("\n");
	  }	
     }
     fflush(rtto);
     return ;
}
