# ASDP ReadMe


1. Compile C/C++source code:

Two programs noesyassign and pdbstat are written in C/C++.

noesyassign:

	go to noeysassign/src/Release/ directory and type 'make noesyassign'

pdbstat:

	go to PDBSTAT/src directory and type `make` to follow the instruction.


2. Setup ASDP runs with clusters, cyana and xplor

a. Edit the file 'env.sh' for your computer system.

b. run "./config.pl"

c. Cluster

You may also need to edit the queue configuration file under 'queue' directory. If you are using PBS, edit file 'queue/PBS.pm'. If you are using SLURM, edit file 'queue/SLURM.pm'. If you are using something else, you need to work on file 'Custom.pm', change the queue_header to fit your system.

d. EC-NMR

cyana/openmpi compiled version is required if running on a cluster

e. perl/TK

In order to use the graphical user interface version of ASDP, you must have perl/TK installed.  TK can be downloaded and installed from http://search.cpan.org.  The command line version does not require TK.

3. How to run ASDP
Visit ASDP website: http://montelionelab.chem.rpi.edu/NMRsoftware/asdp for more details


For most of the programs, you may type the command for help.

asdp -> run in command-line

asdp-gui -> run with GUI interface

CreateProc -> Setup structure calculations with Cyana or Xplor on a cluster


Other tools:

bmrb2lacs.pl -> convert bmrb file to lacs input format (bija.nmrfam.wisc.edu/MANI-LACS/).

bmrb2talos.pl -> convert bmrb file to talos input format.

talos2aco.pl -> convert talos output to dihedral angle file in cyana format



4. Prepare Input

See examples directory

A. resonance assignment files in bmrb 2.1 or 3.1 format

B. peak lists

C. control-file (use asdp-gui to prepare or see examples)


5. Examples:

Visit ASDP website http://montelionelab.chem.rpi.edu/NMRsoftware/asdp/ for more info.

CtR69A:

	asdp run with cyana: asdp -c control_fileCyana -o runCyana
	asdp run with xplor: asdp -c control_fileXplor -o runXplor


oxidized_ET109 - it has a disulfide bond, a HIST with RDC data

	HIST is defined in the chemical shift file (final.bmrb) and special.lib
	Disulfide bond and RDC are defined in the control_fileNoCns file.
	Step 1: asdp run: asdp -c control_fileCyana -o runCyana
	Step 2: run CNSw Refinement

taf3 - it has two ZNs. one binds to 21C,24C,44H, 47C, and another binds to 36C,39C,62C,65C
	Zn binding residue modification - defined in the chemical shift file (final.bmrb) and special.lib

	Zn geometry constraints are zn_dist2.lol and zn_dist2.upl
	asdp run with no Cns: asdp -c control_filesCyana -o runCyana
