#!perl 

use strict; 
my ($table, $final, $pdb) = @ARGV; 

my @final; 
open(FINAL, "<$final"); 

while (<FINAL>)
{
    chomp;
    my ($a, $b, $w, $s) = split(/\s+/, $_); 
    if ($b < $a)
    {
	my $c = $b; 
	$b = $a; 
	$a = $c; 
    }
    push @final, "$a-$b"; 
}

my $finalEC = ";" . join(";", @final) . ";"; 

my @table; 
my @toDelete;
my %score; 
open(TABLE, "<$table"); 
while (<TABLE>)
{
    chomp; 
    $_ =~ s/^\s+//g; 
    my ($a, $b, $s) = split(/\s+/, $_); 
    if ($b < $a)
    {
	my $c = $b; 
	$b = $a; 
	$a = $c; 
    }

    if ($finalEC !~ /;$a\-$b;/)
    {
	push @toDelete, "$a-$b"; 
    }

    push @table, "$a-$b"; 
    $score{"$a-$b"} = $s;
}

my $ec = ";" . join(";", @table) . ";"; 
my $model = 0; 
my %atom; 

open(PDB, "<$pdb"); 

while (<PDB>)
{
    chomp;
    if ($_ =~ /MODEL/)
    {
	$model++; 
    }
    next if ($_ !~ /^ATOM/); 
    my ($atomName, $res, $x, $y, $z) = $_ =~ /ATOM\s+\d+\s*([\w\d]+)\s*\w+\s*A\s*(\d+)\s+(-*\d+\.\d+)\s*(-*\d+\.\d+)\s*(-*\d+\.\d+)/;
    $atom{$res}{$atomName}{$model} = $x . "/" . $y . "/" . $z; 
    #print "$atomName-$res-$model-$x-$y-$z\n";
}

foreach my $pair (@toDelete)
{
    my ($a1, $a2) = split(/-/, $pair); 

    next if ($a1 eq $a2);
    next if ($a2 < $a1); 
    
#    next if (abs($a2-$a1) < 5); 
#    next if ($ec !~ /;$a1-$a2;/); 
    
#	my ($num1, $name1) = split(/-/, $a1); 
#	my ($num2, $name2) = split(/-/, $a2); 
	
#	next if (abs($num1 - $num2) < 5); 
#	next if ($name1 !~ /^C/); 
#	next if ($name2 !~ /^C/); 
	
	#next if (($num1 != 2) && ($num1 !=104)); 
	#next if (($num2 != 2) && ($num2 != 104));  

    my $dismin = 100000; 
    
    foreach my $n1 (sort keys %{$atom{$a1}})
    {
	foreach my $n2 (sort keys %{$atom{$a2}})
	{
	    
	    #print "$num1-$name1, $num2-$name2\n"; 
	    #print "$a1-$n1, $a2-$n2 $dismin\n"; 
	    
	    for(my $i = 1; $i <= $model; $i++)
	    {
		my ($x1, $y1, $z1) = split(/\//, $atom{$a1}{$n1}{$i});
		my ($x2, $y2, $z2) = split(/\//, $atom{$a2}{$n2}{$i}); 
		my $dist = sqrt(($x1-$x2)**2+($y1-$y2)**2+($z1-$z2)**2); 
		$dismin = $dist if ($dist < $dismin); 
		#print "$i $atom{$a1}{$n1}{$i} $atom{$a2}{$n2}{$i} $dist  $dismin\n" if ($dist < 5.00001); 
	    }
	    
	}
    }
    
    
#	print "AmbigousNMRDistance\t$name1\t$num1\t$name2\t$num2\tBOUNDED\t1.80\t7.0\t0.3\tNOE\n" if (($dismax < 5.00001) && ($ec =~ /\/$pair\//)); 
    if (($dismin > 10.00001))
    {
	$score{"$a1-$a2"} = -1; 
#    print "$a1-$a2 $dismin voilated\n"; 
    }
}

foreach my $i (@table)
{
    my ($a, $b) = split(/-/, $i); 
    print "$a\t$b\t$score{$i}\n"; 
}
