
sub FileSelection
{
    my $dir_lbx;
    my $fil_lbx;
    
    my $new = 0;
   
    my ($cur_dir, $file_sel, $lbl, $command, $window, $basepath, $only_dir) = @_;
    chdir $basepath;

    $$cur_dir = $basepath;
    $$file_sel = '';

    my $ok = 0;


    my $file_dlg = $window->Toplevel();
    $file_dlg->minsize(qw/350 400/);
    $file_dlg->configure(-title=>$lbl);
    my $fil_ent;

    #interface
    my $frm1 = $file_dlg->Frame()->pack(-fill=>'x', -padx=>5, -pady=>5);
    my $dir_ent_lbl = $frm1->Label(-text=>'Directory')->pack(-side=>'left', -ipadx=>3, -ipady=>3);
    my $dir_ent = $frm1->Entry(-textvariable=>$cur_dir, -background=>'white')->pack(-side=>'left', -expand=>1, -fill=>'x', -ipadx=>3, -ipady=>3);
    
    my $frm2 = $file_dlg->Frame(-relief=>'ridge', -borderwidth=>2)->pack(-fill=>'both', -expand=>1);
    
    my $frm2a = $frm2->Frame()->pack(-fill=>'x', -padx=>5, -pady=>5);
    my $dir_lbl = $frm2a->Label(-text=>'Directories')->pack(-side=>'left', -fill=>'x', -expand=>1);
    my $fil_lbl = $frm2a->Label(-text=>'Files')->pack(-side=>'left', -fill=>'x', -expand=>1) unless ($only_dir);

    my $frm2b = $frm2->Frame()->pack(-fill=>'both', -expand=>1);
    my $scr_dir_lbx = $frm2b->Scrolled('Listbox', -scrollbars=>'osoe')->pack(-side=>'left', -fill=>'both', -expand=>1);
    $dir_lbx = $scr_dir_lbx->Subwidget('listbox');
    $dir_lbx->configure(-selectmode=>'single');
    

    unless ($only_dir)
    {
	my $scr_fil_lbx = $frm2b->Scrolled('Listbox', -scrollbars=>'osoe')->pack(-side=>'left', -fill=>'both', -expand=>1);
	$fil_lbx = $scr_fil_lbx->Subwidget('listbox');
	$fil_lbx->configure(-selectmode=>'single');
	
	my $frm3 = $file_dlg->Frame()->pack(-fill=>'x', -expand=>1);
	my $fil_ent_lbl = $frm3->Label(-text=>'File Selected')->pack(-side=>'left');
	
	$fil_ent = $frm3->Entry(-background=>'white', -textvariable=>$file_sel);
	$fil_ent->pack(-fill=>'x', -expand=>1);
	
    }

    my $frm4 = $file_dlg->Frame(-relief=>'ridge', -borderwidth=>2)->pack(-fill=>'x');
    my $ok_but = $frm4->Button(-text=>'Select')->pack(-side=>'left', -padx=>5, -pady=>5, -expand=>1);
    my $can_but = $frm4->Button(-text=>'Cancel')->pack(-side=>'left', -padx=>5, -pady=>5, -expand=>1);

    unless ($only_dir)
    {

	my $frm5 = $file_dlg->Frame(-relief=>'groove', -borderwidth=>2)->pack(-side=>'top', -fill=>'x', -expand=>1, -pady=>5, -after=>$frm1, -before=>$frm2);
	my $new_but = $frm5->Button(-text=>'Make new Directory', -command=>sub 
				    {
					my $new_dir;
					my $dir_dlg = $file_dlg->Toplevel();
					
					my $lbl = $dir_dlg->Label(-text=>'Create New Directory:')->pack(-side=>'top', -fill=>'x', -expand=>1, -pady=>5);
					my $ent = $dir_dlg->Entry(-width=>20)->pack(-side=>'top', -expand=>1, -pady=>5);
					my $but_frm = $dir_dlg->Frame()->pack(-fill=>'x', -expand=>1);
					my $ok_but = $but_frm->Button(-text=>'OK', -command=>sub
								      {
									  $new_dir = $ent->get;
									  if ($new_dir)
									  {
									      mkdir $new_dir;
									      $$cur_dir = $new_dir;
									      $new = 1;
									      &populate_dir($only_dir, $cur_dir, $dir_lbx, $file_sel, $fil_lbx);
									      $dir_dlg->destroy();
									  }
								      }
								      )->pack(-expand=>1, -padx=>5);
					my $can_but = $but_frm->Button(-text=>'Cancel', -command=>sub {$dir_dlg->destroy();})->pack(-expand=>1, -padx=>5);
				    }
				    )->pack(-side=>'left', -expand=>1, -padx=>5);
    }
    &populate_dir($only_dir, $cur_dir, $dir_lbx, $file_sel, $fil_lbx);
    
    if ($only_dir)
    {
	$dir_lbx->bind('<Button-1>', sub 
		       {
			   if ($dir_lbx->curselection())
			   {
			       $$cur_dir = File::Spec->rel2abs($dir_lbx->get($dir_lbx->curselection()));
			   }
		       });
    }
    
    $dir_lbx->bind('<Double-Button-1>', sub 
		   {
		       if ($dir_lbx->curselection())
		       {			   
			   $$cur_dir = $dir_lbx->get($dir_lbx->curselection());
			   &populate_dir($only_dir, $cur_dir, $dir_lbx, $file_sel, $fil_lbx);
		       }
		   }
		   );

    unless ($only_dir)
    {
	$fil_lbx->bind('<Button-1>', sub 
		       {
			   if ($fil_lbx->curselection())
			   {
			       $$file_sel = $fil_lbx->get($fil_lbx->curselection());
			   }
		       }
		       );
    
	$fil_lbx->bind('<Double-Button-1>', sub 
		       {
			   if ($fil_lbx->curselection())
			   {
			       $$file_sel = $fil_lbx->get($fil_lbx->curselection());
			       $$file_sel = File::Spec->rel2abs($$file_sel);
			       $file_dlg->destroy();
			   }
		       }
		       );
	$fil_ent->bind('<Key-Return>', sub
		       {
			   $ok_but->invoke();
		       });
	
    }
    
    $dir_ent->bind('<Key-Return>', sub 
		   {
		       if ($$cur_dir)
		       {
			   if ($$cur_dir =~ /^~(.*)/)
			   {
			       print "cur_dir starts with ~, and 1 is $1\n";
			       
			       if ($1)
			       {
				   if ($1 =~ /^\//)
				   {
				       $$cur_dir =~ s/^~/$ENV{'HOME'}/;
				       print "cur_dir changed to $$cur_dir\n";
				   }
				   else
				   {
				       print "1 does not start with /\n";
				       my $home = $ENV{'HOME'};
				       my @items = split(/\//, $home);
				       my $user = $items[$#items];
				       print "substituting $user with $1 in $home\n";
				       my $new_user = $1;
				       $home =~ s/$user/$new_user/;
				       print "home is now $home\n";
				       $$cur_dir = $home;
				       print "cur_dir changed to $$cur_dir\n";
				   }				       
			       }
			       else
			       {
				   $$cur_dir =~ s/^~/$ENV{'HOME'}/;
				   print "cur_dir changed to $$cur_dir\n";
			       }
			   }

			   if (-d $$cur_dir)
			   {
			       &populate_dir($only_dir, $cur_dir, $dir_lbx, $file_sel, $fil_lbx);
			   }
		       }
		   });
    
    $ok_but->configure(-command=>sub 
		       {
			   $ok = 1;
			   if ($only_dir and $$cur_dir)
			   {
			       if ($$cur_dir =~ /^~(.*)$/)
			       {
				    #print "cur_dir starts with ~, and 1 is $1\n";
			       
				    if ($1)
				    {
					if ($1 =~ /^\//)
					{
					    $$cur_dir =~ s/^~/$ENV{'HOME'}/;
					    print "cur_dir changed to $$cur_dir\n";
					}
					else
					{
					    #print "$1 does not start with /\n";
					    my $home = $ENV{'HOME'};
					    my @items = split(/\//, $home);
					    my $user = $items[$#items];
					    #print "substituting $user with $1 in $home\n";
					    my $new_user = $1;
					    $home =~ s/$user/$new_user/;
					    #print "home is now $home\n";
					    $$cur_dir = $home;
					    #print "cur_dir changed to $$cur_dir\n";
					}				       
				    }
				    else
				    {
					$$cur_dir =~ s/^~/$ENV{'HOME'}/;
					#print "cur_dir changed to $$cur_dir\n";
				    }
				}
			       
			       $$cur_dir = File::Spec->rel2abs($$cur_dir, $basepath);
			       $file_dlg->destroy();
			   }
			   elsif ($$file_sel)
			   {
			       $$file_sel = File::Spec->rel2abs($$file_sel);
			       $file_dlg->destroy();
			   }
			   
		       });
    $can_but->configure(-command=>sub {$ok = 0; $$file_sel = ''; $$cur_dir = ''; $file_dlg->destroy();});
    
    $file_dlg->OnDestroy(sub
			 {
			     unless ($ok)
			     {
				 $$file_sel = '';
				 $$cur_dir = '';
				 $file_dlg->destroy();
			     }
			 });


    $file_dlg->waitWindow;
    
}
#end sub fileselection

sub populate_dir
{

    #populates the dir listbox with the subdirectories

    my ($only_dir, $cur_dir, $dir_lbx, $file_sel, $fil_lbx) = @_;

    chdir $$cur_dir;
    $$cur_dir = Cwd::cwd();

    $dir_lbx->delete('0.1', 'end');
    unless ($only_dir)
    {
	$fil_lbx->delete('0.1', 'end');
    }

    opendir DIR, $$cur_dir;
    my $name;

    my @names = sort {lc($a) cmp lc($b)}readdir(DIR);

    foreach $name (@names)
    {
	chomp($name);
	if ($name !~ /^\.\w+/)
	{
	    if (-f $name and !$only_dir)
	    {
		$fil_lbx->insert('end', $name);
	    }
	    elsif (-d $name)
	    {
		$dir_lbx->insert('end', $name);
	    }
	    
	}
    }
    $$file_sel = '';
    close DIR;
    

}
#end sub populate dir

sub OpenFile
{
    my ($lbl, $window, $basepath, $file_sel_orig) = @_;    

    my $cur_dir;
    my $file_sel;

    &FileSelection(\$cur_dir, \$file_sel, $lbl, 'open', $window, $basepath, 0);
    #print "file_sel: $file_sel\n";
    #print "basepath: $basepath\n";
    chdir $basepath;
    
    if ($file_sel =~ /$basepath/)
    {
	$file_sel =~ s/$basepath\///;
    }
    chdir $basepath;
    
    if (($file_sel =~/[\d\w]/))
    {
	$$file_sel_orig = $file_sel; 
    }

    return $file_sel;
}

sub SaveFile
{
    my ($lbl, $window, $basepath) = @_;
    my $cur_dir;
    my $file_sel;

    &FileSelection(\$cur_dir, \$file_sel, $lbl, 'save', $window, $basepath, 0);

    if ($file_sel)
    {
	print "SaveFile: returning $file_sel\n";
	return $file_sel;
    }
    
}

sub OpenDir
{
    my ($lbl, $window, $basepath) = @_;
    my $cur_dir;
    my $file_sel;
    
    &FileSelection(\$cur_dir, \$file_sel, $lbl, 'open', $window, $basepath, 1);

    chdir $basepath;
    #print "OpenDir: returning cur_dir as $cur_dir\n";

    if ($cur_dir =~ /$basepath/)
    {
	$cur_dir =~ s/$basepath\///;
    }
    return $cur_dir;
    
}



return 1;
