my $bg = '#EFF8FF';
my $but_bg = '#265580';
my $but_fg = $bg;
my $cbt_act = '#D1E4F2';
my $but_act = '#2D4455';
my $nb1_bg = '#9EBCD2';
my $nb2_bg = '#78A1BF';

sub build_rpf_gui
{
    my ($main, $basepath, $rpf_vals) = @_;
    
    my $txt_pdb;
    my $ety_line = 0;
    my $pdb_done = 0;
    my $stat_txt = '';
    my ($key, $value);
    my $pid;
    my $tree;

    my $window = $main->Toplevel();
    
    $window->configure(-title=>'RPF Scores - Single');
    
    my $full_frm = $window->Frame(-background=>$bg)->pack(-fill=>'both', -expand=>1, -padx=>3, -pady=>3);
    
    my $path_lbl = $full_frm->Label(-background=>$bg, -text=>"Basepath - $$basepath", -relief=>'ridge', -borderwidth=>2)->pack(-fill=>'x', -expand=>1, -padx=>3, -pady=>3);
    
    my $opt_frm = $full_frm->Frame(-background=>$bg)->pack(-fill=>'x', -expand=>1, -padx=>3, -pady=>3);

    
    &rpf_create_row('-c', 1,1, 'Specify Control File', $opt_frm, $main, $basepath, $rpf_vals);
    
    &rpf_create_row('-ro', 1,1, 'Set RPF Output Directory', $opt_frm, $main, $basepath, $rpf_vals);
    
    &rpf_create_row('-q', 1,1, 'Structures given in pdb format with AS(IUPAC) naming for AutoQF program', $opt_frm, $main, $basepath, $rpf_vals);
    
    
    my $but_frm = $full_frm->Frame(-relief=>'ridge', -background=>$bg)->pack(-fill=>'both', -expand=>1, -padx=>3, -pady=>3);
    
    my $run_but = $but_frm->Button(-text=>'RUN', -background=>$but_bg, -foreground=>$but_fg, -font=>[-size=>11], -activebackground=>$but_act, -activeforeground=>$but_fg)
	->pack(-fill=>'x', -expand=>1, -padx=>5, -side=>'left');
    
    my $stp_but = $but_frm->Button(-text=>'STOP', -background=>$but_bg, -foreground=>$but_fg, -font=>[-size=>11], -activebackground=>$but_act, -activeforeground=>$but_fg, -state=>'disabled')
	->pack(-fill=>'x', -expand=>1, -padx=>5, -side=>'left');

    my $can_but = $but_frm->Button(-text=>'CLOSE', -background=>$but_bg, -foreground=>$but_fg, -font=>[-size=>11], -activebackground=>$but_act, -activeforeground=>$but_fg)
	->pack(-fill=>'x', -expand=>1, -padx=>5, -side=>'left');

    
    #notebook
    
    my $nb_frm = $full_frm->Frame(-relief=>'ridge', -borderwidth=>2, -background=>$bg)->pack(-fill=>'both', -expand=>1, -padx=>5, -pady=>5);
    
    my $nb = $nb_frm->NoteBook(-background=>$nb1_bg, -backpagecolor=>$bg, -inactivebackground=>$bg)->pack(-fill=>'both', -expand=>1);

    #pages in notebook
    my $txt_frm = $nb->add('txt_frm', -label=>'Log');
    my $rpf_frm = $nb->add('rpf_frm', -label=>'RPF Scores');
    my $tre_frm = $nb->add('tre_frm', -label=>'Tree View');
    $tre_frm->configure(-background=>$nb1_bg);
    $txt_frm->configure(-background=>$nb1_bg);
    $rpf_frm->configure(-background=>$nb1_bg);

    $txt_pdb = $txt_frm->Scrolled('Text', -scrollbars=>'oe', -background=>'white', -height=>20)->pack(-fill=>'x', -expand=>1, -padx=>3, -pady=>3);
    
    my $txt_stat = $txt_frm->Label(-textvariable=>\$stat_txt, -background=>$nb1_bg, -height=>2, -relief=>'sunken')->pack(-fill=>'x', -expand=>1);

    while (($key, $value) = each (%$rpf_vals))
    {
	if ($key =~ /cbt/i)
	{
	    $rpf_vals->{$key} = 1;
	}
    }

    $rpf_vals->{'c_ent_val'} = '';
    
    $run_but->configure(-command=>sub 
		       {
			   if ($rpf_vals->{'ro_ent_val'} =~ /^\~/)
			   {
			       $rpf_vals->{'ro_ent_val'} =~ s/\~/$ENV{'HOME'}/;
			   }

			   if ($rpf_vals->{'q_ent_val'} =~ /^\~/)
			   {
			       $rpf_vals->{'q_ent_val'} =~ s/\~/$ENV{'HOME'}/;
			   }

			   if ($rpf_vals->{'c_ent_val'} =~ /^\~/)
			   {
			       $rpf_vals->{'c_ent_val'} =~ s/\~/$ENV{'HOME'}/;
			   }

			   if (&check_rpf_vals($rpf_vals, $window))
			   {
			       $nb->raise('txt_frm');
			       if ($tree)
			       {
				   $tree->delete('all');
			       }

			       my $kid;
			       foreach $kid ($tre_frm->children)
			       {
				   $kid->destroy if Tk::Exists($kid);
			       }
			       foreach $kid ($rpf_frm->children)
			       {
				   $kid->destroy if Tk::Exists($kid);
			       }
			       
			       my $id = $window->after(2500, sub
						       {
							   &load_tree($rpf_vals, $tre_frm, $window, $tree);
							   
						       });

			   
			       if (-f $rpf_vals->{'q_ent_val'})
			       {
				   $run_but->configure(-state=>'disabled');
				   $stp_but->configure(-state=>'normal');
				   
				   if (&load_pdb($rpf_frm, $rpf_vals, \$stat_txt, \$pdb_done, $window, \$ety_line, $txt_pdb, \$pid))
				   {
				       $nb->raise('rpf_frm');
				   }
				   #print "returned from load_pdb...\n";
				   $run_but->configure(-state=>'normal');
				   $stp_but->configure(-state=>'disabled');
				   $stat_txt = '';
				   
			       }
			       
#    if (!(-f $rpf_vals->{'q_ent_val'})
#    {
#	&err_msg("File \"" . $rpf_vals->{'q_ent_val'} . "\" does not exist!", $window);
#    }
			       			       
			   }
		       });

    $stp_but->configure(-command=>sub {&stop_pdb_load($window, $txt_pdb, \$stat_txt, \$pid, \$pdb_done);});

    $can_but->configure(-command=>sub {%$rpf_vals = (); $window->destroy(); });
    
    $window->OnDestroy(sub 
		       {
			   if ($$pid)
			   {
			       &stop_pdb_load(\$pdb_mult_done, $window, $txt_pdb, \$stat_txt, \$pid);
			       
			   }
		       });

    $window->waitWindow;
}


sub load_tree
{
    my ($rpf_vals, $tre_frm, $window, $tree) = @_;
    my $root = $rpf_vals->{'ro_ent_val'};
    unless ($root =~ /^\//)
    {
	$root = File::Spec->rel2abs($root, $basepath);
    }

    if (-d $root)
    {
	&create_tree($tre_frm, $window, $root, $tree);
    }
}


sub rpf_create_row
{
    my ($cbt_txt, $ent, $brw, $desc, $big_frm, $main, $bp, $rpf_vals) = @_;

    $cbt_txt=~/\-(\w+)/;
    my $option = $1;
 

    my $cbt_val = $option."_cbt_val";
    my $ent_val = $option."_ent_val";

    $rpf_vals->{$cbt_val} = 1;

    my $frm = $big_frm->Frame(-background=>$bg)->pack(-side=>'top', -padx=>3, -pady=>3, -fill=>'x', -expand=>1);
    
    my $desc_lbl = $frm->Label(-text=>"$desc: ", -width=>40, -wraplength=>250, -background=>$bg)->pack(-side=>'left', -padx=>5, -pady=>3, -anchor=>'e');

    my $cbt = $frm->Checkbutton(-text=>$cbt_txt, -variable=>\$rpf_vals->{$cbt_val}, -background=>$bg, -activebackground=>$cbt_act, -width=>5)->pack(-side=>'left', -padx=>3, -pady=>3);
    

    if ($ent)
    {
	my $entry = $frm->Entry(-textvariable=>\$rpf_vals->{$ent_val}, -width=>25, -background=>'white')->pack(-side=>'left', -padx=>3, -pady=>3);
    }
    else
    {
	my $ety_lbl = $frm->Label(-width=>20, -background=>$bg)->pack(-side=>'left', -padx=>3, -pady=>3);
    }
    
    if ($brw)
    {
	my $brw_but = $frm->Button(-text=>'Browse', -command=>sub 
				   {
				       if ($cbt_txt =~ /o/i)
				       {
					   my $new_name = &OpenDir($cbt_txt, $main, $$bp, 1);
					   if ($new_name)
					   {
					       $rpf_vals->{$ent_val} = $new_name;
					   }
					   else
					   {
					       return;
					   }
				       }
				       else
				       {
					   my $new_name =  &OpenFile($cbt_txt, $main, $$bp, \$a);
					   if ($new_name)
					   {
					       $rpf_vals->{$ent_val} = $new_name;
					   }
					   else
					   {
					       return;
					   }
				       }
				       				       
				   }
				   , -width=>10, -background=>$but_bg, 
				   -foreground=>$but_fg, -activebackground=>$but_act, -activeforeground=>$but_fg)
	    ->pack(-side=>'left', -padx=>3, -pady=>3);
    }
    else
    {
	my $ety_lbl = $frm->Label(-width=>10, -background=>$bg)->pack(-side=>'left', -padx=>3, -pady=>3);
    }
    
}


sub check_rpf_vals
{
    my ($ret_vals, $win) = @_;

    my ($key, $value);
    
    foreach $key (sort keys %$ret_vals)
    {
    	if ($key =~ /ent/)
	{
	    unless ($ret_vals->{$key})
	    {
		$key =~ /^(\w+)_ent_val/;
		my $x = '-'.$1;
	        
	        &err_msg("Enter option $x", $win);
		return 0;
	    }
	}
    }

    
    my $dir = $ret_vals->{'ro_ent_val'};
    
    if (-d $dir)
    {
	my $dlg = $win->Dialog(-text=>"Directory \"$dir\" already exists!\n Clicking Yes will erase its contents!\n Overwrite?", -buttons=>['Yes', 'No'], -bitmap=>'warning', 
			       -background=>'cyan');
	
	my $ans = $dlg->Show;
	
	if ($ans eq 'Yes')
	{
	    #rm('-r', $dir);
	    rmtree($dir);
	    $win->after(100);
	    return 1;
	}
	else
	{
	    $ret_vals->{'ro_ent_val'} = '';
	    return 0;
	}
    }

    my $pdb_file = $ret_vals->{'q_ent_val'}; 

    if (!(-f $pdb_file))
    {
	&err_msg("File \"$pdb_file\" does not exist!", $win);
	return 0; 
    }

    return 1;
}


sub rpf_gui
{
    my ($main, $basepath) = @_;
    
    my %rpf_vals = ();
    
    &build_rpf_gui($main, \$basepath, \%rpf_vals);
    
    $rpf_vals{'ro_ent_val'} = File::Spec->rel2abs($rpf_vals{'ro_ent_val'}, $basepath) if ($rpf_vals{'ro_ent_val'});
    $rpf_vals{'c_ent_val'} = File::Spec->rel2abs($rpf_vals{'c_ent_val'}, $basepath) if ($rpf_vals{'c_ent_val'});
    $rpf_vals{'q_ent_val'} = File::Spec->rel2abs($rpf_vals{'q_ent_val'}, $basepath) if ($rpf_vals{'q_ent_val'});

    return (\%rpf_vals);
}


#run rpf calculations
sub load_pdb
{
    my ($rpf_frm, $rpf_vals, $stat_txt, $pdb_done, $window, $ety_line, $txt_pdb, $pid) = @_;
    
    my $pdb_file = $rpf_vals->{'q_ent_val'};
   

    if (-f $pdb_file)
    {
	$$stat_txt = "Calculation running on pdb_file  - $pdb_file...\n";

	$$pdb_done = 0;
	my $out_dir = $rpf_vals->{'ro_ent_val'};
	unless ($out_dir =~ /^\//)
	{
	    $out_dir = File::Spec->rel2abs($out_dir, $basepath);
	}
	#print "RPF_gui: out_dir is $out_dir\n";
	
	my $vals = "-c ".$rpf_vals->{'c_ent_val'}." -o ".$out_dir." -q ".$pdb_file;

	if (-d $out_dir)
	{
	    &err_msg("Directory \"$out_dir\" exists!  Please remove it and try running the script again", $window);
	    #print "returning from load_pdb...\n";
	    return 0;
	}
	
	unless (defined($$pid = open(PDB_FILE, "$EXECODE $vals 2>&1|")))
	{
	    &err_msg("Cannot fork", $window);
	    return 0;
	}
	
	#print "load_pdb: child process started...\n";
	
	$window->fileevent(PDB_FILE, 'readable'=>sub {&pdb_load_txt($ety_line, $txt_pdb, $pdb_done, $window, $stat_txt, $pid)});
	
	$window->waitVariable($pdb_done);
	#print "load_pdb: child process done...\n";

	#$window->bell;

	#load rpf score data for this pdb file
	
	#get .ovw file from cycle dir
	
	if (opendir(OUT, $out_dir))
	{
	    my @contents = readdir(OUT);
	    my ($ovw_file) = grep {/_DP\.ovw$/} @contents;
	    close(OUT);
	
	    my ($notes_file) = grep {/\.note$/} @contents;
	    $notes_file = File::Spec->rel2abs($notes_file, $out_dir);
	    my @notes;

	    if (open(NOTE, $notes_file))
	    {
		@notes = <NOTE>;
	    }
	    
	    close(NOTE);

	    $ovw_file = File::Spec->rel2abs($ovw_file, $out_dir);
	    	    
	    my ($data, $pklsts_fnames) = &parse_ovw($ovw_file, $window);
	    my ($fpd_but, $ql_but, $qi_but, $nb, $txt) = &rpf_scores_frame($rpf_frm, $data, $pklsts_fnames, $window);

	    my $temp_dir = $out_dir;
	    my $temp_ovw = $ovw_file;
	    my $key;

	    foreach $key (keys %$fpd_but)
	    {
		my $temp_key = $key;
		$fpd_but->{$temp_key}->configure(-command=>sub
				{
				    my ($pdb_fname, $ql_fname) = &get_fpd_fnames($temp_dir, $temp_ovw, $window);
			
				    if ($pdb_fname)
				    {
					$pdb_fname = File::Spec->rel2abs($pdb_fname, $temp_dir);
					$ql_fname = File::Spec->rel2abs($ql_fname, $temp_dir);
					
					print "calc_rasmol: calling with pdb $pdb_fname, ql $ql_fname, and key is $temp_key\n";
					&calc_rasmol($window, $pdb_fname, $ql_fname, $temp_key);
				    }
				});
	    }
	    
	    $ql_but->configure(-command=>sub
			       {
				   my ($pdb_fname, $ql_fname) = &get_fpd_fnames($temp_dir, $temp_ovw, $window);
				   if ($ql_fname)
				   {
				       $ql_fname = File::Spec->rel2abs($ql_fname, $temp_dir);
				       print "show interactions: ql is $ql_fname\n";
				       &show_interactions($window, $ql_fname);
				   }
				   
			       });

	    $qi_but->configure(-command=>sub
			   {
			       &display_qi($temp_dir, $window);
			   });

	    $txt->insert('end', @notes);

	}
    }
    return 1;
}



sub pdb_load_txt
{
    my $c;
    my ($ety_line, $txt_pdb, $pdb_done, $window, $stat_txt, $pid) = @_;
    
    if (defined ($c = (getc PDB_FILE)))
    {
	if (($c =~  /[\n\w\.\:\-\(\)\/\\\ \[\]\>\,\`\'\;\*]/))
	{
	    $$ety_line = 0;
	    $txt_pdb->insert('end', $c);
	    $txt_pdb->yview('end');
	    return;
	}
	else
	{
	    if (!($$ety_line))
	    {
		$$ety_line = 1;
		$txt_pdb->insert('end', "\n");
		return;
	    }
	}
	
    }
    else
    {
	&stop_pdb_load($window, $txt_pdb, $stat_txt, $pid, $pdb_done);
    }
}

sub stop_pdb_load
{
    
    my ($window, $txt_pdb, $stat_txt, $pid, $pdb_done) = @_;

    $$pdb_done = !$$pdb_done;

    unless ($$pid)
    {
	return;
    }
    
    kill 9 => $$pid;
    
    $window->fileevent(PDB_FILE, 'readable'=>'');
    close(PDB_FILE);
    
    $txt_pdb->insert('end', "\n\n");
    $txt_pdb->insert('end', '***Done***');
    $txt_pdb->insert('end', "\n\n");
    $txt_pdb->yview('end');
    $$stat_txt = '';
    
    return;
}

sub change_rpf_basepath
{
    my ($basepath, $chg_bpth, $window, $rpf_vals) = @_;
    
    $old_basepath = Cwd::cwd;
    #print "change_rpf_basepath: old_basepath - $old_basepath, basepath = $$basepath\n";
    
    unless (-d $$basepath)
    {
	my $err_dlg = $window->Dialog(-text=>"Directory $basepath does not exist!\n Do you want to create it?", -buttons=>['Yes', 'No']);
	my $ans = $err_dlg->Show();
	if ($ans eq 'No')
	{
	    $$basepath = $old_basepath;
	    $chg_bpth->configure(-state=>'disabled');
	    return;
	}
	else
	{
	    mkdir $$basepath;
	}
    }
    
    chdir $$basepath;
    $$basepath = Cwd::cwd;
    $chg_bpth->configure(-state=>'disabled');

    foreach $option (qw/c_ent_val ro_ent_val q_ent_val/)
    {
	if ($rpf_vals->{$option})
	{
	    my $name = $rpf_vals->{$option};
	    #print "change_rpf_basepath: rpf_vals{$option} = $name\n";
	    
	    $name = File::Spec->rel2abs($name, $old_basepath);
	    #print "change_rpf_basepath: name after rel2abs = $name\n";
	    
	    if ($name =~ /$$basepath/)
	    {
		$rpf_vals->{$option} = File::Spec->abs2rel($name, $$basepath);
	    }
	    else
	    {
		$rpf_vals->{$option} = $name;
	    }
	    #print "change_rpf_basepath: rpf_vals->{$option} changed to $rpf_vals->{$option}\n";
	}
    }
}

return 1;
