my $bg = '#EFF8FF';
my $but_bg = '#265580';
my $but_fg = $bg;
my $cbt_act = '#D1E4F2';
my $but_act = '#2D4455';
my $nb1_bg = '#9EBCD2';
my $nb2_bg = '#78A1BF';


sub build_rpf_mult_gui
{
    my ($main, $basepath, $rpf_mult_vals) = @_;

    my $txt_pdb;
    my $ety_line = 0;
    my $pdb_mult_done = 0;
    my $pid;
    my $stop_mult = 0;
    my $stat_txt = '';
    my $root;
    my $tree;
    my $pid;
    
    my $window = $main->Toplevel();
    
    $window->configure(-title=>'RPF Scores - for AutoStructure Output Directory');
    
    my $full_frm = $window->Frame(-background=>$bg)->pack(-fill=>'both', -expand=>1, -padx=>3, -pady=>3);
    my $path_lbl = $full_frm->Label(-background=>$bg, -text=>"Basepath - $$basepath", -relief=>'ridge', -borderwidth=>2)->pack(-fill=>'x', -expand=>1, -padx=>3, -pady=>3);
    
    my $opt_frm = $full_frm->Frame(-background=>$bg)->pack(-fill=>'x', -expand=>1, -padx=>3, -pady=>3);

    
    &rpf_mult_create_row('-c', 1,1, 'Specify Control File', $opt_frm, $window, $basepath, $rpf_mult_vals);
    
    &rpf_mult_create_row('-ro', 1,1, 'Set RPF Parent Output Directory', $opt_frm, $window, $basepath, $rpf_mult_vals);
        
    &rpf_mult_create_row('-ao', 1,1, 'AutoStructure Output directory from NOESY Analysis', $opt_frm, $window, $basepath, $rpf_mult_vals);
    
    
    my $but_frm = $full_frm->Frame(-relief=>'ridge', -background=>$bg)->pack(-fill=>'both', -expand=>1, -padx=>3, -pady=>3);
    
    my $run_but = $but_frm->Button(-text=>'RUN', -background=>$but_bg, -foreground=>$but_fg, -font=>[-size=>11], -activebackground=>$but_act, -activeforeground=>$but_fg)
	->pack(-fill=>'x', -expand=>1, -padx=>5, -side=>'left');
    
    my $stp_but = $but_frm->Button(-text=>'STOP', -background=>$but_bg, -foreground=>$but_fg, -font=>[-size=>11], -activebackground=>$but_act, -activeforeground=>$but_fg, -state=>'disabled')
	->pack(-fill=>'x', -expand=>1, -padx=>5, -side=>'left');

    my $can_but = $but_frm->Button(-text=>'CANCEL', -background=>$but_bg, -foreground=>$but_fg, -font=>[-size=>11], -activebackground=>$but_act, -activeforeground=>$but_fg)
	->pack(-fill=>'x', -expand=>1, -padx=>5, -side=>'left');

    
    #notebook
    
    my $nb_frm = $full_frm->Frame(-relief=>'ridge', -borderwidth=>2, -background=>$bg)->pack(-fill=>'both', -expand=>1, -padx=>5, -pady=>5);
    
    my $nb = $nb_frm->NoteBook(-background=>$nb1_bg, -backpagecolor=>$bg, -inactivebackground=>$bg)->pack(-fill=>'both', -expand=>1);

    #pages in notebook
    my $txt_frm = $nb->add('txt_frm', -label=>'Log');
    my $rpf_frm = $nb->add('rpf_frm', -label=>'RPF Scores');
    my $tre_frm = $nb->add('tre_frm', -label=>'Tree View');
    my $grp_frm = $nb->add('grp_frm', -label=>'Graph');

    $tre_frm->configure(-background=>$nb1_bg);
    $txt_frm->configure(-background=>$nb1_bg);
    $rpf_frm->configure(-background=>$nb1_bg);
    $grp_frm->configure(-background=>$nb1_bg);

    $txt_pdb = $txt_frm->Scrolled('Text', -scrollbars=>'oe', -background=>'white')->pack(-fill=>'both', -expand=>1, -padx=>3, -pady=>5);
    
    my $txt_stat = $txt_frm->Label(-textvariable=>\$stat_txt, -background=>$nb1_bg, -height=>2, -relief=>'sunken')->pack(-fill=>'x', -side=>'bottom');

    my $canvas = $grp_frm->Canvas(-background=>'white', -relief=>'sunken', -cursor=>"crosshair", -width=>680, -height=>530)->pack(-fill=>'both', -expand=>1, -padx=>5, -pady=>5);

    while (($key, $value) = each (%$rpf_mult_vals))
    {
	if ($key =~ /cbt/i)
	{
	    $rpf_mult_vals->{$key} = 1;
	}
    }

    $rpf_mult_vals->{'c_ent_val'} = '';
    
    $run_but->configure(-command=>sub 
		       {
			   if ($rpf_mult_vals->{'ro_ent_val'})
			   {
			       $rpf_mult_vals->{'ro_ent_val'} =~ s/\~/$ENV{'HOME'}/;
			   }

                           if ($rpf_mult_vals->{'ao_ent_val'} =~ /^\~/)
                           {
                               $rpf_mult_vals->{'ao_ent_val'} =~ s/\~/$ENV{'HOME'}/;
                           }

                           if ($rpf_mult_vals->{'c_ent_val'} =~ /^\~/)
                           {
                               $rpf_mult_vals->{'c_ent_val'} =~ s/\~/$ENV{'HOME'}/;
                           }

			   if (&check_mult_rpf_vals($rpf_mult_vals, $window))
			   {
			       $nb->raise('txt_frm');
			       my ($pdb_refs, $pdb_dirs_refs) = &get_pdbs($rpf_mult_vals, $window);
			       $root = $rpf_mult_vals->{'ro_ent_val'};

			       if ($tree)
			       {
				   $tree->delete('all');
			       }
			       
			       my $kid;
			       foreach $kid ($tre_frm->children)
			       {
				   $kid->destroy if Tk::Exists($kid);
			       }
			       foreach $kid ($rpf_frm->children)
			       {
				   $kid->destroy if Tk::Exists($kid);
			       }
			       
			       foreach $kid ($grp_frm->children)
			       {
				   $kid->destroy if Tk::Exists($kid);
			       }
			       $canvas = $grp_frm->Canvas(-background=>'white', -relief=>'sunken', -cursor=>"crosshair", -width=>680, -height=>530)->pack(-fill=>'both', -expand=>1, -padx=>5, -pady=>5);
			       
			       my $id = $window->after(5000, sub
						       {
							   &load_mult_tree($tre_frm, $window, $root, $tree);
							   
						       });
			       if ($pdb_refs)
			       {
				   $run_but->configure(-state=>'disabled');
				   $stp_but->configure(-state=>'normal');

				   

				   &load_mult_pdb($pdb_refs, $pdb_dirs_refs, $rpf_frm, $grp_frm, $nb, $window, $canvas, \$stat_txt, \$ety_line, $txt_pdb, \$pdb_mult_done, \$stop_mult, $rpf_mult_vals, $$basepath, \$pid);
				   $run_but->configure(-state=>'normal');
				   $stp_but->configure(-state=>'disabled');
				   
			       }
			       
			   }
		       });

    $stp_but->configure(-command=>sub {$stop_mult = 1; &stop_mult_pdb_load(\$pdb_mult_done, $window, $txt_pdb, \$stat_txt, \$pid);});

    $can_but->configure(-command=>sub 
			{
			    %$rpf_vals = ();
			    $window->destroy();
			   
			});

    $window->update();

    $window->OnDestroy(sub 
		       {
			   if ($$pid)
			   {
			       $stop_mult = 1; 
			       &stop_mult_pdb_load(\$pdb_mult_done, $window, $txt_pdb, \$stat_txt, \$pid);
			   }
		       });

    $window->waitWindow;
}


sub load_mult_tree
{
    my ($tre_frm, $window, $root, $tree) = @_;
    
    if (-d $root)
    {
	&create_tree($tre_frm, $window, $root, $tree);
    }
    
}



sub rpf_mult_create_row
{
    my ($cbt_txt, $ent, $brw, $desc, $big_frm, $main, $bp, $rpf_mult_vals) = @_;

    $cbt_txt=~/\-(\w+)/;
    my $option = $1;
 

    my $cbt_val = $option."_cbt_val";
    my $ent_val = $option."_ent_val";

    $rpf_mult_vals->{$cbt_val} = 1;

    my $frm = $big_frm->Frame(-background=>$bg)->pack(-side=>'top', -padx=>3, -pady=>3, -fill=>'x', -expand=>1);
    

    my $desc_lbl = $frm->Label(-text=>"$desc: ", -width=>40, -wraplength=>250, -background=>$bg)->pack(-side=>'left', -padx=>5, -pady=>3, -anchor=>'e');

    my $cbt = $frm->Checkbutton(-text=>$cbt_txt, -variable=>\$rpf_mult_vals->{$cbt_val}, -background=>$bg, -activebackground=>$cbt_act, -width=>5)->pack(-side=>'left', -padx=>3, -pady=>3);
    

    if ($ent)
    {
	my $entry = $frm->Entry(-textvariable=>\$rpf_mult_vals->{$ent_val}, -width=>25, -background=>'white')->pack(-side=>'left', -padx=>3, -pady=>3);
    }
    else
    {
	my $ety_lbl = $frm->Label(-width=>20, -background=>$bg)->pack(-side=>'left', -padx=>3, -pady=>3);
    }
    
    if ($brw)
    {
	my $brw_but = $frm->Button(-text=>'Browse', -command=>sub 
				   {				       
				       if ($cbt_txt =~ /o/i)
				       {
					   my $new_name = &OpenDir($cbt_txt, $main, $$bp, 1);
					   if ($new_name)
					   {
					       $rpf_mult_vals->{$ent_val} = $new_name;
					   }
					   else
					   {
					       return;
					   }
				       }
				       else
				       {
					   my $new_name =  &OpenFile($cbt_txt, $main, $$bp, \$a);
					   if ($new_name)
					   {
					       $rpf_mult_vals->{$ent_val} = $new_name;
					   }
					   else
					   {
					       return;
					   }
				       }
				   }
				   , -width=>10, -background=>$but_bg, 
				   -foreground=>$but_fg, -activebackground=>$but_act, -activeforeground=>$but_fg)
	    ->pack(-side=>'left', -padx=>3, -pady=>3);
    }
    else
    {
	my $ety_lbl = $frm->Label(-width=>10, -background=>$bg)->pack(-side=>'left', -padx=>3, -pady=>3);
    }
    
}


sub check_mult_rpf_vals
{
    my ($ret_vals, $win) = @_;
    my ($key, $value);

    
    foreach $key (sort keys %$ret_vals)
    {
    	if ($key =~ /ent/)
	{
	    unless ($ret_vals->{$key})
	    {
		$key =~ /^(\w+)_ent_val/;
		my $x = '-'.$1;
	        
	        &err_msg("Enter option $x", $win);
		return 0;
	    }
	}
    }
    
    my $dir = $ret_vals->{'ro_ent_val'};
    
    if (-d $dir)
    {
	my $dlg = $win->Dialog(-text=>"Directory $dir already exists!\nClicking Yes will erase its contents!\nOverwrite?", -buttons=>['Yes', 'No'], -bitmap=>'warning', 
			       -background=>'cyan');
	
	my $ans = $dlg->Show;
	
	if ($ans eq 'Yes')
	{
	    #rm('-rf', $dir);
	    rmtree($dir);
	    $win->after(100);
	    return 1;
	}
	else
	{
	    $ret_vals->{'ro_ent_val'} = '';
	    return 0;
	}
    }
    
    return 1;
}


sub rpf_mult_gui
{
    my ($main, $basepath) = @_;
    
    my %rpf_mult_vals = ();
    
    &build_rpf_mult_gui($main, \$basepath, \%rpf_mult_vals);
    
    $rpf_mult_vals{'ro_ent_val'} = File::Spec->rel2abs($rpf_mult_vals{'ro_ent_val'}, $basepath) if ($rpf_mult_vals{'ro_ent_val'});
    $rpf_mult_vals{'c_ent_val'} = File::Spec->rel2abs($rpf_mult_vals{'c_ent_val'}, $basepath) if ($rpf_mult_vals{'c_ent_val'});
    $rpf_mult_vals{'ao_ent_val'} = File::Spec->rel2abs($rpf_mult_vals{'ao_ent_val'}, $basepath) if ($rpf_mult_vals{'ao_ent_val'});

    return (\%rpf_mult_vals);
}



sub get_pdbs
{
    my ($rpf_mult_vals, $parent) = @_;

    unless ($rpf_mult_vals->{'ao_ent_val'})
    {
	return;
    }
    
    my $ao_dir = $rpf_mult_vals->{'ao_ent_val'};
    
    my $protName = &openContFile($rpf_mult_vals->{'c_ent_val'}, 1);

    unless (-d $ao_dir)
    {
	&err_msg("$ao_dir is not a Directory!", $parent);
	return;
    }
    
    my $opened = opendir(AOD, $ao_dir);

    unless ($opened)
    {
	&err_msg("Cannot open $ao_dir!", $parent);
	return;
    }

    my @cycles = grep {/^cycle.+final$/i} readdir(AOD);
    
    my $cyc_dir;
    my @pdb_files;
    my %pdb_dirs;

    foreach $cyc_dir (sort {$a cmp $b || $a <=> $b} @cycles)
    {
	my $cyc_dir_name = $cyc_dir;
	$cyc_dir = File::Spec->rel2abs($cyc_dir, $ao_dir);
	
	if (opendir(CYCDIR, $cyc_dir))
	{
	    my ($pdb_file) = grep {/^$protName\.pdb$/} readdir(CYCDIR);
	    $pdb_file = File::Spec->rel2abs($pdb_file, $cyc_dir);
	    
	    push @pdb_files, $pdb_file;
	    $pdb_dirs{$pdb_file} = $cyc_dir_name;
	    close(CYCDIR);
	}
	
    }
    close(AOD);
    
    return (\@pdb_files, \%pdb_dirs);
}

my $pid;

sub load_mult_pdb
{
    my ($pdb_list, $pdb_dirs, $rpf_frm, $grp_frm, $nb, $window, $canvas, $stat_txt, $ety_line, $txt_pdb, $pdb_mult_done, $stop_mult, $rpf_mult_vals, $basepath, $pid) = @_;
    
    my $num_cycles = scalar(@$pdb_list);

    my %graph_data;
    
    my ($x, $y) = (20, 0);
    my $help_rect = $canvas->createRectangle($x, $y, $x+500, $y+25, -outline=>'brown', -width=>3);
    
    my $help_txt = "Move mouse over one of the points to display its value";
    
    my $help_lbl = $canvas->Label(-textvariable=>\$help_txt, -background=>'white', -width=>60, -height=>1, -borderwidth=>2, -foreground=>'#660099');
    my $can_help = $canvas->createWindow($x+270, $y+14, -window=>$help_lbl);

    #create graph - grid
    my ($gx1, $gy1, $gx2, $gy2) = (20, 35, 520, 500);

    #print "1. load_mult_pdb: starting to create canvas...\n";

    my $grid = $canvas->createRectangle($gx1, $gy1, $gx2, $gy2, -outline=>'red');
    
    my ($marks, $lines, $rect) = &place_marks($gx1, $gy1, $gx2, $gy2, $canvas, $num_cycles);

    &create_legend(530, 20, $canvas);
    &create_save_button($canvas, \%graph_data, $window, $basepath, $num_cycles);
    $canvas->configure(-scrollregion=>[$canvas->bbox('all')], -confine=>1);
    
    #print "2. load_mult_pdb: done creating empty canvas...\n";

    my $control_file = File::Spec->rel2abs($rpf_mult_vals->{'c_ent_val'}, $basepath);
    my $cycle_num = 1;
       
    my $rpf_nb = $rpf_frm->NoteBook(-backpagecolor=>$nb1_bg, -background=>$nb2_bg)->pack(-fill=>'both', -expand=>1);
    my $main_pg = $rpf_nb->add('Main', -label=>'Main');
    $main_pg->configure(-background=>$nb2_bg);

    my $par_dir = $rpf_mult_vals->{'ro_ent_val'};
    $par_dir = File::Spec->rel2abs($par_dir, $basepath);

    if (-d $pdb_dir)
    {
	&err_msg("Directory \"$pdb_dir\" exists! Please remove it and try running the script again", $window);
    }

    
    mkdir $par_dir;
    
    my $pdb_file;

    foreach $pdb_file (sort by_cycle @$pdb_list)
    {
	$$stat_txt = "Cycle $cycle_num: Calculation running on file - $pdb_file...\n";
	
	my $pdb_dir = $pdb_dirs->{$pdb_file};
	$pdb_dir = 'Q'.$pdb_dir;
	$pdb_dir = File::Spec->rel2abs($pdb_dir, $par_dir);
	
	my $vals = "-c ".$control_file." -o ".$pdb_dir." -q ".$pdb_file;
	
	unless (defined($$pid = open(PDB_FILE, "$EXECODE $vals 2>&1|")))
	{
	    &err_msg("Cannot fork", $window);
	    return 0;
	}
	
	$window->fileevent(PDB_FILE, 'readable'=>sub {&pdb_mult_load_txt($ety_line, $txt_pdb, $window, $pdb_mult_done)});
	
	$window->waitVariable($pdb_mult_done);

	$window->fileevent(PDB_FILE, 'readable'=>'');
	close(PDB_FILE);

	#$window->bell;
    
	#load rpf score data for this pdb file
	my $rpf_pg = $rpf_nb->add("Cycle $cycle_num", -label=>"Cycle $cycle_num");
	$rpf_pg->configure(-background=>$nb2_bg);

	if ($cycle_num == 1)
	{
	    $rpf_nb->delete('Main');
	}
	
	#put file name on top
	my $rpf_lbl = $rpf_pg->Label(-text=>$pdb_file, -background=>$nb2_bg)->pack();
	my $rpf_pg_frm = $rpf_pg->Frame(-background=>$nb2_bg)->pack(-fill=>'both', -expand=>1);
	

	#get .ovw file from cycle dir
	if (opendir(OUT, $pdb_dir))
	{
	    my @contents = readdir(OUT);
	    my ($ovw_file) = grep {/_DP\.ovw$/} @contents;
	    $ovw_file = File::Spec->rel2abs($ovw_file, $pdb_dir);

	    my ($notes_file) = grep {/\.note$/} @contents;
	    $notes_file = File::Spec->rel2abs($notes_file, $pdb_dir);
	    my @notes;

	    if (open(NOTE, $notes_file))
	    {
		@notes = <NOTE>;
	    }
	    
	    close(NOTE);
	    close(OUT);
	    
	    my ($data, $pklsts_fnames) = &parse_ovw($ovw_file, $window);
	    
	    my ($fpd_but, $ql_but, $qi_but, $nb, $txt) = &rpf_scores_frame($rpf_pg_frm, $data, $pklsts_fnames, $window);
	    my $temp_dir = $pdb_dir;
	    my $temp_num = $cycle_num;
	    my $key;

	    foreach $key (keys %$fpd_but)
	    {
		my $temp_key = $key;
		$fpd_but->{$temp_key}->configure(-command=>sub
				{
				    
				    my ($pdb_fname, $ql_fname) = &get_fpd_fnames($temp_dir, $ovw_file, $window);
				    
				    if ($pdb_fname)
				    {
					$pdb_fname = File::Spec->rel2abs($pdb_fname, $temp_dir);
					$ql_fname = File::Spec->rel2abs($ql_fname, $temp_dir);
					
					&calc_rasmol($window, $pdb_fname, $ql_fname, $temp_key);
				    }
				});
	    }
	    
	    $ql_but->configure(-command=>sub
			       {
				   my ($pdb_fname, $ql_fname) = &get_fpd_fnames($temp_dir, $ovw_file, $window);
				   if ($ql_fname)
				   {
				       $ql_fname = File::Spec->rel2abs($ql_fname, $temp_dir);
				       &show_interactions($window, $ql_fname);
				   }
				   
			       });

	    $qi_but->configure(-command=>sub
			   {
			       &display_qi($pdb_dir, $window);
			   });

	    $txt->insert('end', @notes);
	    
	    my $option;
	    foreach $option ('Precision-score', 'Recall-score', 'F-score', 'dp-score')
	    {
		my $number = $data->{'model'}{'ave'}{$option}{'input query structures'};
		
		#print $number . "\n";

		#$number = 0.5;

		if  ($number > 0)
		{
		    my $cyc_num = $cycle_num;
		    my $opt = $option;

		    $graph_data{$opt}{$cyc_num} = $number;
		    
		    my $x = $marks->{$cyc_num};
		    my $y = &format_number($number);

		    #print "placing $option for cycle $cyc_num at ($x,$y) - value is $number\n";
		    
		    my $point;
		    
		    if ($option =~ /precision/i)
		    {$point = &put_precision($x, $y, $canvas);}
		    elsif ($option =~ /recall/i)
		    {$point = &put_recall($x, $y, $canvas);}
		    elsif ($option =~ /f-score/i)
		    {$point = &put_fscore($x, $y, $canvas);}
		    elsif ($option =~ /dp-score/i)
		    {$point = &put_dp($x, $y, $canvas);}
		    
		    #bind the point
		    $canvas->bind($point, '<Enter>'=> sub 
				  {
				      $help_txt = "Cycle $cyc_num - $opt = ".$data->{'model'}{'ave'}{$opt}{'input query structures'};
				      $help_lbl->configure(-foreground=>'#FF3300');
				  });
		    $canvas->bind($point, '<Leave>'=>sub
				  {
				      $help_txt = "Move mouse over one of the points to display its value";
				      $help_lbl->configure(-foreground=>'#660099');
				  });
		}
	    }	    

	    $canvas->bind($rect->{$cyc_num}, '<Enter>'=>sub
		      {
			  $help_txt = "Cycle $cyc_num - Precision=".$data->{'model'}{'ave'}{'Precision-score'}.", Recall=".$data->{'model'}{'ave'}{'Recall-score'}.
			      ", F-score=".$data->{'model'}{'ave'}{'F-score'}.", DP=".$data->{'model'}{'ave'}{'dp-score'};
			  $help_lbl->configure(-foreground=>'#FF3300');
		      });
	    $canvas->bind($rect->{$cyc_num}, '<Leave>'=>sub
		      {
			  $help_txt = "Move mouse over one of the points to display its value";
			  $help_lbl->configure(-foreground=>'#660099');
		      });
	    $canvas->bind($lines->{$cyc_num}, '<Enter>'=>sub
		      {
			  $help_txt = "Cycle $cyc_num - Precision=".$data->{'model'}{'ave'}{'Precision-score'}.", Recall=".$data->{'model'}{'ave'}{'Recall-score'}.
			      ", F-score=".$data->{'model'}{'ave'}{'F-score'}.", DP=".$data->{'model'}{'ave'}{'dp-score'};
			  $help_lbl->configure(-foreground=>'#FF3300');
		      });
	}
	$cycle_num++;
	last if ($$stop_mult);
    }
    $nb->raise('grp_frm');

    #after looping through pdb list
    
    &stop_mult_pdb_load($pdb_mult_done, $window, $txt_pdb, $stat_txt, $pid);
}

sub by_cycle
{
    ($ac) = $a =~ /CYCLE(\d+)-/; 
    ($bc) = $b =~ /CYCLE(\d+)-/; 

    return ($ac <=> $bc); 
}

sub pdb_mult_load_txt
{
    my ($ety_line, $txt_pdb, $window, $pdb_mult_done) = @_;


    my $c;
    
    if (defined ($c = (getc PDB_FILE)))
    {
	if (($c =~  /[\n\w\.\:\-\(\)\/\\\ \[\]\>\,\`\'\;\*]/))
	{
	    $$ety_line = 0;
	    $txt_pdb->insert('end', $c);
	    $txt_pdb->yview('end');
	    return;
	}
	else
	{
	    if (!$$ety_line)
	    {
		$$ety_line = 1;
		$txt_pdb->insert('end', "\n");
		return;
	    }
	}
	
    }
    else
    {
	$txt_pdb->insert('end', "\n\n");
	$window->fileevent(PDB_FILE, 'readable'=>'');
	$$pdb_mult_done = !$$pdb_mult_done;
    }
}

sub stop_mult_pdb_load
{
    
    #stop_mult_pdb_load called when -stop button clicked, -end of pdb list.  If error while reading a pdb file, next pdb file in list is read instead of stopping the process.


    my ($pdb_mult_done, $window, $txt_pdb, $stat_txt, $pid) = @_;

    $$pdb_mult_done = !($$pdb_mult_done);
    

    unless ($$pid)
    {
	return;
    }
    
    kill 9 => $$pid;
    
    $window->fileevent(PDB_FILE, 'readable'=>'');
    close(PDB_FILE);
    
    $txt_pdb->insert('end', "\n\n");
    $txt_pdb->insert('end', '***Done***');
    $txt_pdb->insert('end', "\n\n");
    $txt_pdb->yview('end');
    $$stat_txt = '';
    
    return;
}

sub change_rpf_mult_basepath
{
    my ($basepath, $chg_bpth, $window, $rpf_mult_vals) = @_;
    
    my $old_basepath = Cwd::cwd;
    
    unless (-d $$basepath)
    {
	my $err_dlg = $window->Dialog(-text=>"Directory $$basepath does not exist!\n Do you want to create it?", -buttons=>['Yes', 'No']);
	my $ans = $err_dlg->Show();
	if ($ans eq 'No')
	{
	    $$basepath = $old_basepath;
	    $chg_bpth->configure(-state=>'disabled');
	    return;
	}
	else
	{
	    mkdir $$basepath;
	}
    }
    
    chdir $$basepath;
    $$basepath = Cwd::cwd;
    $chg_bpth->configure(-state=>'disabled');

    foreach $option (qw/c_ent_val ro_ent_val ao_ent_val/)
    {
	if ($rpf_mult_vals->{$option})
	{
	    my $name = $rpf_mult_vals->{$option};
	    
	    $name = File::Spec->rel2abs($name, $old_basepath);
	    
	    if ($name =~ /$$basepath/)
	    {
		$rpf_mult_vals->{$option} = File::Spec->abs2rel($name, $$basepath);
	    }
	    else
	    {
		$rpf_mult_vals->{$option} = $name;
	    }
	}
    }
}


#given a RPF QCycle directory, returns the .QL file, and the .pdb file from subdirectory source
sub get_fpd_fnames
{
    my ($dir, $ovw_file, $parent) = @_;
    my $basepath = Cwd::cwd;
    

    #print "get_fpd_names: dir is $dir\n";
    my ($source_dir) = "$dir/source/";

    unless (-d $source_dir)
    {
	&err_msg("source directory does not exist in \"$dir\"", $parent);
	return 0;
    }
    
    unless(opendir(SOURCE, $source_dir))
    {
	&err_msg("Cannot open directory \"$source_dir\"", $parent);
	return 0;
    }

    my @source_contents = readdir(SOURCE);
    close(SOURCE);
    
    #get pdb filename from ovw_file
    my ($pdb_file_name) = &get_pdb_ovw($ovw_file, $parent);
    $pdb_file_name = basename($pdb_file_name);
    chop($pdb_file_name);
    
    my ($pdb_file) = grep {/^$pdb_file_name\.gz$/i} @source_contents;

    #print "get_fpd_fnames: pdb_file is $pdb_file\n";
    if ($pdb_file)
    {
	($pdb_file) = File::Spec->rel2abs($pdb_file, $source_dir);
    }
    print "$pdb_file\n"; 

    if ($pdb_file =~ /\.gz$/)
    {
	$pdb_file = &unzip_file($pdb_file);
    }
    
    #only keep the first model
    open(PDB, "<$pdb_file"); 
    @lines = <PDB>;
    close PDB; 
    unlink($pdb_file); 
 
    open(PDB, ">$pdb_file"); 
    my $model = 0; 
    foreach my $l (@lines)
    {
	#print "$model $l"; 
	$model++ if ($l =~ /^MODEL|model/);
	last if ($model > 1); 
	print PDB "$l"; 
    }

    unless (opendir(DIR, $dir))
    {
	&err_msg("Cannot open directory \"$dir\"", $parent);
	return 0;
    }
    
    my @dir_contents = readdir(DIR);
    close(DIR);

    my ($ql_file) = grep {/\.qp$/i} @dir_contents;
	unless ($ql_file =~ /qp/i) {
		($ql_file) = grep {/\.ql$/i} @dir_contents;
	}
    
    chdir $basepath;
    #$pdb_file = File::Spec->rel2abs($pdb_file, $dir);
    #$ql_file = File::Spec->rel2abs($ql_file, $dir);
    print "get_fpd_fnames: pdb_file is $pdb_file, and ql_file is $ql_file $dir\n"; 
    return ($pdb_file, $ql_file);
}

sub get_pdb_ovw
{
    my ($ovw_file, $parent) = @_;

    unless (open(FILE, $ovw_file))
    {
	&err_msg("Cannot open ovw file \"$ovw_file\"", $parent);
	return;
    }
    
    my $line;
    while (chomp($line = <FILE>))
    {
	if ($line =~ /^\#\s+\-q(.+)$/)
	{
	    my $pdb = $1;
	    if ($pdb =~ /\s+/)
	    {
		$pdb =~ s/\s+//;
	    }
		print "found $pdb\n";
	    return ($pdb);
	}
    }

}


return 1;
