my ($bg1, $bg2, $bg3) = ('white', 'white', 'white');
my $scale = 1.2;

my $width = $scale * 45;
my $height = $scale * 65;

my $x_div = $width + $width/2;
my $y_div = $height + $height/2;;


sub all_betas
{
    my ($parent, $data_ref) = @_;

    my %data = %$data_ref;

    #create interface
    my $window = $parent->Toplevel();
    
    my $frm1 = $window->Frame(-background=>$bg1, -relief=>'ridge', -borderwidth=>2)->pack(-padx=>5, -pady=>5, -ipadx=>3, -ipady=>5, -fill=>'x');
    my $lbl1 = $frm1->Label(-background=>$bg1, -text=>'Select Strands - ')->pack(-padx=>3, -pady=>3, -side=>'left', -fill=>'x');
    
    my ($sheets_ref, $sheets_id_ref) = &get_all_sheets($data_ref);
    my @sheets = @$sheets_ref;
    my %sheets_id = %$sheets_id_ref;

    #print "sheets are @sheets\n";

    #my @sheets = sort {$a <=> $b || $a cmp $b} keys %{$data{'Evidences'}};
    my ($strand1, $strand2);
    $strand1 = $sheets[0];
    my $opt_menu1 = $frm1->Optionmenu(-options=>$sheets_ref, -variable=>\$strand1)->pack(-side=>'left', -padx=>5, -pady=>5);
    my $opt_menu2 = $frm1->Optionmenu(-variable=>\$strand2)->pack(-side=>'left', -padx=>5, -pady=>5);
    #my $opt_but = $frm1->Button(-text=>"Load Registers")->pack(-side=>'left',-padx=>5, -pady=>5); 

    my $lbl2 = $window->Label(-text=>"Selected Supporting Evidences for All Possible Registers :")->pack(-fill=>'x', -expand=>1, -padx=>3, -pady=>3);

    my $frm2 = $window->Frame(-background=>$bg1, -relief=>'ridge', -borderwidth=>2)->pack(-padx=>5, -pady=>5, -ipadx=>3, -ipady=>5, -fill=>'both', -expand=>1);
    my $slbx2 = $frm2->Scrolled('Listbox', -scrollbars=>'se')->pack(-fill=>'both', -expand=>1, -padx=>5, -pady=>5);
    my $lbx2 = $slbx2->Subwidget('listbox');
    $lbx2->configure(-selectmode=>'single', -background=>$bg2);
    
    my $lbl3 = $window->Label(-text=>"Candidate Registers :")->pack(-fill=>'x', -expand=>1, -padx=>3, -pady=>3);

    my $frm3 = $window->Frame(-background=>$bg1, -relief=>'ridge', -borderwidth=>2)->pack(-padx=>5, -pady=>5, -ipadx=>3, -ipady=>5, -fill=>'both', -expand=>1);
    my $slbx3 = $frm3->Scrolled('Listbox', -scrollbars=>'se')->pack(-fill=>'both', -expand=>1, -padx=>5, -pady=>5);
    my $lbx3 = $slbx3->Subwidget('listbox');
    $lbx3->configure(-selectmode=>'single', -background=>$bg2);

    $opt_menu1->configure(-command=>sub
			  {
			      $lbx2->delete(0, 'end');
			      my $id1 = $sheets_id{$strand1};
			      my @temp_sheets = keys %{$data{'Evidences'}};
			      (@temp_sheets) = grep {/^$id1\-/} @temp_sheets;
			      #print "strand1 is $strand1 (id = $id1); temp_sheets are @temp_sheets\n";
			      my @opts;
			      my $opt_count = 0;
			      
			      my $temp1;
			      foreach $temp1 (sort {$a <=> $b || $a cmp $b} @temp_sheets)
			      {
				  my ($id1, $id2) = &get_res($temp1);
				  my %rev_ids = reverse %sheets_id;
				  $opts[$opt_count] = $rev_ids{$id2};
				  $opt_count++;
			      }
			      
			      $opt_menu2->configure(-options=>\@opts);
			      $strand2 = $opts[0];
			  });

    $opt_menu2->configure(-command=>sub
			 {
			     $lbx2->delete(0, 'end');

			     #load registers in list box
			     my ($id1, $id2) = ($sheets_id{$strand1}, $sheets_id{$strand2});
			     my $strand = "$id1-$id2";
			     my @registers = keys %{$data{'Evidences'}{$strand}};
			     #print "Registers for strand $strand are @registers\n";
			     
			     
			     #sort them according to their scores
			     my @regs;
			     my $i;
			     for ($i = 0; $i <= $#registers; $i++)
			     {
				 $registers[$i] =~ /\:\s*([.\d]+)$/;
				 $regs[$i][0] = $registers[$i];
				 $regs[$i][1] = $1;
				 #print "score is $regs[$i][1]\n";
			     }

			     #sort regs according to its second column
			     my @sorted_regs = sort {$b->[1] <=> $a->[1]} @regs;
			     
			     for ($i = 0; $i <= $#sorted_regs; $i++)
			     {
				 $lbx2->insert('end', $sorted_regs[$i][0]);
			     }
			 });
    
    $lbx2->bind('<Double-Button-1>'=>sub
		{
		    my $reg_line = $lbx2->get($lbx2->curselection());
		    return unless($reg_line);

		    $reg_line =~ /\-\>([\d\-]+)\stotal/i;
		    my $register = $1;
		    my $sel_strands = "$sheets_id{$strand1}-$sheets_id{$strand2}";

		    #print "reg_line is ($reg_line); register is $register and sel_strands is $sel_strands\n";

		    my $win = $window->Toplevel;
		    my $title_lbl = $win->Label(-text=>"Strands - ($strand1) - ($strand2); Register - $reg_line", -relief=>'ridge', -borderwidth=>2)->pack(-fill=>'x', -ipadx=>5, -ipady=>5);
		    my $canvas = $win->Canvas(-background=>'white')->pack(-fill=>'both', -expand=>1);
		    my $help;
		    my $help_lbl = $win->Label(-background=>'yellow', -foreground=>'red', -textvariable=>\$help)->pack(-fill=>'x', -ipadx=>5, -ipady=>5);
		    
		    my ($x, $y) = (100, 0);

		    #get sheets from ids
		    my @sheets;
		    my ($id1, $id2) = &get_res($sel_strands);
		    $sheets[0] = &get_sheet_from_id($data_ref, $id1, 'Temp_ids');
		    my ($first, $last) = &get_res($sheets[0]);
		    if ($first < 2)
		    {
			$a = $first;
		    }
		    else
		    {
			$a = $first-1;
		    }
		    $b = $last+1;
		    $sheets[0] = "$a-$b";
		    $sheets[1] = &get_sheet_from_id($data_ref, $id2, 'Temp_ids');
		    ($first, $last) = &get_res($sheets[1]);
		    if ($first < 2)
		    {
			$a = $first;
		    }
		    else
		    {
			$a = $first-1;
		    }
		    $b = $last+1;
		    $sheets[1] = "$a-$b";
		    
		    my @registers;
		    $registers[0] = $register;

		    my ($ht, $stats_ref);
		    #print "sheets are @sheets, registers are @registers\n";
		    
		    
		    if ($reg_line =~ /anti/i)
		    {
			($ht, $stats_ref) = &place_anti_sheets($canvas, $x, $y, \@sheets, \@registers, $data_ref, \$help, 'Temp_ids');
		    }
		    else
		    {
			($ht, $stats_ref) = &place_para_sheets($canvas, $x, $y, \@sheets, \@registers, $data_ref, \$help, 'Temp_ids');
		    }
		    
		    

		    my %interactions = %{$data{'Evidences'}{$sel_strands}{$reg_line}};
		    
		    &put_evidences($canvas, \@sheets, \@registers, $stats_ref, $data_ref, $win, \$help, \%interactions);
		});

    #load candidates into lbx3
    my $i;
    my @candidates;
    my $cand_count = 0;
    for ($i = 0; $i<scalar(@{$data{'Candidates'}}); $i++)
    {
	my $line = $data{'Candidates'}[$i];
	#$line =~ /\:\s+([\d\-]+)\s*$/;
	$line =~ /found\s*\:\s([\-\s\d]+)\sscore\:\s+([.\d]+)$/i;
	my $register = $1;
	my $score = $2;

	#status
	#print "register is $register\n";
	unless ($register =~ /\d+\-\d+/)
	{
	    my ($reg1, $reg2) = split(/\s/, $register);
	    $register = "$reg1-$reg2";
	}

	$line =~ /strands\s(\d+)-(\d+)\s+/i;
	my ($id1, $id2) = ($1, $2);
	my ($sheet1, $sheet2) = (&get_sheet_from_id($data_ref, $id1, 'Temp_ids'), &get_sheet_from_id($data_ref, $id2, 'Temp_ids'));
	$sheet1 = "($sheet1)";
	$sheet2 = "($sheet2)";

	$line =~ s/Strands\s\d+\-\d+/Strands $sheet1\-$sheet2/;

	my $status;
	if ($data{'removed_candidates'}{$register})
	{
	    $status = "Removed";
	}
	else
	{
	    $status = "Good";
	}
	
	$candidates[$cand_count][0] = $score;
	$candidates[$cand_count][1] = "$line (Status : $status)";
	
	$cand_count++;
    }
    
    my @sorted_candidates = sort {$b->[0] <=> $a->[0]} @candidates;

    for ($i = 0; $i < scalar(@sorted_candidates); $i++)
    {
	$lbx3->insert('end', $sorted_candidates[$i][1]);
    }

    $lbx3->bind('<Double-Button-1>'=>sub
		{
		    my $reg_line = $lbx3->get($lbx3->curselection());
		    return unless($reg_line);
		    
		    $reg_line =~ /\:\s+register\sfor.+strands\s+([\-\d\)\(]+)\s+found\s*\:\s+([\-\s\d]+)\sscore\:\s+([.\d]+)\s/i;
		    
		    #$reg_line =~ /strands\s([\d\-]+)\:.+\-\>([\d\-]+)\stotal\sscore\:\s*(\d+)$/i;
		    my $register = $2;
		    my $sel_strands = $1;
		    my $score = $3;

		    #print "reg_line is $reg_line, sel_strands are $sel_strands\n";

		    unless ($register =~ /\d+\-\d+/)
		    {
			my ($reg1, $reg2) = split(/\s/, $register);
			$register = "$reg1-$reg2";
		    }
		    
		    #get sheets from ids
		    my @sheets;
		    my @temp_sheets;

		    $sel_strands =~ /\(([\-\d]+)\)\-\(([\-\d]+)\)/;
		    ($temp_sheets[0], $temp_sheets[1]) = ($1, $2);
		    #my ($id1, $id2) = &get_res($sel_strands);
		    #$sheets[0] = &get_sheet_from_id($data_ref, $id1, 'Temp_ids');
		    my ($first, $last) = &get_res($temp_sheets[0]);
		    my $a = $first-1;
		    my $b = $last+1;
		    $sheets[0] = "$a-$b";
		    #$sheets[1] = &get_sheet_from_id($data_ref, $id2, 'Temp_ids');
		    ($first, $last) = &get_res($temp_sheets[1]);
		    $a = $first-1;
		    $b = $last+1;
		    $sheets[1] = "$a-$b";

		    my $win = $window->Toplevel;
		    my $title_lbl = $win->Label(-text=>"Candidate register - $register in strands ($temp_sheets[0]) and ($temp_sheets[1]) with score $score", -relief=>'ridge', -borderwidth=>2)
			->pack(-fill=>'x', -ipadx=>5, -ipady=>5);
		    my $canvas = $win->Canvas(-background=>'white')->pack(-fill=>'both', -expand=>1);
		    my $help;
		    my $help_lbl = $win->Label(-background=>'yellow', -foreground=>'red', -textvariable=>\$help)->pack(-fill=>'x', -ipadx=>5, -ipady=>5);
		    
		    my ($x, $y) = (100, 0);

		    my @registers;
		    $registers[0] = $register;

		    my ($ht, $stats_ref, $key, $line, $temp_line);
		    #print "sheets are @sheets, registers are @registers, sel_strands are $sel_strands\n";
		    
		    
		    if ($reg_line =~ /anti/i)
		    {
			($ht, $stats_ref) = &place_anti_sheets($canvas, $x, $y, \@sheets, \@registers, $data_ref, \$help, 'Temp_ids');
			$key = 'anti_para';
		    }
		    else
		    {
			($ht, $stats_ref) = &place_para_sheets($canvas, $x, $y, \@sheets, \@registers, $data_ref, \$help, 'Temp_ids');
			$key = 'para';
		    }
		    
		    $sel_strands = "$sheets_id{$temp_sheets[0]}-$sheets_id{$temp_sheets[1]}";

		    my %temp_lines = %{$data{'Evidences'}{$sel_strands}};
		    foreach $line (keys %temp_lines)
		    {
			#print "line is $line\n";
			if ($line =~ /^\s*$key\s*\-\>$register\s/i)
			{
			    $temp_line = $line;
			}
		    }
		    
		    #my ($temp_line) = grep {/^\s+$key\s*\-\>$register\s/} keys %temp_lines;
		    #print "register is $register, sel_strands are $sel_strands; temp_line is $temp_line\n";
		    
		    my %interactions = %{$data{'Evidences'}{$sel_strands}{$temp_line}};
		    
		    # for one pair of registers - help is the text variable for the help label.
		    &put_evidences($canvas, \@sheets, \@registers, $stats_ref, $data_ref, $win, \$help, \%interactions);
		});
    
}


sub put_evidences
{
    my ($canvas, $sheets_ref, $registers_ref, $stats_ref, $data_ref, $parent, $help_ref, $interactions_ref) = @_;

    my @sheets = @$sheets_ref;
    my @registers = @$registers_ref;
    my %stats = %$stats_ref;
    my %data = %$data_ref;
    my %interactions = %$interactions_ref;
    
    #print "1. put_evidences: sheets are @sheets, registers are @registers\n";
    
    my ($sheet_above, $sheet_below) = ($sheets[0], $sheets[1]);
    
    my $cur_inter;
    
    # addin evidence
    foreach $cur_inter (keys %interactions)
    {
	my ($res1, $res2) = &get_res($cur_inter);

	$res1 =~ /^(\d+)(\w+)$/;
	my ($res_above, $res_atm_above) = ($1, $2);

	$res2 =~ /^(\d+)(\w+)$/;
	my ($res_below, $res_atm_below) = ($1, $2);

	#print "2. put_evidences: Strands are ($sheet_above and $sheet_below), cur_inter is $cur_inter; Res1 - ($res_above, $res_atm_above), Res2 - ($res_below, $res_atm_below)\n";
	
	#get_coords
	my ($first_above, $last_above) = &get_res($sheet_above);
	my ($first_below, $last_below) = &get_res($sheet_below);

	my ($ax, $ay) = &get_coords_of_res($stats{$sheet_above}{'coords'}{'x'}, $stats{$sheet_above}{'coords'}{'y'}, $first_above, 
					   $last_above, $res_above, $stats{$sheet_above}{'left_to_right'});
	my $res_up_above;
	if ($stats{$sheet_above}{'left_to_right'})
	{
	    $res_up_above = &get_res_up($stats{$sheet_above}{'up'}, $first_above, $res_above);
	}
	else
	{
	    $res_up_above = &get_res_up($stats{$sheet_above}{'up'}, $last_above, $res_above);
	}
	$ax += $x_div;
	my $elem_above_ref = &get_coords_elements($ax, $ay, $res_up_above, $stats{$sheet_above}{'left_to_right'});
	my %elem_above = %$elem_above_ref;

	
	my ($bx, $by) = &get_coords_of_res($stats{$sheet_below}{'coords'}{'x'}, $stats{$sheet_below}{'coords'}{'y'}, 
					   $first_below, $last_below, $res_below, $stats{$sheet_below}{'left_to_right'});
	$bx += $x_div;
	my $res_up_below;
	if ($stats{$sheet_below}{'left_to_right'})
	{
	    $res_up_below = &get_res_up($stats{$sheet_below}{'up'}, $first_below, $res_below);
	}
	else
	{
	    $res_up_below = &get_res_up($stats{$sheet_below}{'up'}, $last_below, $res_below);
	}
	my $elem_below_ref = &get_coords_elements($bx, $by, $res_up_below, $stats{$sheet_below}{'left_to_right'});
	my %elem_below = %$elem_below_ref;
	
	if ($interactions{$cur_inter}[1])
	{
	    #two peaks
	    my $line = "$cur_inter:\n$interactions{$cur_inter}[0]\n$interactions{$cur_inter}[1]";
	    my ($arrow) = &place_arrow($canvas, $elem_above{$res_atm_above}{'x'}, $elem_above{$res_atm_above}{'y'}, $elem_below{$res_atm_below}{'x'}, 
				       $elem_below{$res_atm_below}{'y'}, 'double', $line, $help_ref);
	    
	}
	else
	{
	    #one peak
	    my $line = "$cur_inter:\n$interactions{$cur_inter}[0]";
	    my ($arrow) = &place_arrow($canvas, $elem_above{$res_atm_above}{'x'}, $elem_above{$res_atm_above}{'y'}, $elem_below{$res_atm_below}{'x'}, 
				       $elem_below{$res_atm_below}{'y'}, 'single', $line, $help_ref);
	}

    }
    

}

sub opt_menu1_load
{


}

sub opt_menu2_load
{


}


sub get_all_sheets
{
    my ($data_ref) = @_;

    my @sheets;
    my %sheets_id;
    my $sheet_count = 0;
    my %data = %$data_ref;
    my $id;

    for ($id = 0; $id < scalar(@{$data{'Temp_ids'}}); $id++)
    {
	my $line = $data{'Temp_ids'}[$id];
	if ($line =~ /sheet\s+([\-\d]+)$/i)
	{
	    $sheets[$sheet_count] = $1;
	    $sheets_id{$sheets[$sheet_count]} = $id;
	    $sheet_count++;
	}
    }
    
    return (\@sheets, \%sheets_id);
}

return 1;
