my $bg = '#EFF8FF';
my $but_bg = '#265580';
my $but_fg = $bg;
my $cbt_act = '#D1E4F2';
my $but_act = '#2D4455';
my $nb1_bg = '#9EBCD2';
my $nb2_bg = '#78A1BF';

sub build_cns_new_gui {
	my ($main, $basepath, $cns_vals) = @_;
	my $txt_pdb;
	my $txt_ranks;
	my $ety_line = 0;
	my $pdb_done = 0;
	my $stat_txt = '';
	my ($key, $value);
	my $pid;
	my $tree;

	my $window = $main->Toplevel();
	$window->configure(-title=>'CNS Water Refinement');
	my $full_frm = $window->Frame(-background=>$bg)->pack(-fill=>'both', -expand=>1, -padx=>3, -pady=>3);
	my $path_lbl = $full_frm->Label(-background=>$bg, -text=>"Basepath - $$basepath", -relief=>'ridge', -borderwidth=>2)->pack(-fill=>'x', -expand=>1, -padx=>3, -pady=>3);
	my $opt_frm = $full_frm->Frame(-background=>$bg)->pack(-fill=>'x', -expand=>1, -padx=>3, -pady=>3);
	&cns_create_row('-na', 1,1, 'Protein Name', $opt_frm, $main, $basepath, $cns_vals);
	&cns_create_row('-cf', 1,1, 'Control File (optional) - to run DP on the refined models', $opt_frm, $main, $basepath, $cns_vals);
	my $but_frm = $full_frm->Frame(-relief=>'ridge', -background=>$bg)->pack(-fill=>'both', -expand=>1, -padx=>3, -pady=>3);
	my $run_but = $but_frm->Button(-text=>'RUN', -background=>$but_bg, -foreground=>$but_fg, -font=>[-size=>11], -activebackground=>$but_act, -activeforeground=>$but_fg)
		->pack(-fill=>'x', -expand=>1, -padx=>5, -side=>'left');
	my $stp_but = $but_frm->Button(-text=>'STOP', -background=>$but_bg, -foreground=>$but_fg, -font=>[-size=>11], -activebackground=>$but_act, -activeforeground=>$but_fg, -state=>'disabled')
		->pack(-fill=>'x', -expand=>1, -padx=>5, -side=>'left');
	my $can_but = $but_frm->Button(-text=>'CLOSE', -background=>$but_bg, -foreground=>$but_fg, -font=>[-size=>11], -activebackground=>$but_act, -activeforeground=>$but_fg)
		->pack(-fill=>'x', -expand=>1, -padx=>5, -side=>'left');

	#notebook

	my $nb_frm = $full_frm->Frame(-relief=>'ridge', -borderwidth=>2, -background=>$bg)->pack(-fill=>'both', -expand=>1, -padx=>5, -pady=>5);
	my $nb = $nb_frm->NoteBook(-background=>$nb1_bg, -backpagecolor=>$bg, -inactivebackground=>$bg)->pack(-fill=>'both', -expand=>1);

	#pages in notebook
	my $txt_frm = $nb->add('txt_frm', -label=>'Log');
	my $cns_frm = $nb->add('cns_frm', -label=>'CNS Scores');
	my $dp_ranks_frm = $nb->add('dp_ranks_frame', -label=>'DP Ranks');
	my $tre_frm = $nb->add('tre_frm', -label=>'Tree View');
	$tre_frm->configure(-background=>$nb1_bg);
	$txt_frm->configure(-background=>$nb1_bg);
	$cns_frm->configure(-background=>$nb1_bg);
	$dp_ranks_frm->configure(-background=>$nb1_bg);

	$txt_pdb = $txt_frm->Scrolled('Text', -scrollbars=>'oe', -background=>'white', -height=>20)->pack(-fill=>'x', -expand=>1, -padx=>3, -pady=>3);
	my $txt_stat = $txt_frm->Label(-textvariable=>\$stat_txt, -background=>$nb1_bg, -height=>2, -relief=>'sunken')->pack(-fill=>'x', -expand=>1);

	$txt_ranks = $dp_ranks_frm->Scrolled('Text', -scrollbars=>'oe', -background=>'white', -height=>20)->pack(-fill=>'x', -expand=>1, -padx=>3, -pady=>3);
	my $ranks_stat = $dp_ranks_frm->Label(-textvariable=>\$stat_txt, -background=>$nb1_bg, -height=>2, -relief=>'sunken')->pack(-fill=>'x', -expand=>1);

	while (($key, $value) = each (%$cns_vals)) {
		if ($key =~ /cbt/i) {
			$cns_vals->{$key} = 1;
		}
	}
	$cns_vals->{'cf_ent_val'} = '';

	$run_but->configure(-command=>sub 
			{
				if ($cns_vals->{'na_ent_val'} =~ /^\~/) {
					$cns_vals->{'na_ent_val'} =~ s/\~/$ENV{'HOME'}/;
				}
				if ($cns_vals->{'cf_ent_val'} =~ /^\~/) {
					$cns_vals->{'cf_ent_val'} =~ s/\~/$ENV{'HOME'}/;
				}
				if (&check_cns_vals($cns_vals, $window)) {
					$nb->raise('txt_frm');
					if ($tree) {
						$tree->delete('all');
					}
					my $kid;
					foreach $kid ($tre_frm->children) {
						$kid->destroy if Tk::Exists($kid);
					}
					foreach $kid ($cns_frm->children) {
						$kid->destroy if Tk::Exists($kid);
					}
					my $id = $window->after(2500, sub
						{
							&load_tree($cns_vals, $tre_frm, $window, $tree);
						});
					if (-f $cns_vals->{'na_ent_val'} . ".pdb") {
						$run_but->configure(-state=>'disabled');
						$stp_but->configure(-state=>'normal');
						if (&run_cns($cns_frm, $dp_ranks_frm, $txt_ranks, $cns_vals, \$stat_txt, \$pdb_done, $window, \$ety_line, $txt_pdb, \$pid)) {
							$nb->raise('cns_frm');
						}
						#print "returned from run_cns...\n";
						$run_but->configure(-state=>'normal');
						$stp_but->configure(-state=>'disabled');
						$stat_txt = '';
					}
				} else {
					print "check_cns_vals was not successful\n";
				}
			});
	$stp_but->configure(-command=>sub {&stop_pdb_load($window, $txt_pdb, \$stat_txt, \$pid, \$pdb_done);});
	$can_but->configure(-command=>sub {%$cns_vals = (); $window->destroy(); });
	$window->OnDestroy(sub 
			{
				if ($$pid) {
					&stop_pdb_load(\$pdb_mult_done, $window, $txt_pdb, \$stat_txt, \$pid);
				}
			});
    $window->waitWindow;
}

sub build_cns_open_gui {
	my ($main, $basepath, $cns_vals) = @_;
	my $pdb_done = 0;
	my $txt_ranks;
	my $dp = 0;
	my $stat_txt = '';
	my ($key, $value);
	my $pid;
	my $tree;
    my ($cns_dir) = &OpenDir('cns', $main, $basepath);
    $cns_dir = File::Spec->rel2abs($cns_dir, $basepath);
	my $ranks = 0;
	my $ranks_file = "$cns_dir/RANKS";
	if (-f $ranks_file) {
		$ranks = 1;
	}

	my $window = $main->Toplevel();
	$window->configure(-title=>'CNS Water Refinement');
	my $full_frm = $window->Frame(-background=>$bg)->pack(-fill=>'both', -expand=>1, -padx=>3, -pady=>3);
	my $path_lbl = $full_frm->Label(-background=>$bg, -text=>"Basepath - $$basepath", -relief=>'ridge', -borderwidth=>2)->pack(-fill=>'x', -expand=>1, -padx=>3, -pady=>3);

	#notebook
	my $nb_frm = $full_frm->Frame(-relief=>'ridge', -borderwidth=>2, -background=>$bg)->pack(-fill=>'both', -expand=>1, -padx=>5, -pady=>5);
	my $nb = $nb_frm->NoteBook(-background=>$nb1_bg, -backpagecolor=>$bg, -inactivebackground=>$bg)->pack(-fill=>'both', -expand=>1);

	#pages in notebook
	my $cns_frm = $nb->add('cns_frm', -label=>'CNS Results');
	$cns_frm->configure(-background=>$nb1_bg);
	my $tre_frm = $nb->add('tre_frm', -label=>'Tree View');
	$tre_frm->configure(-background=>$nb1_bg);
	$cns_frm->configure(-background=>$nb1_bg);

	my $dp_ranks_frm;
	if ($ranks) {
		$dp_ranks_frm = $nb->add('dp_ranks_frame', -label=>'DP Ranks');
		$dp_ranks_frm->configure(-background=>$nb1_bg);
		$txt_ranks = $dp_ranks_frm->Scrolled('Text', -scrollbars=>'oe', -background=>'white', -height=>20)->pack(-fill=>'x', -expand=>1, -padx=>3, -pady=>3);
		my $ranks_stat = $dp_ranks_frm->Label(-textvariable=>\$stat_txt, -background=>$nb1_bg, -height=>2, -relief=>'sunken')->pack(-fill=>'x', -expand=>1);
	}
	#my $cn_txt = $cns_frm->Scrolled('Text', -scrollbars=>'oe', -background=>'white', -height=>20)->pack(-fill=>'x', -expand=>1, -padx=>3, -pady=>3);
	#$nb->raise('tr_frm');
	#return;

	$nb->raise('tre_frm');
	if ($tree) {
		#$tree->delete('all');
	}
	my $kid;
	foreach $kid ($tre_frm->children) {
		$kid->destroy if Tk::Exists($kid);
	}
	foreach $kid ($cns_frm->children) {
		$kid->destroy if Tk::Exists($kid);
	}
	my $id = $window->after(0, sub
		{
			&load_tree($cns_vals, $tre_frm, $window, $tree);
		});
	if ($ranks) {
		$nb->raise('dp_ranks_frame');
		my ($fpd_but, $ql_but, $qi_but, $nb, $txt) = &dp_ranks_frame($dp_ranks_frm, $ranks_file, $txt_ranks, $window);
	}
	$stat_txt = '';
    $window->waitWindow;
}

sub load_tree {
    my ($cns_vals, $tre_frm, $window, $tree) = @_;
    my $root = $cns_vals->{'ro_ent_val'};
    unless ($root =~ /^\//) {
		$root = File::Spec->rel2abs($root, $basepath);
    }
    if (-d $root) {
		&create_tree($tre_frm, $window, $root, $tree);
    }
}

sub cns_create_row {
    my ($cbt_txt, $ent, $brw, $desc, $big_frm, $main, $bp, $cns_vals) = @_;
    $cbt_txt=~/\-(\w+)/;
    my $option = $1;
    my $cbt_val = $option."_cbt_val";
    my $ent_val = $option."_ent_val";
    $cns_vals->{$cbt_val} = 1;
    my $frm = $big_frm->Frame(-background=>$bg)->pack(-side=>'top', -padx=>3, -pady=>3, -fill=>'x', -expand=>1);
    my $desc_lbl = $frm->Label(-text=>"$desc: ", -width=>40, -wraplength=>250, -background=>$bg)->pack(-side=>'left', -padx=>5, -pady=>3, -anchor=>'e');
    my $cbt = $frm->Checkbutton(-text=>$cbt_txt, -variable=>\$cns_vals->{$cbt_val}, -background=>$bg, -activebackground=>$cbt_act, -width=>5)->pack(-side=>'left', -padx=>3, -pady=>3);
    if ($ent) {
		my $entry = $frm->Entry(-textvariable=>\$cns_vals->{$ent_val}, -width=>25, -background=>'white')->pack(-side=>'left', -padx=>3, -pady=>3);
    } else {
		my $ety_lbl = $frm->Label(-width=>20, -background=>$bg)->pack(-side=>'left', -padx=>3, -pady=>3);
    }
    if ($brw) {
		my $brw_but = $frm->Button(-text=>'Browse', -command=>sub 
				{
					if ($cbt_txt =~ /o/i) {
						my $new_name = &OpenDir($cbt_txt, $main, $$bp, 1);
						if ($new_name) {
							$cns_vals->{$ent_val} = $new_name;
						} else {
							return;
						}
					} else {
						my $new_name =  &OpenFile($cbt_txt, $main, $$bp, \$a);
						if ($new_name) {
							$cns_vals->{$ent_val} = $new_name;
						} else {
							return;
						}
					}
				}
				, -width=>10, -background=>$but_bg, 
				-foreground=>$but_fg, -activebackground=>$but_act, -activeforeground=>$but_fg)
				->pack(-side=>'left', -padx=>3, -pady=>3);
    } else {
		my $ety_lbl = $frm->Label(-width=>10, -background=>$bg)->pack(-side=>'left', -padx=>3, -pady=>3);
    }
}

sub check_cns_vals {
	my ($ret_vals, $win) = @_;
	my $protein_name = $ret_vals->{'na_ent_val'}; 
	if (!($protein_name)) {
		&err_msg("protein name is required", $win);
		return 0; 
	}
	return 1;
	my $cf_file = $ret_vals->{'cf_ent_val'}; 
	if (!(-f $cf_file)) {
		&err_msg("File \"$cf_file\" does not exist!", $win);
		return 0; 
	}
	return 1;
}

sub cns_gui {
    my ($main, $basepath, $option) = @_;
    
    my %cns_vals = ();
    
	if ($option =~ /open/) {
	    &build_cns_open_gui($main, \$basepath, \%cns_vals);
	} else {
	    &build_cns_new_gui($main, \$basepath, \%cns_vals);
	}
    
    #$cns_vals{'ro_ent_val'} = File::Spec->rel2abs($cns_vals{'ro_ent_val'}, $basepath) if ($cns_vals{'ro_ent_val'});
    $cns_vals{'cf_ent_val'} = File::Spec->rel2abs($cns_vals{'cf_ent_val'}, $basepath) if ($cns_vals{'cf_ent_val'});
    #$cns_vals{'q_ent_val'} = File::Spec->rel2abs($cns_vals{'q_ent_val'}, $basepath) if ($cns_vals{'q_ent_val'});

    return (\%cns_vals);
}

#run cns calculations
sub run_cns {
    my ($cns_frm, $dp_ranks_frm, $txt_ranks, $cns_vals, $stat_txt, $pdb_done, $window, $ety_line, $txt_pdb, $pid) = @_;
	my $protein_name = $cns_vals->{'na_ent_val'};
    my $pdb_file = $protein_name . ".pdb";
   
    if (-f $pdb_file) {
		$$stat_txt = "Calculation running on pdb_file  - $pdb_file...\n";
		$$pdb_done = 0;
		my $out_dir = "";#$cns_vals->{'ro_ent_val'};
		unless ($out_dir =~ /^\//) {
			$out_dir = File::Spec->rel2abs($out_dir, $basepath);
		}
		#print "RPF_gui: out_dir is $out_dir\n";
	
		my $command = $ENV{'ASBIN'} . "/Refinement";
		my $vals = "-na $protein_name";
		if ($cns_vals->{'cf_ent_val'}) {
			$vals .= " -cf ".$cns_vals->{'cf_ent_val'}."";#-o ".$out_dir." -q ".$pdb_file;
		}
		print "commad to execute is: $command $vals\n";
		#if (-d $out_dir)
		#{
		#    &err_msg("Directory \"$out_dir\" exists!  Please remove it and try running the script again", $window);
		#    #print "returning from run_cns...\n";
		#    return 0;
		#}
	
		unless (defined($$pid = open(PDB_FILE, "$command $vals 2>&1|")))
		{
			&err_msg("Cannot fork", $window);
			return 0;
		}
	
		#print "run_cns: child process started...\n";
	
		$window->fileevent(PDB_FILE, 'readable'=>sub {&pdb_load_txt($ety_line, $txt_pdb, $pdb_done, $window, $stat_txt, $pid)});
	
		$window->waitVariable($pdb_done);
		#print "run_cns: child process done...\n";

		#$window->bell;

		#load cns score data for this pdb file
	
		#get .ovw file from cycle dir
		#return 1;
		if ($cns_vals->{'na_ent_val'}) {
			if (-f "RANKS") {
				my $ranks_file = File::Spec->rel2abs("RANKS", $out_dir);
				my ($fpd_but, $ql_but, $qi_but, $nb, $txt) = &dp_ranks_frame($dp_ranks_frm, $ranks_file, $txt_ranks, $window);
			}
		}
    }
    return 1;
}

sub pdb_load_txt {
    my $c;
    my ($ety_line, $txt_pdb, $pdb_done, $window, $stat_txt, $pid) = @_;
    if (defined ($c = (getc PDB_FILE))) {
		if (($c =~  /[\t\n\w\.\:\-\(\)\/\\\ \[\]\>\,\`\'\;\*]/)) {
			$$ety_line = 0;
			$txt_pdb->insert('end', $c);
			$txt_pdb->yview('end');
			return;
		} else {
			if (!($$ety_line)) {
				$$ety_line = 1;
				$txt_pdb->insert('end', "\n");
				return;
			}
		}
    } else {
		&stop_pdb_load($window, $txt_pdb, $stat_txt, $pid, $pdb_done);
    }
}

sub stop_pdb_load {
    my ($window, $txt_pdb, $stat_txt, $pid, $pdb_done) = @_;
    $$pdb_done = !$$pdb_done;
    unless ($$pid) {
		return;
    }
    kill 9 => $$pid;
    $window->fileevent(PDB_FILE, 'readable'=>'');
    close(PDB_FILE);
    
    $txt_pdb->insert('end', "\n\n");
    $txt_pdb->insert('end', '***Done***');
    $txt_pdb->insert('end', "\n\n");
    $txt_pdb->yview('end');
    $$stat_txt = '';
    
    return;
}

sub change_cns_basepath {
    my ($basepath, $chg_bpth, $window, $cns_vals) = @_;
    
    $old_basepath = Cwd::cwd;
    #print "change_cns_basepath: old_basepath - $old_basepath, basepath = $$basepath\n";
    
    unless (-d $$basepath) {
		my $err_dlg = $window->Dialog(-text=>"Directory $basepath does not exist!\n Do you want to create it?", -buttons=>['Yes', 'No']);
		my $ans = $err_dlg->Show();
		if ($ans eq 'No') {
			$$basepath = $old_basepath;
			$chg_bpth->configure(-state=>'disabled');
			return;
		} else {
			mkdir $$basepath;
		}
    }
    
    chdir $$basepath;
    $$basepath = Cwd::cwd;
    $chg_bpth->configure(-state=>'disabled');

    foreach $option (qw/c_ent_val ro_ent_val q_ent_val/) {
		if ($cns_vals->{$option}) {
			my $name = $cns_vals->{$option};
			#print "change_cns_basepath: cns_vals{$option} = $name\n";
			
			$name = File::Spec->rel2abs($name, $old_basepath);
			#print "change_cns_basepath: name after rel2abs = $name\n";
			
			if ($name =~ /$$basepath/) {
				$cns_vals->{$option} = File::Spec->abs2rel($name, $$basepath);
			} else {
				$cns_vals->{$option} = $name;
			}
			#print "change_cns_basepath: cns_vals->{$option} changed to $cns_vals->{$option}\n";
		}
    }
}

return 1;
