sub convert_bmrb
{
    my ($parent) = @_;

    my %data;
    my @formats = ('BMRB');
	my %output_formats = ('LACS' => 'l', 'TALOS' => 't');#, 'ASDP shifts table' => 'c', 'ASDP sequence' => 's');

    my $window = $parent->Toplevel(-title=>'BMRB Conversions');
    
    my $title_lbl = $window->Label(-text=>'Do Conversions', -relief=>'raised')->pack(-fill=>'x', -ipady=>3);
    
    my $frm1 = $window->Frame()->pack(-padx=>5, -pady=>5);
    my $inp_lbl = $frm1->Label(-text=>'Input : ')->pack(-side=>'left', -padx=>3);
    my $inp_ent = $frm1->Entry(-background=>'white', -textvariable=>\$data{'input'})->pack(-side=>'left', -padx=>3);
    my $inp_brw = $frm1->Button(-text=>'Browse', -command=>sub
				{
				    $data{'input'} = &OpenFile('Input', $window, Cwd::cwd);
				})->pack(-side=>'left', -padx=>3);
    my $inp_for = $frm1->Optionmenu(-variable=>\$data{'input format'}, -options=>[@formats], -background=>'white')->pack(-side=>'left', -padx=>3);

    my $frm2 = $window->Frame()->pack(-padx=>5, -pady=>5);
    my $out_lbl = $frm2->Label(-text=>'Output : ')->pack(-side=>'left');
    my $out_ent = $frm2->Entry(-background=>'white', -textvariable=>\$data{'output'})->pack(-side=>'left', -padx=>3);
    my $out_brw = $frm2->Button(-text=>'Browse', -command=>sub
				{
				    $data{'output'} = &OpenFile('Output', $window, Cwd::cwd);
				})->pack(-side=>'left', -padx=>3);
    my $out_for = $frm2->Optionmenu(-variable=>\$data{'output format'}, -options=>[keys(%output_formats)], -background=>'white')->pack(-side=>'left', -padx=>3);
    
    my $frm3 = $window->Frame()->pack(-padx=>5, -pady=>5);
    my $con_but = $frm3->Button(-text=>'Convert')->pack(-side=>'left', -padx=>3);
    my $cls_but = $frm3->Button(-text=>'Close', -command=>sub {$window->destroy();})->pack(-side=>'left', -padx=>3);
    
    $con_but->configure(-command=>sub
			{
			    return if ($data{'input format'} eq $data{'output format'});
			    $data{'input'} =~ s/^\~/$ENV{'HOME'}/;
			    $data{'output'} =~ s/^\~/$ENV{'HOME'}/;
			    
			    print "input file is $data{'input'} (format $data{'input format'}) and output_file is $data{'output'} (format $data{'output format'})\n";
				#print "options is " . $output_formats{$data{'output format'}} . "\n";

			    my $key = "$data{'input format'},$data{'output format'}";
				my $command = $ENV{'ASBIN'} . "/parse_bmrb.pl -" . $output_formats{$data{'output format'}} . " $data{'input'} > " . $data{'output'};
				#print "command is $command\n";
				`$command`;
			    #&conv_all($data{'input'}, $data{'output'}, $window, $key);
			    
			    print "Done Converting!\n";
			});

}

return 1;
