my ($win_wid, $win_ht);

my $bga = '#E9EFFF';
my $bgb = $bga;
my $bgc = '#6699CC';
my $bgd = '#376EA4';

my $bg1 = "#EEFFFF";



sub create_as_sum
{
    my ($parent, $page, $data_ref, $heading_ref, $dir) = @_;

    my $debug = 0;

    my %data = %$data_ref;
    #my (@peaklists) = (keys %data);
    my ($pklst);
    my $pklst_count = 1;


    my $nb = $page->NoteBook()->pack(-fill=>'both', -expand=>1);
    my $main = $nb->add('main', -label=>'Main');
    my $del_main = 1;
    #my $pk_pg;

    $parent->update;
    ($win_wid, $win_ht) = ($parent->width, $parent->height);
    

    foreach $pklst (keys %data)
    {
	my $txt_ht = $win_ht * 0.01;
	my $pk_pg = $nb->add($pklst, -label=>"Peaklist $pklst_count");
	$pklst_count++;

	my $graph_frm = $pk_pg->Frame()->pack(-fill=>'both', -expand=>1, -padx=>3, -pady=>3);
	&put_as_data($graph_frm, $data_ref, $pklst, $parent, $heading_ref, $dir);
    }

    $nb->delete('main');

    my $upd_but = $page->Button(-text=>'Update', -command=>sub
				{
				    #update
				    foreach $pklst (keys %data)
				    {
					$nb->delete($pklst);
				    }
				    my $main = $nb->add('main', -label=>'Main');
				    $pklst_count = 1;
				    foreach $pklst (keys %data)
				    {
					my $txt_ht = $win_ht * 0.01;
					my $pk_pg = $nb->add($pklst, -label=>"Peaklist $pklst_count");
					$pklst_count++;
					
					my $graph_frm = $pk_pg->Frame(-background=>$bg1)->pack(-fill=>'both', -expand=>1, -padx=>3, -pady=>3);
					&put_as_data($graph_frm, $data_ref, $pklst, $parent, $heading_ref, $dir);
				    }
				    $nb->delete('main');
				    
				})->pack(-fill=>'x', -expand=>1);

    if ($debug)
    {
	print "create_as_sum:\n";
	print "Window width = $win_wid, height = $win_ht\n";
	print "done create_as_sum\n";
    }
    
}


sub put_as_data
{
    my ($frame, $data_ref, $pklst, $parent, $heading_ref, $dir) = @_;
    my %data = %$data_ref;
    my %cyc_but;

    my $debug = 0;

    my ($can_wid, $can_ht) = ($win_wid * 0.95, $win_wid * 1.01);

    my (@cycles) = &get_as_cycles($data_ref, $pklst);
    
    my ($x_tot_div) = ($#cycles) + 1;

    my $lbl = $frame->Label(-text=>"Peaklist $pklst", -relief=>'ridge', -background=>$bg1)->pack(-fill=>'x', -ipadx=>5, -ipady=>5);

    my $out_canvas = $frame->Canvas(-background=>$bg1)->pack(-fill=>'both', -expand=>1, -padx=>5, -pady=>5, -ipadx=>5, -ipady=>15);

    #create canvas
    my $scr_canvas = $out_canvas->Scrolled('Canvas', -scrollbars=>'s')->pack(-anchor=>'nw', -padx=>37, -pady=>5);
    my $canvas = $scr_canvas->Subwidget('canvas');
    $canvas->configure(-background=>'white', -width=>$can_wid, -height=>$can_ht);

    #$out_canvas->createWindow(30, 0, -window=>$scr_canvas, -anchor=>'nw');
    #my $canvas = $frame->Canvas(-background=>'white', -width=>$can_wid, -height=>$can_ht)->pack();
    
    #create grid
    my ($rx1, $ry1, $rx2, $ry2) = (0,0, $can_wid, $can_wid);

    if ($#cycles > 12)
    {
	$rx2 = $#cycles * 40;
    }
    my $grid_rect = $canvas->createRectangle($rx1, $ry1, $rx2, $ry2, -outline=>'red', -width=>1);

    #place cycles on x axis
    $x_tot_div = 1 if ($x_tot_div == 0);
    my ($x_div) = ($rx2 - $rx1) / ($x_tot_div);

    my $x_pt;
    my $cyc_ct = 1;

    for ($x_pt = ($rx1 + $x_div); $x_pt<($rx2-1); $x_pt+=$x_div)
    {
	my @new = @{$cycles[$cyc_ct]};
	#print "new is @new\n";
	#next unless (@new);
	&place_x_mark($x_pt, $ry2, $canvas);
	if (@new)
	{
	    $cyc_but{$cycles[$cyc_ct][$#new]} = &place_cyc_but($x_pt, ($ry2 + 15), $canvas, $cycles[$cyc_ct][$#new], ($x_div * 0.8), $data_ref, $pklst, $parent, $heading_ref, $dir);
	}
	else
	{
	    #$cyc_but{$cycles[$cyc_ct][$#new]} = &place_cyc_but($x_pt, ($ry2 + 15), $canvas, $cycles[$cyc_ct][$#new], ($x_div * 0.8), $data_ref, $pklst, $parent, $heading_ref, $dir);
	    &place_cyc_but($x_pt, ($ry2 + 15), $canvas, $cyc_ct);
	}
	$cyc_ct++;
    }
    
    #configure the y-axis
    my ($max_peak, %y_pts) = &get_y_pts($data_ref, $pklst);
    #print "max_peak is $max_peak\n";
    my $max_y = (($max_peak / 100) + 0.5);
	
    $max_y = sprintf("%0.0f", $max_y);
    $max_y = $max_y * 100;
    
    #print "max_y is $max_y\n";
    
    my $y_lbl_div = $max_y / 10;
    $y_lbl_div = sprintf("%d", $y_lbl_div);

    my $y_div = ($ry2) / 10;

    my $k = 0;
    my $y_pt;
    
    for ($y_pt = 0; $y_pt<=$max_y; $y_pt+=$y_lbl_div)
    {
	#my $x = $rx1;
	my $x = 35;
	my $y = $ry2 - ($k * $y_div);

	my $y_lbl = ($y_pt / $max_y) * 100;
	&place_y_mark($x, $y, $out_canvas, $y_lbl, $y_pt, $can_wid+90);
	
	$k++;
    }

    $out_canvas->configure(-scrollregion=>[$out_canvas->bbox('all')], -confine=>1);
    
    my $y_scale = $ry2 / $max_y;

    my $prev_cycle;

    #place data points on grid
    my $c;
    for ($c = 1; $c<=$#cycles; $c++)
    {
	my @new = @{$cycles[$c]};
	#next unless (@new);

	my $x = (($c-1) * $x_div) + $x_div + $rx1;

	#Peak Assigned curve
	my $point = $y_pts{'Peak_Assigned'}{$cycles[$c][$#new]};
	#print "% assigned is $point\n";
	unless ($point)
	{
	    my $x = $c;
	    my @new_cyc = @{$cycles[$x]};
	    my $b = $#new_cyc - 1;
	    #print "cycle $x has not peak assigned point, looking in subcycles $b\n";
	   
	    while (!$point)
	    {
		if ($b >=0)
		{
		    $point = $y_pts{'Peak_Assigned'}{$cycles[$x][$b]};
		    #print "new point is of cycle $x-$b, checking\n";
		    $b--;
		}
		else
		{
		    $x--;
		    @new_cyc = @{$cycles[$x]};
		    $b = $#new_cyc;
		}
	    }
	}
	
	if ($point)
	{
	    my $y = $ry2 - (($point/100) * $ry2);
	    $y = sprintf("%d", $y);
	    #print "% assigned is $point at ($x, $y)\n";
	    
	    &put_recall($x, $y, $canvas);
	}
	
	
	#Assignment made curve
	$point = $y_pts{'Assignment_Made'}{$cycles[$c][$#new]};
	unless ($point)
	{
	    my $x = $c;
	    my @new_cyc = @{$cycles[$x]};
	    my $b = $#new_cyc - 1;
	    
	    while (!$point)
	    {
		if ($b >= 0)
		{
		    $point = $y_pts{'Assignment_Made'}{$cycles[$x][$b]};
		    $b--;
		}
		else
		{
		    $x--;
		    @new_cyc = @{$cycles[$x]};
		    $b = $#new_cyc;
		}
	    }
	}
	if ($point)
	{
	    my $y = $point * $y_scale;
	    $y = sprintf("%d", ($ry2 - $y));
	    &put_precision($x, $y, $canvas);
	}
	
    }


    #legend
    my ($lx1, $ly1, $lx2, $ly2) = ($rx1+50, $ry2 + 55, $can_wid+50, $ry2 + 70);
    my $leg_rect = $out_canvas->createRectangle($lx1, $ly1, $lx2, $ly2, -outline=>'green');
    
    &put_recall($lx1 + 10, $ly1 + 7, $out_canvas);
    my $leg_txt1 = $out_canvas->createText($lx1 + 75, $ly1 + 7, -text=>" - % Peak Assigned");
    
    &put_precision($lx1 + 200, $ly1 + 10, $out_canvas);
    my $leg_txt2 = $out_canvas->createText($lx1 + 275, $ly1 + 7, -text=>" - Assignment Made");


    
    $canvas->update;
    $canvas->configure(-scrollregion=>[$canvas->bbox('all')], -confine=>1);
    $out_canvas->update;
    $out_canvas->configure(-scrollregion=>[$out_canvas->bbox('all')], -confine=>1);
    #$canvas->configure(-confine=>1);
    
    
    if ($debug)
    {
	print "put_as_data:\n";
	#print "canvas width = $can_wid, height = $can_ht\n";
	print "peaklist $pklst\n";
	print "max_peak is $max_peak, max_y is $max_y, and y_div is $y_div, ry2 = $ry2\n";
	print "y_scale = $y_scale\n";
	print "cycles are @cycles\n";
    }
    
}

sub place_y_mark
{
    my ($x, $y, $canvas, $label, $peak, $width) = @_;
    
    my ($line) = $canvas->createLine($x, $y, $x+3, $y);
    my ($text) = $canvas->createText($x-12, $y, -text=>$label, -fill=>'dark green');
    my ($line2) = $canvas->createLine($width-31, $y, $width-28, $y);
    my ($text2) = $canvas->createText($width-25, $y, -text=>$peak, -anchor=>'w', -fill=>'red');
    
}


sub get_y_pts
{
    my ($data_ref, $pklst) = @_;
    my %data = %$data_ref;

    my $debug = 0;

    my %y_pts;
    my $cycle;
    my $max_peak = 0;
    my $prev_cycle;

    foreach $cycle (sort keys %{$data{$pklst}{'Peak-Assignment Stat'}})
    {
	my $count = scalar(@{$data{$pklst}{'Peak-Assignment Stat'}{$cycle}});
	my $line = $data{$pklst}{'Peak-Assignment Stat'}{$cycle}[$count - 1];
	my (@info) = split(/\s+/, $line);

	$y_pts{'Peak_Assigned'}{$cycle} = $info[8];
	$y_pts{'Assignment_Made'}{$cycle} = $info[7];

	unless ($y_pts{'Peak_Assigned'}{$cycle})
	{
	    if ($prev_cycle)
	    {
		$y_pts{'Peak_Assigned'}{$cycle} = $y_pts{'Peak_Assigned'}{$prev_cycle};
	    }
	}

	unless ($y_pts{'Assignment_Made'}{$cycle})
	{
	    if ($prev_cycle)
	    {
		$y_pts{'Assignment_Made'}{$cycle} = $y_pts{'Assignment_Made'}{$prev_cycle};
	    }
	}

	
	if ($max_peak < $info[1])
	{
	    $max_peak = $info[1];
	}
	
	$prev_cycle = $cycle;
    }


    return ($max_peak, %y_pts);
    
}



sub place_x_mark
{
    my ($x, $y, $canvas) = @_;
    
    my ($line) = $canvas->createLine($x, 0, $x, $y, -dash=>".");
    
}

sub place_cyc_but
{
    my ($x, $y, $canvas, $label, $width, $data_ref, $pklst, $parent, $heading_ref, $dir) = @_;
    my %data = %$data_ref;
    my %heading = %$heading_ref;

    my ($button) = $canvas->Button(-text=>$label, -command=>sub 
				   {
				       if ($data_ref)
				       {
					   &show_cycle_info($parent, $data_ref, $pklst, $label, $heading_ref, $dir);
				       }
				   });
    $canvas->createWindow($x, $y, -window=>$button, -width=>30);
    return ($button);
}


sub show_cycle_info
{
    my ($parent, $data_ref, $pklst, $label, $heading_ref, $dir) = @_;

    my (@all_cycles) = &get_as_cycles($data_ref, $pklst);
    $label =~ /^(\d+)-/;
    my $cur_cycle = $1;
    
    my @cycles = @{$all_cycles[$cur_cycle]};
    #print "cur_cycle is $cur_cycle, sub cycles are @cycles\n";
    
    my %data = %$data_ref;
    my %heading = %$heading_ref;

    my $win = $parent->Toplevel(-title=>"Cycle information", -background=>$bga);
 
    my $head_lbl = $win->Label(-text=>"Peaklist $pklst : Cycle $cur_cycle", -relief=>'ridge', -borderwidth=>2, -background=>$bga)->pack(-fill=>'x', -ipadx=>2, -ipady=>2);

    my $page = $win->Frame(-background=>$bga)->pack(-fill=>'both', -expand=>1);
    #my $nb = $frm->NoteBook()->pack(-fill=>'both', -expand=>1);
    #my $main = $nb->add('Main', -label=>'Main');

    my $i;
    
    my $frm1 = $page->Frame(-relief=>'ridge', -borderwidth=>2, -background=>$bgb)->pack(-pady=>3);
    my $frm1_lbl = $frm1->Label(-text=>'NOESY_Assign Process', -background=>$bga, -relief=>'ridge', -borderwidth=>2)->pack(-fill=>'x', -padx=>2, -pady=>2);
    my $frm1_grid = $frm1->Frame(-background=>$bgb)->pack();
    
    my $row = 0;
    my $col = 0;
    my $head;
    
    my @heads = split(/\s+/, $heading{$pklst}{'NOESY_Assign Process'});
    #print "heads = @heads\n";
    
    for ($head = 0; $head<=$#heads; $head++)
    {
	$frm1_grid->Label(-text=>$heads[$head], -relief=>'raised', -background=>$bgc)->grid(-row=>$row, -column=>$col);
	$col++;
    }
    $row = 1;
    
    for ($i = 0; $i<=$#cycles; $i++)
    {
	my $cycle = $cycles[$i];
	
	my @noesy_assign = @{$data{$pklst}{'NOESY_Assign Process'}{$cycle}};
	my $count = scalar(@noesy_assign);
	
	#go through each item in noesy_assign, split the contents and enter into row
	my $line;
	for ($line = 0; $line < $count; $line++)
	{
	    my @items = split(/\s+/, $noesy_assign[$line]);
	    $col = 0;
	    my $k;
	    
	    for ($k = 0; $k<=$#items; $k++)
	    {
		next if (($k == 2) or ($k == 4));
		
		$frm1_grid->Label(-text=>$items[$k], -background=>$bgb)->grid(-row=>$row, -column=>$col);
		$col++;
	    }
	    $row++;
	    
	}
    }
	
    my $frm2 = $page->Frame(-relief=>'ridge', -borderwidth=>2, -background=>$bgb)->pack(-fill=>'both', -expand=>1, -pady=>3);
    my $frm2_lbl = $frm2->Label(-text=>'Assignment Stat', -relief=>'ridge', -borderwidth=>2, -background=>$bga)->pack(-fill=>'x', -padx=>2, -pady=>2, -ipady=>3);
    
    my $ass_stat = $data{$pklst}{'Assignment Stat'}{$cycles[$#cycles]}[0];
    #print "ass_stat = @ass_stat\n";
    @items = split(/\s+/, $ass_stat);
    

    my $frm2_lbl1 = $frm2->Label(-text=>"Total Assignment : $items[1]", -background=>$bgb)->pack(-expand=>1, -anchor=>'w');
    my $frm2_lbl2 = $frm2->Label(-text=>"Intra Residue : $items[2]", -background=>$bgb)->pack(-expand=>1, -anchor=>'w');
    my $frm2_lbl3 = $frm2->Label(-text=>"Inter Residue : ", -background=>$bgb)->pack(-expand=>1, -anchor=>'w');
    
    my $sub_frm2 = $frm2->Frame(-background=>$bgb)->pack(-fill=>'both', -expand=>1);
    
    my $frm2_grid = $sub_frm2->Frame(-relief=>'ridge', -borderwidth=>2, -background=>$bgb)->pack(-expand=>1, -anchor=>'w', -side=>'left');
    $col = 1;
    foreach $head (qw/TOT BB BS SS/)
    {
	$frm2_grid->Label(-relief=>'raised', -text=>$head, -background=>$bgc)->grid(-row=>0, -column=>$col, -ipadx=>25);
	$col++;
    }
    
    $row = 1;
    foreach $head("  (i-j)=1  ", "1<(i-j)<5", "  (i-j)>5  ")
    {
	$frm2_grid->Label(-relief=>'groove', -borderwidth=>2, -text=>$head, -background=>$bgc)->grid(-row=>$row, -column=>0, -ipadx=>7);
	$row++;
    }
    
    $count = 3;
    for ($row = 1; $row <=3; $row++)
    {
	for ($col = 1; $col<=4; $col++)
	{
	    $frm2_grid->Label(-text=>$items[$count], -background=>$bgb)->grid(-row=>$row, -column=>$col);
	    $count++;
	}
    }
    
    unless ($cur_cycle == 1)
    {
	#if ($i == $#cycles)
	my $temp_cycle = $cycles[$#cycles];
	my $but_frm2 = $sub_frm2->Frame(-background=>$bgb)->pack(-fill=>'both', -expand=>1, -side=>'right');
	my $new_ass = $but_frm2->Button(-text=>'New Assignments', 
					-background=>$bgd,
					-state=> 'disabled',
					-command=>sub 
					{
					    $frm2->configure(-cursor=>"watch");
					    $win->update;
					    #print "cur_cycle is $cur_cycle, temp_cycle is $temp_cycle\n";
					    my (@new_ass) = &get_diff_ass($dir, $pklst, $temp_cycle, $data_ref, 'new');
					    &show_diff_ass($parent, \@new_ass, "New Assignments for Cycle $temp_cycle", $pklst, $dir, $temp_cycle);
					    $frm2->configure(-cursor=>"top_left_arrow");
					    $win->update;
					})->pack(-ipadx=>3, -pady=>5);
	my $rem_ass = $but_frm2->Button(-text=>'Removed Assignments', 
					-background=>$bgd,
					-state=>'disabled',
					-command=>sub
					{
					    $page->configure(-cursor=>'watch');
					    $win->update;
					    #print "cur_cycle is $cur_cycle, temp_cycle is $temp_cycle\n";
					    my (@rem_ass) = &get_diff_ass($dir, $pklst, $temp_cycle, $data_ref, 'rem');
					    #print "displaying data...\n";
					    &show_diff_ass($parent, \@rem_ass, "Removed Assignments for Cycle $temp_cycle", $pklst, $dir, $temp_cycle);
					    $page->configure(-cursor=>'top_left_arrow');
					    $win->update;
					})->pack(-pady=>5);
    }
    
    
    my $frm3 = $page->Frame(-relief=>'ridge', -borderwidth=>2, -background=>$bgb)->pack(-fill=>'both', -expand=>1, -padx=>3, -pady=>3);
    my $frm3_lbl = $frm3->Label(-text=>'Peak_Assignment Stat', -relief=>'ridge', -borderwidth=>2, -background=>$bga)->pack(-fill=>'x', -expand=>1, -ipady=>2);
    my $pk_ass = $data{$pklst}{'Peak-Assignment Stat'}{$cycles[$#cycles]}[0];
    
    @items = split(/\s+/, $pk_ass);
    
    #print "pk_ass: $pk_ass\nitems = @items\n";
    
    my $frm3_grid = $frm3->Frame(-relief=>'ridge', -borderwidth=>2, -background=>$bgb)->pack(-pady=>3, -ipady=>3);
    $row = 0;
    $col = 1;
    
    foreach $head (qw/Total_Assignable_Peak Unambiguous_Assigned Ambiguous_Assigned Total_Assigned Peak_Not_Assigned/)
    {
	$frm3_grid->Label(-relief=>'raised', -text=>$head, -background=>$bgc)->grid(-row=>$row, -column=>$col);
	$col++;
    }
    
    $frm3_grid->Label(-text=>'#', -relief=>'groove', -borderwidth=>2, -background=>$bgc)->grid(-row=>1, -column=>0, -ipadx=>7);
    $frm3_grid->Label(-text=>'%', -relief=>'groove', -borderwidth=>2, -background=>$bgc)->grid(-row=>2, -column=>0, -ipadx=>5);
    
    $count = 1;
    
    for ($col = 1; $col<=5; $col++)
    {
	for ($row = 1; $row<=2; $row++)
	{
	    $frm3_grid->Label(-text=>$items[$count], -background=>$bgb)->grid(-row=>$row, -column=>$col);
	    $count++;
	}
    }
    
    if ($i == 0)
    {
	$nb->delete('Main');
    }
    
    my $cls_but = $win->Button(-text=>'Close', -command=>sub {$win->destroy();}, -background=>$bgd)->pack(-fill=>'x', -padx=>5, -pady=>5);

}

sub show_diff_ass
{
    my ($parent, $ass_ref, $title, $pklst, $dir, $cycle) = @_;

    my @diff = @$ass_ref;

    my $win = $parent->Toplevel(-title=>$title);
    $win->minsize(qw/300 300/);

    my $lbl = $win->Label(-text=>$title, -relief=>'ridge', -borderwidth=>2)->pack(-fill=>'x', -ipadx=>3, -ipady=>3);
    
    my $scr_lbx = $win->Scrolled('Listbox', -scrollbars=>"osoe")->pack(-fill=>'both', -expand=>1, -padx=>5, -pady=>5);
    my $lbx = $scr_lbx->Subwidget("listbox");
    $lbx->configure(-selectmode=>'single', -background=>'white');
    
    my $i;
    for ($i = 0; $i<=$#diff; $i++)
    {
	my $j;
	for ($j = 0; $j<3; $j++)
	{
	    $lbx->insert('end', "$diff[$i][$j]");
	}
	$lbx->insert('end', "");
    }

    $lbx->bind('<Double-Button-1>'=>sub
	       {
		   my $line = $lbx->get($lbx->curselection());
		   #print "line is $line\n";

		   if ($line =~ /^peak/)
		   {
		       #get match file
		       #print "pklst is $pklst, dir is $dir\nline is $line\n";
		       unless (opendir(DIR, $dir))
		       {
			   &err_msg("Cannot open directory \"$dir\"", $parent);
			   return;
		       }
		       
		       my @contents = readdir(DIR);
		       close(DIR);
		       
		       my ($cyc_dir) = grep {/$cycle/} @contents;
		       #print "cyc_dir is $cyc_dir\n";
		       
		       unless ($cyc_dir)
		       {
			   print "no cyc_dir found in $dir\n";
			   return;
		       }
		       $cyc_dir = File::Spec->rel2abs($cyc_dir, $dir);

		       unless (opendir(DIR, $cyc_dir))
		       {
			   &err_msg("Cannot open directory \"$dir\"", $parent);
			   return;
		       }
		       
		       @contents = readdir(DIR);
		       close(DIR);
		       
		       my ($match_file) = grep {/$pklst.+match/} @contents;
		       
		       unless ($match_file)
		       {
			   print "no match file found in $cyc_dir\n";
			   return;
		       }
		       $match_file = File::Spec->rel2abs($match_file, $cyc_dir);

		       if ($match_file =~ /\.gz$/)
		       {
			   $match_file = &unzip_file($match_file);
		       }

		       #print "match file is $match_file\n";
		       &disp_match($parent, $match_file, $line);
		       
		   }
	       });
    #######################3
    #my $stxt = $win->Scrolled('ROText', -scrollbars=>"osoe")->pack(-fill=>'both', -expand=>1);
    #my $txt = $stxt->Subwidget('rotext');
    
    #$txt->configure(-background=>'white');
}

sub get_two_assOrders
{
    my ($dir, $pklst, $cycle, $data_ref) = @_;
 
    my $debug = 0;

    unless (opendir(DIR, $dir))
    {
	print "Cannot open dir $dir\n";
	return;
    }
    
    my @contents = grep {/^CYCLE/} readdir(DIR);
    close(DIR);

    my (@cycles) = &get_as_cycles($data_ref, $pklst);
    $cycle =~ /(\d+)-/;
    my $tmp_prev = $1 - 1;

    my @sub_cyc = @{$cycles[$tmp_prev]};
    my $prev_cycle = $sub_cyc[$#sub_cyc];
    
    my ($cur_cyc_dir) = grep {/$cycle/} @contents;
    my ($prev_cyc_dir) = grep {/$prev_cycle/} @contents;
    
    #get assOrder from cur_cyc_dir
    my $cur_assOrder = $dir."/".$cur_cyc_dir."/".$pklst.'_assOrder';
    my $prv_assOrder = $dir."/".$prev_cyc_dir."/".$pklst.'_assOrder';

    if ($debug)
    {
	print "cur_assOrder = $cur_assOrder\nprv_assOrder = $prv_assOrder\n";
    }

    return ($cur_assOrder, $prv_assOrder);
   
}

sub get_diff_ass
{
    my ($dir, $pklst, $cycle, $data_ref, $code) = @_;

    my ($file1, $file2) = &get_two_assOrders($dir, $pklst, $cycle, $data_ref);
    if ($code eq 'new')
    {
	#new assignments
	return (&get_assignments($dir, $pklst, $cycle, $data_ref, $file1, $file2));
    }
    else
    {
	#removed assignments
	return (&get_assignments($dir, $pklst, $cycle, $data_ref, $file2, $file1));
    }


}


sub get_assignments
{
    my ($dir, $peaklist, $cycle, $data_ref, $file1, $file2) = @_;

    my @new_ass;
    my $new_ass_count = 0;
    
    my $debug = 0;

    unless (open(CUR, $file1))
    {
	print "Cannot open $file1\n";
	return;
    }
    
    
    my ($line1, $line2, $line3);

    my $count = 0;
    #for each set of 3 lines in file1, scan file2 for those three lines, if they dont exist, store them in an array
    while (chomp($line1 = <CUR>))
    {
	next unless ($line1 =~ /^peak/);

	chomp($line2 = <CUR>);
	next unless ($line2 =~ /^atom/);

	$line2 =~ /atom:\s+(\S+\s+\S+)\s+/;
	my $sub_line2 = $1;

	chomp($line3 = <CUR>);
	next unless ($line3 =~ /^atom/);
	$line3 =~ /atom:\s+(\S+\s+\S+)\s+/;
	my $sub_line3 = $1;

	my ($pk_data_ref) = &parse_assOrder_adnl(0, $file2, $line1);
	my @pk_data = @$pk_data_ref;

	my $i;
	my $exists = 0;

	if (@pk_data)
	{
	    $exists = 0;
	    for ($i = 0; $i<=$#pk_data; $i++)
	    {
		$pk_data[$i]{'atom 1'} =~ /atom:\s+(\S+\s+\S+)\s+/;
		my $prv_1 = $1;
		if ($prv_1 eq $sub_line2)
		{
		    $pk_data[$i]{'atom 2'} =~ /atom:\s+(\S+\s+\S+)\s+/;
		    my $prv_2 = $1;
		    if ($prv_2 eq $sub_line3)
		    {
			$exists = 1;
		    }
		}
	    }
	    unless ($exists)
	    {
		$new_ass[$new_ass_count][0] = $line1;
		$new_ass[$new_ass_count][1] = $line2;
		$new_ass[$new_ass_count][2] = $line3;
		$new_ass_count++;
	    }
	}
	else
	{
	    $new_ass[$new_ass_count][0] = $line1;
	    $new_ass[$new_ass_count][1] = $line2;
	    $new_ass[$new_ass_count][2] = $line3;
	    #$new_ass[$new_ass_count] = "$line1\n$line2\n$line3\n\n";
	    $new_ass_count++;
	}

	$line1 = "";
	$line2 = "";
	$line3 = "";
    }
    
    close(CUR);
    
    return (@new_ass);


}



sub get_as_cycles
{
    my ($data_ref, $pklst) = @_;
    my %data = %$data_ref;

    my (@temp_cycles) = keys %{$data{$pklst}{'NOESY_Assign Process'}};
    my $cycle;
    my @cycles;

    foreach $cycle (@temp_cycles)
    {
	my (@items) = split(/-/, $cycle);
	$cycles[$items[0]][$items[1]] = $cycle;
    }
    
    if ($debug)
    {
	print "get_as_cycles:\n";
	print "peaklist = $pklst\n";
	#print "cycles are @cycles\n";
	print "returning cycles @sorted_cycles\n";
	print "end get_as_cycles\n";
    }


    return (@cycles);
}


return 1;
