my ($can_wid, $can_ht) = (550, 525);
my ($x1, $y1) = (50, 500);
my $x_div = ($can_wid-$x1)/5;
my $y_div = $y1 / 5;



sub show_plot_data
{
    my ($parent, $dist_ref, $mod_dist_ref, $data_ref, $x_lbl, $y_lbl, $max_intensity, $max_dist, $orig_int_ref) = @_;

    my %dist = %$dist_ref;
    my %mod_dist = %$mod_dist_ref;
    my %data = %$data_ref;
    my %orig_int;

    if ($orig_int_ref)
    {
	%orig_int = %$orig_int_ref;
    }

    #max distance
    
    #print "max_intensity is $max_intensity, max_distance is $max_dist\n";

    #create empty canvas to put data in
    my ($win, $canvas, $help_ref, $out_but) = &create_empty_plot($x_lbl, $y_lbl, $max_dist, $max_intensity, $parent);

    #put data into the canvas
    my $lbl;
    my $i;
    foreach $lbl (keys %mod_dist)
    {
	my ($x, $y);
	my $temp = ($mod_dist{$lbl}) * ($can_wid - $x1) / $max_dist;
	$x = $temp + $x1;

	$canvas->createLine($x, 0, $x, $y1+20, -dash=>'.');
	#$canvas->createText($x, $y1+25, -text=>$lbl);
	#print "$lbl, distance is $dist{$lbl}, x is $x\n";
	for ($i = 0; $i<scalar(@{$data{$lbl}}); $i++)
	{
	    $temp = ($data{$lbl}[$i] * $y1) / $max_intensity;
	    $y = $y1 - $temp;

	    #print "Placing point: distance - $dist{$lbl}, intensity - $data{$lbl}[$i], (x,y) = ($x, $y)\n";
	    my ($cur_lbl, $cur_dist, $cur_mod_dist, $cur_int) = ($lbl, ${$dist{$lbl}}, $mod_dist{$lbl}, $data{$lbl}[$i]);
	    my $info;
	    my $cur_orig_int;
	    if ($orig_int_ref)
	    {
		$info = "$cur_lbl : Distance = $cur_dist (x = $cur_mod_dist); Intensity = $cur_int (y = $orig_int{$cur_lbl}[$i])";
	    }
	    else
	    {
		$info = "$cur_lbl : Distance = $cur_dist (x = $cur_mod_dist); Intensity = $cur_int";
	    }
	    
	    #puts the point at the r and intensity specified
	    &draw_point($canvas, $x, $y, $info, $help_ref);
	}
    }

    $out_but->configure(-command=>sub
			{
			    my $file = &SaveFile('Data Points', $win, Cwd::cwd);

			    if ($file)
			    {
				unless (open(FILE, "> $file"))
				{
				    &err_msg("Cannot open file \"$file\" for writing!", $win);
				    return;
				}
				foreach $lbl (keys %mod_dist)
				{
				    for ($i = 0; $i < scalar (@{$data{$lbl}}); $i++)
				    {
					print FILE "$mod_dist{$lbl}\t$data{$lbl}[$i]\n"
				    }
				}
				close(FILE);
				print "Done writing to file $file\n";
			    }
			});

    
    

}


sub create_empty_plot
{
    my ($x_lbl, $y_lbl, $nx_max, $ny_max, $parent) = @_;
    
    print "create_empty_plot: x_lbl = $x_lbl, y_lbl = $y_lbl, nx_max = $nx_max, ny_max = $ny_max\n";
   
    my $win = $parent->Toplevel();
    $win->minsize($can_wid * 1.2, $can_ht * 1.2);
    $win->configure(-title=>"Plot : $x_lbl vs $y_lbl");
    my $canvas = $win->Canvas(-background=>'white')->pack(-fill=>'both', -expand=>1);

    #draw axis
    $canvas->createLine($x1, $y1, $can_wid, $y1, -fill=>'brown');
    $canvas->createLine($x1, $y1, $x1, 0, -fill=>'brown');

    #x axis markings
    #round x_max
    #my $a= $nx_max % 5;
    #my $nx_fin = $nx_max + $a;
    my $nx_div = $nx_max / 5;

    my $x;
    my $x_mark = 0;
    for ($x = $x1; $x <= $can_wid; $x += $x_div)
    {
	&place_mark('x', $x, $y1, $x_mark, $canvas);
	$x_mark += $nx_div;
    }
    
    #y axis markings
    #round y_max
    #$a= $ny_max % 5;
    #my $ny_fin = $ny_max + $a;
    my $ny_div = $ny_max / 5;

    my $y;
    my $y_mark = 0;
    for ($y = $y1; $y >= 0; $y -= $y_div)
    {
	&place_mark('y', $x1, $y, $y_mark, $canvas);
	$y_mark += $ny_div;
    }
    
    #x_lbl
    $canvas->createText($can_wid/2, $y1+25, -text=>$x_lbl, -fill=>'red');
    $canvas->createText(0, $y1/2, -text=>$y_lbl, -fill=>'red');

    my $help = "Click on a point to view its information";
    my $help_lbl = $win->Label(-textvariable=>\$help, -background=>'orange')->pack(-fill=>'x');

    #button to draw_K_roberto
    my $k_frm = $win->Frame(-relief=>'ridge', -borderwidth=>2)->pack(-fill=>'x');
    my ($m_var, $c_var);
    my $k_lbl1 = $k_frm->Label(-text=>"Draw Line = ")->pack(-side=>'left');
    my $m_ent = $k_frm->Entry(-background=>'white', -textvariable=>\$m_var)->pack(-side=>'left');
    my $k_lbl2 = $k_frm->Label(-text=>" X + ")->pack(-side=>'left');
    my $c_ent = $k_frm->Entry(-background=>'white', -textvariable=>\$c_var)->pack(-side=>'left');

    my $k_but = $k_frm->Button(-text=>"Draw Line")->pack(-side=>'left');
    my @colors = (qw/red blue green yellow orange pink violet/);
    my $sel_color = 'red';
    my $k_opts = $k_frm->Optionmenu(-textvariable=>\$sel_color, -options=>\@colors)->pack(-side=>'left');
    my %lines_info;
    my %lines;
    $k_but->configure(-command=>sub
		      {
			  return unless ($m_var);
			  my $info;
			  #convert c to canvas coordinates
			  my $temp = ($c_var * $y1) / $ny_max;
			  my $c_coord = $y1 - $temp;
			  if ($c_var)
			  {
			      #c is intensity
			      $info = "y = $m_var x + $c_var";
			  }
			  else
			  {
			      $info = "y = $m_var x";
			  }

			 
			  $lines{$info} = &draw_line($m_var, $c_var, $c_coord, $canvas, $sel_color, $info, \$help, $nx_max, $ny_max);
			  $lines_info{$info} = 1;
		      });

    my $rem_but = $k_frm->Button(-text=>"Remove Line", -command=>sub
				 {
				     my $new_win = $win->Toplevel();
				     my $lbx = $new_win->Listbox(-selectmode=>'single', -background=>'white')->pack(-fill=>'both', -expand=>1);
				     my $frm = $new_win->Frame()->pack(-fill=>'x');
				     my $but1 = $frm->Button(-text=>"Remove")->pack(-fill=>'x', -side=>'left');

				     my $line;
				     foreach $line (keys %lines_info)
				     {
					 $lbx->insert('end', $line);
				     }
				     
				     $but1->configure(-command=>sub
						     {
							 my $rem_line;
							 if ($rem_line = $lbx->get($lbx->curselection()))
							 {
							     print "removing lines @rem_lines\n";
							     #remove these lines
							     $canvas->delete($lines{$rem_line});
							     delete $lines_info{$rem_line};
							     $lbx->delete($lbx->curselection());
							     #$new_win->destroy();
							     $canvas->update();
							 }
						     });
				     my $but2 = $frm->Button(-text=>'Close', -command=>sub
								 {
								     $new_win->destroy();
								 })->pack(-side=>'left');
				 })->pack(-side=>'left');

    my $out_frm = $win->Frame()->pack(-fill=>'x');
    my $out_but = $out_frm->Button(-text=>"Output data in a text format")->pack(-fill=>'x');
    
    $canvas->update();
    $canvas->configure(-scrollregion=>[$canvas->bbox('all')], -confine=>1);

    return ($win, $canvas, \$help, $out_but);
}

sub draw_point
{
    my ($canvas, $x, $y, $lbl, $help_ref) = @_;

    my $point = $canvas->createText($x, $y, -text=>'X', -fill=>'blue');
    
    $canvas->bind($point, "<Button-1>"=>sub
		  {
		      $$help_ref = $lbl;
		  });
    $canvas->bind($point, '<Enter>'=>sub
		  {
		      $canvas->configure(-cursor=>'crosshair');
		  });
    $canvas->bind($point, '<Leave>'=>sub
		  {
		      $canvas->configure(-cursor=>"top_left_arrow");
		  });
}


sub draw_line
{
    # $m is the slope, $c is the y_intercept of the line, $c_coord is the actual y_ coordinate in the canvas (was calculated before)
    my ($m, $c, $c_coord, $canvas, $color, $info, $help_ref, $x_max, $y_max) = @_;

    #line goes from (ax1,ay1) to (ax2,ay2)
    my ($ax1,$ay1) = ($x1, $c_coord);
    my ($ax2, $ay2);

    if ($m == 0)
    {
	($ax2, $ay2) = ($can_wid, $y1);
    }
    else 
    {
	my ($temp_x, $temp_y) = ($x_max, 0);
	$temp_y = $m * $temp_x + $c;
	if ($temp_y <= $y_max)
	{
	    ($ax2, $ay2) = ($temp_x, $temp_y);
	}
	else
	{
	    ($temp_x, $temp_y) = (0, $y_max);
	    $temp_x = ($temp_y - $c)/ $m;
	    ($ax2, $ay2) = ($temp_x, $temp_y);
	}

	#my $temp_x = ($y_max - $c)/$m;
	#convert to coordinates
	$ax2 = ($ax2 * ($can_wid - $x1)) / $x_max;
	$ax2 = $ax2 + $x1;
	
	$ay2 = ($ay2 * $y1) / $y_max;
	$ay2 = $y1 - $ay2;
    }
    
    my $line = $canvas->createLine($ax1, $ay1, $ax2, $ay2, -fill=>$color, -width=>2);
    $canvas->bind($line, '<Button-1>'=>sub
		  {
		      $$help_ref = $info;
		  });
    $canvas->bind($line, '<Enter>'=>sub
		  {
		      #$canvas->itemconfigure($point, -text=>'@', -fill=>'blue');
		      $canvas->configure(-cursor=>'crosshair');
		  });
    $canvas->bind($line, '<Leave>'=>sub
		  {
		      #$canvas->itemconfigure($point, -text=>'x', -fill=>$color);
		      $canvas->configure(-cursor=>'top_left_arrow');
		  });

    return ($line);
}


sub place_mark
{
    my ($axis, $x, $y, $label, $canvas) = @_;

    if ($axis eq 'x')
    {
	$canvas->createLine($x, $y-5, $x, $y+5);
	$canvas->createText($x, $y+10, -text=>$label);
    }
    else
    {
	$canvas->createLine($x - 5, $y, $x+5, $y);
	$canvas->createText($x-10, $y, -text=>$label, -anchor=>'e');
    }
}

return 1;
