sub get_sec_str_k
{
    my ($as_dir, $parent) = @_;

    my ($sec_file) = &get_key_file($as_dir, $parent, 'sec');
    my $sec_data_ref = &parse_sec($sec_file, $parent);
    my %sec_data = %$sec_data_ref;

    #$sec_str{'Anti'}, $sec_str{'Para'}, $sec_str{'Helix'}
    my %sec_str;
    
    my $i;
    for ($i = 0; $i<scalar(@{$sec_data{'Final'}}); $i++)
    {
	my $line = $sec_data{'Final'}[$i];
	if ($line =~ /helix/i)
	{
	    $line =~ /\s(\d+\-\d+)$/;
	    $sec_str{'Helix'}{$1} = 1;
	}
    }

    for ($i = 0; $i<scalar(@{$sec_data{'Antiparallel'}}); $i++)
    {
	my $lbl = $sec_data{'Antiparallel'}[$i];
	my ($res1, $res2) = &get_res($lbl);
	my $sheet = &get_sheet($sec_data_ref, $res1, 'Final');
	$sec_str{'Anti'}{$sheet} = 1;
	$sheet = &get_sheet($sec_data_ref, $res2, 'Final');
	$sec_str{'Anti'}{$sheet} = 1;
    }

    for ($i = 0; $i<scalar(@{$sec_data{'Parallel'}}); $i++)
    {
	my $lbl = $sec_data{'Parallel'}[$i];
	my ($res1, $res2) = &get_res($lbl);
	my $sheet = &get_sheet($sec_data_ref, $res1, 'Final');
	$sec_str{'Para'}{$sheet} = 1;
	$sheet = &get_sheet($sec_data_ref, $res2, 'Final');
	$sec_str{'Para'}{$sheet} = 1;
    }
    
    if(0){
    print "get_sec_str: \n";
    my $temp;
    foreach $i (keys %sec_str)
    {
	print "$i - ";
	foreach $temp (keys %{$sec_str{$i}})
	{
	    print "$temp ";
	}
	print "\n";
    }
}

    return (\%sec_str, $sec_data_ref);
    
}


return 1;
