my $scale = 1.2;

my $width = $scale * 45;
my $height = $scale * 65;

my $x_div = $width + $width/2;
my $y_div = $height + $height/2;;

sub place_anti_sheets
{
    my ($parent_canvas, $x, $y, $sheets_info_ref, $data_ref, $help_ref) = @_;
    #print "place_anti_sheets\n";

    #create child canvas
    my $canvas = $parent_canvas->Canvas(-background=>'white');
    
    my @pivots;
    
    my ($x1, $y1) = (100, 0);
    
    my ($i, $j);
    my %sheets_info = %$sheets_info_ref;
    my %rem_sheets = %sheets_info;
    
    
    while (%rem_sheets)
    {
	#fill @sheets in right order
	my @temp_sheets = sort {$a <=> $b} keys %rem_sheets;
	#print "***a. remaining sheets are @temp_sheets\n";
	
	my $sheet_num = 0;
	my $inter_num = 0;
	my $left_to_right = 1;
	my $up = 0;
	my $register;
	my @sheets;

	for ($i = 0; $i<=$#temp_sheets; $i++)
	{
	    #print "b. temp_sheets[$i] = $temp_sheets[$i]\n";
	    next if ($sheets_info{$temp_sheets[$i]}[1]);
	    
	    $sheets[0] = $temp_sheets[$i];
	    #print "c. sheets[0] = $sheets[0]\n";
	    last;
	}
	
	#print "d. first sheet: $sheets[$sheet_num], interaction: $sheets_info{$sheets[$sheet_num]}[0]\n";
	($up) = &get_first_up($data_ref, $sheets_info{$sheets[$sheet_num]}[0], $sheets[0], 0, $left_to_right, 0, 'anti');
	
	($x1, $y1) = (150, $y1 + $y_div);
	my %sub_coords;
	my %res;
	my %temp_res;

	while (($sheet_num <= $#temp_sheets))
	{
	    #residues in interaction
	    $inter_num = 0;
	    $register = $sheets_info{$sheets[$sheet_num]}[$inter_num];
	    my ($inter_res1, $inter_res2) = &get_res($sheets_info{$sheets[$sheet_num]}[$inter_num]);
	    
	    if ($sheet_num)
	    {
		($res{'res1'}, $res{'res2'}) = ($inter_res1, $inter_res2);
	    }
	    
	    if ($sheets_info{$sheets[$sheet_num]}[$inter_num+1])
	    {
		if ((&get_sheet($data_ref, $inter_res1) eq $sheets[$sheet_num-1]) or (&get_sheet($data_ref, $inter_res2) eq $sheets[$sheet_num-1]))
		{
		    $inter_num = 1;
		    $register = $sheets_info{$sheets[$sheet_num]}[$inter_num];
		    ($inter_res1, $inter_res2) = &get_res($sheets_info{$sheets[$sheet_num]}[$inter_num]);
		   
		}
		else
		{
		    ($res{'res1'}, $res{'res2'}) = &get_res($sheets_info{$sheets[$sheet_num]}[$inter_num+1]);
		}
	    }
	    
	    if (&get_sheet($data_ref, $inter_res1) eq $sheets[$sheet_num])
	    {
		$pivots[$sheet_num] = $inter_res1;
		$pivots[$sheet_num+1] = $inter_res2;
	    }
	    else
	    {
		$pivots[$sheet_num] = $inter_res2;
		$pivots[$sheet_num+1] = $inter_res1;
	    }

	    my $next_sheet = $sheet_num+1;

	    #print "1: register: $register, pivots of $sheet_num - $pivots[$sheet_num], $next_sheet - $pivots[$next_sheet]\n";
	    
	    #draw sheet
	    my ($res_a, $res_b) = &get_res($sheets[$sheet_num]);
	    my ($start_res, $end_res);
	    if ($left_to_right)
	    {
		($start_res, $end_res) = ($res_a, $res_b);
	    }
	    else
	    {
		($start_res, $end_res) = ($res_b, $res_a);
	    }
	    
	    $res{$sheets[$sheet_num]}{'left_to_right'} = $left_to_right;
	    $res{$sheets[$sheet_num]}{'up'} = $up;
	    $res{$sheets[$sheet_num]}{'start'} = $start_res;
	    $res{$sheets[$sheet_num]}{'end'} = $end_res;
	    $sub_coords{$sheets[$sheet_num]}{'x'} = $x1 + $x_div;
	    $sub_coords{$sheets[$sheet_num]}{'y'} = $y1;
	    
	    print "sub_coords: for $sheets[$sheet_num] are ($sub_coords{$sheets[$sheet_num]}{'x'},$sub_coords{$sheets[$sheet_num]}{'y'})\n";

	    #print "2. creating pepetide $sheet_num - $sheets[$sheet_num], register $register, left_to_right = $left_to_right, up = $up\n";
	    &create_peptide($canvas, $start_res, $end_res, $x1, $y1, $left_to_right, $up);
	    my @temp_sheet = @{$rem_sheets{$sheets[$sheet_num]}};
	    delete $rem_sheets{$sheets[$sheet_num]};
	    my @temps = sort {$a <=> $b} keys %rem_sheets;
	    #print "3. deleting sheet $sheets[$sheet_num], remaining @temps\n";

	    #put evidences
	    
	    if ($sheet_num)
	    {
		#print "putting evidences: sheets[$sheet_num] = $sheets[$sheet_num]\n";
		my $var_res_ref = &put_evidences($data_ref, \%res, $canvas, \%sub_coords, $help_ref, 'anti');
		my %var_res = %$var_res_ref;
		my $temp_sheet;
		foreach $temp_sheet (keys %var_res)
		{
		    my $key;
		    foreach $key ('start', 'end', 'up')
		    {
			$temp_res{$temp_sheet}{$key} = $var_res{$temp_sheet}{$key};
		    }
		}
	    }
	    
	    last unless (%rem_sheets);
	    
	    #get_coords for next sheet
	    ($x1, $y1) = &get_coords_of_res($x1, $y1, $start_res, $pivots[$sheet_num], $left_to_right);
	    ($x1, $y1) = &get_coords_next_sheet($x1, $y1);
	    
	    $left_to_right = !$left_to_right;
	    my $prev_start = $start_res;
	    #my $prev_up = $up;

	    $sheet_num++;
	    $sheets[$sheet_num] = &get_sheet($data_ref, $pivots[$sheet_num]);
	    
	    ($res_a, $res_b) = &get_res($sheets[$sheet_num]);
	    if ($left_to_right)
	    {
		($start_res, $end_res) = ($res_a, $res_b);
	    }
	    else
	    {
		($start_res, $end_res) = ($res_b, $res_a);
	    }
	    
	    my $want_up = &get_first_up($data_ref, $register, $sheets[$sheet_num], 1, $left_to_right, 0, 'anti');
	    my $obs_up = &change_anti_up($up, $prev_start, $pivots[$sheet_num-1], $start_res, $pivots[$sheet_num]);
	    #print "5. register $register: want_up = $want_up, obs_up = $obs_up\n";

	    ($x1, $y1) = &get_coords_of_start($x1, $y1, $start_res, $pivots[$sheet_num]);
	    
	    my $temp = &get_sheet($data_ref, $pivots[$sheet_num]);

	    if ($sheet_num and (($want_up+1) != ($obs_up+1)))
	    {
		#print "6. want_up and obs_up not the same\n";
		if ($sheets_info{$sheets[$sheet_num-1]}[1])
		{
		    #print "6. adding back ".$sheets[$sheet_num-1]." and creating new sheet\n";
		    $rem_sheets{$sheets[$sheet_num-1]}[$inter_num] = $temp_sheet[$inter_num];
		}
		$sheets[$sheet_num] = '';
		$sheet_num = $#temp_sheets+1;
		
		last;
	    }
	    else
	    {
		unless ($rem_sheets{$temp})
		{
		    #print "6. rem_sheets{$temp} with pivot $pivots[$sheet_num] doesnt exist, starting new sheeet\n";
		    $sheets[$sheet_num] = '';
		    $sheet_num = $#temp_sheets+1;
		    last;
		}
		$up = $obs_up; 
		
	    }
	    
	}
	&place_anti_bg_interactions($canvas, \@sheets, $data_ref, \%temp_res, \%sheets_info, \%res, \%sub_coords);
	#print "*****\n";
    }
    
    $canvas->update;
    my ($a, $b, $c, $d) = $canvas->bbox('all');
    my $c_wid = abs($c - $a) * 1.1;
    my $c_ht = abs($d - $b) * 1.1;
    $canvas->configure(-width =>$c_wid, height=>$c_ht);
    $canvas->configure(-scrollregion=>[$canvas->bbox('all')], -confine=>1);
    $parent_canvas->createWindow($x, $y, -window=>$canvas, -width=>$c_wid, -height=>$c_ht, -anchor=>'nw');
    $canvas->update();
    $y = $y + $c_ht;
    return ($x, $y);
}


sub place_para_sheets
{
    my ($parent_canvas, $x, $y, $sheets_info_ref, $data_ref, $help_ref) = @_;
    #print "\nplace_para_sheets\n";

    #create child canvas
    my $para_canvas = $parent_canvas->Canvas(-background=>'white');
    my @pivots;
    my @sheets;
    my ($x1, $y1) = (100, 0);
    
    my ($i, $j);
    my %sheets_info = %$sheets_info_ref;
    my %rem_sheets = %sheets_info;
    my %sub_coords;
    my %res;

    while (%rem_sheets)
    {
	#fill @sheets in right order
	my @temp_sheets = sort {$a <=> $b} keys %rem_sheets;
	#print "***a. rem sheets are @temp_sheets\n";
	my $sheet_num = 0;
	my $inter_num = 0;
	my $left_to_right = 1;
	my $up = 0;
	my $register;
	my %temp_res;
	
	for ($i = 0; $i<=$#temp_sheets; $i++)
	{
	    next if ($sheets_info{$temp_sheets[$i]}[1]);
	    
	    $sheets[0] = $temp_sheets[$i];
	    last;
	}
	
	$up = &get_first_up($data_ref, $sheets_info{$sheets[$sheet_num]}[0], $sheets[0], 0, 1, 0, 'para');
	#print "b. first sheet - $sheets[$sheet_num], up is $up\n";
	
	($x1, $y1) = (150, $y1 + $y_div);
	
	while ($sheet_num <= $#temp_sheets)
	{
	    #residues in interaction
	    $register = $sheets_info{$sheets[$sheet_num]}[$inter_num];
	    $inter_num = 0;
	    my ($inter_res1, $inter_res2) = &get_res($register);
	    
	    if ($sheet_num)
	    {
		($res{'res1'}, $res{'res2'}) = ($inter_res1, $inter_res2);
	    }

	    if ($sheets_info{$sheets[$sheet_num]}[$inter_num+1])
	    {
		if ((&get_sheet($data_ref, $inter_res1 eq $sheets[$sheet_num-1])) or (&get_sheet($data_ref, $inter_res2) eq $sheets[$sheet_num-1]))
		{
		    $inter_num = 1;
		    $register = $sheets_info{$sheets[$sheet_num]}[$inter_num];
		    ($inter_res1, $inter_res2) = &get_res($register);
		}
		else
		{
		    ($res{'res1'}, $res{'res2'}) = &get_res($sheets_info{$sheets[$sheet_num]}[$inter_num+1]);
		}
	    }
	    
	    if (&get_sheet($data_ref, $inter_res1) eq $sheets[$sheet_num])
	    {
		$pivots[$sheet_num] = $inter_res1;
		$pivots[$sheet_num+1] = $inter_res2;
	    }
	    else
	    {
		$pivots[$sheet_num] = $inter_res2;
		$pivots[$sheet_num+1] = $inter_res1;
	    }
	    my $next_sheet = $sheet_num+1;
	    #print "1. register - $register, sheet - $sheets[$sheet_num], pivots - $sheet_num ($pivots[$sheet_num]), $next_sheet ($pivots[$next_sheet])\n";

	    #draw sheet
	    my ($start_res, $end_res) = &get_res($sheets[$sheet_num]);
	    my $prev_start = $start_res;

	    $res{$sheets[$sheet_num]}{'left_to_right'} = $left_to_right;
	    $res{$sheets[$sheet_num]}{'up'} = $up;
	    $res{$sheets[$sheet_num]}{'start'} = $start_res;
	    $res{$sheets[$sheet_num]}{'end'} = $end_res;
	    $sub_coords{$sheets[$sheet_num]}{'x'} = $x1 + $x_div;
	    $sub_coords{$sheets[$sheet_num]}{'y'} = $y1;

	    &create_peptide($para_canvas, $start_res, $end_res, $x1, $y1, 1, $up);
	    my @temp_sheet = @{$rem_sheets{$sheets[$sheet_num]}};
	    #print "2. created peptide $sheets[$sheet_num], removed from rem_sheets\n";
	    delete $rem_sheets{$sheets[$sheet_num]};
	    
	    if ($sheet_num)
	    {
		#print "2. putting evidences: sheets[$sheet_num] = $sheets[$sheet_num], sheet_id is $sheet_id\n";
		my $var_res_ref = &put_evidences($data_ref, \%res, $para_canvas, \%sub_coords, $help_ref, 'para');
		my %var_res = %$var_res_ref;
		my $temp_sheet;
		foreach $temp_sheet (keys %var_res)
		{
		    my $key;
		    foreach $key ('start', 'end', 'up')
		    {
			$temp_res{$temp_sheet}{$key} = $var_res{$temp_sheet}{$key};
		    }
		}
	    }
	    
	    last unless (%rem_sheets);

	    #get_coords for next sheet
	    ($x1, $y1) = &get_coords_of_res($x1, $y1, $start_res, $pivots[$sheet_num], 1);
	    ($x1, $y1) = &get_coords_next_sheet($x1, $y1);

	    $sheet_num++;
	    $sheets[$sheet_num] = &get_sheet($data_ref, $pivots[$sheet_num]);
	    
	    ($start_res, $end_res) = &get_res($sheets[$sheet_num]);
	    my $want_up = &get_first_up($data_ref, $register, $sheets[$sheet_num], 1, 1, 0, 'para');
	    my $obs_up = &change_para_up($up, $prev_start, $pivots[$sheet_num-1],$start_res, $pivots[$sheet_num]);
	    
	    ($x1, $y1) = &get_coords_of_start($x1, $y1, $start_res, $pivots[$sheet_num]);

	    #print "3. exp_up is $exp_up, and obs_up is $obs_up for sheet $sheets[$sheet_num]\n";
	    my $temp = &get_sheet($data_ref, $pivots[$sheet_num]);

	    if ($sheet_num and (($want_up+1) != ($obs_up+1)))
	    {
		if ($sheets_info{$sheets[$sheet_num-1]}[1])
		{
		    #print "4. adding back ".$sheets[$sheet_num-1]." and creating new sheet\n";
		    $rem_sheets{$sheets[$sheet_num-1]}[$inter_num] = $temp_sheet[$inter_num];
		}
		$sheets[$sheet_num] = '';
		$sheet_num = $#temp_sheets+1;
		last;

		#print "4. exp_up and $obs_up not the same, adding back ".$sheets[$sheet_num-1]." and creating new sheet\n";
		#$rem_sheets{$sheets[$sheet_num-1]}[$inter_num] = $temp_sheet[$inter_num];
		#$sheet_num = $#temp_sheets+1;
		#last;
	    }
	    else
	    {
		unless ($rem_sheets{$temp})
		{
		    #print "4. rem_sheets{$temp} with pivot $pivots[$sheet_num] doesnt exist, starting new sheeet\n";
		    $sheets[$sheet_num] = '';
		    $sheet_num = $#temp_sheets+1;
		    last;
		}
		$up = $obs_up;
	    }
	}
	&place_para_bg_interactions($para_canvas, \@sheets, $data_ref, \%temp_res, \%sheets_info, \%res, \%sub_coords);
	#print "*****\n";
    }
    
    
    my ($a, $b, $c, $d) = $para_canvas->bbox('all');
    if ($a and $b and $c and $d)
    {
	$para_canvas->configure(-scrollregion=>[$a,$b,$c,$d], -confine=>1);
	my $c_wid = abs($c - $a);
	my $c_ht = abs($d - $b);
	$para_canvas->configure(-width =>$c_wid, height=>$c_ht);
	$para_canvas->update();
	$parent_canvas->createWindow($x, $y, -window=>$para_canvas, -width=>$c_wid, -height=>$c_ht, -anchor=>'nw');
	$y = $y + $c_ht;
	$para_canvas->update;
    }
    return ($x, $y);
}




sub put_evidences
{
    my ($data_ref, $res_ref, $canvas, $coords_ref, $help_ref, $key) = @_;
        
    my %data = %$data_ref;
    my %coords = %$coords_ref;
    my %res = %$res_ref;
    my %temp_res;
    my $interaction;
    my $strands;
    my $my_reg = "$res{'res1'}-$res{'res2'}";
    my %res_sheets;
    my ($up1_set, $up2_set);
    
    print "^^^put evidences\n";
    my ($sheet);
    foreach $sheet (keys %res)
    {
	my $key;
	foreach $key (qw/left_to_right up start end/)
	{
	    $temp_res{$sheet}{$key} = $res{$sheet}{$key};
	    #print "temp_res{$sheet}{$key} = $temp_res{$sheet}{$key}\n";
	}
    }

    foreach $strands (keys %{$data{'Evidences'}})
    {
	foreach $register (keys %{$data{'Evidences'}{$strands}})
	{
	    if (($register =~ /$my_reg/) and ($register =~ /^\s*$key/))
	    {
		($up1_set, $up2_set) = (0, 0);
		#print "put_evidences: register = $register\n";
		foreach $interaction (keys %{$data{'Evidences'}{$strands}{$register}})
		{
		    $interaction =~ /(\d+)(\w+)\-(\d+)(\w+)/;
		    #print "interaction is $interaction\n";
		    my ($res1, $atm1, $res2, $atm2) = ($1, $2, $3, $4);
		    my ($x1, $y1, $x2, $y2);
		    
		    my ($sheet1, $sheet2) = (&get_sheet($data_ref, $res1), &get_sheet($data_ref, $res2));
		    
		    #print "interaction: $interaction\n";
		    
		    unless ($sheet1)
		    {
			#res1 does not belong to a sheet, find which sheet to place res1 in 
			#print "no sheet1 for $res1\n";

			my $temp_res1 = $res1 + 1;
			my $temp_sheet1 = &get_sheet($data_ref, $temp_res1);
			
			unless ($temp_sheet1)
			{
			    $temp_res1 = $res1 - 1;
			    $temp_sheet1 = &get_sheet($data_ref, $temp_res1);
			}
			next unless ($temp_sheet1);
			
			if ($res{$temp_sheet1}{'left_to_right'})
			{
			    if ($res1 < $res{$temp_sheet1}{'start'})
			    {
				#place res1 at start of sheet1
				my ($sx, $sy) = ($coords{$temp_sheet1}{'x'}, $coords{$temp_sheet1}{'y'});
				($x1, $y1) = ($sx-$x_div, $sy);
				my $up = !$res{$temp_sheet1}{'up'};
				&place_residue($x1, $y1, $canvas, $res1, $up);
				&make_peptide_bond($x1, $y1, $sx, $sy, $canvas, !$up);
				$temp_res{$temp_sheet1}{'start'} = $res1;
				$temp_res{$temp_sheet1}{'up'} = !$res{$temp_sheet1}{'up'};
				#$up1_set = 1;
				#print "a\n";
			    }
			    else
			    {
				#place res1 at end of sheet1
				my ($ex, $ey) = &get_coords_of_res($coords{$temp_sheet1}{'x'}, $coords{$temp_sheet1}{'y'}, $res{$temp_sheet1}{'start'}, $res{$temp_sheet1}{'end'}, $res{$temp_sheet1}{'left_to_right'});
				($x1, $y1) = ($ex+$x_div, $ey);
				my $up = &get_sheet_up($res{$temp_sheet1}{'up'}, $res{$temp_sheet1}{'start'}, $res{$temp_sheet1}{'end'});
				$up = !$up;
				&place_residue($x1, $y1, $canvas, $res1, $up);
				&make_peptide_bond($ex, $ey, $x1, $y1, $canvas, $up);
				$temp_res{$temp_sheet1}{'end'} = $res1;
				#$temp_res{$temp_sheet1}{'up'} = $res{$temp_sheet1}{'up'};
				#print "b\n";
				#$up1_set = 1;
			    }
			}
			else
			{
			    if ($res1 > $res{$temp_sheet1}{'start'})
			    {
				#place at start of sheet1
				my ($sx, $sy) = ($coords{$temp_sheet1}{'x'}, $coords{$temp_sheet1}{'y'});
				($x1, $y1) = ($sx - $x_div, $sy);
				my $up = !$res{$temp_sheet1}{'up'};
				&place_inverse_residue($x1, $y1, $canvas, $res1, $up);
				&make_peptide_bond($x1, $y1, $sx, $sy, $canvas, !$up);
				$temp_res{$temp_sheet1}{'start'} = $res1;
				$temp_res{$temp_sheet1}{'up'} = !$res{$temp_sheet1}{'up'};
				#$up1_set = 1;
				#print "c\n";
			    }
			    else
			    {
				#place at end of sheet1
				my ($ex, $ey) = &get_coords_of_res($coords{$temp_sheet1}{'x'}, $coords{$temp_sheet1}{'y'}, $res{$temp_sheet1}{'start'}, $res{$temp_sheet1}{'end'}, $res{$temp_sheet1}{'left_to_right'});
				($x1, $y1) = ($ex+$x_div, $ey);
				
				my $up = &get_sheet_up($res{$temp_sheet1}{'up'}, $res{$temp_sheet1}{'start'}, $res{$temp_sheet1}{'end'});
				$up = !$up;
				&place_inverse_residue($x1, $y1, $canvas, $res1, $up);
				&make_peptide_bond($ex, $ey, $x1, $y1, $canvas, $up);
				$temp_res{$temp_sheet1}{'end'} = $res1;
				#$temp_res{$temp_sheet1}{'up'} = $res{$temp_sheet1}{'up'};
				#$up1_set = 1;
				#print "d\n";
			    }
			}
			$sheet1 = $temp_sheet1;
			#print "res1 $res1 added to $sheet1, and temp_up as $temp_res{$sheet1}{'up'}, left_to_right as $res{$sheet1}{'left_to_right'}, start = $temp_res{$sheet1}{'start'}, end = $temp_res{$sheet1}{'end'}\n";
		    }

		    unless ($sheet2)
		    {
			#print "no sheet2 for $res2\n";
			my $temp_res2 = $res2 + 1;
			my $temp_sheet2 = &get_sheet($data_ref, $temp_res2);
			
			unless (($temp_sheet2) and ($coords{$temp_sheet2}{'x'}) and ($coords{$temp_sheet2}{'y'}))
			{
			    $temp_res2 = $res2 - 1;
			    $temp_sheet2 = &get_sheet($data_ref, $temp_res2);
			}
			
			next unless (($temp_sheet2) and ($coords{$temp_sheet2}{'x'}) and ($coords{$temp_sheet2}{'y'}));
			
			if ($res{$temp_sheet2}{'left_to_right'})
			{
			    if ($res2 < $res{$temp_sheet2}{'start'})
			    {
				my ($sx, $sy) = ($coords{$temp_sheet2}{'x'}, $coords{$temp_sheet2}{'y'});
				($x2, $y2) = ($sx-$x_div, $sy);
				my $up = !$res{$temp_sheet2}{'up'};
				&place_residue($x2, $y2, $canvas, $res2, $up);
				&make_peptide_bond($x2, $y2, $sx, $sy, $canvas, !$up);
				$temp_res{$temp_sheet2}{'start'} = $res2;
				$temp_res{$temp_sheet2}{'up'} = !$res{$temp_sheet2}{'up'};
				#$up2_set = 1;
				#print "a\n";
			       
			    }
			    else
			    {
				my ($ex, $ey) = &get_coords_of_res($coords{$temp_sheet2}{'x'}, $coords{$temp_sheet2}{'y'}, $res{$temp_sheet2}{'start'}, $res{$temp_sheet2}{'end'}, $res{$temp_sheet2}{'left_to_right'});
				($x2, $y2) = ($ex+$x_div, $ey);
				my $up = &get_sheet_up($res{$temp_sheet2}{'up'}, $res{$temp_sheet2}{'start'}, $res{$temp_sheet2}{'end'});
				$up = !$up;
				&place_residue($x2, $y2, $canvas, $res2, $up);
				&make_peptide_bond($ex, $ey, $x2, $y2, $canvas, $up);
				$temp_res{$temp_sheet2}{'end'} = $res2;
				
				#$up2_set = 1;
				#print "b\n";
			    }
			}
			else
			{
			    if ($res2 > $res{$temp_sheet2}{'start'})
			    {
				print "placing inverse residue $res2 at ($x2,$y2) with coords of $temp_sheet2 at ($coords{$temp_sheet2}{'x'},$coords{$temp_sheet2}{'y'})\n";
				my ($sx, $sy) = ($coords{$temp_sheet2}{'x'}, $coords{$temp_sheet2}{'y'});
				($x2, $y2) = ($sx-$x_div, $sy);
				my $up = !$res{$temp_sheet2}{'up'};
				
				&place_inverse_residue($x2, $y2, $canvas, $res2, $up);
				&make_peptide_bond($x2, $y2, $sx, $sy, $canvas, !$up);
				$temp_res{$temp_sheet2}{'start'} = $res2;
				$temp_res{$temp_sheet2}{'up'} = !$res{$temp_sheet2}{'up'};
				#$up2_set = 1;
				#print "c\n";
			    }
			    else
			    {
				my ($ex, $ey) = &get_coords_of_res($coords{$temp_sheet2}{'x'}, $coords{$temp_sheet2}{'y'}, $res{$temp_sheet2}{'start'}, $res{$temp_sheet2}{'end'}, $res{$temp_sheet2}{'left_to_right'});
				($x2, $y2) = ($ex+$x_div, $ey);
				my $up = &get_sheet_up($res{$temp_sheet2}{'up'}, $res{$temp_sheet2}{'start'}, $res{$temp_sheet2}{'end'});
				$up = !$up;
				&place_inverse_residue($x2, $y2, $canvas, $res2, $up);
				&make_peptide_bond($ex, $ey, $x2, $y2, $canvas, $up);
				$temp_res{$temp_sheet2}{'end'} = $res2;
				#$temp_res{$sheet2}{'up'} = $res{$temp_sheet2}{'up'} unless ($up2_set);
				#$up2_set = 1;
				#print "d\n";
			    }
			}
			$sheet2 = $temp_sheet2;
			#print "res2 $res2 added to $sheet2 with temp_up as $temp_res{$sheet2}{'up'}, left_to_right as $res{$sheet2}{'left_to_right'}, start - $temp_res{$sheet2}{'start'}, end - $temp_res{$sheet2}{'end'}\n";
		    }

		    
		    #print "coords: ($x1, $y1), ($x2, $y2)\n";
		    
		    #get coords of residues $res1 and $res2
		    unless ($x1 and $y1)
		    {
			($x1, $y1) = &get_coords_of_res($coords{$sheet1}{'x'}, $coords{$sheet1}{'y'}, $res{$sheet1}{'start'}, $res1, $res{$sheet1}{'left_to_right'});
		    }

		    unless ($x2, $y2)
		    {
			($x2, $y2) = &get_coords_of_res($coords{$sheet2}{'x'}, $coords{$sheet2}{'y'}, $res{$sheet2}{'start'}, $res2, $res{$sheet2}{'left_to_right'});
		    }
		    
		    #print "coords of sheet: $sheet1: x = $coords{$sheet1}{'x'}, y = $coords{$sheet1}{'y'}, $sheet2: x = $coords{$sheet2}{'x'}, y = $coords{$sheet2}{'y'}\n";
		    #print "coords of residues: $res1 in $sheet1 = ($x1, $y1), $res2 in $sheet2 = ($x2, $y2)\n";
		    
		    next unless ($x1 and $x2 and $y1 and $y2);

		    my $up1 = &get_sheet_up($res{$sheet1}{'up'}, $res{$sheet1}{'start'}, $res1);
		    my $up2 = &get_sheet_up($res{$sheet2}{'up'}, $res{$sheet2}{'start'}, $res2);
		    
		    my $elem_coords_ref1 = &get_coords_elements($x1, $y1, $up1, $res{$sheet1}{'left_to_right'});
		    my %elem_coords1 = %$elem_coords_ref1;
		    my $elem_coords_ref2 = &get_coords_elements($x2, $y2, $up2, $res{$sheet2}{'left_to_right'});
		    my %elem_coords2 = %$elem_coords_ref2;
		    
		    ($x1, $y1, $x2, $y2) = ($elem_coords1{$atm1}{'x'}, $elem_coords1{$atm1}{'y'}, $elem_coords2{$atm2}{'x'}, $elem_coords2{$atm2}{'y'});
		    
		    next unless ($x1 and $x2 and $y1 and $y2);
		    
		    if ($data{'Evidences'}{$strands}{$register}{$interaction}[1])
		    {
			#two peaks
			my $arrow;
			if ($y1 < $y2)
			{
			    $arrow = &place_arrow($canvas, $x1, $y1, $x2, $y2, 'double');
			}
			else
			{
			    $arrow = &place_arrow($canvas, $x2, $y2, $x1, $y1, 'double');
			}
			my $cur_int = $interaction;
			my $cur_str = $strands;
			my $cur_reg = $register;
			$canvas->bind($arrow, '<Button-1>'=>sub
				      {
					  $$help_ref = "Interaction: $cur_int\n$cur_reg\npeak 1: $data{'Evidences'}{$cur_str}{$cur_reg}{$cur_int}[0]\npeak 2: $data{'Evidences'}{$cur_str}{$cur_reg}{$cur_int}[1]";
				      });
		    }
		    else
		    {
			my $arrow;
			if ($y1 < $y2)
			{
			    $arrow = &place_arrow($canvas, $x1, $y1, $x2, $y2, 'single');
			}
			else
			{
			    $arrow = &place_arrow($canvas, $x2, $y2, $x1, $y1, 'single');
			}
			my $cur_int = $interaction;
			my $cur_str = $strands;
			my $cur_reg = $register;
			$canvas->bind($arrow, '<Button-1>'=>sub
				      {
					  $$help_ref = "Interaction: $cur_int\n$cur_reg\npeak: $data{'Evidences'}{$cur_str}{$cur_reg}{$cur_int}[0]";
				      });
			
		    }
		}
	    }
	}
    }

    #print "put_evidences: temp_sheets\n";
    return (\%temp_res);
}


sub place_anti_bg_interactions
{
    
    my ($canvas, $sheets_ref, $data_ref, $temp_res_ref, $sheets_info_ref, $res_ref, $coords_ref) = @_;

    my $sheet_num = 0;
    my @sheets = @$sheets_ref;
    my %temp_res = %$temp_res_ref;
    my %sheets_info = %$sheets_info_ref;
    my %res = %$res_ref;
    my %coords = %$coords_ref;

    my ($start_res, $end_res);
    my ($sheet_above, $sheet_below, $res_above, $res_below, $reg_above, $reg_below, $res_up, $next_below);

    if ($#sheets > 1)
    {
	my $temp_num = $#sheets-2;
	if ($sheets[$#sheets] == $sheets[$temp_num])
	{
	    $sheets[$#sheets] = '';
	}
    }
    
    #print "anti_bg_interactions: number of sheets = $#sheets, sheets are @sheets\n";
    #for each sheet
    for ($sheet_num = 0; $sheet_num < $#sheets; $sheet_num++)
    {
	($sheet_above, $sheet_below) = ($sheets[$sheet_num], $sheets[$sheet_num+1]);
	
	#print "1. sheet_num = $sheet_num, sheet_above - $sheet_above, sheet_below - $sheet_below\n";
	last unless ($sheet_below);

	#get start and end res
	if ($res{$sheet_above}{'left_to_right'})
	{
	    ($start_res, $end_res) = ($temp_res{$sheet_above}{'start'}, $temp_res{$sheet_above}{'end'});
	}
	else
	{
	    ($end_res, $start_res) = ($temp_res{$sheet_above}{'start'}, $temp_res{$sheet_above}{'end'});
	}
	
	
	#print "2. start_res: $start_res, end_res: $end_res for $sheet_above\n";

	#get reg_above and reg_below
	my ($temp1, $temp2) = &get_res($sheets_info{$sheet_above}[0]);

	if (($sheet_above eq &get_sheet($data_ref, $temp1)) and ($sheet_below eq &get_sheet($data_ref, $temp2)))
	{
	    ($reg_above, $reg_below) = ($temp1, $temp2);
	}
	elsif (($sheet_above eq &get_sheet($data_ref, $temp2)) and ($sheet_below eq &get_sheet($data_ref, $temp1)))
	{
	    ($reg_above, $reg_below) = ($temp2, $temp1);
	}
	elsif ($sheets_info{$sheet_above}[1])
	{
	    ($temp1, $temp2) = &get_res($sheets_info{$sheet_above}[1]);

	    if (($sheet_above eq &get_sheet($data_ref, $temp1)) and ($sheet_below eq &get_sheet($data_ref, $temp2)))
	    {
		($reg_above, $reg_below) = ($temp1, $temp2);
	    }
	    elsif (($sheet_above eq &get_sheet($data_ref, $temp2)) and ($sheet_below eq &get_sheet($data_ref, $temp1)))
	    {
		($reg_above, $reg_below) = ($temp2, $temp1);
	    }
	}
	
	unless ($reg_above and $reg_below)
	{
	    print "Error: no reg_above and reg_below\n";
	    return;
	}
	
	
	$res_up = &get_sheet_up($temp_res{$sheet_above}{'up'}, $temp_res{$sheet_above}{'start'}, $start_res);
	#print "3. reg_above: $reg_above, reg_below: $reg_below, sheet_above temp_res : up = $temp_res{$sheet_above}{'up'} for residue $temp_res{$sheet_above}{'start'}, actual start is $start_res, sheet_up is now $res_up\n";
	
	#loop through each residue
	for ($res_above = $start_res; $res_above <= $end_res; $res_above++)
	{
	    #get res_below and see if its valid
	    $res_below = $reg_below + ($reg_above - $res_above);
	    $next_below = $res_below + 1;
	    #print "4a. res_above - $res_above, res_below - $res_below, ";
	    
	    if ($res{$sheet_below}{'left_to_right'})
	    {
		unless (($res_below >= $temp_res{$sheet_below}{'start'}) and ($res_below <= $temp_res{$sheet_below}{'end'}))
		{
		    $res_below = 0;
		}
		
		unless (($temp_res{$sheet_below}{'start'} <= $next_below) and ($temp_res{$sheet_below}{'end'} >= $next_below))
		{
		    $next_below = 0;
		}
	    }
	    else
	    {
		unless (($res_below <= $temp_res{$sheet_below}{'start'}) and ($res_below >= $temp_res{$sheet_below}{'end'}))
		{
		    $res_below = 0;
		}
		
		unless (($temp_res{$sheet_below}{'start'} >= $next_below) and ($temp_res{$sheet_below}{'end'} <= $next_below))
		{
		    $next_below = 0;
		}
	    }
	    
	    #print "next_below = $next_below\n";

	    #get_coords
	    my ($ax, $ay) = &get_coords_of_res($coords{$sheet_above}{'x'}, $coords{$sheet_above}{'y'}, $res{$sheet_above}{'start'}, $res_above, $res{$sheet_above}{'left_to_right'});
	    #$canvas->createText($ax, $ay, -text=>$res_above);
	    my $elem_above_ref = &get_coords_elements($ax, $ay, $res_up, $res{$sheet_above}{'left_to_right'});
	    my %elem_above = %$elem_above_ref;

	    my ($bx, $by) = &get_coords_of_res($coords{$sheet_below}{'x'}, $coords{$sheet_below}{'y'}, $res{$sheet_below}{'start'}, $res_below, $res{$sheet_below}{'left_to_right'});
	    my $elem_below_ref = &get_coords_elements($bx, $by, !$res_up, $res{$sheet_below}{'left_to_right'});
	    my %elem_below = %$elem_below_ref;

	    #print "4b. above res: $res_above ($ax, $ay), below res: $res_below ($bx, $by), and res_up is $res_up\n";
	    
	    #draw interactions
	    if ($res_up)
	    {
		if ($res_below)
		{
		    &create_H_bond($elem_above{'OC'}{'x'}, $elem_above{'OC'}{'y'}, $elem_below{'Hn'}{'x'}, $elem_below{'Hn'}{'y'}, $canvas);
		    &create_H_bond($elem_above{'Hn'}{'x'}, $elem_above{'Hn'}{'y'}, $elem_below{'OC'}{'x'}, $elem_below{'OC'}{'y'}, $canvas);
		    &place_insig_interaction($elem_above{'Hn'}{'x'}, $elem_above{'Hn'}{'y'}, $elem_below{'Hn'}{'x'}, $elem_below{'Hn'}{'y'}, $canvas);
		    &box_H($elem_above{'Hn'}{'x'}, $elem_above{'Hn'}{'y'}, $canvas);
		    &box_H($elem_below{'Hn'}{'x'}, $elem_below{'Hn'}{'y'}, $canvas);
		}

		if ($next_below)
		{
		    my ($nx, $ny) = &get_coords_of_res($coords{$sheet_below}{'x'}, $coords{$sheet_below}{'y'}, $res{$sheet_below}{'start'}, $next_below, $res{$sheet_below}{'left_to_right'});
		    my $elem_next_ref = &get_coords_elements($nx, $ny, $res_up, $res{$sheet_below}{'left_to_right'});
		    my %elem_next = %$elem_next_ref;
		    
		    &place_insig_interaction($elem_above{'Hn'}{'x'}, $elem_above{'Hn'}{'y'}, $elem_next{'Ha'}{'x'}, $elem_next{'Ha'}{'y'}, $canvas);
		    
		}
	    }
	    else
	    {
		if ($res_below)
		{
		    &place_insig_interaction($elem_above{'Ha'}{'x'}, $elem_above{'Ha'}{'y'}, $elem_below{'Ha'}{'x'}, $elem_below{'Ha'}{'y'}, $canvas);
		}

		if ($next_below)
		{
		    my ($nx, $ny) = &get_coords_of_res($coords{$sheet_below}{'x'}, $coords{$sheet_below}{'y'}, $res{$sheet_below}{'start'}, $next_below, $res{$sheet_below}{'left_to_right'});
		    my $elem_next_ref = &get_coords_elements($nx, $ny, $res_up, $res{$sheet_below}{'left_to_right'});
		    my %elem_next = %$elem_next_ref;
		    
		    &place_insig_interaction($elem_above{'Ha'}{'x'}, $elem_above{'Ha'}{'y'}, $elem_next{'Hn'}{'x'}, $elem_next{'Hn'}{'y'}, $canvas);
		    &box_H($elem_next{'Hn'}{'x'}, $elem_next{'Hn'}{'y'}, $canvas);
		}
	    }
	    
	    $res_up = !$res_up;
	}
    }
}


sub place_para_bg_interactions
{
    my ($canvas, $sheets_ref, $data_ref, $temp_res_ref, $sheets_info_ref, $res_ref, $coords_ref) = @_;

    my $sheet_num = 0;
    my @sheets = @$sheets_ref;
    my %temp_res = %$temp_res_ref;
    my %sheets_info = %$sheets_info_ref;
    my %res = %$res_ref;
    my %coords = %$coords_ref;

    my ($start_res, $end_res);
    my ($sheet_above, $sheet_below, $res_above, $res_below, $reg_above, $reg_below, $res_up, $next_below, $prev_below);

    if ($#sheets > 1)
    {
	my $temp_num = $#sheets-2;
	if ($sheets[$#sheets] == $sheets[$temp_num])
	{
	    $sheets[$#sheets] = '';
	}
    }
    
    #print "\npara_bg_interactions: number of sheets = $#sheets, sheets are @sheets\n";
    #for each sheet
    for ($sheet_num = 0; $sheet_num < $#sheets; $sheet_num++)
    {
	($sheet_above, $sheet_below) = ($sheets[$sheet_num], $sheets[$sheet_num+1]);
	last unless ($sheet_below);
	
	#print "1. sheet_above is $sheet_above (up - $temp_res{$sheet_above}{'up'}, sheet_below is $sheet_below (up - $temp_res{$sheet_below}{'up'}, sheet_num = $sheet_num\n";
	
	#get start and end res
	($start_res, $end_res) = ($temp_res{$sheet_above}{'start'}, $temp_res{$sheet_above}{'end'});
	
	#get reg_above and reg_below
	my ($temp1, $temp2) = &get_res($sheets_info{$sheet_above}[0]);

	if (($sheet_above eq &get_sheet($data_ref, $temp1)) and ($sheet_below eq &get_sheet($data_ref, $temp2)))
	{
	    ($reg_above, $reg_below) = ($temp1, $temp2);
	}
	elsif (($sheet_above eq &get_sheet($data_ref, $temp2)) and ($sheet_below eq &get_sheet($data_ref, $temp1)))
	{
	    ($reg_above, $reg_below) = ($temp2, $temp1);
	}
	elsif ($sheets_info{$sheet_above}[1])
	{
	    ($temp1, $temp2) = &get_res($sheets_info{$sheet_above}[1]);

	    if (($sheet_above eq &get_sheet($data_ref, $temp1)) and ($sheet_below eq &get_sheet($data_ref, $temp2)))
	    {
		($reg_above, $reg_below) = ($temp1, $temp2);
	    }
	    elsif (($sheet_above eq &get_sheet($data_ref, $temp2)) and ($sheet_below eq &get_sheet($data_ref, $temp1)))
	    {
		($reg_above, $reg_below) = ($temp2, $temp1);
	    }
	}
	
	unless ($reg_above and $reg_below)
	{
	    print "Error: no reg_above and reg_below\n";
	    return;
	}
	
	$res_up = $temp_res{$sheet_above}{'up'};
	
	#print "2. starting at $start_res to $end_res\n";
	#loop through each residue
	for ($res_above = $start_res; $res_above <= $end_res; $res_above++)
	{
	    #get res_below and see if its valid
	    $res_below = $reg_below - ($reg_above - $res_above);
	    $prev_below = $res_below - 1;
	    $next_below = $res_below + 1;

	    unless (($res_below >= $temp_res{$sheet_below}{'start'}) and ($res_below <= $temp_res{$sheet_below}{'end'}))
	    {
		$res_below = 0;
	    }
	    unless (($temp_res{$sheet_below}{'start'} <= $next_below) and ($temp_res{$sheet_below}{'end'} >= $next_below))
	    {
		$next_below = 0;
	    }
	    unless (($temp_res{$sheet_below}{'start'} <= $prev_below) and ($temp_res{$sheet_below}{'end'} >= $prev_below))
	    {
		$prev_below = 0;
	    }
	    
	    #print "3. res_above = $res_above, res_below = $res_below, res_up = $res_up, prev_below = $prev_below, next_below = $next_below\n";
	    
	    #get_coords
	    my ($ax, $ay) = &get_coords_of_res($coords{$sheet_above}{'x'}, $coords{$sheet_above}{'y'}, $res{$sheet_above}{'start'}, $res_above, 1);
	    my $elem_above_ref = &get_coords_elements($ax, $ay, $res_up, 1);
	    my %elem_above = %$elem_above_ref;

	    my ($bx, $by) = &get_coords_of_res($coords{$sheet_below}{'x'}, $coords{$sheet_below}{'y'}, $res{$sheet_below}{'start'}, $res_below, 1);
	    my $elem_below_ref = &get_coords_elements($bx, $by, $res_up, 1);
	    my %elem_below = %$elem_below_ref;
	    
	    #draw interactions
	    if ($res_up)
	    {
		if ($res_below)
		{
		    &place_insig_interaction($elem_above{'Hn'}{'x'}, $elem_above{'Hn'}{'y'}, $elem_below{'Ha'}{'x'}, $elem_below{'Ha'}{'y'}, $canvas);
		}
		if ($prev_below)
		{
		    my ($px, $py) = &get_coords_of_res($coords{$sheet_below}{'x'}, $coords{$sheet_below}{'y'}, $res{$sheet_below}{'start'}, $prev_below, 1);
		    my $elem_prev_ref = &get_coords_elements($px, $py, !$res_up, 1);
		    my %elem_prev = %$elem_prev_ref;
		    
		    &create_H_bond($elem_above{'Hn'}{'x'}, $elem_above{'Hn'}{'y'}, $elem_prev{'OC'}{'x'}, $elem_prev{'OC'}{'y'}, $canvas);
		    &box_H($elem_above{'Hn'}{'x'}, $elem_above{'Hn'}{'y'}, $canvas);
		}
		if ($next_below)
		{
		    my ($nx, $ny) = &get_coords_of_res($coords{$sheet_below}{'x'}, $coords{$sheet_below}{'y'}, $res{$sheet_below}{'start'}, $next_below, 1);
		    my $elem_next_ref = &get_coords_elements($nx, $ny, !$res_up, 1);
		    my %elem_next = %$elem_next_ref;
		    &create_H_bond($elem_above{'OC'}{'x'}, $elem_above{'OC'}{'y'}, $elem_next{'Hn'}{'x'}, $elem_next{'Hn'}{'y'}, $canvas);
		    &place_insig_interaction($elem_above{'Hn'}{'x'}, $elem_above{'Hn'}{'y'}, $elem_next{'Hn'}{'x'}, $elem_next{'Hn'}{'y'}, $canvas);
		}
	    }
	    else
	    {
		if ($res_below)
		{
		    &place_insig_interaction($elem_above{'Ha'}{'x'}, $elem_above{'Ha'}{'y'}, $elem_below{'Hn'}{'x'}, $elem_below{'Hn'}{'y'}, $canvas);
		    &box_H($elem_below{'Hn'}{'x'}, $elem_below{'Hn'}{'y'}, $canvas);
		}
	    }
	    
	    $res_up = !$res_up;
	}
    }


}



sub get_coords_of_res
{
    my ($x, $y, $start_res, $res_num, $left_to_right) = @_;
    
    my $res_x = abs($res_num - $start_res) * $x_div;
    my ($ret_x);
    
    if ($left_to_right)
    {
	if ($res_num < $start_res)
	{
	    $ret_x = $x - $res_x;
	}
	else
	{
	    $ret_x = $x + $res_x;
	}
    }
    else
    {
	if ($res_num > $start_res)
	{
	    $ret_x = $x-$res_x;
	}
	else
	{
	    $ret_x = $x+$res_x;
	}
    }
    #print "get_coords_of_res: start - ($x, $y) at $start_res, $res_num at ($ret_x, $y), left_to_right = $left_to_right\n";
    return ($ret_x, $y);
}



sub get_first_up
{
    my ($data_ref, $my_reg, $sheet, $inter, $left_to_right, $res, $key) = @_;
    #print "get_first_up: my_reg: $my_reg, sheet: $sheet, inter: $inter, res: $res, key is $key\n";

    my %data = %$data_ref;
    my ($strands, $register, $interaction, $up, $temp_res, $temp_atm);
    
    my ($start, $end);
    if ($left_to_right)
    {
	($start, $end) = &get_res($sheet);
    }
    else
    {
	($end, $start) = &get_res($sheet);
    }
    my ($reg1, $reg2) = &get_res($my_reg);
    

    foreach $strands (keys %{$data{'Evidences'}})
    {
	foreach $register (keys %{$data{'Evidences'}{$strands}})
	{
	    if ($register =~ /$my_reg/ and ($register =~ /^\s*$key/))
	    {
		foreach $interaction (keys %{$data{'Evidences'}{$strands}{$register}})
		{
		    $interaction =~ /(\d+)(\w+)\-(\d+)(\w+)/;
		    my ($res1, $atm1, $res2, $atm2) = ($1, $2, $3, $4);
		    
		    #print "get_first_up: interaction $interaction\n";
		    
		    if ($sheet eq &get_sheet($data_ref, $res1))
		    {
			$temp_atm = $atm1;
			$temp_res = $res1;
		    }
		    elsif ($sheet eq &get_sheet($data_ref, $res2))
		    {
			$temp_atm = $atm2;
			$temp_res = $res2;
		    }
		    else
		    {
			next;
		    }
		    
		    #print "get_first_up: temps in sheet - ($temp_res, $temp_atm)\n";
		    if ($temp_atm eq 'Ha')
		    {
			$up = $inter;
			#print "get_first_up: (interaction - $interaction), atm is Ha, so up is $up for residue $temp_res\n";
			
			($up) = &get_sheet_up($up, $start, $temp_res);
			return ($up);
		    }
		    elsif ($temp_atm eq 'Hn')
		    {
			$up = !$inter;
			#print "get_first_up: (interaction - $interaction), atm is Hn, so up is $up for residue $temp_res\n";
			
			$up = &get_sheet_up($up, $start, $temp_res);
			return ($up);
		    }
		    else
		    {
			next;
		    }
		}

	    }
	}
    }
}

sub place_arrow
{
    my ($canvas, $x1, $y1, $x2, $y2, $key) = @_;

    ($x1, $y1, $x2, $y2) = ($x1, $y1 + 5, $x2, $y2 - 5);

    my $arrow;

    if ($key eq 'double')
    {
	$arrow = $canvas->createLine($x1, $y1, $x2, $y2, -arrow=>'both', -capstyle=>'round', -fill=>'blue', -width=>"1.5");
    }
    elsif ($key eq 'single')
    {
	$arrow = $canvas->createLine($x1, $y1, $x2, $y2, -dash=>'-', -fill=>'blue', -width=>"1.5");
    }
    return ($arrow);

}

sub get_sheets_id
{
    my ($data_ref, $res1, $res2) = @_;

    my ($id1, $id2, $i);
    my %data = %$data_ref;
    
    my $count = scalar(@{$data{'Final'}});
    #print "get_sheets_id: count = $count\n";

    for ($i = 1; $i<$count; $i++)
    {
	#print "data{'Final'}[$i] = $data{'Final'}[$i]\n";
	my $line = $data{'Final'}[$i];
	$line =~ /(\d+)\-(\d+)$/;
	
	my ($start, $end) = ($1, $2);

	if (($start <= $res1) and ($end >= $res1))
	{
	    $id1 = $i;
	}

	if (($start <= $res2) and ($end >= $res2))
	{
	    $id2 = $i;
	}
    }

    #search for strands
    my $strands;
    my $sheet_id;
    foreach $strands (keys %{$data{'Evidences'}})
    {
	if (($strands eq "$id1-$id2") or ($strands eq "$id2-$id1"))
	{
	    $sheet_id = $strands;
	}
    }

    return ($sheet_id);
}



sub get_coords_of_start
{
    my ($x, $y, $start_res, $res_num) = @_;

    my $start_x = abs($res_num - $start_res) * $x_div;
    
    return ($x - $start_x, $y);

}


sub get_coords_next_sheet
{
    my ($x, $y) = @_;

    my $new_y = $y + $y_div;
    return ($x, $new_y);

}


sub create_peptide
{
    my ($canvas, $start_res, $end_res, $x1, $y1, $left_to_right, $up)= @_;

    my $cur_res;
    my ($x2, $y2) = ($x1 + $x_div, $y1);

    if ($left_to_right)
    {
	for ($cur_res = $start_res; $cur_res<=$end_res; $cur_res++)
	{
	    &place_residue($x2, $y2, $canvas, $cur_res, $up);
	    
	    unless ($cur_res == $start_res)
	    {
		&make_peptide_bond($x1, $y1, $x2, $y2, $canvas, $up);
	    }
	    
	    $x1 += $x_div;
	    $x2 += $x_div;
	    
	    $up = !$up;
	}
    }
    else
    {
	for ($cur_res = $start_res; $cur_res>=$end_res; $cur_res--)
	{
	    &place_inverse_residue($x2, $y2, $canvas, $cur_res, $up);
	    unless ($cur_res == $start_res)
	    {
		&make_peptide_bond($x1, $y1, $x2, $y2, $canvas, $up);
	    }

	    $x1 += $x_div;
	    $x2 += $x_div;
	    $up = !$up;

	}
    }
}

sub create_H_bond
{
    my ($x1, $y1, $x2, $y2, $canvas) = @_;

    $canvas->createLine($x1, $y1+5, $x2, $y2-5, -fill=>'purple', -dash=>'.', -width=>2);
}

sub box_H
{
    my ($x, $y, $canvas) = @_;

    $canvas->createRectangle($x-7, $y-7, $x+7, $y+7, -outline=>'black');

}


sub place_inverse_residue
{
    my ($x1, $y1, $canvas, $residue_num, $up) = @_;

    my $coords_ref = &get_coords_elements($x1, $y1, $up, 0);
    my %coords = %$coords_ref;
    
    my $element;
    foreach $element (keys %coords)
    {
	#print "placing element: $element at ($coords{$element}{'x'},$coords{$element}{'y'})\n";
	&place_element($element, $coords{$element}{'x'}, $coords{$element}{'y'}, $canvas);
    }

    if ($up)
    {
	#place bonds
	&make_single_bond($x1+($width/2), $y1+($height/10), $x1+($width/2), $y1+(3*$height/10), $canvas);
	&make_single_bond($x1+($width/8), $y1+(3*$height/5), $x1+(3*$width/8), $y1+(2*$height/5), $canvas);
	&make_double_bond($x1-2, $y1+(7*$height/10), $x1-2, $y1+(9*$height/10), $canvas);
	&make_single_bond($x1+(5*$width/8), $y1+(2*$height/5), $x1+(7*$width/8), $y1+(3*$height/5), $canvas);
	&make_single_bond($x1+$width, $y1+(7*$height/10), $x1+$width, $y1+(9*$height/10), $canvas);

	$canvas->createText($x1+($width/2), $y1+(3*$height/5), -text=>$residue_num);
    }
    else
    {
	#place bonds
	&make_single_bond($x1+($width/2), $y1+(7*$height/10), $x1+($width/2), $y1+(9*$height/10), $canvas);
	&make_single_bond($x1+($width/8), $y1+(2*$height/5), $x1+(3*$width/8), $y1+(3*$height/5), $canvas);
	&make_double_bond($x1-2, $y1+($height/10), $x1-2, $y1+(3*$height/10), $canvas);
	&make_single_bond($x1+(5*$width/8), $y1+(3*$height/5), $x1+(7*$width/8), $y1+(2*$height/5), $canvas);
	&make_single_bond($x1+$width, $y1+($height/10), $x1+$width, $y1+(3*$height/10), $canvas);

	$canvas->createText($x1+($width/2), $y1+(2*$height/5), -text=>$residue_num);
    }

}

sub get_coords_elements
{
    my ($x, $y, $up, $left_to_right) = @_;
    #print "get_coords_element: ($x, $y), residue up = $up, left_to_right = $left_to_right\n";
    my %coords;

    if ($left_to_right)
    {
	if ($up)
	{
	    $coords{'Ha'}{'x'} = $x + $width/2;
	    $coords{'Ha'}{'y'} = $y;
	    $coords{'CA'}{'x'} = $x + ($width/2);
	    $coords{'CA'}{'y'} = $y + (2*$height/5);
	    $coords{'N'}{'x'} = $x;
	    $coords{'N'}{'y'} = $y + (3*$height/5);
	    $coords{'Hn'}{'x'} = $x;
	    $coords{'Hn'}{'y'} = $y + $height;
	    $coords{'C'}{'x'} = $x + $width;
	    $coords{'C'}{'y'} = $y + (3*$height/5);
	    $coords{'OC'}{'x'} = $x + $width;
	    $coords{'OC'}{'y'} = $y + $height;
	}
	else
	{
	    $coords{'Ha'}{'x'} = $x + $width/2;
	    $coords{'Ha'}{'y'} = $y + $height;
	    $coords{'CA'}{'x'} = $x + ($width/2);
	    $coords{'CA'}{'y'} = $y + (3*$height/5);
	    $coords{'N'}{'x'} = $x;
	    $coords{'N'}{'y'} = $y + (2*$height/5);
	    $coords{'Hn'}{'x'} = $x;
	    $coords{'Hn'}{'y'} = $y;
	    $coords{'C'}{'x'} = $x + $width;
	    $coords{'C'}{'y'} = $y + (2*$height/5);
	    $coords{'OC'}{'x'} = $x + $width;
	    $coords{'OC'}{'y'} = $y;
	}
    }
    else
    {
	if ($up)
	{
	    $coords{'Ha'}{'x'} = $x + $width/2;
	    $coords{'Ha'}{'y'} = $y;
	    $coords{'CA'}{'x'} = $x + ($width/2);
	    $coords{'CA'}{'y'} = $y + (2*$height/5);
	    $coords{'N'}{'x'} = $x + $width;
	    $coords{'N'}{'y'} = $y + (3*$height/5);
	    $coords{'Hn'}{'x'} = $x + $width;
	    $coords{'Hn'}{'y'} = $y + $height;
	    $coords{'C'}{'x'} = $x;
	    $coords{'C'}{'y'} = $y + (3*$height/5);
	    $coords{'OC'}{'x'} = $x;
	    $coords{'OC'}{'y'} = $y + $height;
	}
	else
	{
	    $coords{'Ha'}{'x'} = $x + $width/2;
	    $coords{'Ha'}{'y'} = $y + $height;
	    $coords{'CA'}{'x'} = $x + ($width/2);
	    $coords{'CA'}{'y'} = $y + (3*$height/5);
	    $coords{'N'}{'x'} = $x + $width;
	    $coords{'N'}{'y'} = $y + (2*$height/5);
	    $coords{'Hn'}{'x'} = $x + $width;
	    $coords{'Hn'}{'y'} = $y;
	    $coords{'C'}{'x'} = $x ;
	    $coords{'C'}{'y'} = $y + (2*$height/5);
	    $coords{'OC'}{'x'} = $x;
	    $coords{'OC'}{'y'} = $y;
	}
    }

    return (\%coords);

}

sub place_insig_interaction
{
    my ($x1, $y1, $x2, $y2, $canvas) = @_;

    $canvas->createLine($x1, $y1+5, $x2, $y2-5, -fill=>'#777777');
}


sub place_residue
{
    my ($x1, $y1, $canvas, $residue_num, $up) = @_;
    
    my $coords_ref = &get_coords_elements($x1, $y1, $up, 1);
    my %coords = %$coords_ref;
    
    my $element;
    foreach $element (keys %coords)
    {
	&place_element($element, $coords{$element}{'x'}, $coords{$element}{'y'}, $canvas);
    }


    #place atoms
    if ($up)
    {
	#place bonds
	&make_single_bond($x1+($width/2), $y1+($height/10), $x1+($width/2), $y1+(3*$height/10), $canvas);
	&make_single_bond($x1+($width/8), $y1+(3*$height/5), $x1+(3*$width/8), $y1+(2*$height/5), $canvas);
	&make_single_bond($x1+(5*$width/8), $y1+(2*$height/5), $x1+(7*$width/8), $y1+(3*$height/5), $canvas);
	&make_single_bond($x1, $y1+(7*$height/10), $x1, $y1+(9*$height/10), $canvas);
	&make_double_bond($x1+$width-2, $y1+(7*$height/10), $x1+$width-2, $y1+(9*$height/10), $canvas);

	#place residue number
	$canvas->createText($x1+($width/2), $y1+(3*$height/5), -text=>$residue_num);
	
    }
    else
    {
	#place bonds
	&make_single_bond($x1, $y1+($height/10), $x1, $y1+(3*$height/10),  $canvas);
	&make_single_bond($x1+($width/8), $y1+(2*$height/5), $x1+(3*$width/8), $y1+(3*$height/5), $canvas);
	&make_single_bond($x1+(5*$width/8), $y1+(3*$height/5), $x1+(7*$width/8), $y1+(2*$height/5), $canvas);
	&make_single_bond($x1+($width/2), $y1+(7*$height/10), $x1+($width/2), $y1+(9*$height/10), $canvas);
	&make_double_bond($x1+$width-2, $y1+($height/10), $x1+$width-2, $y1+(3*$height/10), $canvas);

	$canvas->createText($x1+($width/2), $y1+(2*$height/5), -text=>$residue_num);
    }


}

sub make_peptide_bond
{
    my ($x1, $y1, $x2, $y2, $canvas, $up) = @_;

    if ($up)
    {
	$canvas->createLine($x1+$width+5, $y1+(2*$height/5), $x2-5, $y2+(3*$height/5), -fill=>'red');
    }
    else
    {
	$canvas->createLine($x1+$width+5, $y1+(3*$height/5), $x2-5, $y2+(2*$height/5), -fill=>'red');
    }
    
}


sub make_double_bond
{
    my ($x1, $y1, $x2, $y2, $canvas) = @_;
    
    &make_single_bond($x1, $y1, $x2, $y2, $canvas);
    &make_single_bond($x1+3, $y1, $x2+3, $y2, $canvas);

}

sub make_single_bond
{
    my ($x1, $y1, $x2, $y2, $canvas) = @_;

    $canvas->createLine($x1, $y1, $x2, $y2);

}


sub place_element
{
    my ($letter, $x, $y, $canvas) = @_;
    
    if ($letter =~ /^(\w)\w$/)
    {
	$letter = $1;
    }
    
    #print "place_element: $letter, $x, $y\n";
    my $element = $canvas->createText($x, $y, -text=>$letter, -font=>[size=>12]);
    return ($element);

}


return 1;
