sub place_sheets
{
    my ($canvas, $x, $y, $data_ref, $help_ref, $parent, $key) = @_;

    my %data = %$data_ref;

    my $count = scalar(@{$data{$key}});
    my @sheets;
    my %sheet_info;
    my %sheet_count;
    #print "$key registers = $count\n";

    
    for ($i = 0; $i<$count; $i++)
    {
	my $interaction = $data{$key}[$i];
	$interaction =~ /^(\d+)\-(\d+)$/;
	my ($inter_res1, $inter_res2) = ($1, $2);

	my ($sheet1, $sheet2) = (&get_sheet($data_ref, $inter_res1), &get_sheet($data_ref, $inter_res2));
	if ($sheet1)
	{
	    $sheet_info{$sheet1}[$sheet_count{$sheet1}] = $interaction;
	    #print "place_sheets: $interaction in $sheet1\n";
	    $sheet_count{$sheet1}++;
	}
	if ($sheet2)
	{
	    $sheet_info{$sheet2}[$sheet_count{$sheet2}] = $interaction;
	    #print "place_sheets: $interaction in $sheet2\n";
	    $sheet_count{$sheet2}++;
	}
	

    }
    
    
    if ($key eq 'Antiparallel')
    {
	($x, $y) = &place_anti_sheets($canvas, $x, $y, \%sheet_info, $data_ref, $help_ref);
    }
    else
    {
	#
($x, $y) = &place_para_sheets($canvas, $x, $y, \%sheet_info, $data_ref, $help_ref);
    }
    
    return ($x, $y);
}

sub change_para_up
{
    my ($up, $sheet1_start, $sheet1_num, $sheet2_start, $sheet2_num) = @_;
    
    my $prev_up = $up;
    ($up) = &get_sheet_up($up, $sheet1_start, $sheet1_num) unless ($sheet1_start eq $sheet1_num);
    ($up) = &get_sheet_up($up, $sheet2_start, $sheet2_num) unless ($sheet2_start eq $sheet2_num);

    return ($up);

}

sub change_anti_up
{
    my ($up, $sheet1_start, $sheet1_num, $sheet2_start, $sheet2_num) = @_;
    
    my $prev_up = $up;

    ($up) = &get_sheet_up($up, $sheet1_start, $sheet1_num) unless ($sheet1_start eq $sheet1_num);
    $up = !$up;
    ($up) = &get_sheet_up($up, $sheet2_start, $sheet2_num) unless ($sheet2_start eq $sheet2_num);
    
    #print "change_anti_up: prev_up = $prev_up, sheet1-start = $sheet1_start, res - $sheet1_num, sheet2-start = $sheet2_start, num - $sheet2_num, returning up = $up\n";
    return ($up);
}

sub get_sheet_up
{
    my ($up, $sheet_start, $sheet_num) = @_;

    my $var = abs($sheet_start - $sheet_num + 1) % 2;
    unless ($var)
    {
	$up = !$up;
    }
    
    #print "get_sheet_up: returning $up for start $sheet_start, num - $sheet_num\n";
    return ($up);
}


sub get_sheet
{
    my ($data_ref, $res) = @_;
    my ($sheet);

    my $id;
    
    my %data = %$data_ref;
    my $count = scalar(@{$data{'Final'}});
    
    #get sheet of res1
    for ($id = 0; $id < $count; $id++)
    {
	my $line = $data{'Final'}[$id];
	$line =~ /(\w+)\s+(\d+)\-(\d+)$/;
	
	my $type = $1;
	my ($start, $end) = ($2, $3);
	if (($start <= $res) and ($end >= $res) and ($type =~ /sheet/i))
	{
	    $sheet = "$start-$end";
	    
	}
    }
    
    #print "$res1 is from $sheet1, $res2 is from $sheet2\n";
    return ($sheet);
 

}


sub get_res
{
    my ($lbl)= @_;

    my ($res1, $res2);
    if ($lbl =~ /^(\d+)\-(\d+)$/)
    {
	($res1, $res2) = ($1, $2);
    }
    
    #print "get_res: returning ($res1, $res2)\n";
    return ($res1, $res2);
}


return 1;
