sub parse_as_ovw
{
    my ($file, $parent) = @_;
    
    my $asdir = dirname($file);
    
    my $debug = 0;

    unless (open(FILE, $file))
    {
	&err_msg("Cannot ovw open file \"$file\"", $parent);
	return;
    }

    #data structures
    my %data;
    my %count;
    my %heading;
    
    
    my ($line, $pklst, $table);
    my $start_read = 0;
    my $line_count = 0;


    while (chomp($line = <FILE>))
    {
	if ($line =~ /NOESY_Assign Version ([\d\.]+) /)
	{
	    my $version = $1; 
	    if ($version =~ /2\.1\./)
	    {
		&err_msg("This is a $version version output. Please use an older version GUI to open it", $parent); 
	    }
	}
       	if ($line =~ /Summary/i)
	{
	    $start_read = 1;
	    next;
	}
	
	
	if ($start_read)
	{
	    if ($line =~ /^peaklist (.+)$/i)
	    {
		$pklst = $1;
		$pklst =~ s/://;
	    }
	    elsif ($line =~ /^\s*\#(.+)\#\s*$/)
	    {
		$table = $1;
		$line_count = 1;
	    }

	    $line_count++;
	    
	    if ($line =~ /^Cycle/i)
	    {
		$heading{$pklst}{$table} = $line;
	    }
	    elsif ($line_count >= 6)
	    {
		if ($line =~ /^(\d+-\d+)/)
		{
		    my $cycle = $1;
		    $data{$pklst}{$table}{$cycle}[$count{$pklst}{$table}{$cycle}] = $line;
		    $count{$pklst}{$table}{$cycle}++;
		}
	    }
	}
    }

    

 
    if ($debug)
    {
	print "parsing ovw file $file\n";
	print "Autostructure directory $asdir\n";
	#print out contents of data
	my ($pklst, $table, $cycle, $count);

	foreach $pklst (keys %data)
	{
	    print "\nPeaklist $pklst:\n\n";
	    foreach $table (keys %{$data{$pklst}})
	    {
		print "****$table****\n\n";
		
		foreach $cycle (sort {$a<=>$b} keys %{$data{$pklst}{$table}})
		{
		    my $tot = scalar(@{$data{$pklst}{$table}{$cycle}});

		    for ($count = 0; $count<$tot; $count++)
		    {
			print "$data{$pklst}{$table}{$cycle}[$count]\n";
		    }
		}
		print "\n";
	    }
	}
	
    }

    return (\%data, \%heading);
    
}

return 1;
