sub parse_assOrder_whole
{
    my ($file, $parent) = @_;

    unless (open(FILE, $file))
    {
	&err_msg("Cannot open assOrder file \"$file\"", $parent);
	return;
    }

    my $read_line1 = 0;
    my @data;
    my $line;
    my %temp_data;

    #print "\n\n***File is $file...\n\n";

    while (chomp($line = <FILE>))
    {
	#print "line is $line\n";

	if ($line =~ /^peak/i)
	{
	    $read_line1 = 1;
	    $temp_data{'peak'} = $line;
	}
	elsif ($line =~ /^atom/i)
	{
	    if ($read_line1)
	    {
		#read first atom line
		my (%info) = &get_residue_line($line);
		$temp_data{'residue 1'} = $info{'residue'};
		$temp_data{'atom 1'} = $info{'atom'};
		$temp_data{'line1'} = $line;
		$read_line1 = 0;
	    }
	    else
	    {
		#read second atom line
		my (%info) = &get_residue_line($line);
		
		# data[<residue 1 num>]{<res 1 atom>}[<res 2 num>]{<res 2 atom>}{'peak'}, {'atom 1'}, {'atom 2'} ( the whole line)

		$data[$temp_data{'residue 1'}]{$temp_data{'atom 1'}}[$info{'residue'}]{$info{'atom'}}{'peak'} = $temp_data{'peak'};
		$data[$temp_data{'residue 1'}]{$temp_data{'atom 1'}}[$info{'residue'}]{$info{'atom'}}{'atom 1'} = $temp_data{'line1'};
		$data[$temp_data{'residue 1'}]{$temp_data{'atom 1'}}[$info{'residue'}]{$info{'atom'}}{'atom 2'} = $line;
		
	    }
	}
    }
    
    if (0){
    my ($res1, $atm1, $res2, $atm2);
    for ($res1 = 1; $res1 < scalar(@data); $res1++)
    {
	foreach $atm1 (sort {$a cmp $b} keys %{$data[$res1]})
	{
	    for ($res2 = 1; $res2 < scalar(@{$data[$res1]{$atm1}}); $res2++)
	    {
		foreach $atm2 (sort {$a cmp $b} keys %{$data[$res1]{$atm1}[$res2]})
		{
		    #print "1-($res1,$atm1); 2-($res2,$atm2); peak - $data[$res1]{$atm1}[$res2]{$atm2}{'peak'}\n"
		}
	    }
	}
    }
    
}
    #print "End file...\n";
    return (\@data);
}

#used for noe assignments tab 
sub parse_assOrder_multiple
{
    my ($file, $parent, $type) = @_;

    my @rdata; 

if ($type != 3)
{
    #print "\n\n***File is $file...\n\n";

    my $read_line1 = 0;
    my %data;
    my $line;
    my %temp_data;
    
    unless (open(FILE, "<$file"))
    {
	&err_msg("Cannot open assOrder file \"$file\"", $parent);
	return;
    }
    
    while (chomp($line = <FILE>))
    {
	#print "line is $line\n";

	if ($line =~ /^peak/i)
	{
	    $read_line1 = 1;
	    $temp_data{'peak'} = $line;
	}
	elsif ($line =~ /^atom/i)
	{
	    if ($read_line1)
	    {
		#read first atom line
		my (%info) = &get_residue_line($line);
		$temp_data{'residue 1'} = $info{'residue'};
		$temp_data{'atom 1'} = $info{'atom'};
		$temp_data{'line1'} = $line;
		$read_line1 = 0;
	    }
	    else
	    {
		#read second atom line
		my (%info) = &get_residue_line($line);
		
		# data[<residue 1 num>]{<res 1 atom>}[<res 2 num>]{<res 2 atom>}{'peak'}, {'atom 1'}, {'atom 2'} ( the whole line)

		$data{$temp_data{'peak'}}++; 

		#$data[$temp_data{'residue 1'}]{$temp_data{'atom 1'}}[$info{'residue'}]{$info{'atom'}}{'peak'} = $temp_data{'peak'};
		#$data[$temp_data{'residue 1'}]{$temp_data{'atom 1'}}[$info{'residue'}]{$info{'atom'}}{'atom 1'} = $temp_data{'line1'};
		#$data[$temp_data{'residue 1'}]{$temp_data{'atom 1'}}[$info{'residue'}]{$info{'atom'}}{'atom 2'} = $line;
	    }
	}
    }

    foreach (sort %data)
    {
	if (($type == 1) && ($data{$_} == 1))
	{
	    push @rdata, $_; 
	}
	elsif (($type == 2) && ($data{$_} > 1))
	{
	    push @rdata, $_; 
	} 
	elsif (($type == 0) && ($data{$_} >=1))
	{
	    push @rdata, $_; 
	}
    }
}

    if (($type == 0) || ($type == 3))
    {
	my ($zerofile) = $file;
	$zerofile =~ s/assOrder/zeroAss/; 

	unless (open(SFILE, "<$zerofile"))
	{
	    &err_msg("Cannot open zeroAss file \"$zerofile\"", $parent);
	    return;
	}

	while (chomp($line = <SFILE>))
	{
	    #print $line;
	    push @rdata, $line; 
	}
    }
    
    #print "End file...\n";
    return (\@rdata);
}

#used for contact maps
sub parse_assOrder_single
{
    #given file, residue 1 and residue 2, parse_assOrder returns all the lines which involve interactions between res1 and res2

    my ($file, $res1, $res2, $parent) = @_;

    #print "parse_assOrder: parsing file $file for residues $res1 and $res2\n";

    unless (open(FILE, $file))
    {
	&err_msg("Cannot open assOrder file \"$file\"", $parent);
	return;
    }

    my $read_line1 = 0;
    my @data;
    my $line;
    my $data_count = 0;
    my %temp_data;
    
    while (chomp($line = <FILE>))
    {
	
	#print "line is $line\n";

	if ($line =~ /^peak/i)
	{
	    $read_line1 = 1;
	    $temp_data{'peak'} = $line;

	    #print "line is peak - $line\n";
	    
	}
	elsif ($line =~ /^atom/i)
	{
	    if ($read_line1)
	    {
		#read first atom line
		my (%info) = &get_residue_line($line);
		if (($info{'residue'} == $res1) or ($info{'residue'} == $res2))
		{
		    $temp_data{'residue 1'} = $info{'residue'};
		    $temp_data{'atom 1'} = $line;
		    $read_line1 = 0;
		    #print "first_line contains residue $temp_data{'residue 1'}\n";
		    
		}
		else
		{
		    #if first atom line is neither, dont read second line, go to next line
		    next;
		}
	    }
	    else
	    {
		#read second atom line
		#print "reading second line\n";
		if ($temp_data{'residue 1'} == $res1)
		{
		    #print "first line contained $res1, reading second line\n";
		    my (%info) = &get_residue_line($line);
		    
		    #res1 is first line, check if res2 is second line
		    if ($info{'residue'} == $res2)
		    {
			#print "first line contained $temp_data{'residue 1'} and second line contains $info{'residue'}\n";
			#res1 is first line, and $res2 is second line - store info in data array
			$data[$data_count]{'peak'} = $temp_data{'peak'};
			$data[$data_count]{'atom 1'} = $temp_data{'atom 1'};
			$data[$data_count]{'atom 2'} = $line;
			$data_count++;
			#print "data_count increased to $data_count\n";
		    }
		    else
		    {
			next;
		    }
		    #print "\n";
		}
		elsif ($temp_data{'residue 1'} == $res2)
		{
		    #print "first line contained $res2, reading second line\n";
		    my (%info) = &get_residue_line($line);
		    
		    #res2 is first line, check if $res1 is second line
		    if ($info{'residue'} == $res1)
		    {
			#print "first line contained $temp_data{'residue 1'} and second line contains $info{'residue'}\n";
			#store info in data array
			$data[$data_count]{'peak'} = $temp_data{'peak'};
			$data[$data_count]{'atom 1'} = $temp_data{'atom 1'};
			$data[$data_count]{'atom 2'} = $line;
			$data_count++;
			#print "data_count increased to $data_count\n";
		    }
		    else
		    {
			next;
		    }

		    #print "\n";
		}
		
	    }
	    #print "\n";
	}
    }

    #print "parse_assOrder: done parsing file - display data\n";

    my $count = $#data;
    #print "parse_assOrder_single: data_count is $data_count\n";
    my $i;

    for ($i = 0; $i<=$count; $i++)
    {
	foreach $key (keys %{$data[$i]})
	{
	    #print "data[$i]{$key} = $data[$i]{$key}\n";
	}
	#print "\n";
    }


    return (\@data);
}

#used for contact maps 
sub parse_assOrder_mult
{
    my ($file, $res1, $parent) = @_;

    #given residue 1, parse the file for all those peaks that involve residue 1 and any other residue
    unless (open(FILE, $file))
    {
	&err_msg("Cannot open assOrder file \"$file\"", $parent);
	return;
    }

    my $read_line1 = 0;
    my $first_res1 = 0;
    my @data;
    my $line;
    my $data_count = 0;
    my %temp_data;
    
    while (chomp($line = <FILE>))
    {
	if ($line =~ /^peak/i)
	{
	    $temp_data{'peak'} = $line;
	    $read_line1 = 1;
	    $first_res1 = 0;
	    
	}
	elsif ($line =~ /^atom/i)
	{
	    if ($read_line1)
	    {
		#first atom line
		my (%info) = &get_residue_line($line);
		$temp_data{'atom 1'} = $line;

		if ($info{'residue'} == $res1)
		{
		    $data[$data_count]{'atom 1'} = $line;
		    $data[$data_count]{'peak'} = $temp_data{'peak'};
		    $read_line1 = 0;
		    $first_res1 = 1;
		}
		else
		{
		    $read_line1 = 0;
		    $first_res1 = 0;
		    next;
		}
	    }
	    else
	    {
		#second atom line
		if ($first_res1)
		{
		    $data[$data_count]{'atom 2'} = $line;
		    $data_count++;
		    next;
		}
		else
		{
		    #check if second line contains $res1
		    my (%info) = &get_residue_line($line);
		    
		    if ($info{'residue'} == $res1)
		    {
			$data[$data_count]{'atom 1'} = $temp_data{'atom 1'};
			$data[$data_count]{'peak'} = $temp_data{'peak'};
			$data[$data_count]{'atom 2'} = $line;
			$data_count++;
		    }
		}
	    }
	}
    }
    
    #print "parse_assOrder_mult: data_count is $data_count\n";
    
    return (\@data);
    
}

sub parse_assOrder_adnl
{
    #given a file, and a peak line, returns additional assignments of that peak
    my ($parent, $file, $peak) = @_;
    
    if ($peak =~ /^- /)
    {
	$peak =~ s/^- //;
    }

    unless (open(FILE, $file))
    {
	if ($parent)
	{
	    &err_msg("Cannot open file \"$file\"", $parent);
	}
	else
	{
	    print "Cannot open $file\n";
	}
	return;
    }
    
    my $data_count = 0;
    my @data;
    my $line;
    my $pk_match = 0;
    my ($pk_match, $atom1) = (0,0);

    while (chomp($line = <FILE>))
    {
	if ($line =~ /^peak/i)
	{
	    #peak
	    if ($line eq $peak)
	    {
		$pk_match = 1;
		$data[$data_count]{'peak'} = $line;
		$atom1 = 1;
	    }
	    else
	    {
		$pk_match = 0;
		$atom1 = 0;
		next;
	    }
	}
	elsif ($line =~ /^atom/i)
	{
	    #atom
	    if ($pk_match)
	    {
		#read 2 atom lines
		if ($atom1)
		{
		    #first atom line
		    $data[$data_count]{'atom 1'} = $line;
		    $atom1 = 0;
		}
		else
		{
		    $data[$data_count]{'atom 2'} = $line;
		    $data_count++;
		}
	    }
	}
    }

    #print $data_count . "\n";
    #print $data[0]{'atom 1'} . "\n";
    #print $data[0]{'atom 2'}; 

    return(\@data);
    
}


sub get_residue_line
{
    my ($line) = @_;
    #print "getting info for $line\n";

    my %info;
    
    $line =~ /(\d+)(\w)-([\w\d]+)\s+(.+)/;
    
    $info{'residue'} = $1;
    $info{'residue name'} = $2;
    $info{'atom'} = $3;

    if ($info{'atom'} =~ /HA/i)
    {
	$info{'atom'} = 'HA';
    }
    
    #print "get_residue_line: residue = $1, and residue_name is $2\n";
    
    return (%info);
}


sub get_assOrders
{
    my ($dir, $parent) = @_;

    unless (opendir(DIR, $dir))
    {
	&err_msg("Cannot open directory $dir", $parent);
	return;
    }

    my (@files) = grep {/_assOrder$/i} readdir(DIR);

    my $i;
    for ($i = 0; $i<=$#files; $i++)
    {
	$files[$i] = File::Spec->rel2abs($files[$i], $dir);
    }

    return (@files);
}



return 1;
