my %aa_3to1 = (
    "ALA"=>"A",
    "ARG"=>"R",
    "ASN"=>"N",
    "ASP"=>"D",
    "CYS"=>"C",
    "GLN"=>"Q",
    "GLU"=>"E",
    "GLY"=>"G",
    "HIS"=>"H",
    "ILE"=>"I",
    "LEU"=>"L",
    "LYS"=>"K",
    "MET"=>"M",
    "PHE"=>"F",
    "PRO"=>"P",
    "SER"=>"S",
    "THR"=>"T",
    "TRP"=>"W",
    "TYR"=>"Y",
    "VAL"=>"V"
	  );

my %aa_1to3 = reverse %aa_3to1;

sub parse_atom_nom
{
    my ($tbl) = @_;

    unless (open(FILE, $tbl))
    {
	print "Cannot open table $tbl\n";
	return;
    }

    my $line;
    my %data;

    while (chomp($line = <FILE>))
    {
	my @info = split(/[\t\s]+/, $line);
	my $aa = $aa_1to3{$info[0]};
	
	unless ($info[2])
	{
	    $info[2] = $info[1];
	}
	unless ($info[3])
	{
	    $info[3] = $info[1];
	}

	$data{$aa}{'IUPAC,PDB'}{$info[1]} = $info[2];
	$data{$aa}{'IUPAC,XPLOR'}{$info[1]} = $info[3];
	$data{$aa}{'PDB,IUPAC'}{$info[2]} = $info[1];
	$data{$aa}{'PDB,XPLOR'}{$info[2]} = $info[3];
	$data{$aa}{'XPLOR,IUPAC'}{$info[3]} = $info[1];
	$data{$aa}{'XPLOR,PDB'}{$info[3]} = $info[2];
    }

    close(FILE);
    return (\%data);

}
