sub parse_match
{

    #given a filename, and a peak line, returns an array with all the atom lines contained all possible assignments of the peak

    my ($file, $peak, $parent) = @_;

    $peak =~ s/- //;
    $peak =~ /(peak:\s+.+\(label\))/;
    my $peak_info = $1;
    
    #print "$peak_info $file\n\n";
    
    unless (-e $file)
    {
	return;
    }
    
    unless (open(FILE, $file))
    {
	&err_msg("Cannot open match file \"$file\"", $parent);
	return;
    }
    
    my @data;
    my $line;
    my $data_count = 0;

    my $store_data = 0;

    while (chomp($line = <FILE>))
    {
	#print $line . "\n";
	if ($line =~ /^peak/)
	{
	    #print "$line\n";
	    $line =~ /(peak:\s+.+\(label\))/;
	    my $line_info = $1;
	    
	    #print $line_info . "\n";
	    if ($line_info eq $peak_info)
	    {
		$store_data = 1;
		$data[$data_count] = $line;
		$data_count++;
	    }
	    else
	    {
		$store_data = 0;
	    }
	}
	elsif (($line =~ /atom:/) or ($line =~ /assigned\sby/i))
	{
	    if ($store_data)
	    {
		#print "$line\n";
		$data[$data_count] = $line;
		$data_count++;
	    }
	}
	
    }

    return (\@data);

}



return 1;
