sub parse_unassign
{
    my ($file, $parent) = @_; 

#    print "unassign $file \n"; #debug 

    unless (-f $file)
    {
	print "unassign file does not exist\n";
	return;
    }

    unless (open(FILE, $file))
    {
	&err_msg("Cannot open unassign file \"$file\"", $parent);
	return;
    }


    my ($line, %data);
    my $data_count = 0;
    my $start_read = 0;
    my $next_line;
    my $cycle;

    my $code = ''; 
    while ($line = <FILE>)
    {
	chomp $line;

	#print "$line\n";  

	if ($line =~ /^\s*=+\s*$/)
	{
	    $code = 'peaklist';
	    next;
	}
	
	unless ($line =~ /^\s*$/)
	{
	    if ($code eq 'peaklist')
	    {
		#my (@items) = split(/ /, $line);
		#print "Cycle $items[0], Peaklist $items[1]\n";
		$data_count = 0;
		$cycle = $line;
		#print "parse_unassign: $cycle\n";
		$code = 'peak';
	    }
	    elsif ($code eq 'peak')
	    {
		$data{$cycle}[$data_count]{'peak'} = $line;
		$code = 'atom1';
	    }
	    elsif ($code eq 'atom1')
	    {
		$data{$cycle}[$data_count]{'atom1'} = $line;
		$code = 'atom2';
	    }
	    elsif ($code eq 'atom2')
	    {
		$data{$cycle}[$data_count]{'atom2'} = $line;
		$code = 'reason';
	    }
	    elsif ($code eq 'reason')
	    {
		if ($line =~ /^\#/)
		{
		    $data{$cycle}[$data_count]{'distance'} = $line;
		}
		else
		{
		    $data{$cycle}[$data_count]{'reason'} = $line;
		    $data_count++;
		    #$start_read = 0;
		    $code = 'peak';
		    next;
		}
	    }
	}	
    }

    #foreach my $d (keys %data)
    #{
#	print "$d\n"; #debug
#    }
    return (\%data);
}


return 1;
