sub prof_pred
{
    my ($parent) = @_;

    my $window = $parent->Toplevel(-title=>'PROF - Secondary Structure Prediction');
    
    my %data;
    
    my $lbl = $window->Label(-relief=>'sunken', -background=>'white', -text=>"PROF - Secondary Structure Prediction System, developed by M.Ouali and R.D.King\n( (c) 1999-2003)")
	->pack(-fill=>'x', -ipadx=>3, -ipady=>3);
    
    my $frm1 = $window->Frame()->pack();
    my $email_lbl = $frm1->Label(-text=>'Email : ')->pack(-side=>'left');
    my $email_ent = $frm1->Entry(-background=>'white', -textvariable=>\$data{'email'})->pack(-side=>'left');

    my $frm2 = $window->Frame()->pack();
    my $fasta_lbl = $frm2->Label(-text=>"Protein sequence in\nFASTA format")->pack(-side=>'left');
    my $fasta_txt_s = $frm2->Scrolled('Text', -scrollbars=>'e')->pack(-side=>'left');
    my $fasta_txt = $fasta_txt_s->Subwidget('text');
    $fasta_txt->configure(-background=>'white');
    
    my $frm3 = $window->Frame()->pack();

    my $sub_but = $frm3->Button(-text=>'Submit')->pack(-side=>'left', -padx=>10, -pady=>5, -ipadx=>3, -ipady=>3);
    my $cls_but = $frm3->Button(-text=>'Close', -command=>sub
				{
				    $window->destroy();
				})->pack(-side=>'left', -padx=>10, -pady=>5, -ipadx=>3, -ipady=>3);

    $sub_but->configure(-command=>sub
			{
			    $data{'protein'} = $fasta_txt->get('1.0', 'end');
			    if ($data{'email'} and $data{'protein'})
			    {
				&send_request(\%data, $window);
			    }
			    else
			    {
				&err_msg('Please enter both the email address and the protein sequence', $window);
			    }
			});

    my $msg = "After submitting your request to the PROF server, you will recieve an email containing the secondary structure prediction.\nSave the information in text format, and import the file in the 'Open AutoStructure Directory' interface or\ncopy and paste it into the text box provided";

    my $msg_lbl = $window->Label(-background=>'white', -relief=>'ridge', -borderwidth=>2, -text=>$msg)->pack(-fill=>'x', -padx=>3, -pady=>3, -ipadx=>3, -ipady=>3);
}


sub send_request
{
    my ($data_ref, $parent) = @_;

    my $ua = LWP::UserAgent->new();
    my $req = POST 'http://www.aber.ac.uk/cgi-bin/user/phiwww/get_prof_info', [email=>$data_ref->{'email'}, foutput=>0, sequence=>$data_ref->{'protein'}];

    my $response = $ua->request($req)->as_string;

    if ($response =~ /been\saccepted/)
    {
	&err_msg("Your request has been submitted!\nResults will be emailed to $data_ref->{'email'}\nThe PROF system was developed by M.Ouali and R.D.King\n( (c) 1999-2003)", $parent);
	return;
    }
    else
    {
	&err_msg("Error submitting request!!\nPlease recheck the format of your data or try after sometime", $parent);
	return;
    }

}



return 1;
