#!perl -w

use strict; 
#use POSIX;
use File::Spec; 
use File::Basename;  
use File::Temp qw / tempfile /;
use File::Copy;  

require "parse_pdb.pl"; 
#require "calc_distance.pl"; 
require "distance_query.pl";
require "OpenOutDir.pl";
require "parse_unassign.pl"; 
require "tools.pl"; 
require "openContFile.pl";
require "unassign_distance.pl"; 

#rmRun2(@ARGV);  #debug

sub rmRun2
{
    my ($root, $newdir, $cutoff) = @_; #$root - output dir
    my $win = ''; 
    my $unas_lbx;
    
    my $HOME = $ENV{'HOME'};
    
#print "$HOME\n"; 
    
    my ($unassign, $pdb, $assOrder_ref, $match_ref, $ec2) = &get_unassign($root, $win); 
    my ($un_data_ref) = &parse_unassign($unassign, $win); 
    my ($distances_ref) = &put_unassign_data($unas_lbx, $win, $un_data_ref, $unassign, $pdb, $assOrder_ref, $match_ref);
    #print "after put_unassign_data $root $newdir, $cutoff\n"; 
    
#	$lbx->insert('end', "Peaklist = $sorted_data[$i][0], Cycle = $sorted_data[$i][1]");
#	$lbx->insert('end', $sorted_data[$i][2]);
#	$lbx->insert('end', $sorted_data[$i][3]);
#	$lbx->insert('end', $sorted_data[$i][4]);
#	$lbx->insert('end', $sorted_data[$i][5]);
    
    my (@sorted_data) = @{$distances_ref};
    my (@assOrder) = @{$assOrder_ref}; 
    #my (@data) = @{$un_data_ref}; 

    my @violated; my %peaknames;  
    for (my $i = 0; $i < scalar(@sorted_data); $i++)
    {
	#my %distance = %{$sorted_data[$i][6]}; 
	my $distance = $sorted_data[$i][7];
	
#	print "$sorted_data[$i][0] $sorted_data[$i][1] $distance $sorted_data[$i][2]\n"; 

#	if (($distance{'mid'} > $cutoff) && ($sorted_data[$i][4] =~ /SYM|UNIQUE/)) 
	if ( #(($distance > 10.0) && ($sorted_data[$i][4] =~ /SYM|UNIQUE/)) ||
	    (($distance > $cutoff) && ($sorted_data[$i][4] =~ /SYM|UNIQUE/) && ($sorted_data[$i][1] =~/1-0/)))
	{
#	    my $plname = $sorted_data[$i][0]; 
#
#	    #next if assigned 
#	    my $assOrder_file; 
#	    my $j;
#            for ($j = 0; $j<=$#assOrder; $j++)
#            {
#                if ($assOrder[$j] =~ /.*$plname.*/)
#                {
#                    $assOrder_file = $assOrder[$j];
#                }
#            }
            
#            my ($peak_assigned) = &check_peak_assigned($data{$cycle}[$i]{'peak'}, $assOrder_file);

#	    my ($peak_assigned) = &check_peak_assigned($data{$i}[$in]{'peak'}, $assOrder_file); 
#            next if ($peak_assigned);

	    print "Violated peak: $sorted_data[$i][0] $sorted_data[$i][1] $sorted_data[$i][2] " . $distance . "\n"; 
	    push @violated, $sorted_data[$i]; 
	    $peaknames{$sorted_data[$i][0]}++; 
	}
    }

    if (scalar(@violated)) #noe
    {
	#unless (mkdir($root . "/input2", 0750)) {
	#    die "Unable to create folder. Error: $!\n"; 
	#}

	my $total = 0; 
	foreach my $pn (keys %peaknames)
	{
	    #print "gunzip $root/source/$pn\.gz\n"; 
	    system('gunzip', "$root/source/$pn\.gz") or warn "$!\n"; 
	}
	foreach my $pn (keys %peaknames)
	{
	    open(PO, "<$root/source/$pn"); 
	    my @peaks  = <PO>; 
	    
	    for(my $line=0; $line < scalar(@peaks); $line++)
	    {
		#print "peaks: $peaks[$line]\n"; 
		foreach my $v_ref (@violated) # comment out the violated one 
		{
		    my @v = @{$v_ref}; 
		    my $vpn = $v[0];
		    #print "vpn $vpn\n"; 
		    next if ($vpn ne $pn); 
		    #print "$v[2]\n"; 

		    my($hx1) = $v[2] =~ /\(hx1\)(-?\d+\.?\d+)/;
		    my($hx2) = $v[2] =~ /\(hx2\)(-?\d+\.?\d+)/;
		    my($x1) = $v[2] =~ /\(x1\)(-?\d+\.?\d+)/;
		    my($x2) = $v[2] =~ /\(x2\)(-?\d+\.?\d+)/;
		    my ($intensity) = $v[2] =~ /\s+(-?\d+\.?\d+)\s+\(label/;
		    
		    my @as = (); 
		    push @as, $hx1 if ($hx1); 
		    push @as, $hx2 if ($hx2); 
		    push @as, $x1 if ($x1); 
		    push @as, $x2 if ($x2); 
		    push @as, $intensity if ($intensity); 

		    my @as_sorted = sort {$a<=>$b} (@as);

		    #foreach my $p (@as_sorted)
		    #{
			#print "$p\n"; 
		    #}

		    #print "$hx1, $hx2, $x1, $x2, $intensity\n";
		    #print "$peaks[$line]"; 
		    my (@peakRaw) = $peaks[$line] =~ /([-\d\.e\+]+)/gm;
		    my (@peakFiltered); 
		    foreach my $p (@peakRaw)
		    {
			#print "$p\n"; 
			push @peakFiltered, $p if ($p =~/\d/); 
		    }
		    my @peaks_sorted = sort {$a<=>$b} (@peakFiltered);

		    #foreach my $p (@peaks)
		    #{
			#print "$p\n"; 
		    #}

		    my $pi = 0; my $match = 0;  
		    for(my $ai=0; $ai < scalar(@as_sorted); $ai++)
		    { 
			#print "ai $ai $as_sorted[$ai]\n"; #from as
			while ($pi < scalar(@peaks_sorted))
			{
			    if ($peaks_sorted[$pi] =~ /\d/)
			    {
				#print "pi $pi $peaks_sorted[$pi]\n"; #raw
				if ($peaks_sorted[$pi] == $as_sorted[$ai])
				{
				    $match++;
				    #print "match $match\n"; 
				    last; 
				}
			    }
			    $pi++; 
			}
		    }

		    if ($match >= scalar(@as_sorted))
		    {
			$peaks[$line] = "#" . $peaks[$line];
			print "$peaks[$line]"; 
			$total++; 
			last; 
		    }
		}
	    }

	    open(PN, ">$newdir/$pn\_2"); 
	    foreach my $pp (@peaks)
	    {
		print PN $pp; 
	    }
	}

	print "Found " . scalar(@violated) . " violated, commented out $total.\n"; 
	#return \%peaknames; 
    } else
    {
	print "No violation found\n"; 
	#return 0; 
    }
    
    if ((scalar(keys %peaknames) > 0))
    {
	return (\%peaknames);
    } else
    {
	return 0; 
    }
}
