#!perl -w

use strict; 
#use POSIX;
use File::Spec; 
use File::Basename;  
use File::Temp qw / tempfile /;
use File::Copy;  

require "parse_pdb.pl"; 
#require "calc_distance.pl"; 
require "distance_query.pl";
require "OpenOutDir.pl";
require "parse_unassign.pl"; 
require "tools.pl"; 
require "openContFile.pl";
require "unassign_distance.pl"; 

#rmRun2(@ARGV);  #debug

sub rmRun2
{
    my ($root, $newdir, $cutoff, $debug) = @_; #$root - output dir
    
#$debug = 1; 

    my $win = ''; 
    my $unas_lbx;
    
    my $HOME = $ENV{'HOME'};
    
#print "$HOME\n"; 
    
    my ($unassign, $pdb, $assOrder_ref, $match_ref, $ec, $ec2) = &get_unassign($root, $win); 

if (!(defined $pdb))
{
	print "No pdb file found\n"; 
	return 0; 
}

    my ($un_data_ref) = &parse_unassign($unassign, $win); 
    my ($distances_ref) = &put_unassign_data($unas_lbx, $win, $un_data_ref, $unassign, $pdb, $assOrder_ref, $match_ref);
    #print "after put_unassign_data $root $newdir, $cutoff\n"; 
    
#	$lbx->insert('end', "Peaklist = $sorted_data[$i][0], Cycle = $sorted_data[$i][1]");
#	$lbx->insert('end', $sorted_data[$i][2]);
#	$lbx->insert('end', $sorted_data[$i][3]);
#	$lbx->insert('end', $sorted_data[$i][4]);
#	$lbx->insert('end', $sorted_data[$i][5]);
    
    my (@sorted_data) = @{$distances_ref};

    my @violated; my %peaknames;
    my $total = 0; my $ecC = 0;   
    for (my $i = 0; $i < scalar(@sorted_data); $i++)
    {
	#my %distance = %{$sorted_data[$i][6]}; 
	my $distance = $sorted_data[$i][7];
	
#	print "$sorted_data[$i][0] $sorted_data[$i][1] $distance $sorted_data[$i][2]\n"; 

#	if (($distance{'mid'} > $cutoff) && ($sorted_data[$i][4] =~ /SYM|UNIQUE/)) 
	if (($distance > $cutoff) && ($sorted_data[$i][4] =~ /SYM|UNIQUE/) && ($sorted_data[$i][1] =~/1-0/))
	{
	    print "Violated peak: $sorted_data[$i][0] $sorted_data[$i][1] $sorted_data[$i][2] " . $distance . "\n"; 
	    push @violated, $sorted_data[$i]; 
	    $peaknames{$sorted_data[$i][0]}++; 
	}
    }

    if (scalar(@violated)) #noe
    {
	#unless (mkdir($root . "/input2", 0750)) {
	#    die "Unable to create folder. Error: $!\n"; 
	#}

	foreach my $pn (keys %peaknames)
	{
	    #print "gunzip $root/source/$pn\.gz\n"; 
	    system('gunzip', "$root/source/$pn\.gz") or warn "$!\n"; 
	}
	foreach my $pn (keys %peaknames)
	{
	    open(PO, "<$root/source/$pn"); 
	    my @peaks  = <PO>; 
	    
	    for(my $line=0; $line < scalar(@peaks); $line++)
	    {
		print "$peaks[$line]\n" if ($debug);  
		foreach my $v_ref (@violated) # comment out the violated one 
		{
		    my @v = @{$v_ref}; 
		    my $vpn = $v[0];
		    #print "vpn $vpn\n"; 
		    next if ($vpn ne $pn); 
		    #print "$v[2]\n"; 

		    my($hx1) = $v[2] =~ /\(hx1\)(-?\d+\.?\d+)/;
		    my($hx2) = $v[2] =~ /\(hx2\)(-?\d+\.?\d+)/;
		    my($x1) = $v[2] =~ /\(x1\)(-?\d+\.?\d+)/;
		    my($x2) = $v[2] =~ /\(x2\)(-?\d+\.?\d+)/;
		    my ($intensity) = $v[2] =~ /\s+(-?\d+\.?\d+)\s+\(label/;
		    
		    my @as = (); 
		    push @as, $hx1 if ($hx1); 
		    push @as, $hx2 if ($hx2); 
		    push @as, $x1 if ($x1); 
		    push @as, $x2 if ($x2); 
		    push @as, $intensity if ($intensity); 

		    my @as_sorted = sort{$a <=>$b}(@as);

		    #foreach my $p (@as_sorted)
		    #{
			#print "$p\n"; 
		    #}

		    #print "$hx1, $hx2, $x1, $x2, $intensity\n";
		    #print "$peaks[$line]";
 
		    #$peaks[$line] =~ s/\s+e\s+//gm;

		    my $orig_peak = $peaks[$line]; 
		    $orig_peak =~ s/\s+e\s+//gm; 
		    print "orig $orig_peak\n" if ($debug); 
 
		    #$peaks[$line] =~ s/ U //gm; 
		    my (@peakRaw) = $orig_peak =~ /(-*\d[\d\.e\+]*)/gm;
		    foreach my $p (@peakRaw)
		    {
			print "peak Raw $p\n" if ($debug); 
		    }
		    my @peaks_sorted = sort {$a<=>$b}(@peakRaw);

		    #foreach my $p (@peaks)
		    #{
			#print "$p\n"; 
		    #}

		    my $pi = 0; my $match = 0;  
		    for(my $ai=0; $ai < scalar(@as_sorted); $ai++)
		    { 
			print "test ai $ai $as_sorted[$ai]\n" if ($debug); #from as
			while ($pi < scalar(@peaks_sorted))
			{
			    if ($peaks_sorted[$pi] =~ /\d/)
			    {
				print "pi $pi $peaks_sorted[$pi]\n" if ($debug); #raw
				if ($peaks_sorted[$pi] == $as_sorted[$ai])
				{
				    $match++;
				    print "match $match\n" if ($debug); 
				    last; 
				}
			    }
			    $pi++; 
			}
		    }

		    if ($match >= scalar(@as_sorted))
		    {
			$peaks[$line] = "#" . $peaks[$line];
			print "$peaks[$line]"; 
			$total++; 
			last; 
		    }
		}
	    }

	    open(PN, ">$newdir/$pn\_2"); 
	    foreach my $pp (@peaks)
	    {
		print PN $pp; 
	    }
	}

	print "Found " . scalar(@violated) . " violated, commented out $total.\n"; 
	#return \%peaknames; 
    } else
    {
	print "No peak violation found\n"; 
	#return 0; 
    }

    #ec 
    #$pdb at the final cycle

    my %atom; 
    open(PDB, "<$pdb"); 
    my $model= 0; 
    
    while (<PDB>)
    {
	chomp;
	if ($_ =~ /MODEL/)
	{
	    $model++; 
	}
	next if ($_ !~ /^ATOM/); 
	my ($atomName, $res, $x, $y, $z) = $_ =~ /ATOM\s+\d+\s*([\w\d]+)\s*\w+\s*A\s*(\d+)\s+(-*\d+\.\d+)\s*(-*\d+\.\d+)\s*(-*\d+\.\d+)/;
	$atom{$res}{$atomName}{$model} = $x . "/" . $y . "/" . $z; 
	#print "$atomName-$res-$model-$x-$y-$z\n";
    }

    #$ec2 at the cycle2
    my @final; 

if ($ec && $ec2)
{
    open(FINAL, "<$ec2"); 
    
    while (<FINAL>)
    {
	chomp;
	my ($a, $b, $dmin, $dmax, $w, $s) = split(/\s+/, $_); 
	if ($b < $a)
	{
	    my $c = $b; 
	    $b = $a; 
	    $a = $c; 
	}
	push @final, "$a-$b-$dmin-$dmax"; 
	#print "ec2 $a-$b\n"; 
    }
    
    #print "ec2\n"; 

    my $finalEC = ";" . join(";", @final) . ";"; 
    
    #$ec in the source
    #open(PO, "<$root/source/$ec"); 

    my @table; 
    my @toDelete;
    my %score; 
    #if ($ec =~ /\w/)
    #{
	print "ec $ec\n"; 

	system('gunzip', "$root/source/$ec\.gz") or warn "$!\n";
	open(TABLE, "<$root/source/$ec");
    
    while (<TABLE>)
    {
	chomp; 
	$_ =~ s/^\s+//g; 
	next if ($_ !~ /\d/); 
	my ($a, $b, $dmin, $dmax, $s) = split(/\s+/, $_); 
	if ($b < $a)
	{
	    my $c = $b; 
	    $b = $a; 
	    $a = $c; 
	}
	
	if ($finalEC !~ /;$a\-$b\-$dmin\-$dmax;/)
	{
	    push @toDelete, "$a-$b-$dmin-$dmax";
	    #print "delete $a-$b\n"; 
	}
	
	push @table, "$a-$b-$dmin-$dmax"; 
	$score{"$a-$b-$dmin-$dmax"} = $s;

	#print "ec $a-$b $s\n"; 
    }

    #print "$ec\n"; 

    my $ecinput = ";" . join(";", @table) . ";"; 

    foreach my $pair (@toDelete)
    {
	my ($a1, $a2, $dmin, $dmax) = split(/-/, $pair); 
	
	next if ($a1 eq $a2);
	next if ($a2 < $a1); 
	
	#print "to delete $a1-$a2\n";

#    next if (abs($a2-$a1) < 5); 
#    next if ($ec !~ /;$a1-$a2;/); 
	
#	my ($num1, $name1) = split(/-/, $a1); 
#	my ($num2, $name2) = split(/-/, $a2); 
	
#	next if (abs($num1 - $num2) < 5); 
#	next if ($name1 !~ /^C/); 
#	next if ($name2 !~ /^C/); 
	
	#next if (($num1 != 2) && ($num1 !=104)); 
	#next if (($num2 != 2) && ($num2 != 104));  

	my $dismin = 100000; 
	
	foreach my $n1 (sort keys %{$atom{$a1}})
	{
	    foreach my $n2 (sort keys %{$atom{$a2}})
	    {
		
		#print "$num1-$name1, $num2-$name2\n"; 
		#print "$a1-$n1, $a2-$n2 $dismin\n"; 
		
		for(my $i = 1; $i <= $model; $i++)
		{
		    my ($x1, $y1, $z1) = split(/\//, $atom{$a1}{$n1}{$i});
		    my ($x2, $y2, $z2) = split(/\//, $atom{$a2}{$n2}{$i}); 
		    my $dist = sqrt(($x1-$x2)**2+($y1-$y2)**2+($z1-$z2)**2); 
		    $dismin = $dist if ($dist < $dismin); 
		    #print "$i $atom{$a1}{$n1}{$i} $atom{$a2}{$n2}{$i} $dist  $dismin\n" if ($dist < 5.00001); 
		}
		
	    }
	}
	
#	print "AmbigousNMRDistance\t$name1\t$num1\t$name2\t$num2\tBOUNDED\t1.80\t7.0\t0.3\tNOE\n" if (($dismax < 5.00001) && ($ec =~ /\/$pair\//)); 
	if (($dismin > $cutoff))
	{
	    $ecC++; 
	    $score{"$a1-$a2-$dmin-$dmax"} = -1; 
	    print "Violated EC: $a1-$a2 $dismin\n"; 
	}
    }

    #write to the rawec_2
    if ($ecC)
    { 
	open(EC2, ">$newdir/$ec\_2"); 
	foreach my $i (@table)
	{
	    my ($a, $b, $dmin, $dmax) = split(/-/, $i); 
	    print EC2 "$a\t$b\t$dmin\t$dmax\t$score{$i}\n"; 
	}
	print "Found $ecC EC violated\n"; 
    }
}    
    if ((scalar(keys %peaknames) > 0) || ($ecC))
    {
        if (($ecC) && (scalar(keys %peaknames) > 0))
        {
                return (\%peaknames, $ec);
        } elsif (!$ecC)
        {
                return (\%peaknames, 0);
        } else
        {
                return (0, $ec);
        }
    } else
    {
	return 0; 
    }
}
