my $nb_bg = '#D1E2Ef';
my $nb_back = '#78A1BF';


sub rpf_scores_frame
{
    my ($frame, $data, $pklsts_fnames, $parent) = @_;

    unless ($frame)
    {
	&err_msg("Frame does not exist", $parent);
	return;
    }
    
    my $but_frm = $frame->Frame(-background=>$nb_back)->pack(-padx=>5, -pady=>5);

    my $ql_but = $but_frm->Button(-text=>'Show False Positive Interactions')->pack(-side=>'left', -padx=>10);
    my $qi_but = $but_frm->Button(-text=>'Show False Negetive Interactions')->pack(-side=>'left', -padx=>10);

    my $nb = $frame->NoteBook(-backpagecolor=>$nb_back, -background=>$nb_bg, -inactivebackground=>'#517FA2')->pack(-fill=>'both', -expand=>1, -padx=>2, -pady=>2);
    
    my %fpd_but;
    
    #Summary page
    my $fin_pg = $nb->add('Final', -label=>'Summary(Multi-Models)');
    $fin_pg->configure(-background=>$nb_bg);

    my $fin_msc = $data->{'final'}{'m-score'};
    my $fin_dp = $data->{'model'}{'ave'}{'dp-score'}{'input query structures'};

    my $msr_lbl = $fin_pg->Label(-text=>"Final m-score: $fin_msc", -background=>$nb_bg)->pack(-side=>'top');
    

    my $fin_frm = $fin_pg->Frame(-relief=>'ridge', -borderwidth=>2, -background=>$nb_bg)->pack(-padx=>10, -pady=>10);
    #create a table
    my $table = $fin_frm->Table(
				-rows=>4,
				-columns=>4,
				-fixedrows=>1,
				-relief=>'flat',
				-scrollbars=>'',
				-background=>$nb_bg
				)->pack(-side=>'top', -fill=>'both', -expand=>1);

    
    

    #table headings
    my $i = 0;

    foreach ('Score type', 'Query', 'Freely Rotating', 'Ideal')
    {
	my $lbl = $table->Label(-relief=>'raised', -text=>$_, -width=>21, -height=>1, -background=>$nb_back);
	$table->put(0, $i, $lbl);
	$i++;
    }

    $i = 1;
    foreach ('Recall', 'Precision', 'F-measure')
    {
	my $lbl = $table->Label(-background=>'white', -text=>$_);
	$table->put($i, 0, $lbl);
	$i++;
    }
    
    $i = 1;
    $j = 1;

    foreach $row ('Recall-score', 'Precision-score', 'F-score')
    {
	$j = 1;
	foreach $col ('input query structures', 'freely-rotating-chain model', 'ideal true structures')
	{
	    
	    my $lbl = $table->Label(-background=>'white', -text=>${$data->{'model'}{'ave'}}{$row}{$col});
	    $table->put($i, $j, $lbl);
	    $j++;
	}
	$i++;
    }


    my $dp_lbl = $fin_pg->Label(-text=>"Final dp-score(midrange distances): $fin_dp", -background=>$nb_bg)->pack();

    $fpd_but{'summary'} = $fin_pg->Button(-text=>'False Positive Distribution - Summary')->pack();
    
    my $pl;
    my $pl_num = 1;

    #add a 'single model' tab
    my $m_pg = $nb->add('model', -label=>'Single-Models');
    $m_pg->configure(-background=>$nb_bg);
    
    my $m_frm = $m_pg->Frame(-relief=>'ridge', -borderwidth=>2, -background=>$nb_bg)->pack(-padx=>10, -pady=>10);

    #create a table
    my $rowNum = keys %{$data->{'model'}};
    #print $rowNum;

    my $table = $m_frm->Table(
				-rows=>$rowNum, #number of models
				-columns=>5,
				-fixedrows=>1,
				-relief=>'flat',
				-scrollbars=>'',
				-background=>$nb_bg
				)->pack(-side=>'top', -fill=>'both', -expand=>1);

    #table headings
    $i = 0;
    foreach ('Model #', 'Recall', 'Precision', 'F-measure', 'DP')
    {
	my $lbl = $table->Label(-relief=>'raised', -text=>$_, -width=>21, -height=>1, -background=>$nb_back);
	$table->put(0, $i, $lbl);
	$i++;
    }

    $i = 1;
    foreach (sort {$a<=>$b} keys %{$data->{'model'}})
    {
	next if ($_ eq 'ave'); 
	my $lbl = $table->Label(-background=>'white', -text=>$_);
	$table->put($i, 0, $lbl);
	$i++;
    }
    
    $i = 1;
    $j = 1;
    my $dpsum = 0; 
    foreach $row (sort {$a<=>$b} keys %{$data->{'model'}})
    {
	next if ($row eq 'ave'); 
	$j = 1;
	foreach $col ('Recall-score', 'Precision-score', 'F-score', 'dp-score')
	{ 
	    my $lbl = $table->Label(-background=>'white', -text=>$data->{'model'}{$row}{$col}{'input query structures'});
	    $table->put($i, $j, $lbl);
	    $j++;

	    if ($col eq 'dp-score')
	    {
		$dpsum += $data->{'model'}{$row}{$col}{'input query structures'};
	    }
	}
	$i++;
    }

    #print $rowNum . " " . $dpsum . "\n";
    $rowNum++ if ($rowNum == 1); 
    my $adp = $dpsum/($rowNum-1); 
    my $str = sprintf("%.3f", $adp);
    my $dp_lbl = $m_pg->Label(-text=>"Average dp-score(single): " . $str, -background=>$nb_bg)->pack();

    #Add one page for each peaklist
    foreach $pl (@$pklsts_fnames)
    {
	next unless $pl;

	my $pl_pg = $nb->add($pl, -label=>"Peaklist $pl_num");
	$pl_pg->configure(-background=>$nb_bg);

	my $pl_lbl = $pl_pg->Label(-text=>"Peaklist FileName: $pl", -background=>$nb_bg)->pack(-side=>'top');

	my $mscr = ${$data->{$pl}}{'M-score'};
	my $mscr_lbl = $pl_pg->Label(-text=>"M-Score = $mscr", -background=>$nb_bg)->pack(-side=>'top');

	#summary lines
	my $sum_txt = ${$data->{$pl}}{'summary'}[0]."\n".${$data->{$pl}}{'summary'}[1]."\n".${$data->{$pl}}{'summary'}[2];
	my $sum_lbl = $pl_pg->Label(-text=>$sum_txt, -relief=>'ridge', -borderwidth=>2, -background=>'white')->pack(-side=>'top', -ipadx=>1, -ipady=>1, -padx=>2, -pady=>2);

	my $tbl_frm = $pl_pg->Frame(-relief=>'ridge', -borderwidth=>2, -background=>$nb_bg)->pack(-side=>'top', -padx=>2, -pady=>2);

	my $pl_table = $tbl_frm->Table(
				       -rows=>4,
				       -columns=>4,
				       -fixedrows=>1,
				       -borderwidth=>3,
				       -relief=>'flat',
				       -scrollbars=>'',
				       -background=>$nb_bg
				       )->pack(-side=>'top',-fill=>'both', -expand=>1);
	
	my $k = 0;
	my $title;
	foreach ('Score type', 'Query', 'Freely Rotating', 'Ideal')
	{
	    my $pl_lbl = $pl_table->Label(-relief=>'raised', -text=>$_, -width=>21, -height=>1, -background=>$nb_back);
	    $pl_table->put(0, $k, $pl_lbl);
	    $k++;
	}
	
	&create_lbl($pl_table, 'Recall', 1, 0);
	&create_lbl($pl_table, 'Precision', 2, 0);
	&create_lbl($pl_table, 'F-measure', 3, 0);

	&create_lbl($pl_table, ${$data->{$pl}}{'query'}{'recall'}, 1, 1);
	&create_lbl($pl_table, ${$data->{$pl}}{'freely'}{'recall'}, 1, 2);
	&create_lbl($pl_table, '1', 1, 3);


	#calculate precision
	my $f_score = ${$data->{$pl}}{'query'}{'F-measure'}{'F-measure:(0,PrecisionIdealW)'};
	my $precision = ($f_score)/(2 - $f_score);
	$precision = sprintf("%0.3f", $precision);
	
	&create_lbl($pl_table, ${$data->{$pl}}{'query'}{'precision'}{'allw'}, 2, 1);
	&create_lbl($pl_table, ${$data->{$pl}}{'freely'}{'precision'}{'allw'}, 2, 2);
	&create_lbl($pl_table, $precision, 2, 3);

	&create_lbl($pl_table, ${$data->{$pl}}{'query'}{'F-measure'}{'F-measure:(Recall,PrecisionW)'}, 3, 1);
	&create_lbl($pl_table, ${$data->{$pl}}{'freely'}{'F-measure'}{'F-measure:(ReallFree,PrecisionFreeW)'}, 3, 2);
	&create_lbl($pl_table, ${$data->{$pl}}{'query'}{'F-measure'}{'F-measure:(0,PrecisionIdealW)'}, 3, 3);

	my $fname = $pl;
	$fpd_but{$pl} = $pl_pg->Button(-text=>'False Positive Distribution of this peaklist')->pack;
	
	$pl_num++;
    }

   
    #add a 'Missing atoms' tab
    my $not_pg = $nb->add('Notes', -label=>'Missing Atoms');
    $not_pg->configure(-background=>$nb_bg);
    
    my $txt_area = $not_pg->Scrolled('Text', -scrollbars=>'e', -background=>'white', -height=>10)->pack(-fill=>'x', -expand=>1, -padx=>3, -pady=>5);
    my $txt = $txt_area->Subwidget('text');
    
    return (\%fpd_but, $ql_but, $qi_but, $nb, $txt);
    
}



sub create_lbl
{
    my ($table, $txt, $row, $col) = @_;

    my $lbl = $table->Label(-background=>'white', -text=>$txt);
    $table->put($row, $col, $lbl);
}



return 1;
