sub place_sheets
{
    my ($canvas, $x, $y, $y_div, $data_ref, $help_ref, $parent, $dir, $key) = @_;

    # %data is from the .sec file that was parsed
    my %data = %$data_ref;

    #my $count = scalar(@{$data{$key}});
    #my @sheets;
    #my %sheet_info;
    #my %sheet_count;
    #print "$key registers = $count\n";

    #print "key is $key\n";

    my %undrawn_registers;
    my $i;
    my $cur_reg;
    for ($i = 0; $i<scalar(@{$data{$key}}); $i++)
    {
		$undrawn_registers{$data{$key}[$i]} = 1;
    }
    
    my @undrawn = keys %undrawn_registers;
    my %missing;
   
    
    #groups of strands to draw together are identified here

    foreach $cur_reg (sort {$a <=> $b} keys %undrawn_registers)
    {
		next unless ($undrawn_registers{$cur_reg});
		#next if ($cur_reg =~ /38/);
		@undrawn = keys %undrawn_registers;
		print "############################################\n";
		print "1. undrawn are @undrawn, cur_reg is $cur_reg\n";
	
		my @drawn_registers;
		my @drawn_sheets;
		my $sheet_count = 2;
		my $reg_count = 0;
		my $new_sheets_added = 0;
	
		@drawn_registers[$reg_count] = $cur_reg;
		$reg_count++;

		#remove from undrawn
		delete($undrawn_registers{$cur_reg});

		#get sheets[0] and [1] for cur_reg
		my ($cur_res1, $cur_res2) = &get_res($cur_reg);


		# get_sheet returns the strand range that the residue belongs to
		$drawn_sheets[0] = &get_sheet($data_ref, $cur_res1, 'Final');
		$drawn_sheets[1] = &get_sheet($data_ref, $cur_res2, 'Final');
		$new_sheets_added = 1;

		print "2. Register: $cur_reg, belonging to sheets $drawn_sheets[0] and $drawn_sheets[1]\n";
		print "\t compare against all undrawn registers\n";
	
		#foreach $rest_reg (keys %undrawn_registers)
		for (my $i = 0; $i <= scalar keys %undrawn_registers; $i++) {
			my @keys = keys(%undrawn_registers);
			$rest_reg = $keys[$i];
			next if (&beta_bulge($rest_reg, \@drawn_registers));
			print "no beta bulge, not skipping\n";
			my ($temp_res1, $temp_res2) = &get_res($rest_reg);

			print "registers remaining to be examined: @keys\n";
			print "3a. number $i register is $rest_reg, checking whether part of drawnsheets @drawn_sheets (num = $#drawn_sheets)\n";
			my $temp_sh;
			for ($temp_sh = 0; $temp_sh <= $#drawn_sheets; $temp_sh++) {
				print "3b1. checking if register $rest_reg matches sheet $drawn_sheets[$temp_sh]  (all sheets are @drawn_sheets)\n";
				if ((&get_sheet($data_ref, $temp_res1, 'Final')) eq $drawn_sheets[$temp_sh]) {
					print "\t register $rest_reg matched sheet $drawn_sheets[$temp_sh]\n";
					my ($drawn_sheet_reg1, $drawn_sheet_reg2) = &get_res($drawn_sheets[$temp_sh]);
					my ($reg1, $reg2) = &get_res($drawn_sheets[$temp_sh + 1]);
					print "neighbour sheet below with registers $reg1 and $reg2\n";
					#next if ($reg1 and $reg2 and (($temp_res2 <= $drawn_sheet_reg1 and $reg1 <= $drawn_sheet_reg1) or ($temp_res2 >= $drawn_sheet_reg1 and $reg1 >= $drawn_sheet_reg1)));
					my ($reg1, $reg2) = &get_res($drawn_sheets[$temp_sh - 1]);
					print "neighbour sheet above with registers $reg1 and $reg2\n";
					#next if ($reg1 and $reg2 and (($temp_res2 <= $drawn_sheet_reg1 and $reg1 <= $drawn_sheet_reg1) or ($temp_res2 >= $drawn_sheet_reg1 and $reg1 >= $drawn_sheet_reg1)));
					if ($temp_sh == 0) {
						print "adding to top\n";
						unshift(@drawn_registers, $rest_reg);
						unshift(@drawn_sheets, &get_sheet($data_ref, $temp_res2, 'Final'));
					} else {
						print "adding to bottom\n";
						push(@drawn_registers, $rest_reg);
						push(@drawn_sheets, &get_sheet($data_ref, $temp_res2, 'Final'));

					}
					print "3b2. $temp_res1 belongs to sheet $drawn_sheets[$temp_sh]\n";
					print "3b3. adding register $rest_reg to drawn_registers at $reg_count\n";
					$reg_count++;
					delete($undrawn_registers{$rest_reg});
				
					#$drawn_sheets[$sheet_count] = &get_sheet($data_ref, $temp_res2, 'Final');
					$sheet_count++;
					$new_sheets_added = 1;
					#print "MATCH FOUND FOR $rest_reg\n";
					$i = -1;
					last;
				}
				elsif ((&get_sheet($data_ref, $temp_res2, 'Final')) eq $drawn_sheets[$temp_sh]) {
					print "register $rest_reg matched sheet $drawn_sheets[$temp_sh]\n";
						my ($reg1, $reg2) = &get_res($drawn_sheets[$temp_sh + 1]);
						print "neighbour sheet below with registers $reg1 and $reg2\n";
						#next if ($reg1 and $reg2 and (($temp_res1 <= $drawn_sheet_reg1 and $reg1 <= $drawn_sheet_reg1) or ($temp_res1 >= $drawn_sheet_reg1 and $reg1 >= $drawn_sheet_reg1)));
						($reg1, $reg2) = &get_res($drawn_sheets[$temp_sh - 1]);
						print "neighbour sheet above with registers $reg1 and $reg2\n";
						#next if ($reg1 and $reg2 and (($temp_res1 <= $drawn_sheet_reg1 and $reg1 <= $drawn_sheet_reg1) or ($temp_res1 >= $drawn_sheet_reg1 and $reg1 >= $drawn_sheet_reg1)));
						#print "not skipping\n";
					if ($temp_sh == 0) {
						#print "adding to top\n";
						unshift(@drawn_registers, $rest_reg);
						unshift(@drawn_sheets, &get_sheet($data_ref, $temp_res1, 'Final'));
					} else {
						#print "adding to bottom\n";
						push(@drawn_registers, $rest_reg);
						push(@drawn_sheets, &get_sheet($data_ref, $temp_res1, 'Final'));
					}

					print "3b2. $temp_res2 belongs to sheet $drawn_sheets[$temp_sh]\n";
					#@drawn_registers[$reg_count] = $rest_reg
					print "3b3. adding register $rest_reg to drawn_registers at $reg_count\n";
					$reg_count++;
					delete($undrawn_registers{$rest_reg});
				
					#$drawn_sheets[$sheet_count] = &get_sheet($data_ref, $temp_res1, 'Final');
					$sheet_count++;
					$new_sheets_added = 1;
					#print "MATCH FOUND FOR $rest_reg\n";
					$i = -1;
					last;
				} else {
					print "NO MATCH FOUND FOR $rest_reg\n";
				}
			}
			@undrawn = keys %undrawn_registers;
			print "3b. done checking all sheets, new sheets list is @drawn_sheets, remaining undrawn_registers are @undrawn\n";
			print "** drawn registers: @drawn_registers\n";

			#($x, $y) = &place_anti_sheets($canvas, $x, $y, \@drawn_sheets, \@drawn_registers, $data_ref, $help_ref);
		}

		@undrawn = keys %undrawn_registers;
		#draw sheets
		#print "Sheets list is @drawn_sheets ($#drawn_sheets); Registers are @drawn_registers (remainging undrawn are @undrawn)\n\n";
		#$y+= $y_div * ($#drawn_sheets+1) + $y_div;
	
		my $sub_canvas = $canvas->Canvas(-background=>'white', -borderwidth=>2);
		$canvas->createWindow($x, $y, -window=>$sub_canvas, -anchor=>'nw');

		#print "place_sheets: sub_canvas created at ($x, $y)\n";

		my ($ax, $ay) = (100, 0);
		my $ht;
		my $stats_ref;

		# @drawn_sheets is an array of strands that need to be drawn together as a sheet, @drawn_registers is the array of registers between these strands

		if ($key eq 'Antiparallel')
		{
			($ht, $stats_ref) = &place_anti_sheets($sub_canvas, $ax, $ay, \@drawn_sheets, \@drawn_registers, $data_ref, $help_ref, 'Final');
			($res_ref) = &place_anti_bg($sub_canvas, \@drawn_sheets, \@drawn_registers, $stats_ref, $data_ref, $dir, $parent, $help_ref, 'Final', \%missing);
			
		}
		else
		{
			($ht, $stats_ref) = &place_para_sheets($sub_canvas, $ax, $ay, \@drawn_sheets, \@drawn_registers, $data_ref, $help_ref, 'Final');
			($res_ref) = &place_para_bg($sub_canvas, \@drawn_sheets, \@drawn_registers, $stats_ref, $data_ref, $dir, $parent, $help_ref, 'Final', \%missing);
			
		}
	
		$y += ($ht + $y_div);
    }
    
    #print "place_sheets - end\n";
    
    return($x, $y, \%missing, $res_ref);
}

sub change_para_up
{
    my ($up, $sheet1_start, $sheet1_num, $sheet2_start, $sheet2_num) = @_;
    
    my $prev_up = $up;
    ($up) = &get_res_up($up, $sheet1_start, $sheet1_num) unless ($sheet1_start eq $sheet1_num);
    ($up) = &get_res_up($up, $sheet2_start, $sheet2_num) unless ($sheet2_start eq $sheet2_num);

    return ($up);

}

sub change_anti_up
{
    my ($up, $sheet1_start, $sheet1_num, $sheet2_start, $sheet2_num) = @_;
    
    my $prev_up = $up;

    ($up) = &get_res_up($up, $sheet1_start, $sheet1_num) unless ($sheet1_start eq $sheet1_num);
    $up = !$up;
    ($up) = &get_res_up($up, $sheet2_start, $sheet2_num) unless ($sheet2_start eq $sheet2_num);
    
    #print "change_anti_up: prev_up = $prev_up, sheet1-start = $sheet1_start, res - $sheet1_num, sheet2-start = $sheet2_start, num - $sheet2_num, returning up = $up\n";
    return ($up);
}

sub get_res_up
{
    my ($up, $sheet_start, $sheet_num) = @_;

    my $var = abs($sheet_start - $sheet_num + 1) % 2;
    unless ($var)
    {
	$up = !$up;
    }
    
    #print "get_sheet_up: returning $up for start $sheet_start, num - $sheet_num\n";
    return ($up);
}

#given a residue, returns the sheet it belongs to
sub get_sheet
{
    my ($data_ref, $res, $key) = @_;
    my ($sheet);

    unless ($key)
    {
	$key = 'Temp_ids';
    }

    my $id;
    
    my %data = %$data_ref;
    my $count = scalar(@{$data{$key}});
    
    #get sheet of res1
    for ($id = 0; $id < $count; $id++)
    {
	my $line = $data{$key}[$id];
	$line =~ /(\w+)\s+(\d+)\-(\d+)$/;
	
	my $type = $1;
	my ($start, $end) = ($2, $3);
	if ((($start-1) <= $res) and (($end+1) >= $res) and ($type =~ /sheet/i))
	{
		$start--;
		$end++;
	    $sheet = "$start-$end";
	}
    }
    
    #print "$res is from $sheet\n";
    return ($sheet);
}


sub get_sheet_from_id
{
    my ($data_ref, $id, $key) = @_;
    
    unless ($key)
    {
	$key = 'Temp_ids';
    }
    

    my %data = %$data_ref;
    my $sheet_line = $data{$key}[$id];
    #print "sheet_line is $sheet_line, key is $key\n";
    $sheet_line =~ /sheet\s+([\d\-]+)$/i;
    
    my $temp = $1;
    #print "returning temp as $temp for id $id\n";
    return ($temp);
}

sub get_res
{
    my ($lbl)= @_;

    my ($res1, $res2);
    if ($lbl =~ /^(\w+)\-(\w+)$/)
    {
	($res1, $res2) = ($1, $2);
    }
    
    #print "get_res: returning ($res1, $res2)\n";
    return ($res1, $res2);
}

sub beta_bulge {
	#check for beta bulge.
	my ($current_register, $drawn_registers_ref) = @_;
	my ($res1, $res2) = &get_res($current_register);
	my $current_sheet1 = &get_sheet($res1);
	my $current_sheet2 = &get_sheet($res2);
	my @drawn_registers = @$drawn_registers_ref;
	my $difference = 0;
	#print "comparing $current_register against @drawn_registers\n";
	foreach my $temp_register (@drawn_registers) {
		my ($temp_res1, $temp_res2) = &get_res($temp_register);
		if (&get_sheet($temp_res1) eq $current_sheet1) {
			$difference = abs($temp_res1 - $res1) - abs($temp_res2 - $res2);
		} elsif (&get_sheet($temp_res2) eq $current_sheet1) {
			$difference = abs($temp_res2 - $res1) - abs($temp_res1 - $res2);
		} elsif (&get_sheet($temp_res1) eq $current_sheet2) {
			$difference = abs($temp_res1 - $res2) - abs($temp_res2 - $res1);
		} elsif (&get_sheet($temp_res2) eq $current_sheet2) {
			$difference = abs($temp_res1 - $res2) - abs($temp_res2 - $res1);
		}
		#print "difference is $difference ********\n";
		if (abs($difference) == 1) {
			print "found beta_bulge\n";
			return 1;
		}
	}
	return 0;
}


return 1;
