sub start_child
{
    my ($ret_vals, $txtArea, $calc, $main, $stat2, $log_txt, $prog_cont, $prog_var) = @_;
    my $ety_line = 0;

    my $cont_file = $ret_vals->{'c_ent_val'};
    
    chdir dirname($cont_file);
    
    my $vals;
    while ((my $key, my $value) = each (%$ret_vals))
    {
	if ($value and $key=~/cbt/i)
	{
	    $key =~ /^(\w)/;
	    $vals = $vals." -$1";
	    if ($ret_vals->{$1."_ent_val"})
	    {
		$vals = $vals." ".$ret_vals->{$1."_ent_val"};
	    }
	}
    }
    
    my $out_dir = File::Spec->rel2abs($ret_vals->{'o_ent_val'});
    if (-d $out_dir)
    {
	&err_msg("Directory \"$out_dir\" already exists! Please remove it and try running the script again", $main);
	return 0;
    }

    my $pid;
    unless (defined($pid = open(CONT_FILE, "$EXECODE $vals 2>&1|")))
    {
	&err_open("Cannot fork");
	return 0;
    }
    
   
    if ($pid)
    {
	#parent
	$txtArea->insert('end', "Starting calculation...\n");
	
	#disable start and rerun commands
	$calc->cget(-menu)->entryconfigure('Start', -state=>'disabled');
	$calc->cget(-menu)->entryconfigure('Rerun', -state=>'disabled');
	$calc->cget(-menu)->entryconfigure('Stop', -state=>'normal');

	$main->fileevent(CONT_FILE, 'readable'=>sub {&load_text($txtArea)});

	#open log file
	
	#get log file
	if (0){
	my $id = $main->after(200, sub
			      {
				  opendir(OUT, "$out_dir");
				  my ($log_file) = grep(/\.log$/,readdir(OUT));
				  print "before: log_file is $log_file\n";
				  closedir(OUT);
				  
				  $log_file = $out_dir.'/'.$log_file;
				  print "log_file is $log_file\n";
				  
				  
				  #if (open(LOG_FILE,"tail -f $log_file|"))
				  #if (open(LOG_FILE, "ls |"))
				  #if (sysopen(LOG_FILE, $log_file, O_NONBLOCK | O_RDONLY))
				  {
				      #$log_txt->insert('end', 'log file opened');
				      $main->fileevent(LOG_FILE, 'readable'=>sub {&load_log});
				      print "after event\n";
				  }
			      });
    }
	
    }

return 1;

    
    
sub load_text
{
	#print "in load text\n";
	my $c;
	
	if (defined ($c = (getc CONT_FILE)))
	{
	    if (($c =~  /[\n\w\.\:\-\(\)\/\\\ \[\]\>\,\`\'\;\*]/))
	    {
		$ety_line = 0;
		$txtArea->insert('end', $c);
		$txtArea->yview('end');
		return;
	    }
	    else
	    {
		if (!$ety_line)
		{
		    $ety_line = 1;
		    $txtArea->insert('end', "\n");
		    return;
		}
	    }
	    
	}
	else
	{
	    &stop_load($txtArea, $calc);
	    return;
	    
	}
	
	
    }

sub load_log
{
    my ($log_file, $stop_ref) = @_;
    
    #delete text in log_txt
    $log_txt->delete('1.0', 'end');
    
    #open and load log file
    if (open(LOG, $log_file))
    {
	
    }
        
    
}

sub stop_load
{
    #my ($txtArea, $calc) = @_;

    kill 9 => $pid;

    $main->fileevent(CONT_FILE,'readable' => ''); 
    close(CONT_FILE);
    $$prog_cont = 0;
    $$prog_var = 0;
    

    $txtArea->insert('end', "\n\nCalculation stopped...\n\n");
    $txtArea->yview('end');
    $$stat2 = "";
    $calc->cget(-menu)->entryconfigure('Rerun', -state=>'normal');
    $calc->cget(-menu)->entryconfigure('Start', -state=>'normal');
    $calc->cget(-menu)->entryconfigure('Stop', -state=>'disabled');
    
    return;
    
}


}



return 1;
