
my $bg = '#EFF8FF';
my $but_bg = '#265580';
my $but_fg = $bg;
my $cbt_act = '#D1E4F2';
my $but_act = '#2D4455';



sub build_start_gui
{
    my ($main, $return_vals, $basepath) = @_;

    
    my $stwin = $main->Toplevel();
    $stwin->minsize(qw/650 720/);

    $stwin->configure(-title=>"Start Calculation", -background=>$bg);

    my $full_frm = $stwin->Frame(-background=>$bg)->pack(-fill=>'both', -expand=>1, -padx=>1, -pady=>1);
    
    my $path_lbl = $full_frm->Label(-background=>$bg, -text=>"Basepath - $$basepath", -relief=>'ridge', -borderwidth=>2)->pack(-fill=>'x', -expand=>1, -padx=>1, -pady=>1);

    my $req_lbl = $full_frm->Label(-text=>'Required', -background=>$bg)->pack(-side=>'top', -fill=>'x', -expand=>1);
    my $req_frm = $full_frm->Frame(-relief=>'ridge', -borderwidth=>2, -background=>$bg)->pack(-fill=>'x', -expand=>1, -padx=>1, -pady=>1);

    &start_create_row('-c', 1,1, 'Specify Control File', $req_frm, $stwin, $basepath, $return_vals);
    &start_create_row('-o', 1,1, 'Set Output Directory', $req_frm, $stwin, $basepath, $return_vals);

    my $opt_frm = $full_frm->Frame(-relief=>'ridge', -borderwidth=>2, -background=>$bg)->pack(-fill=>'both', -expand=>1, -padx=>1, -pady=>1);
    my $opt_lbl = $opt_frm->Label(-text=>"Optional\n", -background=>$bg)->pack(-side=>'top', -fill=>'x', -expand=>1, -pady=>1);

    my $opt_frm1 = $opt_frm->Frame(-relief=>'groove', -borderwidth=>2, -background=>$bg)->pack(-fill=>'x', -expand=>1) ;
    
    &start_create_row('-i', 1,1, 'Specify initial fold for bootstrapping', $opt_frm1, $stwin, $basepath, $return_vals);
    &start_create_row('-n', 0,0, 'Exclude CSI-based secondary structure analysis', $opt_frm1, $stwin, $basepath, $return_vals);
    &start_create_row('-m', 0,0, 'Exclude PCT-filter of Cycle 1 for symmetry analysis', $opt_frm1, $stwin, $basepath, $return_vals);    
    &start_create_row('-j', 0,0, 'Include J-coupling constant data for angle constraint analysis (HYPER)', $opt_frm1, $stwin, $basepath, $return_vals);    

    my $opt_frm2 = $opt_frm->Frame(-relief=>'groove', -borderwidth=>2, -background=>$bg)->pack(-fill=>'x', -expand=>1);
    my $val_lbl = $opt_frm2->Label(-text=>"Validation:\n", -background=>$bg)->pack(-side=>'top');
    
    &start_create_row('-v', 0,0, 'Calculate the M score/Validation of input data', $opt_frm2, $stwin, $basepath, $return_vals);    
   
    my $opt_frm3 = $opt_frm->Frame(-relief=>'groove', -borderwidth=>2, -background=>$bg)->pack(-fill=>'x', -expand=>1);
    my $hpr_lbl = $opt_frm3->Label(-text=>"HYPER\n", -background=>$bg)->pack(-side=>'top');

    &start_create_row('-N', 0,0, "Use NOE assignments in HYPER\n(not fully tested)", $opt_frm3, $stwin, $basepath, $return_vals);    
    &start_create_row('-R', 0,0, "Use Rotamer constraints in HYPER\n(not fully tested)", $opt_frm3, $stwin, $basepath, $return_vals);   

    my $opt_frm4 = $opt_frm->Frame(-relief=>'groove', -borderwidth=>2, -background=>$bg)->pack(-fill=>'x', -expand=>1);
    my $oth_lbl = $opt_frm4->Label(-text=>"Other options\n", -background=>$bg)->pack(-side=>'top');

    &start_create_row('-d', 0,0, 'Debug', $opt_frm4, $stwin, $basepath, $return_vals);    
    &start_create_row('-r', 1,1, 'Restore from a previous output directory', $opt_frm4, $stwin, $basepath, $return_vals);

    my $but_frm = $full_frm->Frame(-relief=>'ridge', -background=>$bg)->pack(-fill=>'both', -expand=>1, -padx=>3, -pady=>3);
    
    my $run_but = $but_frm->Button(-text=>'RUN', -background=>$but_bg, -foreground=>$but_fg, -activebackground=>$but_act, -activeforeground=>$but_fg)
	->pack(-fill=>'x', -expand=>1, -padx=>2, -side=>'left');
    my $can_but = $but_frm->Button(-text=>'CANCEL', -background=>$but_bg, -foreground=>$but_fg, -activebackground=>$but_act, -activeforeground=>$but_fg)
	->pack(-fill=>'x', -expand=>1, -padx=>2, -side=>'left');

    
    $return_vals->{'c_cbt_val'} = 1;
    $return_vals->{'o_cbt_val'} = 1;
    #$return_vals->{'j_cbt_val'} = 1;

    $can_but->configure(-command=>sub {%$return_vals = (); $stwin->destroy(); });

    $run_but->configure(-command=>sub 
		       {
			   if (&check_start_vals($return_vals, $stwin))
			   {
			       $stwin->destroy();
			   }
		       });
			   
    $stwin->waitWindow;
}


sub start_create_row
{
    my ($cbt_txt, $ent, $brw, $desc, $big_frm, $window, $bp, $return_vals) = @_;

    $cbt_txt=~/\-(\w+)/;
    my $option = $1;
 

    my $cbt_val = $option."_cbt_val";
    my $ent_val = $option."_ent_val";

    $return_vals->{$cbt_val} = 0;

    my $frm = $big_frm->Frame(-background=>$bg)->pack(-side=>'top', -padx=>3, -pady=>1, -fill=>'x', -expand=>1);
    

    my $desc_lbl = $frm->Label(-text=>"$desc: ", -width=>40, -wraplength=>250, -background=>$bg)->pack(-side=>'left', -padx=>5, -pady=>1, -anchor=>'e');

    my $cbt = $frm->Checkbutton(-text=>$cbt_txt, -variable=>\$return_vals->{$cbt_val}, -background=>$bg, -activebackground=>$cbt_act, -width=>5)->pack(-side=>'left', -padx=>3, -pady=>1);
    

    if ($ent)
    {
	my $entry = $frm->Entry(-textvariable=>\$return_vals->{$ent_val}, -width=>25, -background=>'white')->pack(-side=>'left', -padx=>3, -pady=>1);
    }
    else
    {
	my $ety_lbl = $frm->Label(-width=>20, -background=>$bg)->pack(-side=>'left', -padx=>3, -pady=>1);
    }
    
    if ($brw)
    {
	my $brw_but = $frm->Button(-text=>'Browse', -command=>sub 
				   {
				       if ($cbt_txt =~ /o/)
				       {
					   my $new_name = &OpenDir($cbt_txt, $window, $$bp, 1);
					   
					   if ($new_name)
					   {
					       $return_vals->{$ent_val} = $new_name;
					   }
					   else
					   {
					       return;
					   }
				       }
				       else
				       {
					   my $new_name =  &OpenFile($cbt_txt, $window, $$bp, \$a);
					   if ($new_name)
					   {
					       $return_vals->{$ent_val} = $new_name;
					   }
					   else
					   {
					       return;
					   }
				       }
				   }
				   , -width=>10, -background=>$but_bg, 
				   -foreground=>$but_fg, -activebackground=>$but_act, -activeforeground=>$but_fg)
	    ->pack(-side=>'left', -padx=>3, -pady=>1);
    }
    else
    {
	my $ety_lbl = $frm->Label(-width=>10, -background=>$bg)->pack(-side=>'left', -padx=>3, -pady=>1);
    }
    
    
    

}

sub start_gui
{
    my ($main) = @_;

    my %return_vals = ();
    my $basepath = Cwd::cwd;
    
    &build_start_gui($main, \%return_vals, \$basepath);

    return (\%return_vals);

}


sub check_start_vals
{
    my ($ret_vals, $win) = @_;

    unless ($ret_vals->{'c_ent_val'})
    {
	&err_msg("Please enter a control file", $win);
	return 0;
    }

    unless ($ret_vals->{'o_ent_val'} or ($ret_vals->{'po_ent_val'} and $ret_vals{'ao_ent_val'}))
    {
	&err_msg("Please enter an output directory", $win);
	return 0;
    }

    my $dir = $ret_vals->{'o_ent_val'};

    if (-d $dir)
    {
	my $dlg = $win->Dialog(-text=>"Directory $dir already exists!\nClicking Yes will erase its contents!\nOverwrite?", -buttons=>['Yes', 'No'], -bitmap=>'warning', 
			       -background=>'cyan');
	
	my $ans = $dlg->Show;

	if ($ans eq 'Yes')
	{
	    rmtree($dir);
	}
	else
	{
	    $ret_vals->{'o_ent_val'} = '';
	    return 0;
	}
    }

    return 1;
}





return 1;
