my $HOME = $ENV{'HOME'};

sub getTempFileName
{
    my ($file) = @_; 


    my $fname; 

    if (defined $tempFile{$file})
    { 
    } else
    {
	my $template = basename($file); 
	$template =~ s/\.gz$//; 

	my $HOME = $ENV{'HOME'}; 
	unless (-d "$HOME/.asdp")
	{
	    mkdir "$HOME/.asdp"; 
	}

	(undef, $fname) = tempfile($template . "XXXX", DIR => "$HOME/.asdp/", OPEN=>1, UNLINK=>1); 
	$tempFile{$file} = $fname;  

	#print "tempFile $file $fname\n";
    }

    return $tempFile{$file}; 
}

sub unzip_file
{
    my ($file) = @_;
    unless ($file =~ /\.gz$/)
    {
	print "File \"$file\" is not zipped!";
	return;
    }
    
    my $fname = getTempFileName($file); 

    system("gunzip -c $file > $fname");

    return ("$fname");
}


sub err_msg
{
    my ($msg, $win) = @_;
    
    my $dlg = $win->Dialog(-text=>$msg, -buttons=>['OK'], -bitmap=>'error');
    $dlg->Show;
}


sub change_basepath
{
    my ($basepath, $stwin, $chg_bpth) = @_;
    print "change basepath - basepath is $$basepath\n";

    if ($$basepath =~ /^\~/)
    {
	$$basepath =~ s/\~/$ENV{'HOME'}/;
    }

    unless (-d $$basepath)
    {
	my $err_dlg = $stwin->Dialog(-text=>"Directory $basepath does not exist!\n Do you want to create it?", -buttons=>['Yes', 'No']);
	my $ans = $err_dlg->Show();
	if ($ans eq 'No')
	{
	    $$basepath = Cwd::cwd;
	    $chg_bpth->configure(-state=>'normal');
	    return;
	}
	else
	{
	    mkdir $$basepath;
	}
    }
    chdir $$basepath;
    $$basepath = Cwd::cwd;
    &err_msg("The Current Working Directory has been changed to \"$$basepath\"\nClose any previously opened windows to update their working directory!", $stwin);

    $chg_bpth->configure(-state=>'disabled');
    print "change_basepath: basepath changed to $$basepath\n";
}


sub get_log_file
{
    my ($dir, $parent) = @_;

    unless (opendir(DIR, $dir))
    {
	&err_msg("Cannot open AS directory \"$dir\"", $parent);
	return;
    }

    my @contents = readdir(DIR);
    close(DIR);

    my ($log) = grep {/\.log$/} @contents;
    if ($log)
    {
	$log = File::Spec->rel2abs($log, $dir);
    }
    return ($log);

}

sub get_key_file
{
    my ($dir, $parent, $key) = @_;

    unless (opendir(DIR, $dir))
    {
	&err_msg("Cannot open AS directory \"$dir\"", $parent);
	return;
    }

    my @contents = readdir(DIR);
    close(DIR);

    my ($file) = grep {/\.$key$/} @contents;
    if ($file)
    {
	$file = File::Spec->rel2abs($file, $dir);
    }
    return ($file);


} 

return 1; 
