#cyana calculation with single cpu

package Cyana;

use Cwd;
use ASDP::Protocol;
use ASDP::DP;
use ASDP::Utils;
use File::Copy;

@ISA = qw(Protocol);

sub new {
	my $class = shift;
	my $self = $class->SUPER::new( @_ );
	$self->{calc_duration} = 2;
	$self->{max_calc_wait} = 60;
	$self->{command} = $ENV{'CyanaCmd'};
	my $options_ref = shift;
	bless($self, $class);
	return $self;
}

#not used
# sub rama {
# 	my $self = shift;
# 	my $name = $self->{options}->{na};
# 	open(RAMA_CYA, ">rama.cya");
# 	print RAMA_CYA "cyanalib\n";
# 	if (defined $self->{options}->{lib}) {
# 		print RAMA_CYA "read lib " . $self->{options}->{lib} . " append\n";
# 	}
# #	print RAMA_CYA "readdata $name\n";
# 	print RAMA_CYA "read seq $name\n";
# 	print RAMA_CYA "ramaaco\n";
# 	print RAMA_CYA "rotameraco\n";
# 	print RAMA_CYA "write aco cycle.aco\n";
# 	print RAMA_CYA "quit\n";
#
# 	close(RAMA_CYA);
# 	unless (-f "rama.cya") {
# 		print "rama.cya doesn't exist\n";
# 		sleep(2);
# 	}
#
# 	Utils->qsub($ENV{'SUBMITPBS'}, $ENV{'CyanaCmd'} . " < " . getcwd() . "/rama.cya > " . getcwd() . "/LogRamaOvw", "rama");
# 	#system($ENV{'CyanaCmd'} . " < myOverview.cya > LogOverview");
# 	my $cwd = getcwd();
# #	my $pdb_file = "$cwd/${name}.pdb";
# #	my $ovw_file = "$cwd/${name}.ovw";
# #	return ($pdb_file, $ovw_file);
# }

sub do_overview {
	my $self = shift;
	my $run_number = shift;
	my $name = $self->{options}->{na};
	my $total_str = $self->{options}->{nstr} * $self->{options}->{np};
	$total_str = 100 if ($total_str > 100); #only read the top 100 structures
	my ($pdb_file, $ovw_file);
	if ($run_number == 1) {			#run_number 1 is for all models
#		($pdb_file, $ovw_file) = $self->run_overview("read_all $name???.ang", "overview ${name} $total_str pdb hbond=1");
#		rename(${name} . ".ovw", "all_models.ovw");
#		rename(${name} . ".pdb", "all_models.pdb"); #mv to all_models.pdb and select top 20
#		copy("all_models.pdb", "all_modelsi_bk.pdb") or die "copy failed: $!"; #mv to all_models.pdb and select top 20
#		return ("all_models.pdb", "all_models.ovw");
		return(${name} . ".pdb", ${name} . ".ovw");
	} elsif ($run_number == 2) {		#run_number 2 is for the best models (after rpf is run on all models)
#		copy("all_models.pdb", ${name} . ".pdb"); #only the top 20 are cp to the name.pdb
		$total_str = $self->{options}->{nb}; $total_str = 100 if ($total_str > 100);
		($pdb_file, $ovw_file) = $self->run_overview("read pdb ${name}.pdb", "overview ${name} $total_str hbond=1");
	} else {
		die("unidentified run_number for cyana overview");
	}
	return ($pdb_file, $ovw_file);
}

sub run_overview {
	my $self = shift;
	my $read_command = shift;
	my $overview_command = shift;
	my $name = $self->{options}->{na};
	#RT changed Overview.cya to myOverview.cya to avoid problem in MacOS
	open(OVW_CYA, ">myOverview.cya");

	#read the standard and special libs
	print OVW_CYA "cyanalib\n";
	if (defined $self->{options}->{lib}) {
		print OVW_CYA "read lib " . $self->{options}->{lib} . " append\n";
	}
	print OVW_CYA "readdata $name\n";
	print OVW_CYA "$read_command\n";
	print OVW_CYA "read lol hbond.lol append\n";
	print OVW_CYA "read upl hbond.upl append\n";

	if (defined $self->{options}->{rdc}) {

		print OVW_CYA "read rdc $name\n";
		print OVW_CYA "rdcscale\n";
	}
	print OVW_CYA "$overview_command\n";
	print OVW_CYA "cut_upl=0.5\n";
	print OVW_CYA "quit\n";
	close(OVW_CYA);

	unless (-f "myOverview.cya") {
		print "myOverview.cya doesn't exist\n";
		sleep(2);
	}

	system($ENV{'CyanaCmd'} . " < myOverview.cya > LogOverview");

	my $cwd = getcwd();
	my $pdb_file = "$cwd/${name}.pdb";
	my $ovw_file = "$cwd/${name}.ovw";
	return ($pdb_file, $ovw_file);
}

sub prepare_batch {
	my $self = shift;
	my $seed = shift;
	my $cmdname = shift;
	my $process = shift;
	my $name = $self->{options}->{na};
	my $filename = "Smt${cmdname}${process}.sh";
	my $commands = "";
	$commands .= "date\n";
	$commands .= "hostname\n";
	$commands .= $ENV{'CyanaCmd'} . " << EOF > log${process}\n";
	$commands .= "nproc=1\n";
	$commands .= "seed=$seed\n";
	$commands .= "calc_para${process} ${name}\n";
	$commands .= "quit\n";
	$commands .= "EOF\n";
	$commands .= "date\n";
	$commands .= "touch Done${name}${process}\n";
	$self->{queue}->create_batch($filename, "${name}_${process}", $commands);
}

#testing
sub runAMBI {
    my $self = shift;

    my $name = $self->{options}->{na};

    #prepre EC constraints
    open(SA, ">init.cya");
    print SA "name := $self->{options}->{na}\n";
    print SA "cyanalib\n";
    print SA "read seq $self->{options}->{na}\n";
    print SA "rdcscale\n";
    print SA "cut_upl=0.5";

    open(AMBI, ">ambiEC.cya");
#    print AMBI "name := $self->{options}->{na}\n";
#    print AMBI "cyanalib\n";
#    print AMBI "read seq $self->{options}->{na}\n";
    open(EC, "<$self->{options}->{na}.ec");
    while (<EC>)
    {
	chomp;
	$_ =~ s/^\s+//g;
	my (@list) = split(/\s+/, $_);
	$list[2] = 1 if ($list[2] !~ /\d/);
	print AMBI "distances make first=\"C* $list[0]\" second=\"C* $list[1]\" ambiguous upl=$list[2]\tweight=$list[3]\n";
    }
    print AMBI "write upl $self->{options}->{na}_EC.upl\n";
    close AMBI;
    my $commands = $ENV{'CyanaCmd'} . " ambiEC.cya > logAmbi\n";
    #`$commands`;
    $commands .= "cat < $name\_EC.upl >> $name.upl\n";
    `$commands`;

}

#
sub prepare_run {
	# Routine to set up a calculation with CYANA
	my $self = shift;
	my ($process, $structures, $begin, $end, $seed) = @_;
	my $processes = $self->{options}->{np};
	my $total_structures = $self->{options}->{np} * $self->{options}->{nstr};
	Utils->debug("in Cyana->prepare_SA().  creating calc_para${process}.cya");
	open(SA, ">calc_para$process.cya") or die"@_\n";
	print SA "## calc_para - calculate a group of structures\n";
	print SA "##\n";
	print SA "## Usage: calc_para file=<file> [struct=<n>]\n";
	print SA "\n";
	print SA "syntax file=* struct=\@i=$structures\n";
	print SA "\n";
	print SA "cyanalib\n";
	if (defined $self->{options}->{lib}) {
		print SA "read lib " . $self->{options}->{lib} . " append\n";
	}
	print SA "readdata \$file\n";
	print SA "read lol hbond.lol append\n";
	print SA "read upl hbond.upl append\n";

	#added by J. Huang
	if ($self->{options}->{rdc} =~ /rdc/i) {
		print SA "read rdc \$file\n";
		print SA "rdcscale\n";
		print SA "weight_rdc = 0.02\n";
		print SA "cut_rdc=0.2\n";
	}
	if (defined $self->{options}->{ss}) {
		my @bridges = split(/,/, $self->{options}->{ss});
		foreach my $bridge (@bridges) {
			print SA "ssbond $bridge\n";
		}
	}
	#print SA "distance modify\n"
	if ($self->{options}->{av} =~ /center/i) {
	    print SA "expand=0\n";
	}

	# if ambi or not
	if ($self->{options}->{ambi}) {
	    print SA "cut_upl=0.5\n"; #for ambi upl
	    print SA "swap=1\n";
	} else
	{
	    print SA "swap=0\n";
	}

#        print SA "read aco cycle.aco append\n"; #delay for syc`

	print SA "random_all \$struct\n";#$total_structures\n";#
	print SA "\n";
	print SA "do i $begin struct parallel\n";
	print SA "  structure copy i 0\n";
	if (defined $self->{options}->{steps}) {
	    print SA "  anneal steps=$self->{options}->{steps}\n";
	} else
	{
	    if (defined $self->{options}->{rdc}) {
					print SA "  anneal steps=15000\n";
	    } else {
					print SA "  anneal steps=10000\n";
	    }
	}

	print SA "  write ang {\$file}\$i(I3.3).ang\n";
	print SA "  write pdb {\$file}\$i(I3.3).pdb\n";
	print SA "end do\n";
	print SA "\n";
	close(SA);
}

sub get_top_ranked_models {
	my $self = shift;
	my $dp_hash_ref = shift;
	my $ovw_file = shift;

	Utils->debug("loading f values from ang files");
	#new035.ang:# Structure from CYANA, f = 2.27591E+00
	my $tf = `grep "f = " *.ang`;
	my @lines = split("\n", $tf);
	my %energy = ();
	my $min = 1000000;
	foreach $l (@lines)
	{
		my ($i, $tf) = $l =~ /(\d\d\d)\.ang[\:\#\w\s\,]+ f = ([\d\.]+E[\d\+\-]+)/;
		#print "$i-$tf-$l\n";
		$i = $i * 1;
		$tf = $tf * 1;
		$energy{$i} = $tf;
		$min = $tf if ($tf < $min);
	}
	$min = 0.0000001 if ($min < 0.0000001);

	#close OVW;
	my $weight = $min*100;

	my %rank = ();
	#print "keys in dp_hash_ref " . scalar(keys %{$dp_hash_ref}) . "\n";
	foreach (reverse sort {$dp_hash_ref->{$a}<=>$dp_hash_ref->{$b}} keys %{$dp_hash_ref}) {
	    #print "$weight $min\n";
		$rank{$_} = ((1.0 * $energy{$1} / $weight) - (1.0 * $dp_hash_ref->{$_})) if (/(\d+)/);
	}
	my @rank_models = sort {$rank{$a}<=>$rank{$b}} keys %rank;
	#print "keys in rank " . scalar(keys %rank) . "\n";
	Utils->debug("BEST RANKED model is " . $rank_models[0] . " with a score of: " . $rank{$rank_models[0]});
	open(RANKS, ">RANKS");
	print RANKS "#total = (target / $weight) - dp\n";
	print RANKS "#model  \ttarget\tdp\ttotal\n";
	for (my $i = 0; $i < scalar(@rank_models); $i++) {
		if ($rank_models[$i] =~ /(\d+)/) {
			#print RANKS $rank_models[$i] . "  \t" . ($energy{$1}) . "\t" . $dp_hash_ref->{$rank_models[$i]} . "\t" . $rank{$rank_models[$i]} . "\n";
			printf RANKS "%s %12.3f %12.3f %12.3f\n",
			$rank_models[$i], $energy{$1}, $dp_hash_ref->{$rank_models[$i]}, $rank{$rank_models[$i]} ;
		}
	}
	close(RANKS);
	return \@rank_models;
}

sub do_cleanup {
	my $self = shift;
	my $name = $self->{options}->{na};
	#TODO condense the rm's into one command to minimize process forking!
	system("rm -f Done*");
	system("more log* > Log" . ref($self));
	unless ($ENV{'DEBUG'} == 1) {
		#system("rm -f all_models.pdb log* Calc* Smt* SedFile* FileCis* SSBridges* SSNoes*");
		#system("rm -f ${name}???.ang");
		system("rm -rf rpf_out");
		system("more Smt*sh > SubCmd_ASDP");
		#system("cat run_*sh > SubCmd_DP");
		system("more calc_para* > SubCmd_AS" . ref($self));
		system("more Calc_e* > LogError") if (<Calc_e*>);
		system("rm -f ${name}?*.pdb");
		system("rm -f log* *ang Calc_* calc_para* Smt*sh");
	}
}
return(1);
