#cyana with mpi
#
# package CyanaMPI;
#
# use Cwd;
# use ASDP::Cyana;
# use ASDP::DP;
# use ASDP::Utils;
# @ISA = qw(Cyana);
#
# sub new {
# 	my $class = shift;
# 	my $self = $class->SUPER::new( @_ );
# 	$self->{calc_duration} = 2;
# 	$self->{max_calc_wait} = 60;
# 	$self->{command} = $ENV{'CyanaCmd'};
# 	my $options_ref = shift;
# 	bless($self, $class);
# 	return $self;
# }
# sub wait_for_structure_calculations {
# 	my $self = shift;
# 	my $name = $self->{options}->{na};
# 	my $max_wait = (defined $self->{max_calc_wait} ? $self->{max_calc_wait} : 60);
# 	my $wait_time = (defined $self->{calc_duration} ? $self->{calc_duration} : 2);
# 	my $accumulated_wait = 0;
# 	Utils->debug("in CreateProc->wait_for_structure_calculations()");
# 	until (-e "Done${name}") {
# 		$accumulated_wait += $wait_time;
# 		sleep($wait_time);
# 	}
# 	Utils->debug("total wait was: $accumulated_wait seconds.");
# 	#$self->{structtime} = `date`;
# }
# sub run {
# 	my $self = shift;
# 	my $seeds_ref = shift;
# 	Utils->debug("in CyanaMPI->run()");
# 	my $name = $self->{options}->{na};
# 	$self->prepare_run();
# 	$self->do_batch(2377, "");
# }
# sub do_overview {
# 	my $self = shift;
# 	my $run_number = shift;
# 	my $name = $self->{options}->{na};
# 	my $total_str = $self->{options}->{nstr} * $self->{options}->{np};
# 	my ($pdb_file, $ovw_file);
# 	if ($run_number == 1) {			#run_number 1 is for all models
# 		$pdb_file = "${name}.pdb";
# 		$ovw_file = "${name}.ovw";
# 		#($pdb_file, $ovw_file) = $self->run_overview("read_all $name???.ang", "overview ${name} $total_str pdb hbond=1");
# 	} elsif ($run_number == 2) {		#run_number 2 is for the best models (after rpf is run on all models)
# 		#system("cp ${name}.pdb ${name}_right_after_rpf.pdb");
# 		$total_str = $self->{options}->{nb};
# 		($pdb_file, $ovw_file) = $self->run_overview("read pdb ${name}.pdb", "overview ${name} $total_str hbond=1");
# 	} else {
# 		die("unidentified run_number for cyana overview");
# 	}
# 	return ($pdb_file, $ovw_file);
# }
# sub run_overview {
# 	my $self = shift;
# 	my $read_command = shift;
# 	my $overview_command = shift;
# 	my $name = $self->{options}->{na};
# 	open(OVW_CYA, ">Overview.cya");
# 	print OVW_CYA "cyanalib\n";
# 	if (defined $self->{options}->{lib}) {
# 		print OVW_CYA "read lib " . $self->{options}->{lib} . " append\n";
# 	}
# 	print OVW_CYA "readdata $name\n";
# 	print OVW_CYA "$read_command\n";
# #	print OVW_CYA "read $name.pdb\n";
# 	print OVW_CYA "read lol hbond.lol append\n";
# 	print OVW_CYA "read upl hbond.upl append\n";
# 	if (defined $self->{options}->{rdc}) {
# 		print OVW_CYA "rdcscale\n";
# 		print OVW_CYA "read rdc $name\n";
# 	}
# 	print OVW_CYA "$overview_command\n";
# 	print OVW_CYA "quit\n";
# 	close(OVW_CYA);
# 	unless (-f "Overview.cya") {
# 		print "Overview.cya doesn't exist\n";
# 		sleep(2);
# 	}
# 	Utils->qsub($ENV{'SUBMITPBS'}, $ENV{'CyanaCmd'} . " < " . getcwd() . "/Overview.cya > " . getcwd() . "/LogCyanaOvw", "overview");
# 	#system($ENV{'CyanaCmd'} . " < Overview.cya > LogOverview");
# 	my $cwd = getcwd();
# 	my $pdb_file = "$cwd/${name}.pdb";
# 	my $ovw_file = "$cwd/${name}.ovw";
# 	return ($pdb_file, $ovw_file);
# }
# sub prepare_batch {
# 	my $self = shift;
# 	my $seed = shift;
# 	my $process = shift;
# 	my $name = $self->{options}->{na};
# 	Utils->debug("in Cyana->batch_PBS() creating Smt${name}${process}.sh");
# 	my $commands = $ENV{'CyanaCmdMPI'} . " calc_structures.cya ${name} > log\n";
# 	$self->{queue}->create_batch_MPI($name, $process, $commands);
# }
# sub batch_NOQ {
# 	my $self = shift;
# 	my $seed = shift;
# 	my $process = shift;
# 	my $name = $self->{options}->{na};
# 	open(SMT, ">Smt${name}${process}.sh") or die;
# 	print SMT "#!/bin/sh\n";
# 	print SMT "cd " . getcwd() . "\n";
# 	print SMT "date\n";
# 	print SMT $ENV{'CyanaCmd'} . " << EOF > log${process}\n";
# 	print SMT "nproc=1\n";
# 	print SMT "seed=$seed\n";
# 	print SMT "calc_para${process} ${name}\n";
# 	print SMT "quit\n";
# 	print SMT "EOF\n";
# 	print SMT "date\n";
# 	print SMT "touch Done${name}${process}\n";
# 	print SMT "exit\n";
# 	close(SMT);
# }
#
#
# sub prepare_run {
# 	# Routine to set up a calculation with CYANA
# 	my $self = shift;
# 	my $total_structures = $self->{options}->{mpi};
# 	my $name = $self->{options}->{na};
# 	Utils->debug("in Cyana->prepare_SA().  creating calc_para${process}.cya");
# 	open(SA, ">calc_structures.cya") or die"@_\n";
# 	print SA "## calc_para - calculate a group of structures\n";
# 	print SA "##\n";
# 	print SA "## Usage: calc_para file=<file> [struct=<n>]\n";
# 	print SA "\n";
# 	#print SA "syntax file=* struct=@i=20\n";
# 	#print SA "\n";
# 	print SA "cyanalib\n";
# 	if (defined $self->{options}->{lib}) {
# 		print SA "read lib " . $self->{options}->{lib} . " append\n";
# 	}
# 	print SA "readdata $name\n";
# 	print SA "read lol hbond.lol append\n";
# 	print SA "read upl hbond.upl append\n";
# 	#added by J. Huang
# 	if ($self->{options}->{rdc} =~ /rdc/i) {
# 		print SA "rdcscale\n";
# 		print SA "read rdc $name\n";
# 		print SA "weight_rdc = 0.02\n";
# 		print SA "cut_rdc=0.2\n";
# 	}
# 	if (defined $self->{options}->{ss}) {
# 		my @bridges = split(/,/, $self->{options}->{ss});
# 		foreach my $bridge (@bridges) {
# 			print SA "ssbond $bridge\n";
# 		}
# 	}
# 	#print SA "distance modify\n"
# 	if ($self->{options}->{av} =~ /center/i) {
# 	    print SA "expand=0\n";
# 	}
# 	print SA "swap=0\n";
# 	if (defined $self->{options}->{rdc}) {
# 		print SA "calc_all structures=${total_structures} command=anneal steps=15000\n";
# 	} else {
# 		print SA "calc_all structures=${total_structures} command=anneal steps=10000\n";
# 	}
# 	print SA "\n";
# 	print SA "overview $name.ovw pdb\n";
# 	print SA "\n";
# 	close(SA);
# }
# return(1);
