package N15noesy;
use Peaks;
use PeakList;
use Dimension;
use DataColumn;
use List::Util qw(max);
@ISA = qw(PeakList);
sub new {
	my $class = shift;
	my $self = $class->SUPER::new( $_[0], $_[1], $_[2], $_[3], $_[4], $_[5], $_[6] );
	$self->{dimension_count} = 3;
	$self->{h_count} = 2;
	$self->{x_count} = 1;
	$self->{dimensions} = {};
	$self->{height} = undef;
	bless($self, $class);
	$self->assign_columns();
	$self->assign_hx_columns();
	$self->fill_dimensions();
	return $self;
}
sub fill_dimensions() {
	my $self = shift;
	$self->{dimensions}{"x1"}->set_type("N15");
}
sub parse_columns_deprecated {
	my $self = shift;
	my $shift_columns = $self->{shift_columns};
	my $filepath = $self->{filepath};
	open ( FILE, "<$filepath" ) or die "$!";
	binmode FILE;
    my $rec_num = 0;
    my $col_num = 0;
    my $temp_line;
	while( chomp($temp_line = <FILE>)) {
		next if (($temp_line =~ /^\#/) or ($temp_line =~ /^\s*$/) or $temp_line =~ /assignment/i);
		$rec_num++;
		$temp_line =~ s/^\s+//;
		$temp_line =~ s/\s+$//;
		my @items = split(/\s+/, $temp_line);
		$col_num = scalar(@items);
		#print "cols: $col_num <br/>";
		my $j;
		for ($j=0; $j<$col_num; $j++) {
			#print "*   item $j: " . $items[$j] . "  ";
		}
#		$self->{label}->push($items[0]);
#		$self->{shift_columns}{2}->push($items[1]);
#		$self->{shift_columns}{3}->push($items[2]);
#		$self->{shift_columns}{4}->push($items[3]);
		$self->{height}->push($items[4]);
    }
    close(FILE);
	my ($col2_mean, $col3_mean, $col4_mean) = ($self->{shift_columns}{2}->get_mean(), $self->{shift_columns}{3}->get_mean(), $self->{shift_columns}{4}->get_mean());
	my ($col2_std, $col3_std, $col4_std) = ($self->{shift_columns}{2}->get_std(), $self->{shift_columns}{3}->get_std(), $self->{shift_columns}{4}->get_std());
	my ($x1, $hx1, $hx2);
	if ($col2_mean > $col3_mean and $col2_mean > $col4_mean) {
		$x1 = 2;
		if ($col3_std < $col4_std) {
			$hx1 = 3;
			$hx2 = 4;
		} else {
			$hx1 = 4;
			$hx2 = 3;
		}
	} elsif ($col3_mean > $col4_mean) {
		$x1 = 3;
		if ($col2_std < $col4_std) {
			$hx1 = 2;
			$hx2 = 4;
		} else {
			$hx1 = 4;
			$hx2 = 2;
		}
	} else {
		$x1 = 4;
		if ($col3_std < $col2_std) {
			$hx1 = 3;
			$hx2 = 2;
		} else {
			$hx1 = 2;
			$hx2 = 3;
		}
	}
	$self->{shift_columns}{$x1}->set_type("N15");
	$self->{shift_columns}{$x1}->set_tol(0.5);
	$self->{shift_columns}{$x1}->set_shift(0.00);
	$self->{shift_columns}{$x1}->set_name("x1");
	$self->{shift_columns}{$x1}->set_sign(0);
	$self->{shift_columns}{$x1}->set_sw(1000.00);
	$self->{type_by_name}{"x1"} = "N15";

	$self->{shift_columns}{$hx1}->set_type("H");
	$self->{shift_columns}{$hx1}->set_tol(0.05);
	$self->{shift_columns}{$hx1}->set_shift(0.00);
	$self->{shift_columns}{$hx1}->set_name("hx1");
	$self->{shift_columns}{$hx1}->set_sign(0);
	$self->{shift_columns}{$hx1}->set_sw(1000.00);
	$self->{type_by_name}{"hx1"} = "H";

	$self->{shift_columns}{$hx2}->set_type("H");
	$self->{shift_columns}{$hx2}->set_tol(0.05);
	$self->{shift_columns}{$hx2}->set_shift(0.00);
	$self->{shift_columns}{$hx2}->set_name("hx2");
	$self->{shift_columns}{$hx2}->set_sign(0);
	$self->{shift_columns}{$hx2}->set_sw(1000.00);
	$self->{type_by_name}{"hx2"} = "H";

# 	my $biggest_column = $self->get_max_mean_column();
# 	my $smallest_column = $self->get_min_std_column();
# 	print "std1: " . $self->{shift_columns}{2}->get_std() . "<br/>";
# 	print "std2: " . $self->{shift_columns}{3}->get_std() . "<br/>";
# 	print "std3: " . $self->{shift_columns}{4}->get_std() . "<br/>";
# 	#print "stdh: " . $self->{height}->get_std() . "<br/>";
}
return(1);

