package Session;

use Digest::MD5;
use Digest::MD5  qw(md5 md5_hex md5_base64);
use POSIX qw( strftime );

sub new {
	my $class = shift;
	my $self = {};
	$self->{cgi} = shift;
	$self->{sessid} = undef;
	$self->{time} = strftime("%Y\_%m\_%d\_%H\_%M\_%S", localtime);
	bless($self, $class);
	$self->purge_old_sessions();
	if (defined $self->{cgi}->param('sessid')) {
# 		print "old session " . $self->{cgi}->param('sessid') . "<br/>";
		$self->{sessid} = $self->{cgi}->param('sessid');
		$self->load();
	} else {
# 		print "new session<br/>";
		$self->{sessid} = $self->create_session_id();
		$self->save();
	}
	return $self;
}
sub get_session_id {
	my $self = shift;
	return $self->{sessid};
}
sub save {
	my $self = shift;
# 	print "saving<br/>";
	$ENV{'RPF_SESS_DIR'} = $ENV{'DOCUMENT_ROOT'} . '/rpf/sessions';
	$file = $ENV{'RPF_SESS_DIR'} . "/" . $self->{sessid};
	open( FILE, ">$file" );
	binmode FILE;
	my $key;
	foreach $key ( keys %$self ) {
# 		print "*** $key" . ":^_^:" . $self->{$key} . " ---<br/>";
		print FILE $key . ":^_^:" . $self->{$key} . "\n";
	}
	close FILE;
}
sub load {
	my $self = shift;
	$file = $ENV{'DOCUMENT_ROOT'} . "/rpf/sessions/" . $self->{sessid};
# 	print "session_file: $file<br/>";
	open( FILE, "<$file" );
	binmode FILE;
	my $temp_line;
	my @personal;
	while (chomp($temp_line = <FILE>)) {
# 		print "line in session: $temp_line<br/>";
		@personal = split(/:\^_\^:/, $temp_line);
#		print $personal[0] . "::*" . $personal[1] . "*<br/>";
		$self->{$personal[0]} = $personal[1];
# 		print $self->{'time'} . "########################<br/>";
# 		print $personal . "<br/>";
	}
	close FILE;
}
sub put {
	my $self = shift;
	my $key = shift;
	my $val = shift;
	$self->{$key} = $val;
 	$self->save();
}
sub get {
	my $self = shift;
	my $key = shift;
	return $self->{$key};
}
sub delete {
	my $self = shift;
	my $key = shift;
	delete $self->{$key};
}
sub create_session_id {
	my $self = shift;
	$data = shift;
	unless (defined $data) {
		$data = $self->{cgi} . rand(999999);
	}
	my $digest = md5($data);
	print "md5    : $digest<br/>";
 	$digest = md5_hex($data);
	print "md5_hex: $digest<br/>";
 	#$digest = md5_base64($data);
	#print "md5_b64: $digest<br/>";
	return $digest;
}
sub purge_old_sessions {
	my $class = shift;
	my $sessions_dir = $ENV{'DOCUMENT_ROOT'} . '/rpf/sessions';
	opendir (DIR, $sessions_dir);
	my @conents = readdir(DIR);
	close(DIR);
	my ($key, $file, $mod_time);
	foreach $key ( @contents ) {
		$file = $sessions_dir . "." . $key;
		$mod_time = (stat("$logFile"))[9];
		if (time - $mod_time > 600) {
			print "Older than 10 min: $logFile <br/>";
			unlink($file);
		} else {
			print "Newer than 10 min: $logFile <br/>";
		}
	}
}

return(1);
