package Utils;

use strict;
use Carp;
use Cwd;
use Thread;
use Fcntl;

#$SIG{__DIE__} = sub { print shift; };
my $output = "";
my $done = 0;
my $debug = 0;
sub debug {
	my $class = shift;
	my $key = shift;
	my $text = shift;
	if ($debug == 1) {
		print STDOUT $key , ": " . $text . "<br/>";
	}
}
sub alert {
	my $class = shift;
	my $key = shift;
	my $text = shift;
	if ($debug == 1) {
		print STDOUT "<script type='text/javascript'>alert('$key');</script>";
	}
}
sub run_rpf {
	my $class = shift;
	my $control_file = shift;
	my $pdb_file = shift;
	my $output_dir = shift;
	my $pl_count = shift;
	my $session_id = shift;
	my $verbose = shift;
	#my $program = $ENV{'DOCUMENT_ROOT'} . "/rpf/bin/noesyassign";
	my $program = $ENV{'NOESYASSIGN'};
	my $vals = "-c $control_file -o $output_dir -q $pdb_file";
	#print STDERR $program, $vals, $pl_count, "<br/>";
	return $class->run_prog($program, $vals, $pl_count, $session_id, $verbose);
}
sub run_prog {
	my $class = shift;
	my $program = shift;
	my $vals = shift;
	my $pl_count = shift;
	my $session_id = shift;
	my $verbose = shift;
	#print STDERR "pl_count is $pl_count, verbose is $verbose\n";
	my $total_work = ($pl_count * 6) + 2;
	my $current_work = 0;
	my $pid;
	my $temp_line;
	#print "running: ", "$program $vals", "\n";
	$class->debug("running: ", "$program $vals");
	$class->debug("cwd: ", cwd());
	unless (defined($$pid = open(PDB_FILE, "$program $vals 2>&1|"))) {
		print STDERR "Could not launch rpf<br/>\n";
	    return 0;
	}
	$class->debug("rpf running");
	my $output = "";
	my $old_output = "";
	my $ety_line = 0;
	my $c;
	while (defined ($c = (getc PDB_FILE))) {
		if (($c =~  /[@\r\n\w\.\:\-\(\)\/\\\ \[\]\>\,\`\'\;\*]/)) {
			if ($ety_line) {
				if ($c =~ /\s/) {
					next;
				}
			}
			if ($c =~ /\n/) {
				$c = "<br/>";
			}
			$ety_line = 0;
# 			$txt_pdb->insert('end', $c);
# 			$txt_pdb->yview('end');
# 			print $c;
			$output .= $c;
# 			$| = 1;
		} else {
			if (!($ety_line)) {
				$ety_line = 1;
# 				print "<br/>\n";
				$output .= "<br/>";
				unless ($output eq $old_output) {
					my $progress = ($current_work / $total_work) * 100;
					if ($progress > 100) {$progress = 100;}
					if ($verbose) {
						print "<script type='text/javascript'>";
						print "document.getElementById('progress_bar').style.width = '$progress%';";
						print "</script>\n";
					}
					$current_work++;
				}
				$| = 1;
				$old_output = $output;
				$output = "";
			}
		}
	}
	if ($verbose) {
		print "<script type='text/javascript'>
		var progress_bar = document.getElementById('progress_bar'); 
		progress_bar.style.width = '100%'; 
		progress_bar.innerHTML = '<center><bold>RPF Results</bold></center>';
		location.href='results.pl?sessid=$session_id';
</script>\n";
		#print "<script type='text/javascript'> window.dialog.hideAndUnload(); </script>\n";
	}
# 	print "</div>";		#end noessyassign_output
# 	while ($temp_line = <PDB_FILE>) {
# 		print $temp_line . "<br/>";
# 	}
# 	print "###################################<br/>";
	close(PDB_FILE);
	my $returnval;
	return $returnval;
}
sub trim($) {
	my $class = shift;
	my $string = shift;
	$string =~ s/^\s+//;
	$string =~ s/\s+$//;
	return $string;
}
sub confirm_control_values {
	my $class = shift;
	my $dataset = shift;
	my $session_id = shift;
	my ($dim, $dim_name, $sw, $tol, $shift, $col, $type);
	my $str = "<form method='POST' action='/rpf/cgi-bin/run_rpf.pl' name='confirm_control_values' onsubmit=''>";
	foreach my $key ( keys %{$dataset->{peaklists}} ) {
		my $peaklist = $dataset->{peaklists}{$key};
		my $peaklist_name = $peaklist->get_name();
		my $num_columns_in_file = scalar(keys(%{$peaklist->{columns}}));
		$str .= $peaklist_name . "<br/>\n";
		$str .= "<table class='confirm_table' width='100%'><tbody><tr>";
#		print scalar(keys %{$peaklist->{columns}});
		my $col_width = 100 / $num_columns_in_file - 1;
		for (my $col_num = 1; $col_num <= scalar(keys %{$peaklist->{columns}}); $col_num++) {
			my $column = $peaklist->{columns}->{$col_num};
			my $dimension = $peaklist->get_dimension_by_col_num($col_num);
			$str .= "<td width='$col_width%'>$col_num</td>\n" if not defined $dimension;
			if (ref($dimension) =~ /dimension/i) {
				$str .= "<td width='$col_width%'>" . $dimension->get_type() . "</td>\n";
			} elsif (ref($dimension) =~ /datacolumn/i) {
				$str.= "<td width='$col_width%'>" . "intensity" . "</td>\n";
			}
		}
		$str .= "</tr>";
		for (my $j = 0; $j < 5; $j++) {		#5 lines from peaklist data
			$str .= "<tr>";
			for (my $col_num = 1; $col_num <= $num_columns_in_file; $col_num++) {
				my $column = $peaklist->{columns}->{$col_num};
				my $dimension = $peaklist->get_dimension_by_col_num();
				if (defined $column) {
					$str .= "<td width='$col_width%'>" . $column->get($j) . "</td>\n";
				} else {
					$str .= "<td width='$col_width%'>$col_num is not defined</td>\n";
				}
			}
			$str .= "</tr>";
		}
		$str .= "</tbody></table>\n";
	}
	$str .= "<input type='hidden' name='sessid' value='$session_id' />";
	$str .= "<input type='submit' value='Submit' name='controlvaluessubmit' />";
	$str .= "</form>";
	print $str;
}
sub confirm_control_values_deprecated {
	my $class = shift;
	my $dataset = shift;
	my $session_id = shift;
	my ($dim, $dim_name, $sw, $tol, $shift, $col, $type);
	my $str = "<form method='POST' action='/rpf/cgi-bin/run_rpf.pl' name='confirm_control_values' onsubmit=''>";
	my $id = 1;
	my @keys = keys (%{$dataset->{peaklists}});
#	$str .= "<ul id='pl_confirm_list' type='none' class='tab_menu'>";
#	foreach my $key ( @keys ) {
#		$str .= "<li onclick=\"swap_sections('pl_confirm_div_$key', 'pl_confirm_divs');\">" . $key . "</li>";
#	}
#	$str .= "</ul>";
	foreach my $key ( @keys ) {
		my $peaklist = $dataset->{peaklists}{$key};
		my $peaklist_name = $peaklist->get_name();
		my $num_columns_in_file = scalar(keys(%{$peaklist->{columns}}));
		my $display = 'block';
		if ($id++ == 1) {$display='block';}
		$str .= "<div style='display:$display;' class='pl_confirm_divs' id='pl_confirm_div_" . $key . "'><h5 class='header'>" . $peaklist_name . "</h5>\n";
		$str .= "<table class='confirm_table' width='95%' align='center'><tr><th align='left'>Dimension</th><th align='left'>Type</th><th align='left'>Column</th><th align='left' class='sw_input'>SW</th><th align='left'>Ref. Shift</th><th align='left'>Tolerance</th></tr><tbody>";
		foreach my $dim_key ( keys %{$peaklist->{dimensions}} ) {
			$dim = $peaklist->{dimensions}->{$dim_key};
			$dim_name = $dim->get_name();
			$sw = $dim->get_sw();
			$tol = $dim->get_tol();
			$shift = $dim->get_shift();
			$col = $dim->get_number();
			$type = $dim->get_type();
			$str .= "<tr><td width='15%'>$dim_name</td>";
			$str .= "<td width='15%'>$type</td>";
			$str .= "<td width='15%'>";
			$str .= "<select class='control_inputs' name='" . $peaklist_name . "_col_" . $dim_name . "' type='text' value='$col'>";
			for (my $i = 1; $i < $num_columns_in_file; $i++) {
				$str .= "<option value='$i' ";
				if ($col == $i) {
					$str .= "selected";
				}
				$str .= ">$i</option>\n";
			}
			$str .= "</select></td>\n";
			$str .= "<td width='15%'><input class='control_inputs sw_input' size='6' type='text' name='" . $peaklist_name . "_" . $dim_name . "_sw' value='$sw'/></td>";
			$str .= "<td width='15%'><input class='control_inputs' size='6' type='text' name='" . $peaklist_name . "_" . $dim_name . "_shift' value='$shift'/></td>";
			$str .= "<td width='15%'><input class='control_inputs' size='6' type='text' name='" . $peaklist_name . "_" . $dim_name . "_tol' value='$tol'/></td>";
			$str .= "</tr>\n";
		}
		my $column = $peaklist->{height};
		$col = $column->get_number();
		$str .= "<tr><td width='15%'>Intensity</td><td></td><td width='15%'>";
			$str .= "<select class='control_inputs' name='" . $peaklist_name . "_col_intensity' type='text' value='$col'>";
			for (my $i = 1; $i <= $num_columns_in_file; $i++) {
				$str .= "<option value='$i' ";
				if ($col == $i) {
#					$str .= "<br/>col is $i<br/>";
					$str .= "selected";
				}
				$str .= ">$i</option>\n";
			}
			$str .= "</select>\n";
		$str .= "</td><td></td><td></td><td></td></tr>\n";
		$str .= "<tr style='border-bottom:1px; solid'></tr>";
		$str .= "</table><table style='font-family:sans-serif; color:black; font-size:7pt; border:inset 1px; background:#f5f5f5;' class='confirm_table' width='95%' align='center'>";
		$str .= "<center>preview:</center>";
		foreach my $prev_row (@{$peaklist->{first_five_lines}}) {
			$str .= "<tr>";
			foreach my $prev_col (@$prev_row) {
				$str .= "<td>$prev_col</td>";
			}
			$str .= "</tr>\n";
		}
		$str .= "</tbody></table></div>\n";
	}
	$str .= "<input type='hidden' name='sessid' value='$session_id' />";
	$str .= "<center><input type='submit' value='Submit' name='controlvaluessubmit' /></center>";
	$str .= "</form>";
	print $str;
}
sub openContFile {
    #parses the Control File and returns the data
    my ($class, $file, $prot, $cycles, $nhs, $jfile) = @_;
    unless (-e $file) {
		&err_open("File does not exist");
		return;
    }
    my $opened = open (CFILE, $file);
    unless ($opened) {
		&err_open("File cannot be opened");
    }
    my $dir = dirname($file);
    #print "Control File is $file, and directory is $dir\n";
    my $line;
    my @comments;
    my $heading;
    my %general;
    my %commands;
    my %peaklists;
    my $pklst_count = 0;
    my %col_names;
    my %extra_ops;
    while ($line = <CFILE>) {
		chomp($line);
		#if the line is a comment
		if ($line =~ /^\#/) {
			$line =~ s/^\#//;
			push (@comments, $line);
			next;
		}
		next if ($line =~ /^(\s)*$/);#blank lines
		#check if line is a heading - General, Command or Peaklist
		if ($line =~ /^\[([\~\w\-\_\.\/]+)\]$/) {
			$heading = $1;
			unless ($heading =~ /general/i or $heading =~ /command/i) {
			$pklst_count++;
			}
		} else {
			if ($heading =~ /general/i) {
				#general section
				my ($command, $value) = split(/=/,$line);
				$general{$command} = $value;
				#return protein name from control file
				if ($prot and ($command eq 'proteinName')) {
					close(CFILE);
					return $value;
				}
				#return cycles from control file
				if ($cycles and ($command eq 'nCycles')) {
					close(CFILE);
					return $value;
				}
				#return nhslowlist from control file
				if ($nhs and ($command eq 'NHSlowList')) {
					close(CFILE);
					return $value;
				}
				#return JListFile from control file
				if ($jfile and ($command eq 'JListFile')) {
					close(CFILE);
					return $value;
				}
			} elsif ($heading =~ /command/i) {
				$commands{$heading} = $line;
			} else { #peaklist
				#peaklist options
				my ($option, $value) = split(/=/,$line);
				if ($option =~ /col/i) {
					my ($col, $name) = split(/\./, $option);
					$col_names{$heading}{$value} = $name;
				} else {
					$peaklists{$heading}{$option} = $value;
				}
			}
		}
	#end if reading in commands
    }
    #end while reading in file
    $pklst_count--;
    close(CFILE);
    return (\@comments, \%general, \%commands, \%peaklists, \%col_names, $pklst_count);
}
sub three_to_one {
	my $class = shift;
	my $three = uc(shift);
	my %AAcode_h = ('ALA' => 'A', 'CYS' => 'C', 'ASP' => 'D', 'GLU' => 'E', 'PHE' => 'F', 'GLY' => 'G', 'HIS' => 'H', 'ILE' => 'I', 'LYS' => 'K', 'LEU' => 'L', 'MET' => 'M', 'ASN' => 'N', 'PRO' => 'P', 'GLN' => 'Q', 'ARG' => 'R', 'SER' => 'S',  'THR'=> 'T', 'VAL' => 'V', 'TRP' => 'W', 'TYR' => 'Y', 'ASX' => 'B', 'GLX' => 'Z', 'CPR' => 'P');
	return $AAcode_h{$three};
}
sub test {
	my $class = shift;
	my $program = shift;
	my $vals = shift;
	$class->$output = "";
	my $i = 100000000;
	print "in test: $class $program $vals <br/>";
	while ($i > 1) {
		$i--;
		$output .= "adding $i<br/>"
	}
	lock($class->$done);
	$class->$done = 1;
}
return(1);
