#!perl 
use strict; 
open(PDB, "<PDBCT.txt"); 

my %pdb; 
while (<PDB>)
{
    chomp; 
    my ($a, $b) = split(/\t/, $_); 
    next if (abs($b-$a) < 5); 
    $pdb{$_}++;  
}

open(E0, "<e0.txt"); 
my %e0; 
while (<E0>)
{
    chomp;
    my ($a, $b, $c) = split(/\s+/, $_); 
    $e0{$a . "\t" . $b}++; 
}

open(E6, "<e6.txt");
my %e6; 
my $count=0; 
while (<E6>)
{
    chomp;
    my ($a, $b, $c) = split(/\s+/, $_);
    $e6{$a . "\t" . $b}++;
    $count++; 
}

#print "$count\n"; 

open(S6, "<s6.txt"); 
while (<S6>)
{
    chomp;
    my ($a, $b) = split(/\s+/, $_);
    next if (abs($b-$a) < 5); 
    $e6{$a . "\t" . $b}++; 
}

my $e0tp=0; 
my $e0fp=0;
my $e6tp=0; 
my $e6fp=0;
foreach my $c (sort keys %e0)
{
    if (defined $pdb{$c})
    {
	$e0tp++; 
    } else
    {
	$e0fp++; 
    }
}

my $e06fp=0; 
my $e06tp=0; 
foreach my $c (sort keys %e6)
{
    if (defined $pdb{$c})
    {
	$e6tp++; 
    } else
    {
	$e6fp++; 
    }

    if (defined $e0{$c})  #from the e0 
    {
	if (defined $pdb{$c})
	{
	    $e06tp++; 
	} else
	{
	    $e06fp++; 
	}
    }
}

my $e0fn=0; 
my $e6fn=0; 
foreach my $c (sort keys %pdb)
{
    if (!$e0{$c})
    {
	$e0fn++; 
    } 

    if (!$e6{$c})
    {
	$e6fn++; 
    }
}

my $r0 = 0; my $p0 = 0; 
my $r6=0; my $p6=0; 

$r0 = $e0tp/($e0tp+$e0fn);
$p0 = $e0tp/($e0tp+$e0fp);
$r6 = $e6tp/($e6tp+$e6fn);
$p6 = $e6tp/($e6tp+$e6fp);
#print "Oirginal N ". (scalar keys(%e0)) . " R " . $r0 . " P " . $p0 . " F " . 2*($r0*$p0)/($r0+$p0) . "\n"; 
#print "Final    N ". (scalar keys(%e6)) . " R " . $r6 . " P " . $p6 . " F " . 2*($r6*$p6)/($r6+$p6) . "\n"; 

print "E0_FP " . $e0fp . " E0_P " . $p0 . " E06_FP " . $e06fp . " ALL_FP " . $e6fp . " ALL_P " . $p6 . "\n";  
