#!perl 

use strict; 

my ($pdb, $ec) = @ARGV; 

open(EC, "<$ec"); 
my @ec; 

while (<EC>)
{
    chomp; 
    my ($a, $b, $s) = split(/\s+/, $_); 
    if ($a < $b)
    {
	push @ec, "$a-$b"; 
    } else
    {
	push @ec, "$b-$a"; 
    }
}
my $ec; $ec = join("/", @ec); 
$ec = "\/$ec\/";

my $model = 0; 
my %atom; 

open(PDB, "<$pdb"); 

while (<PDB>)
{
    chomp;
    if ($_ =~ /MODEL/)
    {
	$model++; 
    }
    next if ($_ !~ /^ATOM/); 
    my ($atomName, $res, $x, $y, $z) = $_ =~ /ATOM\s+\d+\s*([\w\d]+)\s*\w+\s*A\s*(\d+)\s+(-*\d+\.\d+)\s*(-*\d+\.\d+)\s*(-*\d+\.\d+)/;
    $atom{$res . "-" . $atomName}{$model} = $x . "/" . $y . "/" . $z; 
    #print "$atomName-$res-$model-$x-$y-$z\n";
}

foreach my $a1 (sort keys %atom)
{
    foreach my $a2 (sort keys %atom)
    {
	#print "$a1-$a2\n"; 

	next if ($a1 eq $a2);
	next if ($a2 < $a1); 
 
	my ($num1, $name1) = split(/-/, $a1); 
	my ($num2, $name2) = split(/-/, $a2); 
	
	next if (abs($num1 - $num2) < 5); 
	next if ($name1 !~ /^C/); 
	next if ($name2 !~ /^C/); 
	
	#next if (($num1 != 2) && ($num1 !=104)); 
	#next if (($num2 != 2) && ($num2 != 104));  

	#print "$num1-$name1, $num2-$name2\n"; 
	my $dismax = -1; 
	
	for(my $i = 1; $i <= $model; $i++)
	{
	    my ($x1, $y1, $z1) = split(/\//, $atom{$a1}{$i});
	    my ($x2, $y2, $z2) = split(/\//, $atom{$a2}{$i}); 
	    my $dist = sqrt(($x1-$x2)**2+($y1-$y2)**2+($z1-$z2)**2); 
	    $dismax = $dist if ($dist > $dismax); 
	    #print "$i $atom{$a1}{$i} $atom{$a2}{$i} $dist  $dismax\n" if ($dist < 5.00001); 
	}
	
	my $pair; 
	if ($num1 < $num2) 
	{
	    $pair = "$num1-$num2"; 
	} else
	{
	    $pair = "$num2-$num1"; 
	}

	print "AmbiguousNMRDistance\t$name1\t$num1\t$name2\t$num2\tBOUNDED\t1.80\t7.0\t0.3\tNOE\n" if (($dismax < 5.00001) && ($ec =~ /\/$pair\//)); 
    }
}
