#!perl 

use strict; 

my ($pdb, $cycle0, $cycle3, $rosetta, @matches) = @ARGV;

if ($#ARGV < 4)
{
    print "Usage: perl makePlot.pl PDB cycle0 cycle6 rosetta matches...\n"; 
    exit 0;
}

#create file PDBCT.txt
print "working on $pdb\n";
my $output = ""; 
$output = `perl /farm/users/tang/huang/scripts/pdbCT.pl $pdb`;
print "$output\n"; 

#create file eCx.txt, sCx.txt
print "working on cycle0\n"; 
`perl  /farm/users/tang/huang/scripts/cycleCT.pl $cycle0 0`;
print "working on cycle6\n"; 
`perl  /farm/users/tang/huang/scripts/cycleCT.pl $cycle3 6`; 

#create file eRPDB.txt sRPDB.txt
print "working on rosetta URL\n"; 
`perl  /farm/users/tang/huang/scripts/rCTPDB.pl $rosetta`;

#create ambi
print "working on matches\n"; 
`perl  /farm/users/tang/huang/scripts/ambi.pl @matches`;
 
#run R command 
print "R ploting\n"; 
`R CMD BATCH  /farm/users/tang/huang/scripts/plot2.R`;

print "RPFing\n"; 
$output = `perl /farm/users/tang/huang/scripts/RPF.pl`; 
print "$output\n"; 
