# This module allows for the use of new queue software.
#
# The create_batch subroutine will create a shell script
# which will be passed as an argument to the queue software
# that the user selected when configuring ASDP.
#

package Custom;


use queue::Queue;
@ISA = qw(Queue);

sub new {
	my $class = shift;
	my $self = $class->SUPER::new( @_ );
	bless($self, $class);
	return $self;
}

sub create_batch {
	my $self = shift;
	my $filename = shift;
	my $name = shift;
	my $commands = shift;

	open(SMT, ">$filename") or die;
	print SMT "#!/bin/sh\n";
	
	$self->queue_header(SMT, $name);  	
	
	print SMT "$commands\n";
	print SMT "exit\n";
	close(SMT);
} 

sub queue_header 
{
	my ($self, $smt, $name) = @_;
	
	##############################################################
	######### begin changes here
	#please update this subroutine to write the necessary (if any)
	#queue headers required by your queue software
	##############################################################

	print $smt "#PBS -S /bin/sh\n";                     #	these are example directives
	print $smt "#PBS -N Calc_${name}\n";                #	used by the pbs queue
	print $smt "cd \$PBS_O_WORKDIR\n";                  #	software.
	
	######### end changes here ###########
	
}
return(1);
