#need to customize to your cluster

package PBS;

use queue::Queue;
@ISA = qw(Queue);

sub new {
	my $class = shift;
	my $self = $class->SUPER::new( @_ );
	bless($self, $class);
	return $self;
}

sub create_batch {
	my $self = shift;
	my $filename = shift;
	my $name = shift;
	my $commands = shift;
	Utils->debug("in PBS->create_batch() creating $filename");
	open(SMT, ">$filename") or die;
	print SMT "#!/bin/sh\n";
	print SMT "#PBS -S /bin/sh\n";
	print SMT "#PBS -N ${name}\n";
	print SMT "cd \$PBS_O_WORKDIR\n";

	print SMT "$commands\n";

	print SMT "exit\n";
	close(SMT);
}

sub create_batch_MPI {
	my $self = shift;
	my $filename = shift;
	my $name = shift;
	#my $process = shift;
	my $commands = shift;
	Utils->debug("in PBS->create_batch_MPI creating $filename");
	open(SMT, ">$filename") or die;
	print SMT "#!/bin/bash\n";
	print SMT "#PBS -N mpi_${name}\n";

	print SMT "#PBS -lnodes=" . $ENV{'MPI_NODES'} . ":ppn=" . $ENV{'MPI_PROCESSES_PER_NODE'} . "\n";
	print SMT "setenv LD_LIBRARY_PATH " . $ENV{'MPI_LIB'} . "\n";

	print SMT "cd \$PBS_O_WORKDIR\n";
	print SMT "$commands\n";
	print SMT "touch Done${name}\n";
	print SMT "exit\n";
	close(SMT);
}
return(1);
