#need to customize to your cluster

package SLURM;

use queue::Queue;
@ISA = qw(Queue);

sub new {
	my $class = shift;
	my $self = $class->SUPER::new( @_ );
	bless($self, $class);
	return $self;
}

sub create_batch {
	my $self = shift;
	my $filename = shift;
	my $name = shift;
	my $commands = shift;
	Utils->debug("in SLURM->create_batch() creating $filename");
	open(SMT, ">$filename") or die;
	print SMT "#!/bin/bash\n";
	print SMT "#SBATCH --job-name=${name}\n";
	print SMT "#SBATCH --output=${name}.out\n";
	print SMT "#SBATCH --error=${name}.err\n";
	print SMT "$commands\n";
	#print SMT $ENV{'CyanaCmd'} . " $commands\n";
	print SMT "exit\n\n";
	close(SMT);
}

sub create_batch_MPI {
	my $self = shift;
	my $filename = shift;
	my $name = shift;
	my $commands = shift;
	Utils->debug("in SLURM->create_batch_MPI creating $filename");
	open(SMT, ">$filename") or die;
	print SMT "#!/bin/bash\n";
  print SMT "#SBATCH --job-name=MPI_${name}\n";
  print SMT "#SBATCH --output=MPI_${name}.out\n";
  print SMT "#SBATCH --error=MPI_${name}.err\n";
	print SMT "#SBATCH --ntasks=$ENV{'MPI_NP'}\n"; #number of tasks

	print SMT $ENV{'MPI_LOAD'} . "\n";  # defined in CreateProc: module load mpi/openmpi-16

	#print SMT "$commands\n";
	#CyanaCmdMPI - command to run EC-NMR with CyanaMPI
	print SMT "mpirun -np " . $ENV{'MPI_NP'} . " $commands\n";

	print SMT "touch Done${name}\n";
	print SMT "exit\n\n";
	close(SMT);
}
return(1);
